/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/resources","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLog","vs/platform/log/node/loggerService","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],v=0,U=K.length;v<U;v++)e[v]=Z[K[v]];return e};define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(U,A){if(!U)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=v}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function U(R){const d=[];for(let m in R)v.call(R,m)&&d.push(R[m]);return d}e.values=U;function A(R,d){for(let m in R)if(v.call(R,m)&&d({key:m,value:R[m]},function(){delete R[m]})===!1)return}e.forEach=A;function P(R,d){const m=Object.create(null);for(const b of R){const o=d(b);let C=m[o];C||(C=m[o]=[]),C.push(b)}return m}e.groupBy=P;function k(R){const d=Object.create(null);return R&&R.forEach((m,b)=>{d[b]=m}),d}e.fromMap=k;function T(R,d){const m=[],b=[];for(let o of R)d.has(o)||m.push(o);for(let o of d)R.has(o)||b.push(o);return{removed:m,added:b}}e.diffSets=T;function f(R,d){const m=[],b=[];for(let[o,C]of R)d.has(o)||m.push(C);for(let[o,C]of d)R.has(o)||b.push(C);return{removed:m,added:b}}e.diffMaps=f;class g{constructor(){this.map=new Map}add(d,m){let b=this.map.get(d);b||(b=new Set,this.map.set(d,b)),b.add(m)}delete(d,m){const b=this.map.get(d);!b||(b.delete(m),b.size===0&&this.map.delete(d))}forEach(d,m){const b=this.map.get(d);!b||b.forEach(m)}}e.SetMap=g}),define(Z[86],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(f){return(g,R,d)=>{let m=null,b=null;if(typeof d.value=="function"?(m="value",b=d.value):typeof d.get=="function"&&(m="get",b=d.get),!b)throw new Error("not supported");d[m]=f(b,R)}}e.createDecorator=v;let U=0;function A(){const f=`$memoize${U++}`;let g;const R=function(m,b,o){let C=null,E=null;if(typeof o.value=="function"?(C="value",E=o.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(C="get",E=o.get),!E)throw new Error("not supported");const p=`${f}:${b}`;o[C]=function(...w){return g=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,w)}),this[p]}};return R.clear=()=>{typeof g!="undefined"&&Object.getOwnPropertyNames(g).forEach(d=>{d.indexOf(f)===0&&delete g[d]})},R}e.createMemoizer=A;function P(f,g,R){return A()(f,g,R)}e.memoize=P;function k(f,g,R){return v((d,m)=>{const b=`$debounce$${m}`,o=`$debounce$result$${m}`;return function(...C){this[o]||(this[o]=R?R():void 0),clearTimeout(this[b]),g&&(this[o]=g(this[o],...C),C=[this[o]]),this[b]=setTimeout(()=>{d.apply(this,C),this[o]=R?R():void 0},f)}})}e.debounce=k;function T(f,g,R){return v((d,m)=>{const b=`$throttle$timer$${m}`,o=`$throttle$result$${m}`,C=`$throttle$lastRun$${m}`,E=`$throttle$pending$${m}`;return function(...p){if(this[o]||(this[o]=R?R():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),g&&(this[o]=g(this[o],...p)),!this[E]){const w=this[C]+f;w<=Date.now()?(this[C]=Date.now(),d.apply(this,[this[o]]),this[o]=R?R():void 0):(this[E]=!0,this[b]=setTimeout(()=>{this[E]=!1,this[C]=Date.now(),d.apply(this,[this[o]]),this[o]=R?R():void 0},w-Date.now()))}}})}e.throttle=T}),define(Z[13],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function U(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=U;function A(i){f(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=A;function P(i){f(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=P;function k(i){if(i instanceof Error){let{name:t,message:n}=i;const r=i.stacktrace||i.stack;return{$isError:!0,name:t,message:n,stack:r}}return i}e.transformErrorForSerialization=k;const T="Canceled";function f(i){return i instanceof Error&&i.name===T&&i.message===T}e.isPromiseCanceledError=f;class g extends Error{constructor(){super(T);this.name=this.message}}e.CancellationError=g;function R(){const i=new Error(T);return i.name=i.message,i}e.canceled=R;function d(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=d;function m(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=m;function b(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function o(i){const t=new Error(`${i} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function C(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=C;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function y(i){const t=i;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=y;function s(i,t=Object.create(null)){const n=new Error(i);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=s}),define(Z[18],ee([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function U(z,H=0){return z[z.length-(1+H)]}e.tail=U;function A(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=A;function P(z,H,q=(D,O)=>D===O){if(z===H)return!0;if(!z||!H||z.length!==H.length)return!1;for(let D=0,O=z.length;D<O;D++)if(!q(z[D],H[D]))return!1;return!0}e.equals=P;function k(z,H,q){let D=0,O=z.length-1;for(;D<=O;){const F=(D+O)/2|0,N=q(z[F],H);if(N<0)D=F+1;else if(N>0)O=F-1;else return F}return-(D+1)}e.binarySearch=k;function T(z,H){let q=0,D=z.length;if(D===0)return 0;for(;q<D;){const O=Math.floor((q+D)/2);H(z[O])?D=O:q=O+1}return q}e.findFirstInSorted=T;function f(z,H,q){if(z=z|0,z>=H.length)throw new TypeError("invalid index");let D=H[Math.floor(H.length*Math.random())],O=[],F=[],N=[];for(let V of H){const G=q(V,D);G<0?O.push(V):G>0?F.push(V):N.push(V)}return z<O.length?f(z,O,q):z<O.length+N.length?N[0]:f(z-(O.length+N.length),F,q)}e.quickSelect=f;function g(z,H){const q=[];let D;for(const O of z.slice(0).sort(H))!D||H(D[0],O)!==0?(D=[O],q.push(D)):D.push(O);return q}e.groupBy=g;function R(z,H,q){const D=[];function O(V,G,Q){if(!(G===0&&Q.length===0)){const X=D[D.length-1];X&&X.start+X.deleteCount===V?(X.deleteCount+=G,X.toInsert.push(...Q)):D.push({start:V,deleteCount:G,toInsert:Q})}}let F=0,N=0;for(;;){if(F===z.length){O(F,0,H.slice(N));break}if(N===H.length){O(F,z.length-F,[]);break}const V=z[F],G=H[N],Q=q(V,G);Q===0?(F+=1,N+=1):Q<0?(O(F,1,[]),F+=1):Q>0&&(O(F,0,[G]),N+=1)}return D}e.sortedDiff=R;function d(z,H,q){const D=R(z,H,q),O=[],F=[];for(const N of D)O.push(...z.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:O,added:F}}e.delta=d;function m(z,H,q){if(q===0)return[];const D=z.slice(0,q).sort(H);return o(z,H,D,q,z.length),D}e.top=m;function b(z,H,q,D,O){return q===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const V=z.length,G=z.slice(0,q).sort(H);for(let Q=q,X=Math.min(q+D,V);Q<V;Q=X,X=Math.min(X+D,V)){if(Q>q&&await new Promise(ne=>setTimeout(ne)),O&&O.isCancellationRequested)throw(0,v.canceled)();o(z,H,G,Q,X)}return G})().then(F,N)})}e.topAsync=b;function o(z,H,q,D,O){for(const F=q.length;D<O;D++){const N=z[D];if(H(N,q[F-1])<0){q.pop();const V=T(q,G=>H(N,G)<0);q.splice(V,0,N)}}}function C(z){return z.filter(H=>!!H)}e.coalesce=C;function E(z){let H=0;for(let q=0;q<z.length;q++)z[q]&&(z[H]=z[q],H+=1);z.length=H}e.coalesceInPlace=E;function p(z,H,q){z.splice(q,0,z.splice(H,1)[0])}e.move=p;function w(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=w;function y(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=y;function s(z,H){if(!H)return z.filter((D,O)=>z.indexOf(D)===O);const q=Object.create(null);return z.filter(D=>{const O=H(D);return q[O]?!1:(q[O]=!0,!0)})}e.distinct=s;function i(z){const H=new Set;return z.filter(q=>H.has(q)?!1:(H.add(q),!0))}e.distinctES6=i;function t(z){const H=Object.create(null);return q=>{const D=z(q);return H[D]?!1:(H[D]=!0,!0)}}e.uniqueFilter=t;function n(z,H){for(let q=z.length-1;q>=0;q--){const D=z[q];if(H(D))return q}return-1}e.lastIndex=n;function r(z,H){return z.length>0?z[0]:H}e.firstOrDefault=r;function l(z,H,q=(D,O)=>D===O){let D=0;for(let O=0,F=Math.min(z.length,H.length);O<F&&q(z[O],H[O]);O++)D++;return D}e.commonPrefixLength=l;function a(z){return[].concat(...z)}e.flatten=a;function c(z,H){let q=typeof H=="number"?z:0;typeof H=="number"?q=z:(q=0,H=z);const D=[];if(q<=H)for(let O=q;O<H;O++)D.push(O);else for(let O=q;O>H;O--)D.push(O);return D}e.range=c;function h(z,H,q){return z.reduce((D,O)=>(D[H(O)]=q?q(O):O,D),Object.create(null))}e.index=h;function S(z,H){return z.push(H),()=>I(z,H)}e.insert=S;function I(z,H){const q=z.indexOf(H);if(q>-1)return z.splice(q,1),H}e.remove=I;function u(z,H,q){const D=z.slice(0,H),O=z.slice(H);return D.concat(q,O)}e.arrayInsert=u;function L(z,H){let q;if(typeof H=="number"){let D=H;q=()=>{const O=Math.sin(D++)*179426549;return O-Math.floor(O)}}else q=Math.random;for(let D=z.length-1;D>0;D-=1){const O=Math.floor(q()*(D+1)),F=z[D];z[D]=z[O],z[O]=F}}e.shuffle=L;function _(z,H){const q=z.indexOf(H);q>-1&&(z.splice(q,1),z.unshift(H))}e.pushToStart=_;function $(z,H){const q=z.indexOf(H);q>-1&&(z.splice(q,1),z.push(H))}e.pushToEnd=$;function B(z,H){return Array.isArray(z)?z.map(H):H(z)}e.mapArrayOrNot=B;function M(z){return Array.isArray(z)?z:[z]}e.asArray=M;function j(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=j;function W(z,H){for(const q of z){const D=H(q);if(D!==void 0)return D}}e.mapFind=W}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(U){const A=this;let P=!1,k;return function(){return P||(P=!0,k=U.apply(A,arguments)),k}}e.once=v}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(U){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}U.is=A;const P=Object.freeze([]);function k(){return P}U.empty=k;function*T(i){yield i}U.single=T;function f(i){return i||P}U.from=f;function g(i){return!i||i[Symbol.iterator]().next().done===!0}U.isEmpty=g;function R(i){return i[Symbol.iterator]().next().value}U.first=R;function d(i,t){for(const n of i)if(t(n))return!0;return!1}U.some=d;function m(i,t){for(const n of i)if(t(n))return n}U.find=m;function*b(i,t){for(const n of i)t(n)&&(yield n)}U.filter=b;function*o(i,t){for(const n of i)yield t(n)}U.map=o;function*C(...i){for(const t of i)for(const n of t)yield n}U.concat=C;function*E(i){for(const t of i)for(const n of t)yield n}U.concatNested=E;function p(i,t,n){let r=n;for(const l of i)r=t(r,l);return r}U.reduce=p;function*w(i,t,n=i.length){for(t<0&&(t+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);t<n;t++)yield i[t]}U.slice=w;function y(i,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,i];const r=i[Symbol.iterator]();for(let l=0;l<t;l++){const a=r.next();if(a.done)return[n,U.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}U.consume=y;function s(i,t,n=(r,l)=>r===l){const r=i[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const a=r.next(),c=l.next();if(a.done!==c.done)return!1;if(a.done)return!0;if(!n(a.value,c.value))return!1}}U.equals=s})(v=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var U;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(U=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function k(t,n=!1){let r=0,l=t.length,a="",c=0,h=16,S=0;function I(j){let W=0,z=0;for(;W<j;){const H=t.charCodeAt(r);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;r++,W++}return W<j&&(z=-1),z}function u(j){r=j,a="",c=0,h=16,S=0}function L(){const j=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return S=3,t.substring(j,r);let W=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;W=r}else S=3;return t.substring(j,W)}function _(){let j="",W=r;for(;;){if(r>=l){j+=t.substring(W,r),S=2;break}const z=t.charCodeAt(r);if(z===34){j+=t.substring(W,r),r++;break}if(z===92){if(j+=t.substring(W,r),r++,r>=l){S=2;break}switch(t.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const q=I(4);q>=0?j+=String.fromCharCode(q):S=4;break;default:S=5}W=r;continue}if(z>=0&&z<=31)if(f(z)){j+=t.substring(W,r),S=2;break}else S=6;r++}return j}function $(){if(a="",S=0,c=r,r>=l)return c=l,h=17;let j=t.charCodeAt(r);if(T(j)){do r++,a+=String.fromCharCode(j),j=t.charCodeAt(r);while(T(j));return h=15}if(f(j))return r++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),h=14;switch(j){case 123:return r++,h=1;case 125:return r++,h=2;case 91:return r++,h=3;case 93:return r++,h=4;case 58:return r++,h=6;case 44:return r++,h=5;case 34:return r++,a=_(),h=10;case 47:const W=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<l&&!f(t.charCodeAt(r));)r++;return a=t.substring(W,r),h=12}if(t.charCodeAt(r+1)===42){r+=2;const z=l-1;let H=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,S=1),a=t.substring(W,r),h=13}return a+=String.fromCharCode(j),r++,h=16;case 45:if(a+=String.fromCharCode(j),r++,r===l||!g(t.charCodeAt(r)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=L(),h=11;default:for(;r<l&&B(j);)r++,j=t.charCodeAt(r);if(c!==r){switch(a=t.substring(c,r),a){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return a+=String.fromCharCode(j),r++,h=16}}function B(j){if(T(j)||f(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=$();while(j>=12&&j<=15);return j}return{setPosition:u,getPosition:()=>r,scan:n?M:$,getToken:()=>h,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>S}}e.createScanner=k;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function d(t,n){const r=[],l=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function S(I,u,L,_){c.value=I,c.offset=u,c.length=L,c.type=_,c.colonOffset=void 0,a=c}try{y(t,{onObjectBegin:(I,u)=>{if(n<=I)throw l;a=void 0,h=n>I,r.push("")},onObjectProperty:(I,u,L)=>{if(n<u||(S(I,u,L,"property"),r[r.length-1]=I,n<=u+L))throw l},onObjectEnd:(I,u)=>{if(n<=I)throw l;a=void 0,r.pop()},onArrayBegin:(I,u)=>{if(n<=I)throw l;a=void 0,r.push(0)},onArrayEnd:(I,u)=>{if(n<=I)throw l;a=void 0,r.pop()},onLiteralValue:(I,u,L)=>{if(n<u||(S(I,u,L,i(I)),n<=u+L))throw l},onSeparator:(I,u,L)=>{if(n<=u)throw l;if(I===":"&&a&&a.type==="property")a.colonOffset=u,h=!1,a=void 0;else if(I===","){const _=r[r.length-1];typeof _=="number"?r[r.length-1]=_+1:(h=!0,r[r.length-1]=""),a=void 0}}})}catch(I){if(I!==l)throw I}return{path:r,previousNode:a,isAtPropertyKey:h,matches:I=>{let u=0;for(let L=0;u<I.length&&L<r.length;L++)if(I[u]===r[L]||I[u]==="*")u++;else if(I[u]!=="**")return!1;return u===I.length}}}e.getLocation=d;function m(t,n=[],r=P.DEFAULT){let l=null,a=[];const c=[];function h(I){Array.isArray(a)?a.push(I):l!==null&&(a[l]=I)}return y(t,{onObjectBegin:()=>{const I={};h(I),c.push(a),a=I,l=null},onObjectProperty:I=>{l=I},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const I=[];h(I),c.push(a),a=I,l=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:h,onError:(I,u,L)=>{n.push({error:I,offset:u,length:L})}},r),a[0]}e.parse=m;function b(t,n=[],r=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(I){l.type==="property"&&(l.length=I-l.offset,l=l.parent)}function c(I){return l.children.push(I),I}y(t,{onObjectBegin:I=>{l=c({type:"object",offset:I,length:-1,parent:l,children:[]})},onObjectProperty:(I,u,L)=>{l=c({type:"property",offset:u,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:I,offset:u,length:L,parent:l})},onObjectEnd:(I,u)=>{l.length=I+u-l.offset,l=l.parent,a(I+u)},onArrayBegin:(I,u)=>{l=c({type:"array",offset:I,length:-1,parent:l,children:[]})},onArrayEnd:(I,u)=>{l.length=I+u-l.offset,l=l.parent,a(I+u)},onLiteralValue:(I,u,L)=>{c({type:i(I),offset:u,length:L,parent:l,value:I}),a(u+L)},onSeparator:(I,u,L)=>{l.type==="property"&&(I===":"?l.colonOffset=u:I===","&&a(u))},onError:(I,u,L)=>{n.push({error:I,offset:u,length:L})}},r);const S=l.children[0];return S&&delete S.parent,S}e.parseTree=b;function o(t,n){if(!!t){let r=t;for(let l of n)if(typeof l=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===l){r=c.children[1],a=!0;break}if(!a)return}else{const a=l;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}}e.findNodeAtLocation=o;function C(t){if(!t.parent||!t.parent.children)return[];const n=C(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=C;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let r of t.children){const l=r.children[1];l&&(n[r.children[0].value]=E(l))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function p(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=p;function w(t,n,r=!1){if(p(t,n,r)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=n;a++){const c=w(l[a],n,r);if(c)return c}return t}}e.findNodeAtOffset=w;function y(t,n,r=P.DEFAULT){const l=k(t,!1);function a(G){return G?()=>G(l.getTokenOffset(),l.getTokenLength()):()=>!0}function c(G){return G?Q=>G(Q,l.getTokenOffset(),l.getTokenLength()):()=>!0}const h=a(n.onObjectBegin),S=c(n.onObjectProperty),I=a(n.onObjectEnd),u=a(n.onArrayBegin),L=a(n.onArrayEnd),_=c(n.onLiteralValue),$=c(n.onSeparator),B=a(n.onComment),M=c(n.onError),j=r&&r.disallowComments,W=r&&r.allowTrailingComma;function z(){for(;;){const G=l.scan();switch(l.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(G){case 12:case 13:j?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return G}}}function H(G,Q=[],X=[]){if(M(G),Q.length+X.length>0){let ne=l.getToken();for(;ne!==17;){if(Q.indexOf(ne)!==-1){z();break}else if(X.indexOf(ne)!==-1)break;ne=z()}}}function q(G){const Q=l.getTokenValue();return G?_(Q):S(Q),z(),!0}function D(){switch(l.getToken()){case 11:let G=0;try{G=JSON.parse(l.getTokenValue()),typeof G!="number"&&(H(2),G=0)}catch(Q){H(2)}_(G);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return z(),!0}function O(){return l.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),l.getToken()===6?($(":"),z(),V()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){h(),z();let G=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(G||H(4,[],[]),$(","),z(),l.getToken()===2&&W)break}else G&&H(6,[],[]);O()||H(4,[],[2,5]),G=!0}return I(),l.getToken()!==2?H(7,[2],[]):z(),!0}function N(){u(),z();let G=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(G||H(4,[],[]),$(","),z(),l.getToken()===4&&W)break}else G&&H(6,[],[]);V()||H(4,[],[4,5]),G=!0}return L(),l.getToken()!==4?H(8,[4],[]):z(),!0}function V(){switch(l.getToken()){case 3:return N();case 1:return F();case 10:return q(!0);default:return D()}}return z(),l.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):V()?(l.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=y;function s(t,n){let r=k(t),l=[],a,c=0,h;do switch(h=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:c!==h&&l.push(t.substring(c,h)),n!==void 0&&l.push(r.getTokenValue().replace(/[^\r\n]/g,n)),c=r.getPosition();break}while(a!==17);return l.join("")}e.stripComments=s;function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=i}),define(Z[46],ee([0,1,32]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function U(f,g,R){let d,m,b,o,C;if(g){for(o=g.offset,C=o+g.length,b=o;b>0&&!T(f,b-1);)b--;let c=C;for(;c<f.length&&!T(f,c);)c++;m=f.substring(b,c),d=P(m,R)}else m=f,d=0,b=0,o=0,C=f.length;const E=k(R,f);let p=!1,w=0,y;R.insertSpaces?y=A(" ",R.tabSize||4):y="	";const s=(0,v.createScanner)(m,!1);let i=!1;function t(){return E+A(y,d+w)}function n(){let c=s.scan();for(p=!1;c===15||c===14;)p=p||c===14,c=s.scan();return i=c===16||s.getTokenError()!==0,c}const r=[];function l(c,h,S){!i&&h<C&&S>o&&f.substring(h,S)!==c&&r.push({offset:h,length:S-h,content:c})}let a=n();if(a!==17){const c=s.getTokenOffset()+b,h=A(y,d);l(h,b,c)}for(;a!==17;){let c=s.getTokenOffset()+s.getTokenLength()+b,h=n(),S="";for(;!p&&(h===12||h===13);){const u=s.getTokenOffset()+b;l(" ",c,u),c=s.getTokenOffset()+s.getTokenLength()+b,S=h===12?t():"",h=n()}if(h===2)a!==1&&(w--,S=t());else if(h===4)a!==3&&(w--,S=t());else{switch(a){case 3:case 1:w++,S=t();break;case 5:case 12:S=t();break;case 13:p?S=t():S=" ";break;case 6:S=" ";break;case 10:if(h===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?S=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}p&&(h===12||h===13)&&(S=t())}const I=s.getTokenOffset()+b;l(S,c,I),a=h}return r}e.format=U;function A(f,g){let R="";for(let d=0;d<g;d++)R+=f;return R}function P(f,g){let R=0,d=0;const m=g.tabSize||4;for(;R<f.length;){const b=f.charAt(R);if(b===" ")d++;else if(b==="	")d+=m;else break;R++}return Math.floor(d/m)}function k(f,g){for(let R=0;R<g.length;R++){const d=g.charAt(R);if(d==="\r")return R+1<g.length&&g.charAt(R+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=k;function T(f,g){return`\r
`.indexOf(f.charAt(g))!==-1}e.isEOL=T}),define(Z[41],ee([0,1,32,46]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(g,R,d){return P(g,R,void 0,d)}e.removeProperty=A;function P(g,R,d,m,b){const o=R.slice(),C=[],E=(0,v.parseTree)(g,C);let p,w;for(;o.length>0&&(w=o.pop(),p=(0,v.findNodeAtLocation)(E,o),p===void 0&&d!==void 0);)typeof w=="string"?d={[w]:d}:d=[d];if(p)if(p.type==="object"&&typeof w=="string"&&Array.isArray(p.children)){const y=(0,v.findNodeAtLocation)(p,[w]);if(y!==void 0)if(d===void 0){if(!y.parent)throw new Error("Malformed AST");const s=p.children.indexOf(y.parent);let i,t=y.parent.offset+y.parent.length;if(s>0){const n=p.children[s-1];i=n.offset+n.length}else i=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return k(g,{offset:i,length:t-i,content:""},m)}else return k(g,{offset:y.offset,length:y.length,content:JSON.stringify(d)},m);else{if(d===void 0)return[];const s=`${JSON.stringify(w)}: ${JSON.stringify(d)}`,i=b?b(p.children.map(n=>n.children[0].value)):p.children.length;let t;if(i>0){const n=p.children[i-1];t={offset:n.offset+n.length,length:0,content:","+s}}else p.children.length===0?t={offset:p.offset+1,length:0,content:s}:t={offset:p.offset+1,length:0,content:s+","};return k(g,t,m)}}else if(p.type==="array"&&typeof w=="number"&&Array.isArray(p.children))if(d!==void 0){const y=`${JSON.stringify(d)}`;let s;if(p.children.length===0||w===0)s={offset:p.offset+1,length:0,content:p.children.length===0?y:y+","};else{const i=w===-1||w>p.children.length?p.children.length:w,t=p.children[i-1];s={offset:t.offset+t.length,length:0,content:","+y}}return k(g,s,m)}else{const y=w,s=p.children[y];let i;if(p.children.length===1)i={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===y){const t=p.children[y-1],n=t.offset+t.length,r=p.offset+p.length;i={offset:n,length:r-2-n,content:""}}else i={offset:s.offset,length:p.children[y+1].offset-s.offset,content:""};return k(g,i,m)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${p.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return k(g,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(d)},m)}}e.setProperty=P;function k(g,R,d){let m=T(g,R),b=R.offset,o=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;b>0&&!(0,U.isEOL)(m,b-1);)b--;for(;o<m.length&&!(0,U.isEOL)(m,o);)o++}const C=(0,U.format)(m,{offset:b,length:o-b},d);for(let p=C.length-1;p>=0;p--){const w=C[p];m=T(m,w),b=Math.min(b,w.offset),o=Math.max(o,w.offset+w.length),o+=w.content.length-w.length}const E=g.length-(m.length-o)-b;return[{offset:b,length:E,content:m.substring(b,o)}]}e.withFormatting=k;function T(g,R){return g.substring(0,R.offset)+R.content+g.substring(R.offset+R.length)}e.applyEdit=T;function f(g,R){let d=R.slice(0).sort((b,o)=>{const C=b.offset-o.offset;return C===0?b.length-o.length:C}),m=g.length;for(let b=d.length-1;b>=0;b--){let o=d[b];if(o.offset+o.length<=m)g=T(g,o);else throw new Error("Overlapping edit");m=o.offset}return g}e.applyEdits=f}),define(Z[2],ee([0,1,63,52]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let P=null;function k(y){P=y}if(e.setDisposableTracker=k,A){const y="__is_disposable_tracked__";P=new class{trackDisposable(s){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[y]||console.log(i)},3e3)}markTracked(s){if(s&&s!==C.None)try{s[y]=!0}catch(i){}}}}function T(y){!P||P.markTracked(y)}function f(y){return P&&P.trackDisposable(y),y}e.trackDisposable=f;class g extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=g;function R(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.isDisposable=R;function d(y){if(U.Iterable.is(y)){let s=[];for(const i of y)if(i){T(i);try{i.dispose()}catch(t){s.push(t)}}if(s.length===1)throw s[0];if(s.length>1)throw new g(s);return Array.isArray(y)?[]:y}else if(y)return T(y),y.dispose(),y}e.dispose=d;function m(...y){return y.forEach(T),b(()=>d(y))}e.combinedDisposable=m;function b(y){const s=f({dispose:()=>{T(s),y()}});return s}e.toDisposable=b;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(T(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return T(s),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new o,f(this)}dispose(){T(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var i;this._isDisposed||s===this._value||((i=this._value)===null||i===void 0||i.dispose(),s&&T(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,T(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=E;class p{constructor(){this.references=new Map}acquire(s,...i){let t=this.references.get(s);t||(t={counter:0,object:this.createReferencedObject(s,...i)},this.references.set(s,t));const{object:n}=t,r=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(s,t.object),this.references.delete(s))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=p;class w{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=w}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(P){this.element=P,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class U{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,k){const T=new v(P);if(this._first===v.Undefined)this._first=T,this._last=T;else if(k){const g=this._last;this._last=T,T.prev=g,g.next=T}else{const g=this._first;this._first=T,T.next=g,g.prev=T}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(T))}}shift(){if(this._first!==v.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==v.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==v.Undefined&&P.next!==v.Undefined){const k=P.prev;k.next=P.next,P.next.prev=k}else P.prev===v.Undefined&&P.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):P.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):P.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==v.Undefined;)yield P.element,P=P.next}}e.LinkedList=U});"use strict";(function(){function K(A){const P=[];typeof A=="number"&&P.push("code/timeOrigin",A);function k(f){P.push(f,Date.now())}function T(){const f=[];for(let g=0;g<P.length;g+=2)f.push({name:P[g],startTime:P[g+1]});return f}return{mark:k,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const k of performance.getEntriesByType("mark"))P.push({name:k.name,startTime:Math.round(A+k.startTime)});return P}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=v(U))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const U="en";let A=!1,P=!1,k=!1,T=!1,f=!1,g=!1,R=!1,d,m=U,b,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof process!="undefined"?C=process:typeof e.globals.vscode!="undefined"&&(C=e.globals.vscode.process);const E=typeof((v=C==null?void 0:C.versions)===null||v===void 0?void 0:v.electron)=="string"&&C.type==="renderer";if(e.isElectronSandboxed=E&&(C==null?void 0:C.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const l=C==null?void 0:C.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof l=="string")return l==="none"||l==="code"||l==="bypassHeatCheck"||l==="bypassHeatCheckAndEagerCompile"?l:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)o=navigator.userAgent,A=o.indexOf("Windows")>=0,P=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=o.indexOf("Linux")>=0,g=!0,d=navigator.language,m=d;else if(typeof C=="object"){A=C.platform==="win32",P=C.platform==="darwin",k=C.platform==="linux",T=k&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,d=U,m=U;const l=C.env.VSCODE_NLS_CONFIG;if(l)try{const a=JSON.parse(l),c=a.availableLanguages["*"];d=a.locale,m=c||U,b=a._translationsConfigFile}catch(a){}f=!0}else console.error("Unable to resolve platform.");var p;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function w(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let y=0;P?y=1:A?y=3:k&&(y=2),e.isWindows=A,e.isMacintosh=P,e.isLinux=k,e.isLinuxSnap=T,e.isNative=f,e.isWeb=g,e.isIOS=R,e.platform=y,e.userAgent=o,e.language=m;var s;(function(l){function a(){return e.language}l.value=a;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=c;function h(){return e.language==="en"}l.isDefault=h})(s=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let I=0,u=c.length;I<u;I++){const L=c[I];if(L.id===S.data.vscodeSetImmediateId){c.splice(I,1),L.callback();return}}});let h=0;return S=>{const I=++h;c.push({id:I,callback:S}),e.globals.postMessage({vscodeSetImmediateId:I},"*")}}if(typeof(C==null?void 0:C.nextTick)=="function")return C.nextTick.bind(C);const a=Promise.resolve();return c=>a.then(c)}();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||R?2:A?1:3;let t=!0,n=!1;function r(){if(!n){n=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,t=new Uint16Array(l.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(Z[36],ee([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let U;if(typeof process!="undefined")U={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}};else if(typeof v.globals.vscode!="undefined"){const A=v.globals.vscode.process;U={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(P){return(0,v.setImmediate)(P)}}}else U={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(A){return(0,v.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.nextTick=U.nextTick}),define(Z[9],ee([0,1,36]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,A=97,P=90,k=122,T=46,f=47,g=92,R=58,d=63;class m extends Error{constructor(s,i,t){let n;typeof i=="string"&&i.indexOf("not ")===0?(n="must not be",i=i.replace(/^not /,"")):n="must be";const r=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${r} ${n} of type ${i}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function b(y,s){if(typeof y!="string")throw new m(s,"string",y)}function o(y){return y===f||y===g}function C(y){return y===f}function E(y){return y>=U&&y<=P||y>=A&&y<=k}function p(y,s,i,t){let n="",r=0,l=-1,a=0,c=0;for(let h=0;h<=y.length;++h){if(h<y.length)c=y.charCodeAt(h);else{if(t(c))break;c=f}if(t(c)){if(!(l===h-1||a===1))if(a===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==T||n.charCodeAt(n.length-2)!==T){if(n.length>2){const S=n.lastIndexOf(i);S===-1?(n="",r=0):(n=n.slice(0,S),r=n.length-1-n.lastIndexOf(i)),l=h,a=0;continue}else if(n.length!==0){n="",r=0,l=h,a=0;continue}}s&&(n+=n.length>0?`${i}..`:"..",r=2)}else n.length>0?n+=`${i}${y.slice(l+1,h)}`:n=y.slice(l+1,h),r=h-l-1;l=h,a=0}else c===T&&a!==-1?++a:a=-1}return n}function w(y,s){if(s===null||typeof s!="object")throw new m("pathObject","Object",s);const i=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return i?i===s.root?`${i}${t}`:`${i}${y}${t}`:t}e.win32={resolve(...y){let s="",i="",t=!1;for(let n=y.length-1;n>=-1;n--){let r;if(n>=0){if(r=y[n],b(r,"path"),r.length===0)continue}else s.length===0?r=v.cwd():(r=v.env[`=${s}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==s.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${s}\\`));const l=r.length;let a=0,c="",h=!1;const S=r.charCodeAt(0);if(l===1)o(S)&&(a=1,h=!0);else if(o(S))if(h=!0,o(r.charCodeAt(1))){let I=2,u=I;for(;I<l&&!o(r.charCodeAt(I));)I++;if(I<l&&I!==u){const L=r.slice(u,I);for(u=I;I<l&&o(r.charCodeAt(I));)I++;if(I<l&&I!==u){for(u=I;I<l&&!o(r.charCodeAt(I));)I++;(I===l||I!==u)&&(c=`\\\\${L}\\${r.slice(u,I)}`,a=I)}}}else a=1;else E(S)&&r.charCodeAt(1)===R&&(c=r.slice(0,2),a=2,l>2&&o(r.charCodeAt(2))&&(h=!0,a=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(t){if(s.length>0)break}else if(i=`${r.slice(a)}\\${i}`,t=h,h&&s.length>0)break}return i=p(i,!t,"\\",o),t?`${s}\\${i}`:`${s}${i}`||"."},normalize(y){b(y,"path");const s=y.length;if(s===0)return".";let i=0,t,n=!1;const r=y.charCodeAt(0);if(s===1)return C(r)?"\\":y;if(o(r))if(n=!0,o(y.charCodeAt(1))){let a=2,c=a;for(;a<s&&!o(y.charCodeAt(a));)a++;if(a<s&&a!==c){const h=y.slice(c,a);for(c=a;a<s&&o(y.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&!o(y.charCodeAt(a));)a++;if(a===s)return`\\\\${h}\\${y.slice(c)}\\`;a!==c&&(t=`\\\\${h}\\${y.slice(c,a)}`,i=a)}}}else i=1;else E(r)&&y.charCodeAt(1)===R&&(t=y.slice(0,2),i=2,s>2&&o(y.charCodeAt(2))&&(n=!0,i=3));let l=i<s?p(y.slice(i),!n,"\\",o):"";return l.length===0&&!n&&(l="."),l.length>0&&o(y.charCodeAt(s-1))&&(l+="\\"),t===void 0?n?`\\${l}`:l:n?`${t}\\${l}`:`${t}${l}`},isAbsolute(y){b(y,"path");const s=y.length;if(s===0)return!1;const i=y.charCodeAt(0);return o(i)||s>2&&E(i)&&y.charCodeAt(1)===R&&o(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let s,i;for(let r=0;r<y.length;++r){const l=y[r];b(l,"path"),l.length>0&&(s===void 0?s=i=l:s+=`\\${l}`)}if(s===void 0)return".";let t=!0,n=0;if(typeof i=="string"&&o(i.charCodeAt(0))){++n;const r=i.length;r>1&&o(i.charCodeAt(1))&&(++n,r>2&&(o(i.charCodeAt(2))?++n:t=!1))}if(t){for(;n<s.length&&o(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.win32.normalize(s)},relative(y,s){if(b(y,"from"),b(s,"to"),y===s)return"";const i=e.win32.resolve(y),t=e.win32.resolve(s);if(i===t||(y=i.toLowerCase(),s=t.toLowerCase(),y===s))return"";let n=0;for(;n<y.length&&y.charCodeAt(n)===g;)n++;let r=y.length;for(;r-1>n&&y.charCodeAt(r-1)===g;)r--;const l=r-n;let a=0;for(;a<s.length&&s.charCodeAt(a)===g;)a++;let c=s.length;for(;c-1>a&&s.charCodeAt(c-1)===g;)c--;const h=c-a,S=l<h?l:h;let I=-1,u=0;for(;u<S;u++){const _=y.charCodeAt(n+u);if(_!==s.charCodeAt(a+u))break;_===g&&(I=u)}if(u!==S){if(I===-1)return t}else{if(h>S){if(s.charCodeAt(a+u)===g)return t.slice(a+u+1);if(u===2)return t.slice(a+u)}l>S&&(y.charCodeAt(n+u)===g?I=u:u===2&&(I=3)),I===-1&&(I=0)}let L="";for(u=n+I+1;u<=r;++u)(u===r||y.charCodeAt(u)===g)&&(L+=L.length===0?"..":"\\..");return a+=I,L.length>0?`${L}${t.slice(a,c)}`:(t.charCodeAt(a)===g&&++a,t.slice(a,c))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const s=e.win32.resolve(y);if(s.length<=2)return y;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const i=s.charCodeAt(2);if(i!==d&&i!==T)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return y},dirname(y){b(y,"path");const s=y.length;if(s===0)return".";let i=-1,t=0;const n=y.charCodeAt(0);if(s===1)return o(n)?y:".";if(o(n)){if(i=t=1,o(y.charCodeAt(1))){let a=2,c=a;for(;a<s&&!o(y.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&o(y.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&!o(y.charCodeAt(a));)a++;if(a===s)return y;a!==c&&(i=t=a+1)}}}}else E(n)&&y.charCodeAt(1)===R&&(i=s>2&&o(y.charCodeAt(2))?3:2,t=i);let r=-1,l=!0;for(let a=s-1;a>=t;--a)if(o(y.charCodeAt(a))){if(!l){r=a;break}}else l=!1;if(r===-1){if(i===-1)return".";r=i}return y.slice(0,r)},basename(y,s){s!==void 0&&b(s,"ext"),b(y,"path");let i=0,t=-1,n=!0,r;if(y.length>=2&&E(y.charCodeAt(0))&&y.charCodeAt(1)===R&&(i=2),s!==void 0&&s.length>0&&s.length<=y.length){if(s===y)return"";let l=s.length-1,a=-1;for(r=y.length-1;r>=i;--r){const c=y.charCodeAt(r);if(o(c)){if(!n){i=r+1;break}}else a===-1&&(n=!1,a=r+1),l>=0&&(c===s.charCodeAt(l)?--l==-1&&(t=r):(l=-1,t=a))}return i===t?t=a:t===-1&&(t=y.length),y.slice(i,t)}for(r=y.length-1;r>=i;--r)if(o(y.charCodeAt(r))){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":y.slice(i,t)},extname(y){b(y,"path");let s=0,i=-1,t=0,n=-1,r=!0,l=0;y.length>=2&&y.charCodeAt(1)===R&&E(y.charCodeAt(0))&&(s=t=2);for(let a=y.length-1;a>=s;--a){const c=y.charCodeAt(a);if(o(c)){if(!r){t=a+1;break}continue}n===-1&&(r=!1,n=a+1),c===T?i===-1?i=a:l!==1&&(l=1):i!==-1&&(l=-1)}return i===-1||n===-1||l===0||l===1&&i===n-1&&i===t+1?"":y.slice(i,n)},format:w.bind(null,"\\"),parse(y){b(y,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return s;const i=y.length;let t=0,n=y.charCodeAt(0);if(i===1)return o(n)?(s.root=s.dir=y,s):(s.base=s.name=y,s);if(o(n)){if(t=1,o(y.charCodeAt(1))){let I=2,u=I;for(;I<i&&!o(y.charCodeAt(I));)I++;if(I<i&&I!==u){for(u=I;I<i&&o(y.charCodeAt(I));)I++;if(I<i&&I!==u){for(u=I;I<i&&!o(y.charCodeAt(I));)I++;I===i?t=I:I!==u&&(t=I+1)}}}}else if(E(n)&&y.charCodeAt(1)===R){if(i<=2)return s.root=s.dir=y,s;if(t=2,o(y.charCodeAt(2))){if(i===3)return s.root=s.dir=y,s;t=3}}t>0&&(s.root=y.slice(0,t));let r=-1,l=t,a=-1,c=!0,h=y.length-1,S=0;for(;h>=t;--h){if(n=y.charCodeAt(h),o(n)){if(!c){l=h+1;break}continue}a===-1&&(c=!1,a=h+1),n===T?r===-1?r=h:S!==1&&(S=1):r!==-1&&(S=-1)}return a!==-1&&(r===-1||S===0||S===1&&r===a-1&&r===l+1?s.base=s.name=y.slice(l,a):(s.name=y.slice(l,r),s.base=y.slice(l,a),s.ext=y.slice(r,a))),l>0&&l!==t?s.dir=y.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let s="",i=!1;for(let t=y.length-1;t>=-1&&!i;t--){const n=t>=0?y[t]:v.cwd();b(n,"path"),n.length!==0&&(s=`${n}/${s}`,i=n.charCodeAt(0)===f)}return s=p(s,!i,"/",C),i?`/${s}`:s.length>0?s:"."},normalize(y){if(b(y,"path"),y.length===0)return".";const s=y.charCodeAt(0)===f,i=y.charCodeAt(y.length-1)===f;return y=p(y,!s,"/",C),y.length===0?s?"/":i?"./":".":(i&&(y+="/"),s?`/${y}`:y)},isAbsolute(y){return b(y,"path"),y.length>0&&y.charCodeAt(0)===f},join(...y){if(y.length===0)return".";let s;for(let i=0;i<y.length;++i){const t=y[i];b(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(y,s){if(b(y,"from"),b(s,"to"),y===s||(y=e.posix.resolve(y),s=e.posix.resolve(s),y===s))return"";const i=1,t=y.length,n=t-i,r=1,l=s.length-r,a=n<l?n:l;let c=-1,h=0;for(;h<a;h++){const I=y.charCodeAt(i+h);if(I!==s.charCodeAt(r+h))break;I===f&&(c=h)}if(h===a)if(l>a){if(s.charCodeAt(r+h)===f)return s.slice(r+h+1);if(h===0)return s.slice(r+h)}else n>a&&(y.charCodeAt(i+h)===f?c=h:h===0&&(c=0));let S="";for(h=i+c+1;h<=t;++h)(h===t||y.charCodeAt(h)===f)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(r+c)}`},toNamespacedPath(y){return y},dirname(y){if(b(y,"path"),y.length===0)return".";const s=y.charCodeAt(0)===f;let i=-1,t=!0;for(let n=y.length-1;n>=1;--n)if(y.charCodeAt(n)===f){if(!t){i=n;break}}else t=!1;return i===-1?s?"/":".":s&&i===1?"//":y.slice(0,i)},basename(y,s){s!==void 0&&b(s,"ext"),b(y,"path");let i=0,t=-1,n=!0,r;if(s!==void 0&&s.length>0&&s.length<=y.length){if(s===y)return"";let l=s.length-1,a=-1;for(r=y.length-1;r>=0;--r){const c=y.charCodeAt(r);if(c===f){if(!n){i=r+1;break}}else a===-1&&(n=!1,a=r+1),l>=0&&(c===s.charCodeAt(l)?--l==-1&&(t=r):(l=-1,t=a))}return i===t?t=a:t===-1&&(t=y.length),y.slice(i,t)}for(r=y.length-1;r>=0;--r)if(y.charCodeAt(r)===f){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":y.slice(i,t)},extname(y){b(y,"path");let s=-1,i=0,t=-1,n=!0,r=0;for(let l=y.length-1;l>=0;--l){const a=y.charCodeAt(l);if(a===f){if(!n){i=l+1;break}continue}t===-1&&(n=!1,t=l+1),a===T?s===-1?s=l:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||t===-1||r===0||r===1&&s===t-1&&s===i+1?"":y.slice(s,t)},format:w.bind(null,"/"),parse(y){b(y,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return s;const i=y.charCodeAt(0)===f;let t;i?(s.root="/",t=1):t=0;let n=-1,r=0,l=-1,a=!0,c=y.length-1,h=0;for(;c>=t;--c){const S=y.charCodeAt(c);if(S===f){if(!a){r=c+1;break}continue}l===-1&&(a=!1,l=c+1),S===T?n===-1?n=c:h!==1&&(h=1):n!==-1&&(h=-1)}if(l!==-1){const S=r===0&&i?1:r;n===-1||h===0||h===1&&n===l-1&&n===r+1?s.base=s.name=y.slice(S,l):(s.name=y.slice(S,n),s.base=y.slice(S,l),s.ext=y.slice(n,l))}return r>0?s.dir=y.slice(0,r-1):i&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var U in v)(typeof exports=="object"?exports:K)[U]=v[U]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function v(U){if(e[U])return e[U].exports;var A=e[U]={i:U,l:!1,exports:{}};return K[U].call(A.exports,A,A.exports,v),A.l=!0,A.exports}return v.m=K,v.c=e,v.d=function(U,A,P){v.o(U,A)||Object.defineProperty(U,A,{enumerable:!0,get:P})},v.r=function(U){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},v.t=function(U,A){if(1&A&&(U=v(U)),8&A||4&A&&typeof U=="object"&&U&&U.__esModule)return U;var P=Object.create(null);if(v.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:U}),2&A&&typeof U!="string")for(var k in U)v.d(P,k,function(T){return U[T]}.bind(null,k));return P},v.n=function(U){var A=U&&U.__esModule?function(){return U.default}:function(){return U};return v.d(A,"a",A),A},v.o=function(U,A){return Object.prototype.hasOwnProperty.call(U,A)},v.p="",v(v.s=0)}([function(K,e,v){(function(U){var A;e=K.exports=X,A=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],f=e.src=[],g=0,R=g++;f[R]="0|[1-9]\\d*";var d=g++;f[d]="[0-9]+";var m=g++;f[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;f[b]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var o=g++;f[o]="("+f[d]+")\\.("+f[d]+")\\.("+f[d]+")";var C=g++;f[C]="(?:"+f[R]+"|"+f[m]+")";var E=g++;f[E]="(?:"+f[d]+"|"+f[m]+")";var p=g++;f[p]="(?:-("+f[C]+"(?:\\."+f[C]+")*))";var w=g++;f[w]="(?:-?("+f[E]+"(?:\\."+f[E]+")*))";var y=g++;f[y]="[0-9A-Za-z-]+";var s=g++;f[s]="(?:\\+("+f[y]+"(?:\\."+f[y]+")*))";var i=g++,t="v?"+f[b]+f[p]+"?"+f[s]+"?";f[i]="^"+t+"$";var n="[v=\\s]*"+f[o]+f[w]+"?"+f[s]+"?",r=g++;f[r]="^"+n+"$";var l=g++;f[l]="((?:<|>)?=?)";var a=g++;f[a]=f[d]+"|x|X|\\*";var c=g++;f[c]=f[R]+"|x|X|\\*";var h=g++;f[h]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[p]+")?"+f[s]+"?)?)?";var S=g++;f[S]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[w]+")?"+f[s]+"?)?)?";var I=g++;f[I]="^"+f[l]+"\\s*"+f[h]+"$";var u=g++;f[u]="^"+f[l]+"\\s*"+f[S]+"$";var L=g++;f[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=g++;f[_]="(?:~>?)";var $=g++;f[$]="(\\s*)"+f[_]+"\\s+",T[$]=new RegExp(f[$],"g");var B=g++;f[B]="^"+f[_]+f[h]+"$";var M=g++;f[M]="^"+f[_]+f[S]+"$";var j=g++;f[j]="(?:\\^)";var W=g++;f[W]="(\\s*)"+f[j]+"\\s+",T[W]=new RegExp(f[W],"g");var z=g++;f[z]="^"+f[j]+f[h]+"$";var H=g++;f[H]="^"+f[j]+f[S]+"$";var q=g++;f[q]="^"+f[l]+"\\s*("+n+")$|^$";var D=g++;f[D]="^"+f[l]+"\\s*("+t+")$|^$";var O=g++;f[O]="(\\s*)"+f[l]+"\\s*("+n+"|"+f[h]+")",T[O]=new RegExp(f[O],"g");var F=g++;f[F]="^\\s*("+f[h]+")\\s+-\\s+("+f[h]+")\\s*$";var N=g++;f[N]="^\\s*("+f[S]+")\\s+-\\s+("+f[S]+")\\s*$";var V=g++;f[V]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)A(G,f[G]),T[G]||(T[G]=new RegExp(f[G]));function Q(J,re){if(J instanceof X)return J;if(typeof J!="string"||J.length>P||!(re?T[r]:T[i]).test(J))return null;try{return new X(J,re)}catch(se){return null}}function X(J,re){if(J instanceof X){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof X))return new X(J,re);A("SemVer",J,re),this.loose=re;var se=J.trim().match(re?T[r]:T[i]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var x=+me;if(x>=0&&x<k)return x}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=Q,e.valid=function(J,re){var se=Q(J,re);return se?se.version:null},e.clean=function(J,re){var se=Q(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return A("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),ie(this.major,J.major)||ie(this.minor,J.minor)||ie(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=J.prerelease[re];if(A("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ie(se,me)}while(++re)},X.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new X(J,se).inc(re,me).version}catch(x){return null}},e.diff=function(J,re){if(we(J,re))return null;var se=Q(J),me=Q(re);if(se.prerelease.length||me.prerelease.length){for(var x in se)if((x==="major"||x==="minor"||x==="patch")&&se[x]!==me[x])return"pre"+x;return"prerelease"}for(var x in se)if((x==="major"||x==="minor"||x==="patch")&&se[x]!==me[x])return x},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(J,re){var se=ne.test(J),me=ne.test(re);return se&&me&&(J=+J,re=+re),se&&!me?-1:me&&!se?1:J<re?-1:J>re?1:0}function ae(J,re,se){return new X(J,se).compare(new X(re,se))}function he(J,re,se){return ae(J,re,se)>0}function fe(J,re,se){return ae(J,re,se)<0}function we(J,re,se){return ae(J,re,se)===0}function Ie(J,re,se){return ae(J,re,se)!==0}function ke(J,re,se){return ae(J,re,se)>=0}function Ue(J,re,se){return ae(J,re,se)<=0}function Fe(J,re,se,me){var x;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),x=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),x=J!==se;break;case"":case"=":case"==":x=we(J,se,me);break;case"!=":x=Ie(J,se,me);break;case">":x=he(J,se,me);break;case">=":x=ke(J,se,me);break;case"<":x=fe(J,se,me);break;case"<=":x=Ue(J,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return x}function _e(J,re){if(J instanceof _e){if(J.loose===re)return J;J=J.value}if(!(this instanceof _e))return new _e(J,re);A("comparator",J,re),this.loose=re,this.parse(J),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(J,re){return ie(re,J)},e.major=function(J,re){return new X(J,re).major},e.minor=function(J,re){return new X(J,re).minor},e.patch=function(J,re){return new X(J,re).patch},e.compare=ae,e.compareLoose=function(J,re){return ae(J,re,!0)},e.rcompare=function(J,re,se){return ae(re,J,se)},e.sort=function(J,re){return J.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(J,re){return J.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=he,e.lt=fe,e.eq=we,e.neq=Ie,e.gte=ke,e.lte=Ue,e.cmp=Fe,e.Comparator=_e;var Me={};function De(J,re){if(J instanceof De)return J.loose===re?J:new De(J.raw,re);if(J instanceof _e)return new De(J.value,re);if(!(this instanceof De))return new De(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function $e(J,re,se,me,x,te,oe,ce,le,de,ve,ye,Ee){return((re=Ae(se)?"":Ae(me)?">="+se+".0.0":Ae(x)?">="+se+"."+me+".0":">="+re)+" "+(ce=Ae(le)?"":Ae(de)?"<"+(+le+1)+".0.0":Ae(ve)?"<"+le+"."+(+de+1)+".0":ye?"<="+le+"."+de+"."+ve+"-"+ye:"<="+ce)).trim()}function He(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(A(J[se].semver),J[se].semver!==Me&&J[se].semver.prerelease.length>0){var me=J[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function Ne(J,re,se){try{re=new De(re,se)}catch(me){return!1}return re.test(J)}function ze(J,re,se,me){var x,te,oe,ce,le;switch(J=new X(J,me),re=new De(re,me),se){case">":x=he,te=Ue,oe=fe,ce=">",le=">=";break;case"<":x=fe,te=ke,oe=he,ce="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(J,re,me))return!1;for(var de=0;de<re.set.length;++de){var ve=re.set[de],ye=null,Ee=null;if(ve.forEach(function(be){be.semver===Me&&(be=new _e(">=0.0.0")),ye=ye||be,Ee=Ee||be,x(be.semver,ye.semver,me)?ye=be:oe(be.semver,Ee.semver,me)&&(Ee=be)}),ye.operator===ce||ye.operator===le||(!Ee.operator||Ee.operator===ce)&&te(J,Ee.semver)||Ee.operator===le&&oe(J,Ee.semver))return!1}return!0}_e.prototype.parse=function(J){var re=this.loose?T[q]:T[D],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new X(se[2],this.loose):this.semver=Me},_e.prototype.toString=function(){return this.value},_e.prototype.test=function(J){return A("Comparator.test",J,this.loose),this.semver===Me||(typeof J=="string"&&(J=new X(J,this.loose)),Fe(J,this.operator,this.semver,this.loose))},_e.prototype.intersects=function(J,re){if(!(J instanceof _e))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new De(J.value,re),Ne(this.value,se,re);if(J.operator==="")return se=new De(this.value,re),Ne(J.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),x=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),te=this.semver.version===J.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),ce=Fe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),le=Fe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||x||te&&oe||ce||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),A("range",J,re);var se=re?T[N]:T[F];J=J.replace(se,$e),A("hyphen replace",J),J=J.replace(T[O],"$1$2$3"),A("comparator trim",J,T[O]),J=(J=(J=J.replace(T[$],"$1~")).replace(T[W],"$1^")).split(/\s+/).join(" ");var me=re?T[q]:T[D],x=J.split(" ").map(function(te){return function(oe,ce){return A("comp",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){A("caret",ye,Ee);var be=Ee?T[H]:T[z];return ye.replace(be,function(Le,Se,pe,Ce,Re){var Te;return A("caret",ye,Le,Se,pe,Ce,Re),Ae(Se)?Te="":Ae(pe)?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ae(Ce)?Te=Se==="0"?">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+".0 <"+(+Se+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+Re+" <"+(+Se+1)+".0.0"):(A("no pr"),Te=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+" <"+(+Se+1)+".0.0"),A("caret return",Te),Te})}(ve,de)}).join(" ")}(oe,ce),A("caret",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){var be=Ee?T[M]:T[B];return ye.replace(be,function(Le,Se,pe,Ce,Re){var Te;return A("tilde",ye,Le,Se,pe,Ce,Re),Ae(Se)?Te="":Ae(pe)?Te=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ae(Ce)?Te=">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0"):Te=">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0",A("tilde return",Te),Te})}(ve,de)}).join(" ")}(oe,ce),A("tildes",oe),oe=function(le,de){return A("replaceXRanges",le,de),le.split(/\s+/).map(function(ve){return function(ye,Ee){ye=ye.trim();var be=Ee?T[u]:T[I];return ye.replace(be,function(Le,Se,pe,Ce,Re,Te){A("xRange",ye,Le,Se,pe,Ce,Re,Te);var ge=Ae(pe),Pe=ge||Ae(Ce),Oe=Pe||Ae(Re);return Se==="="&&Oe&&(Se=""),ge?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Oe?(Pe&&(Ce=0),Oe&&(Re=0),Se===">"?(Se=">=",Pe?(pe=+pe+1,Ce=0,Re=0):Oe&&(Ce=+Ce+1,Re=0)):Se==="<="&&(Se="<",Pe?pe=+pe+1:Ce=+Ce+1),Le=Se+pe+"."+Ce+"."+Re):Pe?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Oe&&(Le=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),A("xRange return",Le),Le})}(ve,de)}).join(" ")}(oe,ce),A("xrange",oe),oe=function(le,de){return A("replaceStars",le,de),le.trim().replace(T[V],"")}(oe,ce),A("stars",oe),oe}(te,re)}).join(" ").split(/\s+/);return this.loose&&(x=x.filter(function(te){return!!te.match(me)})),x=x.map(function(te){return new _e(te,re)})},De.prototype.intersects=function(J,re){if(!(J instanceof De))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return J.set.some(function(x){return x.every(function(te){return me.intersects(te,re)})})})})},e.toComparators=function(J,re){return new De(J,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var re=0;re<this.set.length;re++)if(He(this.set[re],J))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(J,re,se){var me=null,x=null;try{var te=new De(re,se)}catch(oe){return null}return J.forEach(function(oe){te.test(oe)&&(me&&x.compare(oe)!==-1||(x=new X(me=oe,se)))}),me},e.minSatisfying=function(J,re,se){var me=null,x=null;try{var te=new De(re,se)}catch(oe){return null}return J.forEach(function(oe){te.test(oe)&&(me&&x.compare(oe)!==1||(x=new X(me=oe,se)))}),me},e.validRange=function(J,re){try{return new De(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return ze(J,re,"<",se)},e.gtr=function(J,re,se){return ze(J,re,">",se)},e.outside=ze,e.prerelease=function(J,re){var se=Q(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new De(J,se),re=new De(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var re=J.match(T[L]);return re==null?null:Q((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,v(1))},function(K,e){var v,U,A=K.exports={};function P(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function T(E){if(v===setTimeout)return setTimeout(E,0);if((v===P||!v)&&setTimeout)return v=setTimeout,setTimeout(E,0);try{return v(E,0)}catch(p){try{return v.call(null,E,0)}catch(w){return v.call(this,E,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:P}catch(E){v=P}try{U=typeof clearTimeout=="function"?clearTimeout:k}catch(E){U=k}})();var f,g=[],R=!1,d=-1;function m(){R&&f&&(R=!1,f.length?g=f.concat(g):d=-1,g.length&&b())}function b(){if(!R){var E=T(m);R=!0;for(var p=g.length;p;){for(f=g,g=[];++d<p;)f&&f[d].run();d=-1,p=g.length}f=null,R=!1,function(w){if(U===clearTimeout)return clearTimeout(w);if((U===k||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(w);try{U(w)}catch(y){try{return U.call(null,w)}catch(s){return U.call(this,w)}}}(E)}}function o(E,p){this.fun=E,this.array=p}function C(){}A.nextTick=function(E){var p=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)p[w-1]=arguments[w];g.push(new o(E,p)),g.length!==1||R||T(b)},o.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=C,A.addListener=C,A.once=C,A.off=C,A.removeListener=C,A.removeAllListeners=C,A.emit=C,A.prependListener=C,A.prependOnceListener=C,A.listeners=function(E){return[]},A.binding=function(E){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(E){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[87],ee([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const U=v.globals.performance&&typeof v.globals.performance.now=="function";class A{constructor(k){this._highResolution=U&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new A(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,13,63,2,64,87]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var T;(function(p){p.None=()=>A.Disposable.None;function w(M){return(j,W=null,z)=>{let H=!1,q;return q=M(D=>{if(!H)return q?q.dispose():H=!0,j.call(W,D)},null,z),H&&q.dispose(),q}}p.once=w;function y(M,j){return l((W,z=null,H)=>M(q=>W.call(z,j(q)),null,H))}p.map=y;function s(M,j){return l((W,z=null,H)=>M(q=>{j(q),W.call(z,q)},null,H))}p.forEach=s;function i(M,j){return l((W,z=null,H)=>M(q=>j(q)&&W.call(z,q),null,H))}p.filter=i;function t(M){return M}p.signal=t;function n(...M){return(j,W=null,z)=>(0,A.combinedDisposable)(...M.map(H=>H(q=>j.call(W,q),null,z)))}p.any=n;function r(M,j,W){let z=W;return y(M,H=>(z=j(z,H),z))}p.reduce=r;function l(M){let j;const W=new m({onFirstListenerAdd(){j=M(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}p.snapshot=l;function a(M,j,W=100,z=!1,H){let q,D,O,F=0;const N=new m({leakWarningThreshold:H,onFirstListenerAdd(){q=M(V=>{F++,D=j(D,V),z&&!O&&(N.fire(D),D=void 0),clearTimeout(O),O=setTimeout(()=>{const G=D;D=void 0,O=void 0,(!z||F>1)&&N.fire(G),F=0},W)})},onLastListenerRemove(){q.dispose()}});return N.event}p.debounce=a;function c(M){const j=new Date().getTime();return y(w(M),W=>new Date().getTime()-j)}p.stopwatch=c;function h(M){let j=!0,W;return i(M,z=>{const H=j||z!==W;return j=!1,W=z,H})}p.latch=h;function S(M,j=!1,W=[]){let z=W.slice(),H=M(O=>{z?z.push(O):D.fire(O)});const q=()=>{z&&z.forEach(O=>D.fire(O)),z=null},D=new m({onFirstListenerAdd(){H||(H=M(O=>D.fire(O)))},onFirstListenerDidAdd(){z&&(j?setTimeout(q):q())},onLastListenerRemove(){H&&H.dispose(),H=null}});return D.event}p.buffer=S;class I{constructor(j){this.event=j}map(j){return new I(y(this.event,j))}forEach(j){return new I(s(this.event,j))}filter(j){return new I(i(this.event,j))}reduce(j,W){return new I(r(this.event,j,W))}latch(){return new I(h(this.event))}debounce(j,W=100,z=!1,H){return new I(a(this.event,j,W,z,H))}on(j,W,z){return this.event(j,W,z)}once(j,W,z){return w(this.event)(j,W,z)}}function u(M){return new I(M)}p.chain=u;function L(M,j,W=z=>z){const z=(...O)=>D.fire(W(...O)),H=()=>M.on(j,z),q=()=>M.removeListener(j,z),D=new m({onFirstListenerAdd:H,onLastListenerRemove:q});return D.event}p.fromNodeEventEmitter=L;function _(M,j,W=z=>z){const z=(...O)=>D.fire(W(...O)),H=()=>M.addEventListener(j,z),q=()=>M.removeEventListener(j,z),D=new m({onFirstListenerAdd:H,onLastListenerRemove:q});return D.event}p.fromDOMEventEmitter=_;function $(M){const j=new m;let W=!1;return M.then(void 0,()=>null).then(()=>{W?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),W=!0,j.event}p.fromPromise=$;function B(M){return new Promise(j=>w(M)(j))}p.toPromise=B})(T=e.Event||(e.Event={}));class f{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${f._idPool++}`}start(w){this._stopWatch=new k.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let g=-1;function R(p){const w=g;return g=p,{dispose(){g=w}}}e.setGlobalLeakWarningThreshold=R;class d{constructor(w,y=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=y,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let y=g;if(typeof this.customThreshold=="number"&&(y=this.customThreshold),!(y<=0||w<y)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(s)||0;if(this._stacks.set(s,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let t,n=0;for(const[r,l]of this._stacks)(!t||n<l)&&(t=r,n=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}}class m{constructor(w){var y;this._disposed=!1,this._options=w,this._leakageMon=g>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((y=this._options)===null||y===void 0?void 0:y._profName)?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(w,y,s)=>{var i;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(y?[w,y]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,y);const r=(i=this._leakageMon)===null||i===void 0?void 0:i.check(this._listeners.size);let l;return l={dispose:()=>{r&&r(),l.dispose=m._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof A.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(w){var y,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,w]);for((y=this._perfMon)===null||y===void 0||y.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,t]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,t):i[0].call(i[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var w,y,s;(w=this._listeners)===null||w===void 0||w.clear(),(y=this._deliveryQueue)===null||y===void 0||y.clear(),(s=this._leakageMon)===null||s===void 0||s.dispose(),this._disposed=!0}}e.Emitter=m,m._noop=function(){};class b extends m{constructor(w){super(w);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=b;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const y={event:w,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const s=()=>{this.hasListeners&&this.unhook(y);const i=this.events.indexOf(y);this.events.splice(i,1)};return(0,A.toDisposable)((0,U.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(y=>this.emitter.fire(y))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class C{constructor(){this.buffers=[]}wrapEvent(w){return(y,s,i)=>w(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>y.call(s,t)):y.call(s,t)},void 0,i)}bufferEvents(w){const y=[];this.buffers.push(y);const s=w();return this.buffers.pop(),y.forEach(i=>i()),s}}e.EventBufferer=C;class E{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=A.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Z[30],ee([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(T,f){const g=setTimeout(T.bind(f),0);return{dispose(){clearTimeout(g)}}});var A;(function(T){function f(g){return g===T.None||g===T.Cancelled||g instanceof P?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}T.isCancellationToken=f,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(A=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=A.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=k}),define(Z[47],ee([0,1,13,2]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(E){const p=E;return p&&[p.on,p.pause,p.resume,p.destroy].every(w=>typeof w=="function")}e.isReadableStream=A;function P(E){const p=E;return p&&A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=P;function k(E,p){return new T(E,p)}e.newWriteableStream=k;class T{constructor(p,w){this.reducer=p,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(w=>w(p))}emitError(p){this.listeners.error.length===0?(0,v.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(w=>w(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,w){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(p,w){if(!this.state.destroyed){let y;switch(p){case"data":y=this.listeners.data;break;case"end":y=this.listeners.end;break;case"error":y=this.listeners.error;break}if(y){const s=y.indexOf(w);s>=0&&y.splice(s,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(y=>y())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(E,p){const w=[];let y;for(;(y=E.read())!==null;)w.push(y);return p(w)}e.consumeReadable=f;function g(E,p,w){const y=[];let s;for(;(s=E.read())!==null&&y.length<w;)y.push(s);return s===null&&y.length>0?p(y):{read:()=>{if(y.length>0)return y.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return E.read()}}}e.peekReadable=g;function R(E,p){return new Promise((w,y)=>{const s=[];d(E,{onData:i=>{p&&s.push(i)},onError:i=>{p?y(i):w(void 0)},onEnd:()=>{w(p?p(s):void 0)}})})}e.consumeStream=R;function d(E,p){E.on("error",w=>p.onError(w)),E.on("end",()=>p.onEnd()),E.on("data",w=>p.onData(w))}e.listenStream=d;function m(E,p){return new Promise((w,y)=>{const s=new U.DisposableStore,i=[],t=l=>{if(i.push(l),i.length>p)return s.dispose(),E.pause(),w({stream:E,buffer:i,ended:!1})},n=l=>y(l),r=()=>w({stream:E,buffer:i,ended:!0});s.add((0,U.toDisposable)(()=>E.removeListener("error",n))),E.on("error",n),s.add((0,U.toDisposable)(()=>E.removeListener("end",r))),E.on("end",r),s.add((0,U.toDisposable)(()=>E.removeListener("data",t))),E.on("data",t)})}e.peekStream=m;function b(E,p){const w=k(p);return w.end(E),w}e.toStream=b;function o(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}e.toReadable=o;function C(E,p,w){const y=k(w);return d(E,{onData:s=>y.write(p.data(s)),onError:s=>y.error(p.error?p.error(s):s),onEnd:()=>y.end()}),y}e.transform=C}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=v;const U=/{(\d+)}/g;function A(x,...te){return te.length===0?x:x.replace(U,function(oe,ce){const le=parseInt(ce,10);return isNaN(le)||le<0||le>=te.length?oe:te[le]})}e.format=A;function P(x){return x.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function k(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function T(x,te){let oe=0;const ce=te.charCodeAt(0);for(let le=x.length-1;le>=0;le--)x.charCodeAt(le)===ce&&oe++;return oe}e.count=T;function f(x,te,oe="\u2026"){return x.length<=te?x:`${x.substr(0,te)}${oe}`}e.truncate=f;function g(x,te=" "){const oe=R(x,te);return d(oe,te)}e.trim=g;function R(x,te){if(!x||!te)return x;const oe=te.length;if(oe===0||x.length===0)return x;let ce=0;for(;x.indexOf(te,ce)===ce;)ce=ce+oe;return x.substring(ce)}e.ltrim=R;function d(x,te){if(!x||!te)return x;const oe=te.length,ce=x.length;if(oe===0||ce===0)return x;let le=ce,de=-1;for(;de=x.lastIndexOf(te,le-1),!(de===-1||de+oe!==le);){if(de===0)return"";le=de}return x.substring(0,le)}e.rtrim=d;function m(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function b(x){return x.replace(/\*/g,"")}e.stripWildcards=b;function o(x,te,oe={}){if(!x)throw new Error("Cannot create regex from empty string");te||(x=k(x)),oe.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let ce="";return oe.global&&(ce+="g"),oe.matchCase||(ce+="i"),oe.multiline&&(ce+="m"),oe.unicode&&(ce+="u"),new RegExp(x,ce)}e.createRegExp=o;function C(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function E(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function p(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=p;function w(x){return x.split(/\r\n|\r|\n/)}e.splitLines=w;function y(x){for(let te=0,oe=x.length;te<oe;te++){const ce=x.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=y;function s(x,te=0,oe=x.length){for(let ce=te;ce<oe;ce++){const le=x.charCodeAt(ce);if(le!==32&&le!==9)return x.substring(te,ce)}return x.substring(te,oe)}e.getLeadingWhitespace=s;function i(x,te=x.length-1){for(let oe=te;oe>=0;oe--){const ce=x.charCodeAt(oe);if(ce!==32&&ce!==9)return oe}return-1}e.lastNonWhitespaceIndex=i;function t(x,te){return x<te?-1:x>te?1:0}e.compare=t;function n(x,te,oe=0,ce=x.length,le=0,de=te.length){for(;oe<ce&&le<de;oe++,le++){let Ee=x.charCodeAt(oe),be=te.charCodeAt(le);if(Ee<be)return-1;if(Ee>be)return 1}const ve=ce-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function r(x,te){return l(x,te,0,x.length,0,te.length)}e.compareIgnoreCase=r;function l(x,te,oe=0,ce=x.length,le=0,de=te.length){for(;oe<ce&&le<de;oe++,le++){let Ee=x.charCodeAt(oe),be=te.charCodeAt(le);if(Ee!==be){const Le=Ee-be;if(!(Le===32&&c(be))&&!(Le===-32&&c(Ee)))return a(Ee)&&a(be)?Le:n(x.toLowerCase(),te.toLowerCase(),oe,ce,le,de)}}const ve=ce-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=l;function a(x){return x>=97&&x<=122}e.isLowerAsciiLetter=a;function c(x){return x>=65&&x<=90}e.isUpperAsciiLetter=c;function h(x){return a(x)||c(x)}function S(x,te){return x.length===te.length&&I(x,te)}e.equalsIgnoreCase=S;function I(x,te,oe=x.length){for(let ce=0;ce<oe;ce++){const le=x.charCodeAt(ce),de=te.charCodeAt(ce);if(le!==de){if(h(le)&&h(de)){const ve=Math.abs(le-de);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(de).toLowerCase())return!1}}return!0}function u(x,te){const oe=te.length;return te.length>x.length?!1:I(x,te,oe)}e.startsWithIgnoreCase=u;function L(x,te){let oe,ce=Math.min(x.length,te.length);for(oe=0;oe<ce;oe++)if(x.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ce}e.commonPrefixLength=L;function _(x,te){let oe,ce=Math.min(x.length,te.length);const le=x.length-1,de=te.length-1;for(oe=0;oe<ce;oe++)if(x.charCodeAt(le-oe)!==te.charCodeAt(de-oe))return oe;return ce}e.commonSuffixLength=_;function $(x){return 55296<=x&&x<=56319}e.isHighSurrogate=$;function B(x){return 56320<=x&&x<=57343}e.isLowSurrogate=B;function M(x,te){return(x-55296<<10)+(te-56320)+65536}e.computeCodePoint=M;function j(x,te,oe){const ce=x.charCodeAt(oe);if($(ce)&&oe+1<te){const le=x.charCodeAt(oe+1);if(B(le))return M(ce,le)}return ce}e.getNextCodePoint=j;function W(x,te){const oe=x.charCodeAt(te-1);if(B(oe)&&te>1){const ce=x.charCodeAt(te-2);if($(ce))return M(ce,oe)}return oe}function z(x,te){const oe=se.getInstance(),ce=te,le=x.length,de=j(x,le,te);te+=de>=65536?2:1;let ve=oe.getGraphemeBreakType(de);for(;te<le;){const ye=j(x,le,te),Ee=oe.getGraphemeBreakType(ye);if(J(ve,Ee))break;te+=ye>=65536?2:1,ve=Ee}return te-ce}e.nextCharLength=z;function H(x,te){const oe=se.getInstance(),ce=te,le=W(x,te);te-=le>=65536?2:1;let de=oe.getGraphemeBreakType(le);for(;te>0;){const ve=W(x,te),ye=oe.getGraphemeBreakType(ve);if(J(ye,de))break;te-=ve>=65536?2:1,de=ye}return ce-te}e.prevCharLength=H;function q(x,te){const oe=se.getInstance(),ce=x.length,le=te,de=j(x,ce,te),ve=oe.getGraphemeBreakType(de);te+=de>=65536?2:1;let ye=ve;for(;te<ce;){const be=j(x,ce,te),Le=oe.getGraphemeBreakType(be);if(J(ye,Le))break;te+=be>=65536?2:1,ye=Le}const Ee=te;for(te=le,ye=ve;te>0;){const be=W(x,te),Le=oe.getGraphemeBreakType(be);if(J(Le,ye))break;te-=be>=65536?2:1,ye=Le}return[te,Ee]}function D(x,te){return te>0&&B(x.charCodeAt(te))?q(x,te-1):q(x,te)}e.getCharContainingOffset=D;function O(x){const te=x.length;let oe=0,ce=0;for(;ce<te;){const ve=j(x,te,ce);ce+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ce=0;let de=0;for(;ce<te;){const ve=j(x,te,ce);ce+=ve>=65536?2:1,ve<128?le[de++]=ve:ve<2048?(le[de++]=192|(ve&1984)>>>6,le[de++]=128|(ve&63)>>>0):ve<65536?(le[de++]=224|(ve&61440)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0):(le[de++]=240|(ve&1835008)>>>18,le[de++]=128|(ve&258048)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=O;function F(x){const te=x.byteLength,oe=[];let ce=0;for(;ce<te;){const le=x[ce];let de;if(le>=240&&ce+3<te?de=(x[ce++]&7)<<18>>>0|(x[ce++]&63)<<12>>>0|(x[ce++]&63)<<6>>>0|(x[ce++]&63)<<0>>>0:le>=224&&ce+2<te?de=(x[ce++]&15)<<12>>>0|(x[ce++]&63)<<6>>>0|(x[ce++]&63)<<0>>>0:le>=192&&ce+1<te?de=(x[ce++]&31)<<6>>>0|(x[ce++]&63)<<0>>>0:de=x[ce++],de>=0&&de<=55295||de>=57344&&de<=65535)oe.push(String.fromCharCode(de));else if(de>=65536&&de<=1114111){const ve=de-65536,ye=55296+((ve&1047552)>>>10),Ee=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(ye)),oe.push(String.fromCharCode(Ee))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(x){return N.test(x)}e.containsRTL=V;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Q(x){return G.test(x)}e.containsEmoji=Q;const X=/^[\t\n\r\x20-\x7E]*$/;function ne(x){return X.test(x)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ie;function ae(x){for(let te=0,oe=x.length;te<oe;te++)if(he(x.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ae;function he(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=he;function fe(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=fe;function we(x,te){if(x.length<te)return x;const oe=/\b/g;let ce=0;for(;oe.test(x)&&!(x.length-oe.lastIndex<te);)ce=oe.lastIndex,oe.lastIndex+=1;return x.substring(ce).replace(/^\s/,"")}e.lcut=we;const Ie=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Ue=/\x1b\[0?m/g;function Fe(x){return x&&(x=x.replace(Ie,""),x=x.replace(ke,""),x=x.replace(Ue,"")),x}e.removeAnsiEscapeCodes=Fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=_e;function Me(x){return _e(x)?x.substr(1):x}e.stripUTF8BOM=Me;function De(x,te){if(!x||!te||x.length<te.length)return!1;const oe=te.length,ce=x.toLowerCase();let le=0,de=-1;for(;le<oe;){const ve=ce.indexOf(te[le],de+1);if(ve<0)return!1;de=ve,le++}return!0}e.fuzzyContains=De;function Ae(x,te=!1){return x?(te&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Ae;function $e(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=$e;function He(x,te=1){if(te===0)return"";let oe=-1;do oe=x.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?x:(x[oe-1]==="\r"&&oe--,x.substr(0,oe))}e.getNLines=He;function Ne(x){const te=90-65+1;return x=x%(2*te),x<te?String.fromCharCode(97+x):String.fromCharCode(65+x-te)}e.singleLetterHash=Ne;function ze(x){return se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=ze;function J(x,te){return x===0?te!==5&&te!==7:x===2&&te===3?!1:x===4||x===2||x===3||te===4||te===2||te===3?!0:!(x===8&&(te===8||te===9||te===11||te===12)||(x===11||x===9)&&(te===9||te===10)||(x===12||x===10)&&te===10||te===5||te===13||te===7||x===1||x===13&&te===14||x===6&&te===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ce=oe.length/3;let le=1;for(;le<=ce;)if(te<oe[3*le])le=2*le;else if(te>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[22],ee([0,1,21,47]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let T,f;class g{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return A?new g(Buffer.allocUnsafe(a)):new g(new Uint8Array(a))}static wrap(a){return A&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new g(a)}static fromString(a,c){return!((c==null?void 0:c.dontUseNodeBuffer)||!1)&&A?new g(Buffer.from(a)):P?(T||(T=new TextEncoder),new g(T.encode(a))):new g(v.encodeUTF8(a))}static concat(a,c){if(typeof c=="undefined"){c=0;for(let I=0,u=a.length;I<u;I++)c+=a[I].byteLength}const h=g.alloc(c);let S=0;for(let I=0,u=a.length;I<u;I++){const L=a[I];h.set(L,S),S+=L.byteLength}return h}toString(){return A?this.buffer.toString():k?(f||(f=new TextDecoder),f.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(a,c){return new g(this.buffer.subarray(a,c))}set(a,c){a instanceof g?this.buffer.set(a.buffer,c):this.buffer.set(a,c)}readUInt32BE(a){return m(this.buffer,a)}writeUInt32BE(a,c){b(this.buffer,a,c)}readUInt32LE(a){return o(this.buffer,a)}writeUInt32LE(a,c){C(this.buffer,a,c)}readUInt8(a){return E(this.buffer,a)}writeUInt8(a,c){p(this.buffer,a,c)}}e.VSBuffer=g;function R(l,a){return l[a+0]<<0>>>0|l[a+1]<<8>>>0}e.readUInt16LE=R;function d(l,a,c){l[c+0]=a&255,a=a>>>8,l[c+1]=a&255}e.writeUInt16LE=d;function m(l,a){return l[a]*2**24+l[a+1]*2**16+l[a+2]*2**8+l[a+3]}e.readUInt32BE=m;function b(l,a,c){l[c+3]=a,a=a>>>8,l[c+2]=a,a=a>>>8,l[c+1]=a,a=a>>>8,l[c]=a}e.writeUInt32BE=b;function o(l,a){return l[a+0]<<0>>>0|l[a+1]<<8>>>0|l[a+2]<<16>>>0|l[a+3]<<24>>>0}e.readUInt32LE=o;function C(l,a,c){l[c+0]=a&255,a=a>>>8,l[c+1]=a&255,a=a>>>8,l[c+2]=a&255,a=a>>>8,l[c+3]=a&255}e.writeUInt32LE=C;function E(l,a){return l[a]}e.readUInt8=E;function p(l,a,c){l[c]=a}e.writeUInt8=p;function w(l){return U.consumeReadable(l,a=>g.concat(a))}e.readableToBuffer=w;function y(l){return U.toReadable(l)}e.bufferToReadable=y;function s(l){return U.consumeStream(l,a=>g.concat(a))}e.streamToBuffer=s;async function i(l){return l.ended?g.concat(l.buffer):g.concat([...l.buffer,await s(l.stream)])}e.bufferedStreamToBuffer=i;function t(l){return U.toStream(l,a=>g.concat(a))}e.bufferToStream=t;function n(l){return U.transform(l,{data:a=>typeof a=="string"?g.fromString(a):g.wrap(a)},a=>g.concat(a))}e.streamToBufferReadableStream=n;function r(l){return U.newWriteableStream(a=>g.concat(a),l)}e.newWriteableBufferStream=r}),define(Z[17],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(c){return Array.isArray(c)}e.isArray=v;function U(c){return typeof c=="string"}e.isString=U;function A(c){return Array.isArray(c)&&c.every(h=>U(h))}e.isStringArray=A;function P(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=P;function k(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=k;function T(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=T;function f(c){return c===!0||c===!1}e.isBoolean=f;function g(c){return typeof c=="undefined"}e.isUndefined=g;function R(c){return!d(c)}e.isDefined=R;function d(c){return g(c)||c===null}e.isUndefinedOrNull=d;function m(c,h){if(!c)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=m;function b(c){if(d(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=b;function o(...c){const h=[];for(let S=0;S<c.length;S++){const I=c[S];if(d(I))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);h.push(I)}return h}e.assertAllDefined=o;const C=Object.prototype.hasOwnProperty;function E(c){if(!P(c))return!1;for(let h in c)if(C.call(c,h))return!1;return!0}e.isEmptyObject=E;function p(c){return typeof c=="function"}e.isFunction=p;function w(...c){return c.length>0&&c.every(p)}e.areFunctions=w;function y(c,h){const S=Math.min(c.length,h.length);for(let I=0;I<S;I++)s(c[I],h[I])}e.validateConstraints=y;function s(c,h){if(U(h)){if(typeof c!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(p(h)){try{if(c instanceof h)return}catch(S){}if(!d(c)&&c.constructor===h||h.length===1&&h.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function i(c){let h=[],S=Object.getPrototypeOf(c);for(;Object.prototype!==S;)h=h.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return h}e.getAllPropertyNames=i;function t(c){const h=[];for(const S of i(c))typeof c[S]=="function"&&h.push(S);return h}e.getAllMethodNames=t;function n(c,h){const S=u=>function(){const L=Array.prototype.slice.call(arguments,0);return h(u,L)};let I={};for(const u of c)I[u]=S(u);return I}e.createProxyObject=n;function r(c){return c===null?void 0:c}e.withNullAsUndefined=r;function l(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=l;function a(c){return class{constructor(){return new Proxy({},{get(h,S){if(h[S])return h[S];throw new Error(`Not Implemented: ${c}->${String(S)}`)}})}}}e.NotImplementedProxy=a}),define(Z[42],ee([0,1,7,21,9,17]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function T(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=T;function f(n,r=A.posix.sep){if(!n)return"";const l=n.length,a=n.charCodeAt(0);if(k(a)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let h=3;const S=h;for(;h<l&&!k(n.charCodeAt(h));h++);if(S!==h&&!k(n.charCodeAt(h+1))){for(h+=1;h<l;h++)if(k(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,r)}}return r}else if(E(a)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<l;c++)if(k(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=f;function g(n){if(!v.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let l=2;const a=l;for(;l<n.length&&(r=n.charCodeAt(l),r!==92);l++);return!(a===l||(r=n.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=g;const R=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(n,r=v.isWindows){const l=r?R:d;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||r&&m.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=b;function o(n,r,l){const a=n===r;return!l||a?a:!n||!r?!1:(0,U.equalsIgnoreCase)(n,r)}e.isEqual=o;function C(n,r,l,a=A.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(l){if(!(0,U.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let h=r.length;return r.charAt(r.length-1)===a&&h--,n.charAt(h)===a}return r.charAt(r.length-1)!==a&&(r+=a),n.indexOf(r)===0}e.isEqualOrParent=C;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function p(n,r){return v.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(r,n)),n=(0,A.normalize)(n),v.isWindows?(n=(0,U.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,U.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=p;function w(n){const r=(0,A.normalize)(n);return v.isWindows?n.length>3?!1:y(r)&&(n.length===2||r.charCodeAt(2)===92):r===A.posix.sep}e.isRootOrDriveLetter=w;function y(n){return v.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function s(n){return y(n)?n[0]:void 0}e.getDriveLetter=s;function i(n,r,l){return r.length>n.length?-1:n===r?0:(l&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=i;function t(n){const r=n.split(":");let l,a,c;if(r.forEach(h=>{const S=Number(h);(0,P.isNumber)(S)?a===void 0?a=S:c===void 0&&(c=S):l=l?[l,h].join(":"):h}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:a!==void 0?a:void 0,column:c!==void 0?c:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const C=Array.isArray(o)?[]:{};return Object.keys(o).forEach(E=>{o[E]&&typeof o[E]=="object"?C[E]=U(o[E]):C[E]=o[E]}),C}e.deepClone=U;function A(o){if(!o||typeof o!="object")return o;const C=[o];for(;C.length>0;){const E=C.shift();Object.freeze(E);for(const p in E)if(P.call(E,p)){const w=E[p];typeof w=="object"&&!Object.isFrozen(w)&&C.push(w)}}return o}e.deepFreeze=A;const P=Object.prototype.hasOwnProperty;function k(o,C){return T(o,C,new Set)}e.cloneAndChange=k;function T(o,C,E){if((0,v.isUndefinedOrNull)(o))return o;const p=C(o);if(typeof p!="undefined")return p;if((0,v.isArray)(o)){const w=[];for(const y of o)w.push(T(y,C,E));return w}if((0,v.isObject)(o)){if(E.has(o))throw new Error("Cannot clone recursive data-structure");E.add(o);const w={};for(let y in o)P.call(o,y)&&(w[y]=T(o[y],C,E));return E.delete(o),w}return o}function f(o,C,E=!0){return(0,v.isObject)(o)?((0,v.isObject)(C)&&Object.keys(C).forEach(p=>{p in o?E&&((0,v.isObject)(o[p])&&(0,v.isObject)(C[p])?f(o[p],C[p],E):o[p]=C[p]):o[p]=C[p]}),o):C}e.mixin=f;function g(o,C){if(o===C)return!0;if(o==null||C===null||C===void 0||typeof o!=typeof C||typeof o!="object"||Array.isArray(o)!==Array.isArray(C))return!1;let E,p;if(Array.isArray(o)){if(o.length!==C.length)return!1;for(E=0;E<o.length;E++)if(!g(o[E],C[E]))return!1}else{const w=[];for(p in o)w.push(p);w.sort();const y=[];for(p in C)y.push(p);if(y.sort(),!g(w,y))return!1;for(E=0;E<w.length;E++)if(!g(o[w[E]],C[w[E]]))return!1}return!0}e.equals=g;function R(o){const C=new Set;return JSON.stringify(o,(E,p)=>{if((0,v.isObject)(p)||Array.isArray(p)){if(C.has(p))return"[Circular]";C.add(p)}return p})}e.safeStringify=R;function d(o,C,E){const p=C(o);return typeof p=="undefined"?E:p}e.getOrDefault=d;function m(o,C){const E=Object.create(null);return!o||!C||Object.keys(C).forEach(w=>{const y=o[w],s=C[w];g(y,s)||(E[w]=s)}),E}e.distinct=m;function b(o,C){const E=C.toLowerCase(),p=Object.keys(o).find(w=>w.toLowerCase()===E);return p?o[p]:o[C]}e.getCaseInsensitive=b}),define(Z[5],ee([0,1,7,9]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,P=/^\//,k=/^\/\//;function T(r,l){if(!r.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!A.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,l){return!r&&!l?"file":r}function g(r,l){switch(r){case"https":case"http":case"file":l?l[0]!==d&&(l=d+l):l=d;break}return l}const R="",d="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(l,a,c,h,S,I=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=f(l,I),this.authority=a||R,this.path=g(this.scheme,c||R),this.query=h||R,this.fragment=S||R,T(this,I))}static isUri(l){return l instanceof b?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return y(this,!1)}with(l){if(!l)return this;let{scheme:a,authority:c,path:h,query:S,fragment:I}=l;return a===void 0?a=this.scheme:a===null&&(a=R),c===void 0?c=this.authority:c===null&&(c=R),h===void 0?h=this.path:h===null&&(h=R),S===void 0?S=this.query:S===null&&(S=R),I===void 0?I=this.fragment:I===null&&(I=R),a===this.scheme&&c===this.authority&&h===this.path&&S===this.query&&I===this.fragment?this:new C(a,c,h,S,I)}static parse(l,a=!1){const c=m.exec(l);return c?new C(c[2]||R,n(c[4]||R),n(c[5]||R),n(c[7]||R),n(c[9]||R),a):new C(R,R,R,R,R)}static file(l){let a=R;if(v.isWindows&&(l=l.replace(/\\/g,d)),l[0]===d&&l[1]===d){const c=l.indexOf(d,2);c===-1?(a=l.substring(2),l=d):(a=l.substring(2,c),l=l.substring(c)||d)}return new C("file",a,l,R,R)}static from(l){return new C(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...a){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return v.isWindows&&l.scheme==="file"?c=b.file(U.win32.join(y(l,!0),...a)).path:c=U.posix.join(l.path,...a),l.with({path:c})}toString(l=!1){return s(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof b)return l;{const a=new C(l);return a._formatted=l.external,a._fsPath=l._sep===o?l.fsPath:null,a}}else return l}}e.URI=b;const o=v.isWindows?1:void 0;class C extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(l=!1){return l?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=o),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,l){let a,c=-1;for(let h=0;h<r.length;h++){const S=r.charCodeAt(h);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||l&&S===47)c!==-1&&(a+=encodeURIComponent(r.substring(c,h)),c=-1),a!==void 0&&(a+=r.charAt(h));else{a===void 0&&(a=r.substr(0,h));const I=E[S];I!==void 0?(c!==-1&&(a+=encodeURIComponent(r.substring(c,h)),c=-1),a+=I):c===-1&&(c=h)}}return c!==-1&&(a+=encodeURIComponent(r.substring(c))),a!==void 0?a:r}function w(r){let l;for(let a=0;a<r.length;a++){const c=r.charCodeAt(a);c===35||c===63?(l===void 0&&(l=r.substr(0,a)),l+=E[c]):l!==void 0&&(l+=r[a])}return l!==void 0?l:r}function y(r,l){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?l?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,v.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=y;function s(r,l){const a=l?w:p;let c="",{scheme:h,authority:S,path:I,query:u,fragment:L}=r;if(h&&(c+=h,c+=":"),(S||h==="file")&&(c+=d,c+=d),S){let _=S.indexOf("@");if(_!==-1){const $=S.substr(0,_);S=S.substr(_+1),_=$.indexOf(":"),_===-1?c+=a($,!1):(c+=a($.substr(0,_),!1),c+=":",c+=a($.substr(_+1),!1)),c+="@"}S=S.toLowerCase(),_=S.indexOf(":"),_===-1?c+=a(S,!1):(c+=a(S.substr(0,_),!1),c+=S.substr(_))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const _=I.charCodeAt(1);_>=65&&_<=90&&(I=`/${String.fromCharCode(_+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const _=I.charCodeAt(0);_>=65&&_<=90&&(I=`${String.fromCharCode(_+32)}:${I.substr(2)}`)}c+=a(I,!0)}return u&&(c+="?",c+=a(u,!1)),L&&(c+="#",c+=l?L:p(L,!1)),c}function i(r){try{return decodeURIComponent(r)}catch(l){return r.length>3?r.substr(0,3)+i(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,l=>i(l)):r}}),define(Z[88],ee([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(g){const R=g;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=U;function A(g){const R=[];let d;try{const m=JSON.parse(g.arguments),b=m[m.length-1];b&&b.__$stack&&(m.pop(),d=b.__$stack),R.push(...m)}catch(m){R.push("Unable to log remote console arguments",g.arguments)}return{args:R,stack:d}}e.parse=A;function P(g){if(typeof g!="string")return P(A(g).stack);const R=g;if(R){const d=k(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(m&&m.length===4)return{uri:v.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=P;function k(g){if(!g)return g;const R=g.indexOf(`
`);return R===-1?g:g.substring(0,R)}function T(g,R){const{args:d,stack:m}=A(g),b=typeof d[0]=="string"&&d.length===1;let o=k(m);o&&(o=`(${o.trim()})`);let C=[];if(typeof d[0]=="string"?o&&b?C=[`%c[${R}] %c${d[0]} %c${o}`,f("blue"),f(""),f("grey")]:C=[`%c[${R}] %c${d[0]}`,f("blue"),f(""),...d.slice(1)]:C=[`%c[${R}]%`,f("blue"),...d],o&&!b&&C.push(o),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,C)}e.log=T;function f(g){return`color: ${g}`}}),define(Z[37],ee([0,1,5,21]),function(K,e,v,U){"use strict";var A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(s,i,t){let n=s.get(i);return n===void 0&&(n=t,s.set(i,n)),n}e.getOrSet=k;function T(s){const i=[];return s.forEach((t,n)=>{i.push(`${n} => ${t}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=T;function f(s){const i=[];return s.forEach(t=>{i.push(t)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=f;class g{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const t=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=g;class R{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,U.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class d{constructor(i=!0,t=!0){this._splitOnBackslash=i,this._caseSensitive=t}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,U.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var m;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(m||(m={}));class b{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,U.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,U.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,U.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,U.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new b(i))}static forPaths(){return new C(new d)}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new R)}clear(){this._root=void 0}set(i,t){const n=this._iter.reset(i);let r;for(this._root||(this._root=new o,this._root.segment=n.value()),r=this._root;;){const a=n.cmp(r.segment);if(a>0)r.left||(r.left=new o,r.left.segment=n.value()),r=r.left;else if(a<0)r.right||(r.right=new o,r.right.segment=n.value()),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new o,r.mid.segment=n.value()),r=r.mid;else break}const l=r.value;return r.value=t,r.key=i,l}get(i){var t;return(t=this._getNode(i))===null||t===void 0?void 0:t.value}_getNode(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(i){const t=this._getNode(i);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,t){const n=this._iter.reset(i),r=[];let l=this._root;for(;l;){const a=n.cmp(l.segment);if(a>0)r.push([1,l]),l=l.left;else if(a<0)r.push([-1,l]),l=l.right;else if(n.hasNext())n.next(),r.push([0,l]),l=l.mid;else{for(t?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;r.length>0&&l.isEmpty();){let[c,h]=r.pop();switch(c){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}l=h}break}}}findSubstr(i){const t=this._iter.reset(i);let n=this._root,r;for(;n;){const l=t.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(t.hasNext())t.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[t,n]of this)i(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=C;class E{constructor(i,t){this[A]="ResourceMap",i instanceof E?(this.map=new Map(i.map),this.toKey=t!=null?t:E.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:E.defaultToKey)}set(i,t){return this.map.set(this.toKey(i),t),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,t){typeof t!="undefined"&&(i=i.bind(t));for(let[n,r]of this.map)i(r,v.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=E,E.defaultToKey=s=>s.toString();var p;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class w{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,t=0){const n=this._map.get(i);if(!!n)return t!==0&&this.touch(n,t),n.value}set(i,t,n=0){let r=this._map.get(i);if(r)r.value=t,n!==0&&this.touch(r,n);else{switch(r={key:i,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const t=this._map.get(i);if(!!t)return this._map.delete(i),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,t){const n=this._state;let r=this._head;for(;r;){if(t?i.bind(t)(r.value,r.key,this):i(r.value,r.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const l={value:n.key,done:!1};return n=n.next,l}else return{value:void 0,done:!0}}};return r}values(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const l={value:n.value,done:!1};return n=n.next,l}else return{value:void 0,done:!0}}};return r}entries(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const l={value:[n.key,n.value],done:!1};return n=n.next,l}else return{value:void 0,done:!0}}};return r}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>i;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const t=i.next,n=i.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}i.next=void 0,i.previous=void 0,this._state++}touch(i,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(i===this._head)return;const n=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(n.previous=r,r.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(t===2){if(i===this._tail)return;const n=i.next,r=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=r,r.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((t,n)=>{i.push([n,t])}),i}fromJSON(i){this.clear();for(const[t,n]of i)this.set(t,n)}}e.LinkedMap=w;class y extends w{constructor(i,t=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,t=2){return super.get(i,t)}peek(i){return super.get(i,0)}set(i,t){return super.set(i,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y}),define(Z[89],ee([0,1,22,21,5]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(g){return JSON.stringify(g,T)}e.stringify=P;function k(g){let R=JSON.parse(g);return R=f(R),R}e.parse=k;function T(g,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,U.regExpFlags)(R)}:R}function f(g,R=0){if(!g||R>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return A.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof v.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let d=0;d<g.length;++d)g[d]=f(g[d],R+1);else for(const d in g)Object.hasOwnProperty.call(g,d)&&(g[d]=f(g[d],R+1))}return g}e.revive=f}),define(Z[16],ee([0,1,5,7]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.vscodeWebviewResource="vscode-webview-resource",T.extension="extension",T.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,g,R){this._hosts[f]=g,this._ports[f]=R}setConnectionToken(f,g){this._connectionTokens[f]=g}rewrite(f){if(this._delegate)return this._delegate(f);const g=f.authority;let R=this._hosts[g];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const d=this._ports[g],m=this._connectionTokens[g];let b=`path=${encodeURIComponent(f.path)}`;return typeof m=="string"&&(b+=`&tkn=${encodeURIComponent(m)}`),v.URI.from({scheme:U.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${d}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new P;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(f,g,R){const d=this.toUri(f,g);return d.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(d):U.isNative&&(R||U.isPreferringBrowserCodeLoad)&&d.scheme===A.file?d.with({scheme:A.vscodeFileResource,authority:d.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(f,g){const R=this.toUri(f,g);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(f,g){return v.URI.isUri(f)?f:v.URI.parse(g.toUrl(f))}}e.FileAccess=new k}),define(Z[65],ee([0,1,37]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const U=new v.LRUCache(1e4);function A(g){return f(g,"NFC",U)}e.normalizeNFC=A;const P=new v.LRUCache(1e4);function k(g){return f(g,"NFD",P)}e.normalizeNFD=k;const T=/[^\u0000-\u0080]/;function f(g,R,d){if(!e.canNormalize||!g)return g;const m=d.get(g);if(m)return m;let b;return T.test(g)?b=g.normalize(R):b=g,d.set(g,b),b}e.removeAccents=function(){if(e.canNormalize){const g=/[\u0300-\u036f]/g;return function(R){return k(R).replace(g,"")}}else return function(g){return g}}()}),define(Z[11],ee([0,1,42,9,5,21,16,7]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=f;class g{constructor(o){this._ignorePathCasing=o}compare(o,C,E=!1){return o===C?0:(0,P.compare)(this.getComparisonKey(o,E),this.getComparisonKey(C,E))}isEqual(o,C,E=!1){return o===C?!0:!o||!C?!1:this.getComparisonKey(o,E)===this.getComparisonKey(C,E)}getComparisonKey(o,C=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,C,E=!1){if(o.scheme===C.scheme){if(o.scheme===k.Schemas.file)return v.isEqualOrParent(f(o),f(C),this._ignorePathCasing(o))&&o.query===C.query&&(E||o.fragment===C.fragment);if((0,e.isEqualAuthority)(o.authority,C.authority))return v.isEqualOrParent(o.path,C.path,this._ignorePathCasing(o),"/")&&o.query===C.query&&(E||o.fragment===C.fragment)}return!1}joinPath(o,...C){return A.URI.joinPath(o,...C)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return U.posix.basename(o.path)}extname(o){return U.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let C;return o.scheme===k.Schemas.file?C=A.URI.file(U.dirname(f(o))).path:(C=U.posix.dirname(o.path),o.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),C="/")),o.with({path:C})}normalizePath(o){if(!o.path.length)return o;let C;return o.scheme===k.Schemas.file?C=A.URI.file(U.normalize(f(o))).path:C=U.posix.normalize(o.path),o.with({path:C})}relativePath(o,C){if(!(o.scheme!==C.scheme||!(0,e.isEqualAuthority)(o.authority,C.authority))){if(o.scheme===k.Schemas.file){const w=U.relative(f(o),f(C));return T.isWindows?v.toSlashes(w):w}let E=o.path||"/",p=C.path||"/";if(this._ignorePathCasing(o)){let w=0;for(const y=Math.min(E.length,p.length);w<y&&!(E.charCodeAt(w)!==p.charCodeAt(w)&&E.charAt(w).toLowerCase()!==p.charAt(w).toLowerCase());w++);E=p.substr(0,w)+E.substr(w)}return U.posix.relative(E,p)}}resolvePath(o,C){if(o.scheme===k.Schemas.file){const E=A.URI.file(U.resolve(f(o),C));return o.with({authority:E.authority,path:E.path})}return C.indexOf("/")===-1&&(C=v.toSlashes(C),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C)),o.with({path:U.posix.resolve(o.path,C)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,C){return o===C||(0,P.equalsIgnoreCase)(o,C)}hasTrailingPathSeparator(o,C=U.sep){if(o.scheme===k.Schemas.file){const E=f(o);return E.length>v.getRoot(E).length&&E[E.length-1]===C}else{const E=o.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,C=U.sep){return(0,e.hasTrailingPathSeparator)(o,C)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,C=U.sep){let E=!1;if(o.scheme===k.Schemas.file){const p=f(o);E=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===C}else{C="/";const p=o.path;E=p.length===1&&p.charCodeAt(p.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(o,C)?o.with({path:o.path+"/"}):o}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(b=>b.scheme===k.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new g(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(b,o){const C=[];for(let E=0;E<b.length;E++){const p=o(b[E]);b.some((w,y)=>y===E?!1:(0,e.isEqualOrParent)(p,o(w)))||C.push(b[E])}return C}e.distinctParents=R;var d;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function o(C){const E=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(y=>{const[s,i]=y.split(":");s&&i&&E.set(s,i)});const w=C.path.substring(0,C.path.indexOf(";"));return w&&E.set(b.META_DATA_MIME,w),E}b.parseMetaData=o})(d=e.DataUri||(e.DataUri={}));function m(b,o,C){if(o){let E=b.path;return E&&E[0]!==U.posix.sep&&(E=U.posix.sep+E),b.with({scheme:C,authority:o,path:E})}return b.with({scheme:C})}e.toLocalResource=m}),define(Z[6],ee([0,1,30,13,3,2,64,11]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(q){return!!q&&typeof q.then=="function"}e.isThenable=f;function g(q){const D=new v.CancellationTokenSource,O=q(D.token),F=new Promise((N,V)=>{D.token.onCancellationRequested(()=>{V((0,U.canceled)())}),Promise.resolve(O).then(G=>{D.dispose(),N(G)},G=>{D.dispose(),V(G)})});return new class{cancel(){D.cancel()}then(N,V){return F.then(N,V)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=g;function R(q,D,O){return Promise.race([q,new Promise(F=>D.onCancellationRequested(()=>F(O)))])}e.raceCancellation=R;async function d(q){let D=-1;const O=q.map((N,V)=>N.then(G=>(D=V,G))),F=await Promise.race(O);return q.forEach((N,V)=>{V!==D&&N.cancel()}),F}e.raceCancellablePromises=d;function m(q,D,O){let F;const N=setTimeout(()=>{F==null||F(void 0),O==null||O()},D);return Promise.race([q.finally(()=>clearTimeout(N)),new Promise(V=>F=V)])}e.raceTimeout=m;function b(q){return new Promise((D,O)=>{const F=q();f(F)?F.then(D,O):D(F)})}e.asPromise=b;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(O,O).then(F)})}return new Promise((O,F)=>{this.queuedPromise.then(O,F)})}return this.activePromise=D(),new Promise((O,F)=>{this.activePromise.then(N=>{this.activePromise=null,O(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=o;class C{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=C;class E{constructor(){this.promiseMap=new Map}queue(D,O){var F;const V=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(D)===V&&this.promiseMap.delete(D)});return this.promiseMap.set(D,V),V}}e.SequencerByKey=E;class p{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,O=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,U.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class w{constructor(D){this.delayer=new p(D),this.throttler=new o}trigger(D,O){return this.delayer.trigger(()=>this.throttler.queue(D),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class y{constructor(){this._isOpen=!1,this._promise=new Promise((D,O)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class s extends y{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(q,D){return D?new Promise((O,F)=>{const N=setTimeout(O,q);D.onCancellationRequested(()=>{clearTimeout(N),F((0,U.canceled)())})}):g(O=>i(q,O))}e.timeout=i;function t(q,D=0){const O=setTimeout(q,D);return(0,P.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(q){return q.then(void 0,D=>{})}e.ignoreErrors=n;function r(q){const D=[];let O=0;const F=q.length;function N(){return O<F?q[O++]():null}function V(G){G!=null&&D.push(G);const Q=N();return Q?Q.then(V):Promise.resolve(D)}return Promise.resolve(null).then(V)}e.sequence=r;function l(q,D=F=>!!F,O=null){let F=0;const N=q.length,V=()=>{if(F>=N)return Promise.resolve(O);const G=q[F++];return Promise.resolve(G()).then(X=>D(X)?Promise.resolve(X):V())};return V()}e.first=l;function a(q,D=F=>!!F,O=null){if(q.length===0)return Promise.resolve(O);let F=q.length;const N=()=>{var V,G;F=-1;for(const Q of q)(G=(V=Q).cancel)===null||G===void 0||G.call(V)};return new Promise((V,G)=>{for(const Q of q)Q.then(X=>{--F>=0&&D(X)?(N(),V(X)):F===0&&V(O)}).catch(X=>{--F>=0&&(N(),G(X))})})}e.firstParallel=a;class c{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((O,F)=>{this.outstandingPromises.push({factory:D,c:O,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const O=D.factory();O.then(D.c,D.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class S{constructor(){this.queues=new Map}queueFor(D,O=T.extUri){const F=O.getComparisonKey(D);let N=this.queues.get(F);return N||(N=new h,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=S;class I{constructor(D,O){this._token=-1,typeof D=="function"&&typeof O=="number"&&this.setIfNotSet(D,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},O)}setIfNotSet(D,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},O))}}e.TimeoutTimer=I;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,O){this.cancel(),this._token=setInterval(()=>{D()},O)}}e.IntervalTimer=u;class L{constructor(D,O){this.timeoutToken=-1,this.runner=D,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class _ extends L{constructor(D,O){super(D,O);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const O=setTimeout(()=>D(q));let F=!1;return{dispose(){F||(F=!0,clearTimeout(O))}}}}else e.runWhenIdle=(q,D)=>{const O=requestIdleCallback(q,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(O))}}}}();class ${constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function B(q,D,O){let F;for(let N=0;N<O;N++)try{return await q()}catch(V){F=V,await i(D)}throw F}e.retry=B;class M{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,O,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:O},O.then(()=>this.donePending(D),()=>this.donePending(D)),O}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let O,F;const N=new Promise((V,G)=>{O=V,F=G});this._next={run:D,promise:N,promiseResolve:O,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class j{constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,O)=>{this.completeCallback=D,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(O=>{this.completeCallback(D),this.resolved=!0,O()})}error(D){return new Promise(O=>{this.errorCallback(D),this.rejected=!0,O()})}cancel(){new Promise(D=>{this.errorCallback((0,U.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=W;class z extends A.Emitter{async fireAsync(D,O,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,D]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[N,V]=this._asyncDeliveryQueue.shift(),G=[],Q=Object.assign(Object.assign({},V),{waitUntil:X=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(X=F(X,typeof N=="function"?N:N[0])),G.push(X)}});try{typeof N=="function"?N.call(void 0,Q):N[0].call(N[1],Q)}catch(X){(0,U.onUnexpectedError)(X);continue}Object.freeze(G),await H.settled(G).catch(X=>(0,U.onUnexpectedError)(X))}}}}e.AsyncEmitter=z;var H;(function(q){async function D(V){return typeof Promise.allSettled=="function"?O(V):F(V)}q.allSettled=D;async function O(V){return Promise.allSettled(V)}async function F(V){return Promise.all(V.map(G=>G.then(Q=>({status:"fulfilled",value:Q}),Q=>({status:"rejected",reason:Q}))))}async function N(V){let G;const Q=await Promise.all(V.map(X=>X.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return Q}q.settled=N})(H=e.Promises||(e.Promises={}))}),define(Z[90],ee([0,1,21,42,9,37,6]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const f="**",g="/",R="[/\\\\]",d="[^/\\\\]",m=/\//g;function b(O){switch(O){case 0:return"";case 1:return`${d}*?`;default:return`(?:${R}|${d}+${R}|${R}${d}+)*?`}}function o(O,F){if(!O)return[];const N=[];let V=!1,G=!1,Q="";for(const X of O){switch(X){case F:if(!V&&!G){N.push(Q),Q="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":G=!0;break;case"]":G=!1;break}Q+=X}return Q&&N.push(Q),N}e.splitGlobAware=o;function C(O){if(!O)return"";let F="";const N=o(O,g);if(N.every(V=>V===f))F=".*";else{let V=!1;N.forEach((G,Q)=>{if(G===f){V||(F+=b(2),V=!0);return}let X=!1,ne="",ie=!1,ae="";for(const he of G){if(he!=="}"&&X){ne+=he;continue}if(ie&&(he!=="]"||!ae)){let fe;he==="-"?fe=he:(he==="^"||he==="!")&&!ae?fe="^":he===g?fe="":fe=v.escapeRegExpCharacters(he),ae+=fe;continue}switch(he){case"{":X=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${o(ne,",").map(Ie=>C(Ie)).join("|")})`,X=!1,ne="";break;case"]":F+="["+ae+"]",ie=!1,ae="";break;case"?":F+=d;continue;case"*":F+=b(1);continue;default:F+=v.escapeRegExpCharacters(he)}}Q<N.length-1&&(N[Q+1]!==f||Q+2<N.length)&&(F+=R),V=!1})}return F}const E=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),n=function(){return!1},r=function(){return null};function l(O,F){if(!O)return r;let N;typeof O!="string"?N=O.pattern:N=O,N=N.trim();const V=`${N}_${!!F.trimForExclusions}`;let G=t.get(V);if(G)return a(G,O);let Q;if(E.test(N)){const X=N.substr(4);G=function(ne,ie){return typeof ne=="string"&&ne.endsWith(X)?N:null}}else(Q=p.exec(c(N,F)))?G=h(Q[1],N):(F.trimForExclusions?y:w).test(N)?G=S(N,F):(Q=s.exec(c(N,F)))?G=I(Q[1].substr(1),N,!0):(Q=i.exec(c(N,F)))?G=I(Q[1],N,!1):G=u(N);return t.set(V,G),a(G,O)}function a(O,F){return typeof F=="string"?O:function(N,V){return U.isEqualOrParent(N,F.base)?O(A.relative(F.base,N),V):null}}function c(O,F){return F.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function h(O,F){const N=`/${O}`,V=`\\${O}`,G=function(X,ne){return typeof X!="string"?null:ne?ne===O?F:null:X===O||X.endsWith(N)||X.endsWith(V)?F:null},Q=[O];return G.basenames=Q,G.patterns=[F],G.allBasenames=Q,G}function S(O,F){const N=D(O.slice(1,-1).split(",").map(ne=>l(ne,F)).filter(ne=>ne!==r),O),V=N.length;if(!V)return r;if(V===1)return N[0];const G=function(ne,ie){for(let ae=0,he=N.length;ae<he;ae++)if(N[ae](ne,ie))return O;return null},Q=N.find(ne=>!!ne.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const X=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return X.length&&(G.allPaths=X),G}function I(O,F,N){const V=A.sep===A.posix.sep,G=V?O:O.replace(m,A.sep),Q=A.sep+G,X=A.posix.sep+O,ne=N?function(ie,ae){return typeof ie=="string"&&(ie===G||ie.endsWith(Q)||!V&&(ie===O||ie.endsWith(X)))?F:null}:function(ie,ae){return typeof ie=="string"&&(ie===G||!V&&ie===O)?F:null};return ne.allPaths=[(N?"*/":"./")+O],ne}function u(O){try{const F=new RegExp(`^${C(O)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?O:null}}catch(F){return r}}function L(O,F,N){return!O||typeof F!="string"?!1:_(O)(F,void 0,N)}e.match=L;function _(O,F={}){if(!O)return n;if(typeof O=="string"||j(O)){const N=l(O,F);if(N===r)return n;const V=function(G,Q){return!!N(G,Q)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return H(O,F)}e.parse=_;function $(O){if(!!O){let F;return N=>(F||(F=(O()||Promise.resolve([])).then(V=>V?M(V):{})),F.then(V=>!!V[N]))}}e.hasSiblingPromiseFn=$;function B(O){if(!!O){let F;return N=>{if(!F){const V=O();F=V?M(V):{}}return!!F[N]}}}e.hasSiblingFn=B;function M(O){const F={};for(const N of O)F[N]=!0;return F}function j(O){const F=O;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=j;function W(O){return O.allBasenames||[]}e.getBasenameTerms=W;function z(O){return O.allPaths||[]}e.getPathTerms=z;function H(O,F){const N=D(Object.getOwnPropertyNames(O).map(ne=>q(ne,O[ne],F)).filter(ne=>ne!==r)),V=N.length;if(!V)return r;if(!N.some(ne=>!!ne.requiresSiblings)){if(V===1)return N[0];const ne=function(he,fe){for(let we=0,Ie=N.length;we<Ie;we++){const ke=N[we](he,fe);if(ke)return ke}return null},ie=N.find(he=>!!he.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ae=N.reduce((he,fe)=>fe.allPaths?he.concat(fe.allPaths):he,[]);return ae.length&&(ne.allPaths=ae),ne}const G=function(ne,ie,ae){let he;for(let fe=0,we=N.length;fe<we;fe++){const Ie=N[fe];Ie.requiresSiblings&&ae&&(ie||(ie=A.basename(ne)),he||(he=ie.substr(0,ie.length-A.extname(ne).length)));const ke=Ie(ne,ie,he,ae);if(ke)return ke}return null},Q=N.find(ne=>!!ne.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const X=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return X.length&&(G.allPaths=X),G}function q(O,F,N){if(F===!1)return r;const V=l(O,N);if(V===r)return r;if(typeof F=="boolean")return V;if(F){const G=F.when;if(typeof G=="string"){const Q=(X,ne,ie,ae)=>{if(!ae||!V(X,ne))return null;const he=G.replace("$(basename)",ie),fe=ae(he);return(0,k.isThenable)(fe)?fe.then(we=>we?O:null):fe?O:null};return Q.requiresSiblings=!0,Q}}return V}function D(O,F){const N=O.filter(ne=>!!ne.basenames);if(N.length<2)return O;const V=N.reduce((ne,ie)=>{const ae=ie.basenames;return ae?ne.concat(ae):ne},[]);let G;if(F){G=[];for(let ne=0,ie=V.length;ne<ie;ne++)G.push(F)}else G=N.reduce((ne,ie)=>{const ae=ie.patterns;return ae?ne.concat(ae):ne},[]);const Q=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let he;for(he=ne.length;he>0;he--){const fe=ne.charCodeAt(he-1);if(fe===47||fe===92)break}ie=ne.substr(he)}const ae=V.indexOf(ie);return ae!==-1?G[ae]:null};Q.basenames=V,Q.patterns=G,Q.allBasenames=V;const X=O.filter(ne=>!ne.basenames);return X.push(Q),X}}),define(Z[91],ee([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function U(R){return R.toJSON()}class A{constructor(d){this._uriTransformer=d}transformIncoming(d){const m=this._uriTransformer.transformIncoming(d);return m===d?d:U(v.URI.from(m))}transformOutgoing(d){const m=this._uriTransformer.transformOutgoing(d);return m===d?d:U(v.URI.from(m))}transformOutgoingURI(d){const m=this._uriTransformer.transformOutgoing(d);return m===d?d:v.URI.from(m)}transformOutgoingScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,d,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof v.URI)return d.transformOutgoing(R);for(let b in R)if(Object.hasOwnProperty.call(R,b)){const o=P(R[b],d,m+1);o!==null&&(R[b]=o)}}return null}function k(R,d){const m=P(R,d,0);return m===null?R:m}e.transformOutgoingURIs=k;function T(R,d,m,b){if(!R||b>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?v.URI.revive(d.transformIncoming(R)):d.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const C=T(R[o],d,m,b+1);C!==null&&(R[o]=C)}}return null}function f(R,d){const m=T(R,d,!1,0);return m===null?R:m}e.transformIncomingURIs=f;function g(R,d){const m=T(R,d,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=g}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(f){return v.test(f)}e.isUUID=U;const A=new Uint8Array(16),P=[];for(let f=0;f<256;f++)P.push(f.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(f){for(let g=0;g<f.length;g++)f[g]=Math.floor(Math.random()*256);return f};function T(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,g="";return g+=P[A[f++]],g+=P[A[f++]],g+=P[A[f++]],g+=P[A[f++]],g+="-",g+=P[A[f++]],g+=P[A[f++]],g+="-",g+=P[A[f++]],g+=P[A[f++]],g+="-",g+=P[A[f++]],g+=P[A[f++]],g+="-",g+=P[A[f++]],g+=P[A[f++]],g+=P[A[f++]],g+=P[A[f++]],g+=P[A[f++]],g+=P[A[f++]],g}e.generateUuid=T}),define(Z[66],ee([0,1,203]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class U{constructor(P="utf8"){this.stringDecoder=new v.StringDecoder(P),this.remaining=null}write(P){const k=[],T=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(T.length<1)return k;let f=0,g,R=f;for(;R<T.length;)if(g=T.charCodeAt(R),g===13||g===10){if(k.push(T.substring(f,R)),R++,R<T.length){const d=g;g=T.charCodeAt(R),(d===13&&g===10||d===10&&g===13)&&R++}f=R}else R++;return this.remaining=f<T.length?T.substr(f):null,k}end(){return this.remaining}}e.LineDecoder=U}),define(Z[92],ee([0,1,38]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(T){const f=T.replace(/\-/g,":").toLowerCase();return!U.has(f)}function P(){return new Promise(async(T,f)=>{const g=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{T(await k())}catch(R){f(R)}finally{clearTimeout(g)}})}e.getMac=P;function k(){return new Promise((T,f)=>{try{const g=(0,v.networkInterfaces)();for(const[,R]of Object.entries(g))for(const d of R)if(A(d.mac))return T(d.mac);f("Unable to retrieve mac address (unexpected format)")}catch(g){f(g)}})}}),define(Z[93],ee([0,1,13,31,38,37,92]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,d=0;const m=(0,A.networkInterfaces)();for(let b in m)if(Object.prototype.hasOwnProperty.call(m,b))for(const{mac:o,internal:C}of m[b])C||(d+=1,this._isVirtualMachineMacAdress(o.toUpperCase())&&(R+=1));this._value=d>0?R/d:0}return this._value}};let T;async function f(){return T||(T=(async()=>await g()||U.generateUuid())()),T}e.getMachineId=f;async function g(){try{const R=await new Promise((m,b)=>{K(["crypto"],m,b)}),d=await(0,k.getMac)();return R.createHash("sha256").update(d,"utf8").digest("hex")}catch(R){v.onUnexpectedError(R);return}}}),define(Z[23],ee([0,1,27,38,9,6,7,42,31,65,11,5]),function(K,e,v,U,A,P,k,T,f,g,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var m;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function b(W,z=m.UNLINK){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return z===m.UNLINK?C(W):o(W)}e.rimraf=b;async function o(W){try{const z=(0,A.join)((0,U.tmpdir)(),(0,f.generateUuid)());try{await v.promises.rename(W,z)}catch(H){return C(W)}C(z).catch(H=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function C(W){return v.promises.rmdir(W,{recursive:!0,maxRetries:3})}function E(W){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(W,{recursive:!0})}e.rimrafSync=E;async function p(W,z){return s(await(z?w(W):v.promises.readdir(W)))}e.readdir=p;async function w(W){try{return await v.promises.readdir(W,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const z=[],H=await p(W);for(const q of H){let D=!1,O=!1,F=!1;try{const N=await v.promises.lstat((0,A.join)(W,q));D=N.isFile(),O=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}z.push({name:q,isFile:()=>D,isDirectory:()=>O,isSymbolicLink:()=>F})}return z}function y(W){return s(v.readdirSync(W))}e.readdirSync=y;function s(W){return W.map(z=>typeof z=="string"?k.isMacintosh?(0,g.normalizeNFC)(z):z:(z.name=k.isMacintosh?(0,g.normalizeNFC)(z.name):z.name,z))}async function i(W){const z=await p(W),H=[];for(const q of z)await n.existsDirectory((0,A.join)(W,q))&&H.push(q);return H}e.readDirsInDir=i;function t(W,z=1e3){return new Promise(H=>{let q=!1;const D=setInterval(()=>{q||(q=!0,v.access(W,O=>{q=!1,O&&(clearInterval(D),H(void 0))}))},z)})}e.whenDeleted=t;var n;(function(W){async function z(D){let O;try{if(O=await v.promises.lstat(D),!O.isSymbolicLink())return{stat:O}}catch(F){}try{return{stat:await v.promises.stat(D),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(k.isWindows&&F.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(D)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw N}throw F}}W.stat=z;async function H(D){try{const{stat:O,symbolicLink:F}=await W.stat(D);return O.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(O){}return!1}W.existsFile=H;async function q(D){try{const{stat:O,symbolicLink:F}=await W.stat(D);return O.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(O){}return!1}W.existsDirectory=q})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new P.ResourceQueue;function l(W,z,H){return r.queueFor(d.URI.file(W),R.extUriBiasedIgnorePathCase).queue(()=>{const q=S(H);return new Promise((D,O)=>c(W,z,q,F=>F?O(F):D()))})}e.writeFile=l;let a=!0;function c(W,z,H,q){if(!a)return v.writeFile(W,z,{mode:H.mode,flag:H.flag},q);v.open(W,H.flag,H.mode,(D,O)=>{if(D)return q(D);v.writeFile(O,z,F=>{if(F)return v.close(O,()=>q(F));v.fdatasync(O,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),a=!1),v.close(O,V=>q(V))))})})}function h(W,z,H){const q=S(H);if(!a)return v.writeFileSync(W,z,{mode:q.mode,flag:q.flag});const D=v.openSync(W,q.flag,q.mode);try{v.writeFileSync(D,z);try{v.fdatasyncSync(D)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),a=!1}}finally{v.closeSync(D)}}e.writeFileSync=h;function S(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function I(W,z){if(W!==z){async function H(q){try{const D=await v.promises.lstat(q);if(D.isDirectory()||D.isSymbolicLink())return;const O=await v.promises.open(q,"a");try{await O.utimes(D.atime,new Date)}finally{await O.close()}}catch(D){}}try{await v.promises.rename(W,z),await H(z)}catch(q){if(W.toLowerCase()!==z.toLowerCase()&&q.code==="EXDEV"||W.endsWith("."))await u(W,z,{preserveSymlinks:!1}),await b(W,m.MOVE),await H(z);else throw q}}}e.move=I;async function u(W,z,H){return _(W,z,{root:{source:W,target:z},options:H,handledSourcePaths:new Set})}e.copy=u;const L=511;async function _(W,z,H){if(!H.handledSourcePaths.has(W)){H.handledSourcePaths.add(W);const{stat:q,symbolicLink:D}=await n.stat(W);if(D){if(H.options.preserveSymlinks)try{return await M(W,z,H)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(D.dangling)return}return q.isDirectory()?$(W,z,q.mode&L,H):B(W,z,q.mode&L)}}async function $(W,z,H,q){await v.promises.mkdir(z,{recursive:!0,mode:H});const D=await p(W);for(const O of D)await _((0,A.join)(W,O),(0,A.join)(z,O),q)}async function B(W,z,H){await v.promises.copyFile(W,z),await v.promises.chmod(z,H)}async function M(W,z,H){let q=await v.promises.readlink(W);(0,T.isEqualOrParent)(q,H.root.source,!k.isLinux)&&(q=(0,A.join)(H.root.target,q.substr(H.root.source.length+1))),await v.promises.symlink(q,z)}async function j(W){try{return await v.promises.access(W),!0}catch(z){return!1}}e.exists=j}),define(Z[94],ee([0,1,27,95,21,9,23]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(d){const m=(0,P.dirname)(d);if(d===m)return d;const b=((0,P.basename)(d)||d).toLowerCase();try{const C=(0,k.readdirSync)(m).filter(E=>E.toLowerCase()===b);if(C.length===1){const E=T(m);if(E)return(0,P.join)(E,C[0])}else if(C.length>1){const E=C.indexOf(b);if(E>=0){const p=T(m);if(p)return(0,P.join)(p,C[E])}}}catch(o){}return null}e.realcaseSync=T;async function f(d){try{return await(0,U.promisify)(v.realpath)(d)}catch(m){const b=R(d);return await v.promises.access(b,v.constants.R_OK),b}}e.realpath=f;function g(d){try{return v.realpathSync(d)}catch(m){const b=R(d);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=g;function R(d){return(0,A.rtrim)((0,P.normalize)(d),P.sep)}}),define(Z[96],ee([0,1,48,16]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(k){return new Promise((T,f)=>{let g;const R=new Map;function d(o,C,E,p,w){const y=R.get(C);if(o===k||y){const s={name:m(E),cmd:E,pid:o,ppid:C,load:p,mem:w};R.set(o,s),o===k&&(g=s),y&&(y.children||(y.children=[]),y.children.push(s),y.children.length>1&&(y.children=y.children.sort((i,t)=>i.pid-t.pid)))}}function m(o){const C=/--disable-blink-features=Auxclick/,E=/\\watcher\\win32\\CodeHelper\.exe/,p=/--crashes-directory/,w=/\\pipe\\winpty-control/,y=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(E.exec(o))return"watcherService ";if(p.exec(o))return"electron-crash-reporter";if(w.exec(o))return"winpty-process";if(y.exec(o))return"console-window-host (Windows internal process)";let i=s.exec(o);if(i&&i.length===2)return i[1]==="renderer"?C.exec(o)?"shared-process":"window":i[1];const t=/[a-zA-Z-]+\.js/g;let n="";do i=t.exec(o),i&&(n+=i+" ");while(i);return n&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron_node ${n}`:o}if(process.platform==="win32"){const o=C=>C.indexOf("\\\\?\\")===0||C.indexOf("\\??\\")===0?C.substr(4):C.indexOf('"\\\\?\\')===0||C.indexOf('"\\??\\')===0?'"'+C.substr(5):C;new Promise((C,E)=>{K(["windows-process-tree"],C,E)}).then(C=>{C.getProcessList(k,E=>{C.getProcessCpuUsage(E,p=>{const w=new Map;p.forEach(y=>{const s=o(y.commandLine||"");w.set(y.pid,{name:m(s),cmd:s,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),g=w.get(k),g?(w.forEach(y=>{const s=w.get(y.ppid);s&&(s.children||(s.children=[]),s.children.push(y))}),w.forEach(y=>{y.children&&(y.children=y.children.sort((s,i)=>s.pid-i.pid))}),T(g)):f(new Error(`Root process ${k} not found`))})},C.ProcessDataFlag.CommandLine|C.ProcessDataFlag.Memory)})}else{function b(){let o=[g];const C=[];for(;o.length;){const p=o.shift();p&&(C.push(p.pid),p.children&&(o=o.concat(p.children)))}let E=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);E+=" "+C.join(" "),(0,v.exec)(E,{},(p,w,y)=>{if(p||y)f(p||new Error(y.toString()));else{const s=w.toString().split(`
`);for(let i=0;i<C.length;i++){const t=R.get(C[i]);t.load=parseFloat(s[i])}if(!g){f(new Error(`Root process ${k} not found`));return}T(g)}})}(0,v.exec)("which ps",{},(o,C,E)=>{if(o||E)if(process.platform!=="linux")f(o||new Error(E.toString()));else{const p=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,v.exec)(p,{},(w,y,s)=>{w||s?f(w||new Error(s.toString())):(P(y,d),b())})}else{const p=C.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,s,i)=>{y||i&&!i.includes("screen size is bogus")?f(y||new Error(i.toString())):(P(s,d),process.platform==="linux"?b():g?T(g):f(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=A;function P(k,T){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=k.toString().split(`
`);for(const R of g){const d=f.exec(R.trim());d&&d.length===6&&T(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(Z[97],ee([0,1,9,27,7,65,2,23]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function f(d,m,b){return R({path:d,isDirectory:!1},m,b)}e.watchFile=f;function g(d,m,b){return R({path:d,isDirectory:!0},m,b)}e.watchFolder=g,e.CHANGE_BUFFER_DELAY=100;function R(d,m,b){const o=(0,v.basename)(d.path),C=new Map;let E=!1,p=[(0,k.toDisposable)(()=>{C.forEach(w=>(0,k.dispose)(w)),C.clear()})];try{const w=(0,U.watch)(d.path);p.push((0,k.toDisposable)(()=>{w.removeAllListeners(),w.close()}));const y=new Set;d.isDirectory&&(0,T.readdir)(d.path).then(s=>s.forEach(i=>y.add(i))),w.on("error",(s,i)=>{E||b(`Failed to watch ${d.path} for changes using fs.watch() (${s}, ${i})`)}),w.on("change",(s,i)=>{if(!E){let t="";if(i&&(t=i.toString(),A.isMacintosh&&(t=(0,P.normalizeNFC)(t))),!(!t||s!=="change"&&s!=="rename")){const n=d.isDirectory?(0,v.join)(d.path,t):d.path;if(d.isDirectory)if(s==="rename"){const r=C.get(n);r&&(0,k.dispose)(r);const l=setTimeout(async()=>{C.delete(n);const a=await(0,T.exists)(n);if(!E){let c;a?y.has(t)?c="changed":(c="added",y.add(t)):(y.delete(t),c="deleted"),m(c,n)}},e.CHANGE_BUFFER_DELAY);C.set(n,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let r;y.has(t)?r="changed":(r="added",y.add(t)),m(r,n)}else if(s==="rename"||t!==o){const r=setTimeout(async()=>{const l=await(0,T.exists)(n);E||(l?(m("changed",n),p=[R(d,m,b)]):m("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(p),p=[(0,k.toDisposable)(()=>clearTimeout(r))]}else m("changed",n)}}})}catch(w){(0,T.exists)(d.path).then(y=>{y&&!E&&b(`Failed to watch ${d.path} for changes using fs.watch() (${w.toString()})`)})}return(0,k.toDisposable)(()=>{E=!0,p=(0,k.dispose)(p)})}}),define(Z[34],ee([0,1,3,2,6,30,13,22,18,17,89,21]),function(K,e,v,U,A,P,k,T,f,g,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function b(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(o=e.ResponseType||(e.ResponseType={}));function C(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(E||(E={}));class p{constructor(D){this.buffer=D,this.pos=0}read(D){const O=this.buffer.slice(this.pos,this.pos+D);return this.pos+=O.byteLength,O}}class w{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var y;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(y||(y={}));function s(q){const D=T.VSBuffer.alloc(4);return D.writeUInt32BE(q,0),D}function i(q){return q.read(4).readUInt32BE(0)}function t(q){const D=T.VSBuffer.alloc(1);return D.writeUInt8(q,0),D}const n={Undefined:t(y.Undefined),String:t(y.String),Buffer:t(y.Buffer),VSBuffer:t(y.VSBuffer),Array:t(y.Array),Object:t(y.Object)},r=typeof Buffer!="undefined";function l(q,D){if(typeof D=="undefined")q.write(n.Undefined);else if(typeof D=="string"){const O=T.VSBuffer.fromString(D);q.write(n.String),q.write(s(O.byteLength)),q.write(O)}else if(r&&Buffer.isBuffer(D)){const O=T.VSBuffer.wrap(D);q.write(n.Buffer),q.write(s(O.byteLength)),q.write(O)}else if(D instanceof T.VSBuffer)q.write(n.VSBuffer),q.write(s(D.byteLength)),q.write(D);else if(Array.isArray(D)){q.write(n.Array),q.write(s(D.length));for(const O of D)l(q,O)}else{const O=T.VSBuffer.fromString(JSON.stringify(D));q.write(n.Object),q.write(s(O.byteLength)),q.write(O)}}function a(q){switch(q.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return q.read(i(q)).toString();case y.Buffer:return q.read(i(q)).buffer;case y.VSBuffer:return q.read(i(q));case y.Array:{const O=i(q),F=[];for(let N=0;N<O;N++)F.push(a(q));return F}case y.Object:return JSON.parse(q.read(i(q)).toString())}}class c{constructor(D,O,F=null,N=1e3){this.protocol=D,this.ctx=O,this.logger=F,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(D,O){this.channels.set(D,O),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const O=this.send([D.type]);this.logger&&this.logger.logOutgoing(O,0,1,C(D.type));return}case 201:case 202:case 204:case 203:{const O=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(O,D.id,1,C(D.type),D.data);return}}}send(D,O=void 0){const F=new w;return l(F,D),l(F,O),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(O){return 0}}onRawMessage(D){const O=new p(D),F=a(O),N=a(O),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(V)}: ${F[2]}.${F[3]}`,N),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(V)}: ${F[2]}.${F[3]}`,N),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${b(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise(D){const O=this.channels.get(D.channelName);if(!O){this.collectPendingRequest(D);return}const F=new P.CancellationTokenSource;let N;try{N=O.call(this.ctx,D.name,D.arg,F.token)}catch(Q){N=Promise.reject(Q)}const V=D.id;N.then(Q=>{this.sendResponse({id:V,data:Q,type:201}),this.activeRequests.delete(D.id)},Q=>{Q instanceof Error?this.sendResponse({id:V,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:V,data:Q,type:203}),this.activeRequests.delete(D.id)});const G=(0,U.toDisposable)(()=>F.cancel());this.activeRequests.set(D.id,G)}onEventListen(D){const O=this.channels.get(D.channelName);if(!O){this.collectPendingRequest(D);return}const F=D.id,V=O.listen(this.ctx,D.name,D.arg)(G=>this.sendResponse({id:F,data:G,type:204}));this.activeRequests.set(D.id,V)}disposeActiveRequest(D){const O=this.activeRequests.get(D.id);O&&(O.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let O=this.pendingRequests.get(D.channelName);O||(O=[],this.pendingRequests.set(D.channelName,O));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const O=this.pendingRequests.get(D);if(O){for(const F of O)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(D,O=null){this.protocol=D,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=O}getChannel(D){const O=this;return{call(F,N,V){return O.isDisposed?Promise.reject(k.canceled()):O.requestPromise(D,F,N,V)},listen(F,N){return O.isDisposed?Promise.reject(k.canceled()):O.requestEvent(D,F,N)}}}requestPromise(D,O,F,N=P.CancellationToken.None){const V=this.lastRequestId++,Q={id:V,type:100,channelName:D,name:O,arg:F};if(N.isCancellationRequested)return Promise.reject(k.canceled());let X;return new Promise((ie,ae)=>{if(N.isCancellationRequested)return ae(k.canceled());const he=()=>{const ke=Ue=>{switch(Ue.type){case 201:this.handlers.delete(V),ie(Ue.data);break;case 202:this.handlers.delete(V);const Fe=new Error(Ue.data.message);Fe.stack=Ue.data.stack,Fe.name=Ue.data.name,ae(Fe);break;case 203:this.handlers.delete(V),ae(Ue.data);break}};this.handlers.set(V,ke),this.sendRequest(Q)};let fe=null;this.state===E.Idle?he():(fe=(0,A.createCancelablePromise)(ke=>this.whenInitialized()),fe.then(()=>{fe=null,he()}));const we=()=>{fe?(fe.cancel(),fe=null):this.sendRequest({id:V,type:101}),ae(k.canceled())},Ie=N.onCancellationRequested(we);X=(0,U.combinedDisposable)((0,U.toDisposable)(we),Ie),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(D,O,F){const N=this.lastRequestId++,G={id:N,type:102,channelName:D,name:O,arg:F};let Q=null;const X=new v.Emitter({onFirstListenerAdd:()=>{Q=(0,A.createCancelablePromise)(ie=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(X),this.sendRequest(G)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(X),this.sendRequest({id:N,type:103}))}}),ne=ie=>X.fire(ie.data);return this.handlers.set(N,ne),X.event}sendRequest(D){switch(D.type){case 100:case 102:{const O=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(O,D.id,0,`${b(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const O=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(O,D.id,0,b(D.type));return}}}send(D,O=void 0){const F=new w;return l(F,D),l(F,O),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(O){return 0}}onBuffer(D){const O=new p(D),F=a(O),N=a(O),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,C(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,C(V),N),this.onResponse({type:F[0],id:F[1],data:N})}}onResponse(D){if(D.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(D.id);O&&O(D)}whenInitialized(){return this.state===E.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelClient=S;class I{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:O,onDidClientDisconnect:F})=>{v.Event.once(O.onMessage)(V=>{const G=new p(V),Q=a(G),X=new c(O,Q),ne=new S(O);this.channels.forEach((ae,he)=>X.registerChannel(he,ae));const ie={channelServer:X,channelClient:ne,ctx:Q};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{X.dispose(),ne.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const D=[];return this._connections.forEach(O=>D.push(O)),D}getChannel(D,O){const F=this;return{call(N,V,G){let Q;if((0,g.isFunction)(O)){let ne=(0,f.getRandomElement)(F.connections.filter(O));Q=ne?Promise.resolve(ne):v.Event.toPromise(v.Event.filter(F.onDidAddConnection,O))}else Q=O.routeCall(F,N,V);const X=Q.then(ne=>ne.channelClient.getChannel(D));return L(X).call(N,V,G)},listen(N,V){if((0,g.isFunction)(O))return F.getMulticastEvent(D,O,N,V);const G=O.routeEvent(F,N,V).then(Q=>Q.channelClient.getChannel(D));return L(G).listen(N,V)}}}getMulticastEvent(D,O,F,N){const V=this;let G=new U.DisposableStore;const Q=new v.Emitter({onFirstListenerAdd:()=>{G=new U.DisposableStore;const X=new v.EventMultiplexer,ne=new Map,ie=he=>{const we=he.channelClient.getChannel(D).listen(F,N),Ie=X.add(we);ne.set(he,Ie)},ae=he=>{const fe=ne.get(he);!fe||(fe.dispose(),ne.delete(he))};V.connections.filter(O).forEach(ie),v.Event.filter(V.onDidAddConnection,O)(ie,void 0,G),V.onDidRemoveConnection(ae,void 0,G),X.event(Q.fire,Q,G),G.add(X)},onLastListenerRemove:()=>{G.dispose()}});return Q.event}registerChannel(D,O){this.channels.set(D,O),this._connections.forEach(F=>{F.channelServer.registerChannel(D,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class u{constructor(D,O,F=null){const N=new w;l(N,O),D.send(N.buffer),this.channelClient=new S(D,F),this.channelServer=new c(D,O,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,O){this.channelServer.registerChannel(D,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function L(q){return{call(D,O,F){return q.then(N=>N.call(D,O,F))},listen(D,O){const F=new v.Relay;return q.then(N=>F.input=N.listen(D,O)),F.event}}}e.getDelayedChannel=L;function _(q){let D=!1;return{call(O,F,N){return D?q.call(O,F,N):(0,A.timeout)(0).then(()=>D=!0).then(()=>q.call(O,F,N))},listen(O,F){if(D)return q.listen(O,F);const N=new v.Relay;return(0,A.timeout)(0).then(()=>D=!0).then(()=>N.input=q.listen(O,F)),N.event}}}e.getNextTickChannel=_;class ${constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const O of D.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await v.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=$;var B;(function(q){function D(N,V){const G=N,Q=V&&V.disableMarshalling,X=new Map;for(const ne in G)F(ne)&&X.set(ne,v.Event.buffer(G[ne],!0));return new class{listen(ne,ie){const ae=X.get(ie);if(ae)return ae;throw new Error(`Event not found: ${ie}`)}call(ne,ie,ae){const he=G[ie];if(typeof he=="function"){if(!Q&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,R.revive)(ae[fe]);return he.apply(G,ae)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=D;function O(N,V){const G=V&&V.disableMarshalling;return new Proxy({},{get(Q,X){var ne;if(typeof X=="string")return((ne=V==null?void 0:V.properties)===null||ne===void 0?void 0:ne.has(X))?V.properties.get(X):F(X)?N.listen(X):async function(...ie){let ae;V&&!(0,g.isUndefinedOrNull)(V.context)?ae=[V.context,...ie]:ae=ie;const he=await N.call(X,ae);return G?he:(0,R.revive)(he)};throw new Error(`Property not found: ${String(X)}`)}})}q.toService=O;function F(N){return N[0]==="o"&&N[1]==="n"&&d.isUpperAsciiLetter(N.charCodeAt(2))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let D=q.toString();if(D!=="[object Object]")return D}return q}function W(q){return Array.isArray(q)?q.map(j):j(q)}function z(q,D,O,F,N,V,G){G=W(G);const Q=M[N],X=Q[F%Q.length];let ne=[`%c[${q}]%c[${String(D).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(V)?(ne=ne.concat(G),ne.push(")")):ne.push(G),console.log.apply(console,ne)}e.logWithColors=z;class H{constructor(D,O){this._outgoingPrefix=D,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,O,F,N,V){this._totalOutgoing+=D,z(this._outgoingPrefix,this._totalOutgoing,D,O,F,N,V)}logIncoming(D,O,F,N,V){this._totalIncoming+=D,z(this._incomingPrefix,this._totalIncoming,D,O,F,N,V)}}e.IPCLogger=H}),define(Z[98],ee([0,1,3,34,22]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class P{constructor(f){this.port=f,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",g=>A.VSBuffer.wrap(g.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=P;class k extends U.IPCClient{constructor(f,g){const R=new P(f);super(R,g);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Z[99],ee([0,1,100,3,34,98]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends A.IPCServer{static getOnDidClientConnect(){const f=U.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(g,R)=>R);return U.Event.map(f,g=>{const{port1:R,port2:d}=new MessageChannel,b={protocol:new P.Protocol(R),onDidClientDisconnect:U.Event.fromDOMEventEmitter(R,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",g,[d]),b})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(Z[101],ee([0,1,13,22]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(T,f){T.proxyAuthorization&&(T.headers=Object.assign(Object.assign({},T.headers||{}),{"Proxy-Authorization":T.proxyAuthorization}));const g=new XMLHttpRequest;return new Promise((R,d)=>{g.open(T.type||"GET",T.url||"",!0,T.user,T.password),P(g,T),g.responseType="arraybuffer",g.onerror=m=>d(new Error(g.statusText&&"XHR failed: "+g.statusText||"XHR failed")),g.onload=m=>{R({res:{statusCode:g.status,headers:k(g)},stream:(0,U.bufferToStream)(U.VSBuffer.wrap(new Uint8Array(g.response)))})},g.ontimeout=m=>d(new Error(`XHR timeout: ${T.timeout}ms`)),T.timeout&&(g.timeout=T.timeout),g.send(T.data),f.onCancellationRequested(()=>{g.abort(),d((0,v.canceled)())})})}e.request=A;function P(T,f){if(f.headers){e:for(let g in f.headers){switch(g){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}T.setRequestHeader(g,f.headers[g])}}}function k(T){const f=Object.create(null);for(const g of T.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(g){const R=g.indexOf(":");f[g.substr(0,R).trim().toLowerCase()]=g.substr(R+1).trim()}return f}}),define(Z[67],ee([0,1,2,3,6,17]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));var T;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(T||(T={}));class f extends v.Disposable{constructor(d,m=Object.create(null)){super();this.database=d,this.options=m,this._onDidChangeStorage=this._register(new U.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=T.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var m,b;(m=d.changed)===null||m===void 0||m.forEach((o,C)=>this.accept(C,o)),(b=d.deleted)===null||b===void 0||b.forEach(o=>this.accept(o,void 0))}accept(d,m){if(this.state!==T.Closed){let b=!1;(0,P.isUndefinedOrNull)(m)?b=this.cache.delete(d):this.cache.get(d)!==m&&(this.cache.set(d,m),b=!0),b&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===T.None&&(this.state=T.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,m){const b=this.cache.get(d);return(0,P.isUndefinedOrNull)(b)?m:b}getBoolean(d,m){const b=this.get(d);return(0,P.isUndefinedOrNull)(b)?m:b==="true"}getNumber(d,m){const b=this.get(d);return(0,P.isUndefinedOrNull)(b)?m:parseInt(b,10)}async set(d,m){if(this.state!==T.Closed){if((0,P.isUndefinedOrNull)(m))return this.delete(d);const b=String(m);if(this.cache.get(d)!==b)return this.cache.set(d,b),this.pendingInserts.set(d,b),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==T.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=T.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var m;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(m=this.whenFlushedCallbacks.pop())===null||m===void 0||m()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((m,b)=>this.items.set(b,m)),d.delete&&d.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=g}),define(Z[102],ee([14,15]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[53],ee([0,1,102]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,A=U*60,P=A*24,k=P*7,T=P*30,f=P*365;function g(d,m){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,v.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(b<30)return(0,v.localize)(1,null);let o;return b<U?(o=b,m?o===1?(0,v.localize)(2,null,o):(0,v.localize)(3,null,o):o===1?(0,v.localize)(4,null,o):(0,v.localize)(5,null,o)):b<A?(o=Math.floor(b/U),m?o===1?(0,v.localize)(6,null,o):(0,v.localize)(7,null,o):o===1?(0,v.localize)(8,null,o):(0,v.localize)(9,null,o)):b<P?(o=Math.floor(b/A),m?o===1?(0,v.localize)(10,null,o):(0,v.localize)(11,null,o):o===1?(0,v.localize)(12,null,o):(0,v.localize)(13,null,o)):b<k?(o=Math.floor(b/P),m?o===1?(0,v.localize)(14,null,o):(0,v.localize)(15,null,o):o===1?(0,v.localize)(16,null,o):(0,v.localize)(17,null,o)):b<T?(o=Math.floor(b/k),m?o===1?(0,v.localize)(18,null,o):(0,v.localize)(19,null,o):o===1?(0,v.localize)(20,null,o):(0,v.localize)(21,null,o)):b<f?(o=Math.floor(b/T),m?o===1?(0,v.localize)(22,null,o):(0,v.localize)(23,null,o):o===1?(0,v.localize)(24,null,o):(0,v.localize)(25,null,o)):(o=Math.floor(b/f),m?o===1?(0,v.localize)(26,null,o):(0,v.localize)(27,null,o):o===1?(0,v.localize)(28,null,o):(0,v.localize)(29,null,o))}e.fromNow=g;function R(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Z[103],ee([14,15]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,103,17,18]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(g,R){return R&&(g.stack||g.stacktrace)?v.localize(0,null,T(g),k(g.stack)||k(g.stacktrace)):T(g)}function k(g){return Array.isArray(g)?g.join(`
`):g}function T(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?v.localize(1,null,g.message):g.message||v.localize(2,null)}function f(g=null,R=!1){if(!g)return v.localize(3,null);if(Array.isArray(g)){const d=A.coalesce(g),m=f(d[0],R);return d.length>1?v.localize(4,null,m,d.length):m}if(U.isString(g))return g;if(g.detail){const d=g.detail;if(d.error)return P(d.error,R);if(d.exception)return P(d.exception,R)}return g.stack?P(g,R):g.message?g.message:v.localize(5,null)}e.toErrorMessage=f}),define(Z[104],ee([14,15]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[105],ee([0,1,9,27,23,48,104,36,17,26,42,7,66,16]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function o(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function C(i,t){if(d.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const r=P.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],n);return new Promise(l=>{r.once("error",a=>{l({success:!1,error:a})}),r.once("exit",(a,c)=>{l(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?o(n.status):1})}else if(d.isLinux||d.isMacintosh)try{const n=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{P.execFile(n,[i.pid.toString()],{encoding:"utf8",shell:!0},(l,a,c)=>{r(l?{success:!1,error:l}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function E(i=T.env){return i.comspec||"cmd.exe"}e.getWindowsShell=E;class p{constructor(t,n,r,l){if(n!==void 0&&r!==void 0&&l!==void 0)this.cmd=t,this.args=n,this.shell=r,this.options=l;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(T.env).forEach(c=>{a[c]=T.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(v.sep);return n!==-1&&(t=t.substring(n+1)),p.WellKnowCommands[t]?t:"other"}start(t){return d.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(T.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(n=>{let r,l;const a=new Promise((c,h)=>{r=c,l=h});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=P.exec(c,this.options,(h,S,I)=>{this.childProcess=null;const u=h;u&&u.killed?l({killed:this.terminateRequested,stdout:S.toString(),stderr:I.toString()}):this.handleExec(r,t,h,S,I)})}else{let c=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,r,t,l);const I={terminated:this.terminateRequested};f.isNumber(S)&&(I.cmdCode=S),r(I)};if(this.shell&&d.isWindows){const S=g.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let I=!1,u=!1;const L=[];let _=this.ensureQuotes(this.cmd);L.push(_.value),I=_.quoted,this.args&&this.args.forEach(B=>{_=this.ensureQuotes(B),L.push(_.value),u=u&&_.quoted});const $=["/s","/c"];I?u?$.push('"'+L.join(" ")+'"'):L.length>1?$.push('"'+L[0]+'" '+L.slice(1).join(" ")):$.push('"'+L[0]+'"'):$.push(L.join(" ")),c=P.spawn(E(),$,S)}else this.cmd&&(c=P.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(f.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",S=>{this.childProcess=null,l({terminated:this.terminateRequested,error:S})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,r,t,l,!0)))}return a})}handleClose(t,n,r,l){}ensureQuotes(t){return p.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,C(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!d.isWindows)return t(!1);const n=P.spawn(E(),["/s","/c"]);n.on("error",r=>t(!0)),n.on("exit",r=>t(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class w extends p{constructor(t,n,r,l){super(t,n,r,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,r,l,a){[l,a].forEach((c,h)=>{const S=new m.LineDecoder;S.write(c).forEach(L=>{n({line:L,source:h===0?0:1})});const u=S.end();u&&n({line:u,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,n,r,l,a){const c=new m.LineDecoder,h=new m.LineDecoder;t.stdout.on("data",S=>{c.write(S).forEach(u=>r({line:u,source:0}))}),t.stderr.on("data",S=>{h.write(S).forEach(u=>r({line:u,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(t,n,r,l){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=w;function y(i){let t=[],n=!1;const r=function(l){if(n){t.push(l);return}(!i.send(l,c=>{if(c&&console.error(c),n=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(S=>r(S))}})||d.isWindows)&&(n=!0)};return{send:r}}e.createQueuedSender=y;var s;(function(i){async function t(n,r,l){if(v.isAbsolute(n))return n;if(r===void 0&&(r=T.cwd()),v.dirname(n)!=="."||(l===void 0&&f.isString(T.env.PATH)&&(l=T.env.PATH.split(v.delimiter)),l===void 0||l.length===0))return v.join(r,n);async function c(h){return await A.exists(h)?!(await U.promises.stat(h)).isDirectory():!1}for(let h of l){let S;if(v.isAbsolute(h)?S=v.join(h,n):S=v.join(r,h,n),await c(S))return S;let I=S+".com";if(await c(I)||(I=S+".exe",await c(I)))return I}return v.join(r,n)}i.findExecutable=t})(s=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,105,34,88,30,13,22,7]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class o extends f.ChannelServer{constructor(p){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch(y){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",w=>m.VSBuffer.wrap(Buffer.from(w,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=o;class C{constructor(p,w){this.modulePath=p,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new A.Delayer(y),this.child=null,this._client=null}getChannel(p){const w=this;return{call(y,s,i){return w.requestPromise(p,y,s,i)},listen(y,s){return w.requestEvent(p,y,s)}}}requestPromise(p,w,y,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(p),t=(0,A.createCancelablePromise)(l=>i.call(w,y,l)),n=s.onCancellationRequested(()=>t.cancel()),r=(0,U.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,w,y){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let s;const i=new k.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(p).listen(w,y)(i.fire,i),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env=Object.assign(Object.assign({},(0,P.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(w.env=Object.assign(Object.assign({},w.env),this.options.env)),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),b.isMacintosh&&w.env&&delete w.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,p,w);const y=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,g.isRemoteConsoleLog)(a)){(0,g.log)(a,`IPC Library: ${this.options.serverName}`);return}y.fire(m.VSBuffer.wrap(Buffer.from(a,"base64")))});const i=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&i.send(a.buffer.toString("base64")),n=y.event,r={send:t,onMessage:n};this._client=new f.ChannelClient(r);const l=()=>this.disposeClient();process.once("exit",l),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,c)=>{process.removeListener("exit",l),this.activeRequests.forEach(h=>(0,U.dispose)(h)),this.activeRequests.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:c})})}return this._client}getCachedChannel(p){let w=this.channels.get(p);return w||(w=this.client.getChannel(p),this.channels.set(p,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[106],ee([14,15]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[107],ee([14,15]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[108],ee([14,15]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[109],ee([14,15]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[110],ee([14,15]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[111],ee([14,15]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[112],ee([14,15]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[113],ee([14,15]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[114],ee([14,15]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[115],ee([14,15]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[116],ee([14,15]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[117],ee([14,15]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[118],ee([14,15]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[119],ee([14,15]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[120],ee([14,15]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[121],ee([14,15]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[122],ee([14,15]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[123],ee([14,15]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[124],ee([14,15]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[125],ee([14,15]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var ue=this&&this.__decorate||function(K,e,v,U){var A=arguments.length,P=A<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,v):U,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(K,e,v,U);else for(var T=K.length-1;T>=0;T--)(k=K[T])&&(P=(A<3?k(P):A>3?k(e,v,P):k(e,v))||P);return A>3&&P&&Object.defineProperty(e,v,P),P};define(Z[126],ee([0,1,9,11,86,53,16,5,36]),function(K,e,v,U,A,P,k,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(o,C,E){this._args=o,this.paths=C,this.productService=E}get appRoot(){return(0,v.dirname)(k.FileAccess.asFileUri("",K).fsPath)}get userHome(){return T.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return T.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return T.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,U.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,U.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const o=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",o)}return this.args.logsPath}get userDataSyncLogResource(){return T.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,U.joinPath)(T.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return T.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return T.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,U.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,U.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=f.env.VSCODE_PORTABLE;return o?T.URI.file((0,v.join)(o,"argv.json")):(0,U.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,U.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return T.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,v.resolve)(o):(0,v.normalize)((0,v.join)(k.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const o=this.args["extensions-download-dir"];return o?(0,v.resolve)(o):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,v.resolve)(o);const C=f.env.VSCODE_EXTENSIONS;if(C)return C;const E=f.env.VSCODE_PORTABLE;return E?(0,v.join)(E,"extensions"):(0,U.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(C=>/^[^:/?#]+?:\/\//.test(C)?T.URI.parse(C):T.URI.file((0,v.normalize)(C)))}get extensionDevelopmentKind(){var o;return(o=this.args.extensionDevelopmentKind)===null||o===void 0?void 0:o.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?T.URI.parse(o):T.URI.file((0,v.normalize)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,U.joinPath)(T.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return T.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([A.memoize],g.prototype,"appRoot",null),ue([A.memoize],g.prototype,"userHome",null),ue([A.memoize],g.prototype,"userDataPath",null),ue([A.memoize],g.prototype,"appSettingsHome",null),ue([A.memoize],g.prototype,"tmpDir",null),ue([A.memoize],g.prototype,"userRoamingDataHome",null),ue([A.memoize],g.prototype,"settingsResource",null),ue([A.memoize],g.prototype,"userDataSyncHome",null),ue([A.memoize],g.prototype,"userDataSyncLogResource",null),ue([A.memoize],g.prototype,"sync",null),ue([A.memoize],g.prototype,"machineSettingsResource",null),ue([A.memoize],g.prototype,"globalStorageHome",null),ue([A.memoize],g.prototype,"workspaceStorageHome",null),ue([A.memoize],g.prototype,"keybindingsResource",null),ue([A.memoize],g.prototype,"keyboardLayoutResource",null),ue([A.memoize],g.prototype,"argvResource",null),ue([A.memoize],g.prototype,"snippetsHome",null),ue([A.memoize],g.prototype,"isExtensionDevelopment",null),ue([A.memoize],g.prototype,"untitledWorkspacesHome",null),ue([A.memoize],g.prototype,"installSourcePath",null),ue([A.memoize],g.prototype,"builtinExtensionsPath",null),ue([A.memoize],g.prototype,"extensionsPath",null),ue([A.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ue([A.memoize],g.prototype,"extensionDevelopmentKind",null),ue([A.memoize],g.prototype,"extensionTestsLocationURI",null),ue([A.memoize],g.prototype,"debugExtensionHost",null),ue([A.memoize],g.prototype,"serviceMachineIdResource",null),ue([A.memoize],g.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=g;function R(b,o){return m(b["inspect-extensions"],b["inspect-brk-extensions"],5870,o,b.debugId)}e.parseExtensionHostPort=R;function d(b,o){return m(b["inspect-search"],b["inspect-brk-search"],5876,o)}e.parseSearchPort=d;function m(b,o,C,E,p){const y=Number(o||b)||(E?null:C),s=y?Boolean(!!o):!1;return{port:y,break:s,debugId:p}}}),function(){"use strict";function K(e,v,U){function A(k){return e.resolve(P(k))}function P(k){const T=process.env.VSCODE_PORTABLE;if(T)return e.join(T,"user-data");const f=k["user-data-dir"];if(f)return f;let g=process.env.VSCODE_APPDATA;if(!g)switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(R,"AppData","Roaming")}break;case"darwin":g=e.join(v.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,U)}return{getUserDataPath:A}}if(typeof define=="function")define(Z[127],ee([0,204,38,16,11]),function(e,v,U,A,P){const k=P.dirname(A.FileAccess.asFileUri("",e)),T=e.__$__nodeRequire(P.joinPath(k,"package.json").fsPath);return K(v,U,T.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),U=require("os");module.exports=K(v,U,e.name)}else throw new Error("Unknown context")}(),define(Z[128],ee([0,1,38,127,126]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends A.AbstractNativeEnvironmentService{constructor(T,f){super(T,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,U.getUserDataPath)(T)},f)}}e.NativeEnvironmentService=P}),define(Z[129],ee([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const U=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,P=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,T=/^\s*url\s*=\s*(.+\S)\s*$/mg,f=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function g(E){const p=E.match(k);return p?p[1]:null}function R(E){if(E.indexOf("://")===-1){const p=E.match(U);return p?g(p[2]):null}try{const p=v.URI.parse(E);if(p.authority)return g(p.authority)}catch(p){}return null}function d(E,p){const w=new Set;let y;for(;y=T.exec(E);){const i=R(y[1]);i&&w.add(i)}const s=new Set(p);return Array.from(w).map(i=>s.has(i)?i:i.replace(f,"a"))}e.getDomainsOfRemotes=d;function m(E){const p=E.match(P);return p?p[2]:null}function b(E,p,w){return E&&p?(w&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${E}${p}`:`${E}/${p}`):null}function o(E,p){if(E.indexOf("://")===-1){const w=E.match(A);if(w)return b(w[2],w[3],p)}try{const w=v.URI.parse(E);if(w.authority)return b(m(w.authority),w.path,p)}catch(w){}return null}function C(E,p=!1){const w=[];let y;for(;y=T.exec(E);){const s=o(y[1],p);s&&w.push(s)}return w}e.getRemotes=C}),define(Z[130],ee([0,1,3,5,91,26,2]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function T(o,C){return U.URI.revive(C?C.transformIncoming(o):o)}function f(o,C){return C?C.transformOutgoingURI(o):o}function g(o,C){C=C||A.DefaultURITransformer;const E=o.manifest,p=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},o),{manifest:void 0}),C);return Object.assign(Object.assign({},p),{manifest:E})}function R(o,C){return C?(0,P.cloneAndChange)(o,E=>E instanceof U.URI?C.transformOutgoingURI(E):void 0):o}class d{constructor(C,E){this.service=C,this.getUriTransformer=E,this.onInstallExtension=v.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,E){const p=this.getUriTransformer(C);switch(E){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,w=>Object.assign(Object.assign({},w),{local:w.local?R(w.local,p):w.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,E,p){const w=this.getUriTransformer(C);switch(E){case"zip":return this.service.zip(g(p[0],w)).then(y=>f(y,w));case"unzip":return this.service.unzip(T(p[0],w));case"install":return this.service.install(T(p[0],w));case"getManifest":return this.service.getManifest(T(p[0],w));case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(g(p[0],w),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(g(p[0],w));case"getInstalled":return this.service.getInstalled(p[0]).then(y=>y.map(s=>R(s,w)));case"updateMetadata":return this.service.updateMetadata(g(p[0],w),p[1]).then(y=>R(y,w));case"updateExtensionScope":return this.service.updateExtensionScope(g(p[0],w),p[1]).then(y=>R(y,w));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class m extends k.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(E=>this._onInstallExtension.fire(E))),this._register(this.channel.listen("onDidInstallExtension")(E=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},E),{local:E.local?g(E.local,null):E.local})))),this._register(this.channel.listen("onUninstallExtension")(E=>this._onUninstallExtension.fire(E))),this._register(this.channel.listen("onDidUninstallExtension")(E=>this._onDidUninstallExtension.fire(E)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(E=>U.URI.revive(E)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C){return Promise.resolve(this.channel.call("install",[C])).then(E=>g(E,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,E){return Promise.resolve(this.channel.call("installFromGallery",[C,E])).then(p=>g(p,null))}uninstall(C,E){return Promise.resolve(this.channel.call("uninstall",[C,E]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(E=>E.map(p=>g(p,null)))}updateMetadata(C,E){return Promise.resolve(this.channel.call("updateMetadata",[C,E])).then(p=>g(p,null))}updateExtensionScope(C,E){return Promise.resolve(this.channel.call("updateExtensionScope",[C,E])).then(p=>g(p,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=m;class b{constructor(C){this.service=C}listen(C,E){throw new Error("Invalid listen")}call(C,E,p){switch(E){case"getConfigBasedTips":return this.service.getConfigBasedTips(U.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[131],ee([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const U=/^%([\w\d.-]+)%$/i;function A(P,k){const T=f=>{if(typeof f=="string"){const g=U.exec(f);if(!!g)return k[g[1]]||f}};return(0,v.cloneAndChange)(P,T)}e.localizeManifest=A}),define(Z[132],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(P){this.channel=P}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(P,k,T,f){return this.channel.call("promptImportantExtensionsInstallNotification",[P,k,T,f])}promptWorkspaceRecommendations(P){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class U{constructor(P){this.service=P}listen(P,k){throw new Error(`Event not found: ${k}`)}call(P,k,T){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(T[0],T[1],T[2],T[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(Z[68],ee([0,1,113]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const U=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(d){return d=d.trim(),d==="*"||U.test(d)}e.isValidVersionStr=A;function P(d){if(!A(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=d.match(U);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=P;function k(d){if(!d)return null;let m=d.majorBase,b=d.majorMustEqual,o=d.minorBase,C=d.minorMustEqual,E=d.patchBase,p=d.patchMustEqual;return d.hasCaret&&(m===0||(C=!1),p=!1),{majorBase:m,majorMustEqual:b,minorBase:o,minorMustEqual:C,patchBase:E,patchMustEqual:p,isMinimum:d.hasGreaterEquals}}e.normalizeVersion=k;function T(d,m){let b;typeof d=="string"?b=k(P(d)):b=d;let o;if(typeof m=="string"?o=k(P(m)):o=m,!b||!o)return!1;let C=b.majorBase,E=b.minorBase,p=b.patchBase,w=o.majorBase,y=o.minorBase,s=o.patchBase,i=o.majorMustEqual,t=o.minorMustEqual,n=o.patchMustEqual;return o.isMinimum?C>w?!0:C<w?!1:E>y?!0:E<y?!1:p>=s:(C===1&&w===0&&(!i||!t||!n)&&(w=1,y=0,s=0,i=!0,t=!1,n=!1),C<w?!1:C>w?!i:E<y?!1:E>y?!t:p<s?!1:p>s?!n:!0)}e.isValidVersion=T;function f(d,m,b){return m.isBuiltin||typeof m.main=="undefined"?!0:R(d,m.engines.vscode,b)}e.isValidExtensionVersion=f;function g(d,m){return d==="*"||R(m,d)}e.isEngineValid=g;function R(d,m,b=[]){let o=k(P(m));if(!o)return b.push(v.localize(0,null,m)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return b.push(v.localize(1,null,m)),!1}else if(!o.majorMustEqual)return b.push(v.localize(2,null,m)),!1;return T(d,o)?!0:(b.push(v.localize(3,null,d,m)),!1)}e.isVersionValid=R}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends A.Disposable{constructor(f,g,R,d){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=R,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new U.Client(P.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[134],ee([0,1,34,49,2,16]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends A.Disposable{constructor(f,g,R,d,m={}){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=R,this.verboseLogging=d,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new U.Client(P.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[135],ee([0,1,48,66,90,16]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(f,g,R,d,m){this.watchedFolder=f,this.eventCallback=R,this.logCallback=d,this.verboseLogging=m,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(b=>A.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=v.spawn(P.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const g=new U.LineDecoder;this.handle.stdout.on("data",R=>{const d=[];g.write(R).forEach(m=>{const b=m.split("|");if(b.length===2){const o=Number(b[0]),C=b[1];if(o>=0&&o<3){if(this.ignored&&this.ignored.some(E=>E(C))){this.verboseLogging&&this.log(C);return}d.push({type:k.changeTypeMap[o],path:C})}else this.log(b[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,d)=>this.onExit(R,d))}onError(f){this.error("process error: "+f.toString())}onExit(f,g){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${g})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Z[136],ee([0,1,135,9,21]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P{constructor(T,f,g,R){this.onDidFilesChange=f,this.onLogMessage=g,this.verboseLogging=R,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(U.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,U.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=P}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(P,k=[],T=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=v;const U=(A,...P)=>new v(A,P);e.createSyncDescriptor=U}),define(Z[137],ee([0,1,50]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const U=[];function A(k,T,f){T instanceof v.SyncDescriptor||(T=new v.SyncDescriptor(T,[],f)),U.push([k,T])}e.registerSingleton=A;function P(){return U}e.getSingletonServiceDescriptors=P}),define(Z[138],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=v;class U{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let k of this._nodes.values())k.outgoing.size===0&&P.push(k);return P}insertEdge(P,k){const T=this.lookupOrInsertNode(P),f=this.lookupOrInsertNode(k);T.outgoing.set(this._hashFn(k),f),f.incoming.set(this._hashFn(P),T)}removeNode(P){const k=this._hashFn(P);this._nodes.delete(k);for(let T of this._nodes.values())T.outgoing.delete(k),T.incoming.delete(k)}lookupOrInsertNode(P){const k=this._hashFn(P);let T=this._nodes.get(k);return T||(T=new v(P),this._nodes.set(k,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[k,T]of this._nodes)P.push(`${k}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=U}),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function f(g){return g[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=f})(v=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function U(T,f,g,R){f[v.DI_TARGET]===f?f[v.DI_DEPENDENCIES].push({id:T,index:g,optional:R}):(f[v.DI_DEPENDENCIES]=[{id:T,index:g,optional:R}],f[v.DI_TARGET]=f)}function A(T){if(v.serviceIds.has(T))return v.serviceIds.get(T);const f=function(g,R,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(f,g,d,!1)};return f.toString=()=>T,v.serviceIds.set(T,f),f}e.createDecorator=A;function P(T){return T}e.refineServiceDecorator=P;function k(T){return function(f,g,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");U(T,f,R,!0)}}e.optional=k}),define(Z[139],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,v.createDecorator)("checksumService")}),define(Z[140],ee([0,1,21,4,7]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=A.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",A.isMacintosh),k.set("isLinux",A.isLinux),k.set("isWindows",A.isWindows),k.set("isWeb",A.isWeb),k.set("isMacNative",A.isMacintosh&&!A.isWeb),k.set("isEdge",P.indexOf("Edg/")>=0),k.set("isFirefox",P.indexOf("Firefox")>=0),k.set("isChrome",P.indexOf("Chrome")>=0),k.set("isSafari",P.indexOf("Safari")>=0),k.set("isIPad",P.indexOf("iPad")>=0);const T=Object.prototype.hasOwnProperty;var f;(function(I){I[I.False=0]="False",I[I.True=1]="True",I[I.Defined=2]="Defined",I[I.Not=3]="Not",I[I.Equals=4]="Equals",I[I.NotEquals=5]="NotEquals",I[I.And=6]="And",I[I.Regex=7]="Regex",I[I.NotRegex=8]="NotRegex",I[I.Or=9]="Or",I[I.In=10]="In",I[I.NotIn=11]="NotIn",I[I.Greater=12]="Greater",I[I.GreaterEquals=13]="GreaterEquals",I[I.Smaller=14]="Smaller",I[I.SmallerEquals=15]="SmallerEquals"})(f=e.ContextKeyExprType||(e.ContextKeyExprType={}));class g{static false(){return d.INSTANCE}static true(){return m.INSTANCE}static has(u){return b.create(u)}static equals(u,L){return o.create(u,L)}static notEquals(u,L){return p.create(u,L)}static regex(u,L){return n.create(u,L)}static in(u,L){return C.create(u,L)}static not(u){return w.create(u)}static and(...u){return l.create(u)}static or(...u){return a.create(u)}static greater(u,L){return y.create(u,L)}static less(u,L){return i.create(u,L)}static deserialize(u,L=!1){if(!!u)return this._deserializeOrExpression(u,L)}static _deserializeOrExpression(u,L){let _=u.split("||");return a.create(_.map($=>this._deserializeAndExpression($,L)))}static _deserializeAndExpression(u,L){let _=u.split("&&");return l.create(_.map($=>this._deserializeOne($,L)))}static _deserializeOne(u,L){if(u=u.trim(),u.indexOf("!=")>=0){let _=u.split("!=");return p.create(_[0].trim(),this._deserializeValue(_[1],L))}if(u.indexOf("==")>=0){let _=u.split("==");return o.create(_[0].trim(),this._deserializeValue(_[1],L))}if(u.indexOf("=~")>=0){let _=u.split("=~");return n.create(_[0].trim(),this._deserializeRegexValue(_[1],L))}if(u.indexOf(" in ")>=0){let _=u.split(" in ");return C.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const _=u.split(">=");return s.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const _=u.split(">");return y.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const _=u.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const _=u.split("<");return i.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(u)?w.create(u.substr(1).trim()):b.create(u)}static _deserializeValue(u,L){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let _=/^'([^']*)'$/.exec(u);return _?_[1].trim():u}static _deserializeRegexValue(u,L){if((0,v.isFalsyOrWhitespace)(u)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=u.indexOf("/"),$=u.lastIndexOf("/");if(_===$||_<0){if(L)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let B=u.slice(_+1,$),M=u[$+1]==="i"?"i":"";try{return new RegExp(B,M)}catch(j){if(L)throw new Error(`bad regexp-value '${u}', parse error: ${j}`);return console.warn(`bad regexp-value '${u}', parse error: ${j}`),null}}}e.ContextKeyExpr=g;function R(I,u){return I.cmp(u)}class d{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class m{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class b{constructor(u){this.key=u,this.type=2}static create(u){const L=k.get(u);return typeof L=="boolean"?L?m.INSTANCE:d.INSTANCE:new b(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=b;class o{constructor(u,L){this.key=u,this.value=L,this.type=4}static create(u,L){if(typeof L=="boolean")return L?b.create(u):w.create(u);const _=k.get(u);return typeof _=="boolean"?L===(_?"true":"false")?m.INSTANCE:d.INSTANCE:new o(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class C{constructor(u,L){this.key=u,this.valueKey=L,this.type=10}static create(u,L){return new C(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const L=u.getValue(this.valueKey),_=u.getValue(this.key);return Array.isArray(L)?L.indexOf(_)>=0:typeof _=="string"&&typeof L=="object"&&L!==null?T.call(L,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=C;class E{constructor(u){this._actual=u,this.type=11}static create(u){return new E(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new E(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class p{constructor(u,L){this.key=u,this.value=L,this.type=5}static create(u,L){if(typeof L=="boolean")return L?w.create(u):b.create(u);const _=k.get(u);return typeof _=="boolean"?L===(_?"true":"false")?d.INSTANCE:m.INSTANCE:new p(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class w{constructor(u){this.key=u,this.type=3}static create(u){const L=k.get(u);return typeof L=="boolean"?L?d.INSTANCE:m.INSTANCE:new w(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=w;class y{constructor(u,L){this.key=u,this.value=L,this.type=12}static create(u,L){return new y(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=y;class s{constructor(u,L){this.key=u,this.value=L,this.type=13}static create(u,L){return new s(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class i{constructor(u,L){this.key=u,this.value=L,this.type=14}static create(u,L){return new i(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=i;class t{constructor(u,L){this.key=u,this.value=L,this.type=15}static create(u,L){return new t(u,L)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return y.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(u,L){this.key=u,this.regexp=L,this.type=7}static create(u,L){return new n(u,L)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const L=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return L<_?-1:L>_?1:0}equals(u){if(u.type===this.type){const L=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return this.key===u.key&&L===_}return!1}evaluate(u){let L=u.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class l{constructor(u){this.expr=u,this.type=6}static create(u){return l._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let L=0,_=this.expr.length;L<_;L++){const $=R(this.expr[L],u.expr[L]);if($!==0)return $}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let L=0,_=this.expr.length;L<_;L++)if(!this.expr[L].equals(u.expr[L]))return!1;return!0}return!1}evaluate(u){for(let L=0,_=this.expr.length;L<_;L++)if(!this.expr[L].evaluate(u))return!1;return!0}static _normalizeArr(u){const L=[];let _=!1;for(const $ of u)if(!!$){if($.type===1){_=!0;continue}if($.type===0)return d.INSTANCE;if($.type===6){L.push(...$.expr);continue}L.push($)}if(L.length===0&&_)return m.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(R);L.length>1;){const $=L[L.length-1];if($.type!==9)break;L.pop();const B=L.pop(),M=a.create($.expr.map(j=>l.create([j,B])));M&&(L.push(M),L.sort(R))}return L.length===1?L[0]:new l(L)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let L of this.expr)u.push(...L.keys());return u}map(u){return new l(this.expr.map(L=>L.map(u)))}negate(){let u=[];for(let L of this.expr)u.push(L.negate());return a.create(u)}}e.ContextKeyAndExpr=l;class a{constructor(u){this.expr=u,this.type=9}static create(u){const L=a._normalizeArr(u);if(L.length!==0)return L.length===1?L[0]:new a(L)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let L=0,_=this.expr.length;L<_;L++){const $=R(this.expr[L],u.expr[L]);if($!==0)return $}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let L=0,_=this.expr.length;L<_;L++)if(!this.expr[L].equals(u.expr[L]))return!1;return!0}return!1}evaluate(u){for(let L=0,_=this.expr.length;L<_;L++)if(this.expr[L].evaluate(u))return!0;return!1}static _normalizeArr(u){let L=[],_=!1;if(u){for(let $=0,B=u.length;$<B;$++){const M=u[$];if(!!M){if(M.type===0){_=!0;continue}if(M.type===1)return[m.INSTANCE];if(M.type===9){L=L.concat(M.expr);continue}L.push(M)}}if(L.length===0&&_)return[d.INSTANCE];L.sort(R)}return L}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let L of this.expr)u.push(...L.keys());return u}map(u){return new a(this.expr.map(L=>L.map(u)))}negate(){let u=[];for(let _ of this.expr)u.push(_.negate());const L=_=>_.type===9?_.expr:[_];for(;u.length>1;){const _=u.shift(),$=u.shift(),B=[];for(const M of L(_))for(const j of L($))B.push(g.and(M,j));u.unshift(g.or(...B))}return u[0]}}e.ContextKeyOrExpr=a;class c extends b{constructor(u,L,_){super(u);this.key=u,this._defaultValue=L,typeof _=="object"?c._info.push(Object.assign(Object.assign({},_),{key:u})):_!==!0&&c._info.push({key:u,description:_,type:L!=null?typeof L:void 0})}static all(){return c._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return g.not(this.key)}isEqualTo(u){return g.equals(this.key,u)}notEqualsTo(u){return g.notEquals(this.key,u)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,U.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(I,u){return I<u?-1:I>u?1:0}function S(I,u,L,_){return I<L?-1:I>L?1:u<_?-1:u>_?1:0}}),define(Z[69],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function U(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=U}),define(Z[70],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,v.createDecorator)("downloadService")}),define(Z[10],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(v,U){e(v,U,K)}};define(Z[141],ee([0,1,10,9,23,13,2,6]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let f=class extends k.Disposable{constructor(R){super();this.environmentService=R,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let R=setTimeout(()=>{R=void 0;const d=(0,U.basename)(this.environmentService.logsPath),m=(0,U.dirname)(this.environmentService.logsPath);(0,A.readdir)(m).then(b=>{const C=b.filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter((p,w)=>p!==d),E=C.slice(0,Math.max(0,C.length-9));return T.Promises.settled(E.map(p=>(0,A.rimraf)((0,U.join)(m,p))))}).then(null,P.onUnexpectedError)},10*1e3);this._register((0,k.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};f=ue([Y(0,v.IEnvironmentService)],f),e.LogsDataCleaner=f}),define(Z[142],ee([0,1,27,10,9,23,13,2]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let f=class at extends T.Disposable{constructor(R,d){super();this.backupWorkspacesPath=R,this.environmentService=d,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let R=setTimeout(()=>{R=void 0,(async()=>{try{const d=await v.promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(d).emptyWorkspaceInfos.map(E=>E.backupFolder),o=await(0,P.readdir)(this.environmentService.workspaceStorageHome.fsPath),C=[];o.forEach(E=>{E.length!==at.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(E)===-1&&C.push((0,P.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}),await Promise.all(C)}catch(d){(0,k.onUnexpectedError)(d)}})()},30*1e3);this._register((0,T.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};f.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,f=ue([Y(1,U.INativeEnvironmentService)],f),e.StorageDataCleaner=f}),define(Z[29],ee([0,1,108,4,16]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function P(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=P;var k;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var T;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(T=e.SortOrder||(e.SortOrder={}));var f;(function(d){d.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(m,b){super(m);this.code=b}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,U.createDecorator)("IExtensionManagementCLIService")}),define(Z[143],ee([0,1,2,29]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends v.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=ue([Y(0,U.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[71],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(U=e.RecommendationSource||(e.RecommendationSource={}));function A(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var P;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(P=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,v.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[72],ee([0,1,21,4]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class k{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,d){if(typeof R=="undefined"||R===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof R=="string"||typeof d=="string"){let m=typeof R=="string"?R:R.value,b=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(m,b)}return R._lower===d._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=k;function T(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function f(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=f,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,72]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(b,o){return b.uuid&&o.uuid?b.uuid===o.uuid:b.id===o.id?!0:(0,v.compareIgnoreCase)(b.id,o.id)===0}e.areSameExtensions=A;class P{constructor(o,C){this.version=C,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof P?A(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=P;function k(b,o){return`${b}.${o}`}e.getExtensionId=k;function T(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function f(b,o){return T(k(b,o))}e.getGalleryExtensionId=f;function g(b,o){const C=[],E=p=>{for(const w of C)if(w.some(y=>A(o(y),o(p))))return w;return null};for(const p of b){const w=E(p);w?w.push(p):C.push([p])}return C}e.groupByExtension=g;function R(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function d(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new U.ExtensionIdentifier("pprice.better-merge");function m(b){const o=new Set;for(const C of b)C.malicious&&o.add(C.id.id);return o}e.getMaliciousExtensionsSet=m}),define(Z[144],ee([0,1,2,9,72,23]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends v.Disposable{constructor(f,g){super();this.environmentService=f,this.extensionsManifestCache=(0,U.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(g.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){P.rimraf(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[8],ee([0,1,115,9,5,4,21,17,37]),function(K,e,v,U,A,P,k,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function g(M){return M.create===!0}e.isFileOpenForWriteOptions=g;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var d;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=m;function b(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=b;function o(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function C(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=C;var E;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=p;function w(M,j){const W=new p(M.toString(),j);return s(W,j),W}e.createFileSystemProviderError=w;function y(M){return M||w((0,v.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=y;function s(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=s;function i(M){if(!M)return E.Unknown;if(M instanceof p)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return E.Unknown;switch(j[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=i;function t(M){if(M instanceof h)return M.fileOperationResult;switch(i(M)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(j,W,z){this.resource=j,this.operation=W,this.target=z}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var l;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class a{constructor(j,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const z of j)switch(z.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(z.resource,z);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...z){var H,q,D,O,F,N;if(!j)return!1;const V=z.length>0;return!!((!V||z.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(j))||W.includeChildren&&((q=this.added)===null||q===void 0?void 0:q.findSuperstr(j)))||(!V||z.includes(0))&&(((D=this.updated)===null||D===void 0?void 0:D.get(j))||W.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(j)))||(!V||z.includes(2))&&(((F=this.deleted)===null||F===void 0?void 0:F.findSubstr(j))||W.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const W=[],z=j===1?this.added:j===0?this.updated:this.deleted;if(z)for(const[,H]of z)W.push(H);return W}filter(j){return new a(this.changes.filter(W=>j(W)),this.ignorePathCasing)}}e.FileChangesEvent=a;function c(M,j,W){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==U.sep&&(j+=U.sep),W?(0,k.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=c;class h extends Error{constructor(j,W,z){super(j);this.fileOperationResult=W,this.options=z}static isFileOperationError(j){return j instanceof Error&&!(0,T.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=h;var S;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=u;async function L(M,j){if(!j.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise(W=>{const z=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(z.dispose(),W())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize(j){return(0,T.isNumber)(j)||(j=0),j<_.KB?(0,v.localize)(1,null,j.toFixed(0)):j<_.MB?(0,v.localize)(2,null,(j/_.KB).toFixed(2)):j<_.GB?(0,v.localize)(3,null,(j/_.MB).toFixed(2)):j<_.TB?(0,v.localize)(4,null,(j/_.GB).toFixed(2)):(0,v.localize)(5,null,(j/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var $;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*_.MB:16*_.GB,maxHeapSize:M===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=B}),define(Z[145],ee([0,1,146,47,8]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let P=class{constructor(T){this.fileService=T}checksum(T){return new Promise(async(f,g)=>{const R=(0,v.createHash)("md5"),d=(await this.fileService.readFileStream(T)).value;(0,U.listenStream)(d,{onData:m=>R.update(m.buffer),onError:m=>g(m),onEnd:()=>f(R.digest("base64").replace(/=+$/,""))})})}};P=ue([Y(0,A.IFileService)],P),e.ChecksumService=P}),define(Z[73],ee([0,1,116,22,8,13]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(R,d,m,b,o,C){let E;try{await T(R,d,m,b,o,C)}catch(p){E=p}finally{E&&o.errorTransformer&&(E=o.errorTransformer(E)),typeof E!="undefined"&&m.error(E),m.end()}}e.readFileIntoStream=k;async function T(R,d,m,b,o,C){f(C);const E=await R.open(d,{create:!1});try{f(C);let p=0,w=0,y=o&&typeof o.length=="number"?o.length:void 0,s=U.VSBuffer.alloc(Math.min(o.bufferSize,typeof y=="number"?y:o.bufferSize)),i=o&&typeof o.position=="number"?o.position:0,t=0;do w=await R.read(E,i,s.buffer,t,s.byteLength-t),i+=w,t+=w,p+=w,typeof y=="number"&&(y-=w),t===s.byteLength&&(await m.write(b(s)),s=U.VSBuffer.alloc(Math.min(o.bufferSize,typeof y=="number"?y:o.bufferSize)),t=0);while(w>0&&(typeof y!="number"||y>0)&&f(C)&&g(p,o));if(t>0){let n=t;typeof y=="number"&&(n=Math.min(t,y)),m.write(b(s.slice(0,n)))}}catch(p){throw(0,A.ensureFileSystemProviderError)(p)}finally{await R.close(E)}}function f(R){if(R.isCancellationRequested)throw(0,P.canceled)();return!0}function g(R,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&R>d.limits.memory)throw(0,A.createFileSystemProviderError)((0,v.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&R>d.limits.size)throw(0,A.createFileSystemProviderError)((0,v.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[74],ee([0,1,5,8,7]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function P(f){return f.map(g=>({type:g.type,resource:v.URI.file(g.path)}))}e.toFileChanges=P;function k(f){const g=new T;for(const R of f)g.processEvent(R);return g.normalize()}e.normalizeFileChanges=k;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const R=this.mapPathToChange.get(g.path);if(R){const d=R.type,m=g.type;d===1&&m===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(R),1)):d===2&&m===1?R.type=0:d===1&&m===0||(R.type=m)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],R=[];return this.normalized.filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,m)=>d.path.length-m.path.length).filter(d=>R.some(m=>(0,U.isParent)(d.path,m,!A.isLinux))?!1:(R.push(d.path),!0)).concat(g)}}}),define(Z[147],ee([0,1,74,2,23,94,97,6,9]),function(K,e,v,U,A,P,k,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends U.Disposable{constructor(d,m,b,o){super();this.path=d,this.onDidFilesChange=m,this.onLogMessage=b,this.verboseLogging=o,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:m}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(m)try{b=await(0,P.realpath)(b)}catch(o){if(this.onError(o),m.dangling)return}d.isDirectory()?this._register((0,k.watchFolder)(b,(o,C)=>{this.onFileChange({type:o==="changed"?0:o==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(C))})},o=>this.onError(o))):this._register((0,k.watchFile)(b,o=>{this.onFileChange({type:o==="changed"?0:2,path:this.path})},o=>this.onError(o)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,v.normalizeFileChanges)(m);this.verboseLogging&&b.forEach(o=>{this.onVerbose(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(Z[75],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...A){this._entries=new Map;for(let[P,k]of A)this.set(P,k)}set(A,P){const k=this._entries.get(A);return this._entries.set(A,P),k}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=v}),define(Z[148],ee([0,1,13,138,50,4,75,6]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class g extends Error{constructor(o){super("cyclic dependency between services");this.message=o.toString()}}class R{constructor(o=new k.ServiceCollection,C=!1,E){this._activeInstantiations=new Set,this._services=o,this._strict=C,this._parent=E,this._services.set(P.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...C){let E=m.traceInvocation(o),p=!1;try{return o({get:(y,s)=>{if(p)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(y,E);if(!i&&s!==P.optional)throw new Error(`[invokeFunction] unknown service '${y}'`);return i}},...C)}finally{p=!0,E.stop()}}createInstance(o,...C){let E,p;return o instanceof A.SyncDescriptor?(E=m.traceCreation(o.ctor),p=this._createInstance(o.ctor,o.staticArguments.concat(C),E)):(E=m.traceCreation(o),p=this._createInstance(o,C,E)),E.stop(),p}_createInstance(o,C=[],E){let p=P._util.getServiceDependencies(o).sort((s,i)=>s.index-i.index),w=[];for(const s of p){let i=this._getOrCreateServiceInstance(s.id,E);if(!i&&this._strict&&!s.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`);w.push(i)}let y=p.length>0?p[0].index:C.length;if(C.length!==y){console.warn(`[createInstance] First service dependency of ${o.name} at position ${y+1} conflicts with ${C.length} static arguments`);let s=y-C.length;s>0?C=C.concat(new Array(s)):C=C.slice(0,y)}return new o(...[...C,...w])}_setServiceInstance(o,C){if(this._services.get(o)instanceof A.SyncDescriptor)this._services.set(o,C);else if(this._parent)this._parent._setServiceInstance(o,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let C=this._services.get(o);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):C}_getOrCreateServiceInstance(o,C){let E=this._getServiceInstanceOrDescriptor(o);return E instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,E,C.branch(o,!0)):(C.branch(o,!1),E)}_safeCreateAndCacheServiceInstance(o,C,E){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,C,E)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,C,E){const p=new U.Graph(s=>s.id.toString());let w=0;const y=[{id:o,desc:C,_trace:E}];for(;y.length;){const s=y.pop();if(p.lookupOrInsertNode(s),w++>1e3)throw new g(p);for(let i of P._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(i.id);if(!t&&!i.optional&&console.warn(`[createInstance] ${o} depends on ${i.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:i.id,desc:t,_trace:s._trace.branch(i.id,!0)};p.insertEdge(s,n),y.push(n)}}}for(;;){const s=p.roots();if(s.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:i}of s){if(this._getServiceInstanceOrDescriptor(i.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}p.removeNode(i)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,C,E=[],p,w){if(this._services.get(o)instanceof A.SyncDescriptor)return this._createServiceInstance(C,E,p,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,C,E,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(o,C=[],E,p){if(E){const w=new T.IdleValue(()=>this._createInstance(o,C,p));return new Proxy(Object.create(null),{get(y,s){if(s in y)return y[s];let i=w.value,t=i[s];return typeof t!="function"||(t=t.bind(i),y[s]=t),t},set(y,s,i){return w.value[s]=i,!0}})}else return this._createInstance(o,C,p)}}e.InstantiationService=R;var d;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(d||(d={}));class m{constructor(o,C){this.type=o,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return f?new m(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(o){return f?new m(0,o.name):m._None}branch(o,C){let E=new m(2,o.toString());return this._dep.push([o,C,E]),E}stop(){let o=Date.now()-this._start;m._totals+=o;let C=!1;function E(w,y){let s=[],i=new Array(w+1).join("	");for(const[t,n,r]of y._dep)if(n&&r){C=!0,s.push(`${i}CREATES -> ${t}`);let l=E(w+1,r);l&&s.push(l)}else s.push(`${i}uses -> ${t}`);return s.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(o>2||C)&&console.log(p.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[149],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class v{constructor(A,P){this.server=A,this.router=P}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,P){this.server.registerChannel(A,P)}}e.MessagePortMainProcessService=v}),define(Z[150],ee([0,1,34,50,137,4]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(b,o,C){const E=C.getChannel(b);return T(o)?new o.channelClientCtor(E):v.ProxyChannel.toService(E,o==null?void 0:o.proxyOptions)}}function T(m){const b=m;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=(0,P.createDecorator)("mainProcessService");let f=class extends k{constructor(b,o,C){super(b,o,C)}};f=ue([Y(2,e.IMainProcessService)],f);function g(m,b,o){(0,A.registerSingleton)(m,new U.SyncDescriptor(f,[b,o],o==null?void 0:o.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=g,e.ISharedProcessService=(0,P.createDecorator)("sharedProcessService");let R=class extends k{constructor(b,o,C){super(b,o,C)}};R=ue([Y(2,e.ISharedProcessService)],R);function d(m,b,o){(0,A.registerSingleton)(m,new U.SyncDescriptor(R,[b,o],o==null?void 0:o.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=d}),define(Z[54],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,v.createDecorator)("localizationsService");function U(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const P of A.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=U}),define(Z[151],ee([0,1,2,54]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends v.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=ue([Y(0,U.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[12],ee([0,1,4,2,7,3,43]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function T(){return new Date().toISOString()}var f;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class g extends U.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class R extends g{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...t]))}debug(i,...t){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...t]))}info(i,...t){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...t]))}warn(i,...t){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...t]))}error(i,...t){if(this.checkLogLevel(f.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([i,...t]))}critical(i,...t){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...t]))}flush(){}format(i){let t="";for(let n=0;n<i.length;n++){let r=i[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}t+=(n>0?" ":"")+r}return t}}e.AbstractMessageLogger=R;class d extends g{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...t){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...t):console.log(`[main ${T()}]`,i,...t))}debug(i,...t){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...t):console.log(`[main ${T()}]`,i,...t))}info(i,...t){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...t):console.log(`[main ${T()}]`,i,...t))}warn(i,...t){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,i,...t):console.warn(`[main ${T()}]`,i,...t))}error(i,...t){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,i,...t):console.error(`[main ${T()}]`,i,...t))}critical(i,...t){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,i,...t):console.error(`[main ${T()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class m extends g{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=m;class b extends g{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class o extends g{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const n of this.logServices)n.trace(i,...t)}debug(i,...t){for(const n of this.logServices)n.debug(i,...t)}info(i,...t){for(const n of this.logServices)n.info(i,...t)}warn(i,...t){for(const n of this.logServices)n.warn(i,...t)}error(i,...t){for(const n of this.logServices)n.error(i,...t)}critical(i,...t){for(const n of this.logServices)n.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=o;class C extends U.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=C;class E{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=E;function p(s){if(s.verbose)return f.Trace;if(typeof s.logLevel=="string"){const i=w(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function w(s){switch(s){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=w;function y(s){switch(s){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=y}),define(Z[152],ee([0,1,27,2,8,29,10,5,11,33,12,31,55,7,6]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends U.Disposable{constructor(w,y,s,i){super();this.fileService=y,this.extensionGalleryService=s,this.logService=i,this.extensionsDownloadDir=T.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,y){await this.cleanUpPromise;const s=this.getName(w),i=(0,f.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(i)){const t=(0,f.joinPath)(this.extensionsDownloadDir,`.${s}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(w,t,y),await this.rename(t,i,Date.now()+2*60*1e3)}return i}async delete(w){}async rename(w,y,s){try{await v.promises.rename(w.fsPath,y.fsPath)}catch(i){if(b.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${w} to ${y} with 'EPERM' error. Trying again...`),this.rename(w,y,s);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const y=[],s=[];for(const n of w.children){const r=this.parse(n.name);r&&s.push([r,n])}const i=(0,g.groupByExtension)(s,([n])=>n),t=[];for(const n of i)n.sort((r,l)=>m.rcompare(r[0].version,l[0].version)),y.push(...n.slice(1).map(r=>r[1].resource)),t.push(n[0][1]);t.sort((n,r)=>n.mtime-r.mtime),y.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await o.Promises.settled(y.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?new g.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase():(0,d.generateUuid)()}parse(w){const y=C.exec(w);return y&&y[1]&&y[2]?new g.ExtensionIdentifierWithVersion({id:y[1]},y[2]):null}};E=ue([Y(0,k.INativeEnvironmentService),Y(1,A.IFileService),Y(2,P.IExtensionGalleryService),Y(3,R.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[153],ee([0,1,2,12,48,43,9,6,3,16,23,10]),function(K,e,v,U,A,P,k,T,f,g,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends v.Disposable{constructor(o,C){super();this.environmentService=o,this.logService=C,this.processesLimiter=new T.Limiter(5)}async postUninstall(o){const C=this.parseScript(o,"uninstall");return C&&(this.logService.info(o.identifier.id,o.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,o).then(()=>this.logService.info(o.identifier.id,o.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(o.identifier.id,o.manifest.version,`Failed to run post uninstall script: ${E}`)))),(0,R.rimraf)(this.getExtensionStoragePath(o)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(o,C){const E=`vscode:${C}`;if(o.location.scheme===g.Schemas.file&&o.manifest&&o.manifest.scripts&&typeof o.manifest.scripts[E]=="string"){const p=o.manifest.scripts[E].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(o.identifier.id,o.manifest.version,`${E} should be a node script`),null):{script:(0,k.join)(o.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(o,C,E,p,w){return new Promise((y,s)=>{const i=this.start(o,C,E,w);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?s(r):y(void 0)};i.on("error",r=>{n((0,P.toErrorMessage)(r)||"Unknown")}),i.on("exit",(r,l)=>{n(r?`post-${C} process exited with code ${r}`:void 0)}),p&&(t=setTimeout(()=>{t=null,i.kill(),s("timed out")},5e3))})}start(o,C,E,p){const w={silent:!0,execArgv:void 0},y=(0,A.fork)(o,[`--type=extension-post-${C}`,...E],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const s=f.Event.fromNodeEventEmitter(y.stdout,"data"),i=f.Event.fromNodeEventEmitter(y.stderr,"data");s(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${C}`,r)),i(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${C}`,r));const t=f.Event.any(f.Event.map(s,r=>({data:`%c${r}`,format:[""]})),f.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]})));return f.Event.debounce(t,(r,l)=>r?{data:r.data+l.data,format:[...r.format,...l.format]}:{data:l.data,format:l.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),y}getExtensionStoragePath(o){return(0,k.join)(this.environmentService.globalStorageHome.fsPath,o.identifier.id.toLowerCase())}};m=ue([Y(0,d.IEnvironmentService),Y(1,U.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[154],ee([0,1,2,10,3,8,5,33,11,12]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends v.Disposable{constructor(m,b,o,C){super();this.extensionsManagementService=m,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(w=>this.onInstallExtension(w))),this._register(m.onDidInstallExtension(w=>this.onDidInstallExtension(w))),this._register(m.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const E=k.URI.file(o.extensionsPath),p=new f.ExtUri(w=>!b.hasCapability(w,1024));this._register(b.watch(E)),this._register(A.Event.filter(b.onDidFilesChange,w=>w.changes.some(y=>this.doesChangeAffects(y,E,p)))(()=>this.onDidChange()))}doesChangeAffects(m,b,o){return o.isEqual(o.dirname(m.resource),b)?o.isEqual(m.resource,o.joinPath(b,".obsolete"))?!0:!(m.type!==1&&m.type!==2||o.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtension(m){this.removeInstallingExtension(m.identifier),m.error||this.addInstalledExtension(m.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(b=>!(0,T.areSameExtensions)(b,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,T.areSameExtensions)(b,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),b=m.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,T.areSameExtensions)(E,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),o=this.installedExtensions.filter(C=>m.every(E=>!(0,T.areSameExtensions)(E.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=m.map(C=>C.identifier),(b.length||o.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:o})}}};R=ue([Y(1,P.IFileService),Y(2,U.INativeEnvironmentService),Y(3,g.ILogService)],R),e.ExtensionsWatcher=R}),define(Z[155],ee([0,1,114,156,2,8,3,11,37,18,12,22,47,6,30,16,73,52]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends A.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,U.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i});const t=new A.DisposableStore;return t.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new P.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),t.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),typeof i.onDidErrorOccur=="function"&&t.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,A.dispose)(t)})}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){i.push(t)}}),!this.provider.has(s)&&await b.Promises.settled(i)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,i){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&i)}listCapabilities(){return p.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,T.isAbsolutePath)(s))throw new P.FileOperationError((0,v.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,s.toString()),t}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i)||(0,P.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(t){throw(0,P.toFileSystemProviderErrorCode)(t)===P.FileSystemProviderErrorCode.FileNotFound?new P.FileOperationError((0,v.localize)(2,null,this.resourceForError(s)),1):(0,P.ensureFileSystemProviderError)(t)}}async doResolveFile(s,i){const t=await this.withProvider(s),n=this.isPathCaseSensitive(t),r=i==null?void 0:i.resolveTo,l=i==null?void 0:i.resolveSingleChildDescendants,a=i==null?void 0:i.resolveMetadata,c=await t.stat(s);let h;return this.toFileStat(t,s,c,void 0,!!a,(S,I)=>(h||(h=f.TernarySearchTree.forUris(()=>!n),h.set(s,!0),(0,g.isNonEmptyArray)(r)&&r.forEach(u=>h.set(u,!0))),Boolean(h.findSuperstr(S.resource)||h.get(S.resource))?!0:S.isDirectory&&l?I===1:!1))}async toFileStat(s,i,t,n,r,l){const{providerExtUri:a}=this.getExtUri(s),c={resource:i,name:a.basename(i),isFile:(t.type&P.FileType.File)!=0,isDirectory:(t.type&P.FileType.Directory)!=0,isSymbolicLink:(t.type&P.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,P.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&l(c,n)){try{const h=await s.readdir(i),S=await b.Promises.settled(h.map(async([I,u])=>{try{const L=a.joinPath(i,I),_=r?await s.stat(L):{type:u};return await this.toFileStat(s,L,_,h.length,r,l)}catch(L){return this.logService.trace(L),null}}));c.children=(0,g.coalesce)(S)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(s){return b.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch(t){return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(t){return t}return!0}async doValidateCreateFile(s,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(s))throw new P.FileOperationError((0,v.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=d.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const n=await this.writeFile(s,i);return this._onDidRunOperation.fire(new P.FileOperationEvent(s,0,n)),n}async writeFile(s,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,s,t)||await this.mkdirp(n,r.dirname(s));let a;if((0,P.hasReadWriteCapability)(n)&&!(i instanceof d.VSBuffer))if((0,m.isReadableStream)(i)){const c=await(0,m.peekStream)(i,3);c.ended?a=d.VSBuffer.concat(c.buffer):a=c}else a=(0,m.peekReadable)(i,c=>d.VSBuffer.concat(c),3);else a=i;!(0,P.hasOpenReadWriteCloseCapability)(n)||(0,P.hasReadWriteCapability)(n)&&a instanceof d.VSBuffer?await this.doWriteUnbuffered(n,s,t,a):await this.doWriteBuffered(n,s,t,a instanceof d.VSBuffer?(0,d.bufferToReadable)(a):a)}catch(l){throw new P.FileOperationError((0,v.localize)(4,null,this.resourceForError(s),(0,P.ensureFileSystemProviderError)(l).toString()),(0,P.toFileOperationResult)(l),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,t){if(!!(t==null?void 0:t.unlock)&&!(s.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(i)));let r;try{r=await s.stat(i)}catch(l){return}if((r.type&P.FileType.Directory)!=0)throw new P.FileOperationError((0,v.localize)(6,null,this.resourceForError(i)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==P.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,P.etag)({mtime:t.mtime,size:r.size}))throw new P.FileOperationError((0,v.localize)(7,null),3,t);return r}async readFile(s,i){const t=await this.withReadProvider(s);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(t,s,i):this.doReadFile(t,s,i)}async doReadFileAtomic(s,i,t){return new Promise((n,r)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(s,i,t);n(l)}catch(l){r(l)}})})}async doReadFile(s,i,t){const n=await this.doReadFileStream(s,i,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,d.streamToBuffer)(n.value)})}async readFileStream(s,i){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,i)}async doReadFileStream(s,i,t){const n=new o.CancellationTokenSource,r=this.validateReadFile(i,t).then(a=>a,a=>{throw n.cancel(),a});let l;try{t&&typeof t.etag=="string"&&t.etag!==P.ETAG_DISABLED&&await r,!((0,P.hasOpenReadWriteCloseCapability)(s)||(0,P.hasFileReadStreamCapability)(s))||(0,P.hasReadWriteCapability)(s)&&(t==null?void 0:t.preferUnbuffered)?l=this.readFileUnbuffered(s,i,t):(0,P.hasFileReadStreamCapability)(s)?l=this.readFileStreamed(s,i,n.token,t):l=this.readFileBuffered(s,i,n.token,t);const a=await r;return Object.assign(Object.assign({},a),{value:l})}catch(a){throw l&&await(0,m.consumeStream)(l),new P.FileOperationError((0,v.localize)(8,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(a).toString()),(0,P.toFileOperationResult)(a),t)}}readFileStreamed(s,i,t,n=Object.create(null)){const r=s.readFileStream(i,n,t);return(0,m.transform)(r,{data:l=>l instanceof d.VSBuffer?l:d.VSBuffer.wrap(l),error:l=>new P.FileOperationError((0,v.localize)(9,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(l).toString()),(0,P.toFileOperationResult)(l),n)},l=>d.VSBuffer.concat(l))}readFileBuffered(s,i,t,n=Object.create(null)){const r=(0,d.newWriteableBufferStream)();return(0,E.readFileIntoStream)(s,i,r,l=>l,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:l=>new P.FileOperationError((0,v.localize)(10,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(l).toString()),(0,P.toFileOperationResult)(l),n)}),t),r}readFileUnbuffered(s,i,t){const n=(0,m.newWriteableStream)(r=>d.VSBuffer.concat(r));return(async()=>{try{let r=await s.readFile(i);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(i,r.byteLength,t),n.end(d.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(s,i){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new P.FileOperationError((0,v.localize)(11,null,this.resourceForError(s)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==P.ETAG_DISABLED&&i.etag===t.etag)throw new P.FileOperationError((0,v.localize)(12,null),2,i);return this.validateReadFileLimits(s,t.size,i),t}validateReadFileLimits(s,i,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&i>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&i>t.limits.size&&(n=7),typeof n=="number")throw new P.FileOperationError((0,v.localize)(13,null,this.resourceForError(s)),n)}}async canMove(s,i,t){return this.doCanMoveCopy(s,i,"move",t)}async canCopy(s,i,t){return this.doCanMoveCopy(s,i,"copy",t)}async doCanMoveCopy(s,i,t,n){if(s.toString()!==i.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,s,l,i,t,n)}catch(r){return r}return!0}async move(s,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),l=await this.doMoveCopy(n,s,r,i,"move",!!t),a=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(s,l==="move"?2:3,a)),a}async copy(s,i,t){const n=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),l=await this.doMoveCopy(n,s,r,i,"copy",!!t),a=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(s,l==="copy"?3:2,a)),a}async doMoveCopy(s,i,t,n,r,l){if(i.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,i,t,n,r,l);if(a&&!c&&l&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),r==="copy"){if(s===t&&(0,P.hasFileFolderCopyCapability)(s))await s.copy(i,n,{overwrite:l});else{const h=await this.resolve(i);h.isDirectory?await this.doCopyFolder(s,h,t,n):await this.doCopyFile(s,i,t,n)}return r}else return s===t?(await s.rename(i,n,{overwrite:l}),r):(await this.doMoveCopy(s,i,t,n,"copy",l),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,t,n){if((0,P.hasOpenReadWriteCloseCapability)(s)&&(0,P.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,i,t,n);if((0,P.hasOpenReadWriteCloseCapability)(s)&&(0,P.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,i,t,n);if((0,P.hasReadWriteCapability)(s)&&(0,P.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,i,t,n);if((0,P.hasReadWriteCapability)(s)&&(0,P.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,i,t,n)}async doCopyFolder(s,i,t,n){await t.mkdir(n),Array.isArray(i.children)&&await b.Promises.settled(i.children.map(async r=>{const l=this.getExtUri(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),t,l):this.doCopyFile(s,r.resource,t,l)}))}async doValidateMoveCopy(s,i,t,n,r,l){let a=!1;if(s===t){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(s);if(S||(a=h.isEqual(i,n)),a&&r==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!a&&h.isEqualOrParent(n,i))throw new Error((0,v.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const c=await this.exists(n);if(c&&!a){if(!l)throw new P.FileOperationError((0,v.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(s===t){const{providerExtUri:h}=this.getExtUri(s);if(h.isEqualOrParent(i,n))throw new Error((0,v.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?T.extUri:T.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(s,0,t)),t}async mkdirp(s,i){const t=[],{providerExtUri:n}=this.getExtUri(s);for(;!n.isEqual(i,n.dirname(i));)try{if(((await s.stat(i)).type&P.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,P.toFileSystemProviderErrorCode)(r)!==P.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(i)),i=n.dirname(i)}for(let r=t.length-1;r>=0;r--){i=n.joinPath(i,t[r]);try{await s.mkdir(i)}catch(l){if((0,P.toFileSystemProviderErrorCode)(l)!==P.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(t){return t}return!0}async doValidateDelete(s,i){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(i==null?void 0:i.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(s)));const r=await this.exists(s);if(!r)throw new P.FileOperationError((0,v.localize)(20,null,this.resourceForError(s)),1);if(!!!(i==null?void 0:i.recursive)&&r){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(s)))}return t}async del(s,i){const t=await this.doValidateDelete(s,i),n=!!(i==null?void 0:i.useTrash),r=!!(i==null?void 0:i.recursive);await t.delete(s,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new P.FileOperationEvent(s,1))}watch(s,i={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(s,i).then(r=>{t?(0,A.dispose)(r):n=()=>(0,A.dispose)(r)},r=>this.logService.error(r)),(0,A.toDisposable)(()=>n())}async doWatch(s,i){const t=await this.withProvider(s),n=this.toWatchKey(t,s,i),r=this.activeWatchers.get(n)||{count:0,disposable:t.watch(s,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,A.toDisposable)(()=>{r.count--,r.count===0&&((0,A.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(s,i,t){const{providerExtUri:n}=this.getExtUri(s);return[n.getComparisonKey(i),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,A.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,i,t,n){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{var r;const l=await s.open(i,{create:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1});try{(0,m.isReadableStream)(n)||(0,m.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(s,l,n):await this.doWriteReadableBufferedQueued(s,l,n)}catch(a){throw(0,P.ensureFileSystemProviderError)(a)}finally{await s.close(l)}})}async doWriteStreamBufferedQueued(s,i,t){let n=0,r;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const l=d.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,i,l,l.byteLength,n,0),n+=l.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(l,a)=>{(0,m.listenStream)(r,{onData:async c=>{r.pause();try{await this.doWriteBuffer(s,i,c,c.byteLength,n,0)}catch(h){return a(h)}n+=c.byteLength,setTimeout(()=>r.resume())},onError:c=>a(c),onEnd:()=>l()})})}async doWriteReadableBufferedQueued(s,i,t){let n=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(s,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(s,i,t,n,r,l){let a=0;for(;a<n;)a+=await s.write(i,r+a,t.buffer,l+a,n-a)}async doWriteUnbuffered(s,i,t,n){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,t,n))}async doWriteUnbufferedQueued(s,i,t,n){var r;let l;n instanceof d.VSBuffer?l=n:(0,m.isReadableStream)(n)?l=await(0,d.streamToBuffer)(n):(0,m.isReadableBufferedStream)(n)?l=await(0,d.bufferedStreamToBuffer)(n):l=(0,d.readableToBuffer)(n),await s.writeFile(i,l.buffer,{create:!0,overwrite:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(s,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,t,n))}async doPipeBufferedQueued(s,i,t,n){let r,l;try{r=await s.open(i,{create:!1}),l=await t.open(n,{create:!0,unlock:!1});const a=d.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,S=0;do S=await s.read(r,c,a.buffer,h,a.byteLength-h),await this.doWriteBuffer(t,l,a,S,c,h),c+=S,h+=S,h===a.byteLength&&(h=0);while(S>0)}catch(a){throw(0,P.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof l=="number"?t.close(l):Promise.resolve()])}}async doPipeUnbuffered(s,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,t,n))}async doPipeUnbufferedQueued(s,i,t,n){return t.writeFile(n,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,t,n))}async doPipeUnbufferedToBufferedQueued(s,i,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const l=await s.readFile(i);await this.doWriteBuffer(t,r,d.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,P.ensureFileSystemProviderError)(l)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(s,i,t,n){const r=await(0,d.streamToBuffer)(this.readFileBuffered(s,i,o.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,r)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new P.FileOperationError((0,v.localize)(22,null,this.resourceForError(i)),6);return s}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};w=ue([Y(0,R.ILogService)],w),e.FileService=w}),define(Z[157],ee([0,1,27,95,2,8,3,7,23,9,11,42,6,12,117,74,134,136,133,147,47,73,18,22]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s,i,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends A.Disposable{constructor(a,c){var h;super();this.logService=a,this.options=c,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new m.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:c,symbolicLink:h}=await f.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(c,h),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(a){try{const c=await(0,f.readdir)(this.toFilePath(a),{withFileTypes:!0}),h=[];return await Promise.all(c.map(async S=>{try{let I;S.isSymbolicLink()?I=(await this.stat((0,R.joinPath)(a,S.name))).type:I=this.toType(S),h.push([S.name,I])}catch(I){this.logService.trace(I)}})),h}catch(c){throw this.toFileSystemProviderError(c)}}toType(a,c){let h;return(c==null?void 0:c.dangling)?h=P.FileType.Unknown:a.isFile()?h=P.FileType.File:a.isDirectory()?h=P.FileType.Directory:h=P.FileType.Unknown,c&&(h|=P.FileType.SymbolicLink),h}async readFile(a){try{const c=this.toFilePath(a);return await v.promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(a,c,h){const S=(0,s.newWriteableStream)(I=>n.VSBuffer.concat(I.map(u=>n.VSBuffer.wrap(u))).buffer);return(0,i.readFileIntoStream)(this,a,S,I=>I.buffer,Object.assign(Object.assign({},c),{bufferSize:this.BUFFER_SIZE}),h),S}async writeFile(a,c,h){let S;try{const I=this.toFilePath(a);if(!h.create||!h.overwrite){if(await(0,f.exists)(I)){if(!h.overwrite)throw(0,P.createFileSystemProviderError)((0,o.localize)(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,P.createFileSystemProviderError)((0,o.localize)(1,null),P.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(a,{create:!0,unlock:h.unlock}),await this.write(S,0,c,0,c.byteLength)}catch(I){throw await this.toFileSystemProviderWriteError(a,I)}finally{typeof S=="number"&&await this.close(S)}}async open(a,c){try{const h=this.toFilePath(a);if((0,P.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(h);u.mode&128||await v.promises.chmod(h,u.mode|128)}catch(u){this.logService.trace(u)}let S;if((0,P.isFileOpenForWriteOptions)(c)){if(T.isWindows)try{await v.promises.truncate(h,0),S="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}S||(S="w")}else S="r";const I=await(0,U.promisify)(v.open)(h,S);return this.mapHandleToPos.set(I,0),(0,P.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(I,a),I}catch(h){throw(0,P.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(a,h):this.toFileSystemProviderError(h)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await(0,U.promisify)(v.fdatasync)(a)}catch(c){this.canFlush=!1,this.logService.error(c)}return await(0,U.promisify)(v.close)(a)}catch(c){throw this.toFileSystemProviderError(c)}}async read(a,c,h,S,I){const u=this.normalizePos(a,c);let L=null;try{const _=await(0,U.promisify)(v.read)(a,h,S,I,u);return typeof _=="number"?L=_:L=_.bytesRead,L}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(a,u,L)}}normalizePos(a,c){return c===this.mapHandleToPos.get(a)?null:c}updatePos(a,c,h){const S=this.mapHandleToPos.get(a);typeof S=="number"&&(typeof c=="number"||(typeof h=="number"?this.mapHandleToPos.set(a,S+h):this.mapHandleToPos.delete(a)))}async write(a,c,h,S,I){return(0,m.retry)(()=>this.doWrite(a,c,h,S,I),100,3)}async doWrite(a,c,h,S,I){const u=this.normalizePos(a,c);let L=null;try{const _=await(0,U.promisify)(v.write)(a,h,S,I,u);return typeof _=="number"?L=_:L=_.bytesWritten,L}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),_)}finally{this.updatePos(a,u,L)}}async mkdir(a){try{await v.promises.mkdir(this.toFilePath(a))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(a,c){try{const h=this.toFilePath(a);await this.doDelete(h,c)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(a,c){c.recursive?await(0,f.rimraf)(a,f.RimRafMode.MOVE):await v.promises.unlink(a)}async rename(a,c,h){const S=this.toFilePath(a),I=this.toFilePath(c);if(S!==I)try{await this.validateTargetDeleted(a,c,"move",h.overwrite),await(0,f.move)(S,I)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,o.localize)(2,null,(0,g.basename)(S),(0,g.basename)((0,g.dirname)(I)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(a,c,h){const S=this.toFilePath(a),I=this.toFilePath(c);if(S!==I)try{await this.validateTargetDeleted(a,c,"copy",h.overwrite),await(0,f.copy)(S,I,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,o.localize)(3,null,(0,g.basename)(S),(0,g.basename)((0,g.dirname)(I)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(a,c,h,S){const I=this.toFilePath(a),u=this.toFilePath(c);let L=!1;if(!!(this.capabilities&1024)||(L=(0,d.isEqual)(I,u,!0)),L&&h==="copy")throw(0,P.createFileSystemProviderError)((0,o.localize)(4,null),P.FileSystemProviderErrorCode.FileExists);if(!L&&await(0,f.exists)(u)){if(!S)throw(0,P.createFileSystemProviderError)((0,o.localize)(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(a,c){return c.recursive?this.watchRecursive(a,c.excludes):this.watchNonRecursive(a)}watchRecursive(a,c){const h={path:this.toFilePath(a),excludes:c},S=(0,t.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var a,c,h;if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let S,I;((c=(a=this.options)===null||a===void 0?void 0:a.watcher)===null||c===void 0?void 0:c.usePolling)?(S=E.FileWatcher,I=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?S=p.FileWatcher:S=E.FileWatcher:S=w.FileWatcher,this.recursiveWatcher=new S(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,C.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===b.LogLevel.Trace,I),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(a){const c=new y.FileWatcher(this.toFilePath(a),S=>this._onDidChangeFile.fire((0,C.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,A.combinedDisposable)(c,h)}toFilePath(a){return(0,g.normalize)(a.fsPath)}toFileSystemProviderError(a){if(a instanceof P.FileSystemProviderError)return a;let c;switch(a.code){case"ENOENT":c=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=P.FileSystemProviderErrorCode.NoPermissions;break;default:c=P.FileSystemProviderErrorCode.Unknown}return(0,P.createFileSystemProviderError)(a,c)}async toFileSystemProviderWriteError(a,c){let h=this.toFileSystemProviderError(c);if(a&&h.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(a));S.mode&128||(h=(0,P.createFileSystemProviderError)(c,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return h}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Z[158],ee([0,1,23,27,146,29,2,10,6,33,12,54,18,3,16,9]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let E=class extends k.Disposable{constructor(y,s,i){super();this.extensionManagementService=y,this.logService=i,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new p(s,i)),this._register(y.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(y.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(y=>{const s=["en",...Object.keys(y)];return(0,m.distinct)(s)})}onDidInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",y.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(y){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(i=>s[i]&&s[i].extensions.some(t=>(0,g.areSameExtensions)(t.extensionIdentifier,y)))&&(this.logService.debug("Removing language packs from the extension",y.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[y,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(s);return!(0,m.equals)(Object.keys(y),Object.keys(i))}};E=ue([Y(0,P.IExtensionManagementService),Y(1,T.INativeEnvironmentService),Y(2,R.ILogService)],E),e.LocalizationsService=E;let p=class extends k.Disposable{constructor(y,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(s=>{Object.keys(s).forEach(i=>delete s[i]),this.createLanguagePacksFromExtensions(s,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,i);Object.keys(y).forEach(i=>this.updateHash(y[i]))}createLanguagePacksFromExtension(y,s){const i=s.identifier,t=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const n of t)if(s.location.scheme===o.Schemas.file&&(0,d.isValidLocalization)(n)){let r=y[n.languageId];r||(r={hash:"",extensions:[],translations:{}},y[n.languageId]=r);let l=r.extensions.filter(a=>(0,g.areSameExtensions)(a.extensionIdentifier,i))[0];l?l.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const a of n.translations)r.translations[a.id]=(0,C.join)(s.location.fsPath,a.path)}}updateHash(y){if(y){const s=(0,A.createHash)("md5");for(const i of y.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);y.hash=s.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return U.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(t){return{}}}).then(i=>(s=y(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,v.writeFile)(this.languagePacksFilePath,t)}).then(()=>s,i=>this.logService.error(i))})}};p=ue([Y(0,T.INativeEnvironmentService),Y(1,R.ILogService)],p)}),define(Z[159],ee([0,1,12]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function U(P,k){switch(k){case v.LogLevel.Trace:return P.trace;case v.LogLevel.Debug:return P.debug;case v.LogLevel.Info:return P.info;case v.LogLevel.Warning:return P.warn;case v.LogLevel.Error:return P.error;case v.LogLevel.Critical:return P.critical;default:throw new Error("Invalid log level")}}class A extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(T=>{this._logger&&this._logger.setLevel(T)}))}set logger(k){this._logger=k;for(const{level:T,args:f}of this.buffer)U(k,T).apply(k,f);this.buffer=[]}_log(k,...T){this._logger?U(this._logger,k).apply(this._logger,T):this.getLevel()<=k&&this.buffer.push({level:k,args:T})}trace(k,...T){this._log(v.LogLevel.Trace,k,...T)}debug(k,...T){this._log(v.LogLevel.Debug,k,...T)}info(k,...T){this._log(v.LogLevel.Info,k,...T)}warn(k,...T){this._log(v.LogLevel.Warning,k,...T)}error(k,...T){this._log(v.LogLevel.Error,k,...T)}critical(k,...T){this._log(v.LogLevel.Critical,k,...T)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=A}),define(Z[160],ee([0,1,12,8,6,22,11,2,4,159]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const R=5*U.ByteSize.MB;let d=class extends v.AbstractLogger{constructor(o,C,E,p){super();this.name=o,this.resource=C,this.fileService=p,this.backupIndex=1,this.setLevel(E),this.queue=this._register(new A.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const o=arguments[0];if(o instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=o.stack,this._log(v.LogLevel.Error,this.format(C))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(o,C){this._log(o,this.format(C))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(o){if(o.fileOperationResult!==3)throw o}}_log(o,C){this.queue.queue(async()=>{await this.initializePromise;let E=await this.loadContent();E.length>R&&(await this.fileService.writeFile(this.getBackupResource(),P.VSBuffer.fromString(E)),E=""),E+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(o)}] ${C}
`,await this.fileService.writeFile(this.resource,P.VSBuffer.fromString(E))})}getCurrentTimestamp(){const o=p=>p<10?`0${p}`:p,C=p=>p<10?`00${p}`:p<100?`0${p}`:p,E=new Date;return`${E.getFullYear()}-${o(E.getMonth()+1)}-${o(E.getDate())} ${o(E.getHours())}:${o(E.getMinutes())}:${o(E.getSeconds())}.${C(E.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(o){return""}}stringifyLogLevel(o){switch(o){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(o){let C="";for(let E=0;E<o.length;E++){let p=o[E];if(typeof p=="object")try{p=JSON.stringify(p)}catch(w){}C+=(E>0?" ":"")+p}return C}};d=ue([Y(3,U.IFileService)],d),e.FileLogger=d;let m=class extends T.Disposable{constructor(o,C,E){super();this.logService=o,this.instantiationService=C,this.fileService=E,this.loggers=new Map,this._register(o.onDidChangeLogLevel(p=>this.loggers.forEach(w=>w.setLevel(p))))}createLogger(o){let C=this.loggers.get(o.toString());return C||(C=new g.BufferLogService(this.logService.getLevel()),this.loggers.set(o.toString(),C),(0,U.whenProviderRegistered)(o,this.fileService).then(()=>C.logger=this.instantiationService.createInstance(d,(0,k.basename)(o),o,this.logService.getLevel()))),C}dispose(){this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}};m=ue([Y(0,v.ILogService),Y(1,f.IInstantiationService),Y(2,U.IFileService)],m),e.FileLoggerService=m}),define(Z[76],ee([0,1,12,3,5]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(m){this.service=m,this.onDidChangeLogLevel=U.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(m,b,o){switch(b){case"setLevel":return this.service.setLevel(o)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=P;class k{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){k.setLevel(this.channel,m)}static setLevel(m,b){return m.call("setLevel",b)}}e.LogLevelChannelClient=k;class T{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,b){throw new Error(`Event not found: ${b}`)}async call(m,b,o){switch(b){case"createLogger":this.createLogger(A.URI.revive(o[0]),o[1]);return;case"log":return this.log(A.URI.revive(o[0]),o[1]);case"consoleLog":return this.consoleLog(o[0],o[1])}throw new Error(`Call not found: ${b}`)}createLogger(m,b){this.loggers.set(m.toString(),this.loggerService.createLogger(m,b))}consoleLog(m,b){let o=console.log;switch(m){case v.LogLevel.Error:o=console.error;break;case v.LogLevel.Warning:o=console.warn;break;case v.LogLevel.Info:o=console.info;break}o.call(console,...b)}log(m,b){const o=this.loggers.get(m.toString());if(!o)throw new Error("Create the logger before logging");for(const[C,E]of b)switch(C){case v.LogLevel.Trace:o.trace(E);break;case v.LogLevel.Debug:o.debug(E);break;case v.LogLevel.Info:o.info(E);break;case v.LogLevel.Warning:o.warn(E);break;case v.LogLevel.Error:o.error(E);break;case v.LogLevel.Critical:o.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=T;class f{constructor(m){this.channel=m}createConsoleMainLogger(){return new v.AdapterLogger({log:(m,b)=>{this.channel.call("consoleLog",[m,b])}})}createLogger(m,b){return new g(this.channel,m,b)}}e.LoggerChannelClient=f;class g extends v.AbstractMessageLogger{constructor(m,b,o){super(o==null?void 0:o.always);this.channel=m,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[b,o]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(m,b){this._log([[m,b]])}_log(m){this.isLoggerCreated?this.channel.call("log",[this.file,m]):this.buffer.push(...m)}}class R extends v.LogService{constructor(m,b){super(b);this.parent=m,this._register(m.onDidChangeLogLevel(o=>b.setLevel(o)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=R}),define(Z[77],ee([0,1,12,8]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(f,g,R,d){try{const m=await new Promise((b,o)=>{K(["spdlog"],b,o)});return m.setAsyncMode(8192,500),m.createRotatingLoggerAsync(f,g,R,d)}catch(m){console.error(m)}return null}function P(f,g,R,d){return K.__$__nodeRequire("spdlog").createRotatingLogger(f,g,R,d)}e.createRotatingLogger=P;function k(f,g,R){switch(g){case v.LogLevel.Trace:f.trace(R);break;case v.LogLevel.Debug:f.debug(R);break;case v.LogLevel.Info:f.info(R);break;case v.LogLevel.Warning:f.warn(R);break;case v.LogLevel.Error:f.error(R);break;case v.LogLevel.Critical:f.critical(R);break;default:throw new Error("Invalid log level")}}class T extends v.AbstractMessageLogger{constructor(g,R,d,m){super();this.name=g,this.filepath=R,this.rotating=d,this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const g=this.rotating?6:1,R=30/g*U.ByteSize.MB;return A(this.name,this.filepath,R,g).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:m,message:b}of this.buffer)k(this._logger,m,b);this.buffer=[]}})}log(g,R){this._logger?k(this._logger,g,R):this.getLevel()<=g&&this.buffer.push({level:g,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(Z[161],ee([0,1,12,2,11,16,160,77,8,31]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends U.Disposable{constructor(m,b){super();this.logService=m,this.fileService=b,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(m.onDidChangeLogLevel(o=>this.logLevelChangeableLoggers.forEach(C=>C.setLevel(o))))}createLogger(m,b){var o;let C=this.loggers.get(m.toString());return C||(m.scheme===P.Schemas.file?(C=new T.SpdLogLogger((b==null?void 0:b.name)||(0,g.generateUuid)(),m.fsPath,!(b==null?void 0:b.donotRotate),this.logService.getLevel()),(b==null?void 0:b.donotUseFormatters)&&C.clearFormatters()):C=new k.FileLogger((o=b==null?void 0:b.name)!==null&&o!==void 0?o:(0,A.basename)(m),m,this.logService.getLevel(),this.fileService),this.loggers.set(m.toString(),C),(b==null?void 0:b.always)?C.setLevel(v.LogLevel.Trace):this.logLevelChangeableLoggers.push(C)),C}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(m=>m.dispose()),this.loggers.clear(),super.dispose()}};R=ue([Y(0,v.ILogService),Y(1,f.IFileService)],R),e.LoggerService=R}),define(Z[56],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,v.createDecorator)("nativeHostService")}),define(Z[57],ee([0,1,16,7,36,11]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(U.isWeb||typeof K=="undefined"||typeof K.__$__nodeRequire!="function")k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.55.0-dev",nameShort:U.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:U.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const T=(0,P.dirname)(v.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,P.joinPath)(T,"product.json").fsPath);const f=K.__$__nodeRequire((0,P.joinPath)(T,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:f.version})}e.default=k}),define(Z[28],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Z[162],ee([0,1,27,9,23,28,2,13,12,10]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends k.Disposable{constructor(m,b,o){super();this._environmentService=m,this._logService=b,this._productService=o,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let m=setTimeout(async()=>{m=void 0,this._logService.info("Starting to clean up unused language packs.");try{const b=Object.create(null),o=JSON.parse(await v.promises.readFile(U.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(o)){const y=o[w];b[`${y.hash}.${w}`]=!0}const C=U.join(this._environmentService.userDataPath,"clp");if(!await A.exists(C))return;for(let w of await A.readdir(C)){if(b[w]){this._logService.info(`Skipping directory ${w}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",w),await A.rimraf(U.join(C,w))}const p=Date.now();for(let w of Object.keys(b)){const y=U.join(C,w);for(let s of await A.readdir(y))if(s!=="tcf.json"){const i=U.join(y,s),t=await v.promises.stat(i);t.isDirectory()&&p-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",U.join(w,s)),await A.rimraf(i))}}}catch(b){(0,T.onUnexpectedError)(b)}},40*1e3);this._register((0,k.toDisposable)(()=>{m!==void 0&&clearTimeout(m)}))}};R=ue([Y(0,g.INativeEnvironmentService),Y(1,f.ILogService),Y(2,P.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(Z[163],ee([0,1,27,9,13,2,23,28]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let f=class{constructor(R,d){this.nodeCachedDataDir=R,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new P.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const R=(0,U.dirname)(this.nodeCachedDataDir),d=(0,U.basename)(this.nodeCachedDataDir);let m=setTimeout(()=>{m=void 0,(0,k.readdir)(R).then(b=>{const o=Date.now(),C=[];return b.forEach(E=>{if(E!==d){const p=(0,U.join)(R,E);C.push(v.promises.stat(p).then(w=>{if(w.isDirectory()&&o-w.mtime.getTime()>this._DataMaxAge)return(0,k.rimraf)(p)}))}}),Promise.all(C)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,P.toDisposable)(()=>{m&&(clearTimeout(m),m=void 0)}))}}};f=ue([Y(1,T.IProductService)],f),e.NodeCachedDataCleaner=f}),define(Z[35],ee([0,1,17,85]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(k,T){U.ok(v.isString(k)),U.ok(v.isObject(T)),U.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,T)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new A}),define(Z[78],ee([0,1,35,3]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new U.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,g){this.schemasById[A(f)]=g,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new P;v.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[39],ee([0,1,107,3,35,17,78]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=A.Registry.as(k.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new U.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new U.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,w=!0){this.registerConfigurations([p],w)}registerConfigurations(p,w=!0){const y=[];p.forEach(s=>{y.push(...this.validateAndRegisterProperties(s,w)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterConfigurations(p){const w=[],y=s=>{if(s.properties)for(const i in s.properties)w.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>y(i))};for(const s of p){y(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(p){const w=[],y=[];for(const s of p)for(const i in s)if(w.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),s[i]);const t={type:"object",default:this.defaultValues[i],description:v.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};y.push(d(i)),this.configurationProperties[i]=t,this.defaultLanguageConfigurationOverridesNode.properties[i]=t}else{this.defaultValues[i]=s[i];const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.registerOverrideIdentifiers(y),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(p){const w=[];for(const y of p)for(const s in y)if(w.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const i=this.configurationProperties[s];i&&(this.updatePropertyDefaultValue(s,i),this.updateSchema(s,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const w of p)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,w=!0,y=3){y=P.isUndefinedOrNull(p.scope)?y:p.scope;let s=[],i=p.properties;if(i)for(let n in i){if(w&&o(n)){delete i[n];continue}const r=i[n];if(this.updatePropertyDefaultValue(n,r),e.OVERRIDE_PROPERTY_PATTERN.test(n)?r.scope=void 0:r.scope=P.isUndefinedOrNull(r.scope)?y:r.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),s.push(n)}let t=p.allOf;if(t)for(let n of t)s.push(...this.validateAndRegisterProperties(n,w,y));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const w=y=>{let s=y.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let i=y.allOf;i&&i.forEach(w)};w(p)}updateSchema(p,w){switch(e.allSettings.properties[p]=w,w.scope){case 1:e.applicationSettings.properties[p]=w;break;case 2:e.machineSettings.properties[p]=w;break;case 6:e.machineOverridableSettings.properties[p]=w;break;case 3:e.windowSettings.properties[p]=w;break;case 4:e.resourceSettings.properties[p]=w;break;case 5:e.resourceSettings.properties[p]=w,this.resourceLanguageSettingsSchema.properties[p]=w;break}}removeFromSchema(p,w){switch(delete e.allSettings.properties[p],w.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const w=`[${p}]`,y={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,y),e.allSettings.properties[w]=y,e.applicationSettings.properties[w]=y,e.machineSettings.properties[w]=y,e.machineOverridableSettings.properties[w]=y,e.windowSettings.properties[w]=y,e.resourceSettings.properties[w]=y}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,w){let y=this.defaultValues[p];P.isUndefined(y)&&(y=w.default),P.isUndefined(y)&&(y=m(w.type)),w.default=y}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function d(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=d;function m(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const b=new g;A.Registry.add(e.Extensions.Configuration,b);function o(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?v.localize(5,null,E):b.getConfigurationProperties()[E]!==void 0?v.localize(6,null,E):null:v.localize(4,null)}e.validateProperty=o;function C(){const E=[],p=b.getConfigurationProperties();for(const w of Object.keys(p))E.push([w,p[w].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=C}),define(Z[24],ee([0,1,26,17,5,35,4,39]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function f(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=f;var g;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function d(n,r){const l=r?n?r.keys.filter(L=>n.keys.indexOf(L)===-1):[...r.keys]:[],a=n?r?n.keys.filter(L=>r.keys.indexOf(L)===-1):[...n.keys]:[],c=[];if(r&&n){for(const L of n.keys)if(r.keys.indexOf(L)!==-1){const _=p(n.contents,L),$=p(r.contents,L);v.equals(_,$)||c.push(L)}}const h=[],S=L=>{const _={};for(const $ of L)for(const B of $.identifiers)_[i(B)]=$;return _},I=r?S(r.overrides):{},u=n?S(n.overrides):{};if(Object.keys(I).length)for(const L of l){const _=I[L];_&&h.push([(0,T.overrideIdentifierFromKey)(L),_.keys])}if(Object.keys(u).length)for(const L of a){const _=u[L];_&&h.push([(0,T.overrideIdentifierFromKey)(L),_.keys])}if(Object.keys(I).length&&Object.keys(u).length)for(const L of c){const _=u[L],$=I[L];if(_&&$){const B=d({contents:_.contents,keys:_.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});h.push([(0,T.overrideIdentifierFromKey)(L),[...B.added,...B.removed,...B.updated]])}}return{added:l,removed:a,updated:c,overrides:h}}e.compare=d;function m(n,r){const l=[];for(const a of Object.keys(n))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const c={};for(const h in n[a])c[h]=n[a][h];l.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(c),contents:b(c,r)})}return l}e.toOverrides=m;function b(n,r){const l=Object.create(null);for(let a in n)o(l,a,n[a],r);return l}e.toValuesTree=b;function o(n,r,l,a){const c=r.split("."),h=c.pop();let S=n;for(let I=0;I<c.length;I++){let u=c[I],L=S[u];switch(typeof L){case"undefined":L=S[u]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${c.slice(0,I+1).join(".")} is ${JSON.stringify(L)}`);return}S=L}if(typeof S=="object"&&S!==null)try{S[h]=l}catch(I){a(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(S)}`)}else a(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=o;function C(n,r){const l=r.split(".");E(n,l)}e.removeFromValueTree=C;function E(n,r){const l=r.shift();if(r.length===0){delete n[l];return}if(Object.keys(n).indexOf(l)!==-1){const a=n[l];typeof a=="object"&&!Array.isArray(a)&&(E(a,r),Object.keys(a).length===0&&delete n[l])}}function p(n,r,l){function a(S,I){let u=S;for(const L of I){if(typeof u!="object"||u===null)return;u=u[L]}return u}const c=r.split("."),h=a(n,c);return typeof h=="undefined"?l:h}e.getConfigurationValue=p;function w(n,r,l){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in n?U.isObject(n[a])&&U.isObject(r[a])?w(n[a],r[a],l):l&&(n[a]=r[a]):n[a]=r[a])})}e.merge=w;function y(){const n=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=y;function s(){const n=Object.create(null),r=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let l in r){let a=r[l].default;o(n,l,a,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=s;function i(n){return`[${n}]`}e.keyFromOverrideIdentifier=i;function t(n,r,l){const a=n.inspect(r),c=n.inspect(l);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:a.defaultValue}e.getMigratedSettingValue=t}),define(Z[164],ee([0,1,32,37,18,17,26,5,39,24,35,2,3]),function(K,e,v,U,A,P,k,T,f,g,R,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,g.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,g.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const l of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[l],c=n[l];c&&(typeof a=="object"&&typeof c=="object"?(a=k.deepClone(a),this.mergeContents(a,c)):a=c),r[l]=a}return new b(r,this.keys,this.overrides)}merge(...t){const n=k.deepClone(this.contents),r=k.deepClone(this.overrides),l=[...this.keys];for(const a of t){this.mergeContents(n,a.contents);for(const c of a.overrides){const[h]=r.filter(S=>A.equals(S.identifiers,c.identifiers));h?this.mergeContents(h.contents,c.contents):r.push(k.deepClone(c))}for(const c of a.keys)l.indexOf(c)===-1&&l.push(c)}return new b(n,l,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&P.isObject(t[r])&&P.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=k.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,g.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,g.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=b;class o extends b{constructor(){const t=(0,g.getDefaultValues)(),n=(0,g.getConfigurationKeys)(),r=[];for(const l of Object.keys(t))f.OVERRIDE_PROPERTY_PATTERN.test(l)&&r.push({identifiers:[(0,f.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(t[l]),contents:(0,g.toValuesTree)(t[l],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,n,r)}}e.DefaultConfigurationModel=o;class C{constructor(t,n){this._name=t,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n)}}parseRaw(t){this._raw=t;const n=this.doParseRaw(t);this._configurationModel=new b(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let n={},r=null,l=[],a=[],c=[];function h(I){Array.isArray(l)?l.push(I):r&&(l[r]=I)}let S={onObjectBegin:()=>{let I={};h(I),a.push(l),l=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{l=a.pop()},onArrayBegin:()=>{let I=[];h(I),a.push(l),l=I,r=null},onArrayEnd:()=>{l=a.pop()},onLiteralValue:h,onError:(I,u,L)=>{c.push({error:I,offset:u,length:L})}};if(t)try{v.visit(t,S),n=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return n}doParseRaw(t){if(this._scopes){const a=R.Registry.as(f.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,a,!0,this._scopes)}const n=(0,g.toValuesTree)(t,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),r=Object.keys(t),l=(0,g.toOverrides)(t,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:n,keys:r,overrides:l}}filterByScope(t,n,r,l){const a={};for(let c in t)if(f.OVERRIDE_PROPERTY_PATTERN.test(c)&&r)a[c]=this.filterByScope(t[c],n,!1,l);else{const h=this.getScope(c,n);(h===void 0||l.indexOf(h)!==-1)&&(a[c]=t[c])}return a}getScope(t,n){const r=n[t];return r?typeof r.scope!="undefined"?r.scope:3:void 0}}e.ConfigurationModelParser=C;class E extends d.Disposable{constructor(t,n,r,l){super();this.userSettingsResource=t,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(m.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new b}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=E;class p{constructor(t,n,r=new b,l=new b,a=new U.ResourceMap,c=new b,h=new U.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=l,this._folderConfigurations=a,this._memoryConfiguration=c,this._memoryConfigurationByResource=h,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new U.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let l;r.resource?(l=this._memoryConfigurationByResource.get(r.resource),l||(l=new b,this._memoryConfigurationByResource.set(r.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(t):l.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const l=this.getConsolidateConfigurationModel(n,r),a=this.getFolderConfigurationModelForResource(n.resource,r),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),I=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,$=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),B=l.getValue(t),M=A.distinct(A.flatten(l.overrides.map(j=>j.identifiers))).filter(j=>l.getOverrideValue(t,j)!==void 0);return{defaultValue:h,userValue:S,userLocalValue:I,userRemoteValue:u,workspaceValue:L,workspaceFolderValue:_,memoryValue:$,value:B,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:n.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(l=>f.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const a=(0,f.overrideIdentifierFromKey)(l),c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),h=t.getKeysForOverrideIdentifier(a),S=[...h.filter(I=>c.indexOf(I)===-1),...c.filter(I=>h.indexOf(I)===-1),...c.filter(I=>!k.equals(this._defaultConfiguration.override(a).getValue(I),t.override(a).getValue(I)))];return[a,S]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:l,overrides:a}=(0,g.compare)(this.localUserConfiguration,t),c=[...n,...r,...l];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:l,overrides:a}=(0,g.compare)(this.remoteUserConfiguration,t);let c=[...n,...r,...l];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:l,overrides:a}=(0,g.compare)(this.workspaceConfiguration,t);let c=[...n,...r,...l];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:l,updated:a,removed:c,overrides:h}=(0,g.compare)(r,n);let S=[...l,...a,...c];return(S.length||!r)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:l,removed:a,overrides:c}=(0,g.compare)(n,void 0);return{keys:[...r,...l,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const l=n.getFolder(t);l&&(r=this.getFolderConsolidatedConfiguration(l.uri)||r);const a=this._memoryConfigurationByResource.get(t);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(n=r.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:l,keys:a}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:l,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((c,h)=>(c.set(T.URI.revive(h[0]),this.parseConfigurationModel(h[1])),c),new U.ResourceMap);return new p(n,r,new b,l,a,new b,new U.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function w(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const t=new Set,n=new Map;for(const l of i)l.keys.forEach(a=>t.add(a)),l.overrides.forEach(([a,c])=>{const h=(0,U.getOrSet)(n,a,new Set);c.forEach(S=>h.add(S))});const r=[];return n.forEach((l,a)=>r.push([a,[...l.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=w;class y{constructor(t,n,r,l){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=l,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(h=>a.add(h)),t.overrides.forEach(([,h])=>h.forEach(S=>a.add(S))),this.affectedKeys=[...a.values()];const c=new b;this.affectedKeys.forEach(h=>c.setValue(h,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,a=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!k.equals(l,a)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,g.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof r=="object"&&(l=Object.keys(r)[0]);){if(t=t[l],!t)return!1;r=r[l]}return!0}}e.ConfigurationChangeEvent=y;class s extends y{constructor(t,n,r,l){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=s}),define(Z[165],ee([0,1,35,39,2,24,164,3,6,11]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends A.Disposable{constructor(m,b){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,b)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(U.Extensions.Configuration).onDidUpdateConfiguration(o=>this.onDidDefaultConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,b){const o=typeof m=="string"?m:void 0,C=(0,P.isConfigurationOverrides)(m)?m:(0,P.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(o,C,void 0)}updateValue(m,b,o,C){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const b=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(o,b,1)}onDidDefaultConfigurationChange(m){const b=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,m);this.trigger(o,b,6)}trigger(m,b,o){const C=new k.ConfigurationChangeEvent(m,{data:b},this.configuration);C.source=o,C.sourceConfig=this.getTargetConfiguration(o),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(Z[166],ee([0,1,24,12,101]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let P=class{constructor(T,f){this.configurationService=T,this.logService=f}request(T,f){return this.logService.trace("RequestService#request",T.url),T.proxyAuthorization||(T.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(T,f)}async resolveProxy(T){}};P=ue([Y(0,v.IConfigurationService),Y(1,U.ILogService)],P),e.RequestService=P}),define(Z[40],ee([0,1,118,4,39,35,22]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,U.createDecorator)("requestService");function T(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=T;function f(d){return d.res.statusCode===204}async function g(d){if(!T(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,k.streamToBuffer)(d.stream)).toString()}e.asText=g;async function R(d){if(!T(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const b=(await(0,k.streamToBuffer)(d.stream)).toString();try{return JSON.parse(b)}catch(o){throw o.message+=`:
`+b,o}}e.asJson=R,P.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,v.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null)],default:"override",description:(0,v.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(8,null)}}})}),define(Z[167],ee([0,1,40,30,8,16]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(f,g){this.requestService=f,this.fileService=g}async download(f,g,R=U.CancellationToken.None){if(f.scheme===P.Schemas.file||f.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(f,g);return}const d={type:"GET",url:f.toString()},m=await this.requestService.request(d,R);if(m.res.statusCode===200)await this.fileService.writeFile(g,m.stream);else{const b=await(0,v.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${b}`)}}};k=ue([Y(0,v.IRequestService),Y(1,A.IFileService)],k),e.DownloadService=k}),define(Z[168],ee([0,1,28,8,18,62,40,30,12,11,129,2]),function(K,e,v,U,A,P,k,T,f,g,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends d.Disposable{constructor(o,C,E,p){super();this.fileService=o,this.productService=C,this.requestService=E,this.logService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,P.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(o){return this.getValidConfigBasedTips(o)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(o){const C=[];for(const[E,p]of this.allConfigBasedTips)try{const w=await this.fileService.readFile((0,g.joinPath)(o,E)),y=new Map;(0,P.forEach)(p.recommendations,({key:i,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const n of t.remotes)y.set(n,{extensionId:i,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:i,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,R.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const i of s){const t=y.get(i);t&&C.push(t)}}catch(w){}return C}async fetchWorkspacesTips(){var o,C;if(!((o=this.productService.extensionsGallery)===null||o===void 0?void 0:o.recommendationsUrl))return[];try{const E=await this.requestService.request({type:"GET",url:(C=this.productService.extensionsGallery)===null||C===void 0?void 0:C.recommendationsUrl},T.CancellationToken.None);if(E.res.statusCode!==200)return[];const p=await(0,k.asJson)(E);return p?p.workspaceRecommendations||[]:[]}catch(E){return this.logService.error(E),[]}}};m=ue([Y(0,U.IFileService),Y(1,v.IProductService),Y(2,k.IRequestService),Y(3,f.ILogService)],m),e.ExtensionTipsService=m}),define(Z[44],ee([0,1,31,22]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(P,k,T){let f=T&&T.get("storage.serviceMachineId",0)||null;if(f)return f;try{const R=(await k.readFile(P.serviceMachineIdResource)).value.toString();f=(0,v.isUUID)(R)?R:null}catch(g){f=null}if(!f){f=(0,v.generateUuid)();try{await k.writeFile(P.serviceMachineIdResource,U.VSBuffer.fromString(f))}catch(g){}}return T&&T.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=A}),define(Z[19],ee([0,1,4,3,2,17,67,6]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var g;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var d;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class m extends A.Disposable{constructor(E={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new U.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new U.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new U.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,p){p===f?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:p,target:this.getKeyTargets(E)[p]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,p,w){var y;return(y=this.getStorage(p))===null||y===void 0?void 0:y.get(E,w)}getBoolean(E,p,w){var y;return(y=this.getStorage(p))===null||y===void 0?void 0:y.getBoolean(E,w)}getNumber(E,p,w){var y;return(y=this.getStorage(p))===null||y===void 0?void 0:y.getNumber(E,w)}store(E,p,w,y){if((0,P.isUndefinedOrNull)(p)){this.remove(E,w);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(E,w,y),(s=this.getStorage(w))===null||s===void 0||s.set(E,p)})}remove(E,p){this.withPausedEmitters(()=>{var w;this.updateKeyTarget(E,p,void 0),(w=this.getStorage(p))===null||w===void 0||w.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,p){const w=[],y=this.getKeyTargets(E);for(const s of Object.keys(y))y[s]===p&&w.push(s);return w}updateKeyTarget(E,p,w){var y,s;const i=this.getKeyTargets(p);typeof w=="number"?i[E]!==w&&(i[E]=w,(y=this.getStorage(p))===null||y===void 0||y.set(f,JSON.stringify(i))):typeof i[E]=="number"&&(delete i[E],(s=this.getStorage(p))===null||s===void 0||s.set(f,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const p=this.get(f,E);if(p)try{return JSON.parse(p)}catch(w){}return Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(){var E,p,w,y;this._onWillSaveState.fire({reason:g.NONE}),await T.Promises.settled([(p=(E=this.getStorage(0))===null||E===void 0?void 0:E.whenFlushed())!==null&&p!==void 0?p:Promise.resolve(),(y=(w=this.getStorage(1))===null||w===void 0?void 0:w.whenFlushed())!==null&&y!==void 0?y:Promise.resolve()])}async logStorage(){var E,p,w,y,s,i;const t=(p=(E=this.getStorage(0))===null||E===void 0?void 0:E.items)!==null&&p!==void 0?p:new Map,n=(y=(w=this.getStorage(1))===null||w===void 0?void 0:w.items)!==null&&y!==void 0?y:new Map;return o(t,n,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends m{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}e.InMemoryStorageService=b;async function o(C,E,p,w){const y=a=>{try{return JSON.parse(a)}catch(c){return a}},s=new Map,i=new Map;C.forEach((a,c)=>{s.set(c,a),i.set(c,y(a))});const t=new Map,n=new Map;E.forEach((a,c)=>{t.set(c,a),n.set(c,y(a))}),console.group(`Storage: Global (path: ${p})`);let r=[];s.forEach((a,c)=>{r.push({key:c,value:a})}),console.table(r),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${w})`);let l=[];t.forEach((a,c)=>{l.push({key:c,value:a})}),console.table(l),console.groupEnd(),console.log(n)}e.logStorage=o}),define(Z[169],ee([0,1,3,2,29,33,19,17]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let f=class extends U.Disposable{constructor(d){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new g(d)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(d,m){return this._removeFromDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:m}),!0):!1}async disableExtension(d,m){return this._addToDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(d){let m=this.getDisabledExtensions();return m.every(b=>!(0,P.areSameExtensions)(b,d))?(m.push(d),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(d){let m=this.getDisabledExtensions();for(let b=0;b<m.length;b++){const o=m[b];if((0,P.areSameExtensions)(o,d))return m.splice(b,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(d){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,d)}_getExtensions(d){return this.storageManger.get(d,0)}_setExtensions(d,m){this.storageManger.set(d,m,0)}};f=ue([Y(0,k.IStorageService)],f),e.GlobalExtensionEnablementService=f;class g extends U.Disposable{constructor(d){super();this.storageService=d,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(d.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(d,m){let b;return m===0?((0,T.isUndefinedOrNull)(this.storage[d])&&(this.storage[d]=this._get(d,m)),b=this.storage[d]):b=this._get(d,m),JSON.parse(b)}set(d,m,b){let o=JSON.stringify(m.map(({id:E,uuid:p})=>({id:E,uuid:p})));this._get(d,b)!==o&&(b===0&&(m.length?this.storage[d]=o:delete this.storage[d]),this._set(d,m.length?o:void 0,b))}onDidStorageChange(d){if(d.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[d.key])&&this._get(d.key,d.scope)!==this.storage[d.key]){const b=this.get(d.key,d.scope);delete this.storage[d.key];const o=this.get(d.key,d.scope),C=b.filter(p=>!o.some(w=>(0,P.areSameExtensions)(p,w))),E=o.filter(p=>!b.some(w=>(0,P.areSameExtensions)(w,p)));(C.length||E.length)&&this._onDidChange.fire([...C,...E])}}_get(d,m){return this.storageService.get(d,m,"[]")}_set(d,m,b){m?this.storageService.store(d,m,b,1):this.storageService.remove(d,b)}}e.StorageManager=g}),define(Z[170],ee([0,1,3,2]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends U.Disposable{constructor(g,R){super();this.channel=g,this.workspace=R}async getItems(){const g={workspace:this.workspace},R=await this.channel.call("getItems",g);return new Map(R)}updateItems(g){const R={workspace:this.workspace};return g.insert&&(R.insert=Array.from(g.insert.entries())),g.delete&&(R.delete=Array.from(g.delete.values())),this.channel.call("updateItems",R)}}class P extends A{constructor(g){super(g,void 0);this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(g=>this.onDidChangeGlobalStorage(g)))}onDidChangeGlobalStorage(g){(Array.isArray(g.changed)||Array.isArray(g.deleted))&&this._onDidChangeItemsExternal.fire({changed:g.changed?new Map(g.changed):void 0,deleted:g.deleted?new Set(g.deleted):void 0})}async close(){this.dispose()}}class k extends A{constructor(g,R){super(g,R);this.onDidChangeItemsExternal=v.Event.None}async close(){const g={workspace:this.workspace};return this.channel.call("close",g)}}class T extends U.Disposable{constructor(g,R){super();this.channel=g,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new P(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=T}),define(Z[171],ee([0,1,2,19,67,6,156,170,11]),function(K,e,v,U,A,P,k,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class g extends U.AbstractStorageService{constructor(d,m,b){super();this.mainProcessService=m,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new v.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(d)}createGlobalStorage(){const d=new T.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new A.Storage(d.globalStorage);return this._register(m.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),m}createWorkspaceStorage(d){const m=new T.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),d);if(m.workspaceStorage){const b=new A.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(o=>this.emitDidChangeValue(1,o)),this.workspaceStorageId=d==null?void 0:d.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var d,m;(0,k.mark)("code/willInitStorage");try{await P.Promises.settled([this.globalStorage.init(),(m=(d=this.workspaceStorage)===null||d===void 0?void 0:d.init())!==null&&m!==void 0?m:Promise.resolve()])}finally{(0,k.mark)("code/didInitStorage")}}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,f.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var d,m;this.stopFlushWhenIdle(),this.emitWillSaveState(U.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.globalStorage.close(),(m=(d=this.workspaceStorage)===null||d===void 0?void 0:d.close())!==null&&m!==void 0?m:Promise.resolve()])}async migrate(d){var m;const b=this.workspaceStorage,o=(m=b==null?void 0:b.items)!==null&&m!==void 0?m:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(d),await this.workspaceStorage.init();for(const[C,E]of o)this.workspaceStorage.set(C,E)}}e.NativeStorageService=g}),define(Z[172],ee([0,1,7,36,31,5]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function k(f,g,R,d,m,b,o,C,E){const p=Object.create(null);p["common.machineId"]=b,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=d,p.version=m,p["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,v.PlatformToString)(v.platform),p["common.nodePlatform"]=U.platform,p["common.nodeArch"]=R,p["common.product"]=E||"desktop";const w=T(o||[]);w&&(p["common.msftInternal"]=w);let y=0;const s=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),v.isLinuxSnap&&(p["common.snap"]="true");try{const i=await f.readFile(P.URI.file(C));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}e.resolveCommonProperties=k;function T(f){const g=U.env.USERDNSDOMAIN;if(!g)return!1;const R=g.toLowerCase();return f.some(d=>R===d)}}),define(Z[25],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[173],ee([0,1,38,93,69,27,9,32,96,28,7,5,25,52,16,8,23]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(t,n){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],l=new Map,a=new Map,c=2e4;function h(u,L,_,$){const B=L.substring(u.length+1);return new Promise(async M=>{var j,W,z;let H;try{H=await(0,E.readdir)(L,{withFileTypes:!0})}catch(O){M();return}if($.count>=c){$.count+=H.length,$.maxReached=!0,M();return}let q=H.length;if(q===0){M();return}let D=H;$.count+H.length>c&&($.maxReached=!0,q=c-$.count,D=H.slice(0,q)),$.count+=H.length;for(const O of D)if(O.isDirectory()){if(_.includes(O.name)||await h(u,(0,k.join)(L,O.name),_,$),--q==0){M();return}}else{const F=O.name.lastIndexOf(".");if(F>=0){const N=O.name.substring(F+1);N&&l.set(N,((j=l.get(N))!==null&&j!==void 0?j:0)+1)}for(const N of r)((W=N.relativePathPattern)===null||W===void 0?void 0:W.test(B))!==!1&&N.filePattern.test(O.name)&&a.set(N.tag,((z=a.get(N.tag))!==null&&z!==void 0?z:0)+1);if(--q==0){M();return}}})}const S={count:0,maxReached:!1};await h(t,t,n,S);const I=await s(t);return{configFiles:w(a),fileTypes:w(l),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:I}}e.collectWorkspaceStats=p;function w(t){return[...b.Iterable.map(t.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function y(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(U.virtualMachineHint.value()*100)}%`},n=v.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=y;function s(t){let n=new Map,r=(0,k.join)(t,".vscode","launch.json");return new Promise((l,a)=>{(0,P.exists)(r,c=>{if(c)(0,P.readFile)(r,(h,S)=>{if(h)return l([]);const I=[],u=(0,T.parse)(S.toString(),I);if(I.length)return console.log(`Unable to parse ${r}`),l([]);if((0,T.getNodeType)(u)==="object"&&u.configurations)for(const L of u.configurations){const _=L.type;_&&(n.has(_)?n.set(_,n.get(_)+1):n.set(_,1))}return l(w(n))});else return l([])})})}e.collectLaunchConfigs=s;let i=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const l=v.cpus();return l&&l.length>0&&r.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||r.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(U.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,f.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async l=>{let[a,c]=l,h=this.formatProcessList(n,a);return r.forEach(S=>{if((0,A.isRemoteDiagnosticError)(S))h+=`
${S.errorMessage}`,c+=`
${S.errorMessage}`;else if(h+=`

Remote: ${S.hostName}`,S.processes&&(h+=`
${this.formatProcessList(n,S.processes)}`),S.workspaceMetadata){c+=`
|  Remote: ${S.hostName}`;for(const I of Object.keys(S.workspaceMetadata)){const u=S.workspaceMetadata[I];let L=`${u.fileCount} files`;u.maxFilesReached&&(L=`more than ${L}`),c+=`|    Folder (${I}): ${L}`,c+=this.formatWorkspaceStats(u)}}}),{processInfo:h,workspaceInfo:c}})}async getSystemInfo(n,r){const{memory:l,vmHint:a,os:c,cpus:h}=y(),S={os:c,memory:l,cpus:h,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return R.isWindows||(S.load=`${v.loadavg().map(I=>Math.round(I)).join(", ")}`),R.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(n,r){const l=[];return(0,f.listProcesses)(n.mainPID).then(async a=>(l.push(""),l.push(this.formatEnvironment(n)),l.push(""),l.push(this.formatProcessList(n,a)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.formatWorkspaceMetadata(n))),r.forEach(c=>{if((0,A.isRemoteDiagnosticError)(c))l.push(`
${c.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${c.hostName}`),l.push(this.formatMachineInfo(c.machineInfo)),c.processes&&l.push(this.formatProcessList(n,c.processes)),c.workspaceMetadata)for(const h of Object.keys(c.workspaceMetadata)){const S=c.workspaceMetadata[h];let I=`${S.fileCount} files`;S.maxFilesReached&&(I=`more than ${I}`),l.push(`Folder (${h}): ${I}`),l.push(this.formatWorkspaceStats(S))}}),l.push(""),l.push(""),l.join(`
`)))}formatWorkspaceStats(n){const r=[],l=60;let a=0;const c=(u,L)=>{const _=` ${u}(${L})`;a+_.length>l?(r.push(h),h="|                 ",a=h.length):a+=_.length,h+=_};let h="|      File types:";const S=10;let I=n.fileTypes.length>S?S:n.fileTypes.length;for(let u=0;u<I;u++){const L=n.fileTypes[u];c(L.name,L.count)}if(r.push(h),n.configFiles.length>=0&&(h="|      Conf files:",a=0,n.configFiles.forEach(u=>{c(u.name,u.count)}),r.push(h)),n.launchConfigFiles.length>0){let u="|      Launch Configs:";n.launchConfigFiles.forEach(L=>{u+=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`}),r.push(u)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(l=>l.length));return Object.keys(n).map(l=>`${l}:  ${" ".repeat(r-l.length)}  ${n[l]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],l=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const h=d.URI.revive(c);if(h.scheme===o.Schemas.file){const S=h.fsPath;l.push(p(S,["node_modules",".git"]).then(I=>{let u=`${I.fileCount} files`;I.maxFilesReached&&(u=`more than ${u}`),r.push(`|    Folder (${(0,k.basename)(S)}): ${u}`),r.push(this.formatWorkspaceStats(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${S} (${I.toString()})`)}))}else r.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,r){const l=new Map;n.windows.forEach(c=>l.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,l,a,r,0),a.join(`
`)}formatProcessItem(n,r,l,a,c){const h=c===0;let S;h?S=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(S=`${S} (${r.get(a.pid)})`));const I=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);l.push(`${a.load.toFixed(0).padStart(5," ")}	${(I/C.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(a.children)&&a.children.forEach(u=>this.formatProcessItem(n,r,l,u,c+1))}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const l=d.URI.revive(r);if(l.scheme===o.Schemas.file){const a=l.fsPath;try{const c=await p(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),c.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),c.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})})}catch(c){}}}}};i=ue([Y(0,m.ITelemetryService),Y(1,g.IProductService)],i),e.DiagnosticsService=i}),define(Z[174],ee([0,1,13,29,33,26,25,40,68,10,30,12,8,5,28,19,44,4,11]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var y;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(y||(y={}));function s(...D){return String(D.reduce((O,F)=>O|F,0))}var i;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:y.None,criteria:[],assetTypes:[]};class a{constructor(O=l){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,F=this.state.pageSize){return new a(Object.assign(Object.assign({},this.state),{pageNumber:O,pageSize:F}))}withFilter(O,...F){const N=[...this.state.criteria,...F.length?F.map(V=>({filterType:O,value:V})):[{filterType:O}]];return new a(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(O){return new a(Object.assign(Object.assign({},this.state),{sortBy:O}))}withSortOrder(O){return new a(Object.assign(Object.assign({},this.state),{sortOrder:O}))}withFlags(...O){return new a(Object.assign(Object.assign({},this.state),{flags:O.reduce((F,N)=>F|N,0)}))}withAssetTypes(...O){return new a(Object.assign(Object.assign({},this.state),{assetTypes:O}))}get raw(){const{criteria:O,pageNumber:F,pageSize:N,sortBy:V,sortOrder:G,flags:Q,assetTypes:X}=this.state;return{filters:[{criteria:O,pageNumber:F,pageSize:N,sortBy:V,sortOrder:G}],assetTypes:X,flags:Q}}get searchText(){const O=this.state.criteria.filter(F=>F.filterType===i.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(D,O){const F=(D||[]).filter(N=>N.statisticName===O)[0];return F?F.value:0}function h(D){const O="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(N=>N.assetType.indexOf(O)===0).reduce((N,V)=>{const G=L(D,V.assetType);return G&&N.push([V.assetType.substring(O.length),G]),N},[])}function S(D){if(D.properties){const O=D.properties.filter(V=>V.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=O.filter(V=>F.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return L(D,t.Repository)}function I(D){return{uri:`${D.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${D.fallbackAssetUri}/${t.VSIX}`}}function u(D){const O=L(D,t.Icon);if(O)return O;const F=U.DefaultIconPath;return{uri:F,fallbackUri:F}}function L(D,O){return D.files.filter(N=>N.assetType===O)[0]?{uri:`${D.assetUri}/${O}`,fallbackUri:`${D.fallbackAssetUri}/${O}`}:null}function _(D,O){const F=D.properties?D.properties.filter(V=>V.key===O):[],N=F.length>0&&F[0].value;return N?N.split(",").map(V=>(0,A.adoptToGalleryExtensionId)(V)):[]}function $(D){const O=D.properties?D.properties.filter(F=>F.key===n.Engine):[];return O.length>0&&O[0].value||""}function B(D){const O=D.properties?D.properties.filter(N=>N.key===n.LocalizedLanguages):[],F=O.length>0&&O[0].value||"";return F?F.split(","):[]}function M(D){return D.indexOf("preview")!==-1}function j(D){const O=D.properties?D.properties.find(F=>F.key===n.WebExtension):void 0;return!!O&&O.value==="true"}function W(D){return D.files.some(O=>O.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,w.joinPath)(b.URI.parse(D.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function z(D,O,F,N,V){const G={manifest:L(O,t.Manifest),readme:L(O,t.Details),changelog:L(O,t.Changelog),license:L(O,t.License),repository:S(O),download:I(O),icon:u(O),coreTranslations:h(O)};return{identifier:{id:(0,A.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:O.version,date:O.lastUpdated,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:c(D.statistics,"install"),rating:c(D.statistics,"averagerating"),ratingCount:c(D.statistics,"ratingcount"),assetUri:b.URI.parse(O.assetUri),webResource:W(O),assetTypes:O.files.map(({assetType:Q})=>Q),assets:G,properties:{dependencies:_(O,n.Dependency),extensionPack:_(O,n.ExtensionPack),engine:$(O),localizedLanguages:B(O),webExtension:j(O)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,searchText:N.searchText,querySource:V},preview:M(D.flags)}}let H=class{constructor(O,F,N,V,G,Q,X){this.requestService=O,this.logService=F,this.environmentService=N,this.telemetryService=V,this.fileService=G,this.productService=Q;const ne=Q.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=q(Q.version,this.environmentService,this.fileService,X)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,F){const N=[];let{total:V,firstPage:G,getPage:Q}=await this.query({names:O,pageSize:O.length},F);N.push(...G);for(let X=1;N.length<V&&(G=await Q(X,F),G.length);X++)N.push(...G);return N}async getCompatibleExtension(O,F){const N=await this.getCompatibleExtensionByEngine(O,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(O,F){const N=(0,U.isIExtensionIdentifier)(O)?null:O;if(N&&N.properties.engine&&(0,f.isEngineValid)(N.properties.engine,this.productService.version))return N;const{id:V,uuid:G}=N?N.identifier:O;let Q=new a().withFlags(y.IncludeAssetUri,y.IncludeStatistics,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");G?Q=Q.withFilter(i.ExtensionId,G):Q=Q.withFilter(i.ExtensionName,V);const{galleryExtensions:X}=await this.queryGallery(Q,R.CancellationToken.None),[ne]=X;if(!ne||!ne.versions.length)return null;if(F){const ae=ne.versions.filter(he=>he.version===F)[0];if(ae){const he=z(ne,ae,0,Q);if(he.properties.engine&&(0,f.isEngineValid)(he.properties.engine,this.productService.version))return he}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?z(ne,ie,0,Q):null}async query(O,F){const N=R.CancellationToken.isCancellationToken(O)?{}:O,V=R.CancellationToken.isCancellationToken(O)?O:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=N.text||"";const Q=(0,P.getOrDefault)(N,fe=>fe.pageSize,50);let X=new a().withFlags(y.IncludeLatestVersionOnly,y.IncludeAssetUri,y.IncludeStatistics,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,Q).withFilter(i.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,we,Ie)=>(X=X.withFilter(i.Category,Ie||we),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,we,Ie)=>(X=X.withFilter(i.Tag,Ie||we),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),X=X.withFilter(i.SearchText,G)),X=X.withSortBy(0)):N.ids?X=X.withFilter(i.ExtensionId,...N.ids):N.names?X=X.withFilter(i.ExtensionName,...N.names):X=X.withSortBy(4),typeof N.sortBy=="number"&&(X=X.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(X=X.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(X,V),ae=ne.map((fe,we)=>z(fe,fe.versions[0],we,X,N.source)),he=async(fe,we)=>{if(we.isCancellationRequested)throw(0,v.canceled)();const Ie=X.withPage(fe+1),{galleryExtensions:ke}=await this.queryGallery(Ie,we);return ke.map((Ue,Fe)=>z(Ue,Ue.versions[0],Fe,Ie,N.source))};return{firstPage:ae,total:ie,pageSize:X.pageSize,getPage:he}}async queryGallery(O,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,y.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,s(y.Unpublished));const N=await this.commonHeadersPromise,V=JSON.stringify(O.raw),G=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)}),Q=new Date().getTime();let X,ne,ie=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:V,headers:G},F),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:ie};const ae=await(0,T.asJson)(X);if(ae){const he=ae.results[0],fe=he.extensions,we=he.resultMetadata&&he.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ie=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:ie}}return{galleryExtensions:[],total:ie}}catch(ae){throw ne=ae,ae}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},O.telemetryData),{requestBodySize:String(V.length),duration:new Date().getTime()-Q,success:!!X&&(0,T.isSuccess)(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:ne?(0,v.isPromiseCanceledError)(ne)?"canceled":(0,v.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(O,F,N,V){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,Q=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${O}/extensions/${F}/${N}/stats?statType=${V}`),headers:Q},R.CancellationToken.None)}catch(X){}}}async download(O,F,N){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const V=(0,A.getGalleryExtensionTelemetryData)(O),G=new Date().getTime(),Q=ae=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},V),{duration:ae})),X=N===1?"install":N===2?"update":"",ne=X?{uri:`${O.assets.download.uri}&${X}=true`,fallbackUri:`${O.assets.download.fallbackUri}?${X}=true`}:O.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),Q(new Date().getTime()-G)}async getReadme(O,F){if(O.assets.readme){const N=await this.getAsset(O.assets.readme,{},F);return await(0,T.asText)(N)||""}return""}async getManifest(O,F){if(O.assets.manifest){const N=await this.getAsset(O.assets.manifest,{},F),V=await(0,T.asText)(N);return V?JSON.parse(V):null}return null}async getCoreTranslation(O,F){const N=O.assets.coreTranslations.filter(V=>V[0]===F.toUpperCase())[0];if(N){const V=await this.getAsset(N[1]),G=await(0,T.asText)(V);return G?JSON.parse(G):null}return null}async getChangelog(O,F){if(O.assets.changelog){const N=await this.getAsset(O.assets.changelog,{},F);return await(0,T.asText)(N)||""}return""}async getAllVersions(O,F){let N=new a().withFlags(y.IncludeVersions,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");O.identifier.uuid?N=N.withFilter(i.ExtensionId,O.identifier.uuid):N=N.withFilter(i.ExtensionName,O.identifier.id);const V=[],{galleryExtensions:G}=await this.queryGallery(N,R.CancellationToken.None);return G.length&&(F?await Promise.all(G[0].versions.map(async Q=>{let X;try{X=await this.getEngine(Q)}catch(ne){}X&&(0,f.isEngineValid)(X,this.productService.version)&&V.push({version:Q.version,date:Q.lastUpdated})})):V.push(...G[0].versions.map(Q=>({version:Q.version,date:Q.lastUpdated})))),V}async getAsset(O,F={},N=R.CancellationToken.None){const V=await this.commonHeadersPromise,G={type:"GET"},Q=Object.assign(Object.assign({},V),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),G),{headers:Q});const X=O.uri,ne=O.fallbackUri,ie=Object.assign(Object.assign({},F),{url:X});try{const ae=await this.requestService.request(ie,N);if(ae.res.statusCode===200)return ae;const he=await(0,T.asText)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${he}`)}catch(ae){if((0,v.isPromiseCanceledError)(ae))throw ae;const he=(0,v.getErrorMessage)(ae);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:he});const fe=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(fe,N)}}async getLastValidExtensionVersion(O,F){const N=this.getLastValidExtensionVersionFromProperties(O,F);return N||this.getLastValidExtensionVersionRecursively(O,F)}getLastValidExtensionVersionFromProperties(O,F){for(const N of F){const V=$(N);if(!V)return null;if((0,f.isEngineValid)(V,this.productService.version))return N}return null}async getEngine(O){const F=$(O);if(F)return F;const N=L(O,t.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.getAsset(N,{headers:V}),Q=await(0,T.asJson)(G);if(Q)return Q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(O,F){if(!F.length)return null;const N=F[0],V=await this.getEngine(N);return(0,f.isEngineValid)(V,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:n.Engine,value:V}),N):this.getLastValidExtensionVersionRecursively(O,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,T.asJson)(O),N=new Map;if(F)for(const V of F.malicious){const G=N.get(V)||{id:{id:V},malicious:!0,slow:!1};G.malicious=!0,N.set(V,G)}return[...N.values()]}};H=ue([Y(0,T.IRequestService),Y(1,d.ILogService),Y(2,g.IEnvironmentService),Y(3,k.ITelemetryService),Y(4,m.IFileService),Y(5,o.IProductService),Y(6,(0,p.optional)(C.IStorageService))],H),e.ExtensionGalleryService=H;async function q(D,O,F,N){const V={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},G=await(0,E.getServiceMachineId)(O,F,N);return V["X-Market-User-Id"]=G,V}e.resolveMarketplaceHeaders=q}),define(Z[175],ee([0,1,5,9,28,10,36,8,7,18,29,62,40,12,168,6,25,71,109,19,3,56]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",n="extensionTips/lastPromptedMediumImpExeTime";let r=class extends o.ExtensionTipsService{constructor(a,c,h,S,I,u,L,_,$,B){super(L,_,$,B);this.environmentService=a,this.telemetryService=c,this.extensionManagementService=h,this.storageService=S,this.nativeHostService=I,this.extensionRecommendationNotificationService=u,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,d.forEach)(_.exeBasedExtensionTips,({key:M,value:j})=>{const W=[],z=[],H=[];(0,d.forEach)(j.recommendations,({key:q,value:D})=>{D.important?j.important?W.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):z.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):H.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:W}),z.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:z}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:H})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,h)}groupImportantTipsByExe(a,c){const h=new Map;a.forEach(_=>h.set(_.extensionId.toLowerCase(),_));const{installed:S,uninstalled:I}=this.groupByInstalled([...h.keys()],c);for(const _ of S){const $=h.get(_);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,U.basename)($.windowsPath)})}for(const _ of I){const $=h.get(_);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,U.basename)($.windowsPath)})}const u=this.getPromptedExecutableTips(),L=new Map;for(const _ of I){const $=h.get(_);if($&&(!u[$.exeName]||!u[$.exeName].includes($.extensionId))){let B=L.get($.exeName);B||(B=[],L.set($.exeName,B)),B.push($)}}return L}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[a,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const S=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(S(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const I=this._register((0,C.disposableTimeout)(()=>{I.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const a=this.getLastPromptedMediumExeTime(),c=Date.now()-a,h=7*24*60*60*1e3;if(c<h){const u=this._register((0,C.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},h-c));return}const[S,I]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(I).then(u=>{switch(u){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(S),this.addToRecommendedExecutables(I[0].exeName,I);const L=this._register((0,C.disposableTimeout)(()=>{L.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(S),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const $=this._register((0,C.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(a){const c=a.map(({extensionId:S})=>S.toLowerCase()),h=(0,w.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,h,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(n,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(n,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,c){const h=this.getPromptedExecutableTips();h[a]=c.map(({extensionId:S})=>S.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(a,c){const h=[],S=[],I=c.reduce((u,L)=>(u.add(L.identifier.id.toLowerCase()),u),new Set);return a.forEach(u=>{I.has(u.toLowerCase())?h.push(u):S.push(u)}),{installed:h,uninstalled:S}}async getValidExecutableBasedExtensionTips(a){const c=[],h=new Map;for(const S of a.keys()){const I=a.get(S);if(!(!I||!(0,g.isNonEmptyArray)(I.recommendations))){const u=[];f.isWindows?I.windowsPath&&u.push(I.windowsPath.replace("%USERPROFILE%",k.env.USERPROFILE).replace("%ProgramFiles(x86)%",k.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",k.env.ProgramFiles).replace("%APPDATA%",k.env.APPDATA).replace("%WINDIR%",k.env.WINDIR)):(u.push((0,U.join)("/usr/local/bin",S)),u.push((0,U.join)("/usr/bin",S)),u.push((0,U.join)(this.environmentService.userHome.fsPath,S)));for(const L of u){let _=h.get(L);if(_===void 0&&(_=await this.fileService.exists(v.URI.file(L)),h.set(L,_)),_)for(const{extensionId:$,extensionName:B,isExtensionPack:M}of I.recommendations)c.push({extensionId:$,extensionName:B,isExtensionPack:M,exeName:S,exeFriendlyName:I.exeFriendlyName,windowsPath:I.windowsPath})}}}return c}};r=ue([Y(0,P.INativeEnvironmentService),Y(1,E.ITelemetryService),Y(2,R.IExtensionManagementService),Y(3,y.IStorageService),Y(4,i.INativeHostService),Y(5,p.IExtensionRecommendationNotificationService),Y(6,T.IFileService),Y(7,A.IProductService),Y(8,m.IRequestService),Y(9,b.ILogService)],r),e.ExtensionTipsService=r}),define(Z[79],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(P){this.appender=P}listen(P,k){throw new Error(`Event not found: ${k}`)}call(P,k,{eventName:T,data:f}){return this.appender.log(T,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class U{constructor(P){this.channel=P}log(P,k){return this.channel.call("log",{eventName:P,data:k}).then(void 0,T=>`Failed to log telemetry: ${console.warn(T)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(Z[80],ee([0,1,57,119,21,4,24,39,2,26,35]),function(K,e,v,U,A,P,k,T,f,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(o,C){this._configurationService=C,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=o.appender,this._commonProperties=o.commonProperties||Promise.resolve({}),this._piiPaths=o.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!o.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(E),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(E=>{const p=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(o,C){this._experimentProperties[o]=C}setEnabled(o){this._enabled=o}_updateUserOptIn(){var o;const C=(o=this._configurationService)===null||o===void 0?void 0:o.getValue(m);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const o=await this._commonProperties;let C=o.sessionID,E=o["common.instanceId"],p=o["common.machineId"],w=o["common.firstSessionDate"],y=o["common.msftInternal"];return{sessionId:C,instanceId:E,machineId:p,firstSessionDate:w,msftInternal:y}}dispose(){this._disposables.dispose()}publicLog(o,C,E){return this.isOptedIn?this._commonProperties.then(p=>{C=(0,g.mixin)(C,p),C=(0,g.mixin)(C,this._experimentProperties),C=(0,g.cloneAndChange)(C,w=>{if(typeof w=="string")return this._cleanupInfo(w,E)}),this._appender.log(o,C)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(o,C,E){return this.publicLog(o,C,E)}publicLogError(o,C){return this.sendErrorTelemetry?this.publicLog(o,C,!0):Promise.resolve(void 0)}publicLogError2(o,C){return this.publicLogError(o,C)}_cleanupInfo(o,C){let E=o;if(C){const p=[];for(let i of this._cleanupPatterns)for(;;){const t=i.exec(o);if(!t)break;p.push([t.index,i.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(E="";;){const i=y.exec(o);if(!i)break;!w.test(i[0])&&p.every(([t,n])=>i.index<t||i.index>=n)&&(E+=o.substring(s,i.index)+"<REDACTED: user-file-path>",s=y.lastIndex)}s<o.length&&(E+=o.substr(s))}for(let p of this._cleanupPatterns)E=E.replace(p,"");return E}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ue([Y(1,(0,P.optional)(k.IConfigurationService))],d),e.TelemetryService=d;const m="telemetry";R.Registry.as(T.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,U.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,U.localize)(2,null,v.default.privacyStatementUrl):(0,U.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,24,26,17,6]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(o,C){return Promise.resolve(void 0)}publicLog2(o,C){return this.publicLog(o,C)}publicLogError(o,C){return Promise.resolve(void 0)}publicLogError2(o,C){return this.publicLogError(o,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(C,E,p){}async publicLogError(C,E,p){}}e.NullEndpointTelemetryService=k;function T(...o){return{log:(C,E)=>o.forEach(p=>p.log(C,E)),flush:()=>P.Promises.settled(o.map(C=>C.flush()))}}e.combinedAppender=T,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(o,C){return C.onDidChangeConfiguration(E=>{E.source!==6&&o.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(E.source),configurationKeys:m(E.sourceConfig)})})}e.configurationTelemetry=f;function g(o){const C=Object.create(null),E=Object.create(null),p=Object.create(null);d(o,p);for(let w in p){w=w.length>150?w.substr(w.length-149):w;const y=p[w];typeof y=="number"?E[w]=y:typeof y=="boolean"?E[w]=y?1:0:typeof y=="string"?C[w]=y.substring(0,1023):typeof y!="undefined"&&y!==null&&(C[w]=y)}return{properties:C,measurements:E}}e.validateTelemetryData=g;function R(o){if(!o)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{o.indexOf(`${p}+`)===0&&(C=p)}),C}e.cleanRemoteAuthority=R;function d(o,C,E=0,p){if(!!o)for(let w of Object.getOwnPropertyNames(o)){const y=o[w],s=p?p+w:w;Array.isArray(y)?C[s]=(0,U.safeStringify)(y):y instanceof Date?C[s]=y.toISOString():(0,A.isObject)(y)?E<2?d(y,C,E+1,s+"."):C[s]=(0,U.safeStringify)(y):C[s]=y}}function m(o){if(!o)return[];const C=[];return b(C,"",o),C}function b(o,C,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(p=>b(o,C?`${C}.${p}`:p,E[p])):o.push(C)}}),define(Z[176],ee([0,1,2,10,12,58]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends v.Disposable{constructor(f,g){super();this.logger=this._register(f.createLogger(g.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(f,g){this.logger.trace(`telemetry/${f}`,(0,P.validateTelemetryData)(g))}};k=ue([Y(0,A.ILoggerService),Y(1,U.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(Z[177],ee([0,1,13,26,58]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(T){const f=await new Promise((R,d)=>{K(["applicationinsights"],R,d)});let g;return f.defaultClient?(g=new f.TelemetryClient(T),g.channel.setUseDiskRetryCaching(!0)):(f.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=f.defaultClient),T.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class k{constructor(f,g,R){this._eventPrefix=f,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(g=>{f(g)},g=>{(0,v.onUnexpectedError)(g),console.error(g)})}}log(f,g){!this._aiClient||(g=(0,U.mixin)(g,this._defaultData),g=(0,A.validateTelemetryData)(g),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+f,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(Z[178],ee([0,1,49,79,16,80,24,25]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(R,d){this.configurationService=R,this.telemetryService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(R){if(!this.customTelemetryServices.has(R.id)){const{machineId:d,sessionId:m}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=d,b["common.vscodesessionid"]=m;const o=[R.id,JSON.stringify(b),R.aiKey],E=new v.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:o,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=new U.TelemetryAppenderClient(E);this.customTelemetryServices.set(R.id,new P.TelemetryService({appender:p,sendErrorTelemetry:R.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(R.id)}async publicLog(R,d,m){await(await this.getCustomTelemetryService(R)).publicLog(d,m)}async publicLogError(R,d,m){await(await this.getCustomTelemetryService(R)).publicLogError(d,m)}};f=ue([Y(0,k.IConfigurationService),Y(1,T.ITelemetryService)],f),e.CustomEndpointTelemetryService=f}),define(Z[81],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var U;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(U=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,v.createDecorator)("localTerminalService"),e.IPtyService=(0,v.createDecorator)("ptyService");var P;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P=e.HeartbeatConstants||(e.HeartbeatConstants={}));var k;(function(f){f[f.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(k=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var T;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(T=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[179],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,v.createDecorator)("localPtyService")}),define(Z[180],ee([0,1,2,12,81,49,16,34,3,76]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var R;(function(b){b[b.MaxRestarts=5]="MaxRestarts"})(R||(R={}));let d=0,m=class extends v.Disposable{constructor(o){super();this._logService=o,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new f.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new f.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new f.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new f.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new f.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new f.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new f.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new f.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new f.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new f.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new f.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new f.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new f.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,v.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const o=new P.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),T.ProxyChannel.toService(o.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(o.onDidProcessExit(w=>{this._onPtyHostExit.fire(w.code),this._isDisposed||(this._restartCount<=R.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${w.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${w.code}, giving up`))}));const E=o.getChannel(A.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{g.LogLevelChannelClient.setLevel(E,this._logService.getLevel())}));const p=T.ProxyChannel.toService(o.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(p.onProcessData(w=>this._onProcessData.fire(w))),this._register(p.onProcessExit(w=>this._onProcessExit.fire(w))),this._register(p.onProcessReady(w=>this._onProcessReady.fire(w))),this._register(p.onProcessTitleChanged(w=>this._onProcessTitleChanged.fire(w))),this._register(p.onProcessShellTypeChanged(w=>this._onProcessShellTypeChanged.fire(w))),this._register(p.onProcessOverrideDimensions(w=>this._onProcessOverrideDimensions.fire(w))),this._register(p.onProcessResolvedShellLaunchConfig(w=>this._onProcessResolvedShellLaunchConfig.fire(w))),this._register(p.onProcessReplay(w=>this._onProcessReplay.fire(w))),this._register(p.onProcessOrphanQuestion(w=>this._onProcessOrphanQuestion.fire(w))),[o,p]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,C,E,p,w,y,s,i,t,n){const r=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),l=await this._proxy.createProcess(o,C,E,p,w,y,s,i,t,n);return clearTimeout(r),d=Math.max(d,l),l}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(o){return this._proxy.listProcesses(o)}start(o){return this._proxy.start(o)}shutdown(o,C){return this._proxy.shutdown(o,C)}input(o,C){return this._proxy.input(o,C)}resize(o,C,E){return this._proxy.resize(o,C,E)}acknowledgeDataEvent(o,C){return this._proxy.acknowledgeDataEvent(o,C)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};m=ue([Y(0,U.ILogService)],m),e.PtyHostService=m}),define(Z[51],ee([0,1,41]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(k,T,f,g){const R=(0,v.setProperty)(k,T,f,g)[0];return R&&(k=k.substring(0,R.offset)+R.content+k.substring(R.offset+R.length)),k}e.edit=U;function A(k,T,f){let g=f;for(;g>=0;){if(k.charAt(g)===T.charAt(T.length-1)&&T.length===1)return g+1;if(g--,T.length===2&&g>=0&&k.charAt(g)===T.charAt(0))return g+2}return 0}e.getLineStartOffset=A;function P(k,T,f){let g=f;for(;g>=0;)if(k.charAt(g)===T.charAt(T.length-1)&&T.length===1||(g++,T.length===2&&g>=0&&k.charAt(g)===T.charAt(1)))return g;return k.length-1}e.getLineEndOffset=P}),define(Z[181],ee([0,1,26,55]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(d,m,b,o,C){var E,p;const w=[],y=[],s=[];if(!m){const $=d.filter(({identifier:B})=>C.every(M=>M.toLowerCase()!==B.id.toLowerCase()));return{added:w,removed:y,updated:s,remote:$.length>0?$:null}}d=d.map(g),m=m.map(g),b=b?b.map(g):null;const i=new Map,t=$=>{$.uuid&&i.set($.id.toLowerCase(),$.uuid)};d.forEach(({identifier:$})=>t($)),m.forEach(({identifier:$})=>t($)),b&&b.forEach(({identifier:$})=>t($));const n=$=>{const B=$.identifier.uuid||i.get($.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${$.identifier.id.toLowerCase()}`},r=($,B)=>($.set(n(B),B),$),l=d.reduce(r,new Map),a=m.reduce(r,new Map),c=m.reduce(($,B)=>{const M=n(B);B=(0,v.deepClone)(B);const j=l.get(M);return j&&(j.installed&&(B.installed=!0),B.version||(B.version=j.version)),r($,B)},new Map),h=b?b.reduce(r,new Map):null,S=o.reduce(r,new Map),I=C.reduce(($,B)=>{const M=i.get(B.toLowerCase());return $.add(M?`uuid:${M}`:`id:${B.toLowerCase()}`)},new Set),u=P(l,a,I);if(u.added.size>0||u.removed.size>0||u.updated.size>0){const $=P(h,l,I),B=P(h,a,I),M=(j,W)=>{const z=l.get(j);if(z){const H=a.get(j);return Object.assign(Object.assign({},W?H:z),{version:(H.version&&U.gt(H.version,z.version),z.version),state:k(z,H,h==null?void 0:h.get(j))})}};for(const j of B.removed.values()){const W=l.get(j);W&&y.push(W.identifier)}for(const j of B.added.values())if($.added.has(j)){if(u.updated.has(j)){const W=M(j,!0);W&&(s.push(R(W,j)),c.set(j,W))}}else{const W=a.get(j);W.installed&&w.push(R(W,j))}for(const j of B.updated.values()){const W=M(j,!0);W&&(s.push(R(W,j)),c.set(j,W))}for(const j of $.added.values())B.added.has(j)||c.set(j,l.get(j));for(const j of $.updated.values())if(!B.removed.has(j)&&!B.updated.has(j)){const W=M(j,!1);W&&(((E=c.get(j))===null||E===void 0?void 0:E.installed)&&(W.installed=!0),c.set(j,W))}for(const j of $.removed.values())!S.has(j)&&!B.updated.has(j)&&((p=h==null?void 0:h.get(j))===null||p===void 0?void 0:p.installed)&&c.delete(j)}const L=[],_=P(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&c.forEach(($,B)=>L.push(R($,B))),{added:w,removed:y,updated:s,remote:L.length?L:null}}e.merge=A;function P(d,m,b,{checkInstalledProperty:o,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const E=d?[...d.keys()].filter(i=>!b.has(i)):[],p=[...m.keys()].filter(i=>!b.has(i)),w=p.filter(i=>E.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),y=E.filter(i=>p.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),s=new Set;for(const i of E)if(!y.has(i)){const t=d.get(i),n=m.get(i);(!n||t.disabled!==n.disabled||!f(t.state,n.state)||C&&t.version!==n.version||o&&t.installed!==n.installed)&&s.add(i)}return{added:w,removed:y,updated:s}}function k(d,m,b){const o=d.state,C=m.state,E=b==null?void 0:b.state;if(!m.version||o&&U.gt(d.version,m.version))return o;if(C&&U.gt(m.version,d.version)||!o)return C;if(!C)return o;const p=(0,v.deepClone)(o),w=E?T(E,C):{added:Object.keys(C).reduce((s,i)=>(s.add(i),s),new Set),removed:new Set,updated:new Set},y=E?T(E,o):{added:Object.keys(o).reduce((s,i)=>(s.add(i),s),new Set),removed:new Set,updated:new Set};for(const s of[...w.added.values(),...w.updated.values()])p[s]=C[s];for(const s of w.removed.values())y.updated.has(s)||delete p[s];return p}function T(d,m){const b=Object.keys(d),o=Object.keys(m),C=o.filter(w=>b.indexOf(w)===-1).reduce((w,y)=>(w.add(y),w),new Set),E=b.filter(w=>o.indexOf(w)===-1).reduce((w,y)=>(w.add(y),w),new Set),p=new Set;for(const w of b)if(!E.has(w)){const y=d[w],s=m[w];(0,v.equals)(y,s)||p.add(w)}return{added:C,removed:E,updated:p}}function f(d={},m={}){const{added:b,removed:o,updated:C}=T(d,m);return b.size===0&&o.size===0&&C.size===0}function g(d){return Object.assign(Object.assign({},d),{disabled:!!d.disabled,installed:!!d.installed})}function R(d,m){const b={identifier:{id:d.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return d.version&&(b.version=d.version),d.disabled&&(b.disabled=!0),d.installed&&(b.installed=!0),d.state&&(b.state=d.state),b}}),define(Z[82],ee([0,1,18,3,2,33,4,28,19]),function(K,e,v,U,A,P,k,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let R=class Ye extends A.Disposable{constructor(m,b){super();this.storageService=m,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new U.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(o=>this.onDidChangeStorageValue(o)))}static toKey(m){return`extensionKeys/${(0,P.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const b=g.exec(m);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const m=this.storageService.keys(0,1);for(const b of m){const o=Ye.fromKey(b);o&&this.extensionsWithKeysForSync.add(o.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope===0){if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Ye.fromKey(m.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(m,b){this.storageService.store(Ye.toKey(m),JSON.stringify(b),0,1)}getKeysForSync(m){var b;const o=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[m.id.toLowerCase()],C=this.storageService.get(Ye.toKey(m),0),E=C?JSON.parse(C):void 0;return E&&o?(0,v.distinct)([...E,...o]):E||o}};R=ue([Y(0,f.IStorageService),Y(1,T.IProductService)],R),e.ExtensionsStorageSyncService=R}),define(Z[83],ee([0,1,18,24,4]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let P=class{constructor(T){this.configurationService=T}hasToNeverSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(T.toLowerCase())}hasToAlwaysSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(`-${T.toLowerCase()}`)}updateIgnoredExtensions(T,f){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return g=g.filter(R=>R!==T&&R!==`-${T}`),f&&g.push(T.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,1)}updateSynchronizedExtensions(T,f){let g=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return g=g.filter(R=>R!==T&&R!==`-${T}`),f&&g.push(`-${T.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,1)}getIgnoredExtensions(T){const f=T.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),g=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),R=[],d=[];if(Array.isArray(g))for(const m of g)m.startsWith("-")?d.push(m.substring(1)):R.push(m);return(0,v.distinct)([...f,...R].filter(m=>d.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let T=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return T!==void 0||(T=this.configurationService.inspect("sync.ignoredExtensions").userValue,T!==void 0)?T:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(f=>f.toLowerCase())}};P=ue([Y(0,U.IConfigurationService)],P),e.IgnoredExtensionsManagementService=P}),define(Z[182],ee([0,1,26,32,18,140,51]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function T(s){return(0,U.parse)(s)||[]}e.parseKeybindings=T;async function f(s,i,t,n,r){const l=T(s),a=T(i),c=t?T(t):null,h=[...l,...a,...c||[]].map(z=>z.key),S=await r.resolveUserBindings(h);let I=R(l,a,c,S);if(!I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!I.hasLocalForwarded&&I.hasRemoteForwarded)return{mergeContent:i,hasChanges:!0,hasConflicts:!1};if(I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const u=m(l),L=m(a),_=c?m(c):null,$=o(u,L,S),B=_?o(_,u,S):{added:[...u.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set},M=_?o(_,L,S):{added:[...L.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set},j=g($,B,M);let W=s;for(const z of j.removed.values())j.conflicts.has(z)||(W=w(W,z,n));for(const z of j.added.values())if(!j.conflicts.has(z)){const H=L.get(z);if(H.some(q=>q.command!==`-${z}`&&I.conflicts.has(S[q.key]))){j.conflicts.add(z);continue}W=p(W,H,n)}for(const z of j.updated.values())if(!j.conflicts.has(z)){const H=L.get(z);if(H.some(q=>q.command!==`-${z}`&&I.conflicts.has(S[q.key]))){j.conflicts.add(z);continue}W=y(W,z,H,n)}return{mergeContent:W,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=f;function g(s,i,t){const n=new Set,r=new Set,l=new Set,a=new Set;for(const c of i.removed.values())t.updated.has(c)&&a.add(c);for(const c of t.removed.values())a.has(c)||(i.updated.has(c)?a.add(c):r.add(c));for(const c of i.added.values())a.has(c)||t.added.has(c)&&s.updated.has(c)&&a.add(c);for(const c of t.added.values())a.has(c)||(i.added.has(c)?s.updated.has(c)&&a.add(c):n.add(c));for(const c of i.updated.values())a.has(c)||t.updated.has(c)&&s.updated.has(c)&&a.add(c);for(const c of t.updated.values())a.has(c)||(i.updated.has(c)?s.updated.has(c)&&a.add(c):l.add(c));return{added:n,removed:r,updated:l,conflicts:a}}function R(s,i,t,n){const r=new Set,l=d(s,n),a=d(i,n),c=t?d(t,n):null,h=b(l,a);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const S=c?b(c,l):{added:[...l.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const I=c?b(c,a):{added:[...a.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:u,removed:L,updated:_,conflicts:$}=g(h,S,I);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:L,updated:_,conflicts:$}}function d(s,i){const t=new Map;for(const n of s){const r=i[n.key];let l=t.get(r);l||(l=[],t.set(r,l)),l.push(n)}return t}function m(s){const i=new Map;for(const t of s){const n=t.command[0]==="-"?t.command.substring(1):t.command;let r=i.get(n);r||(r=[],i.set(n,r)),r.push(t)}return i}function b(s,i){const t=[...s.keys()],n=[...i.keys()],r=n.filter(c=>t.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),l=t.filter(c=>n.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),a=new Set;for(const c of t)if(!l.has(c)){const h=s.get(c).map(I=>Object.assign(Object.assign({},I),{key:c})),S=i.get(c).map(I=>Object.assign(Object.assign({},I),{key:c}));(0,A.equals)(h,S,(I,u)=>E(I,u))||a.add(c)}return{added:r,removed:l,updated:a}}function o(s,i,t){const n=[...s.keys()],r=[...i.keys()],l=r.filter(h=>n.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),a=n.filter(h=>r.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),c=new Set;for(const h of n)if(!a.has(h)){const S=s.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]})),I=i.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]}));C(S,I)||c.add(h)}return{added:l,removed:a,updated:c}}function C(s,i){return!(!(0,A.equals)(s.filter(({command:t})=>t[0]!=="-"),i.filter(({command:t})=>t[0]!=="-"),(t,n)=>E(t,n))||!(0,A.equals)(s.filter(({command:t})=>t[0]==="-"),i.filter(({command:t})=>t[0]==="-"),(t,n)=>E(t,n)))}function E(s,i){if(s.command!==i.command||s.key!==i.key)return!1;const t=P.ContextKeyExpr.deserialize(s.when),n=P.ContextKeyExpr.deserialize(i.when);return!(t&&!n||!t&&n||t&&n&&!t.equals(n)||!v.equals(s.args,i.args))}function p(s,i,t){for(const n of i)s=k.edit(s,[-1],n,t);return s}function w(s,i,t){const n=T(s);for(let r=n.length-1;r>=0;r--)(n[r].command===i||n[r].command===`-${i}`)&&(s=k.edit(s,[r],void 0,t));return s}function y(s,i,t,n){const r=T(s),l=r.findIndex(a=>a.command===i||a.command===`-${i}`);for(let a=r.length-1;a>=0;a--)(r[a].command===i||r[a].command===`-${i}`)&&(s=k.edit(s,[a],void 0,n));for(let a=t.length-1;a>=0;a--)s=k.edit(s,[l],t[a],n);return s}}),define(Z[183],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(P,k,T){const f={},g={},R=new Set;if(!k)return{local:{added:f,updated:g,removed:[...R.values()]},remote:{added:P,updated:{},removed:[]},conflicts:[]};const d=U(P,k);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:f,updated:g,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=U(T,P),b=U(T,k),o={},C={},E=new Set,p=new Set;for(const w of m.removed.values())b.updated.has(w)?f[w]=k[w]:E.add(w);for(const w of b.removed.values())p.has(w)||(m.updated.has(w)?p.add(w):R.add(w));for(const w of m.updated.values())p.has(w)||(b.updated.has(w)?d.updated.has(w)&&p.add(w):C[w]=P[w]);for(const w of b.updated.values())p.has(w)||(m.updated.has(w)?d.updated.has(w)&&p.add(w):P[w]!==void 0&&(g[w]=k[w]));for(const w of m.added.values())p.has(w)||(b.added.has(w)?d.updated.has(w)&&p.add(w):o[w]=P[w]);for(const w of b.added.values())p.has(w)||(m.added.has(w)?d.updated.has(w)&&p.add(w):f[w]=k[w]);return{local:{added:f,removed:[...R.values()],updated:g},remote:{added:o,removed:[...E.values()],updated:C},conflicts:[...p.values()]}}e.merge=v;function U(P,k){const T=P?Object.keys(P):[],f=k?Object.keys(k):[],g=f.filter(m=>T.indexOf(m)===-1).reduce((m,b)=>(m.add(b),m),new Set),R=T.filter(m=>f.indexOf(m)===-1).reduce((m,b)=>(m.add(b),m),new Set),d=new Set;for(const m of T)if(!R.has(m)){const b=P[m],o=k[m];b!==o&&d.add(m)}return{added:g,removed:R,updated:d}}function A(P,k){const{added:T,removed:f,updated:g}=U(P,k);return T.size===0&&f.size===0&&g.size===0}e.areSame=A}),define(Z[20],ee([0,1,4,29,35,39,124,78,11,18,17]),function(K,e,v,U,A,P,k,T,f,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function d(){const a=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(c=>!!a[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=d;function m(){const a=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(a).filter(I=>!!a[I].ignoreSync),h=Object.keys(a).filter(I=>a[I].scope===2||a[I].scope===6),S=d();return(0,g.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...h,...S])}e.getDefaultIgnoredSettings=m;function b(){const a="vscode://schemas/ignoredSettings",c=A.Registry.as(P.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=A.Registry.as(T.Extensions.JSONContribution),S=()=>{const I=d(),u=m().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),L=Object.keys(P.allSettings.properties).filter(B=>u.indexOf(B)===-1),_=u.filter(B=>I.indexOf(B)===-1),$={items:{type:"string",enum:[...L,..._.map(B=>`-${B}`)]}};h.registerSchema(a,$)};return c.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=b;function o(a){return a&&(0,R.isObject)(a)&&(0,R.isString)(a.id)&&(0,R.isArray)(a.scopes)}e.isAuthenticationProvider=o;var C;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,v.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,v.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,v.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(a){const c={};return c[e.HEADER_EXECUTION_ID]=a,c}e.createSyncHeaders=E;var p;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.NoRef="NoRef",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(p=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(c,h,S,I){super(c);this.code=h,this.resource=S,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class y extends w{constructor(c,h,S,I){super(c,S,void 0,I);this.url=h,this.operationId=I}}e.UserDataSyncStoreError=y;class s extends w{constructor(c,h){super(c,h)}}e.UserDataAutoSyncError=s,function(a){function c(h){if(h instanceof a)return h;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(S&&S[1]){const I=S[2]==="unknown"?void 0:S[2],u=S[3]==="unknown"?void 0:S[3];return new a(h.message,S[1],I,u)}return new a(h.message,p.Unknown)}a.toUserDataSyncError=c}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var n;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(a){return`sync.enable.${a}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,v.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,v.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,v.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,v.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,v.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,v.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function l(a,c){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,f.isEqualOrParent)(a,(0,f.joinPath)(c.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=l}),define(Z[45],ee([0,1,2,8,22,5,20,10,11,6,3,25,32,120,24,17,21,18,44,19,30]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=i;function t(c,h,S){return S.joinPath(h.userDataSyncHome,c,`lastSync${c}.json`)}let n=class extends v.Disposable{constructor(h,S,I,u,L,_,$,B,M,j){super();this.resource=h,this.fileService=S,this.environmentService=I,this.userDataSyncStoreService=L,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=$,this.telemetryService=B,this.logService=M,this.configurationService=j,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new g.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new R.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(I.userDataSyncHome,1024)?f.extUri:f.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(I.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,k.PREVIEW_DIR_NAME),this.lastSyncResource=t(h,I,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(I,S,u)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const S=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0);this.setStatus(S)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:I})=>I!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const S=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),S==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,S={}){await this._sync(h,!0,S)}async preview(h,S={}){return this._sync(h,!1,S)}async apply(h,S={}){try{this.syncHeaders=Object.assign({},S);const I=await this.doApply(h);return this.setStatus(I),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,S,I){try{if(this.syncHeaders=Object.assign({},I),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let u="idle";try{const L=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(h,L);return u=await this.performSync(_,L,S),u==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):u==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(u)}}finally{this.syncHeaders={}}}async replace(h){const S=await this.resolveContent(h);if(!S)return!1;const I=this.parseSyncData(S);if(!I)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const u=await this.getLastSyncUserData(),L=await this.getLatestRemoteUserData(null,u),_=await this.generateSyncPreview({ref:L.ref,syncData:I},u,s.CancellationToken.None),$=[];for(const B of _){const M=await this.getAcceptResult(B,B.remoteResource,void 0,s.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,s.CancellationToken.None);$.push([B,Object.assign(Object.assign({},M),{remoteChange:j!==0?j:2})])}await this.applyResult(L,u,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(h,S){if(S){const I=h&&h.latest?h.latest[this.resource]:void 0;if(S.ref===I||I===void 0&&S.syncData===null)return S}return this.getRemoteUserData(S)}async performSync(h,S,I){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new k.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,h.syncData.version),k.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(h,S,I)}catch(u){if(u instanceof k.UserDataSyncError)switch(u.code){case k.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,S,I);case k.UserDataSyncErrorCode.Conflict:case k.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),S=await this.getLastSyncUserData(),this.performSync(h,S,I)}throw u}}async doSync(h,S,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,g.createCancelablePromise)(L=>this.doGenerateSyncResourcePreview(h,S,I,L)));const u=await this.syncPreviewPromise;return this.updateConflicts(u.resourcePreviews),u.resourcePreviews.some(({mergeState:L})=>L==="conflict")?"hasConflicts":I?await this.doApply(!1):"syncing"}catch(u){throw this.syncPreviewPromise=null,u}}async merge(h){return await this.updateSyncResourcePreview(h,async S=>{const I=await this.getMergeResult(S,s.CancellationToken.None);await this.fileService.writeFile(S.previewResource,A.VSBuffer.fromString((I==null?void 0:I.content)||""));const u=I&&!I.hasConflicts?await this.getAcceptResult(S,S.previewResource,void 0,s.CancellationToken.None):void 0;return S.acceptResult=u,S.mergeState=I.hasConflicts?"conflict":u?"accepted":"preview",S.localChange=u?u.localChange:I.localChange,S.remoteChange=u?u.remoteChange:I.remoteChange,S}),this.syncPreviewPromise}async accept(h,S){return await this.updateSyncResourcePreview(h,async I=>{const u=await this.getAcceptResult(I,h,S,s.CancellationToken.None);return I.acceptResult=u,I.mergeState="accepted",I.localChange=u.localChange,I.remoteChange=u.remoteChange,I}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async S=>{const I=await this.getMergeResult(S,s.CancellationToken.None);return await this.fileService.writeFile(S.previewResource,A.VSBuffer.fromString(I.content||"")),S.acceptResult=void 0,S.mergeState="preview",S.localChange=I.localChange,S.remoteChange=I.remoteChange,S}),this.syncPreviewPromise}async updateSyncResourcePreview(h,S){if(!!this.syncPreviewPromise){let I=await this.syncPreviewPromise;const u=I.resourcePreviews.findIndex(({localResource:L,remoteResource:_,previewResource:$})=>this.extUri.isEqual(L,h)||this.extUri.isEqual(_,h)||this.extUri.isEqual($,h));u!==-1&&(this.syncPreviewPromise=(0,g.createCancelablePromise)(async L=>{const _=[...I.resourcePreviews];return _[u]=await S(_[u]),Object.assign(Object.assign({},I),{resourcePreviews:_})}),I=await this.syncPreviewPromise,this.updateConflicts(I.resourcePreviews),I.resourcePreviews.some(({mergeState:L})=>L==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(h){if(!this.syncPreviewPromise)return"idle";const S=await this.syncPreviewPromise;return S.resourcePreviews.some(({mergeState:I})=>I==="conflict")?"hasConflicts":S.resourcePreviews.some(({mergeState:I})=>I!=="accepted")?"syncing":(await this.applyResult(S.remoteUserData,S.lastSyncUserData,S.resourcePreviews.map(I=>[I,I.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const S=h.filter(({mergeState:I})=>I==="conflict");(0,p.equals)(this._conflicts,S,(I,u)=>this.extUri.isEqual(I.previewResource,u.previewResource))||(this._conflicts=S,this._onDidChangeConflicts.fire(S))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:S,ref:I})=>({created:S,uri:this.toRemoteBackupResource(I)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:S,ref:I})=>({created:S,uri:this.toLocalBackupResource(I)}))}toRemoteBackupResource(h){return P.URI.from({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return P.URI.from({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const S=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(S))){const{content:I}=await this.getUserData(S);if(I){const u=this.parseSyncData(I);return u==null?void 0:u.machineId}}}async resolveContent(h){const S=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(S))){const{content:I}=await this.getUserData(S);return I}return this.extUri.isEqual(h,this.toLocalBackupResource(S))?this.userDataSyncBackupStoreService.resolveContent(this.resource,S):null}async resolvePreviewContent(h){const S=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(S)for(const I of S.resourcePreviews){if(this.extUri.isEqual(I.acceptedResource,h))return I.acceptResult?I.acceptResult.content:null;if(this.extUri.isEqual(I.remoteResource,h))return I.remoteContent;if(this.extUri.isEqual(I.localResource,h))return I.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,S,I,u){var L;const _=await this.currentMachineIdPromise,$=!!((L=h.syncData)===null||L===void 0?void 0:L.machineId)&&h.syncData.machineId===_,B=S===null&&$&&!this.hasSyncResourceStateVersionChanged?h:S,M=await this.generateSyncPreview(h,B,u),j=[];for(const W of M){const z=W.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)j.push(Object.assign(Object.assign({},W),{acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const H=I?await this.getMergeResult(W,u):void 0;if(u.isCancellationRequested)break;await this.fileService.writeFile(W.previewResource,A.VSBuffer.fromString((H==null?void 0:H.content)||""));const q=H&&!H.hasConflicts?await this.getAcceptResult(W,W.previewResource,void 0,u):void 0;j.push(Object.assign(Object.assign({},W),{acceptResult:q,mergeState:(H==null?void 0:H.hasConflicts)?"conflict":q?"accepted":"preview",localChange:q?q.localChange:H?H.localChange:W.localChange,remoteChange:q?q.remoteChange:H?H.remoteChange:W.remoteChange}))}}return{remoteUserData:h,lastSyncUserData:S,resourcePreviews:j,isLastSyncFromCurrentMachine:$}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),S=JSON.parse(h.value.toString()),I=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=S.version&&I&&S.version!==I,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${S.version} is not compatible with current sync state version ${I}.`),await this.resetLocal(),null;const u=S;if(u.content===null)return{ref:S.ref,syncData:null};const L=JSON.parse(u.content);if(i(L))return Object.assign(Object.assign({},S),{syncData:L,content:void 0})}catch(h){h instanceof U.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,S={}){if(S.ref||S.content||S.version)throw new Error("Cannot have core properties as additional");const I=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),u=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:I},S);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(u)))}async getRemoteUserData(h){const{ref:S,content:I}=await this.getUserData(h);let u=null;return I!==null&&(u=this.parseSyncData(I)),{ref:S,syncData:u}}parseSyncData(h){try{const S=JSON.parse(h);if(i(S))return S}catch(S){this.logService.error(S)}throw new k.UserDataSyncError((0,b.localize)(1,null),k.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(h){if((0,C.isString)(h)){const S=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:S}}else{const S=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,S,this.syncHeaders)}}async updateRemoteUserData(h,S){const I=await this.currentMachineIdPromise,u={version:this.version,machineId:I,content:h};return S=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(u),S,this.syncHeaders),{ref:S,syncData:u}}async backupLocal(h){const S={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(S))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};n=ue([Y(1,U.IFileService),Y(2,T.IEnvironmentService),Y(3,y.IStorageService),Y(4,k.IUserDataSyncStoreService),Y(5,k.IUserDataSyncBackupStoreService),Y(6,k.IUserDataSyncResourceEnablementService),Y(7,d.ITelemetryService),Y(8,k.IUserDataSyncLogService),Y(9,o.IConfigurationService)],n),e.AbstractSynchroniser=n;let r=class extends n{constructor(h,S,I,u,L,_,$,B,M,j,W){super(S,I,u,L,_,$,B,M,j,W);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,S,I){try{S?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(h),I?void 0:S):await this.fileService.createFile(this.file,A.VSBuffer.fromString(h),{overwrite:I})}catch(u){throw u instanceof U.FileOperationError&&u.fileOperationResult===1||u instanceof U.FileOperationError&&u.fileOperationResult===3?new k.UserDataSyncError(u.message,k.UserDataSyncErrorCode.LocalPreconditionFailed):u}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};r=ue([Y(2,U.IFileService),Y(3,T.IEnvironmentService),Y(4,y.IStorageService),Y(5,k.IUserDataSyncStoreService),Y(6,k.IUserDataSyncBackupStoreService),Y(7,k.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,k.IUserDataSyncLogService),Y(10,o.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let l=class extends r{constructor(h,S,I,u,L,_,$,B,M,j,W,z){super(h,S,I,u,L,_,$,B,M,j,z);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(h){const S=[];return(0,m.parse)(h,S,{allowEmptyContent:!0,allowTrailingComma:!0}),S.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};l=ue([Y(2,U.IFileService),Y(3,T.IEnvironmentService),Y(4,y.IStorageService),Y(5,k.IUserDataSyncStoreService),Y(6,k.IUserDataSyncBackupStoreService),Y(7,k.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,k.IUserDataSyncLogService),Y(10,k.IUserDataSyncUtilService),Y(11,o.IConfigurationService)],l),e.AbstractJsonFileSynchroniser=l;let a=class{constructor(h,S,I,u){this.resource=h,this.environmentService=S,this.logService=I,this.fileService=u,this.extUri=this.fileService.hasCapability(S.userDataSyncHome,1024)?f.extUri:f.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,S,f.extUri)}async initialize({ref:h,content:S}){if(!S){this.logService.info("Remote content does not exist.",this.resource);return}const I=this.parseSyncData(S);if(!!I){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:h,syncData:I})}catch(L){this.logService.error(L)}}}parseSyncData(h){try{const S=JSON.parse(h);if(i(S))return S}catch(S){this.logService.error(S)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,S={}){const I=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},S);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(I)))}};a=ue([Y(1,T.IEnvironmentService),Y(2,k.IUserDataSyncLogService),Y(3,U.IFileService)],a),e.AbstractInitializer=a}),define(Z[184],ee([0,1,20,3,10,29,33,8,24,181,45,25,5,46,41,21,19,30,83,13,82,6]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(c,h){const S=JSON.parse(c.content);if(c.version===1||c.version===2){const I=(await h.getInstalled(0)).filter(u=>u.isBuiltin);for(const u of S)c.version===1&&(u.enabled===!1&&(u.disabled=!0),delete u.enabled),c.version===2&&I.every(L=>!(0,k.areSameExtensions)(L.identifier,u.identifier))&&(u.installed=!0)}return S}function n(c,h,S){const I=S.get((0,k.getExtensionId)(c,h),0)||"{}";return JSON.parse(I)}function r(c,h,S,I){I.store((0,k.getExtensionId)(c,h),JSON.stringify(S),0,1)}let l=class rt extends R.AbstractSynchroniser{constructor(h,S,I,u,L,_,$,B,M,j,W,z,H,q){super("extensions",S,h,I,u,L,z,H,M,W);this.storageService=I,this.extensionManagementService=_,this.extensionEnablementService=$,this.ignoredExtensionsManagementService=B,this.extensionGalleryService=j,this.extensionsStorageSyncService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(U.Event.debounce(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,D=>!!D.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,D=>!D.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,S){const I=h.syncData?await t(h.syncData,this.extensionManagementService):null,u=(S==null?void 0:S.skippedExtensions)||[],L=(S==null?void 0:S.syncData)?await t(S.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(),$=this.getLocalExtensions(_),B=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:M,removed:j,updated:W,remote:z}=(0,g.merge)($,I,L,u,B),H={added:M,removed:j,updated:W,remote:z,content:this.getPreviewContent($,M,W,j),localChange:M.length>0||j.length>0||W.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:u,localResource:this.localResource,localContent:this.format($),localExtensions:$,remoteResource:this.remoteResource,remoteContent:I?this.format(I):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,S,I,u){const L=[...S,...I],_=new Set,$=B=>{_.add(B.id.toLowerCase()),B.uuid&&_.add(B.uuid)};L.forEach(({identifier:B})=>$(B)),u.forEach($);for(const B of h)_.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&_.has(B.identifier.uuid)||L.push(B);return this.format(L)}async getMergeResult(h,S){return Object.assign(Object.assign({},h.previewResult),{hasConflicts:!1})}async getAcceptResult(h,S,I,u){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(S,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(h){const S=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),u=(0,g.merge)(h.localExtensions,null,null,h.skippedExtensions,I),{added:L,removed:_,updated:$,remote:B}=u;return{content:h.localContent,added:L,removed:_,updated:$,remote:B,localChange:L.length>0||_.length>0||$.length>0?2:0,remoteChange:B!==null?2:0}}async acceptRemote(h){const S=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),u=h.remoteContent?JSON.parse(h.remoteContent):null;if(u!==null){const L=(0,g.merge)(h.localExtensions,u,h.localExtensions,[],I),{added:_,removed:$,updated:B,remote:M}=L;return{content:h.remoteContent,added:_,removed:$,updated:B,remote:M,localChange:_.length>0||$.length>0||B.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:h.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(h,S,I,u){let{skippedExtensions:L,localExtensions:_}=I[0][0],{added:$,removed:B,updated:M,remote:j,localChange:W,remoteChange:z}=I[0][1];if(W===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),W!==0&&(await this.backupLocal(JSON.stringify(_)),L=await this.updateLocalExtensions($,B,M,L)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const H=JSON.stringify(j);h=await this.updateRemoteUserData(H,u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(S==null?void 0:S.ref)!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:L}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:rt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,rt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),L=this.getLocalExtensions(I).filter(_=>!u.some($=>(0,k.areSameExtensions)({id:$},_.identifier)));return this.format(L)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let S=await super.resolveContent(h);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(h)),S){const I=this.parseSyncData(S);if(I)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(I))}}return null}format(h){h.sort((u,L)=>!u.identifier.uuid&&L.identifier.uuid?-1:u.identifier.uuid&&!L.identifier.uuid?1:(0,C.compare)(u.identifier.id,L.identifier.id));const S=JSON.stringify(h),I=(0,b.format)(S,void 0,{});return(0,o.applyEdits)(S,I)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(I=>I.installed||I.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,S,I,u){const L=[],_=[],$=await this.extensionManagementService.getInstalled();if(S.length){const M=$.filter(({identifier:j,isBuiltin:W})=>!W&&S.some(z=>(0,k.areSameExtensions)(j,z)));await i.Promises.settled(M.map(async j=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,j.identifier.id),await this.extensionManagementService.uninstall(j,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,j.identifier.id),L.push(j.identifier)}))}(h.length||I.length)&&await i.Promises.settled([...h,...I].map(async M=>{const j=$.find(z=>(0,k.areSameExtensions)(z.identifier,M.identifier));if(j&&j.isBuiltin){M.state&&j.manifest.version===M.version&&this.updateExtensionState(M.state,j.manifest.publisher,j.manifest.name,j.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),L.push(M.identifier);return}const W=await this.extensionGalleryService.getCompatibleExtension(M.identifier);if(M.state&&(j?j.manifest.version===M.version:!!W)){const z=j?j.manifest.publisher:W.publisher,H=j?j.manifest.name:W.name;this.updateExtensionState(M.state,z,H,j==null?void 0:j.manifest.version)}if(W)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,W.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,W.version)),j||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,W.version),await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,W.version),L.push(W.identifier))}catch(z){_.push(M),this.logService.error(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else _.push(M)}));const B=[];for(const M of u)L.some(j=>(0,k.areSameExtensions)(j,M.identifier))||B.push(M);for(const M of _)B.some(j=>(0,k.areSameExtensions)(j.identifier,M.identifier))||B.push(M);return B}updateExtensionState(h,S,I,u){const L=n(S,I,this.storageService),_=u?this.extensionsStorageSyncService.getKeysForSync({id:(0,k.getGalleryExtensionId)(S,I),version:u}):void 0;_?_.forEach($=>{L[$]=h[$]}):Object.keys(h).forEach($=>L[$]=h[$]),r(S,I,L,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const S=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:I,isBuiltin:u,manifest:L})=>{const _={identifier:I,version:L.version};S.some($=>(0,k.areSameExtensions)($,I))&&(_.disabled=!0),u||(_.installed=!0);try{const $=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:L.version});if($){const B=n(L.publisher,L.name,this.storageService);_.state=Object.keys(B).reduce((M,j)=>($.includes(j)&&(M[j]=B[j]),M),{})}}catch($){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,y.getErrorMessage)($))}return _})}};l.EXTENSIONS_DATA_URI=m.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),l=ue([Y(0,A.IEnvironmentService),Y(1,T.IFileService),Y(2,E.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,P.IExtensionManagementService),Y(6,P.IGlobalExtensionEnablementService),Y(7,w.IIgnoredExtensionsManagementService),Y(8,v.IUserDataSyncLogService),Y(9,P.IExtensionGalleryService),Y(10,f.IConfigurationService),Y(11,v.IUserDataSyncResourceEnablementService),Y(12,d.ITelemetryService),Y(13,s.IExtensionsStorageSyncService)],l),e.ExtensionsSynchroniser=l;let a=class extends R.AbstractInitializer{constructor(h,S,I,u,L,_,$,B){super("extensions",$,B,_);this.extensionManagementService=h,this.galleryService=S,this.extensionEnablementService=I,this.storageService=u,this.ignoredExtensionsManagementService=L}async doInitialize(h){const S=h.syncData?await t(h.syncData,this.extensionManagementService):null;if(!S){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(S)}async initializeRemoteExtensions(h){const S=[],I=await this.extensionManagementService.getInstalled(),u=new Map,L=[],_={names:[],uuids:[]},$=[];for(const B of h)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(B.identifier.id)){const M=I.find(j=>(0,k.areSameExtensions)(j.identifier,B.identifier));M?(L.push({syncExtension:B,installedExtension:M}),B.disabled&&$.push(B.identifier)):B.installed&&(u.set(B.identifier.id.toLowerCase(),B),B.identifier.uuid?_.uuids.push(B.identifier.uuid):_.names.push(B.identifier.id),B.disabled&&$.push(B.identifier))}for(const{syncExtension:B,installedExtension:M}of L)if(B.state){const j=n(M.manifest.publisher,M.manifest.name,this.storageService);Object.keys(B.state).forEach(W=>j[W]=B.state[W]),r(M.manifest.publisher,M.manifest.name,j,this.storageService)}if($.length)for(const B of $)this.logService.trace("Disabling extension...",B.id),await this.extensionEnablementService.disableExtension(B),this.logService.info("Disabling extension",B.id);if(_.names.length||_.uuids.length){const B=(await this.galleryService.query({ids:_.uuids,names:_.names,pageSize:_.uuids.length+_.names.length},p.CancellationToken.None)).firstPage;for(const M of B)try{const j=u.get(M.identifier.id.toLowerCase());j.state&&r(M.publisher,M.name,j.state,this.storageService),this.logService.trace("Installing extension...",M.identifier.id);const W=await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1});$.some(z=>(0,k.areSameExtensions)(z,M.identifier))||S.push(W),this.logService.info("Installed extension.",M.identifier.id)}catch(j){this.logService.error(j)}}return S}};a=ue([Y(0,P.IExtensionManagementService),Y(1,P.IExtensionGalleryService),Y(2,P.IGlobalExtensionEnablementService),Y(3,E.IStorageService),Y(4,w.IIgnoredExtensionsManagementService),Y(5,T.IFileService),Y(6,A.IEnvironmentService),Y(7,v.IUserDataSyncLogService)],a),e.ExtensionsInitializer=a}),define(Z[185],ee([0,1,26,20]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(T,f,g,R,d){if(!f)return{remote:Object.keys(T).length>0?T:null,local:{added:{},removed:[],updated:{}}};const m=P(T,f);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=g?P(g,f):{added:Object.keys(f).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},o=g?P(g,T):{added:Object.keys(T).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},E=v.deepClone(f),p=!g;for(const w of o.added.values())w!==U.SYNC_SERVICE_URL_TYPE&&p&&b.added.has(w)||(E[w]=T[w]);for(const w of o.updated.values())E[w]=T[w];for(const w of o.removed.values())R.unregistered.includes(w)||delete E[w];for(const w of b.added.values()){const y=f[w];if(R.machine.includes(w)){d.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(!(g&&o.added.has(w))){const s=T[w];s&&s.value===y.value||w===U.SYNC_SERVICE_URL_TYPE&&p&&o.added.has(w)||(s?C.updated[w]=y:C.added[w]=y)}}for(const w of b.updated.values()){const y=f[w];if(R.machine.includes(w)){d.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(!(o.updated.has(w)||o.removed.has(w))){const s=T[w];s&&s.value===y.value||(C.updated[w]=y)}}for(const w of b.removed.values()){if(R.machine.includes(w)){d.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}o.updated.has(w)||o.removed.has(w)||C.removed.push(w)}return{local:C,remote:k(E,f)?null:E}}e.merge=A;function P(T,f){const g=Object.keys(T),R=Object.keys(f),d=R.filter(o=>g.indexOf(o)===-1).reduce((o,C)=>(o.add(C),o),new Set),m=g.filter(o=>R.indexOf(o)===-1).reduce((o,C)=>(o.add(C),o),new Set),b=new Set;for(const o of g)if(!m.has(o)){const C=T[o],E=f[o];v.equals(C,E)||b.add(o)}return{added:d,removed:m,updated:b}}function k(T,f){const{added:g,removed:R,updated:d}=P(T,f);return g.size===0&&R.size===0&&d.size===0}}),define(Z[186],ee([0,1,20,22,3,10,8,51,185,32,45,25,24,5,46,41,19,7,44,31,12]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",t=["locale"];function n(h){const S=h.storage?Object.keys(h.storage).sort():[],I={};S.forEach(_=>I[_]=h.storage[_]),h.storage=I;const u=JSON.stringify(h),L=(0,o.format)(u,void 0,{});return(0,C.applyEdits)(u,L)}const r=1;let l=class st extends R.AbstractSynchroniser{constructor(S,I,u,L,_,$,B,M,j){super("globalState",S,_,j,I,u,$,B,L,M);this.environmentService=_,this.storageService=j,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(S.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),A.Event.filter(j.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:j.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(S,I,u){const L=S.syncData?JSON.parse(S.syncData.content):null,_=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();L?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(_),{local:M,remote:j}=(0,f.merge)($.storage,L?L.storage:null,_?_.storage:null,B,this.logService),W={content:null,local:M,remote:j,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:n($),localUserData:$,remoteResource:this.remoteResource,remoteContent:L?n(L):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(S,I){return Object.assign(Object.assign({},S.previewResult),{hasConflicts:!1})}async getAcceptResult(S,I,u,L){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(S);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(S);if(this.extUri.isEqual(I,this.previewResource))return S.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(S){return{content:S.localContent,local:{added:{},removed:[],updated:{}},remote:S.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(S){if(S.remoteContent!==null){const I=JSON.parse(S.remoteContent),{local:u,remote:L}=(0,f.merge)(S.localUserData.storage,I.storage,null,S.storageKeys,this.logService);return{content:S.remoteContent,local:u,remote:L,localChange:Object.keys(u.added).length>0||Object.keys(u.updated).length>0||u.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:S.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(S,I,u,L){let{localUserData:_}=u[0][0],{local:$,remote:B,localChange:M,remoteChange:j}=u[0][1];if(M===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:B});S=await this.updateRemoteUserData(W,L?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(I==null?void 0:I.ref)!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:S}){return[{resource:this.extUri.joinPath(S,"globalState.json"),comparableResource:st.GLOBAL_STATE_DATA_URI}]}async resolveContent(S){if(this.extUri.isEqual(S,st.GLOBAL_STATE_DATA_URI)){const u=await this.getLocalGlobalState();return n(u)}if(this.extUri.isEqual(this.remoteResource,S)||this.extUri.isEqual(this.localResource,S)||this.extUri.isEqual(this.acceptedResource,S))return this.resolvePreviewContent(S);let I=await super.resolveContent(S);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(S)),I){const u=this.parseSyncData(I);if(u)switch(this.extUri.basename(S)){case"globalState.json":return n(JSON.parse(u.content))}}return null}async hasLocalData(){var S;try{const{storage:I}=await this.getLocalGlobalState();if(Object.keys(I).length>1||((S=I[`${i}.locale`])===null||S===void 0?void 0:S.value)!=="en")return!0}catch(I){}return!1}async getLocalGlobalState(){const S={},I=await this.getLocalArgvContent(),u=(0,g.parse)(I);for(const L of t)u[L]!==void 0&&(S[`${i}${L}`]={version:1,value:u[L]});for(const L of this.storageService.keys(0,0)){const _=this.storageService.get(L,0);_&&(S[L]={version:1,value:_})}return{storage:S}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(S){}return"{}"}async writeLocalGlobalState({added:S,removed:I,updated:u}){const L={},_={},$=(M,j)=>{for(const W of M){if(W.startsWith(i)){L[W.substring(i.length)]=j?j[W].value:void 0;continue}if(j){const z=j[W];z.value!==String(this.storageService.get(W,0))&&(_[W]=z.value)}else this.storageService.get(W,0)!==void 0&&(_[W]=void 0)}};if($(Object.keys(S),S),$(Object.keys(u),u),$(I),Object.keys(L).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(L),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(_))this.storageService.store(M,_[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(S){const I=await this.getLocalArgvContent();let u=I;for(const L of Object.keys(S))u=(0,T.edit)(u,[L],S[L],{});I!==u&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,U.VSBuffer.fromString(u)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(S){const I=this.storageService.keys(0,0),u=this.storageService.keys(0,1),L=[...I,...u],_=(S==null?void 0:S.storage)?Object.keys(S.storage).filter($=>!$.startsWith(i)&&!L.includes($)&&this.storageService.get($,0)!==void 0):[];if(!p.isWeb){const $=[...v.ALL_SYNC_RESOURCES.map(B=>(0,v.getEnablementKey)(B)),v.SYNC_SERVICE_URL_TYPE];_.push(...$),u.push(...$)}return{user:I,machine:u,unregistered:_}}};l.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=ue([Y(0,k.IFileService),Y(1,v.IUserDataSyncStoreService),Y(2,v.IUserDataSyncBackupStoreService),Y(3,v.IUserDataSyncLogService),Y(4,P.IEnvironmentService),Y(5,v.IUserDataSyncResourceEnablementService),Y(6,d.ITelemetryService),Y(7,m.IConfigurationService),Y(8,E.IStorageService)],l),e.GlobalStateSynchroniser=l;let a=class extends R.AbstractInitializer{constructor(S,I,u,L){super("globalState",u,L,I);this.storageService=S}async doInitialize(S){const I=S.syncData?JSON.parse(S.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const u={},L={};for(const _ of Object.keys(I.storage))_.startsWith(i)?u[_.substring(i.length)]=I.storage[_].value:this.storageService.get(_,0)===void 0&&(L[_]=I.storage[_].value);if(Object.keys(u).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch($){}for(const $ of Object.keys(u))_=(0,T.edit)(_,[$],u[$],{});await this.fileService.writeFile(this.environmentService.argvResource,U.VSBuffer.fromString(_))}if(Object.keys(L).length)for(const _ of Object.keys(L))this.storageService.store(_,L[_],0,0)}};a=ue([Y(0,E.IStorageService),Y(1,k.IFileService),Y(2,P.IEnvironmentService),Y(3,v.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let c=class{constructor(S,I,u,L,_){this.userDataSyncStoreClient=S,this.storageService=I,this.environmentService=u,this.fileService=L,this.logService=_}getSyncStoreType(S){var I;const u=this.parseGlobalState(S);return(I=u==null?void 0:u.storage[v.SYNC_SERVICE_URL_TYPE])===null||I===void 0?void 0:I.value}async sync(S){const I=(0,v.createSyncHeaders)((0,y.generateUuid)());try{return await this.doSync(S,I)}catch(u){if(u instanceof v.UserDataSyncError)switch(u.code){case v.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(S,I)}throw u}}async doSync(S,I){const u=await this.userDataSyncStoreClient.read("globalState",null,I),L=this.parseGlobalState(u)||{storage:{}};L.storage[v.SYNC_SERVICE_URL_TYPE]={value:S,version:r};const _=await(0,w.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:r,machineId:_,content:n(L)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),u.ref,I)}parseGlobalState({content:S}){if(!S)return null;const I=JSON.parse(S);if((0,R.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};c=ue([Y(1,E.IStorageService),Y(2,P.IEnvironmentService),Y(3,k.IFileService),Y(4,s.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[187],ee([0,1,8,20,182,32,121,10,24,7,17,18,45,25,19,22,3]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(s,i){const t=JSON.parse(s);if(!i)return(0,R.isUndefined)(t.all)?null:t.all;switch(g.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=p;let w=class extends m.AbstractJsonFileSynchroniser{constructor(i,t,n,r,l,a,c,h,S,I){super(c.keybindingsResource,"keybindings",a,c,h,i,t,l,I,n,S,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(E.Event.filter(r.onDidChangeConfiguration,u=>u.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,t,n){const r=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null,l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,a=await this.getLocalFileContent(),c=await this.getFormattingOptions();let h=null,S=!1,I=!1,u=!1;if(r){let _=a?a.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new U.UserDataSyncError((0,k.localize)(0,null),U.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==_||l!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await(0,A.merge)(_,r,l,c,this.userDataSyncUtilService);$.hasChanges&&(h=$.mergeContent,u=$.hasConflicts,S=u||$.mergeContent!==_,I=u||$.mergeContent!==r)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=a.value.toString(),I=!0);const L={content:h,localChange:S?a?2:1:0,remoteChange:I?2:0,hasConflicts:u};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async getMergeResult(i,t){return i.previewResult}async getAcceptResult(i,t,n,r){if(this.extUri.isEqual(t,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(i,t,n,r){var l;const{fileContent:a}=n[0][0];let{content:c,localChange:h,remoteChange:S}=n[0][1];if(h===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new U.UserDataSyncError((0,k.localize)(1,null),U.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(c||"[]",a,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const I=this.toSyncContent(c||"[]",(l=i.syncData)===null||l===void 0?void 0:l.content);i=await this.updateRemoteUserData(I,r?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(I){}(t==null?void 0:t.ref)!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const t=(0,P.parse)(i.value.toString());if((0,d.isNonEmptyArray)(t))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:t}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let t=await super.resolveContent(i);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(i)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(i)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(n.content)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(i.syncData.content)}getKeybindingsContentFromSyncContent(i){try{return p(i,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(i,t){let n={};try{n=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=i,g.OS){case 2:n.mac=i;break;case 3:n.linux=i;break;case 1:n.windows=i;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){let i=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return i!==void 0||(i=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,i!==void 0)?i:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=ue([Y(0,U.IUserDataSyncStoreService),Y(1,U.IUserDataSyncBackupStoreService),Y(2,U.IUserDataSyncLogService),Y(3,f.IConfigurationService),Y(4,U.IUserDataSyncResourceEnablementService),Y(5,v.IFileService),Y(6,T.IEnvironmentService),Y(7,o.IStorageService),Y(8,U.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],w),e.KeybindingsSynchroniser=w;let y=class extends m.AbstractInitializer{constructor(i,t,n){super("keybindings",t,n,i)}async doInitialize(i){const t=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,P.parse)(i.value.toString());return!(0,d.isNonEmptyArray)(t)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return p(i,!0)}catch(t){return this.logService.error(t),null}}};y=ue([Y(0,v.IFileService),Y(1,T.IEnvironmentService),Y(2,U.IUserDataSyncLogService)],y),e.KeybindingsInitializer=y}),define(Z[188],ee([0,1,26,32,41,46,51,20,18]),function(K,e,v,U,A,P,k,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function g(c,h,S){let I=[];S?I=d(S):I=R(h);const u=[],L=[...(0,T.getDisallowedIgnoredSettings)()];if(Array.isArray(I))for(const _ of I)_.startsWith("-")?L.push(_.substring(1)):u.push(_);return(0,f.distinct)([...c,...u].filter(_=>L.indexOf(_)===-1))}e.getIgnoredSettings=g;function R(c){let h=c.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=c.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:c.getValue("settingsSync.ignoredSettings")||[]}function d(c){const h=(0,U.parse)(c);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function m(c,h,S,I){if(S.length){const u=a(h),L=(0,U.parse)(h),_=(0,U.parse)(c),$=[];for(const B of S){const M=L[B],j=_[B];M===void 0?c=k.edit(c,[B],void 0,I):j!==void 0?c=k.edit(c,[B],M,I):$.push(i(B,u))}$.sort((B,M)=>B.startOffset-M.startOffset),$.forEach(B=>c=p(B.setting.key,h,c,I))}return c}e.updateIgnoredSettings=m;function b(c,h,S,I,u,L){const _=m(c,h,I,L),$=S!==_,B=S!==h;if(!$&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!B)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(B&&!$)return{conflictsSettings:[],localContent:m(h,c,I,L),remoteContent:null,hasConflicts:!1};if(S===null&&C(c)){const ie=o(c,h,I)?null:m(h,c,I,L);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let M=c,j=h;const W=(0,U.parse)(c),z=(0,U.parse)(h),H=S?(0,U.parse)(S):null,q=I.reduce((ie,ae)=>(ie.add(ae),ie),new Set),D=E(W,z,q),O=E(H,W,q),F=E(H,z,q),N=new Map,V=new Set,G=ie=>{V.add(ie);const ae=u.filter(({key:he})=>he===ie)[0];ae?(M=k.edit(M,[ie],ae.value,L),j=k.edit(j,[ie],ae.value,L)):N.set(ie,{key:ie,localValue:W[ie],remoteValue:z[ie]})};for(const ie of O.removed.values())F.updated.has(ie)?G(ie):j=k.edit(j,[ie],void 0,L);for(const ie of F.removed.values())V.has(ie)||(O.updated.has(ie)?G(ie):M=k.edit(M,[ie],void 0,L));for(const ie of O.updated.values())V.has(ie)||(F.updated.has(ie)?D.updated.has(ie)&&G(ie):j=k.edit(j,[ie],W[ie],L));for(const ie of F.updated.values())V.has(ie)||(O.updated.has(ie)?D.updated.has(ie)&&G(ie):M=k.edit(M,[ie],z[ie],L));for(const ie of O.added.values())V.has(ie)||(F.added.has(ie)?D.updated.has(ie)&&G(ie):j=p(ie,M,j,L));for(const ie of F.added.values())V.has(ie)||(O.added.has(ie)?D.updated.has(ie)&&G(ie):M=p(ie,j,M,L));const Q=N.size>0||!o(M,j,I),X=Q||!o(M,c,[]),ne=Q||!o(j,h,[]);return{localContent:X?M:null,remoteContent:ne?j:null,conflictsSettings:[...N.values()],hasConflicts:Q}}e.merge=b;function o(c,h,S){if(c===h)return!0;const I=(0,U.parse)(c),u=(0,U.parse)(h),L=S.reduce((B,M)=>(B.add(M),B),new Set),_=a(c).filter(B=>!(B.setting&&L.has(B.setting.key))),$=a(h).filter(B=>!(B.setting&&L.has(B.setting.key)));if(_.length!==$.length)return!1;for(let B=0;B<_.length;B++){const M=_[B],j=$[B];if(M.setting&&j.setting){if(M.setting.key!==j.setting.key||!v.equals(I[M.setting.key],u[M.setting.key]))return!1}else if(!M.setting&&!j.setting){if(M.value!==j.value)return!1}else return!1}return!0}e.areSame=o;function C(c){return c?a(c).length===0:!0}e.isEmpty=C;function E(c,h,S){const I=c?Object.keys(c).filter(B=>!S.has(B)):[],u=Object.keys(h).filter(B=>!S.has(B)),L=u.filter(B=>I.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),_=I.filter(B=>u.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),$=new Set;if(c){for(const B of I)if(!_.has(B)){const M=c[B],j=h[B];v.equals(M,j)||$.add(B)}}return{added:L,removed:_,updated:$}}function p(c,h,S,I){const u=(0,U.parse)(h),L=a(h),_=a(S),$=w(c,L,_);return y(S,c,u[c],$,_,I)}e.addSetting=p;function w(c,h,S){const I=h.findIndex(L=>{var _;return((_=L.setting)===null||_===void 0?void 0:_.key)===c}),u=h[I-1];if(u){if(u.setting){const _=i(u.setting.key,S);if(_)return{index:S.indexOf(_),insertAfter:!0}}else{const _=t(I,h);if(_){const $=i(_.setting.key,S);if($){const B=n(S.indexOf($),S),M=r(h,_,h[I]);if(B){const j=r(S,$,B),W=l(M,j);return W?{index:S.indexOf(W),insertAfter:!0}:{index:S.indexOf(B),insertAfter:!1}}else{const j=r(S,$,S[S.length-1]),W=l(M,j);return W?{index:S.indexOf(W),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const L=h[I+1];if(L)if(L.setting){const _=i(L.setting.key,S);if(_)return{index:S.indexOf(_),insertAfter:!1}}else{const _=n(I,h);if(_){const $=i(_.setting.key,S);if($){const B=t(S.indexOf($),S),M=r(h,h[I],_);if(B){const j=r(S,B,$),W=l(M.reverse(),j.reverse());return W?{index:S.indexOf(W),insertAfter:!1}:{index:S.indexOf(B),insertAfter:!0}}else{const j=r(S,S[0],$),W=l(M.reverse(),j.reverse());return W?{index:S.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function y(c,h,S,I,u,L){let _;return I.index===-1?_=(0,A.setProperty)(c,[h],S,L):_=s(c,h,S,I,u,L).map($=>(0,A.withFormatting)(c,$,L)[0]),(0,A.applyEdits)(c,_)}function s(c,h,S,I,u,L){var _;const $=`${JSON.stringify(h)}: ${JSON.stringify(S)}`,B=(0,P.getEOL)(L,c),M=u[I.index];if(I.insertAfter){const j=[];if(M.setting)j.push({offset:M.endOffset,length:0,content:","+$});else{const W=n(I.index,u),z=t(I.index,u),H=(_=z==null?void 0:z.setting)===null||_===void 0?void 0:_.commaOffset;z&&H===void 0&&j.push({offset:z.endOffset,length:0,content:","});const q=H!==void 0&&H>M.endOffset;j.push({offset:q?H+1:M.endOffset,length:0,content:W?B+$+",":B+$})}return j}else{if(M.setting)return[{offset:M.startOffset,length:0,content:$+","}];const j=(u[I.index-1]&&!u[I.index-1].setting?B:"")+$+(n(I.index,u)?",":"")+B;return[{offset:M.startOffset,length:0,content:j}]}}function i(c,h){return h.filter(S=>{var I;return((I=S.setting)===null||I===void 0?void 0:I.key)===c})[0]}function t(c,h){for(let S=c-1;S>=0;S--)if(h[S].setting)return h[S]}function n(c,h){for(let S=c+1;S<h.length;S++)if(h[S].setting)return h[S]}function r(c,h,S){const I=c.indexOf(h),u=c.indexOf(S);return c.filter((L,_)=>I<_&&_<u)}function l(c,h){if(c.length&&h.length){let S=0;for(;S<h.length&&S<c.length;S++)if(c[S].value!==h[S].value)return h[S-1];return h[S-1]}}function a(c){const h=[];let S=-1,I,u;const L={onObjectBegin:_=>{S++},onObjectProperty:(_,$,B)=>{S===0&&(I=$,u=_)},onObjectEnd:(_,$)=>{S--,S===0&&h.push({startOffset:I,endOffset:_+$,value:c.substring(I,_+$),setting:{key:u,commaOffset:void 0}})},onArrayBegin:(_,$)=>{S++},onArrayEnd:(_,$)=>{S--,S===0&&h.push({startOffset:I,endOffset:_+$,value:c.substring(I,_+$),setting:{key:u,commaOffset:void 0}})},onLiteralValue:(_,$,B)=>{S===0&&h.push({startOffset:I,endOffset:$+B,value:c.substring(I,$+B),setting:{key:u,commaOffset:void 0}})},onSeparator:(_,$,B)=>{if(S===0&&_===","){let M=h.length-1;for(;M>=0&&!h[M].setting;M--);const j=h[M];j&&h.splice(M,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:$}})}},onComment:(_,$)=>{S===0&&h.push({startOffset:_,endOffset:_+$,value:c.substring(_,_+$)})}};return(0,U.visit)(c,L),h}}),define(Z[189],ee([0,1,8,20,22,122,3,10,24,188,51,45,25,29,19,41]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function E(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const t=JSON.parse(i);return E(t)?t:{settings:i}}e.parseSettingsSyncContent=p;let w=class extends d.AbstractJsonFileSynchroniser{constructor(t,n,r,l,a,c,h,S,I,u,L){super(n.settingsResource,"settings",t,n,r,l,a,I,u,c,h,S);this.extensionManagementService=L,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,n,r){const l=await this.getLocalFileContent(),a=await this.getFormattingOptions(),c=this.getSettingsSyncContent(t),h=n?this.getSettingsSyncContent(n):null,S=await this.getIgnoredSettings();let I=null,u=!1,L=!1,_=!1;if(c){let B=l?l.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,g.merge)(B,c.settings,h?h.settings:null,S,[],a);I=M.localContent||M.remoteContent,u=M.localContent!==null,L=M.remoteContent!==null,_=M.hasConflicts}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),I=l.value.toString(),L=!0);const $={content:I,localChange:u?2:0,remoteChange:L?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,n){const r=await this.getFormattingOptions(),l=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,g.updateIgnoredSettings)(t.previewResult.content,"{}",l,r):null})}async getAcceptResult(t,n,r,l){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:t.fileContent?(0,g.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:t.remoteContent!==null?(0,g.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,g.updateIgnoredSettings)(r,t.fileContent?t.fileContent.value.toString():"{}",c,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(t,n,r,l){const{fileContent:a}=r[0][0];let{content:c,localChange:h,remoteChange:S}=r[0][1];if(h===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(c,a,l),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),S!==0){const I=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),L=await this.getIgnoredSettings(c);c=(0,g.updateIgnoredSettings)(c,u?u.settings:"{}",L,I),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),l?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(I){}(n==null?void 0:n.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const n=await this.getFormattingOptions(),r=(0,R.edit)(t.value.toString(),[U.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,g.isEmpty)(r)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:n}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let n=await super.resolveContent(t);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(t)),n){const r=this.parseSyncData(n);if(r){const l=this.parseSettingsSyncContent(r.content);if(l)switch(this.extUri.basename(t)){case"settings.json":return l.settings}}}return null}async resolvePreviewContent(t){let n=await super.resolvePreviewContent(t);if(n){const r=await this.getFormattingOptions(),l=await this.getIgnoredSettings();n=(0,g.updateIgnoredSettings)(n,"{}",l,r)}return n}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return p(t)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,l=>!!l.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,l=>!l.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,g.getIgnoredSettings)(n,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new U.UserDataSyncError((0,P.localize)(0,null),U.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const n=JSON.parse(t.value.toString());if(!s(n))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(n.content);if(!r||!r.settings)return;let l=r.settings;const a=await this.getFormattingOptions();for(const c in n)if(["version","content","machineId"].indexOf(c)===-1&&n[c]!==void 0){const h=(0,C.setProperty)(l,[c],n[c],a);h.length&&(l=(0,C.applyEdits)(l,h))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(l))}catch(t){}}};w=ue([Y(0,v.IFileService),Y(1,T.IEnvironmentService),Y(2,o.IStorageService),Y(3,U.IUserDataSyncStoreService),Y(4,U.IUserDataSyncBackupStoreService),Y(5,U.IUserDataSyncLogService),Y(6,U.IUserDataSyncUtilService),Y(7,f.IConfigurationService),Y(8,U.IUserDataSyncResourceEnablementService),Y(9,m.ITelemetryService),Y(10,b.IExtensionManagementService)],w),e.SettingsSynchroniser=w;let y=class extends d.AbstractInitializer{constructor(t,n,r){super("settings",n,r,t)}async doInitialize(t){const n=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,g.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return p(t)}catch(n){this.logService.error(n)}return null}};y=ue([Y(0,v.IFileService),Y(1,T.IEnvironmentService),Y(2,U.IUserDataSyncLogService)],y),e.SettingsInitializer=y;function s(i){return!!(i&&i.version!==void 0&&typeof i.version=="number"&&i.content!==void 0&&typeof i.content=="string"&&i.machineId!==void 0&&typeof i.machineId=="string")}}),define(Z[190],ee([0,1,20,10,8,24,45,25,22,183,19,26,3]),function(K,e,v,U,A,P,k,T,f,g,R,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends k.AbstractSynchroniser{constructor(E,p,w,y,s,i,t,n,r){super("snippets",p,E,w,y,s,n,r,i,t);this.version=1,this.snippetsFolder=E.snippetsHome,this._register(this.fileService.watch(E.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(m.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(E,p,w){const y=await this.getSnippetsFileContents(),s=this.toSnippetsContents(y),i=E.syncData?this.parseSnippets(E.syncData):null,t=p&&p.syncData?this.parseSnippets(p.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,g.merge)(s,i,t);return this.getResourcePreviews(n,y,i||{})}async getMergeResult(E,p){return E.previewResult}async getAcceptResult(E,p,w,y){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:E.fileContent?E.fileContent.value.toString():null,localChange:0,remoteChange:E.fileContent?E.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:E.remoteContent,localChange:E.remoteContent!==null?E.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return w===void 0?{content:E.previewResult.content,localChange:E.previewResult.localChange,remoteChange:E.previewResult.remoteChange}:{content:w,localChange:w===null?E.fileContent!==null?3:0:2,remoteChange:w===null?E.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(E,p,w,y){const s=w.map(([i,t])=>Object.assign(Object.assign({},i),{acceptResult:t}));s.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,y)),s.some(({remoteChange:i})=>i!==0)&&(E=await this.updateRemoteSnippets(s,E,y)),(p==null?void 0:p.ref)!==E.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(E),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of s)try{await this.fileService.del(i)}catch(t){}}getResourcePreviews(E,p,w){const y=new Map;for(const s of Object.keys(E.local.added)){const i={content:E.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};y.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E.local.updated)){const i={content:E.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:p[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of E.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:p[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E.remote.added)){const i={content:E.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:p[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E.remote.updated)){const i={content:E.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s],localContent:p[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of E.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of E.conflicts){const i={content:p[s]?p[s].value.toString():null,hasConflicts:!0,localChange:p[s]?2:1,remoteChange:w[s]?2:1};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s]||null,localContent:p[s]?p[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(p))if(!y.has(s)){const i={content:p[s]?p[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[s]||null,localContent:p[s]?p[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:E}){let p=await super.resolveContent(E);if(p){const w=this.parseSyncData(p);if(w){const y=this.parseSnippets(w),s=[];for(const i of Object.keys(y)){const t=this.extUri.joinPath(E,i),n=this.extUri.joinPath(this.snippetsFolder,i),r=await this.fileService.exists(n);s.push({resource:t,comparableResource:r?n:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(E){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(E);let p=await super.resolveContent(E);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(E)),p){const w=this.parseSyncData(p);if(w)return this.parseSnippets(w)[this.extUri.basename(E)]||null}return null}async hasLocalData(){try{const E=await this.getSnippetsFileContents();if(Object.keys(E).length)return!0}catch(E){}return!1}async updateLocalBackup(E){const p={};for(const w of E)w.fileContent&&(p[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(E,p){for(const{fileContent:w,acceptResult:y,localResource:s,remoteResource:i,localChange:t}of E)if(t!==0){const n=i?this.extUri.basename(i):this.extUri.basename(s),r=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,f.VSBuffer.fromString(y.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,f.VSBuffer.fromString(y.content),p?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(E,p,w){const y=p.syncData?this.parseSnippets(p.syncData):{},s=(0,d.deepClone)(y);for(const{acceptResult:i,localResource:t,remoteResource:n,remoteChange:r}of E)if(r!==0){const l=t?this.extUri.basename(t):this.extUri.basename(n);r===3?delete s[l]:s[l]=i.content}return(0,g.areSame)(y,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(s),w?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(E){return JSON.parse(E.content)}toSnippetsContents(E){const p={};for(const w of Object.keys(E))p[w]=E[w].value.toString();return p}async getSnippetsFileContents(){const E={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof A.FileOperationError&&w.fileOperationResult===1)return E;throw w}for(const w of p.children||[]){const y=w.resource,s=this.extUri.extname(y);if(s===".json"||s===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,y),t=await this.fileService.readFile(y);E[i]=t}}return E}};b=ue([Y(0,U.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,v.IUserDataSyncLogService),Y(6,P.IConfigurationService),Y(7,v.IUserDataSyncResourceEnablementService),Y(8,T.ITelemetryService)],b),e.SnippetsSynchroniser=b;let o=class extends k.AbstractInitializer{constructor(E,p,w){super("snippets",p,w,E)}async doInitialize(E){const p=E.syncData?JSON.parse(E.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(p)){const s=p[y];if(s){const i=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(i,f.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(E)}async isEmpty(){var E;try{return!((E=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||E===void 0?void 0:E.length)}catch(p){return p.fileOperationResult===1}}};o=ue([Y(0,A.IFileService),Y(1,U.IEnvironmentService),Y(2,v.IUserDataSyncLogService)],o),e.SnippetsInitializer=o}),define(Z[59],ee([0,1,4,3,2,20]),function(K,e,v,U,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,v.createDecorator)("IUserDataSyncAccountService");let k=class extends A.Disposable{constructor(f){super();this.userDataSyncStoreService=f,this._onDidChangeAccount=this._register(new U.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new U.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(f.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(f.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(f){(f&&this._account?f.token!==this._account.token||f.authenticationProviderId!==this._account.authenticationProviderId:f!==this._account)&&(this._account=f,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(f))}};k=ue([Y(0,P.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(Z[191],ee([0,1,2,20,11,24,8,10,53,22,6]),function(K,e,v,U,A,P,k,T,f,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let d=class extends v.Disposable{constructor(b,o,C,E){super();this.environmentService=b,this.fileService=o,this.configurationService=C,this.logService=E,U.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(b){const o=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),C=await this.fileService.resolve(o);return C.children?C.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(b,o){if(!o){const C=await this.getAllRefs(b);C.length&&(o=C[C.length-1].ref)}if(o){const C=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,o);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(b,o){const C=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),E=(0,A.joinPath)(C,`${(0,f.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(E,g.VSBuffer.fromString(o))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(b)}catch(p){}}async cleanUpBackup(b){const o=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(o))return}catch(E){return}const C=await this.fileService.resolve(o);if(C.children){const E=C.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=E.filter(s=>Date.now()-this.getCreationTime(s)>p);const y=E.length-w.length;y<10&&(w=w.slice(10-y)),await R.Promises.settled(w.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};d=ue([Y(0,T.IEnvironmentService),Y(1,k.IFileService),Y(2,P.IConfigurationService),Y(3,U.IUserDataSyncLogService)],d),e.UserDataSyncBackupStoreService=d}),define(Z[192],ee([0,1,5,2]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(m){this.service=m}listen(m,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(m,b,o){switch(b){case"triggerSync":return this.service.triggerSync(o[0],o[1],o[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(o[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class P{constructor(m){this.service=m}listen(m,b){throw new Error(`Event not found: ${b}`)}call(m,b,o){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(o[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(o[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=P;class k{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=k;class T{constructor(m){this.service=m}listen(m,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(m,b,o){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(o[0],o[1]);case"setEnablement":return this.service.setEnablement(o[0],o[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=T;class f{constructor(m){this.service=m}listen(m,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(m,b,o){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(o)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=f;class g{constructor(m){this.service=m}listen(m,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(m,b,o){switch(b){case"switch":return this.service.switch(o[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=g;class R extends U.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:v.URI.revive(m.url),type:m.type,defaultUrl:v.URI.revive(m.defaultUrl),insidersUrl:v.URI.revive(m.insidersUrl),stableUrl:v.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(Z[193],ee([0,1,12,10]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends v.AbstractLogger{constructor(k,T){super();this.logger=this._register(k.createLogger(T.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...T){this.logger.trace(k,...T)}debug(k,...T){this.logger.debug(k,...T)}info(k,...T){this.logger.info(k,...T)}warn(k,...T){this.logger.warn(k,...T)}error(k,...T){this.logger.error(k,...T)}critical(k,...T){this.logger.critical(k,...T)}flush(){this.logger.flush()}};A=ue([Y(0,v.ILoggerService),Y(1,U.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,4,2,44,10,8,19,20,125,28,7,21,3]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const o="sync.currentMachineName";let C=class Ve extends U.Disposable{constructor(p,w,y,s,i,t){super();this.storageService=y,this.userDataSyncStoreService=s,this.logService=i,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(p,w,y)}async getMachines(p){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(p)).machines.map(s=>Object.assign(Object.assign({},s),{isCurrent:s.id===w}))}async addCurrentMachine(p){const w=await this.currentMachineIdPromise,y=await this.readMachinesData(p);y.machines.some(({id:s})=>s===w)||(y.machines.push({id:w,name:this.computeCurrentMachineName(y.machines)}),await this.writeMachinesData(y))}async removeCurrentMachine(p){const w=await this.currentMachineIdPromise,y=await this.readMachinesData(p),s=y.machines.filter(({id:i})=>i!==w);s.length!==y.machines.length&&(y.machines=s,await this.writeMachinesData(y))}async renameMachine(p,w,y){const s=await this.currentMachineIdPromise,i=await this.readMachinesData(y),t=i.machines.find(({id:n})=>n===p);t&&(t.name=w,await this.writeMachinesData(i),i.machines.some(({id:n})=>n===s)&&this.storageService.store(o,w,0,1))}async setEnablement(p,w){const y=await this.readMachinesData(),s=y.machines.find(({id:i})=>i===p);s&&(s.disabled=w?void 0:!0,await this.writeMachinesData(y))}computeCurrentMachineName(p){const w=this.storageService.get(o,0);if(w)return w;const y=`${this.productService.nameLong} (${(0,d.PlatformToString)(d.isWeb?0:d.platform)})`,s=new RegExp(`${(0,m.escapeRegExpCharacters)(y)}\\s#(\\d+)`);let i=0;for(const t of p){const n=s.exec(t.name),r=n?parseInt(n[1]):0;i=r>i?r:i}return`${y} #${i+1}`}async readMachinesData(p){this.userData=await this.readUserData(p);const w=this.parse(this.userData);if(w.version!==Ve.VERSION)throw new Error((0,g.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(p){var w;const y=JSON.stringify(p),s=await this.userDataSyncStoreService.write(Ve.RESOURCE,y,((w=this.userData)===null||w===void 0?void 0:w.ref)||null);this.userData={ref:s,content:y},this._onDidChange.fire()}async readUserData(p){if(this.userData){const w=p&&p.latest?p.latest[Ve.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ve.RESOURCE,this.userData)}parse(p){if(p.content!==null)try{return JSON.parse(p.content)}catch(w){this.logService.error(w)}return{version:Ve.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=ue([Y(0,P.IEnvironmentService),Y(1,k.IFileService),Y(2,T.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncLogService),Y(5,R.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[84],ee([0,1,6,3,2,20,59,25,13,19,10,60,123,53,5,11,7,28]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const w="sync.enable",y="sync.disableMachineEventually",s="sync.sessionId",i="sync.storeUrl",t="sync.productQuality";let n=class extends A.Disposable{constructor(c,h,S){super();this.storageService=c,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new U.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(c.onDidChangeValue(I=>this.onDidStorageChange(I)))}isEnabled(c){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,0,!!c)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(c){c&&!this.canToggleEnablement()||this.storageService.store(w,c,0,1)}onDidStorageChange(c){if(c.scope===0&&w===c.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=ue([Y(0,g.IStorageService),Y(1,R.IEnvironmentService),Y(2,P.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends A.Disposable{constructor(c,h,S,I,u,L,_,$,B,M,j){var W;super();this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=I,this.userDataSyncService=u,this.logService=L,this.userDataSyncAccountService=_,this.telemetryService=$,this.userDataSyncMachinesService=B,this.storageService=M,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=j,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(W=h.userDataSyncStore)===null||W===void 0?void 0:W.url,this.previousProductQuality=this.productQuality,this.productQuality=c.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(h.onDidChangeUserDataSyncStore(()=>{var z,H;(0,C.isEqual)(this.syncUrl,(z=h.userDataSyncStore)===null||z===void 0?void 0:z.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=h.userDataSyncStore)===null||H===void 0?void 0:H.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(U.Event.debounce(u.onDidChangeLocal,(z,H)=>z?[...z,H]:[H],1e3)(z=>this.triggerSync(z,!1,!1))),this._register(U.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const c=this.storageService.get(i,0);return c?o.URI.parse(c):void 0}set syncUrl(c){c?this.storageService.store(i,c.toString(),0,1):this.storageService.remove(i,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(c){c?this.storageService.store(t,c,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:c,message:h}=this.isAutoSyncEnabled();c?this.autoSync.value===void 0&&(this.autoSync.value=new l(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(h&&this.logService.info(h),this.autoSync.clear()):h&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(h))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,b.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(c,h,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),c?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(I){if(h)this.logService.error(I),this.updateEnablement(!1);else throw I}}updateEnablement(c){this.userDataAutoSyncEnablementService.isEnabled()!==c&&(this.telemetryService.publicLog2(w,{enabled:c}),this.userDataAutoSyncEnablementService.setEnablement(c),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(c){if(!c){this.successiveFailures=0;return}const h=P.UserDataSyncError.toUserDataSyncError(c);h instanceof P.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:h.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),h.code===P.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):h.code===P.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):h.code===P.UserDataSyncErrorCode.LocalTooManyRequests||h.code===P.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):h.code===P.UserDataSyncErrorCode.UpgradeRequired||h.code===P.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):h.code===P.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with newer version than of client. Requires client upgrade.`)):h.code===P.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with older version than of client. Requires server reset.`)):h.code===P.UserDataSyncErrorCode.ServiceChanged||h.code===P.UserDataSyncErrorCode.DefaultServiceChanged?E.isWeb&&h.code===P.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(h),this.successiveFailures++),this._onError.fire(h)}async disableMachineEventually(){this.storageService.store(y,!0,0,1),await(0,v.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(y,0,!1)}stopDisableMachineEventually(){this.storageService.remove(y,0)}async triggerSync(c,h,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(h&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...c),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=ue([Y(0,p.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncResourceEnablementService),Y(4,P.IUserDataSyncService),Y(5,P.IUserDataSyncLogService),Y(6,k.IUserDataSyncAccountService),Y(7,T.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,g.IStorageService),Y(10,P.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class l extends A.Disposable{constructor(c,h,S,I,u,L,_,$){super();this.lastSyncUrl=c,this.interval=h,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=I,this.userDataSyncService=u,this.userDataSyncMachinesService=L,this.logService=_,this.storageService=$,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new U.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new U.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(l.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,v.disposableTimeout)(()=>this.sync(l.INTERVAL_SYNCING,!1),this.interval)}sync(c,h){const S=(0,v.createCancelablePromise)(async I=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,f.isPromiseCanceledError)(u))return}return this.doSync(c,h,I)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var c;return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,(c=this.userDataSyncStoreManagementService.userDataSyncStore)===null||c===void 0?void 0:c.url)}async hasDefaultServiceChanged(){const c=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),h=this.userDataSyncStoreManagementService.userDataSyncStore;return!!h&&!!c&&(!(0,C.isEqual)(h.defaultUrl,c.defaultUrl)||!(0,C.isEqual)(h.insidersUrl,c.insidersUrl)||!(0,C.isEqual)(h.stableUrl,c.stableUrl))}async doSync(c,h,S){this.logService.info(`Auto Sync: Triggered by ${c}`),this._onDidStartSync.fire();let I;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(h),S.isCancellationRequested)return;let u=this.syncTask.manifest;if(u===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new P.UserDataAutoSyncError((0,m.localize)(0,null),P.UserDataSyncErrorCode.DefaultServiceChanged):new P.UserDataAutoSyncError((0,m.localize)(1,null),P.UserDataSyncErrorCode.ServiceChanged):new P.UserDataAutoSyncError((0,m.localize)(2,null),P.UserDataSyncErrorCode.TurnedOff);const L=this.storageService.get(s,0);if(L&&u&&L!==u.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new P.UserDataAutoSyncError((0,m.localize)(3,null),P.UserDataSyncErrorCode.DefaultServiceChanged):new P.UserDataAutoSyncError((0,m.localize)(4,null),P.UserDataSyncErrorCode.ServiceChanged):new P.UserDataAutoSyncError((0,m.localize)(5,null),P.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(u||void 0);if(S.isCancellationRequested)return;const $=_.find(B=>B.isCurrent);if($==null?void 0:$.disabled)throw new P.UserDataAutoSyncError((0,m.localize)(6,null),P.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),u===null&&(u=await this.userDataSyncStoreService.manifest()),u&&u.session!==L&&this.storageService.store(s,u.session,0,1),S.isCancellationRequested)return;$||await this.userDataSyncMachinesService.addCurrentMachine(u||void 0)}catch(u){this.logService.error(u),I=u}this._onDidFinishSync.fire(I)}register(c){return super._register(c)}}l.INTERVAL_SYNCING="Interval"}),define(Z[194],ee([0,1,20,2,3,19,25,7]),function(K,e,v,U,A,P,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let f=class extends U.Disposable{constructor(R,d){super();this.storageService=R,this.telemetryService=d,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(R.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(R){return this.storageService.getBoolean((0,v.getEnablementKey)(R),0,!0)}setResourceEnablement(R,d){if(this.isResourceEnabled(R)!==d){const m=(0,v.getEnablementKey)(R);this.telemetryService.publicLog2(m,{enabled:d}),this.storeResourceEnablement(m,d)}}getResourceSyncStateVersion(R){}storeResourceEnablement(R,d){this.storageService.store(R,d,0,T.isWeb?0:1)}onDidStorageChange(R){if(R.scope===0){const d=v.ALL_SYNC_RESOURCES.filter(m=>(0,v.getEnablementKey)(m)===R.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}}};f=ue([Y(0,P.IStorageService),Y(1,k.ITelemetryService)],f),e.UserDataSyncResourceEnablementService=f}),define(Z[195],ee([0,1,20,2,4,3,184,187,186,43,25,18,19,189,11,190,31,6,13]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const y="sync.lastSyncTime";let s=class extends U.Disposable{constructor(r,l,a,c,h,S){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=l,this.instantiationService=a,this.logService=c,this.telemetryService=h,this.storageService=S,this._status="uninitialized",this._onDidChangeStatus=this._register(new P.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new P.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new P.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new P.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new P.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new P.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(T.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(f.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(k.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(P.Event.any(...this.synchronisers.map(I=>P.Event.map(I.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(P.Event.any(...this.synchronisers.map(I=>P.Event.map(I.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(y,0,void 0),this.onDidChangeLocal=P.Event.any(...this.synchronisers.map(I=>P.Event.map(I.onDidChangeLocal,()=>I.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r){await this.checkEnablement();const l=(0,E.generateUuid)();let a;try{const I=(0,v.createSyncHeaders)(l);r&&(I["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(I)}catch(I){const u=v.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(u,l),u}let c=!1;const h=this;let S;return{manifest:a,run(){if(c)throw new Error("Can run a task only once");return S=(0,p.createCancelablePromise)(I=>h.sync(a,l,I)),S.finally(()=>S=void 0)},async stop(){if(S&&S.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,E.generateUuid)(),l=(0,v.createSyncHeaders)(r);let a;try{a=await this.userDataSyncStoreService.manifest(l)}catch(c){const h=v.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(h,r),h}return new i(r,a,l,this.synchronisers,this.logService)}async sync(r,l,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!a.isCancellationRequested){const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,v.createSyncHeaders)(l);for(const S of this.synchronisers){if(a.isCancellationRequested)return;try{await S.sync(r,h)}catch(I){if(I instanceof v.UserDataSyncError)switch(I.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(I.message,I.code,S.resource);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw I}const u=v.UserDataSyncError.toUserDataSyncError(I);this.reportUserDataSyncError(u,l),this.logService.error(I),this.logService.error(`${S.resource}: ${(0,g.toErrorMessage)(I)}`),this._syncErrors.push([S.resource,u])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(h){const S=v.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(S,l),S}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(l){this.logService.error(l)}}async replace(r){await this.checkEnablement();for(const l of this.synchronisers)if(await l.replace(r))return}async accept(r,l,a,c){await this.checkEnablement();const h=this.getSynchroniser(r);await h.accept(l,a),c&&await h.apply(!1,(0,v.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(r){for(const l of this.synchronisers){const a=await l.resolveContent(r);if(a)return a}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,l){return this.getSynchroniser(r).getAssociatedResources(l)}getMachineId(r,l){return this.getSynchroniser(r).getMachineId(l)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const l of r)if(await l.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(y,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(l){this.logService.error(`${r.resource}: ${(0,g.toErrorMessage)(l)}`),this.logService.error(l)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const l=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,d.equals)(this._conflicts,r,([l,a],[c,h])=>l===l&&(0,d.equals)(a,h,(S,I)=>(0,o.isEqual)(S.previewResource,I.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(y,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,l){this.telemetryService.publicLog2("sync/error",{code:r.code,url:r instanceof v.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(t)])}getSynchroniser(r){return this.synchronisers.find(l=>l.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=ue([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,v.IUserDataSyncLogService),Y(4,R.ITelemetryService),Y(5,m.IStorageService)],s),e.UserDataSyncService=s;class i extends U.Disposable{constructor(r,l,a,c,h){super();this.id=r,this.manifest=l,this.syncHeaders=a,this.synchronisers=c,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new P.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,p.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,l){try{return await this.performAction(r,a=>a.accept(r,l))}catch(a){throw this.logService.error(a),a}}async merge(r){try{return r?await this.performAction(r,l=>l.merge(r)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(r){try{return await this.performAction(r,l=>l.discard(r))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,l]of this.previews)for(const a of l.resourcePreviews)a.mergeState==="conflict"&&r.push(a.previewResource);for(const l of r)await this.discard(l);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[l,a]of this.previews){this.synchronizingResources.push([l,a.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(S=>S.resource===l);for(const S of a.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&await c.merge(S.previewResource);const h=await c.apply(!1,this.syncHeaders);h&&r.push(this.toSyncResourcePreview(c.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,l]of this.previews){this.synchronizingResources.push([r,l.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(c=>c.resource===r);for(const c of l.resourcePreviews)await a.accept(c.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,l]of this.previews){this.synchronizingResources.push([r,l.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(c=>c.resource===r);for(const c of l.resourcePreviews)await a.accept(c.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(l){(0,w.isPromiseCanceledError)(l)||this.logService.error(l)}this.reset()}async performAction(r,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:B,previewResource:M,remoteResource:j})=>(0,o.isEqual)(r,B)||(0,o.isEqual)(r,M)||(0,o.isEqual)(r,j)));if(a===-1)return this.previews;const[c,h]=this.previews[a],S=h.resourcePreviews.find(({localResource:$,remoteResource:B,previewResource:M})=>(0,o.isEqual)($,r)||(0,o.isEqual)(B,r)||(0,o.isEqual)(M,r));if(!S)return this.previews;let I=this.synchronizingResources.find($=>$[0]===c);I||(I=[c,[]],this.synchronizingResources.push(I)),I[1].some($=>(0,o.isEqual)($,S.localResource))||(I[1].push(S.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const u=this.synchronisers.find($=>$.resource===this.previews[a][0]),L=await l(u);L?this.previews.splice(a,1,this.toSyncResourcePreview(u.resource,L)):this.previews.splice(a,1);const _=this.synchronizingResources.findIndex($=>$[0]===c);return this.synchronizingResources[_][1].splice(I[1].findIndex($=>(0,o.isEqual)($,S.localResource)),1),I[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[l,a]of this.previews){this.synchronizingResources.push([l,a.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(S=>S.resource===l);let h=a;for(const S of a.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&(h=await c.merge(S.previewResource));h&&r.push(this.toSyncResourcePreview(c.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const l=[];for(const a of this.synchronisers){if(r.isCancellationRequested)return[];const c=await a.preview(this.manifest,this.syncHeaders);c&&l.push(this.toSyncResourcePreview(a.resource,c))}return l}toSyncResourcePreview(r,l){return[r,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(Z[196],ee([0,1,3,20,5,2,17]),function(K,e,v,U,A,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class T{constructor(d,m){this.service=d,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new v.Emitter}listen(d,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(d,m,b){try{return await this._call(d,m,b)}catch(o){throw this.logService.error(o),o}}async _call(d,m,b){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],A.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const o=m.substring("manualSync/".length),C=b[0],E=this.getManualSyncTask(C);switch(b=b.slice(1),o){case"preview":return E.preview();case"accept":return E.accept(A.URI.revive(b[0]),b[1]);case"merge":return E.merge(A.URI.revive(b[0]));case"discard":return E.discard(A.URI.revive(b[0]));case"discardConflicts":return E.discardConflicts();case"apply":return E.apply();case"pull":return E.pull();case"push":return E.push();case"stop":return E.stop();case"_getStatus":return E.status;case"dispose":return this.disposeManualSyncTask(E)}}throw new Error("Invalid call")}getManualSyncTask(d){const m=this.manualSyncTasks.get(this.createKey(d));if(!m)throw new Error(`Manual sync taks not found: ${d}`);return m.manualSyncTask}async createManualSyncTask(){const d=new P.DisposableStore,m=d.add(await this.service.createManualSyncTask());return d.add(m.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:b}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:d}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(d){var m;d.dispose();const b=this.createKey(d.id);(m=this.manualSyncTasks.get(b))===null||m===void 0||m.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=T;class f extends P.Disposable{constructor(d){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new v.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new v.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new v.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new v.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,b,o){return d.call(m,b,o).then(null,C=>{throw U.UserDataSyncError.toUserDataSyncError(C)})},listen(m,b){return d.listen(m,b)}},this.channel.call("_getInitialData").then(([m,b,o])=>{this.updateStatus(m),this.updateConflicts(b),o&&this.updateLastSyncTime(o),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([b,o])=>[b,U.UserDataSyncError.toUserDataSyncError(o)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:d,manifest:m,status:b}=await this.channel.call("createManualSyncTask"),o=this,C=new g(d,m,b,{async call(E,p,w){return o.channel.call(`manualSync/${E}`,[d,...(0,k.isArray)(p)?p:[p]],w)},listen(E,p){return v.Event.map(v.Event.filter(o.channel.listen(`manualSync/${E}`,p),w=>!C.isDiposed()&&w.manualSyncTaskId===d),w=>w.data)}});return C}replace(d){return this.channel.call("replace",[d])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,m,b,o){return this.channel.call("accept",[d,m,b,o])}resolveContent(d){return this.channel.call("resolveContent",[d])}async getLocalSyncResourceHandles(d){return(await this.channel.call("getLocalSyncResourceHandles",[d])).map(({created:b,uri:o})=>({created:b,uri:A.URI.revive(o)}))}async getRemoteSyncResourceHandles(d){return(await this.channel.call("getRemoteSyncResourceHandles",[d])).map(({created:b,uri:o})=>({created:b,uri:A.URI.revive(o)}))}async getAssociatedResources(d,m){return(await this.channel.call("getAssociatedResources",[d,m])).map(({resource:o,comparableResource:C})=>({resource:A.URI.revive(o),comparableResource:A.URI.revive(C)}))}async getMachineId(d,m){return this.channel.call("getMachineId",[d,m])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(([m,b])=>[m,b.map(o=>Object.assign(Object.assign({},o),{localResource:A.URI.revive(o.localResource),remoteResource:A.URI.revive(o.remoteResource),previewResource:A.URI.revive(o.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}}e.UserDataSyncChannelClient=f;class g extends P.Disposable{constructor(d,m,b,o){super();this.id=d,this.manifest=m,this._disposed=!1,this._status=b;const C=this;this.channel={async call(E,p,w){try{const y=await o.call(E,p,w);return C.isDiposed()||(C._status=await o.call("_getStatus")),y}catch(y){throw U.UserDataSyncError.toUserDataSyncError(y)}},listen(E,p){return o.listen(E,p)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const d=await this.channel.call("preview");return this.deserializePreviews(d)}async accept(d,m){const b=await this.channel.call("accept",[d,m]);return this.deserializePreviews(b)}async merge(d){const m=await this.channel.call("merge",[d]);return this.deserializePreviews(m)}async discard(d){const m=await this.channel.call("discard",[d]);return this.deserializePreviews(m)}async discardConflicts(){const d=await this.channel.call("discardConflicts");return this.deserializePreviews(d)}async apply(){const d=await this.channel.call("apply");return this.deserializePreviews(d)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(d){return d.map(([m,b])=>[m,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(o=>Object.assign(Object.assign({},o),{localResource:A.URI.revive(o.localResource),remoteResource:A.URI.revive(o.remoteResource),previewResource:A.URI.revive(o.previewResource),acceptedResource:A.URI.revive(o.acceptedResource)}))}])}}}),define(Z[197],ee([0,1,2,20,40,11,30,24,28,44,10,8,19,31,7,3,6,17,5,13]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",i="sync.donot-make-requests-until",t="sync.user-session-id",n="sync.machine-session-id",r=100,l=1e3*60*5;let a=class extends v.Disposable{constructor(L,_,$){super();this.productService=L,this.configurationService=_,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter($.onDidChangeValue,B=>{var M;return B.key===U.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((M=this.userDataSyncStore)===null||M===void 0?void 0:M.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(U.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(L){this.storageService.store(U.SYNC_SERVICE_URL_TYPE,L,0,o.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[U.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(U.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(L,_){L=o.isWeb&&(L==null?void 0:L.web)?Object.assign(Object.assign({},L),L.web):L;const $=Object.assign(Object.assign({},L||{}),_||{});if($&&(0,p.isString)($.url)&&(0,p.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(B=>(0,p.isArray)($.authenticationProviders[B].scopes))){const B=$,M=!!B.canSwitch&&!(_==null?void 0:_.url),j=B.url===B.insidersUrl?"insiders":"stable",W=(M?this.userDataSyncStoreType:void 0)||j,z=(_==null?void 0:_.url)||(W==="insiders"?B.insidersUrl:W==="stable"?B.stableUrl:B.url);return{url:w.URI.parse(z),type:W,defaultType:j,defaultUrl:w.URI.parse(B.url),stableUrl:w.URI.parse(B.stableUrl),insidersUrl:w.URI.parse(B.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(B.authenticationProviders).reduce((H,q)=>(H.push({id:q,scopes:B.authenticationProviders[q].scopes}),H),[])}}}};a=ue([Y(0,f.IProductService),Y(1,T.IConfigurationService),Y(2,m.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let c=class extends a{constructor(L,_,$){super(L,_,$);const B=this.storageService.get(s,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const M=this.productService[U.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(s,JSON.stringify(M),0,1):this.storageService.remove(s,0)}async switch(L){L!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=L,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=ue([Y(0,f.IProductService),Y(1,T.IConfigurationService),Y(2,m.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let h=class extends v.Disposable{constructor(L,_,$,B,M,j,W){super();this.requestService=$,this.logService=B,this.storageService=W,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(L),this.commonHeadersPromise=(0,g.getServiceMachineId)(M,j,W).then(z=>{const H={"X-Client-Name":`${_.applicationName}${o.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":z};return _.commit&&(H["X-Client-Commit"]=_.commit),H}),this.session=new I(r,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,v.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(L,_){this.authToken={token:L,type:_}}updateUserDataSyncStoreUrl(L){this.userDataSyncStoreUrl=L?(0,P.joinPath)(L,"v1"):void 0}initDonotMakeRequestsUntil(){const L=this.storageService.getNumber(i,0);L&&Date.now()<L&&this.setDonotMakeRequestsUntil(new Date(L))}setDonotMakeRequestsUntil(L){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(L==null?void 0:L.getTime())&&(this._donotMakeRequestsUntil=L,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,E.createCancelablePromise)($=>(0,E.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(L){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",L),$={},B=await this.request(_.toString(),{type:"GET",headers:$},[],k.CancellationToken.None);return(await(0,A.asJson)(B)||[]).map(({url:j,created:W})=>({ref:(0,P.relativePath)(_,_.with({path:j})),created:W*1e3}))}async resolveContent(L,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",L,_).toString(),B={};B["Cache-Control"]="no-cache";const M=await this.request($,{type:"GET",headers:B},[],k.CancellationToken.None);return await(0,A.asText)(M)}async delete(L){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",L).toString(),$={};await this.request(_,{type:"DELETE",headers:$},[],k.CancellationToken.None)}async read(L,_,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",L,"latest").toString();$=Object.assign({},$),$["Cache-Control"]="no-cache",_&&($["If-None-Match"]=_.ref);const M=await this.request(B,{type:"GET",headers:$},[304],k.CancellationToken.None);if(M.res.statusCode===304)return _;const j=M.res.headers.etag;if(!j)throw new U.UserDataSyncStoreError("Server did not return the ref",B,U.UserDataSyncErrorCode.NoRef,M.res.headers[U.HEADER_OPERATION_ID]);const W=await(0,A.asText)(M);return{ref:j,content:W}}async write(L,_,$,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",L).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",$&&(B["If-Match"]=$);const j=await this.request(M,{type:"POST",data:_,headers:B},[],k.CancellationToken.None),W=j.res.headers.etag;if(!W)throw new U.UserDataSyncStoreError("Server did not return the ref",M,U.UserDataSyncErrorCode.NoRef,j.res.headers[U.HEADER_OPERATION_ID]);return W}async manifest(L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();L=Object.assign({},L),L["Content-Type"]="application/json";const $=await this.request(_,{type:"GET",headers:L},[],k.CancellationToken.None),B=await(0,A.asJson)($),M=this.storageService.get(t,0);return M&&B&&M!==B.session&&this.clearSession(),B===null&&M&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(L,{type:"DELETE",headers:_},[],k.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(n,0)}async request(L,_,$,B){if(!this.authToken)throw new U.UserDataSyncStoreError("No Auth Token Available",L,U.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because of too many requests (429).`,L,U.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),M),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:L,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let j;try{j=await this.session.request(L,_,B)}catch(q){if(!(q instanceof U.UserDataSyncStoreError)){const D=(0,y.isPromiseCanceledError)(q)?U.UserDataSyncErrorCode.RequestCanceled:(0,y.getErrorMessage)(q).startsWith("XHR timeout")?U.UserDataSyncErrorCode.RequestTimeout:U.UserDataSyncErrorCode.RequestFailed;q=new U.UserDataSyncStoreError(`Connection refused for the request '${L}'.`,L,D,void 0)}throw this.logService.info("Request failed",L),q}const W=j.res.headers[U.HEADER_OPERATION_ID],z={url:L,status:j.res.statusCode,"execution-id":_.headers[U.HEADER_EXECUTION_ID],"operation-id":W},H=(0,A.isSuccess)(j)||j.res.statusCode&&$.indexOf(j.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new U.UserDataSyncStoreError(`Request '${L}' failed because of Unauthorized (401).`,L,U.UserDataSyncErrorCode.Unauthorized,W);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,L,U.UserDataSyncErrorCode.Conflict,W);if(j.res.statusCode===410)throw new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because the requested resource is not longer available (410).`,L,U.UserDataSyncErrorCode.Gone,W);if(j.res.statusCode===412)throw new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,L,U.UserDataSyncErrorCode.PreconditionFailed,W);if(j.res.statusCode===413)throw new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because of too large payload (413).`,L,U.UserDataSyncErrorCode.TooLarge,W);if(j.res.statusCode===426)throw new U.UserDataSyncStoreError(`${_.type} request '${L}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,L,U.UserDataSyncErrorCode.UpgradeRequired,W);if(j.res.statusCode===429){const q=j.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because of too many requests (429).`,L,U.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W)):new U.UserDataSyncStoreError(`${_.type} request '${L}' failed because of too many requests (429).`,L,U.UserDataSyncErrorCode.TooManyRequests,W)}if(!H)throw new U.UserDataSyncStoreError("Server returned "+j.res.statusCode,L,U.UserDataSyncErrorCode.Unknown,W);return j}addSessionHeaders(L){let _=this.storageService.get(n,0);_===void 0&&(_=(0,b.generateUuid)(),this.storageService.store(n,_,0,1)),L["X-Machine-Session-Id"]=_;const $=this.storageService.get(t,0);$!==void 0&&(L["X-User-Session-Id"]=$)}};h=ue([Y(1,f.IProductService),Y(2,A.IRequestService),Y(3,U.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,d.IFileService),Y(6,m.IStorageService)],h),e.UserDataSyncStoreClient=h;let S=class extends h{constructor(L,_,$,B,M,j,W){var z;super((z=L.userDataSyncStore)===null||z===void 0?void 0:z.url,_,$,B,M,j,W);this._register(L.onDidChangeUserDataSyncStore(()=>{var H;return this.updateUserDataSyncStoreUrl((H=L.userDataSyncStore)===null||H===void 0?void 0:H.url)}))}};S=ue([Y(0,U.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,A.IRequestService),Y(3,U.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,d.IFileService),Y(6,m.IStorageService)],S),e.UserDataSyncStoreService=S;class I{constructor(L,_,$,B){this.limit=L,this.interval=_,this.requestService=$,this.logService=B,this.requests=[],this.startTime=void 0}request(L,_,$){if(this.isExpired()&&this.reset(),_.url=L,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new U.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,L,U.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(L),this.requestService.request(_,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(Z[198],ee([0,1,20,3,56,84,59,25,19,60,28]),function(K,e,v,U,A,P,k,T,f,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let d=class extends P.UserDataAutoSyncService{constructor(b,o,C,E,p,w,y,s,i,t,n,r){super(b,o,C,E,p,y,s,i,t,n,r);this._register(U.Event.debounce(U.Event.any(U.Event.map(w.onDidFocusWindow,()=>"windowFocus"),U.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(l,a)=>l?[...l,a]:[a],1e3)(l=>this.triggerSync(l,!0,!1)))}};d=ue([Y(0,R.IProductService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncResourceEnablementService),Y(4,v.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,v.IUserDataSyncLogService),Y(7,k.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,g.IUserDataSyncMachinesService),Y(10,f.IStorageService),Y(11,v.IUserDataAutoSyncEnablementService)],d),e.UserDataAutoSyncService=d}),define(Z[199],ee([0,1,3,2,6]),function(K,e,v,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class P extends U.Disposable{constructor({onDidOpenWindow:T,onDidFocusWindow:f,getActiveWindowId:g}){super();this.disposables=this._register(new U.DisposableStore),v.Event.latch(v.Event.any(T,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>g()),(async()=>{try{const d=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:d}catch(d){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(T){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=T}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=P}),define(Z[61],ee([0,1,106,9,27,6,23,205,206,17]),function(K,e,v,U,A,P,k,T,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,n){let r=n.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=n}}e.ExtractError=R;function d(i){const t=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,r)=>n+r,t&61440)}function m(i){if(i instanceof R)return i;let t;return/end of central directory record signature not found/.test(i.message)&&(t="CorruptZip"),new R(t,i)}function b(i,t,n,r,l,a){const c=U.dirname(t),h=U.join(r,c);if(!h.startsWith(r))return Promise.reject(new Error(v.localize(0,null,t)));const S=U.join(r,t);let I;return a.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(A.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((u,L)=>{if(!a.isCancellationRequested)try{I=(0,A.createWriteStream)(S,{mode:n}),I.once("close",()=>u()),I.once("error",L),i.once("error",L),i.pipe(I)}catch(_){L(_)}}))}function o(i,t,n,r){let l=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{l.cancel(),i.close()}),new Promise((c,h)=>{const S=new P.Sequencer,I=u=>{u.isCancellationRequested||(a++,i.readEntry())};i.once("error",h),i.once("close",()=>l.then(()=>{r.isCancellationRequested||i.entryCount===a?c():h(new R("Incomplete",new Error(v.localize(1,null,a,i.entryCount))))},h)),i.readEntry(),i.on("entry",u=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(u.fileName)){I(r);return}const L=u.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(L)){const B=U.join(t,L);l=(0,P.createCancelablePromise)(M=>A.promises.mkdir(B,{recursive:!0}).then(()=>I(M)).then(void 0,h));return}const _=E(i,u),$=d(u);l=(0,P.createCancelablePromise)(B=>S.queue(()=>_.then(M=>b(M,L,$,t,n,B).then(()=>I(B)))).then(null,h))}})})}function C(i,t=!1){return new Promise((n,r)=>{(0,T.open)(i,t?{lazyEntries:!0}:void 0,(l,a)=>{l?r(m(l)):n((0,g.assertIsDefined)(a))})})}function E(i,t){return new Promise((n,r)=>{i.openReadStream(t,(l,a)=>{l?r(m(l)):n((0,g.assertIsDefined)(a))})})}function p(i,t){return new Promise((n,r)=>{const l=new f.ZipFile;t.forEach(c=>{c.contents?l.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&l.addFile(c.localPath,c.path)}),l.end();const a=(0,A.createWriteStream)(i);l.outputStream.pipe(a),l.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>n(i))})}e.zip=p;function w(i,t,n={},r){const l=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=C(i,!0);return n.overwrite&&(a=a.then(c=>(0,k.rimraf)(t).then(()=>c))),a.then(c=>o(c,t,{sourcePathRegex:l},r))}e.extract=w;function y(i,t){return C(i).then(n=>new Promise((r,l)=>{n.on("entry",a=>{a.fileName===t&&E(n,a).then(c=>r(c),c=>l(c))}),n.once("close",()=>l(new Error(v.localize(2,null,t))))}))}function s(i,t){return y(i,t).then(n=>new Promise((r,l)=>{const a=[];n.once("error",l),n.on("data",c=>a.push(c)),n.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=s}),define(Z[200],ee([0,1,61,111]),function(K,e,v,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(P){return(0,v.buffer)(P,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(T){throw new Error((0,U.localize)(0,null))}})}e.getManifest=A}),define(Z[201],ee([0,1,27,55,2,23,9,12,29,33,6,5,10,131,112,28,61,7,18,16,8,11,31,13]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s,i,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",l="scanningUser",a="extracting",c="deleting",h="renaming";let S=class extends A.Disposable{constructor(u,L,_,$,B){super();this.beforeRemovingExtension=u,this.fileService=L,this.logService=_,this.environmentService=$,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=$.builtinExtensionsPath,this.extensionsPath=$.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(u){const L=[];(u===null||u===0)&&L.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(_).message,r)))),(u===null||u===1)&&L.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(_).message,l))));try{const _=await Promise.all(L);return(0,w.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(u){this.logService.trace("Started scanning user extensions");let[L,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter($=>!L[new g.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]),u&&(_=(0,g.groupByExtension)(_,B=>B.identifier).map(B=>B.sort((M,j)=>U.rcompare(M.manifest.version,j.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(u,L,_){const $=u.key(),B=k.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),M=k.join(this.extensionsPath,$);try{await P.rimraf(M)}catch(W){try{await P.rimraf(M)}catch(z){}throw new f.ExtensionManagementError((0,o.localize)(0,null,M,u.id),c)}await this.extractAtLocation(u,L,B,_);let j=await this.scanExtension(d.URI.file(B),1);if(!j)throw new Error((0,o.localize)(1,null,B));await this.storeMetadata(j,{installedTimestamp:Date.now()});try{await this.rename(u,B,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(W){try{await P.rimraf(B)}catch(z){}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",u.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(W)}. Deleted from extracted location`,B),W}try{j=await this.scanExtension(d.URI.file(M),1)}catch(W){}if(j)return j;throw new Error((0,o.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(u,L){return this.setMetadata(u,L),await this.storeMetadata(u,Object.assign(Object.assign({},L),{installedTimestamp:u.installedTimestamp})),u}async storeMetadata(u,L){L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.installedTimestamp=L.installedTimestamp||void 0;const _=k.join(u.location.fsPath,"package.json"),$=await v.promises.readFile(_,"utf8"),{manifest:B}=await this.parseManifest($);return B.__metadata=L,await P.writeFile(_,JSON.stringify(B,null,"	")),u}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...u){const L=u.map(_=>new g.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{L.forEach($=>_[$.key()]=!0)})}async setInstalled(u){await this.withUninstalledExtensions($=>delete $[u.key()]);const _=(await this.scanExtensions(1)).find($=>new g.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(u))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(u){return this.uninstalledFileLimiter.queue(async()=>{let L;try{L=await v.promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let _={};if(L)try{_=JSON.parse(L)}catch($){}return u&&(u(_),Object.keys(_).length?await P.writeFile(this.uninstalledPath,JSON.stringify(_)):await P.rimraf(this.uninstalledPath)),_})}async removeExtension(u,L){this.logService.trace(`Deleting ${L} extension from disk`,u.identifier.id,u.location.fsPath),await P.rimraf(u.location.fsPath),this.logService.info("Deleted from disk",u.identifier.id,u.location.fsPath)}async removeUninstalledExtension(u){await this.removeExtension(u,"uninstalled"),await this.withUninstalledExtensions(L=>delete L[new g.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()])}async extractAtLocation(u,L,_,$){this.logService.trace(`Started extracting the extension from ${L} to ${_}`);try{await P.rimraf(_)}catch(B){throw new f.ExtensionManagementError(this.joinErrors(B).message,c)}try{await(0,E.extract)(L,_,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${_}:`,u.id)}catch(B){try{await P.rimraf(_)}catch(M){}throw new f.ExtensionManagementError(B.message,B instanceof E.ExtractError&&B.type?B.type:a)}}async rename(u,L,_,$){try{await v.promises.rename(L,_)}catch(B){if(p.isWindows&&B&&B.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${L} to ${_} with 'EPERM' error. Trying again...`,u.id),this.rename(u,L,_,$);throw new f.ExtensionManagementError(B.message||(0,o.localize)(3,null,L,_),B.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const u=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return u;const L=this.scanDevSystemExtensions(),[_,$]=await Promise.all([u,L]);return[..._,...$]}async scanExtensionsInDir(u,L){const _=new R.Limiter(10),$=await this.fileService.resolve(d.URI.file(u));return $.children?(await Promise.all($.children.filter(M=>M.isDirectory).map(M=>_.queue(async()=>L===1&&(0,i.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,L))))).filter(M=>M&&M.identifier):[]}async scanExtension(u,L){var _,$;try{const B=await this.fileService.resolve(u);if(B.children){const{manifest:M,metadata:j}=await this.readManifest(u.fsPath),W=(_=B.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D)))===null||_===void 0?void 0:_.resource,z=($=B.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D)))===null||$===void 0?void 0:$.resource,H={id:(0,g.getGalleryExtensionId)(M.publisher,M.name)},q={type:L,identifier:H,manifest:M,location:u,readmeUrl:W,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:L===0};return j&&(this.setMetadata(q,j),q.installedTimestamp=j.installedTimestamp),q}}catch(B){L!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const u=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",u.length),u}async scanDevSystemExtensions(){const u=this.getDevSystemExtensionsList();if(u.length){const L=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",L.length),L.filter(_=>u.some($=>(0,g.areSameExtensions)(_.identifier,{id:$})))}else return[]}setMetadata(u,L){u.publisherDisplayName=L.publisherDisplayName||null,u.publisherId=L.publisherId||null,u.identifier.uuid=L.id,u.isMachineScoped=!!L.isMachineScoped,u.isBuiltin=u.type===0||!!L.isBuiltin}async removeUninstalledExtensions(){const u=await this.getUninstalledExtensions(),L=await this.scanAllUserExtensions(),_=new Set;for(const M of L)u[new g.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||_.add(M.identifier.id.toLowerCase());const $=(0,g.groupByExtension)(L,M=>M.identifier);await R.Promises.settled($.map(async M=>{const j=M.sort((W,z)=>U.rcompare(W.manifest.version,z.manifest.version))[0];_.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(j)}));const B=L.filter(M=>u[new g.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await R.Promises.settled(B.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const u=await this.scanAllUserExtensions(),L=[],_=(0,g.groupByExtension)(u,$=>$.identifier);L.push(...(0,w.flatten)(_.map($=>$.sort((B,M)=>U.rcompare(B.manifest.version,M.manifest.version)).slice(1)))),await R.Promises.settled(L.map($=>this.removeExtension($,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(u=>u.name)}joinErrors(u){const L=Array.isArray(u)?u:[u];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((_,$)=>new Error(`${_.message}${_.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(y.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(u){const L=[v.promises.readFile(k.join(u,"package.json"),"utf8").then(M=>this.parseManifest(M)),v.promises.readFile(k.join(u,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:_,metadata:$},B]=await Promise.all(L);return{manifest:(0,b.localizeManifest)(_,B),metadata:$}}parseManifest(u){return new Promise((L,_)=>{try{const $=JSON.parse(u),B=$.__metadata||null;L({manifest:$,metadata:B})}catch($){_(new Error((0,o.localize)(4,null)))}})}};S=ue([Y(1,s.IFileService),Y(2,T.ILogService),Y(3,m.INativeEnvironmentService),Y(4,C.IProductService)],S),e.ExtensionsScanner=S}),define(Z[202],ee([0,1,27,110,9,23,2,18,61,29,33,10,6,3,55,5,57,7,12,144,43,25,68,11,31,70,4,16,30,200,152,201,153,154,8]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s,i,t,n,r,l,a,c,h,S,I,u,L,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const B="unsetUninstalled",M="downloading",j="validating",W="local",z="unknown";let H=class extends k.Disposable{constructor(D,O,F,N,V,G,Q){super();this.environmentService=D,this.galleryService=O,this.logService=F,this.downloadService=N,this.telemetryService=V,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const X=this._register(G.createInstance(L.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(u.ExtensionsScanner,ie=>X.postUninstall(ie))),this.manifestCache=this._register(new y.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(G.createInstance(I.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,Q,D,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ae})=>{ie.forEach(he=>this._onDidInstallExtension.fire({identifier:he.identifier,operation:0,local:he})),ae.forEach(he=>this._onDidUninstallExtension.fire({identifier:he}))})),this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(D){this.logService.trace("ExtensionManagementService#zip",D.identifier.id);const O=await this.collectFiles(D),F=await(0,f.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,O);return C.URI.file(F)}async unzip(D){return this.logService.trace("ExtensionManagementService#unzip",D.toString()),(await this.install(D)).identifier}async getManifest(D){const O=await this.downloadVsix(D),F=A.resolve(O.fsPath);return(0,S.getManifest)(F)}async collectFiles(D){const O=async N=>{let V=await P.readdir(N);V=V.map(X=>A.join(N,X));const G=await Promise.all(V.map(X=>v.promises.stat(X)));let Q=Promise.resolve([]);return G.forEach((X,ne)=>{const ie=V[ne];X.isFile()&&(Q=Q.then(ae=>[...ae,ie])),X.isDirectory()&&(Q=Q.then(ae=>O(ie).then(he=>[...ae,...he])))}),Q};return(await O(D.location.fsPath)).map(N=>({path:`extension/${A.relative(D.location.fsPath,N)}`,localPath:N}))}async install(D,O={}){return this.logService.trace("ExtensionManagementService#install",D.toString()),(0,m.createCancelablePromise)(async F=>{const N=await this.downloadVsix(D),V=A.resolve(N.fsPath),G=await(0,S.getManifest)(V),Q={id:(0,R.getGalleryExtensionId)(G.publisher,G.name)};let X=1;if(G.engines&&G.engines.vscode&&!(0,t.isEngineValid)(G.engines.vscode,E.default.version))throw new Error(U.localize(0,null,Q.id,E.default.version));const ne=new R.ExtensionIdentifierWithVersion(Q,G.version),ae=(await this.getInstalled(1)).find(fe=>(0,R.areSameExtensions)(Q,fe.identifier));if(ae)if(O.isMachineScoped=O.isMachineScoped||ae.isMachineScoped,O.isBuiltin=O.isBuiltin||ae.isBuiltin,X=2,ne.equals(new R.ExtensionIdentifierWithVersion(ae.identifier,ae.manifest.version)))try{await this.extensionsScanner.removeExtension(ae,"existing")}catch(fe){throw new Error(U.localize(1,null,G.displayName||G.name))}else o.gt(ae.manifest.version,G.version)&&await this.uninstallExtension(ae);else{const fe=await this.unsetUninstalledAndGetLocal(ne);if(fe)try{await this.extensionsScanner.removeExtension(fe,"existing")}catch(we){throw new Error(U.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",Q.id),this._onInstallExtension.fire({identifier:Q,zipPath:V});let he;try{he=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(G.publisher,G.name))}catch(fe){}try{const fe=await this.installFromZipPath(ne,V,Object.assign(Object.assign({},he||{}),O),O,X,F);return this.logService.info("Successfully installed the extension:",Q.id),fe}catch(fe){throw this.logService.error("Failed to install the extension:",Q.id,fe.message),fe}})}async downloadVsix(D){if(D.scheme===c.Schemas.file)return D;if(!this.downloadService)throw new Error("Download service is not available");const O=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(D,O),O}async installFromZipPath(D,O,F,N,V,G){try{const Q=await this.installExtension({zipPath:O,identifierWithVersion:D,metadata:F},G);try{await this.installDependenciesAndPackExtensions(Q,void 0,N)}catch(X){(0,T.isNonEmptyArray)(Q.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Q.identifier.id,X.message),(0,T.isNonEmptyArray)(Q.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Q.identifier.id,X.message)}return this._onDidInstallExtension.fire({identifier:D,zipPath:O,local:Q,operation:V}),Q}catch(Q){throw this._onDidInstallExtension.fire({identifier:D,zipPath:O,operation:V,error:Q}),Q}}async canInstall(D){return!0}async installFromGallery(D,O={}){if(!this.galleryService.isEnabled())throw new Error(U.localize(3,null));try{D=await this.checkAndGetCompatibleVersion(D)}catch(V){const G=V&&V.code?V.code:z;throw this.logService.error("Failed to install extension:",D.identifier.id,V?V.message:G),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(D),void 0,V),V instanceof Error&&(V.name=G),V}const F=new R.ExtensionIdentifierWithVersion(D.identifier,D.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,m.createCancelablePromise)(V=>this.doInstallFromGallery(D,O,V)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(D,O,F){const N=new Date().getTime();let V=1;this.logService.info("Installing extension:",D.identifier.id),this._onInstallExtension.fire({identifier:D.identifier,gallery:D});try{const Q=(await this.getInstalled(1)).find(ie=>(0,R.areSameExtensions)(ie.identifier,D.identifier));Q&&(V=2);const X=await this.downloadInstallableExtension(D,V);X.metadata.isMachineScoped=O.isMachineScoped||(Q==null?void 0:Q.isMachineScoped),X.metadata.isBuiltin=O.isBuiltin||(Q==null?void 0:Q.isBuiltin);const ne=await this.installExtension(X,F);try{await this.extensionsDownloader.delete(C.URI.file(X.zipPath))}catch(ie){}if(!O.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,Q,O)}catch(ie){try{await this.uninstall(ne)}catch(ae){}throw ie}return Q&&o.neq(Q.manifest.version,D.version)&&await this.extensionsScanner.setUninstalled(Q),this.logService.info("Extensions installed successfully:",D.identifier.id),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,local:ne,operation:V}),this.reportTelemetry(this.getTelemetryEvent(V),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,void 0),ne}catch(G){const Q=G&&G.code?G.code:z;throw this.logService.error("Failed to install extension:",D.identifier.id,G?G.message:Q),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,operation:V,error:Q}),this.reportTelemetry(this.getTelemetryEvent(V),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,G),G instanceof Error&&(G.name=Q),G}}async checkAndGetCompatibleVersion(D){if(await this.isMalicious(D))throw new g.ExtensionManagementError(U.localize(4,null),g.INSTALL_ERROR_MALICIOUS);const O=await this.galleryService.getCompatibleExtension(D);if(!O)throw new g.ExtensionManagementError(U.localize(5,null,D.identifier.id,E.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return O}async reinstallFromGallery(D){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",D.identifier.id),!this.galleryService.isEnabled())throw new Error(U.localize(6,null));const O=await this.findGalleryExtension(D);if(!O)throw new Error(U.localize(7,null));await this.extensionsScanner.setUninstalled(D);try{await this.extensionsScanner.removeUninstalledExtension(D)}catch(F){throw new Error(U.localize(8,null,(0,s.toErrorMessage)(F)))}await this.installFromGallery(O)}getTelemetryEvent(D){return D===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(D){const O=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(O).has(D.identifier.id)}async downloadInstallableExtension(D,O){const F={id:D.identifier.uuid,publisherId:D.publisherId,publisherDisplayName:D.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",D.identifier.id);const V=await this.extensionsDownloader.downloadExtension(D,O);this.logService.info("Downloaded extension:",D.identifier.id,N),N=V.fsPath}catch(V){throw new g.ExtensionManagementError(this.joinErrors(V).message,M)}try{const V=await(0,S.getManifest)(N);return{zipPath:N,identifierWithVersion:new R.ExtensionIdentifierWithVersion(D.identifier,V.version),metadata:F}}catch(V){throw new g.ExtensionManagementError(this.joinErrors(V).message,j)}}async installExtension(D,O){try{const F=await this.unsetUninstalledAndGetLocal(D.identifierWithVersion);if(F)return D.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,D.metadata):F}catch(F){throw p.isMacintosh?new g.ExtensionManagementError(U.localize(9,null),B):new g.ExtensionManagementError(U.localize(10,null),B)}return this.extractAndInstall(D,O)}async unsetUninstalledAndGetLocal(D){if(!await this.isUninstalled(D))return null;this.logService.trace("Removing the extension from uninstalled list:",D.id);const F=await this.extensionsScanner.setInstalled(D);return this.logService.info("Removed the extension from uninstalled list:",D.id),F}async extractAndInstall({zipPath:D,identifierWithVersion:O,metadata:F},N){let V=await this.extensionsScanner.extractUserExtension(O,D,N);return this.logService.info("Installation completed.",O.id),F&&(V=await this.extensionsScanner.saveMetadataForLocalExtension(V,F)),V}async installDependenciesAndPackExtensions(D,O,F){if(!!this.galleryService.isEnabled()){const N=D.manifest.extensionDependencies||[];if(D.manifest.extensionPack)for(const V of D.manifest.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(G=>(0,R.areSameExtensions)({id:G},{id:V}))||N.every(G=>!(0,R.areSameExtensions)({id:G},{id:V}))&&N.push(V);if(N.length){const V=await this.getInstalled(),G=N.filter(Q=>V.every(({identifier:X})=>!(0,R.areSameExtensions)(X,{id:Q})));if(G.length){const X=(await this.galleryService.query({names:G,pageSize:N.length},h.CancellationToken.None)).firstPage;try{await m.Promises.settled(X.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(X)}catch(ie){}throw ne}}}}}async rollback(D){const F=(await this.getInstalled(1)).filter(N=>D.some(V=>new R.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new R.ExtensionIdentifierWithVersion(V.identifier,V.version))));await m.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(D,O={}){this.logService.trace("ExtensionManagementService#uninstall",D.identifier.id);const F=await this.getInstalled(1),N=F.find(V=>(0,R.areSameExtensions)(V.identifier,D.identifier));if(!N)throw new Error(U.localize(11,null,D.manifest.displayName||D.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,O)}catch(V){throw this.joinErrors(V)}}async updateMetadata(D,O){return this.logService.trace("ExtensionManagementService#updateMetadata",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),O)),this.manifestCache.invalidate(),D}async updateExtensionScope(D,O){return this.logService.trace("ExtensionManagementService#updateExtensionScope",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),{isMachineScoped:O})),this.manifestCache.invalidate(),D}async getGalleryMetadata(D){const O=await this.findGalleryExtensionByName(D);return O?{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId}:void 0}async findGalleryExtension(D){if(D.identifier.uuid){const O=await this.findGalleryExtensionById(D.identifier.uuid);return O||this.findGalleryExtensionByName(D.identifier.id)}return this.findGalleryExtensionByName(D.identifier.id)}async findGalleryExtensionById(D){return(await this.galleryService.query({ids:[D],pageSize:1},h.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(D){return(await this.galleryService.query({names:[D],pageSize:1},h.CancellationToken.None)).firstPage[0]}joinErrors(D){const O=Array.isArray(D)?D:[D];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(D,O,F){try{await this.preUninstallExtension(D);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(D,O);await this.uninstallExtensions(D,N,O,F)}catch(N){throw await this.postUninstallExtension(D,new g.ExtensionManagementError(N instanceof Error?N.message:N,W)),N}await this.postUninstallExtension(D)}async uninstallExtensions(D,O,F,N){const V=[D,...O];if(!N.donotCheckDependents)for(const G of V)this.checkForDependents(G,V,F,D);await m.Promises.settled([this.uninstallExtension(D),...O.map(G=>this.doUninstall(G))])}checkForDependents(D,O,F,N){const V=this.getDependents(D,F);if(V.length){const G=V.filter(Q=>O.indexOf(Q)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(D,G,N))}}getDependentsErrorMessage(D,O,F){return F===D?O.length===1?U.localize(12,null,F.manifest.displayName||F.manifest.name,O[0].manifest.displayName||O[0].manifest.name):O.length===2?U.localize(13,null,F.manifest.displayName||F.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):U.localize(14,null,F.manifest.displayName||F.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):O.length===1?U.localize(15,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name):O.length===2?U.localize(16,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):U.localize(17,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name)}getAllPackExtensionsToUninstall(D,O,F=[]){if(F.indexOf(D)!==-1)return[];F.push(D);const N=D.manifest.extensionPack?D.manifest.extensionPack:[];if(N.length){const V=O.filter(Q=>!Q.isBuiltin&&N.some(X=>(0,R.areSameExtensions)({id:X},Q.identifier))),G=[];for(const Q of V)G.push(...this.getAllPackExtensionsToUninstall(Q,O,F));return[...V,...G]}return[]}getDependents(D,O){return O.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,R.areSameExtensions)({id:N},D.identifier)))}async doUninstall(D){try{await this.preUninstallExtension(D),await this.uninstallExtension(D)}catch(O){throw await this.postUninstallExtension(D,new g.ExtensionManagementError(O instanceof Error?O.message:O,W)),O}await this.postUninstallExtension(D)}async preUninstallExtension(D){if(!await P.exists(D.location.fsPath))throw new Error(U.localize(18,null));this.logService.info("Uninstalling extension:",D.identifier.id),this._onUninstallExtension.fire(D.identifier)}async uninstallExtension(D){let O=this.uninstallingExtensions.get(D.identifier.id);return O||(O=(0,m.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,R.areSameExtensions)(N.identifier,D.identifier)))}),this.uninstallingExtensions.set(D.identifier.id,O),O.finally(()=>this.uninstallingExtensions.delete(D.identifier.id))),O}async postUninstallExtension(D,O){if(O)this.logService.error("Failed to uninstall extension:",D.identifier.id,O.message);else if(this.logService.info("Successfully uninstalled extension:",D.identifier.id),D.identifier.uuid)try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(D),void 0,O);const F=O?O instanceof g.ExtensionManagementError?O.code:z:void 0;this._onDidUninstallExtension.fire({identifier:D.identifier,error:F})}getInstalled(D=null){return this.extensionsScanner.scanExtensions(D)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(D){return(await this.filterUninstalled(D)).length===1}async filterUninstalled(...D){const O=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of D)F[N.key()]&&O.push(N.key());return O}getExtensionsReport(){const D=new Date().getTime();return(!this.reportedExtensions||D-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=D),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const D=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${D.length} reported extensions from service`),D}catch(D){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(D,O,F,N){const V=N?N instanceof g.ExtensionManagementError?N.code:z:void 0;this.telemetryService.publicLogError(D,Object.assign(Object.assign({},O),{success:!N,duration:F,errorcode:V}))}};H=ue([Y(0,d.INativeEnvironmentService),Y(1,g.IExtensionGalleryService),Y(2,w.ILogService),Y(3,(0,a.optional)(l.IDownloadService)),Y(4,i.ITelemetryService),Y(5,a.IInstantiationService),Y(6,$.IFileService)],H),e.ExtensionManagementService=H}),define(Z[207],ee([0,1,27,38,208,100,57,99,34,75,50,148,10,128,130,29,202,174,24,165,40,166,25,58,172,79,80,177,12,76,158,54,2,167,70,163,162,142,141,150,149,77,173,69,155,8,157,16,28,20,195,197,192,56,161,193,198,171,19,169,194,59,191,175,60,71,132,199,176,84,83,82,4,151,143,13,43,9,81,180,179,196,139,145,178]),function(K,e,v,U,A,P,k,T,f,g,R,d,m,b,o,C,E,p,w,y,s,i,t,n,r,l,a,c,h,S,I,u,L,_,$,B,M,j,W,z,H,q,D,O,F,N,V,G,Q,X,ne,ie,ae,he,fe,we,Ie,ke,Ue,Fe,_e,Me,De,Ae,$e,He,Ne,ze,J,re,se,me,x,te,oe,ce,le,de,ve,ye,Ee,be,Le,Se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ce extends L.Disposable{constructor(ge){super();this.configuration=ge,this.server=this._register(new T.Server),(0,A.gracefulify)(v),this.registerListeners()}registerListeners(){const ge=()=>this.dispose();process.once("exit",ge),P.ipcRenderer.once("vscode:electron-main->shared-process=exit",ge)}async open(){const ge=await this.initServices();(0,X.registerConfiguration)(),ge.invokeFunction(Pe=>{const Oe=Pe.get(h.ILogService);Oe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Pe),this.registerErrorHandler(Oe)}),this._register((0,L.combinedDisposable)(ge.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),ge.createInstance(M.LanguagePackCachedDataCleaner),ge.createInstance(j.StorageDataCleaner,this.configuration.backupWorkspacesPath),ge.createInstance(W.LogsDataCleaner),ge.createInstance(te.LocalizationsUpdater),ge.createInstance(oe.DeprecatedExtensionsCleaner)))}async initServices(){const ge=new g.ServiceCollection,Pe=Object.assign({_serviceBrand:void 0},k.default);ge.set(Q.IProductService,Pe);const Oe=new b.NativeEnvironmentService(this.configuration.args,Pe);ge.set(m.INativeEnvironmentService,Oe);const Je=new f.StaticRouter(je=>je==="main"),Ze=new S.LogLevelChannelClient(this.server.getChannel("logLevel",Je)),et=this._register(new h.MultiplexLogService([this._register(new h.ConsoleLogger(this.configuration.logLevel)),this._register(new q.SpdLogLogger("sharedprocess",(0,de.join)(Oe.logsPath,"sharedprocess.log"),!0,this.configuration.logLevel))])),qe=this._register(new S.FollowerLogService(Ze,et));ge.set(h.ILogService,qe);const Ge=new H.MessagePortMainProcessService(this.server,Je);ge.set(z.IMainProcessService,Ge);const Be=this._register(new F.FileService(qe));ge.set(N.IFileService,Be);const tt=this._register(new V.DiskFileSystemProvider(qe));Be.registerProvider(G.Schemas.file,tt);const We=this._register(new y.ConfigurationService(Oe.settingsResource,Be));ge.set(w.IConfigurationService,We),await We.initialize();const Ke=new ke.NativeStorageService(void 0,Ge,Oe);ge.set(Ue.IStorageService,Ke),await Ke.initialize(),this._register((0,L.toDisposable)(()=>Ke.flush())),ge.set(s.IRequestService,new R.SyncDescriptor(i.RequestService)),ge.set(Le.IChecksumService,new R.SyncDescriptor(Se.ChecksumService));const Xe=f.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ge.set(he.INativeHostService,Xe),ge.set($.IDownloadService,new R.SyncDescriptor(_.DownloadService));const it=this._register(new ze.ActiveWindowManager(Xe)),nt=new f.StaticRouter(je=>it.getActiveClientId().then(gt=>je===gt));ge.set(He.IExtensionRecommendationNotificationService,new Ne.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",nt)));const ot=this._register(new fe.LoggerService(qe,Be));ge.set(h.ILoggerService,ot);const{appRoot:ct,extensionsPath:lt,extensionDevelopmentLocationURI:ut,isBuilt:ht,installSourcePath:dt}=Oe;let Qe,xe;if(!ut&&!Oe.disableTelemetry&&Pe.enableTelemetry){if(xe=new J.TelemetryLogAppender(ot,Oe),Pe.aiConfig&&Pe.aiConfig.asimovKey&&ht){const je=new c.AppInsightsAppender("monacoworkbench",null,Pe.aiConfig.asimovKey);this._register((0,L.toDisposable)(()=>je.flush())),xe=(0,n.combinedAppender)(je,xe)}Qe=new a.TelemetryService({appender:xe,commonProperties:(0,r.resolveCommonProperties)(Be,(0,U.release)(),process.arch,Pe.commit,Pe.version,this.configuration.machineId,Pe.msftInternalDomains,dt),sendErrorTelemetry:!0,piiPaths:[ct,lt]},We)}else Qe=n.NullTelemetryService,xe=n.NullAppender;this.server.registerChannel("telemetryAppender",new l.TelemetryAppenderChannel(xe)),ge.set(t.ITelemetryService,Qe);const ft=new pe.CustomEndpointTelemetryService(We,Qe);return ge.set(t.ICustomEndpointTelemetryService,ft),ge.set(C.IExtensionManagementService,new R.SyncDescriptor(E.ExtensionManagementService)),ge.set(C.IExtensionGalleryService,new R.SyncDescriptor(p.ExtensionGalleryService)),ge.set(C.IExtensionTipsService,new R.SyncDescriptor(Ae.ExtensionTipsService)),ge.set(u.ILocalizationsService,new R.SyncDescriptor(I.LocalizationsService)),ge.set(O.IDiagnosticsService,new R.SyncDescriptor(D.DiagnosticsService)),ge.set(Me.IUserDataSyncAccountService,new R.SyncDescriptor(Me.UserDataSyncAccountService)),ge.set(X.IUserDataSyncLogService,new R.SyncDescriptor(we.UserDataSyncLogService)),ge.set(X.IUserDataSyncUtilService,new ae.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),ge.set(C.IGlobalExtensionEnablementService,new R.SyncDescriptor(Fe.GlobalExtensionEnablementService)),ge.set(se.IIgnoredExtensionsManagementService,new R.SyncDescriptor(se.IgnoredExtensionsManagementService)),ge.set(me.IExtensionsStorageSyncService,new R.SyncDescriptor(me.ExtensionsStorageSyncService)),ge.set(X.IUserDataSyncStoreManagementService,new R.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ge.set(X.IUserDataSyncStoreService,new R.SyncDescriptor(ie.UserDataSyncStoreService)),ge.set($e.IUserDataSyncMachinesService,new R.SyncDescriptor($e.UserDataSyncMachinesService)),ge.set(X.IUserDataSyncBackupStoreService,new R.SyncDescriptor(De.UserDataSyncBackupStoreService)),ge.set(X.IUserDataAutoSyncEnablementService,new R.SyncDescriptor(re.UserDataAutoSyncEnablementService)),ge.set(X.IUserDataSyncResourceEnablementService,new R.SyncDescriptor(_e.UserDataSyncResourceEnablementService)),ge.set(X.IUserDataSyncService,new R.SyncDescriptor(ne.UserDataSyncService)),ge.set(Ee.ILocalPtyService,this._register(new ye.PtyHostService(qe))),new d.InstantiationService(ge)}initChannels(ge){const Pe=new o.ExtensionManagementChannel(ge.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Pe);const Oe=f.ProxyChannel.fromService(ge.get(u.ILocalizationsService));this.server.registerChannel("localizations",Oe);const Je=f.ProxyChannel.fromService(ge.get(O.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const Ze=new o.ExtensionTipsChannel(ge.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const et=f.ProxyChannel.fromService(ge.get(Le.IChecksumService));this.server.registerChannel("checksum",et);const qe=new ae.UserDataSyncMachinesServiceChannel(ge.get($e.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",qe);const Ge=f.ProxyChannel.fromService(ge.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Be=new ae.UserDataSyncAccountServiceChannel(ge.get(Me.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const tt=new ae.UserDataSyncStoreManagementServiceChannel(ge.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",tt);const We=new be.UserDataSyncChannel(ge.get(X.IUserDataSyncService),ge.get(h.ILogService));this.server.registerChannel("userDataSync",We);const Ke=this._register(ge.get(x.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),Xe=new ae.UserDataAutoSyncChannel(Ke);this.server.registerChannel("userDataAutoSync",Xe);const it=ge.get(Ee.ILocalPtyService),nt=f.ProxyChannel.fromService(it);this.server.registerChannel(ve.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(ge){window.addEventListener("unhandledrejection",Pe=>{(0,ce.onUnexpectedError)(Pe.reason),Pe.preventDefault()}),(0,ce.setUnexpectedErrorHandler)(Pe=>{const Oe=(0,le.toErrorMessage)(Pe,!0);!Oe||ge.error(`[uncaught exception in sharedProcess]: ${Oe}`)})}}async function Re(Te){const ge=new Ce(Te);P.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ge.open(),P.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Re})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2b66dfe0218cc18333ba92429218b33802b186bc/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
