/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/process","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Z){for(var e=[],E=0,y=Z.length;E<y;E++)e[E]=pe[Z[E]];return e};define(pe[52],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(y,R){if(!y)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=E}),define(pe[53],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function y(T){const k=[];for(let b in T)E.call(T,b)&&k.push(T[b]);return k}e.values=y;function R(T,k){for(let b in T)if(E.call(T,b)&&k({key:b,value:T[b]},function(){delete T[b]})===!1)return}e.forEach=R;function P(T,k){const b=Object.create(null);for(const m of T){const a=k(m);let p=b[a];p||(p=b[a]=[]),p.push(m)}return b}e.groupBy=P;function C(T){const k=Object.create(null);return T&&T.forEach((b,m)=>{k[m]=b}),k}e.fromMap=C;function A(T,k){const b=[],m=[];for(let a of T)k.has(a)||b.push(a);for(let a of k)T.has(a)||m.push(a);return{removed:b,added:m}}e.diffSets=A;function D(T,k){const b=[],m=[];for(let[a,p]of T)k.has(a)||b.push(p);for(let[a,p]of k)T.has(a)||m.push(p);return{removed:b,added:m}}e.diffMaps=D;class n{constructor(){this.map=new Map}add(k,b){let m=this.map.get(k);m||(m=new Set,this.map.set(k,m)),m.add(b)}delete(k,b){const m=this.map.get(k);!m||(m.delete(b),m.size===0&&this.map.delete(k))}forEach(k,b){const m=this.map.get(k);!m||m.forEach(b)}}e.SetMap=n}),define(pe[68],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(D){return(n,T,k)=>{let b=null,m=null;if(typeof k.value=="function"?(b="value",m=k.value):typeof k.get=="function"&&(b="get",m=k.get),!m)throw new Error("not supported");k[b]=D(m,T)}}e.createDecorator=E;let y=0;function R(){const D=`$memoize${y++}`;let n;const T=function(b,m,a){let p=null,S=null;if(typeof a.value=="function"?(p="value",S=a.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(p="get",S=a.get),!S)throw new Error("not supported");const v=`${D}:${m}`;a[p]=function(..._){return n=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,_)}),this[v]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(D)===0&&delete n[k]})},T}e.createMemoizer=R;function P(D,n,T){return R()(D,n,T)}e.memoize=P;function C(D,n,T){return E((k,b)=>{const m=`$debounce$${b}`,a=`$debounce$result$${b}`;return function(...p){this[a]||(this[a]=T?T():void 0),clearTimeout(this[m]),n&&(this[a]=n(this[a],...p),p=[this[a]]),this[m]=setTimeout(()=>{k.apply(this,p),this[a]=T?T():void 0},D)}})}e.debounce=C;function A(D,n,T){return E((k,b)=>{const m=`$throttle$timer$${b}`,a=`$throttle$result$${b}`,p=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...v){if(this[a]||(this[a]=T?T():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),n&&(this[a]=n(this[a],...v)),!this[S]){const _=this[p]+D;_<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[a]]),this[a]=T?T():void 0):(this[S]=!0,this[m]=setTimeout(()=>{this[S]=!1,this[p]=Date.now(),k.apply(this,[this[a]]),this[a]=T?T():void 0},_-Date.now()))}}})}e.throttle=A}),define(pe[16],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function y(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=y;function R(s){D(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=R;function P(s){D(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=P;function C(s){if(s instanceof Error){let{name:t,message:i}=s;const o=s.stacktrace||s.stack;return{$isError:!0,name:t,message:i,stack:o}}return s}e.transformErrorForSerialization=C;const A="Canceled";function D(s){return s instanceof Error&&s.name===A&&s.message===A}e.isPromiseCanceledError=D;class n extends Error{constructor(){super(A);this.name=this.message}}e.CancellationError=n;function T(){const s=new Error(A);return s.name=s.message,s}e.canceled=T;function k(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=k;function b(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=b;function m(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function a(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function p(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=p;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function u(s,t=Object.create(null)){const i=new Error(s);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=u}),define(pe[14],ve([0,1,16]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function y(F,U=0){return F[F.length-(1+U)]}e.tail=y;function R(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=R;function P(F,U,M=(N,O)=>N===O){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let N=0,O=F.length;N<O;N++)if(!M(F[N],U[N]))return!1;return!0}e.equals=P;function C(F,U,M){let N=0,O=F.length-1;for(;N<=O;){const V=(N+O)/2|0,q=M(F[V],U);if(q<0)N=V+1;else if(q>0)O=V-1;else return V}return-(N+1)}e.binarySearch=C;function A(F,U){let M=0,N=F.length;if(N===0)return 0;for(;M<N;){const O=Math.floor((M+N)/2);U(F[O])?N=O:M=O+1}return M}e.findFirstInSorted=A;function D(F,U,M){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],V=[],q=[];for(let Q of U){const me=M(Q,N);me<0?O.push(Q):me>0?V.push(Q):q.push(Q)}return F<O.length?D(F,O,M):F<O.length+q.length?q[0]:D(F-(O.length+q.length),V,M)}e.quickSelect=D;function n(F,U){const M=[];let N;for(const O of F.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],M.push(N)):N.push(O);return M}e.groupBy=n;function T(F,U,M){const N=[];function O(Q,me,we){if(!(me===0&&we.length===0)){const Ae=N[N.length-1];Ae&&Ae.start+Ae.deleteCount===Q?(Ae.deleteCount+=me,Ae.toInsert.push(...we)):N.push({start:Q,deleteCount:me,toInsert:we})}}let V=0,q=0;for(;;){if(V===F.length){O(V,0,U.slice(q));break}if(q===U.length){O(V,F.length-V,[]);break}const Q=F[V],me=U[q],we=M(Q,me);we===0?(V+=1,q+=1):we<0?(O(V,1,[]),V+=1):we>0&&(O(V,0,[me]),q+=1)}return N}e.sortedDiff=T;function k(F,U,M){const N=T(F,U,M),O=[],V=[];for(const q of N)O.push(...F.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=k;function b(F,U,M){if(M===0)return[];const N=F.slice(0,M).sort(U);return a(F,U,N,M,F.length),N}e.top=b;function m(F,U,M,N,O){return M===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const Q=F.length,me=F.slice(0,M).sort(U);for(let we=M,Ae=Math.min(M+N,Q);we<Q;we=Ae,Ae=Math.min(Ae+N,Q)){if(we>M&&await new Promise(Ie=>setTimeout(Ie)),O&&O.isCancellationRequested)throw(0,E.canceled)();a(F,U,me,we,Ae)}return me})().then(V,q)})}e.topAsync=m;function a(F,U,M,N,O){for(const V=M.length;N<O;N++){const q=F[N];if(U(q,M[V-1])<0){M.pop();const Q=A(M,me=>U(q,me)<0);M.splice(Q,0,q)}}}function p(F){return F.filter(U=>!!U)}e.coalesce=p;function S(F){let U=0;for(let M=0;M<F.length;M++)F[M]&&(F[U]=F[M],U+=1);F.length=U}e.coalesceInPlace=S;function v(F,U,M){F.splice(M,0,F.splice(U,1)[0])}e.move=v;function _(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=_;function c(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=c;function u(F,U){if(!U)return F.filter((N,O)=>F.indexOf(N)===O);const M=Object.create(null);return F.filter(N=>{const O=U(N);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=u;function s(F){const U=new Set;return F.filter(M=>U.has(M)?!1:(U.add(M),!0))}e.distinctES6=s;function t(F){const U=Object.create(null);return M=>{const N=F(M);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function i(F,U){for(let M=F.length-1;M>=0;M--){const N=F[M];if(U(N))return M}return-1}e.lastIndex=i;function o(F,U){return F.length>0?F[0]:U}e.firstOrDefault=o;function r(F,U,M=(N,O)=>N===O){let N=0;for(let O=0,V=Math.min(F.length,U.length);O<V&&M(F[O],U[O]);O++)N++;return N}e.commonPrefixLength=r;function l(F){return[].concat(...F)}e.flatten=l;function h(F,U){let M=typeof U=="number"?F:0;typeof U=="number"?M=F:(M=0,U=F);const N=[];if(M<=U)for(let O=M;O<U;O++)N.push(O);else for(let O=M;O>U;O--)N.push(O);return N}e.range=h;function g(F,U,M){return F.reduce((N,O)=>(N[U(O)]=M?M(O):O,N),Object.create(null))}e.index=g;function w(F,U){return F.push(U),()=>d(F,U)}e.insert=w;function d(F,U){const M=F.indexOf(U);if(M>-1)return F.splice(M,1),U}e.remove=d;function f(F,U,M){const N=F.slice(0,U),O=F.slice(U);return N.concat(M,O)}e.arrayInsert=f;function I(F,U){let M;if(typeof U=="number"){let N=U;M=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let N=F.length-1;N>0;N-=1){const O=Math.floor(M()*(N+1)),V=F[N];F[N]=F[O],F[O]=V}}e.shuffle=I;function L(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.unshift(U))}e.pushToStart=L;function B(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.push(U))}e.pushToEnd=B;function ee(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=ee;function H(F){return Array.isArray(F)?F:[F]}e.asArray=H;function x(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=x;function $(F,U){for(const M of F){const N=U(M);if(N!==void 0)return N}}e.mapFind=$}),define(pe[69],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(y){const R=this;let P=!1,C;return function(){return P||(P=!0,C=y.apply(R,arguments)),C}}e.once=E}),define(pe[70],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(pe[71],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(y){function R(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}y.is=R;const P=Object.freeze([]);function C(){return P}y.empty=C;function*A(s){yield s}y.single=A;function D(s){return s||P}y.from=D;function n(s){return!s||s[Symbol.iterator]().next().done===!0}y.isEmpty=n;function T(s){return s[Symbol.iterator]().next().value}y.first=T;function k(s,t){for(const i of s)if(t(i))return!0;return!1}y.some=k;function b(s,t){for(const i of s)if(t(i))return i}y.find=b;function*m(s,t){for(const i of s)t(i)&&(yield i)}y.filter=m;function*a(s,t){for(const i of s)yield t(i)}y.map=a;function*p(...s){for(const t of s)for(const i of t)yield i}y.concat=p;function*S(s){for(const t of s)for(const i of t)yield i}y.concatNested=S;function v(s,t,i){let o=i;for(const r of s)o=t(o,r);return o}y.reduce=v;function*_(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}y.slice=_;function c(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const o=s[Symbol.iterator]();for(let r=0;r<t;r++){const l=o.next();if(l.done)return[i,y.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return o}}]}y.consume=c;function u(s,t,i=(o,r)=>o===r){const o=s[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=o.next(),h=r.next();if(l.done!==h.done)return!1;if(l.done)return!0;if(!i(l.value,h.value))return!1}}y.equals=u})(E=e.Iterable||(e.Iterable={}))}),define(pe[54],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function C(t,i=!1){let o=0,r=t.length,l="",h=0,g=16,w=0;function d(x){let $=0,F=0;for(;$<x;){const U=t.charCodeAt(o);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;o++,$++}return $<x&&(F=-1),F}function f(x){o=x,l="",h=0,g=16,w=0}function I(){const x=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return w=3,t.substring(x,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;$=o}else w=3;return t.substring(x,$)}function L(){let x="",$=o;for(;;){if(o>=r){x+=t.substring($,o),w=2;break}const F=t.charCodeAt(o);if(F===34){x+=t.substring($,o),o++;break}if(F===92){if(x+=t.substring($,o),o++,o>=r){w=2;break}switch(t.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const M=d(4);M>=0?x+=String.fromCharCode(M):w=4;break;default:w=5}$=o;continue}if(F>=0&&F<=31)if(D(F)){x+=t.substring($,o),w=2;break}else w=6;o++}return x}function B(){if(l="",w=0,h=o,o>=r)return h=r,g=17;let x=t.charCodeAt(o);if(A(x)){do o++,l+=String.fromCharCode(x),x=t.charCodeAt(o);while(A(x));return g=15}if(D(x))return o++,l+=String.fromCharCode(x),x===13&&t.charCodeAt(o)===10&&(o++,l+=`
`),g=14;switch(x){case 123:return o++,g=1;case 125:return o++,g=2;case 91:return o++,g=3;case 93:return o++,g=4;case 58:return o++,g=6;case 44:return o++,g=5;case 34:return o++,l=L(),g=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!D(t.charCodeAt(o));)o++;return l=t.substring($,o),g=12}if(t.charCodeAt(o+1)===42){o+=2;const F=r-1;let U=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,w=1),l=t.substring($,o),g=13}return l+=String.fromCharCode(x),o++,g=16;case 45:if(l+=String.fromCharCode(x),o++,o===r||!n(t.charCodeAt(o)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=I(),g=11;default:for(;o<r&&ee(x);)o++,x=t.charCodeAt(o);if(h!==o){switch(l=t.substring(h,o),l){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return l+=String.fromCharCode(x),o++,g=16}}function ee(x){if(A(x)||D(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:f,getPosition:()=>o,scan:i?H:B,getToken:()=>g,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>w}}e.createScanner=C;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,i){const o=[],r=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function w(d,f,I,L){h.value=d,h.offset=f,h.length=I,h.type=L,h.colonOffset=void 0,l=h}try{c(t,{onObjectBegin:(d,f)=>{if(i<=d)throw r;l=void 0,g=i>d,o.push("")},onObjectProperty:(d,f,I)=>{if(i<f||(w(d,f,I,"property"),o[o.length-1]=d,i<=f+I))throw r},onObjectEnd:(d,f)=>{if(i<=d)throw r;l=void 0,o.pop()},onArrayBegin:(d,f)=>{if(i<=d)throw r;l=void 0,o.push(0)},onArrayEnd:(d,f)=>{if(i<=d)throw r;l=void 0,o.pop()},onLiteralValue:(d,f,I)=>{if(i<f||(w(d,f,I,s(d)),i<=f+I))throw r},onSeparator:(d,f,I)=>{if(i<=f)throw r;if(d===":"&&l&&l.type==="property")l.colonOffset=f,g=!1,l=void 0;else if(d===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(g=!0,o[o.length-1]=""),l=void 0}}})}catch(d){if(d!==r)throw d}return{path:o,previousNode:l,isAtPropertyKey:g,matches:d=>{let f=0;for(let I=0;f<d.length&&I<o.length;I++)if(d[f]===o[I]||d[f]==="*")f++;else if(d[f]!=="**")return!1;return f===d.length}}}e.getLocation=k;function b(t,i=[],o=P.DEFAULT){let r=null,l=[];const h=[];function g(d){Array.isArray(l)?l.push(d):r!==null&&(l[r]=d)}return c(t,{onObjectBegin:()=>{const d={};g(d),h.push(l),l=d,r=null},onObjectProperty:d=>{r=d},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const d=[];g(d),h.push(l),l=d,r=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:g,onError:(d,f,I)=>{i.push({error:d,offset:f,length:I})}},o),l[0]}e.parse=b;function m(t,i=[],o=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(d){r.type==="property"&&(r.length=d-r.offset,r=r.parent)}function h(d){return r.children.push(d),d}c(t,{onObjectBegin:d=>{r=h({type:"object",offset:d,length:-1,parent:r,children:[]})},onObjectProperty:(d,f,I)=>{r=h({type:"property",offset:f,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:d,offset:f,length:I,parent:r})},onObjectEnd:(d,f)=>{r.length=d+f-r.offset,r=r.parent,l(d+f)},onArrayBegin:(d,f)=>{r=h({type:"array",offset:d,length:-1,parent:r,children:[]})},onArrayEnd:(d,f)=>{r.length=d+f-r.offset,r=r.parent,l(d+f)},onLiteralValue:(d,f,I)=>{h({type:s(d),offset:f,length:I,parent:r,value:d}),l(f+I)},onSeparator:(d,f,I)=>{r.type==="property"&&(d===":"?r.colonOffset=f:d===","&&l(f))},onError:(d,f,I)=>{i.push({error:d,offset:f,length:I})}},o);const w=r.children[0];return w&&delete w.parent,w}e.parseTree=m;function a(t,i){if(!!t){let o=t;for(let r of i)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let l=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===r){o=h.children[1],l=!0;break}if(!l)return}else{const l=r;if(o.type!=="array"||l<0||!Array.isArray(o.children)||l>=o.children.length)return;o=o.children[l]}return o}}e.findNodeAtLocation=a;function p(t){if(!t.parent||!t.parent.children)return[];const i=p(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;i.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&i.push(o)}return i}e.getNodePath=p;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let o of t.children){const r=o.children[1];r&&(i[o.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,i,o=!1){return i>=t.offset&&i<t.offset+t.length||o&&i===t.offset+t.length}e.contains=v;function _(t,i,o=!1){if(v(t,i,o)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=i;l++){const h=_(r[l],i,o);if(h)return h}return t}}e.findNodeAtOffset=_;function c(t,i,o=P.DEFAULT){const r=C(t,!1);function l(me){return me?()=>me(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(me){return me?we=>me(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const g=l(i.onObjectBegin),w=h(i.onObjectProperty),d=l(i.onObjectEnd),f=l(i.onArrayBegin),I=l(i.onArrayEnd),L=h(i.onLiteralValue),B=h(i.onSeparator),ee=l(i.onComment),H=h(i.onError),x=o&&o.disallowComments,$=o&&o.allowTrailingComma;function F(){for(;;){const me=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(me){case 12:case 13:x?U(10):ee();break;case 16:U(1);break;case 15:case 14:break;default:return me}}}function U(me,we=[],Ae=[]){if(H(me),we.length+Ae.length>0){let Ie=r.getToken();for(;Ie!==17;){if(we.indexOf(Ie)!==-1){F();break}else if(Ae.indexOf(Ie)!==-1)break;Ie=F()}}}function M(me){const we=r.getTokenValue();return me?L(we):w(we),F(),!0}function N(){switch(r.getToken()){case 11:let me=0;try{me=JSON.parse(r.getTokenValue()),typeof me!="number"&&(U(2),me=0)}catch(we){U(2)}L(me);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(B(":"),F(),Q()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){g(),F();let me=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),B(","),F(),r.getToken()===2&&$)break}else me&&U(6,[],[]);O()||U(4,[],[2,5]),me=!0}return d(),r.getToken()!==2?U(7,[2],[]):F(),!0}function q(){f(),F();let me=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),B(","),F(),r.getToken()===4&&$)break}else me&&U(6,[],[]);Q()||U(4,[],[4,5]),me=!0}return I(),r.getToken()!==4?U(8,[4],[]):F(),!0}function Q(){switch(r.getToken()){case 3:return q();case 1:return V();case 10:return M(!0);default:return N()}}return F(),r.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):Q()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=c;function u(t,i){let o=C(t),r=[],l,h=0,g;do switch(g=o.getPosition(),l=o.scan(),l){case 12:case 13:case 17:h!==g&&r.push(t.substring(h,g)),i!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,i)),h=o.getPosition();break}while(l!==17);return r.join("")}e.stripComments=u;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(pe[131],ve([0,1,54]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function y(D,n,T){let k,b,m,a,p;if(n){for(a=n.offset,p=a+n.length,m=a;m>0&&!A(D,m-1);)m--;let h=p;for(;h<D.length&&!A(D,h);)h++;b=D.substring(m,h),k=P(b,T)}else b=D,k=0,m=0,a=0,p=D.length;const S=C(T,D);let v=!1,_=0,c;T.insertSpaces?c=R(" ",T.tabSize||4):c="	";const u=(0,E.createScanner)(b,!1);let s=!1;function t(){return S+R(c,k+_)}function i(){let h=u.scan();for(v=!1;h===15||h===14;)v=v||h===14,h=u.scan();return s=h===16||u.getTokenError()!==0,h}const o=[];function r(h,g,w){!s&&g<p&&w>a&&D.substring(g,w)!==h&&o.push({offset:g,length:w-g,content:h})}let l=i();if(l!==17){const h=u.getTokenOffset()+m,g=R(c,k);r(g,m,h)}for(;l!==17;){let h=u.getTokenOffset()+u.getTokenLength()+m,g=i(),w="";for(;!v&&(g===12||g===13);){const f=u.getTokenOffset()+m;r(" ",h,f),h=u.getTokenOffset()+u.getTokenLength()+m,w=g===12?t():"",g=i()}if(g===2)l!==1&&(_--,w=t());else if(g===4)l!==3&&(_--,w=t());else{switch(l){case 3:case 1:_++,w=t();break;case 5:case 12:w=t();break;case 13:v?w=t():w=" ";break;case 6:w=" ";break;case 10:if(g===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?w=" ":g!==5&&g!==17&&(s=!0);break;case 16:s=!0;break}v&&(g===12||g===13)&&(w=t())}const d=u.getTokenOffset()+m;r(w,h,d),l=g}return o}e.format=y;function R(D,n){let T="";for(let k=0;k<n;k++)T+=D;return T}function P(D,n){let T=0,k=0;const b=n.tabSize||4;for(;T<D.length;){const m=D.charAt(T);if(m===" ")k++;else if(m==="	")k+=b;else break;T++}return Math.floor(k/b)}function C(D,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=C;function A(D,n){return`\r
`.indexOf(D.charAt(n))!==-1}e.isEOL=A}),define(pe[132],ve([0,1,54,131]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(n,T,k){return P(n,T,void 0,k)}e.removeProperty=R;function P(n,T,k,b,m){const a=T.slice(),p=[],S=(0,E.parseTree)(n,p);let v,_;for(;a.length>0&&(_=a.pop(),v=(0,E.findNodeAtLocation)(S,a),v===void 0&&k!==void 0);)typeof _=="string"?k={[_]:k}:k=[k];if(v)if(v.type==="object"&&typeof _=="string"&&Array.isArray(v.children)){const c=(0,E.findNodeAtLocation)(v,[_]);if(c!==void 0)if(k===void 0){if(!c.parent)throw new Error("Malformed AST");const u=v.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(u>0){const i=v.children[u-1];s=i.offset+i.length}else s=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return C(n,{offset:s,length:t-s,content:""},b)}else return C(n,{offset:c.offset,length:c.length,content:JSON.stringify(k)},b);else{if(k===void 0)return[];const u=`${JSON.stringify(_)}: ${JSON.stringify(k)}`,s=m?m(v.children.map(i=>i.children[0].value)):v.children.length;let t;if(s>0){const i=v.children[s-1];t={offset:i.offset+i.length,length:0,content:","+u}}else v.children.length===0?t={offset:v.offset+1,length:0,content:u}:t={offset:v.offset+1,length:0,content:u+","};return C(n,t,b)}}else if(v.type==="array"&&typeof _=="number"&&Array.isArray(v.children))if(k!==void 0){const c=`${JSON.stringify(k)}`;let u;if(v.children.length===0||_===0)u={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const s=_===-1||_>v.children.length?v.children.length:_,t=v.children[s-1];u={offset:t.offset+t.length,length:0,content:","+c}}return C(n,u,b)}else{const c=_,u=v.children[c];let s;if(v.children.length===1)s={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const t=v.children[c-1],i=t.offset+t.length,o=v.offset+v.length;s={offset:i,length:o-2-i,content:""}}else s={offset:u.offset,length:v.children[c+1].offset-u.offset,content:""};return C(n,s,b)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${v.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return C(n,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(k)},b)}}e.setProperty=P;function C(n,T,k){let b=A(n,T),m=T.offset,a=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;m>0&&!(0,y.isEOL)(b,m-1);)m--;for(;a<b.length&&!(0,y.isEOL)(b,a);)a++}const p=(0,y.format)(b,{offset:m,length:a-m},k);for(let v=p.length-1;v>=0;v--){const _=p[v];b=A(b,_),m=Math.min(m,_.offset),a=Math.max(a,_.offset+_.length),a+=_.content.length-_.length}const S=n.length-(b.length-a)-m;return[{offset:m,length:S,content:b.substring(m,a)}]}e.withFormatting=C;function A(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=A;function D(n,T){let k=T.slice(0).sort((m,a)=>{const p=m.offset-a.offset;return p===0?m.length-a.length:p}),b=n.length;for(let m=k.length-1;m>=0;m--){let a=k[m];if(a.offset+a.length<=b)n=A(n,a);else throw new Error("Overlapping edit");b=a.offset}return n}e.applyEdits=D}),define(pe[133],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new E(()=>R(this.getValue()))}}e.Lazy=E}),define(pe[6],ve([0,1,69,71]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let P=null;function C(c){P=c}if(e.setDisposableTracker=C,R){const c="__is_disposable_tracked__";P=new class{trackDisposable(u){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[c]||console.log(s)},3e3)}markTracked(u){if(u&&u!==p.None)try{u[c]=!0}catch(s){}}}}function A(c){!P||P.markTracked(c)}function D(c){return P&&P.trackDisposable(c),c}e.trackDisposable=D;class n extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=n;function T(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=T;function k(c){if(y.Iterable.is(c)){let u=[];for(const s of c)if(s){A(s);try{s.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new n(u);return Array.isArray(c)?[]:c}else if(c)return A(c),c.dispose(),c}e.dispose=k;function b(...c){return c.forEach(A),m(()=>k(c))}e.combinedDisposable=b;function m(c){const u=D({dispose:()=>{A(u),c()}});return u}e.toDisposable=m;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(A(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return A(u),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new a,D(this)}dispose(){A(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var s;this._isDisposed||u===this._value||((s=this._value)===null||s===void 0||s.dispose(),u&&A(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,A(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(u,...s){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...s)},this.references.set(u,t));const{object:i}=t,o=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:i,dispose:o}}}e.ReferenceCollection=v;class _{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=_}),define(pe[55],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(P){this.element=P,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class y{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,C){const A=new E(P);if(this._first===E.Undefined)this._first=A,this._last=A;else if(C){const n=this._last;this._last=A,A.prev=n,n.next=A}else{const n=this._first;this._first=A,A.next=n,n.prev=A}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(A))}}shift(){if(this._first!==E.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==E.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==E.Undefined&&P.next!==E.Undefined){const C=P.prev;C.next=P.next,P.next.prev=C}else P.prev===E.Undefined&&P.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):P.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):P.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==E.Undefined;)yield P.element,P=P.next}}e.LinkedList=y}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(K,se){for(var he=0;he<se.length;he++){var Y=se[he];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(K,Y.key,Y)}}function e(K,se,he){return se&&Z(K.prototype,se),he&&Z(K,he),K}function E(K,se){if(!!K){if(typeof K=="string")return y(K,se);var he=Object.prototype.toString.call(K).slice(8,-1);if(he==="Object"&&K.constructor&&(he=K.constructor.name),he==="Map"||he==="Set")return Array.from(K);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return y(K,se)}}function y(K,se){(se==null||se>K.length)&&(se=K.length);for(var he=0,Y=new Array(se);he<se;he++)Y[he]=K[he];return Y}function R(K,se){var he;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(he=E(K))||se&&K&&typeof K.length=="number"){he&&(K=he);var Y=0;return function(){return Y>=K.length?{done:!0}:{done:!1,value:K[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=K[Symbol.iterator](),he.next.bind(he)}function P(K){var se={exports:{}};return K(se,se.exports),se.exports}var C=P(function(K){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(Y){K.exports.defaults=Y}K.exports={defaults:se(),getDefaults:se,changeDefaults:he}}),A=/[&<>"']/,D=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(se){return k[se]};function m(K,se){if(se){if(A.test(K))return K.replace(D,b)}else if(n.test(K))return K.replace(T,b);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(K){return K.replace(a,function(se,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(K,se){K=K.source||K,se=se||"";var he={replace:function(ne,le){return le=le.source||le,le=le.replace(S,"$1"),K=K.replace(ne,le),he},getRegex:function(){return new RegExp(K,se)}};return he}var _=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(K,se,he){if(K){var Y;try{Y=decodeURIComponent(p(he)).replace(_,"").toLowerCase()}catch(ne){return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}se&&!c.test(he)&&(he=r(se,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ne){return null}return he}var s={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,se){s[" "+K]||(t.test(K)?s[" "+K]=K+"/":s[" "+K]=w(K,"/",!0)),K=s[" "+K];var he=K.indexOf(":")===-1;return se.substring(0,2)==="//"?he?se:K.replace(i,"$1")+se:se.charAt(0)==="/"?he?se:K.replace(o,"$1")+se:K+se}var l={exec:function(){}};function h(K){for(var se=1,he,Y;se<arguments.length;se++){he=arguments[se];for(Y in he)Object.prototype.hasOwnProperty.call(he,Y)&&(K[Y]=he[Y])}return K}function g(K,se){var he=K.replace(/\|/g,function(le,ge,be){for(var He=!1,$e=ge;--$e>=0&&be[$e]==="\\";)He=!He;return He?"|":" |"}),Y=he.split(/ \|/),ne=0;if(Y.length>se)Y.splice(se);else for(;Y.length<se;)Y.push("");for(;ne<Y.length;ne++)Y[ne]=Y[ne].trim().replace(/\\\|/g,"|");return Y}function w(K,se,he){var Y=K.length;if(Y===0)return"";for(var ne=0;ne<Y;){var le=K.charAt(Y-ne-1);if(le===se&&!he)ne++;else if(le!==se&&he)ne++;else break}return K.substr(0,Y-ne)}function d(K,se){if(K.indexOf(se[1])===-1)return-1;for(var he=K.length,Y=0,ne=0;ne<he;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===se[0])Y++;else if(K[ne]===se[1]&&(Y--,Y<0))return ne;return-1}function f(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(K,se){if(se<1)return"";for(var he="";se>1;)se&1&&(he+=K),se>>=1,K+=K;return he+K}var L={escape:m,unescape:p,edit:v,cleanUrl:u,resolveUrl:r,noopTest:l,merge:h,splitCells:g,rtrim:w,findClosingBracket:d,checkSanitizeDeprecation:f,repeatString:I},B=C.defaults,ee=L.rtrim,H=L.splitCells,x=L.escape,$=L.findClosingBracket;function F(K,se,he){var Y=se.href,ne=se.title?x(se.title):null,le=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:he,href:Y,title:ne,text:le}:{type:"image",raw:he,href:Y,title:ne,text:x(le)}}function U(K,se){var he=K.match(/^(\s+)(?:```)/);if(he===null)return se;var Y=he[1];return se.split(`
`).map(function(ne){var le=ne.match(/^\s+/);if(le===null)return ne;var ge=le[0];return ge.length>=Y.length?ne.slice(Y.length):ne}).join(`
`)}var M=function(){function K(he){this.options=he||B}var se=K.prototype;return se.space=function(Y){var ne=this.rules.block.newline.exec(Y);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},se.code=function(Y){var ne=this.rules.block.code.exec(Y);if(ne){var le=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?le:ee(le,`
`)}}},se.fences=function(Y){var ne=this.rules.block.fences.exec(Y);if(ne){var le=ne[0],ge=U(le,ne[3]||"");return{type:"code",raw:le,lang:ne[2]?ne[2].trim():ne[2],text:ge}}},se.heading=function(Y){var ne=this.rules.block.heading.exec(Y);if(ne){var le=ne[2].trim();if(/#$/.test(le)){var ge=ee(le,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(le=ge.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:le}}},se.nptable=function(Y){var ne=this.rules.block.nptable.exec(Y);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(le.header.length===le.align.length){var ge=le.align.length,be;for(be=0;be<ge;be++)/^ *-+: *$/.test(le.align[be])?le.align[be]="right":/^ *:-+: *$/.test(le.align[be])?le.align[be]="center":/^ *:-+ *$/.test(le.align[be])?le.align[be]="left":le.align[be]=null;for(ge=le.cells.length,be=0;be<ge;be++)le.cells[be]=H(le.cells[be],le.header.length);return le}}},se.hr=function(Y){var ne=this.rules.block.hr.exec(Y);if(ne)return{type:"hr",raw:ne[0]}},se.blockquote=function(Y){var ne=this.rules.block.blockquote.exec(Y);if(ne){var le=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:le}}},se.list=function(Y){var ne=this.rules.block.list.exec(Y);if(ne){var le=ne[0],ge=ne[2],be=ge.length>1,He={type:"list",raw:le,ordered:be,start:be?+ge.slice(0,-1):"",loose:!1,items:[]},$e=ne[0].match(this.rules.block.item),qe=!1,Xe,Ze,ut,ot,nt,ce,Ce,ue,X=$e.length;ut=this.rules.block.listItemStart.exec($e[0]);for(var Re=0;Re<X;Re++){if(Xe=$e[Re],le=Xe,Re!==X-1){if(ot=this.rules.block.listItemStart.exec($e[Re+1]),this.options.pedantic?ot[1].length>ut[1].length:ot[1].length>ut[0].length||ot[1].length>3){$e.splice(Re,2,$e[Re]+`
`+$e[Re+1]),Re--,X--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==ge[ge.length-1]:be===(ot[2].length===1))&&(nt=$e.slice(Re+1).join(`
`),He.raw=He.raw.substring(0,He.raw.length-nt.length),Re=X-1);ut=ot}Ze=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(Ze-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ce=qe||/\n\n(?!\s*$)/.test(Xe),Re!==X-1&&(qe=Xe.charAt(Xe.length-1)===`
`,ce||(ce=qe)),ce&&(He.loose=!0),this.options.gfm&&(Ce=/^\[[ xX]\] /.test(Xe),ue=void 0,Ce&&(ue=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:Ce,checked:ue,loose:ce,text:Xe})}return He}},se.html=function(Y){var ne=this.rules.block.html.exec(Y);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):x(ne[0]):ne[0]}},se.def=function(Y){var ne=this.rules.block.def.exec(Y);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var le=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ne[0],href:ne[2],title:ne[3]}}},se.table=function(Y){var ne=this.rules.block.table.exec(Y);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ne[0];var ge=le.align.length,be;for(be=0;be<ge;be++)/^ *-+: *$/.test(le.align[be])?le.align[be]="right":/^ *:-+: *$/.test(le.align[be])?le.align[be]="center":/^ *:-+ *$/.test(le.align[be])?le.align[be]="left":le.align[be]=null;for(ge=le.cells.length,be=0;be<ge;be++)le.cells[be]=H(le.cells[be].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},se.lheading=function(Y){var ne=this.rules.block.lheading.exec(Y);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},se.paragraph=function(Y){var ne=this.rules.block.paragraph.exec(Y);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},se.text=function(Y){var ne=this.rules.block.text.exec(Y);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},se.escape=function(Y){var ne=this.rules.inline.escape.exec(Y);if(ne)return{type:"escape",raw:ne[0],text:x(ne[1])}},se.tag=function(Y,ne,le){var ge=this.rules.inline.tag.exec(Y);if(ge)return!ne&&/^<a /i.test(ge[0])?ne=!0:ne&&/^<\/a>/i.test(ge[0])&&(ne=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:ne,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):x(ge[0]):ge[0]}},se.link=function(Y){var ne=this.rules.inline.link.exec(Y);if(ne){var le=ne[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ge=ee(le.slice(0,-1),"\\");if((le.length-ge.length)%2==0)return}else{var be=$(ne[2],"()");if(be>-1){var He=ne[0].indexOf("!")===0?5:4,$e=He+ne[1].length+be;ne[2]=ne[2].substring(0,be),ne[0]=ne[0].substring(0,$e).trim(),ne[3]=""}}var qe=ne[2],Xe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Ze&&(qe=Ze[1],Xe=Ze[3])}else Xe=ne[3]?ne[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),F(ne,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ne[0])}},se.reflink=function(Y,ne){var le;if((le=this.rules.inline.reflink.exec(Y))||(le=this.rules.inline.nolink.exec(Y))){var ge=(le[2]||le[1]).replace(/\s+/g," ");if(ge=ne[ge.toLowerCase()],!ge||!ge.href){var be=le[0].charAt(0);return{type:"text",raw:be,text:be}}return F(le,ge,le[0])}},se.emStrong=function(Y,ne,le){le===void 0&&(le="");var ge=this.rules.inline.emStrong.lDelim.exec(Y);if(!!ge&&!(ge[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=ge[1]||ge[2]||"";if(!be||be&&(le===""||this.rules.inline.punctuation.exec(le))){var He=ge[0].length-1,$e,qe,Xe=He,Ze=0,ut=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ut.lastIndex=0,ne=ne.slice(-1*Y.length+He);(ge=ut.exec(ne))!=null;)if($e=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!$e){if(qe=$e.length,ge[3]||ge[4]){Xe+=qe;continue}else if((ge[5]||ge[6])&&He%3&&!((He+qe)%3)){Ze+=qe;continue}if(Xe-=qe,!(Xe>0)){if(Xe+Ze-qe<=0&&!ne.slice(ut.lastIndex).match(ut)&&(qe=Math.min(qe,qe+Xe+Ze)),Math.min(He,qe)%2)return{type:"em",raw:Y.slice(0,He+ge.index+qe+1),text:Y.slice(1,He+ge.index+qe)};if(Math.min(He,qe)%2==0)return{type:"strong",raw:Y.slice(0,He+ge.index+qe+1),text:Y.slice(2,He+ge.index+qe-1)}}}}}},se.codespan=function(Y){var ne=this.rules.inline.code.exec(Y);if(ne){var le=ne[2].replace(/\n/g," "),ge=/[^ ]/.test(le),be=/^ /.test(le)&&/ $/.test(le);return ge&&be&&(le=le.substring(1,le.length-1)),le=x(le,!0),{type:"codespan",raw:ne[0],text:le}}},se.br=function(Y){var ne=this.rules.inline.br.exec(Y);if(ne)return{type:"br",raw:ne[0]}},se.del=function(Y){var ne=this.rules.inline.del.exec(Y);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},se.autolink=function(Y,ne){var le=this.rules.inline.autolink.exec(Y);if(le){var ge,be;return le[2]==="@"?(ge=x(this.options.mangle?ne(le[1]):le[1]),be="mailto:"+ge):(ge=x(le[1]),be=ge),{type:"link",raw:le[0],text:ge,href:be,tokens:[{type:"text",raw:ge,text:ge}]}}},se.url=function(Y,ne){var le;if(le=this.rules.inline.url.exec(Y)){var ge,be;if(le[2]==="@")ge=x(this.options.mangle?ne(le[0]):le[0]),be="mailto:"+ge;else{var He;do He=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(He!==le[0]);ge=x(le[0]),le[1]==="www."?be="http://"+ge:be=ge}return{type:"link",raw:le[0],text:ge,href:be,tokens:[{type:"text",raw:ge,text:ge}]}}},se.inlineText=function(Y,ne,le){var ge=this.rules.inline.text.exec(Y);if(ge){var be;return ne?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):x(ge[0]):ge[0]:be=x(this.options.smartypants?le(ge[0]):ge[0]),{type:"text",raw:ge[0],text:be}}},K}(),N=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=V({},Q),Q.pedantic=V({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=V({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=V({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:q,inline:Q},we=C.defaults,Ae=me.block,Ie=me.inline,Me=L.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(K){var se="",he,Y,ne=K.length;for(he=0;he<ne;he++)Y=K.charCodeAt(he),Math.random()>.5&&(Y="x"+Y.toString(16)),se+="&#"+Y+";";return se}var te=function(){function K(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Y={block:Ae.normal,inline:Ie.normal};this.options.pedantic?(Y.block=Ae.pedantic,Y.inline=Ie.pedantic):this.options.gfm&&(Y.block=Ae.gfm,this.options.breaks?Y.inline=Ie.breaks:Y.inline=Ie.gfm),this.tokenizer.rules=Y}K.lex=function(Y,ne){var le=new K(ne);return le.lex(Y)},K.lexInline=function(Y,ne){var le=new K(ne);return le.inlineTokens(Y)};var se=K.prototype;return se.lex=function(Y){return Y=Y.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Y,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(Y,ne,le){ne===void 0&&(ne=[]),le===void 0&&(le=!0),this.options.pedantic&&(Y=Y.replace(/^ +$/gm,""));for(var ge,be,He,$e;Y;){if(ge=this.tokenizer.space(Y)){Y=Y.substring(ge.raw.length),ge.type&&ne.push(ge);continue}if(ge=this.tokenizer.code(Y)){Y=Y.substring(ge.raw.length),$e=ne[ne.length-1],$e&&$e.type==="paragraph"?($e.raw+=`
`+ge.raw,$e.text+=`
`+ge.text):ne.push(ge);continue}if(ge=this.tokenizer.fences(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.heading(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.nptable(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.hr(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.blockquote(Y)){Y=Y.substring(ge.raw.length),ge.tokens=this.blockTokens(ge.text,[],le),ne.push(ge);continue}if(ge=this.tokenizer.list(Y)){for(Y=Y.substring(ge.raw.length),He=ge.items.length,be=0;be<He;be++)ge.items[be].tokens=this.blockTokens(ge.items[be].text,[],!1);ne.push(ge);continue}if(ge=this.tokenizer.html(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(le&&(ge=this.tokenizer.def(Y))){Y=Y.substring(ge.raw.length),this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.lheading(Y)){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(le&&(ge=this.tokenizer.paragraph(Y))){Y=Y.substring(ge.raw.length),ne.push(ge);continue}if(ge=this.tokenizer.text(Y)){Y=Y.substring(ge.raw.length),$e=ne[ne.length-1],$e&&$e.type==="text"?($e.raw+=`
`+ge.raw,$e.text+=`
`+ge.text):ne.push(ge);continue}if(Y){var qe="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ne},se.inline=function(Y){var ne,le,ge,be,He,$e,qe=Y.length;for(ne=0;ne<qe;ne++)switch($e=Y[ne],$e.type){case"paragraph":case"text":case"heading":{$e.tokens=[],this.inlineTokens($e.text,$e.tokens);break}case"table":{for($e.tokens={header:[],cells:[]},be=$e.header.length,le=0;le<be;le++)$e.tokens.header[le]=[],this.inlineTokens($e.header[le],$e.tokens.header[le]);for(be=$e.cells.length,le=0;le<be;le++)for(He=$e.cells[le],$e.tokens.cells[le]=[],ge=0;ge<He.length;ge++)$e.tokens.cells[le][ge]=[],this.inlineTokens(He[ge],$e.tokens.cells[le][ge]);break}case"blockquote":{this.inline($e.tokens);break}case"list":{for(be=$e.items.length,le=0;le<be;le++)this.inline($e.items[le].tokens);break}}return Y},se.inlineTokens=function(Y,ne,le,ge){ne===void 0&&(ne=[]),le===void 0&&(le=!1),ge===void 0&&(ge=!1);var be,He,$e=Y,qe,Xe,Ze;if(this.tokens.links){var ut=Object.keys(this.tokens.links);if(ut.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)ut.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,qe.index)+"["+Me("a",qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,qe.index)+"["+Me("a",qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,qe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;){if(Xe||(Ze=""),Xe=!1,be=this.tokenizer.escape(Y)){Y=Y.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.tag(Y,le,ge)){Y=Y.substring(be.raw.length),le=be.inLink,ge=be.inRawBlock;var ot=ne[ne.length-1];ot&&be.type==="text"&&ot.type==="text"?(ot.raw+=be.raw,ot.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.link(Y)){Y=Y.substring(be.raw.length),be.type==="link"&&(be.tokens=this.inlineTokens(be.text,[],!0,ge)),ne.push(be);continue}if(be=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(be.raw.length);var nt=ne[ne.length-1];be.type==="link"?(be.tokens=this.inlineTokens(be.text,[],!0,ge),ne.push(be)):nt&&be.type==="text"&&nt.type==="text"?(nt.raw+=be.raw,nt.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.emStrong(Y,$e,Ze)){Y=Y.substring(be.raw.length),be.tokens=this.inlineTokens(be.text,[],le,ge),ne.push(be);continue}if(be=this.tokenizer.codespan(Y)){Y=Y.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.br(Y)){Y=Y.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.del(Y)){Y=Y.substring(be.raw.length),be.tokens=this.inlineTokens(be.text,[],le,ge),ne.push(be);continue}if(be=this.tokenizer.autolink(Y,J)){Y=Y.substring(be.raw.length),ne.push(be);continue}if(!le&&(be=this.tokenizer.url(Y,J))){Y=Y.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.inlineText(Y,ge,z)){Y=Y.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(Ze=be.raw.slice(-1)),Xe=!0,He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=be.raw,He.text+=be.text):ne.push(be);continue}if(Y){var ce="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Ie}}}]),K}(),ae=C.defaults,fe=L.cleanUrl,De=L.escape,Oe=function(){function K(he){this.options=he||ae}var se=K.prototype;return se.code=function(Y,ne,le){var ge=(ne||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(Y,ge);be!=null&&be!==Y&&(le=!0,Y=be)}return Y=Y.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+De(ge,!0)+'">'+(le?Y:De(Y,!0))+`</code></pre>
`:"<pre><code>"+(le?Y:De(Y,!0))+`</code></pre>
`},se.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},se.html=function(Y){return Y},se.heading=function(Y,ne,le,ge){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+ge.slug(le)+'">'+Y+"</h"+ne+`>
`:"<h"+ne+">"+Y+"</h"+ne+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(Y,ne,le){var ge=ne?"ol":"ul",be=ne&&le!==1?' start="'+le+'"':"";return"<"+ge+be+`>
`+Y+"</"+ge+`>
`},se.listitem=function(Y){return"<li>"+Y+`</li>
`},se.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(Y){return"<p>"+Y+`</p>
`},se.table=function(Y,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+ne+`</table>
`},se.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},se.tablecell=function(Y,ne){var le=ne.header?"th":"td",ge=ne.align?"<"+le+' align="'+ne.align+'">':"<"+le+">";return ge+Y+"</"+le+`>
`},se.strong=function(Y){return"<strong>"+Y+"</strong>"},se.em=function(Y){return"<em>"+Y+"</em>"},se.codespan=function(Y){return"<code>"+Y+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(Y){return"<del>"+Y+"</del>"},se.link=function(Y,ne,le){if(Y=fe(this.options.sanitize,this.options.baseUrl,Y),Y===null)return le;var ge='<a href="'+De(Y)+'"';return ne&&(ge+=' title="'+ne+'"'),ge+=">"+le+"</a>",ge},se.image=function(Y,ne,le){if(Y=fe(this.options.sanitize,this.options.baseUrl,Y),Y===null)return le;var ge='<img src="'+Y+'" alt="'+le+'"';return ne&&(ge+=' title="'+ne+'"'),ge+=this.options.xhtml?"/>":">",ge},se.text=function(Y){return Y},K}(),_e=function(){function K(){}var se=K.prototype;return se.strong=function(Y){return Y},se.em=function(Y){return Y},se.codespan=function(Y){return Y},se.del=function(Y){return Y},se.html=function(Y){return Y},se.text=function(Y){return Y},se.link=function(Y,ne,le){return""+le},se.image=function(Y,ne,le){return""+le},se.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var se=K.prototype;return se.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(Y,ne){var le=Y,ge=0;if(this.seen.hasOwnProperty(le)){ge=this.seen[Y];do ge++,le=Y+"-"+ge;while(this.seen.hasOwnProperty(le))}return ne||(this.seen[Y]=ge,this.seen[le]=0),le},se.slug=function(Y,ne){ne===void 0&&(ne={});var le=this.serialize(Y);return this.getNextSafeSlug(le,ne.dryrun)},K}(),Te=C.defaults,xe=L.unescape,Se=function(){function K(he){this.options=he||Te,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _e,this.slugger=new ke}K.parse=function(Y,ne){var le=new K(ne);return le.parse(Y)},K.parseInline=function(Y,ne){var le=new K(ne);return le.parseInline(Y)};var se=K.prototype;return se.parse=function(Y,ne){ne===void 0&&(ne=!0);var le="",ge,be,He,$e,qe,Xe,Ze,ut,ot,nt,ce,Ce,ue,X,Re,Le,Ye,Ge,rt=Y.length;for(ge=0;ge<rt;ge++)switch(nt=Y[ge],nt.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,xe(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(ut="",Ze="",$e=nt.header.length,be=0;be<$e;be++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[be]),{header:!0,align:nt.align[be]});for(ut+=this.renderer.tablerow(Ze),ot="",$e=nt.cells.length,be=0;be<$e;be++){for(Xe=nt.tokens.cells[be],Ze="",qe=Xe.length,He=0;He<qe;He++)Ze+=this.renderer.tablecell(this.parseInline(Xe[He]),{header:!1,align:nt.align[He]});ot+=this.renderer.tablerow(Ze)}le+=this.renderer.table(ut,ot);continue}case"blockquote":{ot=this.parse(nt.tokens),le+=this.renderer.blockquote(ot);continue}case"list":{for(ce=nt.ordered,Ce=nt.start,ue=nt.loose,$e=nt.items.length,ot="",be=0;be<$e;be++)Re=nt.items[be],Le=Re.checked,Ye=Re.task,X="",Re.task&&(Ge=this.renderer.checkbox(Le),ue?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=Ge+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=Ge+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:Ge}):X+=Ge),X+=this.parse(Re.tokens,ue),ot+=this.renderer.listitem(X,Ye,Le);le+=this.renderer.list(ot,ce,Ce);continue}case"html":{le+=this.renderer.html(nt.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(ot=nt.tokens?this.parseInline(nt.tokens):nt.text;ge+1<rt&&Y[ge+1].type==="text";)nt=Y[++ge],ot+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);le+=ne?this.renderer.paragraph(ot):ot;continue}default:{var at='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return le},se.parseInline=function(Y,ne){ne=ne||this.renderer;var le="",ge,be,He=Y.length;for(ge=0;ge<He;ge++)switch(be=Y[ge],be.type){case"escape":{le+=ne.text(be.text);break}case"html":{le+=ne.html(be.text);break}case"link":{le+=ne.link(be.href,be.title,this.parseInline(be.tokens,ne));break}case"image":{le+=ne.image(be.href,be.title,be.text);break}case"strong":{le+=ne.strong(this.parseInline(be.tokens,ne));break}case"em":{le+=ne.em(this.parseInline(be.tokens,ne));break}case"codespan":{le+=ne.codespan(be.text);break}case"br":{le+=ne.br();break}case"del":{le+=ne.del(this.parseInline(be.tokens,ne));break}case"text":{le+=ne.text(be.text);break}default:{var $e='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}return le},K}(),Ke=L.merge,G=L.checkSanitizeDeprecation,ie=L.escape,Ee=C.getDefaults,Ne=C.changeDefaults,ze=C.defaults;function We(K,se,he){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof se=="function"&&(he=se,se=null),se=Ke({},We.defaults,se||{}),G(se),he){var Y=se.highlight,ne;try{ne=te.lex(K,se)}catch(He){return he(He)}var le=function($e){var qe;if(!$e)try{qe=Se.parse(ne,se)}catch(Xe){$e=Xe}return se.highlight=Y,$e?he($e):he(null,qe)};if(!Y||Y.length<3||(delete se.highlight,!ne.length))return le();var ge=0;We.walkTokens(ne,function(He){He.type==="code"&&(ge++,setTimeout(function(){Y(He.text,He.lang,function($e,qe){if($e)return le($e);qe!=null&&qe!==He.text&&(He.text=qe,He.escaped=!0),ge--,ge===0&&le()})},0))}),ge===0&&le();return}try{var be=te.lex(K,se);return se.walkTokens&&We.walkTokens(be,se.walkTokens),Se.parse(be,se)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(He.message+"",!0)+"</pre>";throw He}}We.options=We.setOptions=function(K){return Ke(We.defaults,K),Ne(We.defaults),We},We.getDefaults=Ee,We.defaults=ze,We.use=function(K){var se=Ke({},K);if(K.renderer&&function(){var Y=We.defaults.renderer||new Oe,ne=function(be){var He=Y[be];Y[be]=function(){for(var $e=arguments.length,qe=new Array($e),Xe=0;Xe<$e;Xe++)qe[Xe]=arguments[Xe];var Ze=K.renderer[be].apply(Y,qe);return Ze===!1&&(Ze=He.apply(Y,qe)),Ze}};for(var le in K.renderer)ne(le);se.renderer=Y}(),K.tokenizer&&function(){var Y=We.defaults.tokenizer||new M,ne=function(be){var He=Y[be];Y[be]=function(){for(var $e=arguments.length,qe=new Array($e),Xe=0;Xe<$e;Xe++)qe[Xe]=arguments[Xe];var Ze=K.tokenizer[be].apply(Y,qe);return Ze===!1&&(Ze=He.apply(Y,qe)),Ze}};for(var le in K.tokenizer)ne(le);se.tokenizer=Y}(),K.walkTokens){var he=We.defaults.walkTokens;se.walkTokens=function(Y){K.walkTokens(Y),he&&he(Y)}}We.setOptions(se)},We.walkTokens=function(K,se){for(var he=R(K),Y;!(Y=he()).done;){var ne=Y.value;switch(se(ne),ne.type){case"table":{for(var le=R(ne.tokens.header),ge;!(ge=le()).done;){var be=ge.value;We.walkTokens(be,se)}for(var He=R(ne.tokens.cells),$e;!($e=He()).done;)for(var qe=$e.value,Xe=R(qe),Ze;!(Ze=Xe()).done;){var ut=Ze.value;We.walkTokens(ut,se)}break}case"list":{We.walkTokens(ne.items,se);break}default:ne.tokens&&We.walkTokens(ne.tokens,se)}}},We.parseInline=function(K,se){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");se=Ke({},We.defaults,se||{}),G(se);try{var he=te.lexInline(K,se);return se.walkTokens&&We.walkTokens(he,se.walkTokens),Se.parseInline(he,se)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(Y.message+"",!0)+"</pre>";throw Y}},We.Parser=Se,We.parser=Se.parse,We.Renderer=Oe,We.TextRenderer=_e,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=M,We.Slugger=ke,We.parse=We;var et=We;return et}),define(pe[72],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(C,A,D){return Math.min(Math.max(C,A),D)}e.clamp=E;function y(C,A){return(A+C%A)%A}e.rot=y;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class P{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function Z(R){const P=[];typeof R=="number"&&P.push("code/timeOrigin",R);function C(D){P.push(D,Date.now())}function A(){const D=[];for(let n=0;n<P.length;n+=2)D.push({name:P[n],startTime:P[n+1]});return D}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const C of performance.getEntriesByType("mark"))P.push({name:C.name,startTime:Math.round(R+C.startTime)});return P}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function E(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=E(y))})(),define(pe[9],ve([0,1]),function(Z,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const y="en";let R=!1,P=!1,C=!1,A=!1,D=!1,n=!1,T=!1,k,b=y,m,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof process!="undefined"?p=process:typeof e.globals.vscode!="undefined"&&(p=e.globals.vscode.process);const S=typeof((E=p==null?void 0:p.versions)===null||E===void 0?void 0:E.electron)=="string"&&p.type==="renderer";if(e.isElectronSandboxed=S&&(p==null?void 0:p.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=p==null?void 0:p.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)a=navigator.userAgent,R=a.indexOf("Windows")>=0,P=a.indexOf("Macintosh")>=0,T=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=a.indexOf("Linux")>=0,n=!0,k=navigator.language,b=k;else if(typeof p=="object"){R=p.platform==="win32",P=p.platform==="darwin",C=p.platform==="linux",A=C&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,k=y,b=y;const r=p.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),h=l.availableLanguages["*"];k=l.locale,b=h||y,m=l._translationsConfigFile}catch(l){}D=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let c=0;P?c=1:R?c=3:C&&(c=2),e.isWindows=R,e.isMacintosh=P,e.isLinux=C,e.isLinuxSnap=A,e.isNative=D,e.isWeb=n,e.isIOS=T,e.platform=c,e.userAgent=a,e.language=b;var u;(function(r){function l(){return e.language}r.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function g(){return e.language==="en"}r.isDefault=g})(u=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let d=0,f=h.length;d<f;d++){const I=h[d];if(I.id===w.data.vscodeSetImmediateId){h.splice(d,1),I.callback();return}}});let g=0;return w=>{const d=++g;h.push({id:d,callback:w}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof(p==null?void 0:p.nextTick)=="function")return p.nextTick.bind(p);const l=Promise.resolve();return h=>l.then(h)}();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||T?2:R?1:3;let t=!0,i=!1;function o(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(pe[30],ve([0,1,9]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let y;if(typeof process!="undefined")y={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}};else if(typeof E.globals.vscode!="undefined"){const R=E.globals.vscode.process;y={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(P){return(0,E.setImmediate)(P)}}}else y={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(R){return(0,E.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=y.cwd,e.env=y.env,e.platform=y.platform,e.nextTick=y.nextTick}),define(pe[8],ve([0,1,30]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const y=65,R=97,P=90,C=122,A=46,D=47,n=92,T=58,k=63;class b extends Error{constructor(u,s,t){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const o=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${o} ${i} of type ${s}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,u){if(typeof c!="string")throw new b(u,"string",c)}function a(c){return c===D||c===n}function p(c){return c===D}function S(c){return c>=y&&c<=P||c>=R&&c<=C}function v(c,u,s,t){let i="",o=0,r=-1,l=0,h=0;for(let g=0;g<=c.length;++g){if(g<c.length)h=c.charCodeAt(g);else{if(t(h))break;h=D}if(t(h)){if(!(r===g-1||l===1))if(l===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==A||i.charCodeAt(i.length-2)!==A){if(i.length>2){const w=i.lastIndexOf(s);w===-1?(i="",o=0):(i=i.slice(0,w),o=i.length-1-i.lastIndexOf(s)),r=g,l=0;continue}else if(i.length!==0){i="",o=0,r=g,l=0;continue}}u&&(i+=i.length>0?`${s}..`:"..",o=2)}else i.length>0?i+=`${s}${c.slice(r+1,g)}`:i=c.slice(r+1,g),o=g-r-1;r=g,l=0}else h===A&&l!==-1?++l:l=-1}return i}function _(c,u){if(u===null||typeof u!="object")throw new b("pathObject","Object",u);const s=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let u="",s="",t=!1;for(let i=c.length-1;i>=-1;i--){let o;if(i>=0){if(o=c[i],m(o,"path"),o.length===0)continue}else u.length===0?o=E.cwd():(o=E.env[`=${u}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${u}\\`));const r=o.length;let l=0,h="",g=!1;const w=o.charCodeAt(0);if(r===1)a(w)&&(l=1,g=!0);else if(a(w))if(g=!0,a(o.charCodeAt(1))){let d=2,f=d;for(;d<r&&!a(o.charCodeAt(d));)d++;if(d<r&&d!==f){const I=o.slice(f,d);for(f=d;d<r&&a(o.charCodeAt(d));)d++;if(d<r&&d!==f){for(f=d;d<r&&!a(o.charCodeAt(d));)d++;(d===r||d!==f)&&(h=`\\\\${I}\\${o.slice(f,d)}`,l=d)}}}else l=1;else S(w)&&o.charCodeAt(1)===T&&(h=o.slice(0,2),l=2,r>2&&a(o.charCodeAt(2))&&(g=!0,l=3));if(h.length>0)if(u.length>0){if(h.toLowerCase()!==u.toLowerCase())continue}else u=h;if(t){if(u.length>0)break}else if(s=`${o.slice(l)}\\${s}`,t=g,g&&u.length>0)break}return s=v(s,!t,"\\",a),t?`${u}\\${s}`:`${u}${s}`||"."},normalize(c){m(c,"path");const u=c.length;if(u===0)return".";let s=0,t,i=!1;const o=c.charCodeAt(0);if(u===1)return p(o)?"\\":c;if(a(o))if(i=!0,a(c.charCodeAt(1))){let l=2,h=l;for(;l<u&&!a(c.charCodeAt(l));)l++;if(l<u&&l!==h){const g=c.slice(h,l);for(h=l;l<u&&a(c.charCodeAt(l));)l++;if(l<u&&l!==h){for(h=l;l<u&&!a(c.charCodeAt(l));)l++;if(l===u)return`\\\\${g}\\${c.slice(h)}\\`;l!==h&&(t=`\\\\${g}\\${c.slice(h,l)}`,s=l)}}}else s=1;else S(o)&&c.charCodeAt(1)===T&&(t=c.slice(0,2),s=2,u>2&&a(c.charCodeAt(2))&&(i=!0,s=3));let r=s<u?v(c.slice(s),!i,"\\",a):"";return r.length===0&&!i&&(r="."),r.length>0&&a(c.charCodeAt(u-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(c){m(c,"path");const u=c.length;if(u===0)return!1;const s=c.charCodeAt(0);return a(s)||u>2&&S(s)&&c.charCodeAt(1)===T&&a(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let u,s;for(let o=0;o<c.length;++o){const r=c[o];m(r,"path"),r.length>0&&(u===void 0?u=s=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,i=0;if(typeof s=="string"&&a(s.charCodeAt(0))){++i;const o=s.length;o>1&&a(s.charCodeAt(1))&&(++i,o>2&&(a(s.charCodeAt(2))?++i:t=!1))}if(t){for(;i<u.length&&a(u.charCodeAt(i));)i++;i>=2&&(u=`\\${u.slice(i)}`)}return e.win32.normalize(u)},relative(c,u){if(m(c,"from"),m(u,"to"),c===u)return"";const s=e.win32.resolve(c),t=e.win32.resolve(u);if(s===t||(c=s.toLowerCase(),u=t.toLowerCase(),c===u))return"";let i=0;for(;i<c.length&&c.charCodeAt(i)===n;)i++;let o=c.length;for(;o-1>i&&c.charCodeAt(o-1)===n;)o--;const r=o-i;let l=0;for(;l<u.length&&u.charCodeAt(l)===n;)l++;let h=u.length;for(;h-1>l&&u.charCodeAt(h-1)===n;)h--;const g=h-l,w=r<g?r:g;let d=-1,f=0;for(;f<w;f++){const L=c.charCodeAt(i+f);if(L!==u.charCodeAt(l+f))break;L===n&&(d=f)}if(f!==w){if(d===-1)return t}else{if(g>w){if(u.charCodeAt(l+f)===n)return t.slice(l+f+1);if(f===2)return t.slice(l+f)}r>w&&(c.charCodeAt(i+f)===n?d=f:f===2&&(d=3)),d===-1&&(d=0)}let I="";for(f=i+d+1;f<=o;++f)(f===o||c.charCodeAt(f)===n)&&(I+=I.length===0?"..":"\\..");return l+=d,I.length>0?`${I}${t.slice(l,h)}`:(t.charCodeAt(l)===n&&++l,t.slice(l,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const u=e.win32.resolve(c);if(u.length<=2)return c;if(u.charCodeAt(0)===n){if(u.charCodeAt(1)===n){const s=u.charCodeAt(2);if(s!==k&&s!==A)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===T&&u.charCodeAt(2)===n)return`\\\\?\\${u}`;return c},dirname(c){m(c,"path");const u=c.length;if(u===0)return".";let s=-1,t=0;const i=c.charCodeAt(0);if(u===1)return a(i)?c:".";if(a(i)){if(s=t=1,a(c.charCodeAt(1))){let l=2,h=l;for(;l<u&&!a(c.charCodeAt(l));)l++;if(l<u&&l!==h){for(h=l;l<u&&a(c.charCodeAt(l));)l++;if(l<u&&l!==h){for(h=l;l<u&&!a(c.charCodeAt(l));)l++;if(l===u)return c;l!==h&&(s=t=l+1)}}}}else S(i)&&c.charCodeAt(1)===T&&(s=u>2&&a(c.charCodeAt(2))?3:2,t=s);let o=-1,r=!0;for(let l=u-1;l>=t;--l)if(a(c.charCodeAt(l))){if(!r){o=l;break}}else r=!1;if(o===-1){if(s===-1)return".";o=s}return c.slice(0,o)},basename(c,u){u!==void 0&&m(u,"ext"),m(c,"path");let s=0,t=-1,i=!0,o;if(c.length>=2&&S(c.charCodeAt(0))&&c.charCodeAt(1)===T&&(s=2),u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let r=u.length-1,l=-1;for(o=c.length-1;o>=s;--o){const h=c.charCodeAt(o);if(a(h)){if(!i){s=o+1;break}}else l===-1&&(i=!1,l=o+1),r>=0&&(h===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return s===t?t=l:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=s;--o)if(a(c.charCodeAt(o))){if(!i){s=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){m(c,"path");let u=0,s=-1,t=0,i=-1,o=!0,r=0;c.length>=2&&c.charCodeAt(1)===T&&S(c.charCodeAt(0))&&(u=t=2);for(let l=c.length-1;l>=u;--l){const h=c.charCodeAt(l);if(a(h)){if(!o){t=l+1;break}continue}i===-1&&(o=!1,i=l+1),h===A?s===-1?s=l:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||i===-1||r===0||r===1&&s===i-1&&s===t+1?"":c.slice(s,i)},format:_.bind(null,"\\"),parse(c){m(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const s=c.length;let t=0,i=c.charCodeAt(0);if(s===1)return a(i)?(u.root=u.dir=c,u):(u.base=u.name=c,u);if(a(i)){if(t=1,a(c.charCodeAt(1))){let d=2,f=d;for(;d<s&&!a(c.charCodeAt(d));)d++;if(d<s&&d!==f){for(f=d;d<s&&a(c.charCodeAt(d));)d++;if(d<s&&d!==f){for(f=d;d<s&&!a(c.charCodeAt(d));)d++;d===s?t=d:d!==f&&(t=d+1)}}}}else if(S(i)&&c.charCodeAt(1)===T){if(s<=2)return u.root=u.dir=c,u;if(t=2,a(c.charCodeAt(2))){if(s===3)return u.root=u.dir=c,u;t=3}}t>0&&(u.root=c.slice(0,t));let o=-1,r=t,l=-1,h=!0,g=c.length-1,w=0;for(;g>=t;--g){if(i=c.charCodeAt(g),a(i)){if(!h){r=g+1;break}continue}l===-1&&(h=!1,l=g+1),i===A?o===-1?o=g:w!==1&&(w=1):o!==-1&&(w=-1)}return l!==-1&&(o===-1||w===0||w===1&&o===l-1&&o===r+1?u.base=u.name=c.slice(r,l):(u.name=c.slice(r,o),u.base=c.slice(r,l),u.ext=c.slice(o,l))),r>0&&r!==t?u.dir=c.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let u="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const i=t>=0?c[t]:E.cwd();m(i,"path"),i.length!==0&&(u=`${i}/${u}`,s=i.charCodeAt(0)===D)}return u=v(u,!s,"/",p),s?`/${u}`:u.length>0?u:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===D,s=c.charCodeAt(c.length-1)===D;return c=v(c,!u,"/",p),c.length===0?u?"/":s?"./":".":(s&&(c+="/"),u?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===D},join(...c){if(c.length===0)return".";let u;for(let s=0;s<c.length;++s){const t=c[s];m(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(c,u){if(m(c,"from"),m(u,"to"),c===u||(c=e.posix.resolve(c),u=e.posix.resolve(u),c===u))return"";const s=1,t=c.length,i=t-s,o=1,r=u.length-o,l=i<r?i:r;let h=-1,g=0;for(;g<l;g++){const d=c.charCodeAt(s+g);if(d!==u.charCodeAt(o+g))break;d===D&&(h=g)}if(g===l)if(r>l){if(u.charCodeAt(o+g)===D)return u.slice(o+g+1);if(g===0)return u.slice(o+g)}else i>l&&(c.charCodeAt(s+g)===D?h=g:g===0&&(h=0));let w="";for(g=s+h+1;g<=t;++g)(g===t||c.charCodeAt(g)===D)&&(w+=w.length===0?"..":"/..");return`${w}${u.slice(o+h)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===D;let s=-1,t=!0;for(let i=c.length-1;i>=1;--i)if(c.charCodeAt(i)===D){if(!t){s=i;break}}else t=!1;return s===-1?u?"/":".":u&&s===1?"//":c.slice(0,s)},basename(c,u){u!==void 0&&m(u,"ext"),m(c,"path");let s=0,t=-1,i=!0,o;if(u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let r=u.length-1,l=-1;for(o=c.length-1;o>=0;--o){const h=c.charCodeAt(o);if(h===D){if(!i){s=o+1;break}}else l===-1&&(i=!1,l=o+1),r>=0&&(h===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return s===t?t=l:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===D){if(!i){s=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){m(c,"path");let u=-1,s=0,t=-1,i=!0,o=0;for(let r=c.length-1;r>=0;--r){const l=c.charCodeAt(r);if(l===D){if(!i){s=r+1;break}continue}t===-1&&(i=!1,t=r+1),l===A?u===-1?u=r:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===s+1?"":c.slice(u,t)},format:_.bind(null,"/"),parse(c){m(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const s=c.charCodeAt(0)===D;let t;s?(u.root="/",t=1):t=0;let i=-1,o=0,r=-1,l=!0,h=c.length-1,g=0;for(;h>=t;--h){const w=c.charCodeAt(h);if(w===D){if(!l){o=h+1;break}continue}r===-1&&(l=!1,r=h+1),w===A?i===-1?i=h:g!==1&&(g=1):i!==-1&&(g=-1)}if(r!==-1){const w=o===0&&s?1:o;i===-1||g===0||g===1&&i===r-1&&i===o+1?u.base=u.name=c.slice(w,r):(u.name=c.slice(w,i),u.base=c.slice(w,r),u.ext=c.slice(i,r))}return o>0?u.dir=c.slice(0,o-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[134],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var E;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(E=e.Source||(e.Source={}));var y;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(y=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...C){const A=C.reduce((T,k)=>(T[k]=!0,T),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(T=>!A[T]).forEach(T=>{for(let k=0;k<D.length;k++)if(T.search(D[k])!==-1){delete P[T];break}})}e.sanitizeProcessEnvironment=R}),define(pe[46],ve([0,1,9]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const y=E.globals.performance&&typeof E.globals.performance.now=="function";class R{constructor(C){this._highResolution=y&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new R(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=R}),define(pe[3],ve([0,1,16,69,6,55,46]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var A;(function(v){v.None=()=>R.Disposable.None;function _(H){return(x,$=null,F)=>{let U=!1,M;return M=H(N=>{if(!U)return M?M.dispose():U=!0,x.call($,N)},null,F),U&&M.dispose(),M}}v.once=_;function c(H,x){return r(($,F=null,U)=>H(M=>$.call(F,x(M)),null,U))}v.map=c;function u(H,x){return r(($,F=null,U)=>H(M=>{x(M),$.call(F,M)},null,U))}v.forEach=u;function s(H,x){return r(($,F=null,U)=>H(M=>x(M)&&$.call(F,M),null,U))}v.filter=s;function t(H){return H}v.signal=t;function i(...H){return(x,$=null,F)=>(0,R.combinedDisposable)(...H.map(U=>U(M=>x.call($,M),null,F)))}v.any=i;function o(H,x,$){let F=$;return c(H,U=>(F=x(F,U),F))}v.reduce=o;function r(H){let x;const $=new b({onFirstListenerAdd(){x=H($.fire,$)},onLastListenerRemove(){x.dispose()}});return $.event}v.snapshot=r;function l(H,x,$=100,F=!1,U){let M,N,O,V=0;const q=new b({leakWarningThreshold:U,onFirstListenerAdd(){M=H(Q=>{V++,N=x(N,Q),F&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const me=N;N=void 0,O=void 0,(!F||V>1)&&q.fire(me),V=0},$)})},onLastListenerRemove(){M.dispose()}});return q.event}v.debounce=l;function h(H){const x=new Date().getTime();return c(_(H),$=>new Date().getTime()-x)}v.stopwatch=h;function g(H){let x=!0,$;return s(H,F=>{const U=x||F!==$;return x=!1,$=F,U})}v.latch=g;function w(H,x=!1,$=[]){let F=$.slice(),U=H(O=>{F?F.push(O):N.fire(O)});const M=()=>{F&&F.forEach(O=>N.fire(O)),F=null},N=new b({onFirstListenerAdd(){U||(U=H(O=>N.fire(O)))},onFirstListenerDidAdd(){F&&(x?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}v.buffer=w;class d{constructor(x){this.event=x}map(x){return new d(c(this.event,x))}forEach(x){return new d(u(this.event,x))}filter(x){return new d(s(this.event,x))}reduce(x,$){return new d(o(this.event,x,$))}latch(){return new d(g(this.event))}debounce(x,$=100,F=!1,U){return new d(l(this.event,x,$,F,U))}on(x,$,F){return this.event(x,$,F)}once(x,$,F){return _(this.event)(x,$,F)}}function f(H){return new d(H)}v.chain=f;function I(H,x,$=F=>F){const F=(...O)=>N.fire($(...O)),U=()=>H.on(x,F),M=()=>H.removeListener(x,F),N=new b({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromNodeEventEmitter=I;function L(H,x,$=F=>F){const F=(...O)=>N.fire($(...O)),U=()=>H.addEventListener(x,F),M=()=>H.removeEventListener(x,F),N=new b({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromDOMEventEmitter=L;function B(H){const x=new b;let $=!1;return H.then(void 0,()=>null).then(()=>{$?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),$=!0,x.event}v.fromPromise=B;function ee(H){return new Promise(x=>_(H)(x))}v.toPromise=ee})(A=e.Event||(e.Event={}));class D{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${D._idPool++}`}start(_){this._stopWatch=new C.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let n=-1;function T(v){const _=n;return n=v,{dispose(){n=_}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(_,c=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let c=n;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||_<c)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(u)||0;if(this._stacks.set(u,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,i=0;for(const[o,r]of this._stacks)(!t||i<r)&&(t=o,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class b{constructor(_){var c;this._disposed=!1,this._options=_,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(_,c,u)=>{var s;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[_,c]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,c);const o=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let r;return r={dispose:()=>{o&&o(),r.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof R.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(_){var c,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,_]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(i){(0,E.onUnexpectedError)(i)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var _,c,u;(_=this._listeners)===null||_===void 0||_.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class m extends b{constructor(_){super(_);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=m;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const c={event:_,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const u=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,R.toDisposable)((0,y.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(c=>this.emitter.fire(c))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class p{constructor(){this.buffers=[]}wrapEvent(_){return(c,u,s)=>_(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>c.call(u,t)):c.call(u,t)},void 0,s)}bufferEvents(_){const c=[];this.buffers.push(c);const u=_();return this.buffers.pop(),c.forEach(s=>s()),u}}e.EventBufferer=p;class S{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=R.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(pe[21],ve([0,1,3]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const y=Object.freeze(function(A,D){const n=setTimeout(A.bind(D),0);return{dispose(){clearTimeout(n)}}});var R;(function(A){function D(n){return n===A.None||n===A.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}A.isCancellationToken=D,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(R=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?y:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=R.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=C}),define(pe[47],ve([0,1,3]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class y{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new y;e.iconRegistry=R;function P(n,T){return new C(n,T)}e.registerCodicon=P;class C{constructor(T,k,b){this.id=T,this.definition=k,this.description=b,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function A(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=A;var D;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(a){if(a instanceof C)return["codicon","codicon-"+a.id];const p=T.exec(a.id);if(!p)return k(C.error);let[,S,v]=p;const _=["codicon","codicon-"+S];return v&&_.push("codicon-modifier-"+v.substr(1)),_}n.asClassNameArray=k;function b(a){return k(a).join(" ")}n.asClassName=b;function m(a){return"."+k(a).join(".")}n.asCSSSelector=m})(D=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(pe[91],ve([0,1,16,6]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(S){const v=S;return v&&[v.on,v.pause,v.resume,v.destroy].every(_=>typeof _=="function")}e.isReadableStream=R;function P(S){const v=S;return v&&R(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean"}e.isReadableBufferedStream=P;function C(S,v){return new A(S,v)}e.newWriteableStream=C;class A{constructor(v,_){this.reducer=v,this.options=_,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){var _;if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof((_=this.options)===null||_===void 0?void 0:_.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(_=>_(v))}emitError(v){this.listeners.error.length===0?(0,E.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(_=>_(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,_){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(_),this.resume();break;case"end":this.listeners.end.push(_),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(_),this.state.flowing&&this.flowErrors();break}}removeListener(v,_){if(!this.state.destroyed){let c;switch(v){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const u=c.indexOf(_);u>=0&&c.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const _=[...this.pendingWritePromises];this.pendingWritePromises.length=0,_.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(S,v){const _=[];let c;for(;(c=S.read())!==null;)_.push(c);return v(_)}e.consumeReadable=D;function n(S,v,_){const c=[];let u;for(;(u=S.read())!==null&&c.length<_;)c.push(u);return u===null&&c.length>0?v(c):{read:()=>{if(c.length>0)return c.shift();if(typeof u!="undefined"){const s=u;return u=void 0,s}return S.read()}}}e.peekReadable=n;function T(S,v){return new Promise((_,c)=>{const u=[];k(S,{onData:s=>{v&&u.push(s)},onError:s=>{v?c(s):_(void 0)},onEnd:()=>{_(v?v(u):void 0)}})})}e.consumeStream=T;function k(S,v){S.on("error",_=>v.onError(_)),S.on("end",()=>v.onEnd()),S.on("data",_=>v.onData(_))}e.listenStream=k;function b(S,v){return new Promise((_,c)=>{const u=new y.DisposableStore,s=[],t=r=>{if(s.push(r),s.length>v)return u.dispose(),S.pause(),_({stream:S,buffer:s,ended:!1})},i=r=>c(r),o=()=>_({stream:S,buffer:s,ended:!0});u.add((0,y.toDisposable)(()=>S.removeListener("error",i))),S.on("error",i),u.add((0,y.toDisposable)(()=>S.removeListener("end",o))),S.on("end",o),u.add((0,y.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=b;function m(S,v){const _=C(v);return _.end(S),_}e.toStream=m;function a(S){let v=!1;return{read:()=>v?null:(v=!0,S)}}e.toReadable=a;function p(S,v,_){const c=C(_);return k(S,{onData:u=>c.write(v.data(u)),onError:u=>c.error(v.error?v.error(u):u),onEnd:()=>c.end()}),c}e.transform=p}),define(pe[10],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=E;const y=/{(\d+)}/g;function R(K,...se){return se.length===0?K:K.replace(y,function(he,Y){const ne=parseInt(Y,10);return isNaN(ne)||ne<0||ne>=se.length?he:se[ne]})}e.format=R;function P(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function C(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function A(K,se){let he=0;const Y=se.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===Y&&he++;return he}e.count=A;function D(K,se,he="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${he}`}e.truncate=D;function n(K,se=" "){const he=T(K,se);return k(he,se)}e.trim=n;function T(K,se){if(!K||!se)return K;const he=se.length;if(he===0||K.length===0)return K;let Y=0;for(;K.indexOf(se,Y)===Y;)Y=Y+he;return K.substring(Y)}e.ltrim=T;function k(K,se){if(!K||!se)return K;const he=se.length,Y=K.length;if(he===0||Y===0)return K;let ne=Y,le=-1;for(;le=K.lastIndexOf(se,ne-1),!(le===-1||le+he!==ne);){if(le===0)return"";ne=le}return K.substring(0,ne)}e.rtrim=k;function b(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function m(K){return K.replace(/\*/g,"")}e.stripWildcards=m;function a(K,se,he={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=C(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Y="";return he.global&&(Y+="g"),he.matchCase||(Y+="i"),he.multiline&&(Y+="m"),he.unicode&&(Y+="u"),new RegExp(K,Y)}e.createRegExp=a;function p(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=v;function _(K){return K.split(/\r\n|\r|\n/)}e.splitLines=_;function c(K){for(let se=0,he=K.length;se<he;se++){const Y=K.charCodeAt(se);if(Y!==32&&Y!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function u(K,se=0,he=K.length){for(let Y=se;Y<he;Y++){const ne=K.charCodeAt(Y);if(ne!==32&&ne!==9)return K.substring(se,Y)}return K.substring(se,he)}e.getLeadingWhitespace=u;function s(K,se=K.length-1){for(let he=se;he>=0;he--){const Y=K.charCodeAt(he);if(Y!==32&&Y!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function t(K,se){return K<se?-1:K>se?1:0}e.compare=t;function i(K,se,he=0,Y=K.length,ne=0,le=se.length){for(;he<Y&&ne<le;he++,ne++){let He=K.charCodeAt(he),$e=se.charCodeAt(ne);if(He<$e)return-1;if(He>$e)return 1}const ge=Y-he,be=le-ne;return ge<be?-1:ge>be?1:0}e.compareSubstring=i;function o(K,se){return r(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=o;function r(K,se,he=0,Y=K.length,ne=0,le=se.length){for(;he<Y&&ne<le;he++,ne++){let He=K.charCodeAt(he),$e=se.charCodeAt(ne);if(He!==$e){const qe=He-$e;if(!(qe===32&&h($e))&&!(qe===-32&&h(He)))return l(He)&&l($e)?qe:i(K.toLowerCase(),se.toLowerCase(),he,Y,ne,le)}}const ge=Y-he,be=le-ne;return ge<be?-1:ge>be?1:0}e.compareSubstringIgnoreCase=r;function l(K){return K>=97&&K<=122}e.isLowerAsciiLetter=l;function h(K){return K>=65&&K<=90}e.isUpperAsciiLetter=h;function g(K){return l(K)||h(K)}function w(K,se){return K.length===se.length&&d(K,se)}e.equalsIgnoreCase=w;function d(K,se,he=K.length){for(let Y=0;Y<he;Y++){const ne=K.charCodeAt(Y),le=se.charCodeAt(Y);if(ne!==le){if(g(ne)&&g(le)){const ge=Math.abs(ne-le);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function f(K,se){const he=se.length;return se.length>K.length?!1:d(K,se,he)}e.startsWithIgnoreCase=f;function I(K,se){let he,Y=Math.min(K.length,se.length);for(he=0;he<Y;he++)if(K.charCodeAt(he)!==se.charCodeAt(he))return he;return Y}e.commonPrefixLength=I;function L(K,se){let he,Y=Math.min(K.length,se.length);const ne=K.length-1,le=se.length-1;for(he=0;he<Y;he++)if(K.charCodeAt(ne-he)!==se.charCodeAt(le-he))return he;return Y}e.commonSuffixLength=L;function B(K){return 55296<=K&&K<=56319}e.isHighSurrogate=B;function ee(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ee;function H(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=H;function x(K,se,he){const Y=K.charCodeAt(he);if(B(Y)&&he+1<se){const ne=K.charCodeAt(he+1);if(ee(ne))return H(Y,ne)}return Y}e.getNextCodePoint=x;function $(K,se){const he=K.charCodeAt(se-1);if(ee(he)&&se>1){const Y=K.charCodeAt(se-2);if(B(Y))return H(Y,he)}return he}function F(K,se){const he=We.getInstance(),Y=se,ne=K.length,le=x(K,ne,se);se+=le>=65536?2:1;let ge=he.getGraphemeBreakType(le);for(;se<ne;){const be=x(K,ne,se),He=he.getGraphemeBreakType(be);if(Ne(ge,He))break;se+=be>=65536?2:1,ge=He}return se-Y}e.nextCharLength=F;function U(K,se){const he=We.getInstance(),Y=se,ne=$(K,se);se-=ne>=65536?2:1;let le=he.getGraphemeBreakType(ne);for(;se>0;){const ge=$(K,se),be=he.getGraphemeBreakType(ge);if(Ne(be,le))break;se-=ge>=65536?2:1,le=be}return Y-se}e.prevCharLength=U;function M(K,se){const he=We.getInstance(),Y=K.length,ne=se,le=x(K,Y,se),ge=he.getGraphemeBreakType(le);se+=le>=65536?2:1;let be=ge;for(;se<Y;){const $e=x(K,Y,se),qe=he.getGraphemeBreakType($e);if(Ne(be,qe))break;se+=$e>=65536?2:1,be=qe}const He=se;for(se=ne,be=ge;se>0;){const $e=$(K,se),qe=he.getGraphemeBreakType($e);if(Ne(qe,be))break;se-=$e>=65536?2:1,be=qe}return[se,He]}function N(K,se){return se>0&&ee(K.charCodeAt(se))?M(K,se-1):M(K,se)}e.getCharContainingOffset=N;function O(K){const se=K.length;let he=0,Y=0;for(;Y<se;){const ge=x(K,se,Y);Y+=ge>=65536?2:1,ge<128?he+=1:ge<2048?he+=2:ge<65536?he+=3:he+=4}const ne=new Uint8Array(he);Y=0;let le=0;for(;Y<se;){const ge=x(K,se,Y);Y+=ge>=65536?2:1,ge<128?ne[le++]=ge:ge<2048?(ne[le++]=192|(ge&1984)>>>6,ne[le++]=128|(ge&63)>>>0):ge<65536?(ne[le++]=224|(ge&61440)>>>12,ne[le++]=128|(ge&4032)>>>6,ne[le++]=128|(ge&63)>>>0):(ne[le++]=240|(ge&1835008)>>>18,ne[le++]=128|(ge&258048)>>>12,ne[le++]=128|(ge&4032)>>>6,ne[le++]=128|(ge&63)>>>0)}return ne}e.encodeUTF8=O;function V(K){const se=K.byteLength,he=[];let Y=0;for(;Y<se;){const ne=K[Y];let le;if(ne>=240&&Y+3<se?le=(K[Y++]&7)<<18>>>0|(K[Y++]&63)<<12>>>0|(K[Y++]&63)<<6>>>0|(K[Y++]&63)<<0>>>0:ne>=224&&Y+2<se?le=(K[Y++]&15)<<12>>>0|(K[Y++]&63)<<6>>>0|(K[Y++]&63)<<0>>>0:ne>=192&&Y+1<se?le=(K[Y++]&31)<<6>>>0|(K[Y++]&63)<<0>>>0:le=K[Y++],le>=0&&le<=55295||le>=57344&&le<=65535)he.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const ge=le-65536,be=55296+((ge&1047552)>>>10),He=56320+((ge&1023)>>>0);he.push(String.fromCharCode(be)),he.push(String.fromCharCode(He))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(K){return me.test(K)}e.containsEmoji=we;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ie(K){return Ae.test(K)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Me;function z(K){for(let se=0,he=K.length;se<he;se++)if(J(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=z;function J(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=J;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=te;function ae(K,se){if(K.length<se)return K;const he=/\b/g;let Y=0;for(;he.test(K)&&!(K.length-he.lastIndex<se);)Y=he.lastIndex,he.lastIndex+=1;return K.substring(Y).replace(/^\s/,"")}e.lcut=ae;const fe=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function _e(K){return K&&(K=K.replace(fe,""),K=K.replace(De,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Te(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Te;function xe(K,se){if(!K||!se||K.length<se.length)return!1;const he=se.length,Y=K.toLowerCase();let ne=0,le=-1;for(;ne<he;){const ge=Y.indexOf(se[ne],le+1);if(ge<0)return!1;le=ge,ne++}return!0}e.fuzzyContains=xe;function Se(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function G(K,se=1){if(se===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),se--;while(se>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=G;function ie(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ie;function Ee(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ee;function Ne(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=et()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const he=this._data,Y=he.length/3;let ne=1;for(;ne<=Y;)if(se<he[3*ne])ne=2*ne;else if(se>he[3*ne+1])ne=2*ne+1;else return he[3*ne+2];return 0}}We._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(pe[25],ve([0,1,10,91]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let A,D;class n{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return R?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,h){return!((h==null?void 0:h.dontUseNodeBuffer)||!1)&&R?new n(Buffer.from(l)):P?(A||(A=new TextEncoder),new n(A.encode(l))):new n(E.encodeUTF8(l))}static concat(l,h){if(typeof h=="undefined"){h=0;for(let d=0,f=l.length;d<f;d++)h+=l[d].byteLength}const g=n.alloc(h);let w=0;for(let d=0,f=l.length;d<f;d++){const I=l[d];g.set(I,w),w+=I.byteLength}return g}toString(){return R?this.buffer.toString():C?(D||(D=new TextDecoder),D.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(l,h){return new n(this.buffer.subarray(l,h))}set(l,h){l instanceof n?this.buffer.set(l.buffer,h):this.buffer.set(l,h)}readUInt32BE(l){return b(this.buffer,l)}writeUInt32BE(l,h){m(this.buffer,l,h)}readUInt32LE(l){return a(this.buffer,l)}writeUInt32LE(l,h){p(this.buffer,l,h)}readUInt8(l){return S(this.buffer,l)}writeUInt8(l,h){v(this.buffer,l,h)}}e.VSBuffer=n;function T(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0}e.readUInt16LE=T;function k(r,l,h){r[h+0]=l&255,l=l>>>8,r[h+1]=l&255}e.writeUInt16LE=k;function b(r,l){return r[l]*2**24+r[l+1]*2**16+r[l+2]*2**8+r[l+3]}e.readUInt32BE=b;function m(r,l,h){r[h+3]=l,l=l>>>8,r[h+2]=l,l=l>>>8,r[h+1]=l,l=l>>>8,r[h]=l}e.writeUInt32BE=m;function a(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0|r[l+2]<<16>>>0|r[l+3]<<24>>>0}e.readUInt32LE=a;function p(r,l,h){r[h+0]=l&255,l=l>>>8,r[h+1]=l&255,l=l>>>8,r[h+2]=l&255,l=l>>>8,r[h+3]=l&255}e.writeUInt32LE=p;function S(r,l){return r[l]}e.readUInt8=S;function v(r,l,h){r[h]=l}e.writeUInt8=v;function _(r){return y.consumeReadable(r,l=>n.concat(l))}e.readableToBuffer=_;function c(r){return y.toReadable(r)}e.bufferToReadable=c;function u(r){return y.consumeStream(r,l=>n.concat(l))}e.streamToBuffer=u;async function s(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=s;function t(r){return y.toStream(r,l=>n.concat(l))}e.bufferToStream=t;function i(r){return y.transform(r,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=i;function o(r){return y.newWriteableStream(l=>n.concat(l),r)}e.newWriteableBufferStream=o}),define(pe[73],ve([0,1,10]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function y(v){return R(v,0)}e.hash=y;function R(v,_){switch(typeof v){case"object":return v===null?P(349,_):Array.isArray(v)?D(v,_):n(v,_);case"string":return A(v,_);case"boolean":return C(v,_);case"number":return P(v,_);case"undefined":return P(937,_);default:return P(617,_)}}e.doHash=R;function P(v,_){return(_<<5)-_+v|0}function C(v,_){return P(v?433:863,_)}function A(v,_){_=P(149417,_);for(let c=0,u=v.length;c<u;c++)_=P(v.charCodeAt(c),_);return _}e.stringHash=A;function D(v,_){return _=P(104579,_),v.reduce((c,u)=>R(u,c),_)}function n(v,_){return _=P(181387,_),Object.keys(v).sort().reduce((c,u)=>(c=A(u,c),R(v[u],c)),_)}class T{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=R(_,this._value),this._value}}e.Hasher=T;var k;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(v,_,c=32){const u=c-_,s=~((1<<u)-1);return(v<<_|(s&v)>>>u)>>>0}function m(v,_=0,c=v.byteLength,u=0){for(let s=0;s<c;s++)v[_+s]=u}function a(v,_,c="0"){for(;v.length<_;)v=c+v;return v}function p(v,_=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):a((v>>>0).toString(16),_/4)}e.toHexString=p;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const c=_.length;if(c!==0){const u=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,i,o;for(t!==0?(i=t,o=-1,t=0):(i=_.charCodeAt(0),o=0);;){let r=i;if(E.isHighSurrogate(i))if(o+1<c){const l=_.charCodeAt(o+1);E.isLowSurrogate(l)?(o++,r=E.computeCodePoint(i,l)):r=65533}else{t=i;break}else E.isLowSurrogate(i)&&(r=65533);if(s=this._push(u,s,r),o++,o<c)i=_.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(_,c,u){return u<128?_[c++]=u:u<2048?(_[c++]=192|(u&1984)>>>6,_[c++]=128|(u&63)>>>0):u<65536?(_[c++]=224|(u&61440)>>>12,_[c++]=128|(u&4032)>>>6,_[c++]=128|(u&63)>>>0):(_[c++]=240|(u&1835008)>>>18,_[c++]=128|(u&258048)>>>12,_[c++]=128|(u&4032)>>>6,_[c++]=128|(u&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=S._bigBlock32,c=this._buffDV;for(let g=0;g<64;g+=4)_.setUint32(g,c.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)_.setUint32(g,b(_.getUint32(g-12,!1)^_.getUint32(g-32,!1)^_.getUint32(g-56,!1)^_.getUint32(g-64,!1),1),!1);let u=this._h0,s=this._h1,t=this._h2,i=this._h3,o=this._h4,r,l,h;for(let g=0;g<80;g++)g<20?(r=s&t|~s&i,l=1518500249):g<40?(r=s^t^i,l=1859775393):g<60?(r=s&t|s&i|t&i,l=2400959708):(r=s^t^i,l=3395469782),h=b(u,5)+r+o+l+_.getUint32(g*4,!1)&4294967295,o=i,i=t,t=b(s,30),s=u,u=h;this._h0=this._h0+u&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[56],ve([0,1,10]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(y||(y={})),function(R){const P="error",C="warning",A="warn",D="info";function n(T){return T?E.equalsIgnoreCase(P,T)?R.Error:E.equalsIgnoreCase(C,T)||E.equalsIgnoreCase(A,T)?R.Warning:E.equalsIgnoreCase(D,T)?R.Info:R.Ignore:R.Ignore}R.fromValue=n}(y||(y={})),e.default=y}),define(pe[15],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(h){return Array.isArray(h)}e.isArray=E;function y(h){return typeof h=="string"}e.isString=y;function R(h){return Array.isArray(h)&&h.every(g=>y(g))}e.isStringArray=R;function P(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=P;function C(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=C;function A(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=A;function D(h){return h===!0||h===!1}e.isBoolean=D;function n(h){return typeof h=="undefined"}e.isUndefined=n;function T(h){return!k(h)}e.isDefined=T;function k(h){return n(h)||h===null}e.isUndefinedOrNull=k;function b(h,g){if(!h)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=b;function m(h){if(k(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=m;function a(...h){const g=[];for(let w=0;w<h.length;w++){const d=h[w];if(k(d))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);g.push(d)}return g}e.assertAllDefined=a;const p=Object.prototype.hasOwnProperty;function S(h){if(!P(h))return!1;for(let g in h)if(p.call(h,g))return!1;return!0}e.isEmptyObject=S;function v(h){return typeof h=="function"}e.isFunction=v;function _(...h){return h.length>0&&h.every(v)}e.areFunctions=_;function c(h,g){const w=Math.min(h.length,g.length);for(let d=0;d<w;d++)u(h[d],g[d])}e.validateConstraints=c;function u(h,g){if(y(g)){if(typeof h!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(v(g)){try{if(h instanceof g)return}catch(w){}if(!k(h)&&h.constructor===g||g.length===1&&g.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function s(h){let g=[],w=Object.getPrototypeOf(h);for(;Object.prototype!==w;)g=g.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return g}e.getAllPropertyNames=s;function t(h){const g=[];for(const w of s(h))typeof h[w]=="function"&&g.push(w);return g}e.getAllMethodNames=t;function i(h,g){const w=f=>function(){const I=Array.prototype.slice.call(arguments,0);return g(f,I)};let d={};for(const f of h)d[f]=w(f);return d}e.createProxyObject=i;function o(h){return h===null?void 0:h}e.withNullAsUndefined=o;function r(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=r;function l(h){return class{constructor(){return new Proxy({},{get(g,w){if(g[w])return g[w];throw new Error(`Not Implemented: ${h}->${String(w)}`)}})}}}e.NotImplementedProxy=l}),define(pe[31],ve([0,1,9,10,8,15]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function C(i){return i===47||i===92}e.isPathSeparator=C;function A(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=A;function D(i,o=R.posix.sep){if(!i)return"";const r=i.length,l=i.charCodeAt(0);if(C(l)){if(C(i.charCodeAt(1))&&!C(i.charCodeAt(2))){let g=3;const w=g;for(;g<r&&!C(i.charCodeAt(g));g++);if(w!==g&&!C(i.charCodeAt(g+1))){for(g+=1;g<r;g++)if(C(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(S(l)&&i.charCodeAt(1)===58)return C(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let h=i.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(C(i.charCodeAt(h)))return i.slice(0,h+1)}return""}e.getRoot=D;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let r=2;const l=r;for(;r<i.length&&(o=i.charCodeAt(r),o!==92);r++);return!(l===r||(o=i.charCodeAt(r+1),isNaN(o)||o===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,o=E.isWindows){const r=o?T:k;return!(!i||i.length===0||/^\s+$/.test(i)||(r.lastIndex=0,r.test(i))||o&&b.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function a(i,o,r){const l=i===o;return!r||l?l:!i||!o?!1:(0,y.equalsIgnoreCase)(i,o)}e.isEqual=a;function p(i,o,r,l=R.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(r){if(!(0,y.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let g=o.length;return o.charAt(o.length-1)===l&&g--,i.charAt(g)===l}return o.charAt(o.length-1)!==l&&(o+=l),i.indexOf(o)===0}e.isEqualOrParent=p;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function v(i,o){return E.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(o,i)),i=(0,R.normalize)(i),E.isWindows?(i=(0,y.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,y.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=v;function _(i){const o=(0,R.normalize)(i);return E.isWindows?i.length>3?!1:c(o)&&(i.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=_;function c(i){return E.isWindows?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(i){return c(i)?i[0]:void 0}e.getDriveLetter=u;function s(i,o,r){return o.length>i.length?-1:i===o?0:(r&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=s;function t(i){const o=i.split(":");let r,l,h;if(o.forEach(g=>{const w=Number(g);(0,P.isNumber)(w)?l===void 0?l=w:h===void 0&&(h=w):r=r?[r,g].join(":"):g}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(pe[22],ve([0,1,15]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function y(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const p=Array.isArray(a)?[]:{};return Object.keys(a).forEach(S=>{a[S]&&typeof a[S]=="object"?p[S]=y(a[S]):p[S]=a[S]}),p}e.deepClone=y;function R(a){if(!a||typeof a!="object")return a;const p=[a];for(;p.length>0;){const S=p.shift();Object.freeze(S);for(const v in S)if(P.call(S,v)){const _=S[v];typeof _=="object"&&!Object.isFrozen(_)&&p.push(_)}}return a}e.deepFreeze=R;const P=Object.prototype.hasOwnProperty;function C(a,p){return A(a,p,new Set)}e.cloneAndChange=C;function A(a,p,S){if((0,E.isUndefinedOrNull)(a))return a;const v=p(a);if(typeof v!="undefined")return v;if((0,E.isArray)(a)){const _=[];for(const c of a)_.push(A(c,p,S));return _}if((0,E.isObject)(a)){if(S.has(a))throw new Error("Cannot clone recursive data-structure");S.add(a);const _={};for(let c in a)P.call(a,c)&&(_[c]=A(a[c],p,S));return S.delete(a),_}return a}function D(a,p,S=!0){return(0,E.isObject)(a)?((0,E.isObject)(p)&&Object.keys(p).forEach(v=>{v in a?S&&((0,E.isObject)(a[v])&&(0,E.isObject)(p[v])?D(a[v],p[v],S):a[v]=p[v]):a[v]=p[v]}),a):p}e.mixin=D;function n(a,p){if(a===p)return!0;if(a==null||p===null||p===void 0||typeof a!=typeof p||typeof a!="object"||Array.isArray(a)!==Array.isArray(p))return!1;let S,v;if(Array.isArray(a)){if(a.length!==p.length)return!1;for(S=0;S<a.length;S++)if(!n(a[S],p[S]))return!1}else{const _=[];for(v in a)_.push(v);_.sort();const c=[];for(v in p)c.push(v);if(c.sort(),!n(_,c))return!1;for(S=0;S<_.length;S++)if(!n(a[_[S]],p[_[S]]))return!1}return!0}e.equals=n;function T(a){const p=new Set;return JSON.stringify(a,(S,v)=>{if((0,E.isObject)(v)||Array.isArray(v)){if(p.has(v))return"[Circular]";p.add(v)}return v})}e.safeStringify=T;function k(a,p,S){const v=p(a);return typeof v=="undefined"?S:v}e.getOrDefault=k;function b(a,p){const S=Object.create(null);return!a||!p||Object.keys(p).forEach(_=>{const c=a[_],u=p[_];n(c,u)||(S[_]=u)}),S}e.distinct=b;function m(a,p){const S=p.toLowerCase(),v=Object.keys(a).find(_=>_.toLowerCase()===S);return v?a[v]:a[p]}e.getCaseInsensitive=m}),define(pe[92],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function y(P){return P<0?0:P>255?255:P|0}e.toUint8=y;function R(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=R}),define(pe[2],ve([0,1,9,8]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,P=/^\//,C=/^\/\//;function A(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!R.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,r){return!o&&!r?"file":o}function n(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==k&&(r=k+r):r=k;break}return r}const T="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(r,l,h,g,w,d=!1){typeof r=="object"?(this.scheme=r.scheme||T,this.authority=r.authority||T,this.path=r.path||T,this.query=r.query||T,this.fragment=r.fragment||T):(this.scheme=D(r,d),this.authority=l||T,this.path=n(this.scheme,h||T),this.query=g||T,this.fragment=w||T,A(this,d))}static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:h,path:g,query:w,fragment:d}=r;return l===void 0?l=this.scheme:l===null&&(l=T),h===void 0?h=this.authority:h===null&&(h=T),g===void 0?g=this.path:g===null&&(g=T),w===void 0?w=this.query:w===null&&(w=T),d===void 0?d=this.fragment:d===null&&(d=T),l===this.scheme&&h===this.authority&&g===this.path&&w===this.query&&d===this.fragment?this:new p(l,h,g,w,d)}static parse(r,l=!1){const h=b.exec(r);return h?new p(h[2]||T,i(h[4]||T),i(h[5]||T),i(h[7]||T),i(h[9]||T),l):new p(T,T,T,T,T)}static file(r){let l=T;if(E.isWindows&&(r=r.replace(/\\/g,k)),r[0]===k&&r[1]===k){const h=r.indexOf(k,2);h===-1?(l=r.substring(2),r=k):(l=r.substring(2,h),r=r.substring(h)||k)}return new p("file",l,r,T,T)}static from(r){return new p(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return E.isWindows&&r.scheme==="file"?h=m.file(y.win32.join(c(r,!0),...l)).path:h=y.posix.join(r.path,...l),r.with({path:h})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const l=new p(r);return l._formatted=r.external,l._fsPath=r._sep===a?r.fsPath:null,l}}else return r}}e.URI=m;const a=E.isWindows?1:void 0;class p extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(o,r){let l,h=-1;for(let g=0;g<o.length;g++){const w=o.charCodeAt(g);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||r&&w===47)h!==-1&&(l+=encodeURIComponent(o.substring(h,g)),h=-1),l!==void 0&&(l+=o.charAt(g));else{l===void 0&&(l=o.substr(0,g));const d=S[w];d!==void 0?(h!==-1&&(l+=encodeURIComponent(o.substring(h,g)),h=-1),l+=d):h===-1&&(h=g)}}return h!==-1&&(l+=encodeURIComponent(o.substring(h))),l!==void 0?l:o}function _(o){let r;for(let l=0;l<o.length;l++){const h=o.charCodeAt(l);h===35||h===63?(r===void 0&&(r=o.substr(0,l)),r+=S[h]):r!==void 0&&(r+=o[l])}return r!==void 0?r:o}function c(o,r){let l;return o.authority&&o.path.length>1&&o.scheme==="file"?l=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?l=o.path.substr(1):l=o.path[1].toLowerCase()+o.path.substr(2):l=o.path,E.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function u(o,r){const l=r?_:v;let h="",{scheme:g,authority:w,path:d,query:f,fragment:I}=o;if(g&&(h+=g,h+=":"),(w||g==="file")&&(h+=k,h+=k),w){let L=w.indexOf("@");if(L!==-1){const B=w.substr(0,L);w=w.substr(L+1),L=B.indexOf(":"),L===-1?h+=l(B,!1):(h+=l(B.substr(0,L),!1),h+=":",h+=l(B.substr(L+1),!1)),h+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?h+=l(w,!1):(h+=l(w.substr(0,L),!1),h+=w.substr(L))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const L=d.charCodeAt(1);L>=65&&L<=90&&(d=`/${String.fromCharCode(L+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const L=d.charCodeAt(0);L>=65&&L<=90&&(d=`${String.fromCharCode(L+32)}:${d.substr(2)}`)}h+=l(d,!0)}return f&&(h+="?",h+=l(f,!1)),I&&(h+="#",h+=r?I:v(I,!1)),h}function s(o){try{return decodeURIComponent(o)}catch(r){return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(o){return o.match(t)?o.replace(t,r=>s(r)):o}}),define(pe[23],ve([0,1,2,10]),function(Z,e,E,y){"use strict";var R,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(u,s,t){let i=u.get(s);return i===void 0&&(i=t,u.set(s,i)),i}e.getOrSet=C;function A(u){const s=[];return u.forEach((t,i)=>{s.push(`${i} => ${t}`)}),`Map(${u.size}) {${s.join(", ")}}`}e.mapToString=A;function D(u){const s=[];return u.forEach(t=>{s.push(t)}),`Set(${u.size}) {${s.join(", ")}}`}e.setToString=D;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,y.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,y.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var b;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,y.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,y.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,y.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,y.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(s){this._iter=s}static forUris(s=()=>!1){return new p(new m(s))}static forPaths(){return new p(new k)}static forStrings(){return new p(new n)}static forConfigKeys(){return new p(new T)}clear(){this._root=void 0}set(s,t){const i=this._iter.reset(s);let o;for(this._root||(this._root=new a,this._root.segment=i.value()),o=this._root;;){const l=i.cmp(o.segment);if(l>0)o.left||(o.left=new a,o.left.segment=i.value()),o=o.left;else if(l<0)o.right||(o.right=new a,o.right.segment=i.value()),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new a,o.mid.segment=i.value()),o=o.mid;else break}const r=o.value;return o.value=t,o.key=s,r}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const i=this._iter.reset(s),o=[];let r=this._root;for(;r;){const l=i.cmp(r.segment);if(l>0)o.push([1,r]),r=r.left;else if(l<0)o.push([-1,r]),r=r.right;else if(i.hasNext())i.next(),o.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;o.length>0&&r.isEmpty();){let[h,g]=o.pop();switch(h){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}r=g}break}}}findSubstr(s){const t=this._iter.reset(s);let i=this._root,o;for(;i;){const r=t.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(t.hasNext())t.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(s){const t=this._iter.reset(s);let i=this._root;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(s){for(const[t,i]of this)s(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=p;class S{constructor(s,t){this[R]="ResourceMap",s instanceof S?(this.map=new Map(s.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:S.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[i,o]of this.map)s(o,E.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield E.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[E.URI.parse(s[0]),s[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[E.URI.parse(s[0]),s[1]]}}e.ResourceMap=S,S.defaultToKey=u=>u.toString();var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class _{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const i=this._map.get(s);if(!!i)return t!==0&&this.touch(i,t),i.value}set(s,t,i=0){let o=this._map.get(s);if(o)o.value=t,i!==0&&this.touch(o,i);else{switch(o={key:s,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(s,o),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const i=this._state;let o=this._head;for(;o;){if(t?s.bind(t)(o.value,o.key,this):s(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const s=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.key,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}values(){const s=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.value,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}entries(){const s=this,t=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:[i.key,i.value],done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>s;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,i=s.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const i=s.next,o=s.previous;s===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const i=s.next,o=s.previous;s===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,i)=>{s.push([i,t])}),s}fromJSON(s){this.clear();for(const[t,i]of s)this.set(t,i)}}e.LinkedMap=_;class c extends _{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(pe[93],ve([0,1,23,10]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(..._e){return function(ke,Te){for(let xe=0,Se=_e.length;xe<Se;xe++){const Ke=_e[xe](ke,Te);if(Ke)return Ke}return null}}e.or=R,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(_e,ke,Te){if(!Te||Te.length<ke.length)return null;let xe;return _e?xe=y.startsWithIgnoreCase(Te,ke):xe=Te.indexOf(ke)===0,xe?ke.length>0?[{start:0,end:ke.length}]:[]:null}function C(_e,ke){const Te=ke.toLowerCase().indexOf(_e.toLowerCase());return Te===-1?null:[{start:Te,end:Te+_e.length}]}e.matchesContiguousSubString=C;function A(_e,ke){return D(_e.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=A;function D(_e,ke,Te,xe){if(Te===_e.length)return[];if(xe===ke.length)return null;if(_e[Te]===ke[xe]){let Se=null;return(Se=D(_e,ke,Te+1,xe+1))?v({start:xe,end:xe+1},Se):null}return D(_e,ke,Te,xe+1)}function n(_e){return 97<=_e&&_e<=122}function T(_e){return 65<=_e&&_e<=90}e.isUpper=T;function k(_e){return 48<=_e&&_e<=57}function b(_e){return _e===32||_e===9||_e===10||_e===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(_e=>m.add(_e.charCodeAt(0)));function a(_e){return b(_e)||m.has(_e)}function p(_e,ke){return _e===ke||a(_e)&&a(ke)}function S(_e){return n(_e)||T(_e)||k(_e)}function v(_e,ke){return ke.length===0?ke=[_e]:_e.end===ke[0].start?ke[0].start=_e.start:ke.unshift(_e),ke}function _(_e,ke){for(let Te=ke;Te<_e.length;Te++){const xe=_e.charCodeAt(Te);if(T(xe)||k(xe)||Te>0&&!S(_e.charCodeAt(Te-1)))return Te}return _e.length}function c(_e,ke,Te,xe){if(Te===_e.length)return[];if(xe===ke.length)return null;if(_e[Te]!==ke[xe].toLowerCase())return null;{let Se=null,Ke=xe+1;for(Se=c(_e,ke,Te+1,xe+1);!Se&&(Ke=_(ke,Ke))<ke.length;)Se=c(_e,ke,Te+1,Ke),Ke++;return Se===null?null:v({start:xe,end:xe+1},Se)}}function u(_e){let ke=0,Te=0,xe=0,Se=0,Ke=0;for(let ze=0;ze<_e.length;ze++)Ke=_e.charCodeAt(ze),T(Ke)&&ke++,n(Ke)&&Te++,S(Ke)&&xe++,k(Ke)&&Se++;const G=ke/_e.length,ie=Te/_e.length,Ee=xe/_e.length,Ne=Se/_e.length;return{upperPercent:G,lowerPercent:ie,alphaPercent:Ee,numericPercent:Ne}}function s(_e){const{upperPercent:ke,lowerPercent:Te}=_e;return Te===0&&ke>.6}function t(_e){const{upperPercent:ke,lowerPercent:Te,alphaPercent:xe,numericPercent:Se}=_e;return Te>.2&&ke<.8&&xe>.6&&Se<.2}function i(_e){let ke=0,Te=0,xe=0,Se=0;for(let Ke=0;Ke<_e.length;Ke++)xe=_e.charCodeAt(Ke),T(xe)&&ke++,n(xe)&&Te++,b(xe)&&Se++;return(ke===0||Te===0)&&Se===0?_e.length<=30:ke<=5}function o(_e,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!i(_e)||ke.length>60)return null;const Te=u(ke);if(!t(Te)){if(!s(Te))return null;ke=ke.toLowerCase()}let xe=null,Se=0;for(_e=_e.toLowerCase();Se<ke.length&&(xe=c(_e,ke,0,Se))===null;)Se=_(ke,Se+1);return xe}e.matchesCamelCase=o;function r(_e,ke,Te=!1){if(!ke||ke.length===0)return null;let xe=null,Se=0;for(_e=_e.toLowerCase(),ke=ke.toLowerCase();Se<ke.length&&(xe=l(_e,ke,0,Se,Te))===null;)Se=h(ke,Se+1);return xe}e.matchesWords=r;function l(_e,ke,Te,xe,Se){if(Te===_e.length)return[];if(xe===ke.length)return null;if(p(_e.charCodeAt(Te),ke.charCodeAt(xe))){let Ke=null,G=xe+1;if(Ke=l(_e,ke,Te+1,xe+1,Se),!Se)for(;!Ke&&(G=h(ke,G))<ke.length;)Ke=l(_e,ke,Te+1,G,Se),G++;return Ke===null?null:v({start:xe,end:xe+1},Ke)}else return null}function h(_e,ke){for(let Te=ke;Te<_e.length;Te++)if(a(_e.charCodeAt(Te))||Te>0&&a(_e.charCodeAt(Te-1)))return Te;return _e.length}const g=R(e.matchesPrefix,o,C),w=R(e.matchesPrefix,o,A),d=new E.LRUCache(1e4);function f(_e,ke,Te=!1){if(typeof _e!="string"||typeof ke!="string")return null;let xe=d.get(_e);xe||(xe=new RegExp(y.convertSimple2RegExpPattern(_e),"i"),d.set(_e,xe));const Se=xe.exec(ke);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Te?w(_e,ke):g(_e,ke)}e.matchesFuzzy=f;function I(_e,ke){const Te=z(_e,_e.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Te?B(Te):null}e.matchesFuzzy2=I;function L(_e,ke,Te,xe,Se,Ke){const G=Math.min(13,_e.length);for(;Te<G;Te++){const ie=z(_e,ke,Te,xe,Se,Ke,!1);if(ie)return ie}return[0,Ke]}e.anyScore=L;function B(_e){if(typeof _e=="undefined")return[];const ke=[],Te=_e[1];for(let xe=_e.length-1;xe>1;xe--){const Se=_e[xe]+Te,Ke=ke[ke.length-1];Ke&&Ke.end===Se?Ke.end=Se+1:ke.push({start:Se,end:Se+1})}return ke}e.createMatches=B;const ee=128;function H(){const _e=[],ke=[];for(let Te=0;Te<=ee;Te++)ke[Te]=0;for(let Te=0;Te<=ee;Te++)_e.push(ke.slice(0));return _e}function x(_e){const ke=[];for(let Te=0;Te<=_e;Te++)ke[Te]=0;return ke}const $=x(2*ee),F=x(2*ee),U=H(),M=H(),N=H(),O=!1;function V(_e,ke,Te,xe,Se){function Ke(ie,Ee,Ne=" "){for(;ie.length<Ee;)ie=Ne+ie;return ie}let G=` |   |${xe.split("").map(ie=>Ke(ie,3)).join("|")}
`;for(let ie=0;ie<=Te;ie++)ie===0?G+=" |":G+=`${ke[ie-1]}|`,G+=_e[ie].slice(0,Se+1).map(Ee=>Ke(Ee.toString(),3)).join("|")+`
`;return G}function q(_e,ke,Te,xe){_e=_e.substr(ke),Te=Te.substr(xe),console.log(V(M,_e,_e.length,Te,Te.length)),console.log(V(N,_e,_e.length,Te,Te.length)),console.log(V(U,_e,_e.length,Te,Te.length))}function Q(_e,ke){if(ke<0||ke>=_e.length)return!1;const Te=_e.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(Te)}}function me(_e,ke){if(ke<0||ke>=_e.length)return!1;switch(_e.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function we(_e,ke,Te){return ke[_e]!==Te[_e]}function Ae(_e,ke,Te,xe,Se,Ke,G=!1){for(;ke<Te&&Se<Ke;)_e[ke]===xe[Se]&&(G&&($[ke]=Se),ke+=1),Se+=1;return ke===Te}e.isPatternInWord=Ae;var Ie;(function(_e){_e[_e.Diag=1]="Diag",_e[_e.Left=2]="Left",_e[_e.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(_e){_e.Default=[-100,0];function ke(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}_e.isDefault=ke})(Me=e.FuzzyScore||(e.FuzzyScore={}));function z(_e,ke,Te,xe,Se,Ke,G){const ie=_e.length>ee?ee:_e.length,Ee=xe.length>ee?ee:xe.length;if(!(Te>=ie||Ke>=Ee||ie-Te>Ee-Ke)&&!!Ae(ke,Te,ie,Se,Ke,Ee,!0)){J(ie,Ee,Te,Ke,ke,Se);let Ne=1,ze=1,We=Te,et=Ke;const K=[!1];for(Ne=1,We=Te;We<ie;Ne++,We++){const le=$[We],ge=F[We],be=We+1<ie?F[We+1]:Ee;for(ze=le-Ke+1,et=le;et<be;ze++,et++){let He=Number.MIN_SAFE_INTEGER,$e=!1;et<=ge&&(He=te(_e,ke,We,Te,xe,Se,et,Ee,Ke,U[Ne-1][ze-1]===0,K));let qe=0;He!==Number.MAX_SAFE_INTEGER&&($e=!0,qe=He+M[Ne-1][ze-1]);const Xe=et>le,Ze=Xe?M[Ne][ze-1]+(U[Ne][ze-1]>0?-5:0):0,ut=et>le+1&&U[Ne][ze-1]>0,ot=ut?M[Ne][ze-2]+(U[Ne][ze-2]>0?-5:0):0;if(ut&&(!Xe||ot>=Ze)&&(!$e||ot>=qe))M[Ne][ze]=ot,N[Ne][ze]=3,U[Ne][ze]=0;else if(Xe&&(!$e||Ze>=qe))M[Ne][ze]=Ze,N[Ne][ze]=2,U[Ne][ze]=0;else if($e)M[Ne][ze]=qe,N[Ne][ze]=1,U[Ne][ze]=U[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(_e,Te,xe,Ke),!(!K[0]&&!G)){Ne--,ze--;const se=[M[Ne][ze],Ke];let he=0,Y=0;for(;Ne>=1;){let le=ze;do{const ge=N[Ne][le];if(ge===3)le=le-2;else if(ge===2)le=le-1;else break}while(le>=1);he>1&&ke[Te+Ne-1]===Se[Ke+ze-1]&&!we(le+Ke-1,xe,Se)&&he+1>U[Ne][le]&&(le=ze),le===ze?he++:he=1,Y||(Y=le),Ne--,ze=le-1,se.push(ze)}Ee===ie&&(se[0]+=2);const ne=Y-ie;return se[0]-=ne,se}}}e.fuzzyScore=z;function J(_e,ke,Te,xe,Se,Ke){let G=_e-1,ie=ke-1;for(;G>=Te&&ie>=xe;)Se[G]===Ke[ie]&&(F[G]=ie,G--),ie--}function te(_e,ke,Te,xe,Se,Ke,G,ie,Ee,Ne,ze){if(ke[Te]!==Ke[G])return Number.MIN_SAFE_INTEGER;let We=1,et=!1;return G===Te-xe?We=_e[Te]===Se[G]?7:5:we(G,Se,Ke)&&(G===0||!we(G-1,Se,Ke))?(We=_e[Te]===Se[G]?7:5,et=!0):Q(Ke,G)&&(G===0||!Q(Ke,G-1))?We=5:(Q(Ke,G-1)||me(Ke,G-1))&&(We=5,et=!0),We>1&&Te===xe&&(ze[0]=!0),et||(et=we(G,Se,Ke)||Q(Ke,G-1)||me(Ke,G-1)),Te===xe?G>Ee&&(We-=et?3:5):Ne?We+=et?2:0:We+=et?0:1,G+1===ie&&(We-=et?3:5),We}function ae(_e,ke,Te,xe,Se,Ke,G){return De(_e,ke,Te,xe,Se,Ke,!0,G)}e.fuzzyScoreGracefulAggressive=ae;function fe(_e,ke,Te,xe,Se,Ke,G){return De(_e,ke,Te,xe,Se,Ke,!1,G)}e.fuzzyScoreGraceful=fe;function De(_e,ke,Te,xe,Se,Ke,G,ie){let Ee=z(_e,ke,Te,xe,Se,Ke,ie);if(Ee&&!G)return Ee;if(_e.length>=3){const Ne=Math.min(7,_e.length-1);for(let ze=Te+1;ze<Ne;ze++){const We=Oe(_e,ze);if(We){const et=z(We,We.toLowerCase(),Te,xe,Se,Ke,ie);et&&(et[0]-=3,(!Ee||et[0]>Ee[0])&&(Ee=et))}}}return Ee}function Oe(_e,ke){if(!(ke+1>=_e.length)){const Te=_e[ke],xe=_e[ke+1];if(Te!==xe)return _e.slice(0,ke)+xe+Te+_e.slice(ke+2)}}}),define(pe[135],ve([0,1,47,93,10]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${P.source}`,"g");function A(p){return p.replace(C,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=A;const D=new RegExp(`\\\\${P.source}`,"g");function n(p){return p.replace(D,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function k(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(T,(S,v,_,c)=>_?S:v||c||"")}e.stripIcons=k;function b(p){const S=p.indexOf(e.iconStartMarker);return S===-1?{text:p}:m(p,S)}e.parseLabelWithIcons=b;function m(p,S){const v=[];let _="";function c(h){if(h){_+=h;for(const g of h)v.push(t)}}let u=-1,s="",t=0,i,o,r=S;const l=p.length;for(c(p.substr(0,S));r<l;)i=p[r],o=p[r+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=r,c(s),s=e.iconStartMarker,r++):i===")"&&u!==-1?(t+=r-u+1,u=-1,s=""):u!==-1?/^[a-z0-9\-]$/i.test(i)?s+=i:(c(s),u=-1,s=""):c(i),r++;return c(s),{text:_,iconOffsets:v}}function a(p,S,v=!1){const{text:_,iconOffsets:c}=S;if(!c||c.length===0)return(0,y.matchesFuzzy)(p,_,v);const u=(0,R.ltrim)(_," "),s=_.length-u.length,t=(0,y.matchesFuzzy)(p,u,v);if(t)for(const i of t){const o=c[i.start+s]+s;i.start+=o,i.end+=o}return t}e.matchesFuzzyIconAware=a}),define(pe[94],ve([0,1,14,135,16]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(p="",S=!1){var v,_;if(this.value=p,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(v=S.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(_=S.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(p,S=0){return this.value+=k(this.supportThemeIcons?(0,y.escapeIcons)(p):p).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,S){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=C;function A(a){return D(a)?!a.value:Array.isArray(a)?a.every(A):!0}e.isEmptyMarkdownString=A;function D(a){return a instanceof C?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function n(a,p){return!a&&!p?!0:!a||!p?!1:Array.isArray(a)&&Array.isArray(p)?(0,E.equals)(a,p,T):D(a)&&D(p)?T(a,p):!1}e.markedStringsEquals=n;function T(a,p){return a===p?!0:!a||!p?!1:a.value===p.value&&a.isTrusted===p.isTrusted&&a.supportThemeIcons===p.supportThemeIcons}function k(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function b(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function m(a){const p=[],S=a.split("|").map(_=>_.trim());a=S[0];const v=S[1];if(v){const _=/height=(\d+)/.exec(v),c=/width=(\d+)/.exec(v),u=_?_[1]:"",s=c?c[1]:"",t=isFinite(parseInt(s)),i=isFinite(parseInt(u));t&&p.push(`width="${s}"`),i&&p.push(`height="${u}"`)}return{href:a,dimensions:p}}e.parseHrefAndDimensions=m}),define(pe[57],ve([0,1,25,10,2]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,A)}e.stringify=P;function C(n){let T=JSON.parse(n);return T=D(T),T}e.parse=C;function A(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,y.regExpFlags)(T)}:T}function D(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=D(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=D(n[k],T+1))}return n}e.revive=D}),define(pe[11],ve([0,1,2,9]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.vscodeWebviewResource="vscode-webview-resource",A.extension="extension",A.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,n,T){this._hosts[D]=n,this._ports[D]=T}setConnectionToken(D,n){this._connectionTokens[D]=n}rewrite(D){if(this._delegate)return this._delegate(D);const n=D.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],b=this._connectionTokens[n];let m=`path=${encodeURIComponent(D.path)}`;return typeof b=="string"&&(m+=`&tkn=${encodeURIComponent(b)}`),E.URI.from({scheme:y.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new P;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,n,T){const k=this.toUri(D,n);return k.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(k):y.isNative&&(T||y.isPreferringBrowserCodeLoad)&&k.scheme===R.file?k.with({scheme:R.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(D,n){const T=this.toUri(D,n);return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(D,n){return E.URI.isUri(D)?D:E.URI.parse(n.toUrl(D))}}e.FileAccess=new C}),define(pe[74],ve([0,1,23]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const y=new E.LRUCache(1e4);function R(n){return D(n,"NFC",y)}e.normalizeNFC=R;const P=new E.LRUCache(1e4);function C(n){return D(n,"NFD",P)}e.normalizeNFD=C;const A=/[^\u0000-\u0080]/;function D(n,T,k){if(!e.canNormalize||!n)return n;const b=k.get(n);if(b)return b;let m;return A.test(n)?m=n.normalize(T):m=n,k.set(n,m),m}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(T){return C(T).replace(n,"")}}else return function(n){return n}}()}),define(pe[24],ve([0,1,31,8,2,10,11,9]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,R.uriToFsPath)(m,!0)}e.originalFSPath=D;class n{constructor(a){this._ignorePathCasing=a}compare(a,p,S=!1){return a===p?0:(0,P.compare)(this.getComparisonKey(a,S),this.getComparisonKey(p,S))}isEqual(a,p,S=!1){return a===p?!0:!a||!p?!1:this.getComparisonKey(a,S)===this.getComparisonKey(p,S)}getComparisonKey(a,p=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,p,S=!1){if(a.scheme===p.scheme){if(a.scheme===C.Schemas.file)return E.isEqualOrParent(D(a),D(p),this._ignorePathCasing(a))&&a.query===p.query&&(S||a.fragment===p.fragment);if((0,e.isEqualAuthority)(a.authority,p.authority))return E.isEqualOrParent(a.path,p.path,this._ignorePathCasing(a),"/")&&a.query===p.query&&(S||a.fragment===p.fragment)}return!1}joinPath(a,...p){return R.URI.joinPath(a,...p)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return y.posix.basename(a.path)}extname(a){return y.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let p;return a.scheme===C.Schemas.file?p=R.URI.file(y.dirname(D(a))).path:(p=y.posix.dirname(a.path),a.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),p="/")),a.with({path:p})}normalizePath(a){if(!a.path.length)return a;let p;return a.scheme===C.Schemas.file?p=R.URI.file(y.normalize(D(a))).path:p=y.posix.normalize(a.path),a.with({path:p})}relativePath(a,p){if(!(a.scheme!==p.scheme||!(0,e.isEqualAuthority)(a.authority,p.authority))){if(a.scheme===C.Schemas.file){const _=y.relative(D(a),D(p));return A.isWindows?E.toSlashes(_):_}let S=a.path||"/",v=p.path||"/";if(this._ignorePathCasing(a)){let _=0;for(const c=Math.min(S.length,v.length);_<c&&!(S.charCodeAt(_)!==v.charCodeAt(_)&&S.charAt(_).toLowerCase()!==v.charAt(_).toLowerCase());_++);S=v.substr(0,_)+S.substr(_)}return y.posix.relative(S,v)}}resolvePath(a,p){if(a.scheme===C.Schemas.file){const S=R.URI.file(y.resolve(D(a),p));return a.with({authority:S.authority,path:S.path})}return p.indexOf("/")===-1&&(p=E.toSlashes(p),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p)),a.with({path:y.posix.resolve(a.path,p)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,p){return a===p||(0,P.equalsIgnoreCase)(a,p)}hasTrailingPathSeparator(a,p=y.sep){if(a.scheme===C.Schemas.file){const S=D(a);return S.length>E.getRoot(S).length&&S[S.length-1]===p}else{const S=a.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,p=y.sep){return(0,e.hasTrailingPathSeparator)(a,p)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,p=y.sep){let S=!1;if(a.scheme===C.Schemas.file){const v=D(a);S=v!==void 0&&v.length===E.getRoot(v).length&&v[v.length-1]===p}else{p="/";const v=a.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(a,p)?a.with({path:a.path+"/"}):a}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(m=>m.scheme===C.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new n(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(m,a){const p=[];for(let S=0;S<m.length;S++){const v=a(m[S]);m.some((_,c)=>c===S?!1:(0,e.isEqualOrParent)(v,a(_)))||p.push(m[S])}return p}e.distinctParents=T;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(p){const S=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(c=>{const[u,s]=c.split(":");u&&s&&S.set(u,s)});const _=p.path.substring(0,p.path.indexOf(";"));return _&&S.set(m.META_DATA_MIME,_),S}m.parseMetaData=a})(k=e.DataUri||(e.DataUri={}));function b(m,a,p){if(a){let S=m.path;return S&&S[0]!==y.posix.sep&&(S=y.posix.sep+S),m.with({scheme:p,authority:a,path:S})}return m.with({scheme:p})}e.toLocalResource=b}),define(pe[17],ve([0,1,21,16,3,6,55,24]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(M){return!!M&&typeof M.then=="function"}e.isThenable=D;function n(M){const N=new E.CancellationTokenSource,O=M(N.token),V=new Promise((q,Q)=>{N.token.onCancellationRequested(()=>{Q((0,y.canceled)())}),Promise.resolve(O).then(me=>{N.dispose(),q(me)},me=>{N.dispose(),Q(me)})});return new class{cancel(){N.cancel()}then(q,Q){return V.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=n;function T(M,N,O){return Promise.race([M,new Promise(V=>N.onCancellationRequested(()=>V(O)))])}e.raceCancellation=T;async function k(M){let N=-1;const O=M.map((q,Q)=>q.then(me=>(N=Q,me))),V=await Promise.race(O);return M.forEach((q,Q)=>{Q!==N&&q.cancel()}),V}e.raceCancellablePromises=k;function b(M,N,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},N);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(Q=>V=Q)])}e.raceTimeout=b;function m(M){return new Promise((N,O)=>{const V=M();D(V)?V.then(N,O):N(V)})}e.asPromise=m;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=N(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=a;class p{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=p;class S{constructor(){this.promiseMap=new Map}queue(N,O){var V;const Q=((V=this.promiseMap.get(N))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===Q&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Q),Q}}e.SequencerByKey=S;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,y.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class _{constructor(N){this.delayer=new v(N),this.throttler=new a}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class c{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class u extends c{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function s(M,N){return N?new Promise((O,V)=>{const q=setTimeout(O,M);N.onCancellationRequested(()=>{clearTimeout(q),V((0,y.canceled)())})}):n(O=>s(M,O))}e.timeout=s;function t(M,N=0){const O=setTimeout(M,N);return(0,P.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(M){return M.then(void 0,N=>{})}e.ignoreErrors=i;function o(M){const N=[];let O=0;const V=M.length;function q(){return O<V?M[O++]():null}function Q(me){me!=null&&N.push(me);const we=q();return we?we.then(Q):Promise.resolve(N)}return Promise.resolve(null).then(Q)}e.sequence=o;function r(M,N=V=>!!V,O=null){let V=0;const q=M.length,Q=()=>{if(V>=q)return Promise.resolve(O);const me=M[V++];return Promise.resolve(me()).then(Ae=>N(Ae)?Promise.resolve(Ae):Q())};return Q()}e.first=r;function l(M,N=V=>!!V,O=null){if(M.length===0)return Promise.resolve(O);let V=M.length;const q=()=>{var Q,me;V=-1;for(const we of M)(me=(Q=we).cancel)===null||me===void 0||me.call(Q)};return new Promise((Q,me)=>{for(const we of M)we.then(Ae=>{--V>=0&&N(Ae)?(q(),Q(Ae)):V===0&&Q(O)}).catch(Ae=>{--V>=0&&(q(),me(Ae))})})}e.firstParallel=l;class h{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:N,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class w{constructor(){this.queues=new Map}queueFor(N,O=A.extUri){const V=O.getComparisonKey(N);let q=this.queues.get(V);return q||(q=new g,R.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=w;class d{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=d;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=f;class I{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class L extends I{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(M));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,N)=>{const O=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class B{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function ee(M,N,O){let V;for(let q=0;q<O;q++)try{return await M()}catch(Q){V=Q,await s(N)}throw V}e.retry=ee;class H{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,V){return this._pending={taskId:N,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,V;const q=new Promise((Q,me)=>{O=Q,V=me});this._next={run:N,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=H;class x{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,y.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=$;class F extends R.Emitter{async fireAsync(N,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),me=[],we=Object.assign(Object.assign({},Q),{waitUntil:Ae=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");V&&(Ae=V(Ae,typeof q=="function"?q:q[0])),me.push(Ae)}});try{typeof q=="function"?q.call(void 0,we):q[0].call(q[1],we)}catch(Ae){(0,y.onUnexpectedError)(Ae);continue}Object.freeze(me),await U.settled(me).catch(Ae=>(0,y.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=F;var U;(function(M){async function N(Q){return typeof Promise.allSettled=="function"?O(Q):V(Q)}M.allSettled=N;async function O(Q){return Promise.allSettled(Q)}async function V(Q){return Promise.all(Q.map(me=>me.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function q(Q){let me;const we=await Promise.all(Q.map(Ae=>Ae.then(Ie=>Ie,Ie=>{me||(me=Ie)})));if(typeof me!="undefined")throw me;return we}M.settled=q})(U=e.Promises||(e.Promises={}))}),define(pe[95],ve([0,1,8,17]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new y.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),P=new y.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new y.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,s,t=!1){const i=u||"",o=s||"",r=R.value.collator.compare(i,o);return R.value.collatorIsNumeric&&r===0&&i!==o?i<o?-1:1:r}e.compareFileNames=A;function D(u,s){const t=P.value.collator;return u=u||"",s=s||"",p(t,u,s)}e.compareFileNamesDefault=D;function n(u,s,t=!1){t||(u=u&&u.toLowerCase(),s=s&&s.toLowerCase());const[i,o]=m(u),[r,l]=m(s);return i!==r?i<r?-1:1:o===l?0:o<l?-1:1}e.noIntlCompareFileNames=n;function T(u,s){const[t,i]=m(u),[o,r]=m(s);let l=R.value.collator.compare(i,r);if(l===0){if(R.value.collatorIsNumeric&&i!==r)return i<r?-1:1;if(l=R.value.collator.compare(t,o),R.value.collatorIsNumeric&&l===0&&t!==o)return t<o?-1:1}return l}e.compareFileExtensions=T;function k(u,s){u=u||"",s=s||"";const t=a(u),i=a(s),o=P.value.collator,r=C.value.collator;let l;return l=p(r,t,i),l!==0?l:p(o,u,s)}e.compareFileExtensionsDefault=k;const b=/^(.*?)(\.([^.]*))?$/;function m(u,s=!1){const t=u?b.exec(u):[];let i=[t&&t[1]||"",t&&t[3]||""];return s&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function a(u){const s=u?b.exec(u):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function p(u,s,t){let i=u.compare(s,t);return i!==0?i:s.length!==t.length?s.length<t.length?-1:1:0}function S(u,s,t=!1){return t||(u=u&&u.toLowerCase(),s=s&&s.toLowerCase()),u===s?0:u<s?-1:1}function v(u,s,t=!1){const i=u.split(E.sep),o=s.split(E.sep),r=i.length-1,l=o.length-1;let h,g;for(let w=0;;w++){if(h=r===w,g=l===w,h&&g)return A(i[w],o[w],t);if(h)return-1;if(g)return 1;const d=S(i[w],o[w],t);if(d!==0)return d}}e.comparePaths=v;function _(u,s,t){const i=u.toLowerCase(),o=s.toLowerCase(),r=c(u,s,t);if(r)return r;const l=i.endsWith(t),h=o.endsWith(t);if(l!==h)return l?-1:1;const g=A(i,o);return g!==0?g:i.localeCompare(o)}e.compareAnything=_;function c(u,s,t){const i=u.toLowerCase(),o=s.toLowerCase(),r=i.startsWith(t),l=o.startsWith(t);if(r!==l)return r?-1:1;if(r&&l){if(i.length<o.length)return-1;if(i.length>o.length)return 1}return 0}e.compareByPrefix=c}),define(pe[96],ve([0,1,95,93,8,9,10]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const A=0,D=[A,[]];function n(x,$,F,U){if(!x||!$)return D;const M=x.length,N=$.length;if(M<N)return D;const O=x.toLowerCase();return!U&&!O.includes(F)?D:T($,F,N,x,O,M)}e.scoreFuzzy=n;function T(x,$,F,U,M,N){const O=[],V=[];for(let we=0;we<F;we++){const Ae=we*N,Ie=Ae-N,Me=we>0,z=x[we],J=$[we];for(let te=0;te<N;te++){const ae=te>0,fe=Ae+te,De=fe-1,Oe=Ie+te-1,_e=ae?O[De]:0,ke=Me&&ae?O[Oe]:0,Te=Me&&ae?V[Oe]:0;let xe;!ke&&Me?xe=0:xe=k(z,J,U,M,te,Te),xe&&ke+xe>=_e?(V[fe]=Te+1,O[fe]=ke+xe):(V[fe]=A,O[fe]=_e)}}const q=[];let Q=F-1,me=N-1;for(;Q>=0&&me>=0;){const we=Q*N+me;V[we]===A||(q.push(me),Q--),me--}return[O[F*N-1],q.reverse()]}function k(x,$,F,U,M,N){let O=0;if(!b($,U[M]))return O;if(O+=1,N>0&&(O+=N*5),x===F[M]&&(O+=1),M===0)O+=8;else{const V=m(F.charCodeAt(M-1));V?O+=V:(0,y.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function b(x,$){return x===$?!0:x==="/"||x==="\\"?$==="/"||$==="\\":!1}function m(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function p(x,$,F=0,U=0){const M=$;return M.values&&M.values.length>1?S(x,M.values,F,U):v(x,$,F,U)}e.scoreFuzzy2=p;function S(x,$,F,U){let M=0;const N=[];for(const O of $){const[V,q]=v(x,O,F,U);if(typeof V!="number")return a;M+=V,N.push(...q)}return[M,h(N)]}function v(x,$,F,U){const M=(0,y.fuzzyScore)($.original,$.originalLowercase,F,x,x.toLowerCase(),U,!0);return M?[M[0],(0,y.createMatches)(M)]:a}const _=Object.freeze({score:0}),c=1<<18,u=1<<17,s=1<<16;function t(x,$,F,U,M){if(!x||!$.normalized)return _;const N=U.getItemLabel(x);if(!N)return _;const O=U.getItemDescription(x);let V;O?V=`${N}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`:V=`${N}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`;const q=M[V];if(q)return q;const Q=i(N,O,U.getItemPath(x),$,F);return M[V]=Q,Q}e.scoreItemFuzzy=t;function i(x,$,F,U,M){const N=!F||!U.containsPathSeparator;return F&&(P.isLinux?U.pathNormalized===F:(0,C.equalsIgnoreCase)(U.pathNormalized,F))?{score:c,labelMatch:[{start:0,end:x.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:U.values&&U.values.length>1?o(x,$,F,U.values,N,M):r(x,$,F,U,N,M)}function o(x,$,F,U,M,N){let O=0;const V=[],q=[];for(const Q of U){const{score:me,labelMatch:we,descriptionMatch:Ae}=r(x,$,F,Q,M,N);if(me===A)return _;O+=me,we&&V.push(...we),Ae&&q.push(...Ae)}return{score:O,labelMatch:h(V),descriptionMatch:h(q)}}function r(x,$,F,U,M,N){if(M||!$){const[O,V]=n(x,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,y.matchesPrefix)(U.normalized,x);let Q;return q?(Q=u,Q+=Math.round(U.normalized.length/x.length*100)):Q=s,{score:Q+O,labelMatch:q||l(V)}}}if($){let O=$;F&&(O=`${$}${R.sep}`);const V=O.length,q=`${O}${x}`,[Q,me]=n(q,U.normalized,U.normalizedLowercase,N);if(Q){const we=l(me),Ae=[],Ie=[];return we.forEach(Me=>{Me.start<V&&Me.end>V?(Ae.push({start:0,end:Me.end-V}),Ie.push({start:Me.start,end:V})):Me.start>=V?Ae.push({start:Me.start-V,end:Me.end-V}):Ie.push(Me)}),{score:Q,labelMatch:Ae,descriptionMatch:Ie}}}return _}function l(x){const $=[];if(!x)return $;let F;for(const U of x)F&&F.end===U?F.end+=1:(F={start:U,end:U+1},$.push(F));return $}function h(x){const $=x.sort((M,N)=>M.start-N.start),F=[];let U;for(const M of $)!U||!g(U,M)?(U=M,F.push(M)):(U.start=Math.min(U.start,M.start),U.end=Math.max(U.end,M.end));return F}function g(x,$){return!(x.end<$.start||$.end<x.start)}function w(x,$,F,U,M,N){const O=t(x,F,U,M,N),V=t($,F,U,M,N),q=O.score,Q=V.score;if((q===c||Q===c)&&q!==Q)return q===c?-1:1;if(q>s||Q>s){if(q!==Q)return q>Q?-1:1;if(q<u&&Q<u){const J=f(O.labelMatch,V.labelMatch);if(J!==0)return J}const Me=M.getItemLabel(x)||"",z=M.getItemLabel($)||"";if(Me.length!==z.length)return Me.length-z.length}if(q!==Q)return q>Q?-1:1;const me=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,we=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(me&&!we)return-1;if(we&&!me)return 1;const Ae=d(x,O,M),Ie=d($,V,M);return Ae&&Ie&&Ae!==Ie?Ie>Ae?-1:1:I(x,$,F,M)}e.compareItemsByFuzzyScore=w;function d(x,$,F){let U=-1,M=-1;if($.descriptionMatch&&$.descriptionMatch.length?U=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(U=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(M=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const N=F.getItemDescription(x);N&&(M+=N.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(M=$.descriptionMatch[$.descriptionMatch.length-1].end);return M-U}function f(x,$){if(!x&&!$||(!x||!x.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!x||!x.length)return 1;const F=x[0].start,M=x[x.length-1].end-F,N=$[0].start,V=$[$.length-1].end-N;return M===V?0:V<M?1:-1}function I(x,$,F,U){const M=U.getItemLabel(x)||"",N=U.getItemLabel($)||"",O=U.getItemDescription(x),V=U.getItemDescription($),q=M.length+(O?O.length:0),Q=N.length+(V?V.length:0);if(q!==Q)return q-Q;const me=U.getItemPath(x),we=U.getItemPath($);return me&&we&&me.length!==we.length?me.length-we.length:M!==N?(0,E.compareAnything)(M,N,F.normalized):O&&V&&O!==V?(0,E.compareAnything)(O,V,F.normalized):me&&we&&me!==we?(0,E.compareAnything)(me,we,F.normalized):0}const L=" ";function B(x){typeof x!="string"&&(x="");const $=x.toLowerCase(),{pathNormalized:F,normalized:U,normalizedLowercase:M}=ee(x),N=F.indexOf(R.sep)>=0;let O;const V=x.split(L);if(V.length>1)for(const q of V){const{pathNormalized:Q,normalized:me,normalizedLowercase:we}=ee(q);me&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:me,normalizedLowercase:we}))}return{original:x,originalLowercase:$,pathNormalized:F,normalized:U,normalizedLowercase:M,values:O,containsPathSeparator:N}}e.prepareQuery=B;function ee(x){let $;P.isWindows?$=x.replace(/\//g,R.sep):$=x.replace(/\\/g,R.sep);const F=(0,C.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:F,normalizedLowercase:F.toLowerCase()}}function H(x){return Array.isArray(x)?B(x.map($=>$.original).join(L)):B(x.original)}e.pieceToQuery=H}),define(pe[34],ve([0,1,10,31,8,23,17]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const D="**",n="/",T="[/\\\\]",k="[^/\\\\]",b=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function a(O,V){if(!O)return[];const q=[];let Q=!1,me=!1,we="";for(const Ae of O){switch(Ae){case V:if(!Q&&!me){q.push(we),we="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":me=!0;break;case"]":me=!1;break}we+=Ae}return we&&q.push(we),q}e.splitGlobAware=a;function p(O){if(!O)return"";let V="";const q=a(O,n);if(q.every(Q=>Q===D))V=".*";else{let Q=!1;q.forEach((me,we)=>{if(me===D){Q||(V+=m(2),Q=!0);return}let Ae=!1,Ie="",Me=!1,z="";for(const J of me){if(J!=="}"&&Ae){Ie+=J;continue}if(Me&&(J!=="]"||!z)){let te;J==="-"?te=J:(J==="^"||J==="!")&&!z?te="^":J===n?te="":te=E.escapeRegExpCharacters(J),z+=te;continue}switch(J){case"{":Ae=!0;continue;case"[":Me=!0;continue;case"}":V+=`(?:${a(Ie,",").map(fe=>p(fe)).join("|")})`,Ae=!1,Ie="";break;case"]":V+="["+z+"]",Me=!1,z="";break;case"?":V+=k;continue;case"*":V+=m(1);continue;default:V+=E.escapeRegExpCharacters(J)}}we<q.length-1&&(q[we+1]!==D||we+2<q.length)&&(V+=T),Q=!1})}return V}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},o=function(){return null};function r(O,V){if(!O)return o;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Q=`${q}_${!!V.trimForExclusions}`;let me=t.get(Q);if(me)return l(me,O);let we;if(S.test(q)){const Ae=q.substr(4);me=function(Ie,Me){return typeof Ie=="string"&&Ie.endsWith(Ae)?q:null}}else(we=v.exec(h(q,V)))?me=g(we[1],q):(V.trimForExclusions?c:_).test(q)?me=w(q,V):(we=u.exec(h(q,V)))?me=d(we[1].substr(1),q,!0):(we=s.exec(h(q,V)))?me=d(we[1],q,!1):me=f(q);return t.set(Q,me),l(me,O)}function l(O,V){return typeof V=="string"?O:function(q,Q){return y.isEqualOrParent(q,V.base)?O(R.relative(V.base,q),Q):null}}function h(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function g(O,V){const q=`/${O}`,Q=`\\${O}`,me=function(Ae,Ie){return typeof Ae!="string"?null:Ie?Ie===O?V:null:Ae===O||Ae.endsWith(q)||Ae.endsWith(Q)?V:null},we=[O];return me.basenames=we,me.patterns=[V],me.allBasenames=we,me}function w(O,V){const q=N(O.slice(1,-1).split(",").map(Ie=>r(Ie,V)).filter(Ie=>Ie!==o),O),Q=q.length;if(!Q)return o;if(Q===1)return q[0];const me=function(Ie,Me){for(let z=0,J=q.length;z<J;z++)if(q[z](Ie,Me))return O;return null},we=q.find(Ie=>!!Ie.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=q.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Ae.length&&(me.allPaths=Ae),me}function d(O,V,q){const Q=R.sep===R.posix.sep,me=Q?O:O.replace(b,R.sep),we=R.sep+me,Ae=R.posix.sep+O,Ie=q?function(Me,z){return typeof Me=="string"&&(Me===me||Me.endsWith(we)||!Q&&(Me===O||Me.endsWith(Ae)))?V:null}:function(Me,z){return typeof Me=="string"&&(Me===me||!Q&&Me===O)?V:null};return Ie.allPaths=[(q?"*/":"./")+O],Ie}function f(O){try{const V=new RegExp(`^${p(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return o}}function I(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=I;function L(O,V={}){if(!O)return i;if(typeof O=="string"||x(O)){const q=r(O,V);if(q===o)return i;const Q=function(me,we){return!!q(me,we)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return U(O,V)}e.parse=L;function B(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(Q=>Q?H(Q):{})),V.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=B;function ee(O){if(!!O){let V;return q=>{if(!V){const Q=O();V=Q?H(Q):{}}return!!V[q]}}}e.hasSiblingFn=ee;function H(O){const V={};for(const q of O)V[q]=!0;return V}function x(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=x;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,V){const q=N(Object.getOwnPropertyNames(O).map(Ie=>M(Ie,O[Ie],V)).filter(Ie=>Ie!==o)),Q=q.length;if(!Q)return o;if(!q.some(Ie=>!!Ie.requiresSiblings)){if(Q===1)return q[0];const Ie=function(J,te){for(let ae=0,fe=q.length;ae<fe;ae++){const De=q[ae](J,te);if(De)return De}return null},Me=q.find(J=>!!J.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const z=q.reduce((J,te)=>te.allPaths?J.concat(te.allPaths):J,[]);return z.length&&(Ie.allPaths=z),Ie}const me=function(Ie,Me,z){let J;for(let te=0,ae=q.length;te<ae;te++){const fe=q[te];fe.requiresSiblings&&z&&(Me||(Me=R.basename(Ie)),J||(J=Me.substr(0,Me.length-R.extname(Ie).length)));const De=fe(Ie,Me,J,z);if(De)return De}return null},we=q.find(Ie=>!!Ie.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=q.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Ae.length&&(me.allPaths=Ae),me}function M(O,V,q){if(V===!1)return o;const Q=r(O,q);if(Q===o)return o;if(typeof V=="boolean")return Q;if(V){const me=V.when;if(typeof me=="string"){const we=(Ae,Ie,Me,z)=>{if(!z||!Q(Ae,Ie))return null;const J=me.replace("$(basename)",Me),te=z(J);return(0,C.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return we.requiresSiblings=!0,we}}return Q}function N(O,V){const q=O.filter(Ie=>!!Ie.basenames);if(q.length<2)return O;const Q=q.reduce((Ie,Me)=>{const z=Me.basenames;return z?Ie.concat(z):Ie},[]);let me;if(V){me=[];for(let Ie=0,Me=Q.length;Ie<Me;Ie++)me.push(V)}else me=q.reduce((Ie,Me)=>{const z=Me.patterns;return z?Ie.concat(z):Ie},[]);const we=function(Ie,Me){if(typeof Ie!="string")return null;if(!Me){let J;for(J=Ie.length;J>0;J--){const te=Ie.charCodeAt(J-1);if(te===47||te===92)break}Me=Ie.substr(J)}const z=Q.indexOf(Me);return z!==-1?me[z]:null};we.basenames=Q,we.patterns=me,we.allBasenames=Q;const Ae=O.filter(Ie=>!Ie.basenames);return Ae.push(we),Ae}}),define(pe[75],ve([0,1,2,8,10,11,9,24,31]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(r,l,h){if(typeof r=="string"&&(r=E.URI.file(r)),h){const w=h.getWorkspaceFolder(r);if(w){const d=h.getWorkspace().folders.length>1;let f;if((0,A.isEqual)(w.uri,r)?f="":f=(0,A.relativePath)(w.uri,r),d){const I=w.name?w.name:(0,A.basename)(w.uri);f=f?I+" \u2022 "+f:I}return f}}if(r.scheme!==P.Schemas.file&&r.scheme!==P.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,y.normalize)(k(r.fsPath));let g=(0,y.normalize)(r.fsPath);return!C.isWindows&&(l==null?void 0:l.userHome)&&(g=m(g,l.userHome.fsPath)),g}e.getPathLabel=n;function T(r){if(!!r){typeof r=="string"&&(r=E.URI.file(r));const l=(0,A.basename)(r)||(r.scheme===P.Schemas.file?r.fsPath:r.path);return C.isWindows&&(0,D.isRootOrDriveLetter)(l)?k(l):l}}e.getBaseLabel=T;function k(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=k;let b=Object.create(null);function m(r,l){if(C.isWindows||!r||!l)return r;let h=b.original===l?b.normalized:void 0;return h||(h=`${(0,R.rtrim)(l,y.posix.sep)}${y.posix.sep}`,b={original:l,normalized:h}),(C.isLinux?r.startsWith(h):(0,R.startsWithIgnoreCase)(r,h))&&(r=`~/${r.substr(h.length)}`),r}e.tildify=m;function a(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=a;const p="\u2026",S="\\\\",v="~";function _(r,l=y.sep){const h=new Array(r.length);let g=!1;for(let w=0;w<r.length;w++){let d=r[w];if(d===""){h[w]=`.${l}`;continue}if(!d){h[w]=d;continue}g=!0;let f="";d.indexOf(S)===0?(f=d.substr(0,d.indexOf(S)+S.length),d=d.substr(d.indexOf(S)+S.length)):d.indexOf(l)===0?(f=d.substr(0,d.indexOf(l)+l.length),d=d.substr(d.indexOf(l)+l.length)):d.indexOf(v)===0&&(f=d.substr(0,d.indexOf(v)+v.length),d=d.substr(d.indexOf(v)+v.length));const I=d.split(l);for(let L=1;g&&L<=I.length;L++)for(let B=I.length-L;g&&B>=0;B--){g=!1;let ee=I.slice(B,B+L).join(l);for(let H=0;!g&&H<r.length;H++)if(H!==w&&r[H]&&r[H].indexOf(ee)>-1){const x=B+L===I.length,$=B>0&&r[H].indexOf(l)>-1?l+ee:ee,F=r[H].endsWith($);g=!x||F}if(!g){let H="";(I[0].endsWith(":")||f!=="")&&(B===1&&(B=0,L++,ee=I[0]+l+ee),B>0&&(H=I[0]+l),H=f+H),B>0&&(H=H+p+l),H=H+ee,B+L<I.length&&(H=H+l+p),h[w]=H}}g&&(h[w]=d)}return h}e.shorten=_;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function u(r,l=Object.create(null)){const h=[];let g=!1,w="";for(const d of r)if(d==="$"||g&&d==="{")w&&h.push({value:w,type:c.TEXT}),w="",g=!0;else if(d==="}"&&g){const f=l[w];if(typeof f=="string")f.length&&h.push({value:f,type:c.VARIABLE});else if(f){const I=h[h.length-1];(!I||I.type!==c.SEPARATOR)&&h.push({value:f.label,type:c.SEPARATOR})}w="",g=!1}else w+=d;return w&&!g&&h.push({value:w,type:c.TEXT}),h.filter((d,f)=>{if(d.type===c.SEPARATOR){const I=h[f-1],L=h[f+1];return[I,L].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=u;function s(r,l){return C.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(r,l){return C.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):C.isWindows?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(r){const l=r.indexOf("/")!==-1?y.posix:y.win32,h=l.basename(r),g=l.dirname(r);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}e.splitName=o}),define(pe[97],ve([0,1,2]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(T){return T.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const b=this._uriTransformer.transformIncoming(k);return b===k?k:y(E.URI.from(b))}transformOutgoing(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:y(E.URI.from(b))}transformOutgoingURI(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:E.URI.from(b)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,k,b){if(!T||b>200)return null;if(typeof T=="object"){if(T instanceof E.URI)return k.transformOutgoing(T);for(let m in T)if(Object.hasOwnProperty.call(T,m)){const a=P(T[m],k,b+1);a!==null&&(T[m]=a)}}return null}function C(T,k){const b=P(T,k,0);return b===null?T:b}e.transformOutgoingURIs=C;function A(T,k,b,m){if(!T||m>200)return null;if(typeof T=="object"){if(T.$mid===1)return b?E.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let a in T)if(Object.hasOwnProperty.call(T,a)){const p=A(T[a],k,b,m+1);p!==null&&(T[a]=p)}}return null}function D(T,k){const b=A(T,k,!1,0);return b===null?T:b}e.transformIncomingURIs=D;function n(T,k){const b=A(T,k,!0,0);return b===null?T:b}e.transformAndReviveIncomingURIs=n}),define(pe[28],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(D){return E.test(D)}e.isUUID=y;const R=new Uint8Array(16),P=[];for(let D=0;D<256;D++)P.push(D.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(D){for(let n=0;n<D.length;n++)D[n]=Math.floor(Math.random()*256);return D};function A(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let D=0,n="";return n+=P[R[D++]],n+=P[R[D++]],n+=P[R[D++]],n+=P[R[D++]],n+="-",n+=P[R[D++]],n+=P[R[D++]],n+="-",n+=P[R[D++]],n+=P[R[D++]],n+="-",n+=P[R[D++]],n+=P[R[D++]],n+="-",n+=P[R[D++]],n+=P[R[D++]],n+=P[R[D++]],n+=P[R[D++]],n+=P[R[D++]],n+=P[R[D++]],n}e.generateUuid=A}),define(pe[136],ve([0,1,98]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class y{constructor(P="utf8"){this.stringDecoder=new E.StringDecoder(P),this.remaining=null}write(P){const C=[],A=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(A.length<1)return C;let D=0,n,T=D;for(;T<A.length;)if(n=A.charCodeAt(T),n===13||n===10){if(C.push(A.substring(D,T)),T++,T<A.length){const k=n;n=A.charCodeAt(T),(k===13&&n===10||k===10&&n===13)&&T++}D=T}else T++;return this.remaining=D<A.length?A.substr(D):null,C}end(){return this.remaining}}e.LineDecoder=y}),define(pe[26],ve([0,1,37,48,8,17,9,31,28,74,24,2]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var b;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function m($,F=b.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return F===b.UNLINK?p($):a($)}e.rimraf=m;async function a($){try{const F=(0,R.join)((0,y.tmpdir)(),(0,D.generateUuid)());try{await E.promises.rename($,F)}catch(U){return p($)}p(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function p($){return E.promises.rmdir($,{recursive:!0,maxRetries:3})}function S($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync($,{recursive:!0})}e.rimrafSync=S;async function v($,F){return u(await(F?_($):E.promises.readdir($)))}e.readdir=v;async function _($){try{return await E.promises.readdir($,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],U=await v($);for(const M of U){let N=!1,O=!1,V=!1;try{const q=await E.promises.lstat((0,R.join)($,M));N=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}F.push({name:M,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>V})}return F}function c($){return u(E.readdirSync($))}e.readdirSync=c;function u($){return $.map(F=>typeof F=="string"?C.isMacintosh?(0,n.normalizeNFC)(F):F:(F.name=C.isMacintosh?(0,n.normalizeNFC)(F.name):F.name,F))}async function s($){const F=await v($),U=[];for(const M of F)await i.existsDirectory((0,R.join)($,M))&&U.push(M);return U}e.readDirsInDir=s;function t($,F=1e3){return new Promise(U=>{let M=!1;const N=setInterval(()=>{M||(M=!0,E.access($,O=>{M=!1,O&&(clearInterval(N),U(void 0))}))},F)})}e.whenDeleted=t;var i;(function($){async function F(N){let O;try{if(O=await E.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await E.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(C.isWindows&&V.code==="EACCES")try{return{stat:await E.promises.stat(await E.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}$.stat=F;async function U(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsFile=U;async function M(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function r($,F,U){return o.queueFor(k.URI.file($),T.extUriBiasedIgnorePathCase).queue(()=>{const M=w(U);return new Promise((N,O)=>h($,F,M,V=>V?O(V):N()))})}e.writeFile=r;let l=!0;function h($,F,U,M){if(!l)return E.writeFile($,F,{mode:U.mode,flag:U.flag},M);E.open($,U.flag,U.mode,(N,O)=>{if(N)return M(N);E.writeFile(O,F,V=>{if(V)return E.close(O,()=>M(V));E.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l=!1),E.close(O,Q=>M(Q))))})})}function g($,F,U){const M=w(U);if(!l)return E.writeFileSync($,F,{mode:M.mode,flag:M.flag});const N=E.openSync($,M.flag,M.mode);try{E.writeFileSync(N,F);try{E.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{E.closeSync(N)}}e.writeFileSync=g;function w($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function d($,F){if($!==F){async function U(M){try{const N=await E.promises.lstat(M);if(N.isDirectory()||N.isSymbolicLink())return;const O=await E.promises.open(M,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await E.promises.rename($,F),await U(F)}catch(M){if($.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||$.endsWith("."))await f($,F,{preserveSymlinks:!1}),await m($,b.MOVE),await U(F);else throw M}}}e.move=d;async function f($,F,U){return L($,F,{root:{source:$,target:F},options:U,handledSourcePaths:new Set})}e.copy=f;const I=511;async function L($,F,U){if(!U.handledSourcePaths.has($)){U.handledSourcePaths.add($);const{stat:M,symbolicLink:N}=await i.stat($);if(N){if(U.options.preserveSymlinks)try{return await H($,F,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return M.isDirectory()?B($,F,M.mode&I,U):ee($,F,M.mode&I)}}async function B($,F,U,M){await E.promises.mkdir(F,{recursive:!0,mode:U});const N=await v($);for(const O of N)await L((0,R.join)($,O),(0,R.join)(F,O),M)}async function ee($,F,U){await E.promises.copyFile($,F),await E.promises.chmod(F,U)}async function H($,F,U){let M=await E.promises.readlink($);(0,A.isEqualOrParent)(M,U.root.source,!C.isLinux)&&(M=(0,R.join)(U.root.target,M.substr(U.root.source.length+1))),await E.promises.symlink(M,F)}async function x($){try{return await E.promises.access($),!0}catch(F){return!1}}e.exists=x}),define(pe[99],ve([0,1,37,280,10,8,26]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(k){const b=(0,P.dirname)(k);if(k===b)return k;const m=((0,P.basename)(k)||k).toLowerCase();try{const p=(0,C.readdirSync)(b).filter(S=>S.toLowerCase()===m);if(p.length===1){const S=A(b);if(S)return(0,P.join)(S,p[0])}else if(p.length>1){const S=p.indexOf(m);if(S>=0){const v=A(b);if(v)return(0,P.join)(v,p[S])}}}catch(a){}return null}e.realcaseSync=A;async function D(k){try{return await(0,y.promisify)(E.realpath)(k)}catch(b){const m=T(k);return await E.promises.access(m,E.constants.R_OK),m}}e.realpath=D;function n(k){try{return E.realpathSync(k)}catch(b){const m=T(k);return E.accessSync(m,E.constants.R_OK),m}}e.realpathSync=n;function T(k){return(0,R.rtrim)((0,P.normalize)(k),P.sep)}});var vt=this&&this.__await||function(Z){return this instanceof vt?(this.v=Z,this):new vt(Z)},Tn=this&&this.__asyncGenerator||function(Z,e,E){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var y=E.apply(Z,e||[]),R,P=[];return R={},C("next"),C("throw"),C("return"),R[Symbol.asyncIterator]=function(){return this},R;function C(b){y[b]&&(R[b]=function(m){return new Promise(function(a,p){P.push([b,m,a,p])>1||A(b,m)})})}function A(b,m){try{D(y[b](m))}catch(a){k(P[0][3],a)}}function D(b){b.value instanceof vt?Promise.resolve(b.value.v).then(n,T):k(P[0][2],b)}function n(b){A("next",b)}function T(b){A("throw",b)}function k(b,m){b(m),P.shift(),P.length&&A(P[0][0],P[0][1])}},rn=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],E;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),E={},y("next"),y("throw"),y("return"),E[Symbol.asyncIterator]=function(){return this},E);function y(P){E[P]=Z[P]&&function(C){return new Promise(function(A,D){C=Z[P](C),R(A,D,C.done,C.value)})}}function R(P,C,A,D){Promise.resolve(D).then(function(n){P({value:n,done:A})},C)}};define(pe[100],ve([0,1,26,48,8]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,C=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var D;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(D||(D={}));let n;switch(process.arch){case"ia32":case"x32":n=1;break;case"arm":case"arm64":n=2;break;default:n=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class k{constructor(s,t,i){this.exePath=s,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:u=!1}={}){return u?n===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:s=!1}={}){const t=b({useAlternateBitness:u});if(!t)return null;const i=R.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(i))return null;let o=-1,r=null;for(const g of await E.readdir(i)){let w=-1;if(s){const f=g.indexOf("-");if(f<0)continue;const I=g.substring(0,f);if(!P.test(I)||g.substring(f+1)!=="preview")continue;w=parseInt(I,10)}else{if(!P.test(g))continue;w=parseInt(g,10)}if(!(w<=o)){const d=R.join(i,g,"pwsh.exe");!await E.SymlinkSupport.existsFile(d)||(r=d,o=w)}}if(!r)return null;const l=t.includes("x86")?" (x86)":"",h=s?" Preview":"";return new k(r,`PowerShell${h}${l}`,!0)}async function a({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=u?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const o of await E.readdir(s))if(t.test(o)){const r=R.join(s,o,"pwsh.exe");return new k(r,i)}return null}function p(){const u=R.join(y.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function S(){const u=R.join(process.env.windir,n===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}function v(){return Tn(this,arguments,function*(){let s=yield vt(m());s&&(yield yield vt(s)),s=yield vt(m({useAlternateBitness:!0})),s&&(yield yield vt(s)),s=yield vt(a()),s&&(yield yield vt(s)),s=p(),s&&(yield yield vt(s)),s=yield vt(m({findPreview:!0})),s&&(yield yield vt(s)),s=yield vt(a({findPreview:!0})),s&&(yield yield vt(s)),s=yield vt(m({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield vt(s)),s=S(),s&&(yield yield vt(s))})}function _(){return Tn(this,arguments,function*(){var s,t;try{for(var i=rn(v()),o;o=yield vt(i.next()),!o.done;){const r=o.value;(yield vt(r.exists()))&&(yield yield vt(r))}}catch(r){s={error:r}}finally{try{o&&!o.done&&(t=i.return)&&(yield vt(t.call(i)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=_;async function c(){var u,s;try{for(var t=rn(_()),i;i=await t.next(),!i.done;)return i.value}catch(o){u={error:o}}finally{try{i&&!i.done&&(s=t.return)&&await s.call(t)}finally{if(u)throw u.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(pe[101],ve([0,1,3,6,17,21,16,25,14,15,57,10]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function m(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function p(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class _{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var c;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(c||(c={}));function u(M){const N=A.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function s(M){return M.read(4).readUInt32BE(0)}function t(M){const N=A.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const i={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},o=typeof Buffer!="undefined";function r(M,N){if(typeof N=="undefined")M.write(i.Undefined);else if(typeof N=="string"){const O=A.VSBuffer.fromString(N);M.write(i.String),M.write(u(O.byteLength)),M.write(O)}else if(o&&Buffer.isBuffer(N)){const O=A.VSBuffer.wrap(N);M.write(i.Buffer),M.write(u(O.byteLength)),M.write(O)}else if(N instanceof A.VSBuffer)M.write(i.VSBuffer),M.write(u(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(i.Array),M.write(u(N.length));for(const O of N)r(M,O)}else{const O=A.VSBuffer.fromString(JSON.stringify(N));M.write(i.Object),M.write(u(O.byteLength)),M.write(O)}}function l(M){switch(M.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return M.read(s(M)).toString();case c.Buffer:return M.read(s(M)).buffer;case c.VSBuffer:return M.read(s(M));case c.Array:{const O=s(M),V=[];for(let q=0;q<O;q++)V.push(l(M));return V}case c.Object:return JSON.parse(M.read(s(M)).toString())}}class h{constructor(N,O,V=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,p(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,p(N.type),N.data);return}}}send(N,O=void 0){const V=new _;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new v(N),V=l(O),q=l(O),Q=V[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(Q)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:Q,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(Q)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:Q,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:V[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=new P.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,V.token)}catch(we){q=Promise.reject(we)}const Q=N.id;q.then(we=>{this.sendResponse({id:Q,data:we,type:201}),this.activeRequests.delete(N.id)},we=>{we instanceof Error?this.sendResponse({id:Q,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:Q,data:we,type:203}),this.activeRequests.delete(N.id)});const me=(0,y.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,me)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=N.id,Q=O.listen(this.ctx,N.name,N.arg)(me=>this.sendResponse({id:V,data:me,type:204}));this.activeRequests.set(N.id,Q)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(N){const O=this;return{call(V,q,Q){return O.isDisposed?Promise.reject(C.canceled()):O.requestPromise(N,V,q,Q)},listen(V,q){return O.isDisposed?Promise.reject(C.canceled()):O.requestEvent(N,V,q)}}}requestPromise(N,O,V,q=P.CancellationToken.None){const Q=this.lastRequestId++,we={id:Q,type:100,channelName:N,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(C.canceled());let Ae;return new Promise((Me,z)=>{if(q.isCancellationRequested)return z(C.canceled());const J=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Me(Oe.data);break;case 202:this.handlers.delete(Q);const _e=new Error(Oe.data.message);_e.stack=Oe.data.stack,_e.name=Oe.data.name,z(_e);break;case 203:this.handlers.delete(Q),z(Oe.data);break}};this.handlers.set(Q,De),this.sendRequest(we)};let te=null;this.state===S.Idle?J():(te=(0,R.createCancelablePromise)(De=>this.whenInitialized()),te.then(()=>{te=null,J()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:Q,type:101}),z(C.canceled())},fe=q.onCancellationRequested(ae);Ae=(0,y.combinedDisposable)((0,y.toDisposable)(ae),fe),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(N,O,V){const q=this.lastRequestId++,me={id:q,type:102,channelName:N,name:O,arg:V};let we=null;const Ae=new E.Emitter({onFirstListenerAdd:()=>{we=(0,R.createCancelablePromise)(Me=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Ae),this.sendRequest(me)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Ie=Me=>Ae.fire(Me.data);return this.handlers.set(q,Ie),Ae.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${m(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,m(N.type));return}}}send(N,O=void 0){const V=new _;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new v(N),V=l(O),q=l(O),Q=V[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,p(Q)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],0,p(Q),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===S.Idle?Promise.resolve():E.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=w;class d{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:V})=>{E.Event.once(O.onMessage)(Q=>{const me=new v(Q),we=l(me),Ae=new h(O,we),Ie=new w(O);this.channels.forEach((z,J)=>Ae.registerChannel(J,z));const Me={channelServer:Ae,channelClient:Ie,ctx:we};this._connections.add(Me),this._onDidAddConnection.fire(Me),V(()=>{Ae.dispose(),Ie.dispose(),this._connections.delete(Me),this._onDidRemoveConnection.fire(Me)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const V=this;return{call(q,Q,me){let we;if((0,n.isFunction)(O)){let Ie=(0,D.getRandomElement)(V.connections.filter(O));we=Ie?Promise.resolve(Ie):E.Event.toPromise(E.Event.filter(V.onDidAddConnection,O))}else we=O.routeCall(V,q,Q);const Ae=we.then(Ie=>Ie.channelClient.getChannel(N));return I(Ae).call(q,Q,me)},listen(q,Q){if((0,n.isFunction)(O))return V.getMulticastEvent(N,O,q,Q);const me=O.routeEvent(V,q,Q).then(we=>we.channelClient.getChannel(N));return I(me).listen(q,Q)}}}getMulticastEvent(N,O,V,q){const Q=this;let me=new y.DisposableStore;const we=new E.Emitter({onFirstListenerAdd:()=>{me=new y.DisposableStore;const Ae=new E.EventMultiplexer,Ie=new Map,Me=J=>{const ae=J.channelClient.getChannel(N).listen(V,q),fe=Ae.add(ae);Ie.set(J,fe)},z=J=>{const te=Ie.get(J);!te||(te.dispose(),Ie.delete(J))};Q.connections.filter(O).forEach(Me),E.Event.filter(Q.onDidAddConnection,O)(Me,void 0,me),Q.onDidRemoveConnection(z,void 0,me),Ae.event(we.fire,we,me),me.add(Ae)},onLastListenerRemove:()=>{me.dispose()}});return we.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(V=>{V.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class f{constructor(N,O,V=null){const q=new _;r(q,O),N.send(q.buffer),this.channelClient=new w(N,V),this.channelServer=new h(N,O,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=f;function I(M){return{call(N,O,V){return M.then(q=>q.call(N,O,V))},listen(N,O){const V=new E.Relay;return M.then(q=>V.input=q.listen(N,O)),V.event}}}e.getDelayedChannel=I;function L(M){let N=!1;return{call(O,V,q){return N?M.call(O,V,q):(0,R.timeout)(0).then(()=>N=!0).then(()=>M.call(O,V,q))},listen(O,V){if(N)return M.listen(O,V);const q=new E.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>q.input=M.listen(O,V)),q.event}}}e.getNextTickChannel=L;class B{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await E.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=B;var ee;(function(M){function N(q,Q){const me=q,we=Q&&Q.disableMarshalling,Ae=new Map;for(const Ie in me)V(Ie)&&Ae.set(Ie,E.Event.buffer(me[Ie],!0));return new class{listen(Ie,Me){const z=Ae.get(Me);if(z)return z;throw new Error(`Event not found: ${Me}`)}call(Ie,Me,z){const J=me[Me];if(typeof J=="function"){if(!we&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,T.revive)(z[te]);return J.apply(me,z)}throw new Error(`Method not found: ${Me}`)}}}M.fromService=N;function O(q,Q){const me=Q&&Q.disableMarshalling;return new Proxy({},{get(we,Ae){var Ie;if(typeof Ae=="string")return((Ie=Q==null?void 0:Q.properties)===null||Ie===void 0?void 0:Ie.has(Ae))?Q.properties.get(Ae):V(Ae)?q.listen(Ae):async function(...Me){let z;Q&&!(0,n.isUndefinedOrNull)(Q.context)?z=[Q.context,...Me]:z=Me;const J=await q.call(Ae,z);return me?J:(0,T.revive)(J)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&k.isUpperAsciiLetter(q.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function $(M){return Array.isArray(M)?M.map(x):x(M)}function F(M,N,O,V,q,Q,me){me=$(me);const we=H[q],Ae=we[V%we.length];let Ie=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(Q)?(Ie=Ie.concat(me),Ie.push(")")):Ie.push(me),console.log.apply(console,Ie)}e.logWithColors=F;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,V,q,Q){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,O,V,q,Q)}logIncoming(N,O,V,q,Q){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,O,V,q,Q)}}e.IPCLogger=U}),define(pe[102],ve([0,1,3,101,6,25,9,30]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function n(){return D||(D=P.VSBuffer.alloc(0)),D}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return n();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const w=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),w}if(this._chunks[0].byteLength>o){const w=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),w}let l=P.VSBuffer.alloc(o),h=0,g=0;for(;o>0;){const w=this._chunks[g];if(w.byteLength>o){const d=w.slice(0,o);l.set(d,h),h+=o,r&&(this._chunks[g]=w.slice(o),this._totalLength-=o),o-=o}else l.set(w,h),h+=w.byteLength,r?(this._chunks.shift(),this._totalLength-=w.byteLength):g++,o-=w.byteLength}return l}}e.ChunkStream=T;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var b;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,r,l,h){this.type=o,this.id=r,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends R.Disposable{constructor(o){super();this._onMessage=this._register(new E.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const l=this._state.messageType,h=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(l,h,g,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=P.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._writeSoon(r,o.data)}}_bufferAdd(o,r){const l=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,l}_bufferTake(){const o=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends R.Disposable{constructor(o){super();this._onMessage=new E.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=S;class v extends y.IPCClient{constructor(o,r,l=null){super(o,r,l);this.protocol=o}static fromSocket(o,r){return new v(new S(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new E.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class c{constructor(o){this.data=o,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,l=this._first;for(;l;)o[r++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new c(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<s._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=s._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),r=(1+s._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<s._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=r&&l++;return 1-l/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,r=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,n());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const r=new m(4,0,0,n());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let r=0,l=o.length;r<l;r++)this._socketWriter.write(o[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new m(6,0,0,n())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const r=this._outgoingUnackMsg.toArray();for(let l=0,h=r.length;l<h;l++)this._socketWriter.write(r[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new m(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const r=new m(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,n());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(pe[103],ve([0,1,92]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class y{constructor(A){let D=(0,E.toUint8)(A);this._defaultValue=D,this._asciiMap=y._createAsciiMap(D),this._map=new Map}static _createAsciiMap(A){let D=new Uint8Array(256);for(let n=0;n<256;n++)D[n]=A;return D}set(A,D){let n=(0,E.toUint8)(D);A>=0&&A<256?this._asciiMap[A]=n:this._map.set(A,n)}get(A){return A>=0&&A<256?this._asciiMap[A]:this._map.get(A)||this._defaultValue}}e.CharacterClassifier=y;var R;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(R||(R={}));class P{constructor(){this._actual=new y(0)}add(A){this._actual.set(A,1)}has(A){return this._actual.get(A)===1}}e.CharacterSet=P}),define(pe[137],ve([0,1,103]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var y;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(y=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends E.CharacterClassifier{constructor(A){super(0);for(let D=0,n=A.length;D<n;D++)this.set(A.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function P(C){let A={};return D=>(A.hasOwnProperty(D)||(A[D]=C(D)),A[D])}e.getMapForWordSeparators=P(C=>new R(C))}),define(pe[49],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(R,P){this.lineNumber=R,this.column=P}with(R=this.lineNumber,P=this.column){return R===this.lineNumber&&P===this.column?this:new E(R,P)}delta(R=0,P=0){return this.with(this.lineNumber+R,this.column+P)}equals(R){return E.equals(this,R)}static equals(R,P){return!R&&!P?!0:!!R&&!!P&&R.lineNumber===P.lineNumber&&R.column===P.column}isBefore(R){return E.isBefore(this,R)}static isBefore(R,P){return R.lineNumber<P.lineNumber?!0:P.lineNumber<R.lineNumber?!1:R.column<P.column}isBeforeOrEqual(R){return E.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,P){return R.lineNumber<P.lineNumber?!0:P.lineNumber<R.lineNumber?!1:R.column<=P.column}static compare(R,P){let C=R.lineNumber|0,A=P.lineNumber|0;if(C===A){let D=R.column|0,n=P.column|0;return D-n}return C-A}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new E(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=E}),define(pe[43],ve([0,1,49]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class y{constructor(P,C,A,D){P>A||P===A&&C>D?(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=P,this.endColumn=C):(this.startLineNumber=P,this.startColumn=C,this.endLineNumber=A,this.endColumn=D)}isEmpty(){return y.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return y.containsPosition(this,P)}static containsPosition(P,C){return!(C.lineNumber<P.startLineNumber||C.lineNumber>P.endLineNumber||C.lineNumber===P.startLineNumber&&C.column<P.startColumn||C.lineNumber===P.endLineNumber&&C.column>P.endColumn)}containsRange(P){return y.containsRange(this,P)}static containsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>P.endColumn)}strictContainsRange(P){return y.strictContainsRange(this,P)}static strictContainsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<=P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>=P.endColumn)}plusRange(P){return y.plusRange(this,P)}static plusRange(P,C){let A,D,n,T;return C.startLineNumber<P.startLineNumber?(A=C.startLineNumber,D=C.startColumn):C.startLineNumber===P.startLineNumber?(A=C.startLineNumber,D=Math.min(C.startColumn,P.startColumn)):(A=P.startLineNumber,D=P.startColumn),C.endLineNumber>P.endLineNumber?(n=C.endLineNumber,T=C.endColumn):C.endLineNumber===P.endLineNumber?(n=C.endLineNumber,T=Math.max(C.endColumn,P.endColumn)):(n=P.endLineNumber,T=P.endColumn),new y(A,D,n,T)}intersectRanges(P){return y.intersectRanges(this,P)}static intersectRanges(P,C){let A=P.startLineNumber,D=P.startColumn,n=P.endLineNumber,T=P.endColumn,k=C.startLineNumber,b=C.startColumn,m=C.endLineNumber,a=C.endColumn;return A<k?(A=k,D=b):A===k&&(D=Math.max(D,b)),n>m?(n=m,T=a):n===m&&(T=Math.min(T,a)),A>n||A===n&&D>T?null:new y(A,D,n,T)}equalsRange(P){return y.equalsRange(this,P)}static equalsRange(P,C){return!!P&&!!C&&P.startLineNumber===C.startLineNumber&&P.startColumn===C.startColumn&&P.endLineNumber===C.endLineNumber&&P.endColumn===C.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(P){return new E.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(P){return new E.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,C){return new y(this.startLineNumber,this.startColumn,P,C)}setStartPosition(P,C){return new y(P,C,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(P){return new y(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,C=P){return new y(P.lineNumber,P.column,C.lineNumber,C.column)}static lift(P){return P?new y(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn)}static areIntersecting(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,C){if(P&&C){const n=P.startLineNumber|0,T=C.startLineNumber|0;if(n===T){const k=P.startColumn|0,b=C.startColumn|0;if(k===b){const m=P.endLineNumber|0,a=C.endLineNumber|0;if(m===a){const p=P.endColumn|0,S=C.endColumn|0;return p-S}return m-a}return k-b}return n-T}return(P?1:0)-(C?1:0)}static compareRangesUsingEnds(P,C){return P.endLineNumber===C.endLineNumber?P.endColumn===C.endColumn?P.startLineNumber===C.startLineNumber?P.startColumn-C.startColumn:P.startLineNumber-C.startLineNumber:P.endColumn-C.endColumn:P.endLineNumber-C.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=y}),define(pe[138],ve([0,1,49,43]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class P extends y.Range{constructor(A,D,n,T){super(A,D,n,T);this.selectionStartLineNumber=A,this.selectionStartColumn=D,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return P.selectionsEqual(this,A)}static selectionsEqual(A,D){return A.selectionStartLineNumber===D.selectionStartLineNumber&&A.selectionStartColumn===D.selectionStartColumn&&A.positionLineNumber===D.positionLineNumber&&A.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,D){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,A,D):new P(A,D,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(A,D){return this.getDirection()===0?new P(A,D,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,A,D)}static fromPositions(A,D=A){return new P(A.lineNumber,A.column,D.lineNumber,D.column)}static liftSelection(A){return new P(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,D){if(A&&!D||!A&&D)return!1;if(!A&&!D)return!0;if(A.length!==D.length)return!1;for(let n=0,T=A.length;n<T;n++)if(!this.selectionsEqual(A[n],D[n]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,D,n,T,k){return k===0?new P(A,D,n,T):new P(n,T,A,D)}}e.Selection=P}),define(pe[104],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class D{constructor(a,p){this.range=a,this.matches=p}}e.FindMatch=D;var n;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(a,p,S,v,_,c){this.identifier=a,this.range=p,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=_,this._isTracked=c}}e.ValidAnnotatedEditOperation=k;class b{constructor(a,p,S){this.reverseEdits=a,this.changes=p,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=b}),define(pe[139],ve([0,1,10,137,49,43,104]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class D{constructor(c,u,s,t){this.searchString=c,this.isRegex=u,this.matchCase=s,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=n(this.searchString):c=this.searchString.indexOf(`
`)>=0;let u=null;try{u=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let s=!this.isRegex&&!c;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new T(u,this.wordSeparators?(0,y.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}e.SearchParams=D;function n(_){if(!_||_.length===0)return!1;for(let c=0,u=_.length;c<u;c++)if(_.charCodeAt(c)===92){if(c++,c>=u)break;const t=_.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(c,u,s){this.regex=c,this.wordSeparators=u,this.simpleSearch=s}}e.SearchData=T;function k(_,c,u){if(!u)return new C.FindMatch(_,null);let s=[];for(let t=0,i=c.length;t<i;t++)s[t]=c[t];return new C.FindMatch(_,s)}e.createFindMatch=k;class b{constructor(c){let u=[],s=0;for(let t=0,i=c.length;t<i;t++)c.charCodeAt(t)===10&&(u[s++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(c){const u=this._lineFeedsOffsets;let s=0,t=u.length-1;if(t===-1||c<=u[0])return 0;for(;s<t;){const i=s+((t-s)/2>>0);u[i]>=c?t=i-1:u[i+1]>=c?(s=i,t=i):s=i+1}return s+1}}class m{static findMatches(c,u,s,t,i){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(c,s,new v(o.wordSeparators,o.regex),t,i):this._doFindMatchesLineByLine(c,s,o,t,i):[]}static _getMultilineMatchRange(c,u,s,t,i,o){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),r=u+i+l):r=u+i;let h;if(t){let f=t.findLineFeedCountBeforeOffset(i+o.length)-l;h=r+o.length+f}else h=r+o.length;const g=c.getPositionAt(r),w=c.getPositionAt(h);return new P.Range(g.lineNumber,g.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(c,u,s,t,i){const o=c.getOffsetAt(u.getStartPosition()),r=c.getValueInRange(u,1),l=c.getEOL()===`\r
`?new b(r):null,h=[];let g=0,w;for(s.reset(0);w=s.next(r);)if(h[g++]=k(this._getMultilineMatchRange(c,o,r,l,w.index,w[0]),w,t),g>=i)return h;return h}static _doFindMatchesLineByLine(c,u,s,t,i){const o=[];let r=0;if(u.startLineNumber===u.endLineNumber){const h=c.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(s,h,u.startLineNumber,u.startColumn-1,r,o,t,i),o}const l=c.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(s,l,u.startLineNumber,u.startColumn-1,r,o,t,i);for(let h=u.startLineNumber+1;h<u.endLineNumber&&r<i;h++)r=this._findMatchesInLine(s,c.getLineContent(h),h,0,r,o,t,i);if(r<i){const h=c.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(s,h,u.endLineNumber,0,r,o,t,i)}return o}static _findMatchesInLine(c,u,s,t,i,o,r,l){const h=c.wordSeparators;if(!r&&c.simpleSearch){const d=c.simpleSearch,f=d.length,I=u.length;let L=-f;for(;(L=u.indexOf(d,L+f))!==-1;)if((!h||S(h,u,I,L,f))&&(o[i++]=new C.FindMatch(new P.Range(s,L+1+t,s,L+1+f+t),null),i>=l))return i;return i}const g=new v(c.wordSeparators,c.regex);let w;g.reset(0);do if(w=g.next(u),w&&(o[i++]=k(new P.Range(s,w.index+1+t,s,w.index+1+w[0].length+t),w,r),i>=l))return i;while(w);return i}static findNextMatch(c,u,s,t){const i=u.parseSearchRequest();if(!i)return null;const o=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(c,s,o,t):this._doFindNextMatchLineByLine(c,s,o,t)}static _doFindNextMatchMultiline(c,u,s,t){const i=new R.Position(u.lineNumber,1),o=c.getOffsetAt(i),r=c.getLineCount(),l=c.getValueInRange(new P.Range(i.lineNumber,i.column,r,c.getLineMaxColumn(r)),1),h=c.getEOL()===`\r
`?new b(l):null;s.reset(u.column-1);let g=s.next(l);return g?k(this._getMultilineMatchRange(c,o,l,h,g.index,g[0]),g,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(c,new R.Position(1,1),s,t):null}static _doFindNextMatchLineByLine(c,u,s,t){const i=c.getLineCount(),o=u.lineNumber,r=c.getLineContent(o),l=this._findFirstMatchInLine(s,r,o,u.column,t);if(l)return l;for(let h=1;h<=i;h++){const g=(o+h-1)%i,w=c.getLineContent(g+1),d=this._findFirstMatchInLine(s,w,g+1,1,t);if(d)return d}return null}static _findFirstMatchInLine(c,u,s,t,i){c.reset(t-1);const o=c.next(u);return o?k(new P.Range(s,o.index+1,s,o.index+1+o[0].length),o,i):null}static findPreviousMatch(c,u,s,t){const i=u.parseSearchRequest();if(!i)return null;const o=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(c,s,o,t):this._doFindPreviousMatchLineByLine(c,s,o,t)}static _doFindPreviousMatchMultiline(c,u,s,t){const i=this._doFindMatchesMultiline(c,new P.Range(1,1,u.lineNumber,u.column),s,t,10*A);if(i.length>0)return i[i.length-1];const o=c.getLineCount();return u.lineNumber!==o||u.column!==c.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(c,new R.Position(o,c.getLineMaxColumn(o)),s,t):null}static _doFindPreviousMatchLineByLine(c,u,s,t){const i=c.getLineCount(),o=u.lineNumber,r=c.getLineContent(o).substring(0,u.column-1),l=this._findLastMatchInLine(s,r,o,t);if(l)return l;for(let h=1;h<=i;h++){const g=(i+o-h-1)%i,w=c.getLineContent(g+1),d=this._findLastMatchInLine(s,w,g+1,t);if(d)return d}return null}static _findLastMatchInLine(c,u,s,t){let i=null,o;for(c.reset(0);o=c.next(u);)i=k(new P.Range(s,o.index+1,s,o.index+1+o[0].length),o,t);return i}}e.TextModelSearch=m;function a(_,c,u,s,t){if(s===0)return!0;const i=c.charCodeAt(s-1);if(_.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=c.charCodeAt(s);if(_.get(o)!==0)return!0}return!1}function p(_,c,u,s,t){if(s+t===u)return!0;const i=c.charCodeAt(s+t);if(_.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=c.charCodeAt(s+t-1);if(_.get(o)!==0)return!0}return!1}function S(_,c,u,s,t){return a(_,c,u,s,t)&&p(_,c,u,s,t)}e.isValidMatch=S;class v{constructor(c,u){this._wordSeparators=c,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const u=c.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(s=this._searchRegex.exec(c),!s))return null;const t=s.index,i=s[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){E.getNextCodePoint(c,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,c,u,t,i))return s}while(s);return null}}e.Searcher=v}),define(pe[105],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(A=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)A.indexOf(n)>=0||(D+="\\"+n);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=E();function y(A){let D=e.DEFAULT_WORD_REGEXP;if(A&&A instanceof RegExp)if(A.global)D=A;else{let n="g";A.ignoreCase&&(n+="i"),A.multiline&&(n+="m"),A.unicode&&(n+="u"),D=new RegExp(A.source,n)}return D.lastIndex=0,D}e.ensureValidWordDefinition=y;const R={maxLen:1e3,windowSize:15,timeBudget:150};function P(A,D,n,T,k=R){if(n.length>k.maxLen){let S=A-k.maxLen/2;return S<0?S=0:T+=S,n=n.substring(S,A+k.maxLen/2),P(A,D,n,T,k)}const b=Date.now(),m=A-1-T;let a=-1,p=null;for(let S=1;!(Date.now()-b>=k.timeBudget);S++){const v=m-k.windowSize*S;D.lastIndex=Math.max(0,v);const _=C(D,n,m,a);if(!_&&p||(p=_,v<=0))break;a=v}if(p){let S={word:p[0],startColumn:T+1+p.index,endColumn:T+1+p.index+p[0].length};return D.lastIndex=0,S}return null}e.getWordAtText=P;function C(A,D,n,T){let k;for(;k=A.exec(D);){const b=k.index||0;if(b<=n&&A.lastIndex>=n)return k;if(T>0&&b>T)return null}return null}}),define(pe[140],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class y{constructor(A){if(this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let D=0,n=A.notIn.length;D<n;D++)switch(A.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}}e.StandardAutoClosingPairConditional=y;class R{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of A)P(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),P(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),P(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),P(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&P(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=R;function P(C,A,D){C.has(A)?C.get(A).push(D):C.set(A,[D])}}),define(pe[76],ve([0,1,34,8]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(P,C,A,D){if(Array.isArray(P)){let n=0;for(const T of P){const k=R(T,C,A,D);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof P=="string")return D?P==="*"?5:P===A?10:0:0;if(P){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:b}=P;if(!D&&!b)return 0;let m=0;if(k)if(k===C.scheme)m=10;else if(k==="*")m=5;else return 0;if(n)if(n===A)m=10;else if(n==="*")m=Math.max(m,5);else return 0;if(T){let a;if(typeof T=="string"?a=T:a=Object.assign(Object.assign({},T),{base:(0,y.normalize)(T.base)}),a===C.fsPath||(0,E.match)(a,C.fsPath))m=10;else return 0}return m}else return 0}}e.score=R}),define(pe[141],ve([0,1,103]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var y;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(y=e.State||(e.State={}));class R{constructor(a,p,S){const v=new Uint8Array(a*p);for(let _=0,c=a*p;_<c;_++)v[_]=S;this._data=v,this.rows=a,this.cols=p}get(a,p){return this._data[a*this.cols+p]}set(a,p,S){this._data[a*this.cols+p]=S}}e.Uint8Matrix=R;class P{constructor(a){let p=0,S=0;for(let _=0,c=a.length;_<c;_++){let[u,s,t]=a[_];s>p&&(p=s),u>S&&(S=u),t>S&&(S=t)}p++,S++;let v=new R(S,p,0);for(let _=0,c=a.length;_<c;_++){let[u,s,t]=a[_];v.set(u,s,t)}this._states=v,this._maxCharCode=p}nextState(a,p){return p<0||p>=this._maxCharCode?0:this._states.get(a,p)}}e.StateMachine=P;let C=null;function A(){return C===null&&(C=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var D;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let n=null;function T(){if(n===null){n=new E.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<m.length;p++)n.set(m.charCodeAt(p),1);const a=".,;";for(let p=0;p<a.length;p++)n.set(a.charCodeAt(p),2)}return n}class k{static _createLink(a,p,S,v,_){let c=_-1;do{const u=p.charCodeAt(c);if(a.get(u)!==2)break;c--}while(c>v);if(v>0){const u=p.charCodeAt(v-1),s=p.charCodeAt(c);(u===40&&s===41||u===91&&s===93||u===123&&s===125)&&c--}return{range:{startLineNumber:S,startColumn:v+1,endLineNumber:S,endColumn:c+2},url:p.substring(v,c+1)}}static computeLinks(a,p=A()){const S=T();let v=[];for(let _=1,c=a.getLineCount();_<=c;_++){const u=a.getLineContent(_),s=u.length;let t=0,i=0,o=0,r=1,l=!1,h=!1,g=!1,w=!1;for(;t<s;){let d=!1;const f=u.charCodeAt(t);if(r===13){let I;switch(f){case 40:l=!0,I=0;break;case 41:I=l?0:1;break;case 91:g=!0,h=!0,I=0;break;case 93:g=!1,I=h?0:1;break;case 123:w=!0,I=0;break;case 125:I=w?0:1;break;case 39:I=o===34||o===96?0:1;break;case 34:I=o===39||o===96?0:1;break;case 96:I=o===39||o===34?0:1;break;case 42:I=o===42?1:0;break;case 124:I=o===124?1:0;break;case 32:I=g?0:1;break;default:I=S.get(f)}I===1&&(v.push(k._createLink(S,u,_,i,t)),d=!0)}else if(r===12){let I;f===91?(h=!0,I=0):I=S.get(f),I===1?d=!0:r=13}else r=p.nextState(r,f),r===0&&(d=!0);d&&(r=1,l=!1,h=!1,w=!1,i=t+1,o=f),t++}r===13&&v.push(k._createLink(S,u,_,i,s))}return v}}e.LinkComputer=k;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:k.computeLinks(m)}e.computeLinks=b}),define(pe[142],ve([0,1,3,6]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,A){return this._map.set(C,A),this.fire([C]),(0,y.toDisposable)(()=>{this._map.get(C)===A&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,A){let D=null,n=!1;return this._promises.set(C,A.then(T=>{this._promises.delete(C),!(n||!T)&&(D=this.register(C,T))})),(0,y.toDisposable)(()=>{n=!0,D&&D.dispose()})}getPromise(C){const A=this.get(C);if(A)return Promise.resolve(A);const D=this._promises.get(C);return D?D.then(n=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(pe[106],ve([0,1,25,9]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function P(k){for(let b=0,m=k.length;b<m;b+=4){const a=k[b+0],p=k[b+1],S=k[b+2],v=k[b+3];k[b+0]=v,k[b+1]=S,k[b+2]=p,k[b+3]=a}}function C(k){const b=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return y.isLittleEndian()||P(b),E.VSBuffer.wrap(b)}function A(k){const b=k.buffer;if(y.isLittleEndian()||P(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const m=new Uint8Array(b.byteLength);return m.set(b),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(k){const b=new Uint32Array(n(k));let m=0;if(b[m++]=k.id,k.type==="full")b[m++]=1,b[m++]=k.data.length,b.set(k.data,m),m+=k.data.length;else{b[m++]=2,b[m++]=k.deltas.length;for(const a of k.deltas)b[m++]=a.start,b[m++]=a.deleteCount,a.data?(b[m++]=a.data.length,b.set(a.data,m),m+=a.data.length):b[m++]=0}return C(b)}e.encodeSemanticTokensDto=D;function n(k){let b=0;if(b+=1+1,k.type==="full")b+=1+k.data.length;else{b+=1,b+=(1+1+1)*k.deltas.length;for(const m of k.deltas)m.data&&(b+=m.data.length)}return b}function T(k){const b=A(k);let m=0;const a=b[m++];if(b[m++]===1){const _=b[m++],c=b.subarray(m,m+_);return m+=_,{id:a,type:"full",data:c}}const S=b[m++];let v=[];for(let _=0;_<S;_++){const c=b[m++],u=b[m++],s=b[m++];let t;s>0&&(t=b.subarray(m,m+s),m+=s),v[_]={start:c,deleteCount:u,data:t}}return{id:a,type:"delta",deltas:v}}e.decodeSemanticTokensDto=T}),define(pe[107],ve([0,1,92]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class y{constructor(C,A){this.index=C,this.remainder=A}}e.PrefixSumIndexOfResult=y;class R{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,A){C=(0,E.toUint32)(C);const D=this.values,n=this.prefixSum,T=A.length;return T===0?!1:(this.values=new Uint32Array(D.length+T),this.values.set(D.subarray(0,C),0),this.values.set(D.subarray(C),C+T),this.values.set(A,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,A){return C=(0,E.toUint32)(C),A=(0,E.toUint32)(A),this.values[C]===A?!1:(this.values[C]=A,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,A){C=(0,E.toUint32)(C),A=(0,E.toUint32)(A);const D=this.values,n=this.prefixSum;if(C>=D.length)return!1;let T=D.length-C;return A>=T&&(A=T),A===0?!1:(this.values=new Uint32Array(D.length-A),this.values.set(D.subarray(0,C),0),this.values.set(D.subarray(C+A),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(C){return C<0?0:(C=(0,E.toUint32)(C),this._getAccumulatedValue(C))}_getAccumulatedValue(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),C>=this.values.length&&(C=this.values.length-1);for(let D=A;D<=C;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalValue();let A=0,D=this.values.length-1,n=0,T=0,k=0;for(;A<=D;)if(n=A+(D-A)/2|0,T=this.prefixSum[n],k=T-this.values[n],C<k)D=n-1;else if(C>=T)A=n+1;else break;return new y(n,C-k)}}e.PrefixSumComputer=R}),define(pe[143],ve([0,1,10,49,107]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(A,D,n,T){this._uri=A,this._lines=D,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(A){A.eol&&A.eol!==this._eol&&(this._eol=A.eol,this._lineStarts=null);const D=A.changes;for(const n of D)this._acceptDeleteRange(n.range),this._acceptInsertText(new y.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=A.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const A=this._eol.length,D=this._lines.length,n=new Uint32Array(D);for(let T=0;T<D;T++)n[T]=this._lines[T].length+A;this._lineStarts=new R.PrefixSumComputer(n)}}_setLineText(A,D){this._lines[A]=D,this._lineStarts&&this._lineStarts.changeValue(A,this._lines[A].length+this._eol.length)}_acceptDeleteRange(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.startLineNumber-1].substring(A.endColumn-1));return}this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.endLineNumber-1].substring(A.endColumn-1)),this._lines.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}_acceptInsertText(A,D){if(D.length!==0){let n=(0,E.splitLines)(D);if(n.length===1){this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+n[0]+this._lines[A.lineNumber-1].substring(A.column-1));return}n[n.length-1]+=this._lines[A.lineNumber-1].substring(A.column-1),this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(A.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(A.lineNumber,T)}}}e.MirrorTextModel=P}),define(pe[144],ve([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(pe[145],ve([0,1,144]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const y=60,R=y*60,P=R*24,C=P*7,A=P*30,D=P*365;function n(k,b){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,E.localize)(0,null,n(new Date().getTime()+m*1e3,!1));if(m<30)return(0,E.localize)(1,null);let a;return m<y?(a=m,b?a===1?(0,E.localize)(2,null,a):(0,E.localize)(3,null,a):a===1?(0,E.localize)(4,null,a):(0,E.localize)(5,null,a)):m<R?(a=Math.floor(m/y),b?a===1?(0,E.localize)(6,null,a):(0,E.localize)(7,null,a):a===1?(0,E.localize)(8,null,a):(0,E.localize)(9,null,a)):m<P?(a=Math.floor(m/R),b?a===1?(0,E.localize)(10,null,a):(0,E.localize)(11,null,a):a===1?(0,E.localize)(12,null,a):(0,E.localize)(13,null,a)):m<C?(a=Math.floor(m/P),b?a===1?(0,E.localize)(14,null,a):(0,E.localize)(15,null,a):a===1?(0,E.localize)(16,null,a):(0,E.localize)(17,null,a)):m<A?(a=Math.floor(m/C),b?a===1?(0,E.localize)(18,null,a):(0,E.localize)(19,null,a):a===1?(0,E.localize)(20,null,a):(0,E.localize)(21,null,a)):m<D?(a=Math.floor(m/A),b?a===1?(0,E.localize)(22,null,a):(0,E.localize)(23,null,a):a===1?(0,E.localize)(24,null,a):(0,E.localize)(25,null,a)):(a=Math.floor(m/D),b?a===1?(0,E.localize)(26,null,a):(0,E.localize)(27,null,a):a===1?(0,E.localize)(28,null,a):(0,E.localize)(29,null,a))}e.fromNow=n;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(pe[146],ve([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(pe[58],ve([0,1,146,15,14]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,T){return T&&(n.stack||n.stacktrace)?E.localize(0,null,A(n),C(n.stack)||C(n.stacktrace)):A(n)}function C(n){return Array.isArray(n)?n.join(`
`):n}function A(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function D(n=null,T=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const k=R.coalesce(n),b=D(k[0],T);return k.length>1?E.localize(4,null,b,k.length):b}if(y.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return P(k.error,T);if(k.exception)return P(k.exception,T)}return n.stack?P(n,T):n.message?n.message:E.localize(5,null)}e.toErrorMessage=D}),define(pe[147],ve([18,19]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(pe[77],ve([0,1,8,37,26,38,147,30,15,22,31,9,136,11]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(s,t){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const o=P.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{o.once("error",l=>{r({success:!1,error:l})}),o.once("exit",(l,h)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?a(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(o=>{P.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,l,h)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function S(s=A.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,i,o,r){if(i!==void 0&&o!==void 0&&r!==void 0)this.cmd=t,this.args=i,this.shell=o,this.options=r;else{const l=t;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(A.env).forEach(h=>{l[h]=A.env[h]}),Object.keys(this.options.env).forEach(h=>{l[h]=this.options.env[h]}),this.options.env=l}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(E.sep);return i!==-1&&(t=t.substring(i+1)),v.WellKnowCommands[t]?t:"other"}start(t){return k.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(A.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(i=>{let o,r;const l=new Promise((h,g)=>{o=h,r=g});if(i){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=P.exec(h,this.options,(g,w,d)=>{this.childProcess=null;const f=g;f&&f.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:d.toString()}):this.handleExec(o,t,g,w,d)})}else{let h=null;const g=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,o,t,r);const d={terminated:this.terminateRequested};D.isNumber(w)&&(d.cmdCode=w),o(d)};if(this.shell&&k.isWindows){const w=n.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let d=!1,f=!1;const I=[];let L=this.ensureQuotes(this.cmd);I.push(L.value),d=L.quoted,this.args&&this.args.forEach(ee=>{L=this.ensureQuotes(ee),I.push(L.value),f=f&&L.quoted});const B=["/s","/c"];d?f?B.push('"'+I.join(" ")+'"'):I.length>1?B.push('"'+I[0]+'" '+I.slice(1).join(" ")):B.push('"'+I[0]+'"'):B.push(I.join(" ")),h=P.spawn(S(),B,w)}else this.cmd&&(h=P.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(D.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),h.pid&&(this.childProcess.on("close",g),this.handleSpawn(h,o,t,r,!0)))}return l})}handleClose(t,i,o,r){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!k.isWindows)return t(!1);const i=P.spawn(S(),["/s","/c"]);i.on("error",o=>t(!0)),i.on("exit",o=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class _ extends v{constructor(t,i,o,r){super(t,i,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,o,r,l){[r,l].forEach((h,g)=>{const w=new b.LineDecoder;w.write(h).forEach(I=>{i({line:I,source:g===0?0:1})});const f=w.end();f&&i({line:f,source:g===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,i,o,r,l){const h=new b.LineDecoder,g=new b.LineDecoder;t.stdout.on("data",w=>{h.write(w).forEach(f=>o({line:f,source:0}))}),t.stderr.on("data",w=>{g.write(w).forEach(f=>o({line:f,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=g}handleClose(t,i,o,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&o({line:l,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&o({line:h,source:1})}}e.LineProcess=_;function c(s){let t=[],i=!1;const o=function(r){if(i){t.push(r);return}(!s.send(r,h=>{if(h&&console.error(h),i=!1,t.length>0){const g=t.slice(0);t=[],g.forEach(w=>o(w))}})||k.isWindows)&&(i=!0)};return{send:o}}e.createQueuedSender=c;var u;(function(s){async function t(i,o,r){if(E.isAbsolute(i))return i;if(o===void 0&&(o=A.cwd()),E.dirname(i)!=="."||(r===void 0&&D.isString(A.env.PATH)&&(r=A.env.PATH.split(E.delimiter)),r===void 0||r.length===0))return E.join(o,i);async function h(g){return await R.exists(g)?!(await y.promises.stat(g)).isDirectory():!1}for(let g of r){let w;if(E.isAbsolute(g)?w=E.join(g,i):w=E.join(o,g,i),await h(w))return w;let d=w+".com";if(await h(d)||(d=w+".exe",await h(d)))return d}return E.join(o,i)}s.findExecutable=t})(u=e.win32||(e.win32={}))}),define(pe[148],ve([0,1,48,9,100,77]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(m,a){return m===3?y.isWindows?k():P.getWindowsShell(a):n(m,a)}e.getSystemShell=C;function A(m,a){return m===3?y.isWindows?b(a):P.getWindowsShell(a):n(m,a)}e.getSystemShellSync=A;let D=null;function n(m,a){if(y.isLinux&&m===1||y.isMacintosh&&m===2)return"/bin/bash";if(!D){let p;if(y.isWindows)p="/bin/bash";else{if(p=a.SHELL,!p)try{p=E.userInfo().shell}catch(S){}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}D=p}return D}let T=null;async function k(){return T||(T=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),T}function b(m){if(T)return T;const a=y.isWindows&&parseFloat(E.release())>=10,p=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${m.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:P.getWindowsShell(m)}}),define(pe[149],ve([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(pe[150],ve([0,1,149,9,105]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=C;class A{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Ee){this._values[ie]=Ee}}e.ValidatedEditorOptions=A;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class n{constructor(ie,Ee,Ne,ze){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=ze}compute(ie,Ee,Ne){return Ne}}class T{constructor(ie,Ee=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ie){return this.defaultValue}}class k{constructor(ie,Ee,Ne,ze){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Ee,Ne){return Ne}}function b(G,ie){return typeof G=="undefined"?ie:G==="false"?!1:Boolean(G)}e.boolean=b;class m extends k{constructor(ie,Ee,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,Ee,Ne,ze)}validate(ie){return b(ie,this.defaultValue)}}class a extends k{constructor(ie,Ee,Ne,ze,We,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Ne,et.minimum=ze,et.maximum=We),super(ie,Ee,Ne,et),this.minimum=ze,this.maximum=We}static clampedInt(ie,Ee,Ne,ze){if(typeof ie=="undefined")return Ee;let We=parseInt(ie,10);return isNaN(We)?Ee:(We=Math.max(Ne,We),We=Math.min(ze,We),We|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class p extends k{constructor(ie,Ee,Ne,ze,We){typeof We!="undefined"&&(We.type="number",We.default=Ne),super(ie,Ee,Ne,We),this.validationFn=ze}static clamp(ie,Ee,Ne){return ie<Ee?Ee:ie>Ne?Ne:ie}static float(ie,Ee){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Ee;const Ne=parseFloat(ie);return isNaN(Ne)?Ee:Ne}validate(ie){return this.validationFn(p.float(ie,this.defaultValue))}}class S extends k{static string(ie,Ee){return typeof ie!="string"?Ee:ie}constructor(ie,Ee,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,Ee,Ne,ze)}validate(ie){return S.string(ie,this.defaultValue)}}function v(G,ie,Ee){return typeof G!="string"||Ee.indexOf(G)===-1?ie:G}e.stringSet=v;class _ extends k{constructor(ie,Ee,Ne,ze,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=ze,We.default=Ne),super(ie,Ee,Ne,We),this._allowedValues=ze}validate(ie){return v(ie,this.defaultValue,this._allowedValues)}}class c extends n{constructor(ie,Ee,Ne,ze,We,et,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=We,K.default=ze),super(ie,Ee,Ne,K),this._allowedValues=We,this._convert=et}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function u(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ee,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends n{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:E.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertSpace:b(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(G){switch(G){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function h(G){switch(G){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class g extends T{constructor(){super(123,[62,31])}compute(ie,Ee,Ne){const ze=["monaco-editor"];return Ee.get(31)&&ze.push(Ee.get(31)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),Ee.get(62)==="default"?ze.push("mouse-default"):Ee.get(62)==="copy"&&ze.push("mouse-copy"),Ee.get(97)&&ze.push("showUnused"),Ee.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class w extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(ie,Ee,Ne){return Ne&&ie.emptySelectionClipboard}}class d extends n{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:E.localize(13,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:E.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{cursorMoveOnType:b(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":v(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ee.loop,this.defaultValue.loop)}}}class f extends n{constructor(){super(41,"fontLigatures",f.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?f.OFF:ie==="true"?f.ON:ie:Boolean(ie)?f.ON:f.OFF}}e.EditorFontLigatures=f,f.OFF='"liga" off, "calt" off',f.ON='"liga" on, "calt" on';class I extends T{constructor(){super(40)}compute(ie,Ee,Ne){return ie.fontInfo}}class L extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(ie){let Ee=p.float(ie,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(Ee,6,100)}compute(ie,Ee,Ne){return ie.fontInfo.fontSize}}class B extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class ee extends n{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(ie){var Ee,Ne,ze,We,et;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:v(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=K.multipleDefinitions)!==null&&Ee!==void 0?Ee:v(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:v(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:v(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=K.multipleImplementations)!==null&&We!==void 0?We:v(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(et=K.multipleReferences)!==null&&et!==void 0?et:v(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends n{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:E.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:b(Ee.enabled,this.defaultValue.enabled),delay:a.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:b(Ee.sticky,this.defaultValue.sticky)}}}var x;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,Ee,Ne){return $.computeLayout(Ee,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Ee=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?Ee-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),We=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:We}}static _computeMinimapLayout(ie,Ee){const Ne=ie.outerWidth,ze=ie.outerHeight,We=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const et=Ee.stableMinimapLayoutInput,K=et&&ie.outerHeight===et.outerHeight&&ie.lineHeight===et.lineHeight&&ie.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&ie.pixelRatio===et.pixelRatio&&ie.scrollBeyondLastLine===et.scrollBeyondLastLine&&ie.minimap.enabled===et.minimap.enabled&&ie.minimap.side===et.minimap.side&&ie.minimap.size===et.minimap.size&&ie.minimap.showSlider===et.minimap.showSlider&&ie.minimap.renderCharacters===et.minimap.renderCharacters&&ie.minimap.maxColumn===et.minimap.maxColumn&&ie.minimap.scale===et.minimap.scale&&ie.verticalScrollbarWidth===et.verticalScrollbarWidth&&ie.isViewportWrapping===et.isViewportWrapping,se=ie.lineHeight,he=ie.typicalHalfwidthCharacterWidth,Y=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let le=We>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ge=ie.minimap.maxColumn,be=ie.minimap.size,He=ie.minimap.side,$e=ie.verticalScrollbarWidth,qe=ie.viewLineCount,Xe=ie.remainingWidth,Ze=ie.isViewportWrapping,ut=ne?2:3;let ot=Math.floor(We*ze);const nt=ot/We;let ce=!1,Ce=!1,ue=ut*le,X=le/We,Re=1;if(be==="fill"||be==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:st,desiredRatio:gt,minimapLineCount:Et}=$.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:Y,height:ze,lineHeight:se,pixelRatio:We});if(qe/Et>1)ce=!0,Ce=!0,le=1,ue=1,X=le/We;else{let wt=!1,St=le+1;if(be==="fit"){const pt=Math.ceil((qe+st)*ue);Ze&&K&&Xe<=Ee.stableFitRemainingWidth?(wt=!0,St=Ee.stableFitMaxMinimapScale):(wt=pt>ot,Ze&&wt?(Ee.stableMinimapLayoutInput=ie,Ee.stableFitRemainingWidth=Xe):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(be==="fill"||wt){ce=!0;const pt=le;ue=Math.min(se*We,Math.max(1,Math.floor(1/gt))),le=Math.min(St,Math.max(1,Math.floor(ue/ut))),le>pt&&(Re=Math.min(2,le/pt)),X=le/We/Re,ot=Math.ceil(Math.max(ct,qe+st)*ue),Ze&&wt&&(Ee.stableFitMaxMinimapScale=le)}}}const Le=Math.floor(ge*X),Ye=Math.min(Le,Math.max(0,Math.floor((Xe-$e-2)*X/(he+X)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(We*Ye);const rt=Ge/We;Ge=Math.floor(Ge*Re);const at=ne?1:2,Qe=He==="left"?0:Ne-Ye-$e;return{renderMinimap:at,minimapLeft:Qe,minimapWidth:Ye,minimapHeightIsEditorHeight:ce,minimapIsSampling:Ce,minimapScale:le,minimapLineHeight:ue,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:nt}}static computeLayout(ie,Ee){const Ne=Ee.outerWidth|0,ze=Ee.outerHeight|0,We=Ee.lineHeight|0,et=Ee.lineNumbersDigitCount|0,K=Ee.typicalHalfwidthCharacterWidth,se=Ee.maxDigitWidth,he=Ee.pixelRatio,Y=Ee.viewLineCount,ne=ie.get(118),le=ne==="inherit"?ie.get(117):ne,ge=le==="inherit"?ie.get(113):le,be=ie.get(116),He=ie.get(2),$e=Ee.isDominatedByLongLines,qe=ie.get(46),Xe=ie.get(56).renderType!==0,Ze=ie.get(57),ut=ie.get(91),ot=ie.get(61),nt=ie.get(89),ce=nt.verticalScrollbarSize,Ce=nt.verticalHasArrows,ue=nt.arrowSize,X=nt.horizontalScrollbarSize,Re=ie.get(54),Le=ie.get(35);let Ye;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const ft=parseFloat(Re.substr(0,Re.length-2));Ye=a.clampedInt(ft*K,0,0,1e3)}else Ye=a.clampedInt(Re,0,0,1e3);Le&&(Ye+=16);let Ge=0;if(Xe){const ft=Math.max(et,Ze);Ge=Math.round(ft*se)}let rt=0;qe&&(rt=We);let at=0,Qe=at+rt,ct=Qe+Ge,st=ct+Ye;const gt=Ne-rt-Ge-Ye;let Et=!1,Ct=!1,wt=-1;He!==2&&(le==="inherit"&&$e?(Et=!0,Ct=!0):ge==="on"||ge==="bounded"?Ct=!0:ge==="wordWrapColumn"&&(wt=be));const St=$._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:We,typicalHalfwidthCharacterWidth:K,pixelRatio:he,scrollBeyondLastLine:ut,minimap:ot,verticalScrollbarWidth:ce,viewLineCount:Y,remainingWidth:gt,isViewportWrapping:Ct},Ee.memory||new D);St.renderMinimap!==0&&St.minimapLeft===0&&(at+=St.minimapWidth,Qe+=St.minimapWidth,ct+=St.minimapWidth,st+=St.minimapWidth);const pt=gt-St.minimapWidth,Ft=Math.max(1,Math.floor((pt-ce-2)/K)),Mt=Ce?ue:0;return Ct&&(wt=Math.max(1,Ft),ge==="bounded"&&(wt=Math.min(wt,be))),{width:Ne,height:ze,glyphMarginLeft:at,glyphMarginWidth:rt,lineNumbersLeft:Qe,lineNumbersWidth:Ge,decorationsLeft:ct,decorationsWidth:Ye,contentLeft:st,contentWidth:pt,minimap:St,viewportColumn:Ft,isWordWrapMinified:Et,isViewportWrapping:Ct,wrappingColumn:wt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:X,overviewRuler:{top:Mt,width:ce,height:ze-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=$;class F extends n{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:E.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:b(ie.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:E.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:b(Ee.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class M extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(ie,Ee,Ne){return ie.fontInfo.lineHeight}}class N extends n{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:ie.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:E.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:b(Ee.enabled,this.defaultValue.enabled),size:v(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(Ee.side,this.defaultValue.side,["right","left"]),showSlider:v(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(Ee.scale,1,1,3),maxColumn:a.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(G){return G==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{top:a.clampedInt(Ee.top,0,0,1e3),bottom:a.clampedInt(Ee.bottom,0,0,1e3)}}}class q extends n{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:E.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:b(Ee.enabled,this.defaultValue.enabled),cycle:b(Ee.cycle,this.defaultValue.cycle)}}}class Q extends T{constructor(){super(124)}compute(ie,Ee,Ne){return ie.pixelRatio}}class me extends n{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:E.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:E.localize(59,null)},other:{type:"boolean",default:ie.other,description:E.localize(60,null)}}}],default:ie,description:E.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Ee=ie,Ne={other:b(Ee.other,this.defaultValue.other),comments:b(Ee.comments,this.defaultValue.comments),strings:b(Ee.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var we;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(ie){let Ee=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Ee=4,Ne=ie):ie==="interval"?Ee=3:ie==="relative"?Ee=2:ie==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ne}}}function Ie(G){const ie=G.get(84);return ie==="editable"?G.get(77):ie!=="on"}e.filterValidationDecorations=Ie;class Me extends n{constructor(){const ie=[],Ee={type:"number",description:E.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:ie,description:E.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let Ee=[];for(let Ne of ie)if(typeof Ne=="number")Ee.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;Ee.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ee.sort((Ne,ze)=>Ne.column-ze.column),Ee}return this.defaultValue}}function z(G,ie){if(typeof G!="string")return ie;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie,Ne=a.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(Ee.vertical,this.defaultValue.vertical),horizontal:z(Ee.horizontal,this.defaultValue.horizontal),useShadows:b(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(Ee.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(Ee.verticalSliderSize,ze,0,1e3),scrollByPage:b(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:ie.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertMode:v(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ee.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:b(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ee.showMethods,this.defaultValue.showMethods),showFunctions:b(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ee.showConstructors,this.defaultValue.showConstructors),showFields:b(Ee.showFields,this.defaultValue.showFields),showVariables:b(Ee.showVariables,this.defaultValue.showVariables),showClasses:b(Ee.showClasses,this.defaultValue.showClasses),showStructs:b(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ee.showModules,this.defaultValue.showModules),showProperties:b(Ee.showProperties,this.defaultValue.showProperties),showEvents:b(Ee.showEvents,this.defaultValue.showEvents),showOperators:b(Ee.showOperators,this.defaultValue.showOperators),showUnits:b(Ee.showUnits,this.defaultValue.showUnits),showValues:b(Ee.showValues,this.defaultValue.showValues),showConstants:b(Ee.showConstants,this.defaultValue.showConstants),showEnums:b(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ee.showKeywords,this.defaultValue.showKeywords),showWords:b(Ee.showWords,this.defaultValue.showWords),showColors:b(Ee.showColors,this.defaultValue.showColors),showFiles:b(Ee.showFiles,this.defaultValue.showFiles),showReferences:b(Ee.showReferences,this.defaultValue.showReferences),showFolders:b(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ee.showUsers,this.defaultValue.showUsers),showIssues:b(Ee.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends T{constructor(){super(125,[77])}compute(ie,Ee,Ne){return Ee.get(77)?!0:ie.tabFocusMode}}var De;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class _e extends T{constructor(){super(127,[126])}compute(ie,Ee,Ne){const ze=Ee.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Te:y.isLinux?xe:ke,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(G){return e.editorOptionsRegistry[G.id]=G,G}var Ke;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.letterSpacing=52]="letterSpacing",G[G.lightbulb=53]="lightbulb",G[G.lineDecorationsWidth=54]="lineDecorationsWidth",G[G.lineHeight=55]="lineHeight",G[G.lineNumbers=56]="lineNumbers",G[G.lineNumbersMinChars=57]="lineNumbersMinChars",G[G.linkedEditing=58]="linkedEditing",G[G.links=59]="links",G[G.matchBrackets=60]="matchBrackets",G[G.minimap=61]="minimap",G[G.mouseStyle=62]="mouseStyle",G[G.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=64]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",G[G.multiCursorModifier=66]="multiCursorModifier",G[G.multiCursorPaste=67]="multiCursorPaste",G[G.occurrencesHighlight=68]="occurrencesHighlight",G[G.overviewRulerBorder=69]="overviewRulerBorder",G[G.overviewRulerLanes=70]="overviewRulerLanes",G[G.padding=71]="padding",G[G.parameterHints=72]="parameterHints",G[G.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",G[G.quickSuggestions=75]="quickSuggestions",G[G.quickSuggestionsDelay=76]="quickSuggestionsDelay",G[G.readOnly=77]="readOnly",G[G.renameOnType=78]="renameOnType",G[G.renderControlCharacters=79]="renderControlCharacters",G[G.renderIndentGuides=80]="renderIndentGuides",G[G.renderFinalNewline=81]="renderFinalNewline",G[G.renderLineHighlight=82]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=84]="renderValidationDecorations",G[G.renderWhitespace=85]="renderWhitespace",G[G.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",G[G.roundedSelection=87]="roundedSelection",G[G.rulers=88]="rulers",G[G.scrollbar=89]="scrollbar",G[G.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=91]="scrollBeyondLastLine",G[G.scrollPredominantAxis=92]="scrollPredominantAxis",G[G.selectionClipboard=93]="selectionClipboard",G[G.selectionHighlight=94]="selectionHighlight",G[G.selectOnLineNumbers=95]="selectOnLineNumbers",G[G.showFoldingControls=96]="showFoldingControls",G[G.showUnused=97]="showUnused",G[G.snippetSuggestions=98]="snippetSuggestions",G[G.smartSelect=99]="smartSelect",G[G.smoothScrolling=100]="smoothScrolling",G[G.stickyTabStops=101]="stickyTabStops",G[G.stopRenderingLineAfter=102]="stopRenderingLineAfter",G[G.suggest=103]="suggest",G[G.suggestFontSize=104]="suggestFontSize",G[G.suggestLineHeight=105]="suggestLineHeight",G[G.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",G[G.suggestSelection=107]="suggestSelection",G[G.tabCompletion=108]="tabCompletion",G[G.tabIndex=109]="tabIndex",G[G.unusualLineTerminators=110]="unusualLineTerminators",G[G.useTabStops=111]="useTabStops",G[G.wordSeparators=112]="wordSeparators",G[G.wordWrap=113]="wordWrap",G[G.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=116]="wordWrapColumn",G[G.wordWrapOverride1=117]="wordWrapOverride1",G[G.wordWrapOverride2=118]="wordWrapOverride2",G[G.wrappingIndent=119]="wrappingIndent",G[G.wrappingStrategy=120]="wrappingStrategy",G[G.showDeprecated=121]="showDeprecated",G[G.inlineHints=122]="inlineHints",G[G.editorClassName=123]="editorClassName",G[G.pixelRatio=124]="pixelRatio",G[G.tabFocusMode=125]="tabFocusMode",G[G.layoutInfo=126]="layoutInfo",G[G.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:Se(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:Se(new s),accessibilityPageSize:Se(new a(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null),deprecationMessage:E.localize(115,null)})),ariaLabel:Se(new S(4,"ariaLabel",E.localize(116,null))),autoClosingBrackets:Se(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(117,null),E.localize(118,null),""],description:E.localize(119,null)})),autoClosingDelete:Se(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(120,null),""],description:E.localize(121,null)})),autoClosingOvertype:Se(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(122,null),""],description:E.localize(123,null)})),autoClosingQuotes:Se(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(124,null),E.localize(125,null),""],description:E.localize(126,null)})),autoIndent:Se(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null),E.localize(131,null)],description:E.localize(132,null)})),automaticLayout:Se(new m(10,"automaticLayout",!1)),autoSurround:Se(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(133,null),E.localize(134,null),E.localize(135,null),""],description:E.localize(136,null)})),stickyTabStops:Se(new m(101,"stickyTabStops",!1,{description:E.localize(137,null)})),codeLens:Se(new m(12,"codeLens",!0,{description:E.localize(138,null)})),codeLensFontFamily:Se(new S(13,"codeLensFontFamily","",{description:E.localize(139,null)})),codeLensFontSize:Se(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(140,null)})),colorDecorators:Se(new m(15,"colorDecorators",!0,{description:E.localize(141,null)})),columnSelection:Se(new m(16,"columnSelection",!1,{description:E.localize(142,null)})),comments:Se(new t),contextmenu:Se(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new m(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(143,null)})),cursorBlinking:Se(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:E.localize(144,null)})),cursorSmoothCaretAnimation:Se(new m(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(145,null)})),cursorStyle:Se(new c(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:E.localize(146,null)})),cursorSurroundingLines:Se(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(147,null)})),cursorSurroundingLinesStyle:Se(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(148,null),E.localize(149,null)],description:E.localize(150,null)})),cursorWidth:Se(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(151,null)})),disableLayerHinting:Se(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new m(28,"domReadOnly",!1)),dragAndDrop:Se(new m(29,"dragAndDrop",!0,{description:E.localize(152,null)})),emptySelectionClipboard:Se(new w),extraEditorClassName:Se(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new p(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:E.localize(153,null)})),find:Se(new d),fixedOverflowWidgets:Se(new m(34,"fixedOverflowWidgets",!1)),folding:Se(new m(35,"folding",!0,{description:E.localize(154,null)})),foldingStrategy:Se(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(155,null),E.localize(156,null)],description:E.localize(157,null)})),foldingHighlight:Se(new m(37,"foldingHighlight",!0,{description:E.localize(158,null)})),unfoldOnClickAfterEndOfLine:Se(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(159,null)})),fontFamily:Se(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(160,null)})),fontInfo:Se(new I),fontLigatures2:Se(new f),fontSize:Se(new L),fontWeight:Se(new B),formatOnPaste:Se(new m(44,"formatOnPaste",!1,{description:E.localize(161,null)})),formatOnType:Se(new m(45,"formatOnType",!1,{description:E.localize(162,null)})),glyphMargin:Se(new m(46,"glyphMargin",!0,{description:E.localize(163,null)})),gotoLocation:Se(new ee),hideCursorInOverviewRuler:Se(new m(48,"hideCursorInOverviewRuler",!1,{description:E.localize(164,null)})),highlightActiveIndentGuide:Se(new m(49,"highlightActiveIndentGuide",!0,{description:E.localize(165,null)})),hover:Se(new H),inDiffEditor:Se(new m(51,"inDiffEditor",!1)),letterSpacing:Se(new p(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>p.clamp(G,-5,20),{description:E.localize(166,null)})),lightbulb:Se(new F),lineDecorationsWidth:Se(new k(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new m(58,"linkedEditing",!1,{description:E.localize(167,null)})),links:Se(new m(59,"links",!0,{description:E.localize(168,null)})),matchBrackets:Se(new _(60,"matchBrackets","always",["always","near","never"],{description:E.localize(169,null)})),minimap:Se(new N),mouseStyle:Se(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new p(63,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:E.localize(170,null)})),mouseWheelZoom:Se(new m(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(171,null)})),multiCursorMergeOverlapping:Se(new m(65,"multiCursorMergeOverlapping",!0,{description:E.localize(172,null)})),multiCursorModifier:Se(new c(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[E.localize(173,null),E.localize(174,null)],markdownDescription:E.localize(175,null)})),multiCursorPaste:Se(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(176,null),E.localize(177,null)],markdownDescription:E.localize(178,null)})),occurrencesHighlight:Se(new m(68,"occurrencesHighlight",!0,{description:E.localize(179,null)})),overviewRulerBorder:Se(new m(69,"overviewRulerBorder",!0,{description:E.localize(180,null)})),overviewRulerLanes:Se(new a(70,"overviewRulerLanes",3,0,3)),padding:Se(new V),parameterHints:Se(new q),peekWidgetDefaultFocus:Se(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(181,null),E.localize(182,null)],description:E.localize(183,null)})),definitionLinkOpensInPeek:Se(new m(74,"definitionLinkOpensInPeek",!1,{description:E.localize(184,null)})),quickSuggestions:Se(new me),quickSuggestionsDelay:Se(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(185,null)})),readOnly:Se(new m(77,"readOnly",!1)),renameOnType:Se(new m(78,"renameOnType",!1,{description:E.localize(186,null),markdownDeprecationMessage:E.localize(187,null)})),renderControlCharacters:Se(new m(79,"renderControlCharacters",!1,{description:E.localize(188,null)})),renderIndentGuides:Se(new m(80,"renderIndentGuides",!0,{description:E.localize(189,null)})),renderFinalNewline:Se(new m(81,"renderFinalNewline",!0,{description:E.localize(190,null)})),renderLineHighlight:Se(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(191,null)],description:E.localize(192,null)})),renderLineHighlightOnlyWhenFocus:Se(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(193,null)})),renderValidationDecorations:Se(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(194,null),E.localize(195,null),E.localize(196,null),""],description:E.localize(197,null)})),revealHorizontalRightPadding:Se(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new m(87,"roundedSelection",!0,{description:E.localize(198,null)})),rulers:Se(new Me),scrollbar:Se(new J),scrollBeyondLastColumn:Se(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(199,null)})),scrollBeyondLastLine:Se(new m(91,"scrollBeyondLastLine",!0,{description:E.localize(200,null)})),scrollPredominantAxis:Se(new m(92,"scrollPredominantAxis",!0,{description:E.localize(201,null)})),selectionClipboard:Se(new m(93,"selectionClipboard",!0,{description:E.localize(202,null),included:y.isLinux})),selectionHighlight:Se(new m(94,"selectionHighlight",!0,{description:E.localize(203,null)})),selectOnLineNumbers:Se(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(204,null),E.localize(205,null)],description:E.localize(206,null)})),showUnused:Se(new m(97,"showUnused",!0,{description:E.localize(207,null)})),showDeprecated:Se(new m(121,"showDeprecated",!0,{description:E.localize(208,null)})),inlineHints:Se(new U),snippetSuggestions:Se(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(209,null),E.localize(210,null),E.localize(211,null),E.localize(212,null)],description:E.localize(213,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new m(100,"smoothScrolling",!1,{description:E.localize(214,null)})),stopRenderingLineAfter:Se(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new te),suggestFontSize:Se(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestLineHeight:Se(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(216,null)})),suggestOnTriggerCharacters:Se(new m(106,"suggestOnTriggerCharacters",!0,{description:E.localize(217,null)})),suggestSelection:Se(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(218,null),E.localize(219,null),E.localize(220,null)],description:E.localize(221,null)})),tabCompletion:Se(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(222,null),E.localize(223,null),E.localize(224,null)],description:E.localize(225,null)})),tabIndex:Se(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(226,null),E.localize(227,null),E.localize(228,null)],description:E.localize(229,null)})),useTabStops:Se(new m(111,"useTabStops",!0,{description:E.localize(230,null)})),wordSeparators:Se(new S(112,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:E.localize(231,null)})),wordWrap:Se(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(232,null),E.localize(233,null),E.localize(234,null),E.localize(235,null)],description:E.localize(236,null)})),wordWrapBreakAfterCharacters:Se(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(237,null)})),wordWrapOverride1:Se(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new c(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[E.localize(238,null),E.localize(239,null),E.localize(240,null),E.localize(241,null)],description:E.localize(242,null)})),wrappingStrategy:Se(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(243,null),E.localize(244,null)],description:E.localize(245,null)})),editorClassName:Se(new g),pixelRatio:Se(new Q),tabFocusMode:Se(new fe),layoutInfo:Se(new $),wrappingInfo:Se(new _e)}}),define(pe[151],ve([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[152],ve([18,19]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[153],ve([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(pe[154],ve([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(pe[155],ve([18,19]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(pe[156],ve([18,19]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[157],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHost.api.impl",e)}),define(pe[158],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[159],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(pe[160],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[161],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[162],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[163],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[164],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[165],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[166],ve([18,19]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[167],ve([18,19]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(pe[168],ve([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[169],ve([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[170],ve([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(pe[171],ve([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[172],ve([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[173],ve([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[174],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(C){C[C.ACTIVATE=0]="ACTIVATE",C[C.RESTORE=1]="RESTORE",C[C.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var y;(function(C){C[C.PICK=1]="PICK",C[C.DISABLED=2]="DISABLED"})(y=e.EditorOverride||(e.EditorOverride={}));var R;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(R=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[108],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(P,C=[],A=!1){this.ctor=P,this.staticArguments=C,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E;const y=(R,...P)=>new E(R,P);e.createSyncDescriptor=y}),define(pe[78],ve([0,1,108]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const y=[];function R(C,A,D){A instanceof E.SyncDescriptor||(A=new E.SyncDescriptor(A,[],D)),y.push([C,A])}e.registerSingleton=R;function P(){return y}e.getSingletonServiceDescriptors=P}),define(pe[175],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=E;class y{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let C of this._nodes.values())C.outgoing.size===0&&P.push(C);return P}insertEdge(P,C){const A=this.lookupOrInsertNode(P),D=this.lookupOrInsertNode(C);A.outgoing.set(this._hashFn(C),D),D.incoming.set(this._hashFn(P),A)}removeNode(P){const C=this._hashFn(P);this._nodes.delete(C);for(let A of this._nodes.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(P){const C=this._hashFn(P);let A=this._nodes.get(C);return A||(A=new E(P),this._nodes.set(C,A)),A}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[C,A]of this._nodes)P.push(`${C}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=y}),define(pe[4],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function D(n){return n[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=D})(E=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function y(A,D,n,T){D[E.DI_TARGET]===D?D[E.DI_DEPENDENCIES].push({id:A,index:n,optional:T}):(D[E.DI_DEPENDENCIES]=[{id:A,index:n,optional:T}],D[E.DI_TARGET]=D)}function R(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const D=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(D,n,k,!1)};return D.toString=()=>A,E.serviceIds.set(A,D),D}e.createDecorator=R;function P(A){return A}e.refineServiceDecorator=P;function C(A){return function(D,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");y(A,D,T,!0)}}e.optional=C}),define(pe[176],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function y(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=y}),define(pe[177],ve([0,1,3,73,6,23,72,76,176]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(n):!!b.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(m,a){let p={selector:m,provider:a,_score:-1,_time:this._clock++};return this._entries.push(p),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,R.toDisposable)(()=>{if(p){let S=this._entries.indexOf(p);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const a=[];for(let p of this._entries)p._score>0&&a.push(p.provider);return a}ordered(m){const a=[];return this._orderedForEach(m,p=>a.push(p.provider)),a}orderedGroups(m){const a=[];let p,S;return this._orderedForEach(m,v=>{p&&S===v._score?p.push(v.provider):(S=v._score,p=[v.provider],a.push(p))}),a}_orderedForEach(m,a){if(!!m){this._updateScores(m);for(const p of this._entries)p._score>0&&a(p)}}_updateScores(m){let a={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let p of this._entries)if(p._score=(0,A.score)(p.selector,m.uri,m.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(m)),n(p.selector)&&p._score>0){for(let S of this._entries)S._score=0;p._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(m,a){return m._score<a._score?1:m._score>a._score?-1:m._time<a._time?1:m._time>a._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(m,a,p=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=a,this.max=p,this._cache=new P.LRUCache(50,.7)}_key(m){return m.id+(0,y.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const a=this._key(m),p=this._cache.get(a);return this._clamp(p==null?void 0:p.value)}update(m,a){const p=this._key(m);let S=this._cache.get(p);return S||(S=new C.MovingAverage,this._cache.set(p,S)),S.update(a),this.get(m)}}e.LanguageFeatureRequestDelays=k}),define(pe[79],ve([0,1,2,43,177,142,47]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var A;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));class D{constructor(f,I){this.language=f,this.id=I}}e.LanguageIdentifier=D;var n;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(f){return(f&255)>>>0}static getTokenType(f){return(f&1792)>>>8}static getFontStyle(f){return(f&14336)>>>11}static getForeground(f){return(f&8372224)>>>14}static getBackground(f){return(f&4286578688)>>>23}static getClassNameFromMetadata(f){let I=this.getForeground(f),L="mtk"+I,B=this.getFontStyle(f);return B&1&&(L+=" mtki"),B&2&&(L+=" mtkb"),B&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(f,I){const L=this.getForeground(f),B=this.getFontStyle(f);let ee=`color: ${I[L]};`;return B&1&&(ee+="font-style: italic;"),B&2&&(ee+="font-weight: bold;"),B&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var a;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(f){const I=d[f];let L=I&&C.iconRegistry.get(I);return L||(console.info("No codicon found for CompletionItemKind "+f),L=C.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(f,I){let L=d[f];return typeof L=="undefined"&&!I&&(L=9),L}}();var p;(function(d){d[d.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(d){return d&&E.URI.isUri(d.uri)&&y.Range.isIRange(d.range)&&(y.Range.isIRange(d.originSelectionRange)||y.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=s;var t;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(d){d[d.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var o;(function(d){const f=new Map;f.set("file",0),f.set("module",1),f.set("namespace",2),f.set("package",3),f.set("class",4),f.set("method",5),f.set("property",6),f.set("field",7),f.set("constructor",8),f.set("enum",9),f.set("interface",10),f.set("function",11),f.set("variable",12),f.set("constant",13),f.set("string",14),f.set("number",15),f.set("boolean",16),f.set("array",17),f.set("object",18),f.set("key",19),f.set("null",20),f.set("enum-member",21),f.set("struct",22),f.set("event",23),f.set("operator",24),f.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function L(H){return f.get(H)}d.fromString=L;function B(H){return I.get(H)}d.toString=B;function ee(H,x){const $=I.get(H);let F=$&&C.iconRegistry.get("symbol-"+$);return F||(console.info("No codicon found for SymbolKind "+H),F=C.Codicon.symbolProperty),`${x?"inline":"block"} ${F.classNames}`}d.toCssClassName=ee})(o=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(f){this.value=f}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var g;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(g=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var w;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[178],ve([0,1,6,15,4,3,55,71]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,R.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,n){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:D,handler:n})}if(D.description){const a=[];for(let S of D.description.args)a.push(S.constraint);const p=D.handler;D.handler=function(S,...v){return(0,y.validateConstraints)(v,a),p(S,...v)}}const{id:T}=D;let k=this._commands.get(T);k||(k=new C.LinkedList,this._commands.set(T,k));let b=k.unshift(D),m=(0,E.toDisposable)(()=>{b();const a=this._commands.get(T);(a==null?void 0:a.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),m}registerCommandAlias(D,n){return e.CommandsRegistry.registerCommand(D,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(D){const n=this._commands.get(D);if(!(!n||n.isEmpty()))return A.Iterable.first(n)}getCommands(){const D=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&D.set(n,T)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(pe[80],ve([0,1,10,4,9]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=R.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",R.isMacintosh),C.set("isLinux",R.isLinux),C.set("isWindows",R.isWindows),C.set("isWeb",R.isWeb),C.set("isMacNative",R.isMacintosh&&!R.isWeb),C.set("isEdge",P.indexOf("Edg/")>=0),C.set("isFirefox",P.indexOf("Firefox")>=0),C.set("isChrome",P.indexOf("Chrome")>=0),C.set("isSafari",P.indexOf("Safari")>=0),C.set("isIPad",P.indexOf("iPad")>=0);const A=Object.prototype.hasOwnProperty;var D;(function(d){d[d.False=0]="False",d[d.True=1]="True",d[d.Defined=2]="Defined",d[d.Not=3]="Not",d[d.Equals=4]="Equals",d[d.NotEquals=5]="NotEquals",d[d.And=6]="And",d[d.Regex=7]="Regex",d[d.NotRegex=8]="NotRegex",d[d.Or=9]="Or",d[d.In=10]="In",d[d.NotIn=11]="NotIn",d[d.Greater=12]="Greater",d[d.GreaterEquals=13]="GreaterEquals",d[d.Smaller=14]="Smaller",d[d.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return b.INSTANCE}static has(f){return m.create(f)}static equals(f,I){return a.create(f,I)}static notEquals(f,I){return v.create(f,I)}static regex(f,I){return i.create(f,I)}static in(f,I){return p.create(f,I)}static not(f){return _.create(f)}static and(...f){return r.create(f)}static or(...f){return l.create(f)}static greater(f,I){return c.create(f,I)}static less(f,I){return s.create(f,I)}static deserialize(f,I=!1){if(!!f)return this._deserializeOrExpression(f,I)}static _deserializeOrExpression(f,I){let L=f.split("||");return l.create(L.map(B=>this._deserializeAndExpression(B,I)))}static _deserializeAndExpression(f,I){let L=f.split("&&");return r.create(L.map(B=>this._deserializeOne(B,I)))}static _deserializeOne(f,I){if(f=f.trim(),f.indexOf("!=")>=0){let L=f.split("!=");return v.create(L[0].trim(),this._deserializeValue(L[1],I))}if(f.indexOf("==")>=0){let L=f.split("==");return a.create(L[0].trim(),this._deserializeValue(L[1],I))}if(f.indexOf("=~")>=0){let L=f.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],I))}if(f.indexOf(" in ")>=0){let L=f.split(" in ");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const L=f.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const L=f.split(">");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const L=f.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const L=f.split("<");return s.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(f)?_.create(f.substr(1).trim()):m.create(f)}static _deserializeValue(f,I){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let L=/^'([^']*)'$/.exec(f);return L?L[1].trim():f}static _deserializeRegexValue(f,I){if((0,E.isFalsyOrWhitespace)(f)){if(I)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=f.indexOf("/"),B=f.lastIndexOf("/");if(L===B||L<0){if(I)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let ee=f.slice(L+1,B),H=f[B+1]==="i"?"i":"";try{return new RegExp(ee,H)}catch(x){if(I)throw new Error(`bad regexp-value '${f}', parse error: ${x}`);return console.warn(`bad regexp-value '${f}', parse error: ${x}`),null}}}e.ContextKeyExpr=n;function T(d,f){return d.cmp(f)}class k{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class b{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class m{constructor(f){this.key=f,this.type=2}static create(f){const I=C.get(f);return typeof I=="boolean"?I?b.INSTANCE:k.INSTANCE:new m(f)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=m;class a{constructor(f,I){this.key=f,this.value=I,this.type=4}static create(f,I){if(typeof I=="boolean")return I?m.create(f):_.create(f);const L=C.get(f);return typeof L=="boolean"?I===(L?"true":"false")?b.INSTANCE:k.INSTANCE:new a(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class p{constructor(f,I){this.key=f,this.valueKey=I,this.type=10}static create(f,I){return new p(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const I=f.getValue(this.valueKey),L=f.getValue(this.key);return Array.isArray(I)?I.indexOf(L)>=0:typeof L=="string"&&typeof I=="object"&&I!==null?A.call(I,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=p;class S{constructor(f){this._actual=f,this.type=11}static create(f){return new S(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new S(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(f,I){this.key=f,this.value=I,this.type=5}static create(f,I){if(typeof I=="boolean")return I?_.create(f):m.create(f);const L=C.get(f);return typeof L=="boolean"?I===(L?"true":"false")?k.INSTANCE:b.INSTANCE:new v(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class _{constructor(f){this.key=f,this.type=3}static create(f){const I=C.get(f);return typeof I=="boolean"?I?k.INSTANCE:b.INSTANCE:new _(f)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=_;class c{constructor(f,I){this.key=f,this.value=I,this.type=12}static create(f,I){return new c(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class u{constructor(f,I){this.key=f,this.value=I,this.type=13}static create(f,I){return new u(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class s{constructor(f,I){this.key=f,this.value=I,this.type=14}static create(f,I){return new s(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(f,I){this.key=f,this.value=I,this.type=15}static create(f,I){return new t(f,I)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(f,I){this.key=f,this.regexp=I,this.type=7}static create(f,I){return new i(f,I)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const I=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return I<L?-1:I>L?1:0}equals(f){if(f.type===this.type){const I=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return this.key===f.key&&I===L}return!1}evaluate(f){let I=f.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=i;class o{constructor(f){this._actual=f,this.type=8}static create(f){return new o(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new o(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class r{constructor(f){this.expr=f,this.type=6}static create(f){return r._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let I=0,L=this.expr.length;I<L;I++){const B=T(this.expr[I],f.expr[I]);if(B!==0)return B}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].equals(f.expr[I]))return!1;return!0}return!1}evaluate(f){for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].evaluate(f))return!1;return!0}static _normalizeArr(f){const I=[];let L=!1;for(const B of f)if(!!B){if(B.type===1){L=!0;continue}if(B.type===0)return k.INSTANCE;if(B.type===6){I.push(...B.expr);continue}I.push(B)}if(I.length===0&&L)return b.INSTANCE;if(I.length!==0){if(I.length===1)return I[0];for(I.sort(T);I.length>1;){const B=I[I.length-1];if(B.type!==9)break;I.pop();const ee=I.pop(),H=l.create(B.expr.map(x=>r.create([x,ee])));H&&(I.push(H),I.sort(T))}return I.length===1?I[0]:new r(I)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let I of this.expr)f.push(...I.keys());return f}map(f){return new r(this.expr.map(I=>I.map(f)))}negate(){let f=[];for(let I of this.expr)f.push(I.negate());return l.create(f)}}e.ContextKeyAndExpr=r;class l{constructor(f){this.expr=f,this.type=9}static create(f){const I=l._normalizeArr(f);if(I.length!==0)return I.length===1?I[0]:new l(I)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let I=0,L=this.expr.length;I<L;I++){const B=T(this.expr[I],f.expr[I]);if(B!==0)return B}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let I=0,L=this.expr.length;I<L;I++)if(!this.expr[I].equals(f.expr[I]))return!1;return!0}return!1}evaluate(f){for(let I=0,L=this.expr.length;I<L;I++)if(this.expr[I].evaluate(f))return!0;return!1}static _normalizeArr(f){let I=[],L=!1;if(f){for(let B=0,ee=f.length;B<ee;B++){const H=f[B];if(!!H){if(H.type===0){L=!0;continue}if(H.type===1)return[b.INSTANCE];if(H.type===9){I=I.concat(H.expr);continue}I.push(H)}}if(I.length===0&&L)return[k.INSTANCE];I.sort(T)}return I}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let I of this.expr)f.push(...I.keys());return f}map(f){return new l(this.expr.map(I=>I.map(f)))}negate(){let f=[];for(let L of this.expr)f.push(L.negate());const I=L=>L.type===9?L.expr:[L];for(;f.length>1;){const L=f.shift(),B=f.shift(),ee=[];for(const H of I(L))for(const x of I(B))ee.push(n.and(H,x));f.unshift(n.or(...ee))}return f[0]}}e.ContextKeyOrExpr=l;class h extends m{constructor(f,I,L){super(f);this.key=f,this._defaultValue=I,typeof L=="object"?h._info.push(Object.assign(Object.assign({},L),{key:f})):L!==!0&&h._info.push({key:f,description:L,type:I!=null?typeof I:void 0})}static all(){return h._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(f){return n.equals(this.key,f)}notEqualsTo(f){return n.notEquals(this.key,f)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(d,f){return d<f?-1:d>f?1:0}function w(d,f,I,L){return d<I?-1:d>I?1:f<L?-1:f>L?1:0}}),define(pe[179],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[180],ve([0,1,152,4,11]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function P(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=P;var C;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var A;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(A=e.SortOrder||(e.SortOrder={}));var D;(function(k){k.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var n;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(b,m){super(b);this.code=m}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(pe[29],ve([0,1,10,4]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let b=typeof T=="string"?T:T.value,m=typeof k=="string"?k:k.value;return E.equalsIgnoreCase(b,m)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=C;function A(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function D(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,y.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[181],ve([0,1,10,29]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(m,a){return m.uuid&&a.uuid?m.uuid===a.uuid:m.id===a.id?!0:(0,E.compareIgnoreCase)(m.id,a.id)===0}e.areSameExtensions=R;class P{constructor(a,p){this.version=p,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof P?R(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=P;function C(m,a){return`${m}.${a}`}e.getExtensionId=C;function A(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function D(m,a){return A(C(m,a))}e.getGalleryExtensionId=D;function n(m,a){const p=[],S=v=>{for(const _ of p)if(_.some(c=>R(a(c),a(v))))return _;return null};for(const v of m){const _=S(v);_?_.push(v):p.push([v])}return p}e.groupByExtension=n;function T(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function b(m){const a=new Set;for(const p of m)p.malicious&&a.add(p.id.id);return a}e.getMaliciousExtensionsSet=b}),define(pe[44],ve([0,1,153,8,2,4,10,15,23]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(H){return H.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=b;function m(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=m;function a(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function p(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=p;var S;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(x,$){super(x);this.code=$}}e.FileSystemProviderError=v;function _(H,x){const $=new v(H.toString(),x);return u($,x),$}e.createFileSystemProviderError=_;function c(H){return H||_((0,E.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function u(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=u;function s(H){if(!H)return S.Unknown;if(H instanceof v)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return S.Unknown;switch(x[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function t(H){if(H instanceof g)return H.fileOperationResult;switch(s(H)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(x,$,F){this.resource=x,this.operation=$,this.target=F}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var r;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const F of x)switch(F.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(x,...$){return this.doContains(x,{includeChildren:!1},...$)}affects(x,...$){return this.doContains(x,{includeChildren:!0},...$)}doContains(x,$,...F){var U,M,N,O,V,q;if(!x)return!1;const Q=F.length>0;return!!((!Q||F.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(x))||$.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(x)))||(!Q||F.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(x))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(x)))||(!Q||F.includes(2))&&(((V=this.deleted)===null||V===void 0?void 0:V.findSubstr(x))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const $=[],F=x===1?this.added:x===0?this.updated:this.deleted;if(F)for(const[,U]of F)$.push(U);return $}filter(x){return new l(this.changes.filter($=>x($)),this.ignorePathCasing)}}e.FileChangesEvent=l;function h(H,x,$){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==y.sep&&(x+=y.sep),$?(0,C.startsWithIgnoreCase)(H,x):H.indexOf(x)===0)}e.isParent=h;class g extends Error{constructor(x,$,F){super(x);this.fileOperationResult=$,this.options=F}static isFileOperationError(x){return x instanceof Error&&!(0,A.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=g;var w;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var d;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(d=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function f(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=f;async function I(H,x){if(!x.canHandleResource(R.URI.from({scheme:H.scheme})))return new Promise($=>{const F=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(F.dispose(),$())})})}e.whenProviderRegistered=I,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(x){return(0,A.isNumber)(x)||(x=0),x<L.KB?(0,E.localize)(1,null,x.toFixed(0)):x<L.MB?(0,E.localize)(2,null,(x/L.KB).toFixed(2)):x<L.GB?(0,E.localize)(3,null,(x/L.MB).toFixed(2)):x<L.TB?(0,E.localize)(4,null,(x/L.GB).toFixed(2)):(0,E.localize)(5,null,(x/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var B;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function ee(H){return{maxFileSize:H===0?300*L.MB:16*L.GB,maxHeapSize:H===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ee}),define(pe[81],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...R){this._entries=new Map;for(let[P,C]of R)this.set(P,C)}set(R,P){const C=this._entries.get(R);return this._entries.set(R,P),C}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=E}),define(pe[182],ve([0,1,16,175,108,4,81,17]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class n extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class T{constructor(a=new C.ServiceCollection,p=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=p,this._parent=S,this._services.set(P.IInstantiationService,this)}createChild(a){return new T(a,this._strict,this)}invokeFunction(a,...p){let S=b.traceInvocation(a),v=!1;try{return a({get:(c,u)=>{if(v)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,S);if(!s&&u!==P.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...p)}finally{v=!0,S.stop()}}createInstance(a,...p){let S,v;return a instanceof R.SyncDescriptor?(S=b.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(p),S)):(S=b.traceCreation(a),v=this._createInstance(a,p,S)),S.stop(),v}_createInstance(a,p=[],S){let v=P._util.getServiceDependencies(a).sort((u,s)=>u.index-s.index),_=[];for(const u of v){let s=this._getOrCreateServiceInstance(u.id,S);if(!s&&this._strict&&!u.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${u.id}.`);_.push(s)}let c=v.length>0?v[0].index:p.length;if(p.length!==c){console.warn(`[createInstance] First service dependency of ${a.name} at position ${c+1} conflicts with ${p.length} static arguments`);let u=c-p.length;u>0?p=p.concat(new Array(u)):p=p.slice(0,c)}return new a(...[...p,..._])}_setServiceInstance(a,p){if(this._services.get(a)instanceof R.SyncDescriptor)this._services.set(a,p);else if(this._parent)this._parent._setServiceInstance(a,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let p=this._services.get(a);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):p}_getOrCreateServiceInstance(a,p){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,p.branch(a,!0)):(p.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,p,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,p,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,p,S){const v=new y.Graph(u=>u.id.toString());let _=0;const c=[{id:a,desc:p,_trace:S}];for(;c.length;){const u=c.pop();if(v.lookupOrInsertNode(u),_++>1e3)throw new n(v);for(let s of P._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const i={id:s.id,desc:t,_trace:u._trace.branch(s.id,!0)};v.insertEdge(u,i),c.push(i)}}}for(;;){const u=v.roots();if(u.length===0){if(!v.isEmpty())throw new n(v);break}for(const{data:s}of u){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,p,S=[],v,_){if(this._services.get(a)instanceof R.SyncDescriptor)return this._createServiceInstance(p,S,v,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,p,S,v,_);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(a,p=[],S,v){if(S){const _=new A.IdleValue(()=>this._createInstance(a,p,v));return new Proxy(Object.create(null),{get(c,u){if(u in c)return c[u];let s=_.value,t=s[u];return typeof t!="function"||(t=t.bind(s),c[u]=t),t},set(c,u,s){return _.value[u]=s,!0}})}else return this._createInstance(a,p,v)}}e.InstantiationService=T;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class b{constructor(a,p){this.type=a,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new b(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(a){return D?new b(0,a.name):b._None}branch(a,p){let S=new b(2,a.toString());return this._dep.push([a,p,S]),S}stop(){let a=Date.now()-this._start;b._totals+=a;let p=!1;function S(_,c){let u=[],s=new Array(_+1).join("	");for(const[t,i,o]of c._dep)if(i&&o){p=!0,u.push(`${s}CREATES -> ${t}`);let r=S(_+1,o);r&&u.push(r)}else u.push(`${s}uses -> ${t}`);return u.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(a>2||p)&&console.log(v.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(pe[12],ve([0,1,4,6,9,3,58]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function A(){return new Date().toISOString()}var D;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class n extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(D.Error))if(s instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=s.stack,this.log(D.Error,this.format(i))}else this.log(D.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let i=0;i<s.length;i++){let o=s[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(r){}t+=(i>0?" ":"")+o}return t}}e.AbstractMessageLogger=T;class k extends n{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!R.isWindows}trace(s,...t){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,s,...t):console.log(`[main ${A()}]`,s,...t))}debug(s,...t){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,s,...t):console.log(`[main ${A()}]`,s,...t))}info(s,...t){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,s,...t):console.log(`[main ${A()}]`,s,...t))}warn(s,...t){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,s,...t):console.warn(`[main ${A()}]`,s,...t))}error(s,...t){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,s,...t):console.error(`[main ${A()}]`,s,...t))}critical(s,...t){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,s,...t):console.error(`[main ${A()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class b extends n{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class m extends n{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,C.toErrorMessage)(s,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class a extends n{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const i of this.logServices)i.trace(s,...t)}debug(s,...t){for(const i of this.logServices)i.debug(s,...t)}info(s,...t){for(const i of this.logServices)i.info(s,...t)}warn(s,...t){for(const i of this.logServices)i.warn(s,...t)}error(s,...t){for(const i of this.logServices)i.error(s,...t)}critical(s,...t){for(const i of this.logServices)i.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=a;class p extends y.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=p;class S{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(s){}getLevel(){return D.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=S;function v(u){if(u.verbose)return D.Trace;if(typeof u.logLevel=="string"){const s=_(u.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function _(u){switch(u){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=_;function c(u){switch(u){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(pe[109],ve([0,1,12,44]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(D,n,T,k){try{const b=await new Promise((m,a)=>{Z(["spdlog"],m,a)});return b.setAsyncMode(8192,500),b.createRotatingLoggerAsync(D,n,T,k)}catch(b){console.error(b)}return null}function P(D,n,T,k){return Z.__$__nodeRequire("spdlog").createRotatingLogger(D,n,T,k)}e.createRotatingLogger=P;function C(D,n,T){switch(n){case E.LogLevel.Trace:D.trace(T);break;case E.LogLevel.Debug:D.debug(T);break;case E.LogLevel.Info:D.info(T);break;case E.LogLevel.Warning:D.warn(T);break;case E.LogLevel.Error:D.error(T);break;case E.LogLevel.Critical:D.critical(T);break;default:throw new Error("Invalid log level")}}class A extends E.AbstractMessageLogger{constructor(n,T,k,b){super();this.name=n,this.filepath=T,this.rotating=k,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const n=this.rotating?6:1,T=30/n*y.ByteSize.MB;return R(this.name,this.filepath,T,n).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:b,message:m}of this.buffer)C(this._logger,b,m);this.buffer=[]}})}log(n,T){this._logger?C(this._logger,n,T):this.getLevel()<=n&&this.buffer.push({level:n,message:T})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=A}),define(pe[110],ve([0,1,4,154,56]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var C;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function n(a,p){return p-a}D.compare=n;const T=Object.create(null);T[D.Error]=(0,y.localize)(0,null),T[D.Warning]=(0,y.localize)(1,null),T[D.Info]=(0,y.localize)(2,null);function k(a){return T[a]||""}D.toString=k;function b(a){switch(a){case R.default.Error:return D.Error;case R.default.Warning:return D.Warning;case R.default.Info:return D.Info;case R.default.Ignore:return D.Hint}}D.fromSeverity=b;function m(a){switch(a){case D.Error:return R.default.Error;case D.Warning:return R.default.Warning;case D.Info:return R.default.Info;case D.Hint:return R.default.Ignore}}D.toSeverity=m}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(D){const n="";function T(b){return k(b,!0)}D.makeKey=T;function k(b,m){let a=[n];return b.source?a.push(b.source.replace("\xA6","\\\xA6")):a.push(n),b.code?typeof b.code=="string"?a.push(b.code.replace("\xA6","\\\xA6")):a.push(b.code.value.replace("\xA6","\\\xA6")):a.push(n),b.severity!==void 0&&b.severity!==null?a.push(C.toString(b.severity)):a.push(n),b.message&&m?a.push(b.message.replace("\xA6","\\\xA6")):a.push(n),b.startLineNumber!==void 0&&b.startLineNumber!==null?a.push(b.startLineNumber.toString()):a.push(n),b.startColumn!==void 0&&b.startColumn!==null?a.push(b.startColumn.toString()):a.push(n),b.endLineNumber!==void 0&&b.endLineNumber!==null?a.push(b.endLineNumber.toString()):a.push(n),b.endColumn!==void 0&&b.endColumn!==null?a.push(b.endColumn.toString()):a.push(n),a.push(n),a.join("\xA6")}D.makeKeyOptionalMessage=k})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(pe[183],ve([0,1,56,4,3]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,y.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new D,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=A;class D{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=D}),define(pe[184],ve([0,1,11,9,30,24]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(y.isWeb||typeof Z=="undefined"||typeof Z.__$__nodeRequire!="function")C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.55.0-dev",nameShort:y.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:y.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const A=(0,P.dirname)(E.FileAccess.asFileUri("",Z));C=Z.__$__nodeRequire((0,P.joinPath)(A,"product.json").fsPath);const D=Z.__$__nodeRequire((0,P.joinPath)(A,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`}),Object.assign(C,{version:D.version})}e.default=C});var je=this&&this.__decorate||function(Z,e,E,y){var R=arguments.length,P=R<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,E):y,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Z,e,E,y);else for(var A=Z.length-1;A>=0;A--)(C=Z[A])&&(P=(R<3?C(P):R>3?C(e,E,P):C(e,E))||P);return R>3&&P&&Object.defineProperty(e,E,P),P},Ue=this&&this.__param||function(Z,e){return function(E,y){e(E,y,Z)}};define(pe[111],ve([0,1,4,21,6,17]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var C;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let D=class extends R.Disposable{constructor(k,b){super();this.deferred=new P.DeferredPromise,b.withProgress(k,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,R.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};D=je([Ue(1,e.IProgressService)],D),e.UnmanagedProgress=D;class n extends R.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(k){this.stop();const b=++this.currentOperationId,m=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,R.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,R.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,R.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:m.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(pe[40],ve([0,1,15,52]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(C,A){y.ok(E.isString(C)),y.ok(E.isObject(A)),y.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,A)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new R}),define(pe[112],ve([0,1,40,3]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class P{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,n){this.schemasById[R(D)]=n,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new P;E.Registry.add(e.Extensions.JSONContribution,C)}),define(pe[82],ve([0,1,151,3,40,15,112]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=R.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,_=!0){this.registerConfigurations([v],_)}registerConfigurations(v,_=!0){const c=[];v.forEach(u=>{c.push(...this.validateAndRegisterProperties(u,_)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(v){const _=[],c=u=>{if(u.properties)for(const s in u.properties)_.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,u.properties[s]);u.allOf&&u.allOf.forEach(s=>c(s))};for(const u of v){c(u);const s=this.configurationContributors.indexOf(u);s!==-1&&this.configurationContributors.splice(s,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(v){const _=[],c=[];for(const u of v)for(const s in u)if(_.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),u[s]);const t={type:"object",default:this.defaultValues[s],description:E.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(k(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=u[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(v){const _=[];for(const c of v)for(const u in c)if(_.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const s=this.configurationProperties[u];s&&(this.updatePropertyDefaultValue(u,s),this.updateSchema(u,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const _ of v)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,_=!0,c=3){c=P.isUndefinedOrNull(v.scope)?c:v.scope;let u=[],s=v.properties;if(s)for(let i in s){if(_&&a(i)){delete s[i];continue}const o=s[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:o.scope=P.isUndefinedOrNull(o.scope)?c:o.scope,s[i].hasOwnProperty("included")&&!s[i].included){this.excludedConfigurationProperties[i]=s[i],delete s[i];continue}else this.configurationProperties[i]=s[i];!s[i].deprecationMessage&&s[i].markdownDeprecationMessage&&(s[i].deprecationMessage=s[i].markdownDeprecationMessage),u.push(i)}let t=v.allOf;if(t)for(let i of t)u.push(...this.validateAndRegisterProperties(i,_,c));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const _=c=>{let u=c.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let s=c.allOf;s&&s.forEach(_)};_(v)}updateSchema(v,_){switch(e.allSettings.properties[v]=_,_.scope){case 1:e.applicationSettings.properties[v]=_;break;case 2:e.machineSettings.properties[v]=_;break;case 6:e.machineOverridableSettings.properties[v]=_;break;case 3:e.windowSettings.properties[v]=_;break;case 4:e.resourceSettings.properties[v]=_;break;case 5:e.resourceSettings.properties[v]=_,this.resourceLanguageSettingsSchema.properties[v]=_;break}}removeFromSchema(v,_){switch(delete e.allSettings.properties[v],_.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const _=`[${v}]`,c={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,c),e.allSettings.properties[_]=c,e.applicationSettings.properties[_]=c,e.machineSettings.properties[_]=c,e.machineOverridableSettings.properties[_]=c,e.windowSettings.properties[_]=c,e.resourceSettings.properties[_]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,_){let c=this.defaultValues[v];P.isUndefined(c)&&(c=_.default),P.isUndefined(c)&&(c=b(_.type)),_.default=c}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=k;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const m=new n;R.Registry.add(e.Extensions.Configuration,m);function a(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?E.localize(5,null,S):m.getConfigurationProperties()[S]!==void 0?E.localize(6,null,S):null:E.localize(4,null)}e.validateProperty=a;function p(){const S=[],v=m.getConfigurationProperties();for(const _ of Object.keys(v))S.push([_,v[_].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=p}),define(pe[83],ve([0,1,22,15,2,40,4,82]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function D(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=D;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(i,o){const r=o?i?o.keys.filter(I=>i.keys.indexOf(I)===-1):[...o.keys]:[],l=i?o?i.keys.filter(I=>o.keys.indexOf(I)===-1):[...i.keys]:[],h=[];if(o&&i){for(const I of i.keys)if(o.keys.indexOf(I)!==-1){const L=v(i.contents,I),B=v(o.contents,I);E.equals(L,B)||h.push(I)}}const g=[],w=I=>{const L={};for(const B of I)for(const ee of B.identifiers)L[s(ee)]=B;return L},d=o?w(o.overrides):{},f=i?w(i.overrides):{};if(Object.keys(d).length)for(const I of r){const L=d[I];L&&g.push([(0,A.overrideIdentifierFromKey)(I),L.keys])}if(Object.keys(f).length)for(const I of l){const L=f[I];L&&g.push([(0,A.overrideIdentifierFromKey)(I),L.keys])}if(Object.keys(d).length&&Object.keys(f).length)for(const I of h){const L=f[I],B=d[I];if(L&&B){const ee=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});g.push([(0,A.overrideIdentifierFromKey)(I),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:l,updated:h,overrides:g}}e.compare=k;function b(i,o){const r=[];for(const l of Object.keys(i))if(A.OVERRIDE_PROPERTY_PATTERN.test(l)){const h={};for(const g in i[l])h[g]=i[l][g];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(h),contents:m(h,o)})}return r}e.toOverrides=b;function m(i,o){const r=Object.create(null);for(let l in i)a(r,l,i[l],o);return r}e.toValuesTree=m;function a(i,o,r,l){const h=o.split("."),g=h.pop();let w=i;for(let d=0;d<h.length;d++){let f=h[d],I=w[f];switch(typeof I){case"undefined":I=w[f]=Object.create(null);break;case"object":break;default:l(`Ignoring ${o} as ${h.slice(0,d+1).join(".")} is ${JSON.stringify(I)}`);return}w=I}if(typeof w=="object"&&w!==null)try{w[g]=r}catch(d){l(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}else l(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=a;function p(i,o){const r=o.split(".");S(i,r)}e.removeFromValueTree=p;function S(i,o){const r=o.shift();if(o.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const l=i[r];typeof l=="object"&&!Array.isArray(l)&&(S(l,o),Object.keys(l).length===0&&delete i[r])}}function v(i,o,r){function l(w,d){let f=w;for(const I of d){if(typeof f!="object"||f===null)return;f=f[I]}return f}const h=o.split("."),g=l(i,h);return typeof g=="undefined"?r:g}e.getConfigurationValue=v;function _(i,o,r){Object.keys(o).forEach(l=>{l!=="__proto__"&&(l in i?y.isObject(i[l])&&y.isObject(o[l])?_(i[l],o[l],r):r&&(i[l]=o[l]):i[l]=o[l])})}e.merge=_;function c(){const i=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=c;function u(){const i=Object.create(null),o=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in o){let l=o[r].default;a(i,r,l,h=>console.error(`Conflict in default settings: ${h}`))}return i}e.getDefaultValues=u;function s(i){return`[${i}]`}e.keyFromOverrideIdentifier=s;function t(i,o,r){const l=i.inspect(o),h=i.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:l.defaultValue}e.getMigratedSettingValue=t}),define(pe[185],ve([0,1,54,23,14,15,22,2,82,83,40,6,3]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},i=[],o=[]){this._contents=t,this._keys=i,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const o=this.getContentsForOverrideIdentifer(i);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r],h=i[r];h&&(typeof l=="object"&&typeof h=="object"?(l=C.deepClone(l),this.mergeContents(l,h)):l=h),o[r]=l}return new m(o,this.keys,this.overrides)}merge(...t){const i=C.deepClone(this.contents),o=C.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const h of l.overrides){const[g]=o.filter(w=>R.equals(w.identifiers,h.identifiers));g?this.mergeContents(g.contents,h.contents):o.push(C.deepClone(h))}for(const h of l.keys)r.indexOf(h)===-1&&r.push(h)}return new m(i,r,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const o of Object.keys(i)){if(o in t&&P.isObject(t[o])&&P.isObject(i[o])){this.mergeContents(t[o],i[o]);continue}t[o]=C.deepClone(i[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let o=0;o<i;o++)t.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class a extends m{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),o=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&o.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,o)}}e.DefaultConfigurationModel=a;class p{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new m(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},o=null,r=[],l=[],h=[];function g(d){Array.isArray(r)?r.push(d):o&&(r[o]=d)}let w={onObjectBegin:()=>{let d={};g(d),l.push(r),r=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let d=[];g(d),l.push(r),r=d,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:g,onError:(d,f,I)=>{h.push({error:d,offset:f,length:I})}};if(t)try{E.visit(t,w),i=r[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return i}doParseRaw(t){if(this._scopes){const l=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,l,!0,this._scopes)}const i=(0,n.toValuesTree)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),o=Object.keys(t),r=(0,n.toOverrides)(t,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:i,keys:o,overrides:r}}filterByScope(t,i,o,r){const l={};for(let h in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(h)&&o)l[h]=this.filterByScope(t[h],i,!1,r);else{const g=this.getScope(h,i);(g===void 0||r.indexOf(g)!==-1)&&(l[h]=t[h])}return l}getScope(t,i){const o=i[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=p;class S extends k.Disposable{constructor(t,i,o,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(b.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new m}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class v{constructor(t,i,o=new m,r=new m,l=new y.ResourceMap,h=new m,g=new y.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(t,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(t)}updateValue(t,i,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new m,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,o){const r=this.getConsolidateConfigurationModel(i,o),l=this.getFolderConfigurationModelForResource(i.resource,o),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,g=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),I=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,B=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(t):h.getValue(t),ee=r.getValue(t),H=R.distinct(R.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:g,userValue:w,userLocalValue:d,userRemoteValue:f,workspaceValue:I,workspaceFolderValue:L,memoryValue:B,value:ee,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:h.getValue(t),override:i.overrideIdentifier?h.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const o=i.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,D.overrideIdentifierFromKey)(r),h=this._defaultConfiguration.getKeysForOverrideIdentifier(l),g=t.getKeysForOverrideIdentifier(l),w=[...g.filter(d=>h.indexOf(d)===-1),...h.filter(d=>g.indexOf(d)===-1),...h.filter(d=>!C.equals(this._defaultConfiguration.override(l).getValue(d),t.override(l).getValue(d)))];return[l,w]});return this.updateDefaultConfiguration(t),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:o,removed:r,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),h=[...i,...o,...r];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:o,removed:r,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let h=[...i,...o,...r];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:o,removed:r,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let h=[...i,...o,...r];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const o=this.folderConfigurations.get(t),{added:r,updated:l,removed:h,overrides:g}=(0,n.compare)(o,i);let w=[...r,...l,...h];return(w.length||!o)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:g}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:r,removed:l,overrides:h}=(0,n.compare)(i,void 0);return{keys:[...o,...r,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const l=this._memoryConfigurationByResource.get(t);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=o.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=o}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const o=i.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:o,overrides:r,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:o,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((h,g)=>(h.set(A.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new y.ResourceMap);return new v(i,o,new m,r,l,new m,new y.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function _(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const r of s)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,h])=>{const g=(0,y.getOrSet)(i,l,new Set);h.forEach(w=>g.add(w))});const o=[];return i.forEach((r,l)=>o.push([l,[...r.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=_;class c{constructor(t,i,o,r){this.change=t,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(g=>l.add(g)),t.overrides.forEach(([,g])=>g.forEach(w=>l.add(w))),this.affectedKeys=[...l.values()];const h=new m;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!C.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let o=(0,n.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(t=t[r],!t)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=c;class u extends c{constructor(t,i,o,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(pe[113],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var y;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(C,A=y.Unknown,D){super(C);this._message=C,this._code=A,this._detail=D,this.isHandled=A===y.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===y.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===y.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}}e.RemoteAuthorityResolverError=R}),define(pe[114],ve([0,1,11]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function y(P){return P.scheme===E.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=y;function R(P){if(!!P){const C=P.indexOf("+");return C<0?P:P.substr(0,C)}}e.getRemoteName=R}),define(pe[186],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{vsda(){return new Promise((R,P)=>Z(["vsda"],R,P))}async sign(R){try{const P=await this.vsda(),C=new P.signer;if(C)return C.sign(R)}catch(P){}return R}}e.SignService=E}),define(pe[187],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,P,C=5){let A;return A=P(D=>{const n=typeof D=="string"?D:D.data;let T=this._terminalBufferMap.get(R);if(T){T.data.push(n);return}const k=setTimeout(()=>this._flushBuffer(R),C);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this._flushBuffer(R),A.dispose()}},this._terminalBufferMap.set(R,T)}),A}stopBuffering(R){const P=this._terminalBufferMap.get(R);P&&P.dispose()}_flushBuffer(R){const P=this._terminalBufferMap.get(R);P&&(this._terminalBufferMap.delete(R),this._callback(R,P.data.join("")))}}e.TerminalDataBufferer=E}),define(pe[188],ve([0,1,48,8,30,26,15,22,9]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function n(){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let b=0;return k&&k.length===4&&(b=parseInt(k[3])),b}e.getWindowsBuildNumber=n;async function T(k,b,m,a=R.env){if(y.isAbsolute(k))return await(0,P.exists)(k)?k:void 0;if(b===void 0&&(b=R.cwd()),y.dirname(k)!=="."){const _=y.join(b,k);return await(0,P.exists)(_)?_:void 0}const S=(0,A.getCaseInsensitive)(a,"PATH");if(m===void 0&&(0,C.isString)(S)&&(m=S.split(y.delimiter)),m===void 0||m.length===0){const _=y.join(b,k);return await(0,P.exists)(_)?_:void 0}for(let _ of m){let c;if(y.isAbsolute(_)?c=y.join(_,k):c=y.join(b,_,k),await(0,P.exists)(c))return c;if(D.isWindows){let u=c+".com";if(await(0,P.exists)(u)||(u=c+".exe",await(0,P.exists)(u)))return u}}const v=y.join(b,k);return await(0,P.exists)(v)?v:void 0}e.findExecutable=T}),define(pe[189],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(y){y.DARK="dark",y.LIGHT="light",y.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(pe[190],ve([0,1,4,6,40,3,189,47]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var D;(function(S){function v(_){return _&&typeof _=="object"&&typeof _.id=="string"}S.isThemeColor=v})(D=e.ThemeColor||(e.ThemeColor={}));function n(S){return{id:S}}e.themeColorFromId=n;var T;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}S.isThemeIcon=v;const _=new RegExp(`^\\$\\((${A.CSSIcon.iconNameExpression}(?:${A.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const i=_.exec(t);if(!!i){let[,o]=i;return{id:o}}}S.fromString=c;function u(t,i){let o=t.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),i&&(o=`${o}~${i}`),{id:o}}S.modify=u;function s(t,i){var o,r;return t.id===i.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((r=i.color)===null||r===void 0?void 0:r.id)}S.isEqual=s,S.asClassNameArray=A.CSSIcon.asClassNameArray,S.asClassName=A.CSSIcon.asClassName,S.asCSSSelector=A.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=A.Codicon.file,e.FolderThemeIcon=A.Codicon.folder;function k(S){switch(S){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,y.toDisposable)(()=>{const _=this.themingParticipants.indexOf(v);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new b;R.Registry.add(e.Extensions.ThemingContribution,m);function a(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=a;class p extends y.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,_){let c=this.theme.getColor(v);return c&&_&&(c=_(c,this.theme)),c?c.toString():null}}e.Themable=p}),define(pe[191],ve([0,1,40,190,3,155,112,17,47]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,_,c,u){const s=this.iconsById[v];if(s){if(c&&!s.description){s.description=c,this.iconSchema.properties[v].markdownDescription=`${c} $(${v})`;const o=this.iconReferenceSchema.enum.indexOf(v);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=c),this._onDidChange.fire()}return s}let t={id:v,description:c,defaults:_,deprecationMessage:u};this.iconsById[v]=t;let i={$ref:"#/definitions/icons"};return u&&(i.deprecationMessage=u),c&&(i.markdownDescription=`${c}: $(${v})`),this.iconSchema.properties[v]=i,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const _=this.iconReferenceSchema.enum.indexOf(v);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,_){const c=this.iconFontsById[v];if(c)return c;let u={id:v,definition:_};return this.iconFontsById[v]=u,this._onDidChange.fire(),u}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(s,t)=>s.id.localeCompare(t.id),_=s=>{for(;y.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of u.filter(t=>!!t.description).sort(v))c.push(`|<i class="${_(s)}"></i>|${s.id}|${y.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const s of u.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(v))c.push(`|<i class="${_(s)}"></i>|${s.id}|`);return c.join(`
`)}}const T=new n;E.Registry.add(e.Extensions.IconContribution,T);function k(S,v,_,c){return T.registerIcon(S,v,_,c)}e.registerIcon=k;function b(){return T}e.getIconRegistry=b;function m(){for(const S of D.iconRegistry.all)T.registerIcon(S.id,S.definition,S.description);D.iconRegistry.onDidRegister(S=>T.registerIcon(S.id,S.definition,S.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let a=E.Registry.as(C.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,T.getIconSchema());const p=new A.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=k("widget-close",D.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",D.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",D.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=y.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(pe[59],ve([0,1,2,24,4,23]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var C;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function A(b){const m=b;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=A;function D(b){const m=b;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class n{constructor(m,a,p,S){this._id=m,this._configuration=p,this._ignorePathCasing=S,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(m,a){this.raw=a,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,y.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(b){return new T({uri:b,index:0,name:(0,y.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=k}),define(pe[115],ve([0,1,4,156,59,2,9,8,24,132,54,11,75,31,114]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?(0,A.extname)($):(0,D.extname)($))===p}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function v($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function _($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=_;function c($){return $.hasOwnProperty("fileUri")}e.isRecentFile=c;function u($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&P.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=u;function s($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=s;function t($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&P.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function i($){const F=$;if(F==null?void 0:F.uri)return{id:F.id,uri:P.URI.revive(F.uri)};const U=$;if(U==null?void 0:U.configPath)return{id:U.id,configPath:P.URI.revive(U.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=i;function o($,F){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,F.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function r($){return l($)||h($)}e.isStoredWorkspaceFolder=r;function l($){const F=$;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=l;function h($){const F=$;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=h;function g($,F,U,M,N=!C.isWindows,O){if($.scheme!==M.scheme)return{name:U,uri:$.toString(!0)};let V=F?void 0:O.relativePath(M,$);if(V!==void 0)V.length===0?V=".":C.isWindows&&$.scheme===k.Schemas.file&&!N&&(V=V.replace(/\//g,"\\"));else if($.scheme===k.Schemas.file)V=$.fsPath,C.isWindows&&(V=(0,b.normalizeDriveLetter)(V),N&&(V=(0,m.toSlashes)(V)));else{if(!O.isEqualAuthority($.authority,M.authority))return{name:U,uri:$.toString(!0)};V=$.path}return{name:U,path:V}}e.getStoredWorkspaceFolder=g;function w($,F,U){let M=[],N=new Set;const O=U.dirname(F);for(let V of $){let q=null;if(l(V))V.path&&(q=U.resolvePath(O,V.path));else if(h(V))try{q=P.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=U.getComparisonKey(q);if(!N.has(Q)){N.add(Q);const me=V.name||U.basenameOrAuthority(q);M.push(new R.WorkspaceFolder({uri:q,name:me,index:M.length},V))}}}return M}e.toWorkspaceFolders=w;function d($,F,U,M,N){let O=f(F,$);const V=N.dirname(F),q=N.dirname(M),Q=[],me=I(O.folders);for(const Me of O.folders){const z=l(Me)?N.resolvePath(V,Me.path):P.URI.parse(Me.uri);let J;U?J=!1:J=!l(Me)||(0,A.isAbsolute)(Me.path),Q.push(g(z,J,Me.name,q,me,N))}const we={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},Ae=n.setProperty($,["folders"],Q,we);let Ie=n.applyEdits($,Ae);return O.remoteAuthority===(0,a.getRemoteAuthority)(M)&&(Ie=n.applyEdits(Ie,n.removeProperty(Ie,["remoteAuthority"],we))),Ie}e.rewriteWorkspaceFileForNewLocation=d;function f($,F){let U=T.parse(F);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(M=>r(M));else throw new Error(`${$} looks like an invalid workspace file.`);return U}function I($){return C.isWindows?$.some(F=>l(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=I;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function B($){return typeof $.folderUri=="string"}function ee($){return typeof $.fileUri=="string"}function H($,F){const U={workspaces:[],files:[]};if($){const M=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(Q){F.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Q.toString()}. Skip entry.`)}},N=$;if(Array.isArray(N.entries))M(N.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:P.URI.parse(O.workspace.configPath)}}):B(O)?U.workspaces.push({label:V,remoteAuthority:q,folderUri:P.URI.parse(O.folderUri)}):ee(O)&&U.files.push({label:V,remoteAuthority:q,fileUri:P.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&M(O.workspaces3,(V,q)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?U.workspaces.push({label:Q,workspace:{id:V.id,configPath:P.URI.parse(V.configURIPath)}}):typeof V=="string"&&U.workspaces.push({label:Q,folderUri:P.URI.parse(V)})}),Array.isArray(O.files2)&&M(O.files2,(V,q)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&U.files.push({label:Q,fileUri:P.URI.parse(V)})})}}return U}e.restoreRecentlyOpened=H;function x($){const F={entries:[]};for(const U of $.workspaces)_(U)?F.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):F.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of $.files)F.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return F}e.toStoreData=x}),define(pe[116],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const P=this._idPool++;return this._data.set(P,R),this.logDebugInfo(),P}get(R,P){return this._data.has(R)?this._data.get(R)[P]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(pe[192],ve([0,1,2,3]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(A=>({name:A.name,group:A.group,resource:E.URI.revive(A.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(pe[60],ve([0,1,11,4]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,A){A===null?this._providerInfo.delete(C):this._providerInfo.set(C,A)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(pe[27],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(pe[193],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(P,C,A){this._id=P,this._shared=C,this._storage=A,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)})}get whenReady(){return this._init}get(P,C){let A=this._value[P];return typeof A=="undefined"&&(A=C),A}update(P,C){return this._value[P]=C,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class y extends E{constructor(P,C){super(P.identifier.value,!0,C);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=y}),define(pe[13],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class y{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=y});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[194],ve([0,1,29,3]),function(Z,e,E,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(A,D){R.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(A.identifier),tt(this,R,D),Be(this,R).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(A){return Be(this,R).get(this._id,A)}store(A,D){return Be(this,R).store(this._id,A,D)}delete(A){return Be(this,R).delete(this._id,A)}}e.ExtensionSecrets=P,R=new WeakMap}),define(pe[117],ve([0,1,4,3]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class R{constructor(){this._onDidChangeTelemetryEnabled=new y.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=R,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(pe[50],ve([0,1,4,3,13]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(A){function D(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}A.fromApiTunnel=D;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}A.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let C=class{constructor(D){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,n){return{dispose:()=>{}}}async $providePortAttributes(D,n,T,k,b){return[]}async $forwardPort(D,n){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=je([Ue(0,R.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[7],ve([0,1,14,16,94,23,15,2,28,44,113]),function(Z,e,E,y,R,P,C,A,D,n,T){"use strict";var k,b,m,a,p,S,v,_,c,u,s,t,i,o,r,l,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function w(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let d=p=class{constructor(W){k.set(this,void 0),tt(this,k,W)}static from(...W){let oe=W;return new p(function(){if(oe){for(const ye of oe)ye&&typeof ye.dispose=="function"&&ye.dispose();oe=void 0}})}dispose(){typeof Be(this,k)=="function"&&(Be(this,k).call(this),tt(this,k,void 0))}};k=new WeakMap,d=p=je([w],d),e.Disposable=d;let f=S=class{constructor(W,oe){if(W<0)throw(0,y.illegalArgument)("line must be non-negative");if(oe<0)throw(0,y.illegalArgument)("character must be non-negative");this._line=W,this._character=oe}static Min(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let ye=1;ye<W.length;ye++){const Ve=W[ye];Ve.isBefore(oe)&&(oe=Ve)}return oe}static Max(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let ye=1;ye<W.length;ye++){const Ve=W[ye];Ve.isAfter(oe)&&(oe=Ve)}return oe}static isPosition(W){if(!W)return!1;if(W instanceof S)return!0;let{line:oe,character:ye}=W;return typeof oe=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,oe=0){if(W===null||oe===null)throw(0,y.illegalArgument)();let ye;return typeof W=="undefined"?ye=0:typeof W=="number"?ye=W:(ye=typeof W.lineDelta=="number"?W.lineDelta:0,oe=typeof W.characterDelta=="number"?W.characterDelta:0),ye===0&&oe===0?this:new S(this.line+ye,this.character+oe)}with(W,oe=this.character){if(W===null||oe===null)throw(0,y.illegalArgument)();let ye;return typeof W=="undefined"?ye=this.line:typeof W=="number"?ye=W:(ye=typeof W.line=="number"?W.line:this.line,oe=typeof W.character=="number"?W.character:this.character),ye===this.line&&oe===this.character?this:new S(ye,oe)}toJSON(){return{line:this.line,character:this.character}}};f=S=je([w],f),e.Position=f;let I=v=class{constructor(W,oe,ye,Ve){let Je,it;if(typeof W=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Je=new f(W,oe),it=new f(ye,Ve)):W instanceof f&&oe instanceof f&&(Je=W,it=oe),!Je||!it)throw new Error("Invalid arguments");Je.isBefore(it)?(this._start=Je,this._end=it):(this._start=it,this._end=Je)}static isRange(W){return W instanceof v?!0:W?f.isPosition(W.start)&&f.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof v?this.contains(W._start)&&this.contains(W._end):W instanceof f?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const oe=f.Max(W.start,this._start),ye=f.Min(W.end,this._end);if(!oe.isAfter(ye))return new v(oe,ye)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const oe=f.Min(W.start,this._start),ye=f.Max(W.end,this.end);return new v(oe,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,oe=this.end){if(W===null||oe===null)throw(0,y.illegalArgument)();let ye;return W?f.isPosition(W)?ye=W:(ye=W.start||this.start,oe=W.end||this.end):ye=this.start,ye.isEqual(this._start)&&oe.isEqual(this.end)?this:new v(ye,oe)}toJSON(){return[this.start,this.end]}};I=v=je([w],I),e.Range=I;let L=_=class extends I{constructor(W,oe,ye,Ve){let Je,it;if(typeof W=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Je=new f(W,oe),it=new f(ye,Ve)):W instanceof f&&oe instanceof f&&(Je=W,it=oe),!Je||!it)throw new Error("Invalid arguments");super(Je,it);this._anchor=Je,this._active=it}static isSelection(W){return W instanceof _?!0:W?I.isRange(W)&&f.isPosition(W.anchor)&&f.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=_=je([w],L),e.Selection=L;class B{constructor(W,oe,ye){if(typeof W!="string"||W.length===0)throw(0,y.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,y.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,y.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(oe),this.connectionToken=ye}}e.ResolvedAuthority=B;class ee extends Error{constructor(W,oe=T.RemoteAuthorityResolverErrorCode.Unknown,ye){super(W);this._message=W,this._code=oe,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable(W,oe){return new ee(W,T.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(W){return new ee(W,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var H;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var x;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=c=class{constructor(W,oe){this._range=W,this._newText=oe}static isTextEdit(W){return W instanceof c?!0:W?I.isRange(W)&&typeof W.newText=="string":!1}static replace(W,oe){return new c(W,oe)}static insert(W,oe){return c.replace(new I(W,W),oe)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const oe=new c(new I(new f(0,0),new f(0,0)),"");return oe.newEol=W,oe}get range(){return this._range}set range(W){if(W&&!I.isRange(W))throw(0,y.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,y.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,y.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=c=je([w],$),e.TextEdit=$;var F;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellOutput=4]="CellOutput",j[j.CellReplace=5]="CellReplace",j[j.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,oe,ye,Ve){this._edits.push({_type:1,from:W,to:oe,options:ye,metadata:Ve})}createFile(W,oe,ye){this._edits.push({_type:1,from:void 0,to:W,options:oe,metadata:ye})}deleteFile(W,oe,ye){this._edits.push({_type:1,from:W,to:void 0,options:oe,metadata:ye})}replaceNotebookMetadata(W,oe,ye){this._edits.push({_type:3,metadata:ye,uri:W,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(W,oe,ye,Ve,Je){(oe!==ye||Ve.length>0)&&this._edits.push({_type:5,uri:W,index:oe,count:ye-oe,cells:Ve,metadata:Je})}replaceNotebookCellOutput(W,oe,ye,Ve){this._editNotebookCellOutput(W,oe,!1,ye,Ve)}appendNotebookCellOutput(W,oe,ye,Ve){this._editNotebookCellOutput(W,oe,!0,ye,Ve)}replaceNotebookCellOutputItems(W,oe,ye,Ve,Je){this._editNotebookCellOutputItems(W,oe,ye,!1,Ve,Je)}appendNotebookCellOutputItems(W,oe,ye,Ve,Je){this._editNotebookCellOutputItems(W,oe,ye,!0,Ve,Je)}_editNotebookCellOutputItems(W,oe,ye,Ve,Je,it){this._edits.push({_type:6,metadata:it,uri:W,index:oe,outputId:ye,append:Ve,newOutputItems:Je})}_editNotebookCellOutput(W,oe,ye,Ve,Je){this._edits.push({_type:4,metadata:Je,uri:W,index:oe,append:ye,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(W,oe,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:W,edit:{editType:11,index:oe,metadata:ye}})}replace(W,oe,ye,Ve){this._edits.push({_type:2,uri:W,edit:new $(oe,ye),metadata:Ve})}insert(W,oe,ye,Ve){this.replace(W,new I(oe,oe),ye,Ve)}delete(W,oe,ye){this.replace(W,oe,"",ye)}has(W){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===W.toString())}set(W,oe){if(oe)for(const ye of oe)ye&&this._edits.push({_type:2,uri:W,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===W.toString()&&(this._edits[ye]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(W){const oe=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===W.toString()&&oe.push(ye.edit);return oe}entries(){const W=new P.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ye=W.get(oe.uri);ye||(ye=[oe.uri,[]],W.set(oe.uri,ye)),ye[1].push(oe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([w],U),e.WorkspaceEdit=U;let M=u=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof u?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=u._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,oe=this._tabstop++){if(typeof W=="function"){const ye=new u;ye._tabstop=this._tabstop,W(ye),this._tabstop=ye._tabstop,W=ye.value}else W=u._escape(W);return this.value+="${",this.value+=oe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,oe=this._tabstop++){const ye=W.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(W,oe){if(typeof oe=="function"){const ye=new u;ye._tabstop=this._tabstop,oe(ye),this._tabstop=ye._tabstop,oe=ye.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};M=u=je([w],M),e.SnippetString=M;var N;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let V=s=class{constructor(W,oe){if(this.uri=W,oe)if(oe instanceof I)this.range=oe;else if(oe instanceof f)this.range=new I(oe,oe);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof s?!0:W?I.isRange(W.range)&&A.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};V=s=je([w],V),e.Location=V;let q=class{constructor(W,oe){this.location=W,this.message=oe}static is(W){return W?typeof W.message=="string"&&W.location&&I.isRange(W.location.range)&&A.URI.isUri(W.location.uri):!1}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.location.range.isEqual(oe.location.range)&&W.location.uri.toString()===oe.location.uri.toString()}};q=je([w],q),e.DiagnosticRelatedInformation=q;let Q=class{constructor(W,oe,ye=O.Error){if(!I.isRange(W))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=W,this.message=oe,this.severity=ye}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.severity===oe.severity&&W.code===oe.code&&W.severity===oe.severity&&W.source===oe.source&&W.range.isEqual(oe.range)&&(0,E.equals)(W.tags,oe.tags)&&(0,E.equals)(W.relatedInformation,oe.relatedInformation,q.isEqual)}};Q=je([w],Q),e.Diagnostic=Q;let me=class{constructor(W,oe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,R.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=oe}};me=je([w],me),e.Hover=me;var we;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(W,oe=we.Text){this.range=W,this.kind=oe}toJSON(){return{range:this.range,kind:we[this.kind]}}};Ae=je([w],Ae),e.DocumentHighlight=Ae;var Ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var Me;(function(j){j[j.Deprecated=1]="Deprecated"})(Me=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(W,oe,ye,Ve,Je){this.name=W,this.kind=oe,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),Ve instanceof V?this.location=Ve:ye instanceof I&&(this.location=new V(Ve,ye)),t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};z=t=je([w],z),e.SymbolInformation=z;let J=i=class{constructor(W,oe,ye,Ve,Je){this.name=W,this.detail=oe,this.kind=ye,this.range=Ve,this.selectionRange=Je,this.children=[],i.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(i.validate)}};J=i=je([w],J),e.DocumentSymbol=J;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,oe){this.title=W,this.kind=oe}};ae=je([w],ae),e.CodeAction=ae;let fe=o=class{constructor(W){this.value=W}append(W){return new o(this.value?this.value+o.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+o.sep)}};fe.sep=".",fe=o=je([w],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let De=class{constructor(W,oe){if(this.range=W,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=je([w],De),e.SelectionRange=De;class Oe{constructor(W,oe,ye,Ve,Je,it){this.kind=W,this.name=oe,this.detail=ye,this.uri=Ve,this.range=Je,this.selectionRange=it}}e.CallHierarchyItem=Oe;class _e{constructor(W,oe){this.fromRanges=oe,this.from=W}}e.CallHierarchyIncomingCall=_e;class ke{constructor(W,oe){this.fromRanges=oe,this.to=W}}e.CallHierarchyOutgoingCall=ke;let Te=class{constructor(W,oe){this.range=W,this.command=oe}get isResolved(){return!!this.command}};Te=je([w],Te),e.CodeLens=Te;let xe=r=class{constructor(W,oe=!1){b.set(this,void 0),tt(this,b,new R.MarkdownString(W,{supportThemeIcons:oe}))}static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Be(this,b).value}set value(W){Be(this,b).value=W}get isTrusted(){return Be(this,b).isTrusted}set isTrusted(W){Be(this,b).isTrusted=W}get supportThemeIcons(){return Be(this,b).supportThemeIcons}appendText(W){return Be(this,b).appendText(W),this}appendMarkdown(W){return Be(this,b).appendMarkdown(W),this}appendCodeblock(W,oe){return Be(this,b).appendCodeblock(oe!=null?oe:"",W),this}};b=new WeakMap,xe=r=je([w],xe),e.MarkdownString=xe;let Se=class{constructor(W,oe){this.label=W,this.documentation=oe}};Se=je([w],Se),e.ParameterInformation=Se;let Ke=class{constructor(W,oe){this.label=W,this.documentation=oe,this.parameters=[]}};Ke=je([w],Ke),e.SignatureInformation=Ke;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=je([w],G),e.SignatureHelp=G;var ie;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ee=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(W,oe,ye){this.text=W,this.range=oe,this.kind=ye}};Ne=je([w],Ne),e.InlineHint=Ne;var ze;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(We=e.CompletionItemKind||(e.CompletionItemKind={}));var et;(function(j){j[j.Deprecated=1]="Deprecated"})(et=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(W,oe){this.label=W,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&We[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=je([w],K),e.CompletionItem=K;let se=class{constructor(W=[],oe=!1){this.items=W,this.isIncomplete=oe}};se=je([w],se),e.CompletionList=se;var he;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var Y;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Y=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ge;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var be;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var He;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(He=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $e=class{constructor(W,oe){if(oe&&!A.URI.isUri(oe))throw(0,y.illegalArgument)("target");if(!I.isRange(W)||W.isEmpty)throw(0,y.illegalArgument)("range");this.range=W,this.target=oe}};$e=je([w],$e),e.DocumentLink=$e;let qe=class{constructor(W,oe,ye,Ve){this.red=W,this.green=oe,this.blue=ye,this.alpha=Ve}};qe=je([w],qe),e.Color=qe;let Xe=class{constructor(W,oe){if(oe&&!(oe instanceof qe))throw(0,y.illegalArgument)("color");if(!I.isRange(W)||W.isEmpty)throw(0,y.illegalArgument)("range");this.range=W,this.color=oe}};Xe=je([w],Xe),e.ColorInformation=Xe;let Ze=class{constructor(W){if(!W||typeof W!="string")throw(0,y.illegalArgument)("label");this.label=W}};Ze=je([w],Ze),e.ColorPresentation=Ze;var ut;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var ot;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var nt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var ce;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ce=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=l=class{constructor(W,oe){if(typeof W!="string"||typeof oe!="string")throw(0,y.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ce.Clean=new l("clean","Clean"),Ce.Build=new l("build","Build"),Ce.Rebuild=new l("rebuild","Rebuild"),Ce.Test=new l("test","Test"),Ce=l=je([w],Ce),e.TaskGroup=Ce;function ue(j){let W="";for(let oe=0;oe<j.length;oe++)W+=j[oe].replace(/,/g,",,")+",";return W}let X=class{constructor(W,oe,ye){if(typeof W!="string")throw(0,y.illegalArgument)("process");this._args=[],this._process=W,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ye):this._options=oe)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,y.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)W.push(oe);return ue(W)}};X=je([w],X),e.ProcessExecution=X;let Re=class{constructor(W,oe,ye){if(this._args=[],Array.isArray(oe)){if(!W)throw(0,y.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,y.illegalArgument)("command");this._command=W,this._args=oe,this._options=ye}else{if(typeof W!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=W,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,y.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)W.push(typeof oe=="string"?oe:oe.value);return ue(W)}};Re=je([w],Re),e.ShellExecution=Re;var Le;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Le=e.ShellQuoting||(e.ShellQuoting={}));var Ye;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ye=e.TaskScope||(e.TaskScope={}));class Ge{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,D.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=h=class{constructor(W,oe,ye,Ve,Je,it){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ye,this.execution=Ve,dt=Je,this.__deprecated=!0):oe===Ye.Global||oe===Ye.Workspace?(this.target=oe,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Je,dt=it):(this.target=oe,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Je,dt=it),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof X?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,D.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,y.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,y.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const oe=this._definition.type;(h.EmptyType===oe||h.ProcessType===oe||h.ShellType===oe||h.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,y.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=h=je([w],rt),e.Task=rt;var at;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let Qe=class{constructor(W,oe=ct.None){this.collapsibleState=oe,A.URI.isUri(W)?this.resourceUri=W:this.label=W}};Qe=je([w],Qe),e.TreeItem=Qe;var ct;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(W,oe){this.id=W,this.color=oe}};st=je([w],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let gt=class{constructor(W){this.id=W}};gt=je([w],gt),e.ThemeColor=gt;var Et;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(W,oe){if(typeof W!="string"&&(!W||!A.URI.isUri(W)&&!A.URI.isUri(W.uri)))throw(0,y.illegalArgument)("base");if(typeof oe!="string")throw(0,y.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=A.URI.file(W),this.base=W):A.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=oe}};Ct=je([w],Ct),e.RelativePattern=Ct;let wt=class{constructor(W,oe,ye,Ve){this.enabled=typeof W=="boolean"?W:!0,typeof oe=="string"&&(this.condition=oe),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,D.generateUuid)()),this._id}};wt=je([w],wt),e.Breakpoint=wt;let St=class extends wt{constructor(W,oe,ye,Ve,Je){super(oe,ye,Ve,Je);if(W===null)throw(0,y.illegalArgument)("location");this.location=W}};St=je([w],St),e.SourceBreakpoint=St;let pt=class extends wt{constructor(W,oe,ye,Ve,Je){super(oe,ye,Ve,Je);this.functionName=W}};pt=je([w],pt),e.FunctionBreakpoint=pt;let Ft=class extends wt{constructor(W,oe,ye,Ve,Je,it,dt){super(Ve,Je,it,dt);if(!oe)throw(0,y.illegalArgument)("dataId");this.label=W,this.dataId=oe,this.canPersist=ye}};Ft=je([w],Ft),e.DataBreakpoint=Ft;let Mt=class{constructor(W,oe,ye){this.command=W,this.args=oe||[],this.options=ye}};Mt=je([w],Mt),e.DebugAdapterExecutable=Mt;let ft=class{constructor(W,oe){this.port=W,this.host=oe}};ft=je([w],ft),e.DebugAdapterServer=ft;let yt=class{constructor(W){this.path=W}};yt=je([w],yt),e.DebugAdapterNamedPipeServer=yt;let jt=class{constructor(W){this.implementation=W}};jt=je([w],jt),e.DebugAdapterInlineImplementation=jt;let Qt=class{constructor(W,oe){this.range=W,this.expression=oe}};Qt=je([w],Qt),e.EvaluatableExpression=Qt;let Ot=class{constructor(W,oe){this.range=W,this.text=oe}};Ot=je([w],Ot),e.InlineValueText=Ot;let ht=class{constructor(W,oe,ye=!0){this.range=W,this.variableName=oe,this.caseSensitiveLookup=ye}};ht=je([w],ht),e.InlineValueVariableLookup=ht;let Xt=class{constructor(W,oe){this.range=W,this.expression=oe}};Xt=je([w],Xt),e.InlineValueEvaluatableExpression=Xt;let It=class{constructor(W,oe){this.frameId=W,this.stoppedLocation=oe}};It=je([w],It),e.InlineValueContext=It;var Ut;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ut=e.FileChangeType||(e.FileChangeType={}));let qt=g=class extends Error{constructor(W,oe=n.FileSystemProviderErrorCode.Unknown,ye){var Ve;super(A.URI.isUri(W)?W.toString(!0):W);this.code=(Ve=ye==null?void 0:ye.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,n.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(W){return new g(W,n.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(W){return new g(W,n.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(W){return new g(W,n.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(W){return new g(W,n.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(W){return new g(W,n.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(W){return new g(W,n.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};qt=g=je([w],qt),e.FileSystemError=qt;let Jt=class{constructor(W,oe,ye){this.start=W,this.end=oe,this.kind=ye}};Jt=je([w],Jt),e.FoldingRange=Jt;var sn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(pn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class Nt{constructor(W,oe=[]){this.tokenTypes=W,this.tokenModifiers=oe}}e.SemanticTokensLegend=Nt;function vn(j){return typeof j=="undefined"||(0,C.isStringArray)(j)}class xt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let oe=0,ye=W.tokenTypes.length;oe<ye;oe++)this._tokenTypeStrToInt.set(W.tokenTypes[oe],oe);for(let oe=0,ye=W.tokenModifiers.length;oe<ye;oe++)this._tokenModifierStrToInt.set(W.tokenModifiers[oe],oe)}}push(W,oe,ye,Ve,Je){if(typeof W=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(W,oe,ye,Ve,Je);if(I.isRange(W)&&typeof oe=="string"&&vn(ye))return this._push(W,oe,ye);throw(0,y.illegalArgument)()}_push(W,oe,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ve=W.start.line,Je=W.start.character,it=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(oe);let bt=0;if(ye)for(const kt of ye){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(kt);bt|=1<<Pt>>>0}this._pushEncoded(Ve,Je,it,dt,bt)}_pushEncoded(W,oe,ye,Ve,Je){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const bt=this._data.length/5|0;let kt=0,Pt=0;for(let At=0;At<bt;At++){let Rt=this._data[5*At],tn=this._data[5*At+1];Rt===0?(Rt=kt,tn+=Pt):Rt+=kt,this._data[5*At]=Rt,this._data[5*At+1]=tn,kt=Rt,Pt=tn}}let it=W,dt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(it-=this._prevLine,it===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=it,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Je,this._prevLine=W,this._prevChar=oe}static _sortAndDeltaEncode(W){let oe=[];const ye=W.length/5|0;for(let dt=0;dt<ye;dt++)oe[dt]=dt;oe.sort((dt,bt)=>{const kt=W[5*dt],Pt=W[5*bt];if(kt===Pt){const At=W[5*dt+1],Rt=W[5*bt+1];return At-Rt}return kt-Pt});const Ve=new Uint32Array(W.length);let Je=0,it=0;for(let dt=0;dt<ye;dt++){const bt=5*oe[dt],kt=W[bt+0],Pt=W[bt+1],At=W[bt+2],Rt=W[bt+3],tn=W[bt+4],Rn=kt-Je,Nn=Rn===0?Pt-it:Pt,nn=5*dt;Ve[nn+0]=Rn,Ve[nn+1]=Nn,Ve[nn+2]=At,Ve[nn+3]=Rt,Ve[nn+4]=tn,Je=kt,it=Pt}return Ve}build(W){return this._dataIsSortedAndDeltaEncoded?new Wt(new Uint32Array(this._data),W):new Wt(xt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=xt;class Wt{constructor(W,oe){this.resultId=oe,this.data=W}}e.SemanticTokens=Wt;class wn{constructor(W,oe,ye){this.start=W,this.deleteCount=oe,this.data=ye}}e.SemanticTokensEdit=wn;class _n{constructor(W,oe){this.resultId=oe,this.edits=W}}e.SemanticTokensEdits=_n;var Tt;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Tt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new st("arrow-left")},Kt=je([w],Kt),e.QuickInputButtons=Kt;var En;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(En=e.ExtensionKind||(e.ExtensionKind={}));class Sn{constructor(W,oe,ye){this.badge=W,this.tooltip=oe,this.color=ye}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Sn;let $t=class{constructor(W){this.kind=W}};$t=je([w],$t),e.ColorTheme=$t;var an;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class ln{constructor(W,oe){if(W<0)throw(0,y.illegalArgument)("start must be positive");if(oe<W)throw(0,y.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=oe}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=ln;class Bt{constructor(W,oe,ye,Ve,Je,it,dt){this.editable=W,this.breakpointMargin=oe,this.hasExecutionOrder=ye,this.statusMessage=Ve,this.inputCollapsed=Je,this.outputCollapsed=it,this.custom=dt}with(W){let{editable:oe,breakpointMargin:ye,hasExecutionOrder:Ve,statusMessage:Je,inputCollapsed:it,outputCollapsed:dt,custom:bt}=W;return oe===void 0?oe=this.editable:oe===null&&(oe=void 0),ye===void 0?ye=this.breakpointMargin:ye===null&&(ye=void 0),Ve===void 0?Ve=this.hasExecutionOrder:Ve===null&&(Ve=void 0),Je===void 0?Je=this.statusMessage:Je===null&&(Je=void 0),it===void 0?it=this.inputCollapsed:it===null&&(it=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),bt===void 0?bt=this.custom:bt===null&&(bt=void 0),oe===this.editable&&ye===this.breakpointMargin&&Ve===this.hasExecutionOrder&&Je===this.statusMessage&&it===this.inputCollapsed&&dt===this.outputCollapsed&&bt===this.custom?this:new Bt(oe,ye,Ve,Je,it,dt,bt)}}e.NotebookCellMetadata=Bt;class Fe{constructor(W=!0,oe=!0,ye=!0,Ve={},Je=!0){this.editable=W,this.cellEditable=oe,this.cellHasExecutionOrder=ye,this.custom=Ve,this.trusted=Je}with(W){let{editable:oe,cellEditable:ye,cellHasExecutionOrder:Ve,custom:Je,trusted:it}=W;return oe===void 0?oe=this.editable:oe===null&&(oe=void 0),ye===void 0?ye=this.cellEditable:ye===null&&(ye=void 0),Ve===void 0?Ve=this.cellHasExecutionOrder:Ve===null&&(Ve=void 0),Je===void 0?Je=this.custom:Je===null&&(Je=void 0),it===void 0?it=this.trusted:it===null&&(it=void 0),oe===this.editable&&ye===this.cellEditable&&Ve===this.cellHasExecutionOrder&&Je===this.custom&&it===this.trusted?this:new Fe(oe,ye,Ve,Je,it)}}e.NotebookDocumentMetadata=Fe;class Yt{constructor(W,oe,ye,Ve,Je,it){this.kind=W,this.source=oe,this.language=ye,this.outputs=Ve!=null?Ve:[],this.metadata=Je,this.latestExecutionSummary=it}}e.NotebookCellData=Yt;class Zt{constructor(W,oe){this.cells=W,this.metadata=oe!=null?oe:new Fe}}e.NotebookData=Zt;class mt{constructor(W,oe,ye){this.mime=W,this.value=oe,this.metadata=ye}static isNotebookCellOutputItem(W){return W instanceof mt}}e.NotebookCellOutputItem=mt;class yn{constructor(W,oe,ye){this.outputs=W,typeof oe=="string"?(this.id=oe,this.metadata=ye):(this.id=(0,D.generateUuid)(),this.metadata=oe!=null?oe:ye)}}e.NotebookCellOutput=yn;var Dn;(function(j){j[j.Markdown=1]="Markdown",j[j.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var cn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var un;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(un=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Cn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let en=class{constructor(W,oe){this.label=W,this.timestamp=oe}};en=je([w],en),e.TimelineItem=en;var kn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var dn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(dn=e.StandardTokenType||(e.StandardTokenType={}));class Pn{constructor(W,oe){this.ranges=W,this.wordPattern=oe}}e.LinkedEditingRanges=Pn;var An;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(An=e.TestResult||(e.TestResult={}));var hn;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(hn=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const Gt=(j,W,oe)=>{let ye=oe;return{enumerable:!0,configurable:!1,get(){return ye},set(Ve){var Je;(Je=j[e.TestItemHookProperty])===null||Je===void 0||Je.setProp(W,Ve),ye=Ve}}};class fn{constructor(W){m.set(this,new Map),a.set(this,void 0),tt(this,a,W)}get size(){return Be(this,m).size}add(W){const oe=Be(this,m),ye=Be(this,a).call(this),Ve=oe.get(W.id);Ve!==W&&(Ve&&(ye==null||ye.delete(W.id)),oe.set(W.id,W),ye==null||ye.created(W))}get(W){return Be(this,m).get(W)}clear(){for(const W of Be(this,m).keys())this.delete(W)}delete(W){var oe;const ye=typeof W=="string"?W:W.id;Be(this,m).has(ye)&&(Be(this,m).delete(ye),(oe=Be(this,a).call(this))===null||oe===void 0||oe.delete(ye))}toJSON(){return[...Be(this,m).values()]}[(m=new WeakMap,a=new WeakMap,Symbol.iterator)](){return Be(this,m).values()}}e.TestChildrenCollection=fn;class re{constructor(W,oe,ye){this.label=oe,this.expandable=ye,Object.defineProperties(this,{id:{value:W,enumerable:!0,writable:!1},children:{value:new fn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},location:Gt(this,"location",void 0),description:Gt(this,"description",void 0),runnable:Gt(this,"runnable",!0),debuggable:Gt(this,"debuggable",!0)})}invalidate(){var W;(W=this[e.TestItemHookProperty])===null||W===void 0||W.invalidate(this.id)}discoverChildren(W,oe){W.report({busy:!1})}}e.TestItem=re;class de{constructor(W){this.state=W,this.messages=[]}}e.TestState=de;class Pe{constructor(W){this.message=W,this.severity=hn.Error}static diff(W,oe,ye){const Ve=new Pe(W);return Ve.expectedOutput=oe,Ve.actualOutput=ye,Ve}}e.TestMessage=Pe;var lt;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(lt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var _t;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unknown=2]="Unknown"})(_t=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Dt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore"})(Dt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(pe[118],ve([0,1,52,11,10,143,105,7,14]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(a,p){p?n.set(a,p):n.delete(a)}e.setWordDefinitionFor=T;function k(a){return n.get(a)}e.getWordDefinitionFor=k;class b extends P.MirrorTextModel{constructor(p,S,v,_,c,u,s,t){super(S,v,_,c);this._proxy=p,this._languageId=u,this._isDirty=s,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,D.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===y.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(S){return S?p._getTextInRange(S):p.getText()},get eol(){return p._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(S){return p._lineAt(S)},offsetAt(S){return p._offsetAt(S)},positionAt(S){return p._positionAt(S)},validateRange(S){return p._validateRange(S)},validatePosition(S){return p._validatePosition(S)},getWordRangeAtPosition(S,v){return p._getWordRangeAtPosition(S,v)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,E.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,E.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const S=this._validateRange(p);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const v=this._eol,_=S.start.line,c=S.end.line,u=[];u.push(this._lines[_].substring(S.start.character));for(let s=_+1;s<c;s++)u.push(this._lines[s]);return u.push(this._lines[c].substring(0,S.end.character)),u.join(v)}_lineAt(p){let S;if(p instanceof A.Position?S=p.line:typeof p=="number"&&(S=p),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new m(S,this._lines[S],S===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(p),v=this._lines[S.index].length;return new A.Position(S.index,Math.min(S.remainder,v))}_validateRange(p){if(!(p instanceof A.Range))throw new Error("Invalid argument");const S=this._validatePosition(p.start),v=this._validatePosition(p.end);return S===p.start&&v===p.end?p:new A.Range(S.line,S.character,v.line,v.character)}_validatePosition(p){if(!(p instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:S,character:v}=p,_=!1;if(S<0)S=0,v=0,_=!0;else if(S>=this._lines.length)S=this._lines.length-1,v=this._lines[S].length,_=!0;else{const c=this._lines[S].length;v<0?(v=0,_=!0):v>c&&(v=c,_=!0)}return _?new A.Position(S,v):p}_getWordRangeAtPosition(p,S){const v=this._validatePosition(p);if(!S)S=k(this._languageId);else if((0,R.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const _=(0,C.getWordAtText)(v.character+1,(0,C.ensureValidWordDefinition)(S),this._lines[v.line],0);if(_)return new A.Range(v.line,_.startColumn-1,v.line,_.endColumn-1)}}e.ExtHostDocumentData=b;class m{constructor(p,S,v){this._line=p,this._text=S,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(pe[195],ve([0,1,7,3,107,6,76,23,2,28]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(b,m,a,p){this._notebook=a,this._selector=p,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(v=>{const _=this._cellUris.get(v.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(v=>S(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const b=[],m=[];for(const a of this._notebook.cells)a.kind===E.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),b.push(a.document.getText().length+1),m.push(a.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(b){var m,a;if(!b){let c="";for(const u of this._cells)c+=u.document.getText()+`
`;return c=c.slice(0,-1),c}if(b.isEmpty)return"";const p=this.locationAt(b.start),S=this.locationAt(b.end),v=this._cells[(m=this._cellUris.get(p.uri))!==null&&m!==void 0?m:-1],_=this._cells[(a=this._cellUris.get(S.uri))!==null&&a!==void 0?a:-1];if(!v||!_)return"";if(v===_)return v.document.getText(new E.Range(p.range.start,S.range.end));{const c=v.document.getText(new E.Range(p.range.start,new E.Position(v.document.lineCount,0))),u=_.document.getText(new E.Range(new E.Position(0,0),S.range.end));return c+`
`+u}}offsetAt(b){const m=this._cellLines.getIndexOf(b.line),a=this._cellLengths.getAccumulatedValue(m.index-1),p=this._cells[m.index].document.offsetAt(b.with(m.remainder));return a+p}positionAt(b){if(typeof b=="number"){const a=this._cellLengths.getIndexOf(b),p=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(p)}const m=this._cellUris.get(b.uri);if(m!==void 0){const a=this._cellLines.getAccumulatedValue(m-1);return new E.Position(a+b.range.start.line,b.range.start.character)}return new E.Position(0,0)}locationAt(b){E.Range.isRange(b)||(b=new E.Range(b,b));const m=this._cellLines.getIndexOf(b.start.line);let a=m;b.isEmpty||(a=this._cellLines.getIndexOf(b.end.line));const p=new E.Position(m.remainder,b.start.character),S=new E.Position(a.remainder,b.end.character),v=new E.Range(p,S),_=this._cells[m.index];return new E.Location(_.document.uri,_.document.validateRange(v))}contains(b){return this._cellUris.has(b)}validateRange(b){const m=this.validatePosition(b.start),a=this.validatePosition(b.end);return b.with(m,a)}validatePosition(b){const m=this._cellLines.getIndexOf(b.line),a=new E.Position(m.remainder,b.character),p=this._cells[m.index].document.validatePosition(a),S=this._cellLines.getAccumulatedValue(m.index-1);return new E.Position(S+p.line,p.character)}}e.ExtHostNotebookConcatDocument=T}),define(pe[196],ve([0,1,7,13,3]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(A){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let D=A==="light"?E.ColorThemeKind.Light:A==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([Ue(0,y.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(pe[61],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class y{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=y}),define(pe[84],ve([0,1,2]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function y(P,C,A){const D=P.webviewResourceRoot.replace("{{resource}}",A.scheme+R(A)).replace("{{uuid}}",C);return E.URI.parse(D)}e.asWebviewUri=y;function R(P){return P.toString().replace(/^\S+?:/,"")}}),define(pe[197],ve([0,1,3,6,84,28]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(D,n,T){this._proxy=D,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const b of this._insets.values())k.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,n,T,k,b){let m;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===D){m=u;break}if(!m)throw new Error("not a visible editor");const a=this,p=this._handlePool++,S=new E.Emitter,v=new E.Emitter,_=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,R.asWebviewUri)(a._initData,this._uuid,u)}get cspSource(){return a._initData.webviewCspSource}set options(u){this._options=u,a._proxy.$setOptions(p,u)}get options(){return this._options}set html(u){this._html=u,a._proxy.$setHtml(p,u)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(u){return a._proxy.$postMessage(p,u)}},c=new class{constructor(){this.editor=D,this.line=n,this.height=T,this.webview=_,this.onDidDispose=v.event}dispose(){a._insets.has(p)&&(a._insets.delete(p),a._proxy.$disposeEditorInset(p),v.fire(),v.dispose(),S.dispose())}};return this._proxy.$createEditorInset(p,m.id,m.value.document.uri,n+1,T,k||{},b.identifier,b.extensionLocation),this._insets.set(p,{editor:D,inset:c,onDidReceiveMessage:S}),c}$onDidDispose(D){const n=this._insets.get(D);n&&n.inset.dispose()}$onDidReceiveMessage(D,n){const T=this._insets.get(D);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=C}),define(pe[198],ve([0,1,3,80,167,4,6,23,40,14,53,22,47,191]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",b.Codicon.window,(0,R.localize)(0,null));var a;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var p;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(p=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function v(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=v;class _ extends C.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(h,g,w){var d;const f=this.get(h.id);if(f)return f;const I=h;return I.openCommandActionDescriptor=(w==null?void 0:w.donotRegisterOpenCommand)?void 0:(d=I.openCommandActionDescriptor)!==null&&d!==void 0?d:{id:I.id},(0,A.getOrSet)(this.viewContainers,g,[]).push(I),(w==null?void 0:w.isDefault)&&this.defaultViewContainers.push(I),this._onDidRegister.fire({viewContainer:I,viewContainerLocation:g}),I}deregisterViewContainer(h){for(const g of this.viewContainers.keys()){const w=this.viewContainers.get(g),d=w==null?void 0:w.indexOf(h);if(d!==-1){w==null||w.splice(d,1),w.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:g});return}}}get(h){return this.all.filter(g=>g.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(w=>(w==null?void 0:w.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===h)}}D.Registry.add(a.ViewContainersRegistry,new _);var c;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function u(l,h){var g,w,d,f;const I=(g=l.group)!==null&&g!==void 0?g:c.More,L=(w=h.group)!==null&&w!==void 0?w:c.More;return I!==L?I.localeCompare(L):((d=l.order)!==null&&d!==void 0?d:5)-((f=h.order)!==null&&f!==void 0?f:5)}class s extends C.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(h,g){this.registerViews2([{views:h,viewContainer:g}])}registerViews2(h){h.forEach(({views:g,viewContainer:w})=>this.addViews(g,w)),this._onViewsRegistered.fire(h)}deregisterViews(h,g){const w=this.removeViews(h,g);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:g})}moveViews(h,g){for(const w of this._views.keys())if(w!==g){const d=this.removeViews(h,w);d.length&&(this.addViews(d,g),this._onDidChangeContainer.fire({views:d,from:w,to:g}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const g of this._viewContainers){const w=(this._views.get(g)||[]).filter(d=>d.id===h)[0];if(w)return w}return null}getViewContainer(h){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(d=>d.id===h)[0])return g;return null}registerViewWelcomeContent(h,g){return this._viewWelcomeContents.add(h,g),this._onDidChangeViewWelcomeContent.fire(h),(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(h,g),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,g){const w=new Map;for(const[d,f]of g)this._viewWelcomeContents.add(h,f),w.set(d,(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(h,f),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),w}getViewWelcomeContent(h){const g=[];return this._viewWelcomeContents.forEach(h,w=>g.push(w)),g.sort(u)}addViews(h,g){let w=this._views.get(g);w||(w=[],this._views.set(g,w),this._viewContainers.push(g));for(const d of h){if(this.getView(d.id)!==null)throw new Error((0,R.localize)(1,null,d.id));w.push(d)}}removeViews(h,g){const w=this._views.get(g);if(!w)return[];const d=[],f=[];for(const I of w)h.includes(I)?d.push(I):f.push(I);return d.length&&(f.length?this._views.set(g,f):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),d}}D.Registry.add(a.ViewsRegistry,new s),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new y.RawContextKey("focusedView","",(0,R.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(h,g){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,h),this._hasResolve=!!g,this.resolve=async w=>{var d,f;if(g&&!this.resolved){const I=await g(w);I&&(this.tooltip=(d=this.tooltip)!==null&&d!==void 0?d:I.tooltip,this.command=(f=this.command)!==null&&f!==void 0?f:I.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(pe[199],ve([0,1,2,178,115,12,179,198]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(p){return(S,...v)=>p(S.get(y.ICommandService),...v)}class n{static execute(S,v){const _={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return S.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",y.CommandsRegistry.registerCommand({id:n.ID,handler:D(n.execute),description:{description:"Opens an new window",args:[]}}),y.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(p,S){return p.get(R.IWorkspacesService).removeRecentlyOpened([S])});class T{static execute(S,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?E.URI.parse(v):E.URI.file(v):v=E.URI.revive(v),S.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",y.CommandsRegistry.registerCommand(T.ID,D(T.execute));class k{static execute(S,v){const _=typeof v=="string"?{extensionId:v}:v;return S.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",y.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(p,S){const v=p.get(R.IWorkspacesService);let _;const c=S.uri,u=S.label,s=S.remoteAuthority;return S.type==="workspace"?_={workspace:await v.getWorkspaceIdentifier(c),label:u,remoteAuthority:s}:S.type==="folder"?_={folderUri:c,label:u,remoteAuthority:s}:_={fileUri:c,label:u,remoteAuthority:s},v.addRecentlyOpened([_])}),y.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(p){return p.get(R.IWorkspacesService).getRecentlyOpened()}),y.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(p,S){const v=p.get(P.ILogService),_=p.get(C.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&v.setLevel(S)}),y.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(p){return p.get(P.ILogService).getLevel()}),y.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(p,S){const v=p.get(A.IViewDescriptorService),_=v.getViewContainerById(S.destinationId);if(!!_){for(const c of S.viewIds){const u=v.getViewDescriptorById(c);(u==null?void 0:u.canMoveView)&&v.moveViewsToContainer([u],_,A.ViewVisibilityState.Default)}await p.get(A.IViewsService).openViewContainer(_.id,!0)}});class b{static execute(S,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=b,b.ID="vscode.moveViews",y.CommandsRegistry.registerCommand({id:b.ID,handler:D(b.execute),description:{description:"Move Views",args:[]}});class m{static execute(S,v){return S.executeCommand("_workbench.open",v)}}m.ID="vscode.open",y.CommandsRegistry.registerCommand(m.ID,D(m.execute));class a{static execute(S,v,_,c,u){return S.executeCommand("_workbench.diff",[v,_,c])}}a.ID="vscode.diff",y.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(pe[119],ve([0,1,3,17,168]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,D,n,T){const k={command:A};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.internalSend("request",k),typeof T=="number"){const b=setTimeout(()=>{clearTimeout(b);const m=this.pendingRequests.get(k.seq);if(m){this.pendingRequests.delete(k.seq);const a={type:"response",seq:0,request_seq:k.seq,success:!1,command:A,message:(0,R.localize)(0,null,T,A)};m(a)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,D){return A.type!=="event"||D.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,y.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const D=A,n=this.pendingRequests.get(D.request_seq);n&&(this.pendingRequests.delete(D.request_seq),n(D));break}}}internalSend(A,D){D.type=A,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((D,n)=>A.set(n,D)),await(0,y.timeout)(500),A.forEach((D,n)=>{D({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(pe[200],ve([0,1,10,2,8,22,11]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function D(i,o,r){return i.replace(A,function(l,h){return o&&h.length>0&&h[0]!=="_"?l:r&&r.hasOwnProperty(h)?r[h]:l})}e.formatPII=D;function n(i){const o={};for(const r of Object.keys(i))r.startsWith("!")||(o[r]=i[r]);return o}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=T;function k(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(o,"extensionhost")||(0,E.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function b(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=b;function m(i,o,r){let l,h=0,g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=g.exec(i);){let d=w.index+1,f=d+w[0].length;if(d<=o&&f>=r){l=w[0],h=d;break}}if(l){let d=/\w+/g,f=null;for(;(f=d.exec(l))&&!(f.index+1+h+f[0].length>=r););f&&(l=l.substring(0,d.lastIndex))}return l?{start:h,end:h+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(i){return!!(i&&i.match(a))}e.isUri=p;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(p(i.path))return y.URI.parse(i.path);if((0,R.isAbsolute)(i.path))return y.URI.file(i.path)}return i.path}function v(i){if(typeof i.path=="object"){const o=y.URI.revive(i.path);if(o)return o.scheme===C.Schemas.file?o.fsPath:o.toString()}return i.path}function _(i,o){const r=o?S:v,l=(0,P.deepClone)(i);return u(l,(h,g)=>{h&&g&&(g.path=r(g))}),l}e.convertToDAPaths=_;function c(i,o){const r=o?S:v,l=(0,P.deepClone)(i);return u(l,(h,g)=>{!h&&g&&(g.path=r(g))}),l}e.convertToVSCPaths=c;function u(i,o){switch(i.type){case"event":const r=i;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":o(!0,l.arguments.source);break;case"breakpointLocations":o(!0,l.arguments.source);break;case"source":o(!0,l.arguments.source);break;case"gotoTargets":o(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(g=>o(!1,g));break;default:break}break;case"response":const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(g=>o(!1,g.source));break;case"loadedSources":h.body.sources.forEach(g=>o(!1,g));break;case"scopes":h.body.scopes.forEach(g=>o(!1,g.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(g=>o(!1,g.source));break;case"setBreakpoints":h.body.breakpoints.forEach(g=>o(!1,g.source));break;default:break}break}}function s(i){return i.filter(o=>{var r;return!((r=o.presentation)===null||r===void 0?void 0:r.hidden)}).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):t(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=s;function t(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}}),define(pe[201],ve([0,1,26,38,169,120,8,10,22,9,180,119]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class b extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",u=>this.handleData(u))}sendMessage(_){if(this.outputStream){const c=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${b.TWO_CRLF}${c}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+c))}continue}}else{const c=this.rawData.indexOf(b.TWO_CRLF);if(c!==-1){const s=this.rawData.toString("utf8",0,c).split(b.HEADER_LINESEPARATOR);for(const t of s){const i=t.split(b.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(c+b.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=b,b.TWO_CRLF=`\r
\r
`,b.HEADER_LINESEPARATOR=/\r?\n/,b.HEADER_FIELDSEPARATOR=/: */;class m extends b{startSession(){return new Promise((_,c)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",s=>{u?this._onError.fire(s):c(s)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class a extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=a;class p extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return P.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=p;class S extends b{constructor(_,c,u){super();this.adapterExecutable=_,this.debugType=c,this.outputService=u}async startSession(){const _=this.adapterExecutable.command,c=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(_)if(C.isAbsolute(_)){if(!await(0,E.exists)(_))throw new Error(R.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(R.localize(1,null,this.debugType));let s=process.env;if(u.env&&Object.keys(u.env).length>0&&(s=D.mixin(D.deepClone(process.env),u.env)),_==="node")if(Array.isArray(c)&&c.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(o.cwd=u.cwd);const r=y.fork(c[0],c.slice(1),o);if(!r.pid)throw new Error(R.localize(2,null,c[0]));this.serverProcess=r}else throw new Error(R.localize(3,null));else{const i={env:s};u.cwd&&(i.cwd=u.cwd),this.serverProcess=y.spawn(_,c,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,o)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const r=t.getChannel(T.ExtensionsChannelId);r&&r.append(i(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(s){this._onError.fire(s)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((_,c)=>{const u=y.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(s,t,i){if(s)return c(s)});u.on("exit",_),u.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,c){if(!!_){const u=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?u.runtime=C.join(c,_.runtime):u.runtime=_.runtime),_.runtimeArgs&&(u.runtimeArgs=_.runtimeArgs),_.program&&(C.isAbsolute(_.program)?u.program=_.program:u.program=C.join(c,_.program)),_.args&&(u.args=_.args);const s=_;return s.win&&(u.win=S.extract(s.win,c)),s.winx86&&(u.winx86=S.extract(s.winx86,c)),s.windows&&(u.windows=S.extract(s.windows,c)),s.osx&&(u.osx=S.extract(s.osx,c)),s.linux&&(u.linux=S.extract(s.linux,c)),u}}static platformAdapterExecutable(_,c){let u=Object.create(null);c=c.toLowerCase();for(const l of _)if(l.contributes){const h=l.contributes.debuggers;h&&h.length>0&&h.filter(g=>typeof g.type=="string"&&A.equalsIgnoreCase(g.type,c)).forEach(g=>{const w=S.extract(g,l.extensionLocation.fsPath);u=D.mixin(u,w,l.isBuiltin)})}let s;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=u.winx86||u.win||u.windows:n.isWindows?s=u.win||u.windows:n.isMacintosh?s=u.osx:n.isLinux&&(s=u.linux),s=s||u;let t=s.program||u.program;const i=s.args||u.args;let o=s.runtime||u.runtime;const r=s.runtimeArgs||u.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(pe[202],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(pe[203],ve([0,1,38,8,77,170,26,9,83,4,202,11]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=P.localize(0,null);let m=class Ht{constructor(c){this._configurationService=c}openTerminal(c){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(E,u,R.getWindowsShell(),c)}}runInTerminal(c,u,s,t,i){const o=i.windowsExec||Ht.getDefaultTerminalWindows();return new Promise((r,l)=>{const h=`"${u} - ${b}"`,g=`""${s.join('" "')}" & pause"`,w=["/c","start",h,"/wait",o,"/c",g],d=Object.assign({},process.env,t);Object.keys(d).filter(L=>d[L]===null).forEach(L=>delete d[L]);const f={cwd:u,env:d,windowsVerbatimArguments:!0};E.spawn(Ht.CMD,w,f).on("error",L=>{l(S(L))}),r(void 0)})}spawnTerminal(c,u,s,t){const o=u.terminal.external.windowsExec||Ht.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=y.basename(o).toLowerCase();if(r==="cmder"||r==="cmder.exe")return c.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return o.indexOf(" ")>=0&&l.push('""'),l.push(o),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((h,g)=>{const w=t?{cwd:t}:void 0,d=c.spawn(s,l,w);d.on("error",g),d.on("exit",()=>h())})}static getDefaultTerminalWindows(){if(!Ht._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ht._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return Ht._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=je([Ue(0,(0,n.optional)(D.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let a=class Ln{constructor(c){this._configurationService=c}openTerminal(c){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(E,u,c)}}runInTerminal(c,u,s,t,i){const o=i.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(o===T.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const h=o===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,Z).fsPath,"-t",c||b,"-w",u];for(let I of s)w.push("-a"),w.push(I);if(t)for(let I in t){const L=t[I];L===null?(w.push("-u"),w.push(I)):(w.push("-e"),w.push(`${I}=${L}`))}let d="";const f=E.spawn(Ln.OSASCRIPT,w);f.on("error",I=>{l(S(I))}),f.stderr.on("data",I=>{d+=I.toString()}),f.on("exit",I=>{if(I===0)r(void 0);else if(d){const L=d.split(`
`,1);l(new Error(L[0]))}else l(new Error(P.localize(1,null,h,I)))})}else l(new Error(P.localize(2,null,o)))})}spawnTerminal(c,u,s){const i=u.terminal.external.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{const l=["-a",i];s&&l.push(s);const h=c.spawn("/usr/bin/open",l);h.on("error",r),h.on("exit",()=>o())})}};a.OSASCRIPT="/usr/bin/osascript",a=je([Ue(0,(0,n.optional)(D.IConfigurationService))],a),e.MacExternalTerminalService=a;let p=class zt{constructor(c){this._configurationService=c}openTerminal(c){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(E,u,c)}}runInTerminal(c,u,s,t,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{let h=[];o.then(g=>{g.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const w=`${v(s)}; echo; read -p "${zt.WAIT_MESSAGE}" -n1;`;h.push(`''${w}''`);const d=Object.assign({},process.env,t);Object.keys(d).filter(B=>d[B]===null).forEach(B=>delete d[B]);const f={cwd:u,env:d};let I="";const L=E.spawn(g,h,f);L.on("error",B=>{l(S(B))}),L.stderr.on("data",B=>{I+=B.toString()}),L.on("exit",B=>{if(B===0)r(void 0);else if(I){const ee=I.split(`
`,1);l(new Error(ee[0]))}else l(new Error(P.localize(4,null,g,B)))})})})}spawnTerminal(c,u,s){const t=u.terminal.external,i=t.linuxExec?Promise.resolve(t.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{i.then(l=>{const h=s?{cwd:s}:void 0,g=c.spawn(l,[],h);g.on("error",r),g.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return zt._DEFAULT_TERMINAL_LINUX_READY||(zt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async c=>{A.isLinux?await C.exists("/etc/debian_version")?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm"):c("xterm")})),zt._DEFAULT_TERMINAL_LINUX_READY}};p.WAIT_MESSAGE=P.localize(3,null),p=je([Ue(0,(0,n.optional)(D.IConfigurationService))],p),e.LinuxExternalTerminalService=p;function S(_){return"errno"in _&&_.errno==="ENOENT"&&"path"in _&&typeof _.path=="string"?new Error(P.localize(5,null,_.path)):_}function v(_){let c="";for(let u of _)u.indexOf(" ")>=0?c+='"'+u+'"':c+=u,c+=" ";return c}}),define(pe[204],ve([0,1,38,9,203,31]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let C;function A(b,m){if(!C)if(y.isWindows)C=new R.WindowsExternalTerminalService(void 0);else if(y.isMacintosh)C=new R.MacExternalTerminalService(void 0);else if(y.isLinux)C=new R.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=m.getConfiguration("terminal");return C.runInTerminal(b.title,b.cwd,b.args,b.env||{},a.external||{})}e.runInExternalTerminal=A;function D(b,m){return new Promise((a,p)=>{let S="";const v=E.spawn(b,m);v.pid&&v.stdout.on("data",_=>{S+=_.toString()}),v.on("error",_=>{p(_)}),v.on("close",_=>{a(S)})})}function n(b){return b?y.isWindows?D("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(p=>parseInt(p)===b),m=>!0):D("/usr/bin/pgrep",["-lP",String(b)]).then(m=>{const a=m.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var T;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(T||(T={}));function k(b,m,a,p){b=b.trim().toLowerCase();let S;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?S=1:b.indexOf("cmd.exe")>=0?S=0:b.indexOf("bash")>=0?S=2:y.isWindows?S=0:S=2;let v,_=" ";switch(S){case 1:if(v=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),a){const u=(0,P.getDriveLetter)(a);u&&(_+=`${u}:; `),_+=`cd ${v(a)}; `}if(p)for(let u in p){const s=p[u];s===null?_+=`Remove-Item env:${u}; `:_+=`\${env:${u}}='${s}'; `}if(m.length>0){const u=v(m.shift());_+=u[0]==="'"?`& ${u} `:`${u} `;for(let s of m)_+=`${v(s)} `}break;case 0:if(v=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),a){const u=(0,P.getDriveLetter)(a);u&&(_+=`${u}: && `),_+=`cd ${v(a)} && `}if(p){_+='cmd /C "';for(let u in p){let s=p[u];s===null?_+=`set "${u}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${u}=${s}" && `)}}for(let u of m)_+=`${v(u)} `;p&&(_+='"');break;case 2:v=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const c=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(a&&(_+=`cd ${v(a)} ; `),p){_+="/usr/bin/env";for(let u in p){const s=p[u];s===null?_+=` -u ${c(u)}`:_+=` ${c(`${u}=${s}`)}`}_+=" "}for(let u of m)_+=`${v(u)} `;break}return _}e.prepareCommand=k}),define(pe[85],ve([0,1,34,11,8,9,80]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(I){I[I.Markdown=1]="Markdown",I[I.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(I){I[I.Idle=1]="Idle",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.CellClearOutput=3]="CellClearOutput",I[I.CellsClearOutput=4]="CellsClearOutput",I[I.ChangeLanguage=5]="ChangeLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.Unknown=12]="Unknown"})(T=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.OutputsSplice=6]="OutputsSplice",I[I.Move=7]="Move",I[I.Unknown=8]="Unknown",I[I.CellContent=9]="CellContent",I[I.OutputItems=10]="OutputItems",I[I.PartialMetadata=11]="PartialMetadata"})(b=e.CellEditType||(e.CellEditType={}));function m(I){const L=a.parse(I);return L?L.notebook.toString():I.toString()}e.getCellUndoRedoComparisonKey=m;var a;(function(I){I.scheme=y.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function B($,F){return $.with({scheme:I.scheme,fragment:`ch${F.toString().padStart(7,"0")}${$.scheme!==y.Schemas.file?$.scheme:""}`})}I.generate=B;function ee($){if($.scheme===I.scheme){const F=L.exec($.fragment);if(!!F)return{handle:Number(F[1]),notebook:$.with({scheme:$.fragment.substr(F[0].length)||y.Schemas.file,fragment:null})}}}I.parse=ee;function H($,F){return $.with({scheme:y.Schemas.vscodeNotebookCellMetadata,fragment:`ch${F.toString().padStart(7,"0")}${$.scheme!==y.Schemas.file?$.scheme:""}`})}I.generateCellMetadataUri=H;function x($){if($.scheme===y.Schemas.vscodeNotebookCellMetadata){const F=L.exec($.fragment);if(!!F)return{handle:Number(F[1]),notebook:$.with({scheme:$.fragment.substr(F[0].length)||y.Schemas.file,fragment:null})}}}I.parseCellMetadataUri=x})(a=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(I){var L,B;return(B=(L=p.get(I))===null||L===void 0?void 0:L.alwaysSecure)!==null&&B!==void 0?B:!1}e.mimeTypeIsAlwaysSecure=S;function v(I){var L,B;return(B=(L=p.get(I))===null||L===void 0?void 0:L.supportedByCore)!==null&&B!==void 0?B:!1}e.mimeTypeSupportedByCore=v;function _(I){var L,B;return(B=(L=p.get(I))===null||L===void 0?void 0:L.mergeable)!==null&&B!==void 0?B:!1}e.mimeTypeIsMergeable=_;function c(I,L){return P.isWindows&&(I=I.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),E.match(I,L)}function u(I,L,B){let ee=0;for(let H=0;H<L.length;H++){if(c(L[H],I))return ee;ee++}for(let H=0;H<B.length;H++){if(c(B[H],I))return ee;ee++}return ee}function s(I,L,B){return I.sort((ee,H)=>u(ee,L,B)-u(H,L,B))}e.sortMimeTypes=s;function t(I,L,B,ee=(H,x)=>H===x){const H=[];function x(U,M,N){if(!(M===0&&N.length===0)){const O=H[H.length-1];O&&O.start+O.deleteCount===U?(O.deleteCount+=M,O.toInsert.push(...N)):H.push({start:U,deleteCount:M,toInsert:N})}}let $=0,F=0;for(;;){if($===I.length){x($,0,L.slice(F));break}if(F===L.length){x($,I.length-$,[]);break}const U=I[$],M=L[F];if(ee(U,M)){$+=1,F+=1;continue}B(M)?(x($,1,[]),$+=1):(x($,0,[M]),F+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new C.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(I){I.default="default",I.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(I){const L=I;return!!((typeof L.include=="string"||E.isRelativePattern(L.include))&&(typeof L.exclude=="string"||E.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=o;function r(I,L,B){if(Array.isArray(I.viewType)&&I.viewType.indexOf(L)>=0||I.viewType===L)return!0;if(I.filenamePattern){let ee=o(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,H=o(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(E.match(ee,(0,R.basename)(B.fsPath).toLowerCase()))return!(H&&E.match(H,(0,R.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r;class l{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let B=0;B<this.textModel.cells.length;B++)L[B]=this.textModel.cells[B].getHashValue();return L}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var h;(function(I){I[I.LEFT=0]="LEFT",I[I.RIGHT=1]="RIGHT"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function g(I){I.sort((B,ee)=>B-ee);const L=I.shift();return L===void 0?[]:I.reduce(function(B,ee){return ee<=B[0][1]?B[0][1]=ee+1:B.unshift([ee,ee+1]),B},[[L,L+1]]).reverse().map(B=>({start:B[0],end:B[1]}))}e.cellIndexesToRanges=g;function w(I){return I.reduce((B,ee)=>{for(let H=ee.start;H<ee.end;H++)B.push(H);return B},[])}e.cellRangesToIndexes=w;function d(I){const L=I.sort((ee,H)=>ee.start-H.start),B=L[0];return B?L.reduce((ee,H)=>{const x=ee[ee.length-1];return x.end>=H.start?x.end=Math.max(x.end,H.end):ee.push(H),ee},[B]):[]}e.reduceRanges=d;function f(I,L){return L.start>=I.start&&L.end<=I.end}e.cellRangeContains=f}),define(pe[205],ve([0,1,172,4,80]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new R.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new R.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new R.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,y.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[206],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=E;function y(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=y}),define(pe[207],ve([0,1,8,9,134]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(s,t){if(!!t)if(y.isWindows)for(const i in t){let o=i;for(const l in s)if(i.toLowerCase()===l.toLowerCase()){o=l;break}const r=t[i];C(s,o,r)}else Object.keys(t).forEach(i=>{const o=t[i];C(s,i,o)})}e.mergeEnvironments=P;function C(s,t,i){typeof i=="string"?s[t]=i:delete s[t]}function A(s,t,i,o){s.TERM_PROGRAM="vscode",t&&(s.TERM_PROGRAM_VERSION=t),T(s,o)&&(s.LANG=k(i)),s.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=A;function D(s,t){if(!!t)for(const i of Object.keys(t)){const o=t[i];o&&(s[i]=o)}}function n(s,t){return Object.keys(t).forEach(i=>{const o=t[i];if(typeof o=="string")try{t[i]=s(o)}catch(r){t[i]=o}}),t}function T(s,t){if(t==="on")return!0;if(t==="auto"){const i=s.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function k(s){const t=s?s.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=k;function b(s,t,i,o,r,l){if(s.cwd){const g=typeof s.cwd=="object"?s.cwd.fsPath:s.cwd,w=m(g,i);return a(w||g)}let h;return!s.ignoreConfigurationCwd&&r&&(i&&(r=m(r,i,l)),r&&(E.isAbsolute(r)?h=r:o&&(h=E.join(o.fsPath,r)))),h||(h=o?o.fsPath:t||""),a(h)}e.getCwd=b;function m(s,t,i){if(t)try{return t(s)}catch(o){i==null||i.error("Could not resolve terminal cwd",o);return}return s}function a(s){return y.platform===3&&s&&s[1]===":"?s[0].toUpperCase()+s.substr(1):s}function p(s){let t=s;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=p;function S(s,t){if(!!t)return i=>t.resolve(s,i)}e.createVariableResolver=S;function v(s,t,i,o,r,l,h,g,w=y.platform){let d=null;g&&(d=c(s,t,"automationShell",w)),d||(d=c(s,t,"shell",w));let f=d||i;if(w===3&&!o&&r){const I=E.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();f&&f.toLowerCase().indexOf(I)===0&&(f=E.join(r,"System32",f.substr(I.length+1)))}if(f&&w===3&&(f=f.replace(/\//g,"\\")),l)try{f=l(f)}catch(I){h.error("Could not resolve shell",I)}return f}e.getDefaultShell=v;function _(s,t,i,o,r,l=y.platform){if(i&&c(s,t,"automationShell",l))return[];const h=l===3?"windows":l===1?"osx":"linux",g=s(`terminal.integrated.shellArgs.${h}`);let w=(t?g.value:g.userValue)||g.defaultValue;if(!w)return[];if(typeof w=="string"&&l===3)return o?o(w):w;if(o){const d=[];for(const f of w)try{d.push(o(f))}catch(I){r.error(`Could not resolve terminal.integrated.shellArgs.${h}`,I),d.push(f)}w=d}return w}e.getDefaultShellArgs=_;function c(s,t,i,o=y.platform){const l=s(`terminal.integrated.${i}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?l.value:l.userValue)||l.defaultValue}function u(s,t,i,o,r,l,h){let g={};if(s.strictEnv)D(g,s.env);else{D(g,h);const w=Object.assign({},o?t.value:t.userValue);i&&(w&&n(i,w),s.env&&n(i,s.env)),(0,R.sanitizeProcessEnvironment)(g,"VSCODE_IPC_HOOK_CLI"),P(g,w),P(g,s.env),A(g,r,y.locale,l)}return g}e.createTerminalEnvironment=u});var rn=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],E;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),E={},y("next"),y("throw"),y("return"),E[Symbol.asyncIterator]=function(){return this},E);function y(P){E[P]=Z[P]&&function(C){return new Promise(function(A,D){C=Z[P](C),R(A,D,C.done,C.value)})}}function R(P,C,A,D){Promise.resolve(D).then(function(n){P({value:n,done:A})},C)}};define(pe[208],ve([0,1,37,9,8,100,188,38]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D;function n(v,_,c,u,s,t,i){const o=t||E.promises;return y.isWindows?T(v,o,_,c==null?void 0:c.showQuickLaunchWslProfiles,c==null?void 0:c.profiles.windows,u,s):p(o,_,v,y.isMacintosh?c==null?void 0:c.profiles.osx:c==null?void 0:c.profiles.linux,i,u,s)}e.detectAvailableProfiles=n;async function T(v,_,c,u,s,t,i){const o=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),r=`${process.env.windir}\\${o?"Sysnative":"System32"}`;let l=!1;(0,C.getWindowsBuildNumber)()>=16299&&(l=!0),await b();const h=new Map;v||(h.set("PowerShell",{source:"PowerShell"}),h.set("Git Bash",{source:"Git Bash"}),h.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"]}),h.set("Command Prompt",{path:[`${r}\\cmd.exe`]}));for(const[w,d]of Object.entries(s||{}))d===null&&h.delete(w),h.set(w,d);const g=await k(h.entries(),_,c,t,i);return(!v||v&&u)&&g.push(...await a(`${r}\\${l?"wsl.exe":"bash.exe"}`,u)),g}async function k(v,_,c,u,s){const t=[];for(const[i,o]of v)if(o!==null){let r,l;if("source"in o){const g=D==null?void 0:D.get(o.source);if(!g)continue;r=g.paths.slice(),l=g.args}else r=Array.isArray(o.path)?o.path:[o.path],l=o.args;for(let g=0;g<r.length;g++)r[g]=(u==null?void 0:u.resolve(s,r[g]))||r[g];const h=await S(i,r,_,l,c);h?t.push(h):c==null||c.trace("profile not validated",i,r)}return t}async function b(){if(!D){D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),D.set("Cygwin",{profileName:"Cygwin",paths:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"]});for(const v of await m())D.set(v.profileName,{profileName:v.profileName,paths:v.paths,args:v.args})}}async function m(){var v,_;const c=[];try{for(var u=rn((0,P.enumeratePowerShellInstallations)()),s;s=await u.next(),!s.done;){const t=s.value;c.push({profileName:t.displayName,paths:[t.exePath]})}}catch(t){v={error:t}}finally{try{s&&!s.done&&(_=u.return)&&await _.call(u)}finally{if(v)throw v.error}}return c}async function a(v,_){const c=[];if(_){const u=await new Promise((s,t)=>{A.exec("wsl.exe -l",{encoding:"utf16le"},(i,o)=>{if(i)return t("Problem occurred when getting wsl distros");s(o)})});if(u){const s=new RegExp(/[\r?\n]/),t=u.split(s).filter(i=>i.trim().length>0&&i!=="");t.shift();for(let i of t)i=i.replace(/ \(Default\)$/,""),i!==""&&(i.startsWith("docker-desktop")||c.push({profileName:`${i} (WSL)`,path:v,args:["-d",`${i}`]}));return c}}return[]}async function p(v,_,c,u,s,t,i){const o=new Map;if(!c){const r=await E.promises.readFile("/etc/shells","utf8"),l=s||r.split(`
`).filter(h=>h.trim().indexOf("#")!==0&&h.trim().length>0);for(const h of l){const g=(0,R.basename)(h);o.set(g,{path:h})}}for(const[r,l]of Object.entries(u||{}))l===null?o.delete(r):o.set(r,l);return await k(o.entries(),v,_,t,i)}async function S(v,_,c,u,s){if(_.length===0)return Promise.resolve(void 0);const t=_.shift();if(t==="")return S(v,_,c,u);if((0,R.basename)(t)===t)return{profileName:v,path:t,args:u};try{const i=await E.promises.stat((0,R.normalize)(t));if(i.isFile()||i.isSymbolicLink())return u?{profileName:v,path:t,args:u}:{profileName:v,path:t}}catch(i){s==null||s.info("error",i);try{const o=await E.promises.lstat((0,R.normalize)(t));if(o.isFile()||o.isSymbolicLink())return u?{profileName:v,path:t,args:u}:{profileName:v,path:t}}catch(o){}}return S(v,_,c,u)}}),define(pe[121],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const y=(D,n)=>{n.expand!==void 0&&(D.expand=n.expand),n.item!==void 0&&Object.assign(D.item,n.item)};e.applyTestItemUpdate=y;var R;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.DeltaRootsComplete=3]="DeltaRootsComplete",D[D.Retire=4]="Retire"})(R=e.TestDiffOpType||(e.TestDiffOpType={}));const P=(D,n)=>`${D}:${n.toString()}`;e.getTestSubscriptionKey=P;class C{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=C;class A{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const k of n)switch(k[0]){case 0:{const b=k[1];if(b.parent){if(this.items.has(b.parent)){const m=this.items.get(b.parent);m.children.add(b.item.extId);const a=this.createItem(b,m);this.items.set(b.item.extId,a),T.add(a)}}else{this.roots.add(b.item.extId);const m=this.createItem(b);this.items.set(b.item.extId,m),T.add(m)}b.expand===2&&this.updateBusyProviders(1);break}case 1:{const b=k[1],m=this.items.get(b.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,b),T.update(m),b.expand!==void 0&&m.expand===2&&b.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const b=this.items.get(k[1]);if(!b)break;b.parent?this.items.get(b.parent).children.delete(b.item.extId):this.roots.delete(b.item.extId);const m=[[k[1]]];for(;m.length;)for(const a of m.pop()){const p=this.items.get(a);p&&(m.push(p.children),this.items.delete(a),T.remove(p,p!==b),p.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}T.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=A}),define(pe[209],ve([0,1,8,30,15,22,9,75,173]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,b,m){if(this._contributedVariables=new Map,this._context=k,this._labelService=b,m)if(C.isWindows){const a=Object.create(null);this._envVariables=a,Object.keys(m).forEach(p=>{a[p.toLowerCase()]=m[p]})}else this._envVariables=m}resolve(k,b){return this.recursiveResolve(k?k.uri:void 0,b)}resolveAnyBase(k,b,m,a){const p=P.deepClone(b);return C.isWindows&&p.windows?Object.keys(p.windows).forEach(S=>p[S]=p.windows[S]):C.isMacintosh&&p.osx?Object.keys(p.osx).forEach(S=>p[S]=p.osx[S]):C.isLinux&&p.linux&&Object.keys(p.linux).forEach(S=>p[S]=p.linux[S]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(k?k.uri:void 0,p,m,a)}resolveAny(k,b,m){return this.resolveAnyBase(k,b,m)}resolveAnyMap(k,b,m){const a=new Map;return{newConfig:this.resolveAnyBase(k,b,m,a),resolvedVariables:a}}resolveWithInteractionReplace(k,b,m,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,b,m,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,b){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,b)}recursiveResolve(k,b,m,a){if(R.isString(b))return this.resolveString(k,b,m,a);if(R.isArray(b))return b.map(p=>this.recursiveResolve(k,p,m,a));if(R.isObject(b)){let p=Object.create(null);return Object.keys(b).forEach(S=>{const v=this.resolveString(k,S,m,a);p[v]=this.recursiveResolve(k,b[S],m,a)}),p}return b}resolveString(k,b,m,a){return b.replace(n.VARIABLE_REGEXP,(S,v)=>{if(v.includes(n.VARIABLE_LHS))return S;let _=this.evaluateSingleVariable(S,v,k,m);return a&&a.set(v,_),_})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,b,m,a){let p;const S=b.split(":");S.length>1&&(b=S[0],p=S[1]);const v=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,D.localize)(0,null,k))},_=()=>{const u=v();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,D.localize)(1,null,k,E.basename(u)))},c=()=>{if(p){const u=this._context.getFolderUri(p);if(u)return u;throw new Error((0,D.localize)(2,null,k,p))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,k)):new Error((0,D.localize)(4,null,k))};switch(b){case"env":if(p){if(this._envVariables){const u=this._envVariables[C.isWindows?p.toLowerCase():p];if(R.isString(u))return u}return""}throw new Error((0,D.localize)(5,null,k));case"config":if(p){const u=this._context.getConfigurationValue(m,p);if(R.isUndefinedOrNull(u))throw new Error((0,D.localize)(6,null,k,p));if(R.isObject(u))throw new Error((0,D.localize)(7,null,k,p));return u}throw new Error((0,D.localize)(8,null,k));case"command":return this.resolveFromMap(k,p,a,"command");case"input":return this.resolveFromMap(k,p,a,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return m||p?(0,A.normalizeDriveLetter)(this.fsPath(c())):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(c()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,D.localize)(9,null,k));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error((0,D.localize)(10,null,k));case"file":return v();case"fileWorkspaceFolder":return _();case"relativeFile":return m||p?E.relative(this.fsPath(c()),v()):v();case"relativeFileDirname":const t=E.dirname(v());if(m||p){const l=E.relative(this.fsPath(c()),t);return l.length===0?".":l}return t;case"fileDirname":return E.dirname(v());case"fileExtname":return E.extname(v());case"fileBasename":return E.basename(v());case"fileBasenameNoExtension":const i=E.basename(v());return i.slice(0,i.length-E.extname(i).length);case"fileDirnameBasename":return E.basename(E.dirname(v()));case"execPath":const o=this._context.getExecPath();return o||k;case"execInstallFolder":const r=this._context.getAppRoot();return r||k;case"pathSeparator":return E.sep;default:try{const l=p?`${b}:${p}`:b;return this.resolveFromMap(k,l,a,void 0)}catch(l){return k}}}}resolveFromMap(k,b,m,a){if(b&&m){const p=a===void 0?m[b]:m[a+":"+b];if(typeof p=="string")return p;throw new Error((0,D.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[210],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var y;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var C;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var A;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(A=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.EDITOR_OPEN=2]="EDITOR_OPEN",b[b.EDITOR_CLOSE=3]="EDITOR_CLOSE",b[b.EDITOR_MOVE=4]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=6]="EDITOR_LABEL",b[b.EDITOR_PIN=7]="EDITOR_PIN",b[b.EDITOR_STICKY=8]="EDITOR_STICKY",b[b.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(pe[211],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(pe[20],ve([0,1,79,7,174,2,43,94,110,211,15,281,57,22,14,85]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(ce){function Ce(X){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:Ge}=X,rt=new y.Position(Re-1,Le-1),at=new y.Position(Ye-1,Ge-1);return new y.Selection(rt,at)}ce.to=Ce;function ue(X){const{anchor:Re,active:Le}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ce.from=ue})(S=e.Selection||(e.Selection={}));var v;(function(ce){function Ce(X){if(!!X){const{start:Re,end:Le}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}}ce.from=Ce;function ue(X){if(!!X){const{startLineNumber:Re,startColumn:Le,endLineNumber:Ye,endColumn:Ge}=X;return new y.Range(Re-1,Le-1,Ye-1,Ge-1)}}ce.to=ue})(v=e.Range||(e.Range={}));var _;(function(ce){function Ce(ue){switch(ue){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 4:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}ce.to=Ce})(_=e.TokenType||(e.TokenType={}));var c;(function(ce){function Ce(X){return new y.Position(X.lineNumber-1,X.column-1)}ce.to=Ce;function ue(X){return{lineNumber:X.line+1,column:X.character+1}}ce.from=ue})(c=e.Position||(e.Position={}));var u;(function(ce){function Ce(X){switch(X){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}ce.from=Ce;function ue(X){switch(X){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}ce.to=ue})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(ce){function Ce(X){let Re;return X.code&&((0,T.isString)(X.code)||(0,T.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),Object.assign(Object.assign({},v.from(X.range)),{message:X.message,source:X.source,code:Re,severity:i.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(t.from),tags:Array.isArray(X.tags)?(0,a.coalesce)(X.tags.map(u.from)):void 0})}ce.from=Ce;function ue(X){var Re;const Le=new y.Diagnostic(v.to(X),X.message,i.to(X.severity));return Le.source=X.source,Le.code=(0,T.isString)(X.code)?X.code:(Re=X.code)===null||Re===void 0?void 0:Re.value,Le.relatedInformation=X.relatedInformation&&X.relatedInformation.map(t.to),Le.tags=X.tags&&(0,a.coalesce)(X.tags.map(u.to)),Le}ce.to=ue})(s=e.Diagnostic||(e.Diagnostic={}));var t;(function(ce){function Ce(X){return Object.assign(Object.assign({},v.from(X.location.range)),{message:X.message,resource:X.location.uri})}ce.from=Ce;function ue(X){return new y.DiagnosticRelatedInformation(new y.Location(X.resource,v.to(X)),X.message)}ce.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ce){function Ce(X){switch(X){case y.DiagnosticSeverity.Error:return D.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return D.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return D.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return D.MarkerSeverity.Hint}return D.MarkerSeverity.Error}ce.from=Ce;function ue(X){switch(X){case D.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case D.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case D.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case D.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}ce.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ce){function Ce(X){return typeof X=="number"&&X>=y.ViewColumn.One?X-1:X===y.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}ce.from=Ce;function ue(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=ue})(o=e.ViewColumn||(e.ViewColumn={}));function r(ce){return typeof ce.range!="undefined"}function l(ce){return ce.length===0?!0:!!r(ce[0])}e.isDecorationOptionsArr=l;var h;(function(ce){function Ce(Ge){return Ge.map(ce.from)}ce.fromMany=Ce;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function X(Ge){let rt;if(ue(Ge)){const{language:st,value:gt}=Ge;rt={value:"```"+st+`
`+gt+"\n```\n"}}else y.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const at=Object.create(null);rt.uris=at;const Qe=st=>{try{let gt=P.URI.parse(st,!0);gt=gt.with({query:Re(gt.query,at)}),at[st]=gt}catch(gt){}return""},ct=new k.Renderer;return ct.link=Qe,ct.image=st=>Qe(A.parseHrefAndDimensions(st).href),k(rt.value,{renderer:ct}),rt}ce.from=X;function Re(Ge,rt){if(!Ge)return Ge;let at;try{at=(0,b.parse)(Ge)}catch(ct){}if(!at)return Ge;let Qe=!1;return at=(0,m.cloneAndChange)(at,ct=>{if(P.URI.isUri(ct)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ct,Qe=!0,st}else return}),Qe?JSON.stringify(at):Ge}function Le(Ge){const rt=new y.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ce.to=Le;function Ye(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ce.from(Ge)}ce.fromStrict=Ye})(h=e.MarkdownString||(e.MarkdownString={}));function g(ce){return l(ce)?ce.map(Ce=>({range:v.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?h.fromMany(Ce.hoverMessage):Ce.hoverMessage?h.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):ce.map(Ce=>({range:v.from(Ce)}))}e.fromRangeOrRangeWithMessage=g;function w(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?P.URI.file(ce):ce}e.pathOrURIToURI=w;var d;(function(ce){function Ce(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?w(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ce.from=Ce})(d=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var f;(function(ce){function Ce(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?w(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?d.from(ue.before):void 0,after:ue.after?d.from(ue.after):void 0}}ce.from=Ce})(f=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var I;(function(ce){function Ce(ue){if(typeof ue=="undefined")return ue;switch(ue){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=Ce})(I=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ce){function Ce(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?I.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?f.from(ue.light):void 0,dark:ue.dark?f.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?w(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?d.from(ue.before):void 0,after:ue.after?d.from(ue.after):void 0}}ce.from=Ce})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(ce){function Ce(X){return{text:X.newText,eol:X.newEol&&ie.from(X.newEol),range:v.from(X.range)}}ce.from=Ce;function ue(X){const Re=new y.TextEdit(v.to(X.range),X.text);return Re.newEol=typeof X.eol=="undefined"?void 0:ie.to(X.eol),Re}ce.to=ue})(B=e.TextEdit||(e.TextEdit={}));var ee;(function(ce){function Ce(X,Re,Le){var Ye,Ge,rt;const at={edits:[]};if(X instanceof y.WorkspaceEdit)for(let Qe of X._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const ct=Re==null?void 0:Re.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:B.from(Qe.edit),modelVersionId:ct==null?void 0:ct.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Ye=Le==null?void 0:Le.lookupNotebookDocument(Qe.uri))===null||Ye===void 0?void 0:Ye.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(He.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Le==null?void 0:Le.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ge.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((rt=Qe.newOutputItems)===null||rt===void 0?void 0:rt.map(be.from))||[],append:Qe.append}});return at}ce.from=Ce;function ue(X){const Re=new y.WorkspaceEdit;for(const Le of X.edits)Le.edit?Re.replace(P.URI.revive(Le.resource),v.to(Le.edit.range),Le.edit.text):Re.renameFile(P.URI.revive(Le.oldUri),P.URI.revive(Le.newUri),Le.options);return Re}ce.to=ue})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ce){const Ce=Object.create(null);Ce[y.SymbolKind.File]=0,Ce[y.SymbolKind.Module]=1,Ce[y.SymbolKind.Namespace]=2,Ce[y.SymbolKind.Package]=3,Ce[y.SymbolKind.Class]=4,Ce[y.SymbolKind.Method]=5,Ce[y.SymbolKind.Property]=6,Ce[y.SymbolKind.Field]=7,Ce[y.SymbolKind.Constructor]=8,Ce[y.SymbolKind.Enum]=9,Ce[y.SymbolKind.Interface]=10,Ce[y.SymbolKind.Function]=11,Ce[y.SymbolKind.Variable]=12,Ce[y.SymbolKind.Constant]=13,Ce[y.SymbolKind.String]=14,Ce[y.SymbolKind.Number]=15,Ce[y.SymbolKind.Boolean]=16,Ce[y.SymbolKind.Array]=17,Ce[y.SymbolKind.Object]=18,Ce[y.SymbolKind.Key]=19,Ce[y.SymbolKind.Null]=20,Ce[y.SymbolKind.EnumMember]=21,Ce[y.SymbolKind.Struct]=22,Ce[y.SymbolKind.Event]=23,Ce[y.SymbolKind.Operator]=24,Ce[y.SymbolKind.TypeParameter]=25;function ue(Re){return typeof Ce[Re]=="number"?Ce[Re]:6}ce.from=ue;function X(Re){for(const Le in Ce)if(Ce[Le]===Re)return Number(Le);return y.SymbolKind.Property}ce.to=X})(H=e.SymbolKind||(e.SymbolKind={}));var x;(function(ce){function Ce(X){switch(X){case y.SymbolTag.Deprecated:return 1}}ce.from=Ce;function ue(X){switch(X){case 1:return y.SymbolTag.Deprecated}}ce.to=ue})(x=e.SymbolTag||(e.SymbolTag={}));var $;(function(ce){function Ce(X){return{name:X.name,kind:H.from(X.kind),tags:X.tags&&X.tags.map(x.from),containerName:X.containerName,location:O.from(X.location)}}ce.from=Ce;function ue(X){const Re=new y.SymbolInformation(X.name,H.to(X.kind),X.containerName,O.to(X.location));return Re.tags=X.tags&&X.tags.map(x.to),Re}ce.to=ue})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(ce){function Ce(X){var Re,Le;const Ye={name:X.name||"!!MISSING: name!!",detail:X.detail,range:v.from(X.range),selectionRange:v.from(X.selectionRange),kind:H.from(X.kind),tags:(Le=(Re=X.tags)===null||Re===void 0?void 0:Re.map(x.from))!==null&&Le!==void 0?Le:[]};return X.children&&(Ye.children=X.children.map(Ce)),Ye}ce.from=Ce;function ue(X){const Re=new y.DocumentSymbol(X.name,X.detail,H.to(X.kind),v.to(X.range),v.to(X.selectionRange));return(0,a.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(x.to)),X.children&&(Re.children=X.children.map(ue)),Re}ce.to=ue})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ce){function Ce(ue){const X=new y.CallHierarchyItem(H.to(ue.kind),ue.name,ue.detail||"",P.URI.revive(ue.uri),v.to(ue.range),v.to(ue.selectionRange));return X._sessionId=ue._sessionId,X._itemId=ue._itemId,X}ce.to=Ce})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(ce){function Ce(ue){return new y.CallHierarchyIncomingCall(U.to(ue.from),ue.fromRanges.map(X=>v.to(X)))}ce.to=Ce})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ce){function Ce(ue){return new y.CallHierarchyOutgoingCall(U.to(ue.to),ue.fromRanges.map(X=>v.to(X)))}ce.to=Ce})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ce){function Ce(X){return{range:X.range&&v.from(X.range),uri:X.uri}}ce.from=Ce;function ue(X){return new y.Location(P.URI.revive(X.uri),v.to(X.range))}ce.to=ue})(O=e.location||(e.location={}));var V;(function(ce){function Ce(X){const Re=X,Le=X;return{originSelectionRange:Re.originSelectionRange?v.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:v.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?v.from(Re.targetSelectionRange):void 0}}ce.from=Ce;function ue(X){return{targetUri:P.URI.revive(X.uri),targetRange:v.to(X.range),targetSelectionRange:X.targetSelectionRange?v.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?v.to(X.originSelectionRange):void 0}}ce.to=ue})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(ce){function Ce(X){return{range:v.from(X.range),contents:h.fromMany(X.contents)}}ce.from=Ce;function ue(X){return new y.Hover(X.contents.map(h.to),v.to(X.range))}ce.to=ue})(q=e.Hover||(e.Hover={}));var Q;(function(ce){function Ce(X){return{range:v.from(X.range),expression:X.expression}}ce.from=Ce;function ue(X){return new y.EvaluatableExpression(v.to(X.range),X.expression)}ce.to=ue})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(ce){function Ce(X){if(X instanceof y.InlineValueText)return{type:"text",range:v.from(X.range),text:X.text};if(X instanceof y.InlineValueVariableLookup)return{type:"variable",range:v.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=Ce;function ue(X){switch(X.type){case"text":return{range:v.to(X.range),text:X.text};case"variable":return{range:v.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:v.to(X.range),expression:X.expression}}}ce.to=ue})(me=e.InlineValue||(e.InlineValue={}));var we;(function(ce){function Ce(X){return{frameId:X.frameId,stoppedLocation:v.from(X.stoppedLocation)}}ce.from=Ce;function ue(X){return new y.InlineValueContext(X.frameId,v.to(X.stoppedLocation))}ce.to=ue})(we=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(ce){function Ce(X){return{range:v.from(X.range),kind:X.kind}}ce.from=Ce;function ue(X){return new y.DocumentHighlight(v.to(X.range),X.kind)}ce.to=ue})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(ce){function Ce(ue){switch(ue){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}ce.to=Ce})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(ce){function Ce(ue){return{triggerKind:Ie.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ce.to=Ce})(Me=e.CompletionContext||(e.CompletionContext={}));var z;(function(ce){function Ce(X){switch(X){case y.CompletionItemTag.Deprecated:return 1}}ce.from=Ce;function ue(X){switch(X){case 1:return y.CompletionItemTag.Deprecated}}ce.to=ue})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ce){const Ce=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function ue(Le){var Ye;return(Ye=Ce.get(Le))!==null&&Ye!==void 0?Ye:9}ce.from=ue;const X=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function Re(Le){var Ye;return(Ye=X.get(Le))!==null&&Ye!==void 0?Ye:y.CompletionItemKind.Property}ce.to=Re})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ce){function Ce(ue,X){var Re;const Le=new y.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Le.label2=ue.label),Le.insertText=ue.insertText,Le.kind=J.to(ue.kind),Le.tags=(Re=ue.tags)===null||Re===void 0?void 0:Re.map(z.to),Le.detail=ue.detail,Le.documentation=A.isMarkdownString(ue.documentation)?h.to(ue.documentation):ue.documentation,Le.sortText=ue.sortText,Le.filterText=ue.filterText,Le.preselect=ue.preselect,Le.commitCharacters=ue.commitCharacters,C.Range.isIRange(ue.range)?Le.range=v.to(ue.range):typeof ue.range=="object"&&(Le.range={inserting:v.to(ue.range.insert),replacing:v.to(ue.range.replace)}),Le.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Le.insertText=new y.SnippetString(ue.insertText):(Le.insertText=ue.insertText,Le.textEdit=Le.range instanceof y.Range?new y.TextEdit(Le.range,Le.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Le.additionalTextEdits=ue.additionalTextEdits.map(Ye=>B.to(Ye))),Le.command=X&&ue.command?X.fromInternal(ue.command):void 0,Le}ce.to=Ce})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ce){function Ce(X){return{label:X.label,documentation:X.documentation?h.fromStrict(X.documentation):void 0}}ce.from=Ce;function ue(X){return{label:X.label,documentation:A.isMarkdownString(X.documentation)?h.to(X.documentation):X.documentation}}ce.to=ue})(ae=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(ce){function Ce(X){return{label:X.label,documentation:X.documentation?h.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(ae.from):[],activeParameter:X.activeParameter}}ce.from=Ce;function ue(X){return{label:X.label,documentation:A.isMarkdownString(X.documentation)?h.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(ae.to):[],activeParameter:X.activeParameter}}ce.to=ue})(fe=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ce){function Ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(fe.from):[]}}ce.from=Ce;function ue(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(fe.to):[]}}ce.to=ue})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ce){function Ce(X){var Re;return{text:X.text,range:v.from(X.range),kind:_e.from((Re=X.kind)!==null&&Re!==void 0?Re:y.InlineHintKind.Other),description:X.description&&h.fromStrict(X.description),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}ce.from=Ce;function ue(X){const Re=new y.InlineHint(X.text,v.to(X.range),_e.to(X.kind));return Re.whitespaceAfter=X.whitespaceAfter,Re.whitespaceBefore=X.whitespaceBefore,Re.description=A.isMarkdownString(X.description)?h.to(X.description):X.description,Re}ce.to=ue})(Oe=e.InlineHint||(e.InlineHint={}));var _e;(function(ce){function Ce(X){return X}ce.from=Ce;function ue(X){return X}ce.to=ue})(_e=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(ce){function Ce(X){return{range:v.from(X.range),url:X.target,tooltip:X.tooltip}}ce.from=Ce;function ue(X){let Re;if(X.url)try{Re=typeof X.url=="string"?P.URI.parse(X.url,!0):P.URI.revive(X.url)}catch(Le){}return new y.DocumentLink(v.to(X.range),Re)}ce.to=ue})(ke=e.DocumentLink||(e.DocumentLink={}));var Te;(function(ce){function Ce(X){const Re=new y.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=B.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Le=>B.to(Le))),Re}ce.to=Ce;function ue(X){return{label:X.label,textEdit:X.textEdit?B.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>B.from(Re)):void 0}}ce.from=ue})(Te=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(ce){function Ce(X){return new y.Color(X[0],X[1],X[2],X[3])}ce.to=Ce;function ue(X){return[X.red,X.green,X.blue,X.alpha]}ce.from=ue})(xe=e.Color||(e.Color={}));var Se;(function(ce){function Ce(X){return{range:v.from(X.range)}}ce.from=Ce;function ue(X){return new y.SelectionRange(v.to(X.range))}ce.to=ue})(Se=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ce){function Ce(ue){switch(ue){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}ce.to=Ce})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(ce){function Ce(X){switch(X){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=Ce;function ue(X){switch(X){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}ce.to=ue})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(ce){function Ce(X){if(X===y.EndOfLine.CRLF)return 1;if(X===y.EndOfLine.LF)return 0}ce.from=Ce;function ue(X){if(X===1)return y.EndOfLine.CRLF;if(X===0)return y.EndOfLine.LF}ce.to=ue})(ie=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(ce){function Ce(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=Ce})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ce){function Ce(ue){const X={start:ue.start+1,end:ue.end+1};return ue.kind&&(X.kind=ze.from(ue.kind)),X}ce.from=Ce})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(ce){function Ce(ue){if(ue)switch(ue){case y.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}ce.from=Ce})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(ce){function Ce(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?v.from(ue.selection):void 0,override:typeof ue.override=="boolean"?R.EditorOverride.DISABLED:void 0}}ce.from=Ce})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(ce){function Ce(X){return X instanceof y.RelativePattern||typeof X=="string"?X:ue(X)?new y.RelativePattern(X.base,X.pattern):X}ce.from=Ce;function ue(X){const Re=X;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var K;(function(ce){function Ce(ue){if(ue){if(Array.isArray(ue))return ue.map(Ce);if(typeof ue=="string")return ue;{const X=ue;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:et.from(X.pattern),exclusive:X.exclusive}}}else return}ce.from=Ce})(K=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(ce){function Ce(X){return{start:X.start,end:X.end}}ce.from=Ce;function ue(X){return new y.NotebookCellRange(X.start,X.end)}ce.to=ue})(se=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ce){function Ce(ue){return new y.NotebookCellMetadata(ue.editable,ue.breakpointMargin,ue.hasExecutionOrder,ue.statusMessage,ue.inputCollapsed,ue.outputCollapsed,ue.custom)}ce.to=Ce})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Y;(function(ce){function Ce(X){return X}ce.from=Ce;function ue(X){return new y.NotebookDocumentMetadata(X.editable,X.cellEditable,X.cellHasExecutionOrder,X.custom,X.trusted)}ce.to=ue})(Y=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(ce){function Ce(X){return{duration:X.lastRunDuration,executionOrder:X.executionOrder,success:X.lastRunSuccess}}ce.to=Ce;function ue(X){return{lastRunSuccess:X.success,lastRunDuration:X.duration,executionOrder:X.executionOrder}}ce.from=ue})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ce){function Ce(X){switch(X){case y.NotebookCellKind.Markdown:return p.CellKind.Markdown;case y.NotebookCellKind.Code:default:return p.CellKind.Code}}ce.from=Ce;function ue(X){switch(X){case p.CellKind.Markdown:return y.NotebookCellKind.Markdown;case p.CellKind.Code:default:return y.NotebookCellKind.Code}}ce.to=ue})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var ge;(function(ce){function Ce(X){var Re;return{cellKind:le.from(X.kind),language:X.language,source:X.source,metadata:Object.assign(Object.assign({},X.metadata),ne.from((Re=X.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:X.outputs?X.outputs.map(He.from):[]}}ce.from=Ce;function ue(X){return new y.NotebookCellData(le.to(X.cellKind),X.source,X.language,X.outputs?X.outputs.map(He.to):void 0,X.metadata?he.to(X.metadata):void 0)}ce.to=ue})(ge=e.NotebookCellData||(e.NotebookCellData={}));var be;(function(ce){function Ce(X){return{mime:X.mime,value:X.value,metadata:X.metadata}}ce.from=Ce;function ue(X){return new y.NotebookCellOutputItem(X.mime,X.value,X.metadata)}ce.to=ue})(be=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var He;(function(ce){function Ce(X){return{outputId:X.id,outputs:X.outputs.map(be.from),metadata:X.metadata}}ce.from=Ce;function ue(X){const Re=X.outputs.map(be.to);return new y.NotebookCellOutput(Re,X.outputId,X.metadata)}ce.to=ue})(He=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(ce){function Ce(Le){if(Le!=null){if(Le instanceof y.RelativePattern||typeof Le=="string")return Le;if(Re(Le))return new y.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:et.from(Le.include)||void 0,exclude:et.from(Le.exclude)||void 0}}}ce.from=Ce;function ue(Le){return typeof Le=="string"?Le:Re(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ce.to=ue;function X(Le){const Ye=Le,Ge=et.from(Ye.include);if(!(Ge&&Ge instanceof y.RelativePattern||typeof Ge=="string"))return!1;const rt=et.from(Ye.exclude);return!!(rt&&rt instanceof y.RelativePattern||typeof rt=="string")}function Re(Le){const Ye=Le;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var qe;(function(ce){function Ce(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?d.from(ue.top):void 0}}ce.from=Ce})(qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(ce){function Ce(X){return{state:X.state,duration:X.duration,messages:X.messages.map(Ze.from)}}ce.from=Ce;function ue(X){const Re=new y.TestState(X.state);return Re.duration=X.duration,Re.messages=X.messages.map(Ze.to),Re}ce.to=ue})(Xe=e.TestState||(e.TestState={}));var Ze;(function(ce){function Ce(X){return{message:h.fromStrict(X.message)||"",severity:X.severity,expectedOutput:X.expectedOutput,actualOutput:X.actualOutput,location:X.location?O.from(X.location):void 0}}ce.from=Ce;function ue(X){const Re=new y.TestMessage(typeof X.message=="string"?X.message:h.to(X.message));return Re.severity=X.severity,Re.actualOutput=X.actualOutput,Re.expectedOutput=X.expectedOutput,Re}ce.to=ue})(Ze=e.TestMessage||(e.TestMessage={}));var ut;(function(ce){function Ce(Le){var Ye,Ge;return{extId:Le.id,label:Le.label,location:Le.location?O.from(Le.location):void 0,debuggable:(Ye=Le.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Le.description,runnable:(Ge=Le.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Le.expandable}}ce.from=Ce;function ue(Le){return{extId:Le.id,label:Le.label,location:Le.location?O.from(Le.location):void 0,debuggable:!1,description:Le.description,runnable:!0,expandable:!0}}ce.fromResultSnapshot=ue;function X(Le){return{id:Le.extId,label:Le.label,location:Le.location&&O.to({range:Le.location.range,uri:P.URI.revive(Le.location.uri)}),expandable:Le.expandable,debuggable:Le.debuggable,description:Le.description,runnable:Le.runnable}}ce.toPlain=X;function Re(Le){const Ye=new y.TestItem(Le.extId,Le.label,Le.expandable);return Le.location&&(Ye.location=O.to({range:Le.location.range,uri:P.URI.revive(Le.location.uri)})),Ye.debuggable=Le.debuggable,Ye.description=Le.description,Ye.runnable=Le.runnable,Ye}ce.to=Re})(ut=e.TestItem||(e.TestItem={}));var ot;(function(ce){function Ce(Re,Le){var Ye,Ge,rt;const at={completedAt:Le.completedAt,id:Re,items:[]},Qe=[[null,Le.results]];for(;Qe.length;){const[ct,st]=Qe.pop();for(const gt of st){const Et={children:(Ge=(Ye=gt.children)===null||Ye===void 0?void 0:Ye.map(Ct=>Ct.id))!==null&&Ge!==void 0?Ge:[],computedState:gt.result.state,item:ut.fromResultSnapshot(gt),state:Xe.from(gt.result),retired:void 0,expand:3,parent:(rt=ct==null?void 0:ct.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!ct};at.items.push(Et),gt.children&&Qe.push([Et,gt.children])}}return at}ce.from=Ce;const ue=(Re,Le)=>Object.assign(Object.assign({},ut.toPlain(Re.item)),{result:Xe.to(Re.state),children:Re.children.map(Ye=>Le.get(Ye)).filter(T.isDefined).map(Ye=>ue(Ye,Le))});function X(Re){const Le=[],Ye=new Map;for(const Ge of Re.items)Ye.set(Ge.item.extId,Ge),Ge.direct&&Le.push(Ge);return{completedAt:Re.completedAt,results:Le.map(Ge=>ue(Ge,Ye))}}ce.to=X})(ot=e.TestResults||(e.TestResults={}));var nt;(function(ce){function Ce(ue){switch(ue){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}ce.to=Ce})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(pe[212],ve([0,1,2,16,7,20,55]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(n,T,k,b={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=b,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,b)=>{const a={dispose:this._callbacks.push([T,k,n])};return Array.isArray(b)&&b.push(a),a}}async $participateInSave(n,T){const k=E.URI.revive(n);let b=!1;const m=setTimeout(()=>b=!0,this._thresholds.timeout),a=[];try{for(let p of[...this._callbacks]){if(b)break;const S=this._documents.getDocument(k),v=await this._deliverEventAsyncAndBlameBadListeners(p,{document:S,reason:P.TextDocumentSaveReason.to(T)});a.push(v)}}finally{clearTimeout(m)}return a}_deliverEventAsyncAndBlameBadListeners([n,T,k],b){const m=this._badListeners.get(n);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,b).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const p=this._badListeners.get(n);this._badListeners.set(n,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,b){const m=[],a=Date.now(),{document:p,reason:S}=b,{version:v}=p,_=Object.freeze({document:p,reason:S,waitUntil(c){if(Object.isFrozen(m))throw(0,y.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{T.apply(k,[_])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,u)=>{const s=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(s),c(t)}).catch(t=>{clearTimeout(s),u(t)})}).then(c=>{const u={edits:[]};for(const s of c)if(Array.isArray(s)&&s.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:i,range:o}of s)u.edits.push({_type:2,resource:p.uri,edit:{range:o&&P.Range.from(o),text:t,eol:i&&P.EndOfLine.from(i)}});if(u.edits.length!==0)return v===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(pe[213],ve([0,1,3,17,34,2,20,7]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(k,b,m,a,p){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,m&&(this._config+=1),a&&(this._config+=2),p&&(this._config+=4);const S=(0,R.parse)(b),v=k(_=>{if(!m)for(let c of _.created){const u=P.URI.revive(c);S(u.fsPath)&&this._onDidCreate.fire(u)}if(!a)for(let c of _.changed){const u=P.URI.revive(c);S(u.fsPath)&&this._onDidChange.fire(u)}if(!p)for(let c of _.deleted){const u=P.URI.revive(c);S(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,b,m){this._logService=b,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new y.AsyncEmitter,this._onWillCreateFile=new y.AsyncEmitter,this._onWillDeleteFile=new y.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,b,m,a){return new D(this._onFileSystemEvent.event,k,b,m,a)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,b){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(m=>({oldUri:P.URI.revive(m.source),newUri:P.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(m=>P.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(m=>P.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,b){return(m,a,p)=>{const S=function(_){m.call(a,_)};return S.extension=k,b.event(S,void 0,p)}}async $onWillRunFileOperation(k,b,m,a){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(p=>({oldUri:P.URI.revive(p.source),newUri:P.URI.revive(p.target)}))},m,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(p=>P.URI.revive(p.target))},m,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(p=>P.URI.revive(p.target))},m,a)}}async _fireWillEvent(k,b,m,a){const p=new Set,S=[];if(await k.fireAsync(b,a,async(_,c)=>{var u;const s=Date.now(),t=await Promise.resolve(_);t instanceof A.WorkspaceEdit&&(S.push(t),p.add((u=c.extension.displayName)!==null&&u!==void 0?u:c.extension.identifier.value)),Date.now()-s>m&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!a.isCancellationRequested&&S.length!==0){const v={edits:[]};for(let _ of S){let{edits:c}=C.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(c)}return{edit:v,extensionNames:Array.from(p)}}}}e.ExtHostFileSystemEventService=n}),define(pe[214],ve([0,1,3,6,11,22,2,20,7,85]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(a,p,S,v){this.start=a,this.deletedCount=p,this.deletedItems=S,this.items=v}static asApiEvents(a){return a.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(S=>S.cell)}))}}class k{constructor(a,p,S){var v;this._notebook=a,this._extHostDocument=p,this._cellData=S,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=S.handle,this.uri=C.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(v=S.metadata)!==null&&v!==void 0?v:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(a,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:a}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const a=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return a._notebook.getCellIndex(a)},notebook:a._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get latestExecutionSummary(){return a._previousResult}})}return this._cell}setOutputs(a){this._outputs=a.map(A.NotebookCellOutput.to)}setOutputItems(a,p,S){const v=S.map(A.NotebookCellOutputItem.to),_=this._outputs.find(c=>c.id===a);_&&(p||(_.outputs.length=0),_.outputs.push(...v))}setMetadata(a){this._internalMetadata=a,this._metadata=A.NotebookCellMetadata.to(a),this._previousResult=A.NotebookCellPreviousExecutionResult.to(a)}}e.ExtHostCell=k;class b extends y.Disposable{constructor(a,p,S,v,_,c,u){super();this._proxy=a,this._textDocumentsAndEditors=p,this._textDocuments=S,this._emitter=v,this._viewType=_,this._metadata=c,this.uri=u,this.handle=b._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,y.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const a=this;this._notebook=Object.freeze({get uri(){return a.uri},get version(){return a._versionId},get fileName(){return a.uri.fsPath},get viewType(){return a._viewType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===R.Schemas.untitled},get cells(){return a._cells.map(p=>p.cell)},get metadata(){return a._metadata},set metadata(p){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return a._save()}})}return this._notebook}updateBackup(a){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=a}disposeBackup(){var a;(a=this._backup)===null||a===void 0||a.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=this._metadata.with(a.metadata))}acceptModelChanged(a,p){this._versionId=a.versionId,this._isDirty=p;for(const S of a.rawEvents)S.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(S.changes,!0),S.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(S.changes,!1):S.kind===n.NotebookCellsChangeType.Move?this._moveCell(S.index,S.newIdx):S.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(S.index,S.outputs):S.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(S.index,S.outputId,S.append,S.outputItems):S.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(S.index,S.language):S.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(S.index,S.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(a,p){if(!this._disposed){const S=[],v=[],_=[];a.reverse().forEach(c=>{var u;const t=c[2].map(r=>{const l=new k(this,this._textDocumentsAndEditors,r);if(p||v.push(k.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(l.handle)){const h=new y.DisposableStore;h.add(l),this._cellDisposableMapping.set(l.handle,h)}return l});for(let r=c[0];r<c[0]+c[1];r++)(u=this._cellDisposableMapping.get(this._cells[r].handle))===null||u===void 0||u.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const i=new T(c[0],c[1],[],t),o=this._cells.splice(c[0],c[1],...t);for(let r of o)_.push(r.uri),i.deletedItems.push(r.cell);S.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),p||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(S)}))}}_moveCell(a,p){const S=this._cells.splice(a,1);this._cells.splice(p,0,...S);const v=[new T(a,1,S.map(_=>_.cell),[]),new T(p,0,[],S)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(v)}))}_setCellOutputs(a,p){const S=this._cells[a];S.setOutputs(p),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_setCellOutputItems(a,p,S,v){const _=this._cells[a];_.setOutputItems(p,S,v),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_changeCellLanguage(a,p){const S=this._cells[a];S.cell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(S.uri,p)}_changeCellMetadata(a,p){var S;const v=this._cells[a],_=v.internalMetadata,c=v.cell.metadata;v.setMetadata(p);const u=v.cell.metadata;if((0,P.equals)(c,u)||this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:v.cell})),_.runState!==p.runState){const s=(S=p.runState)!==null&&S!==void 0?S:D.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,P.deepFreeze)({document:this.notebookDocument,cell:v.cell,executionState:s}))}}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(p=>p.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=b,b._handlePool=0}),define(pe[215],ve([0,1,3,7,20]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:n})}replaceCellOutput(D,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:D,outputs:n.map(T=>R.NotebookCellOutput.from(T))})}replaceCells(D,n,T){this._throwIfFinalized(),!(D===n&&T.length===0)&&this._collectedEdits.push({editType:1,index:D,count:n-D,cells:T.map(R.NotebookCellData.from)})}}class C{constructor(D,n,T,k,b,m,a){this.id=D,this._viewType=n,this._proxy=T,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=m,this._visibleRanges=b,this._viewColumn=a}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.notebookDocument},get selection(){var n;const T=D._selections[0];return T&&((n=D.notebookData.getCellFromIndex(T.start))===null||n===void 0?void 0:n.cell)},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(n,T){D._proxy.$tryRevealRange(D.id,R.NotebookCellRange.from(n),T!=null?T:y.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},get onDidDispose(){return D.onDidDispose},edit(n){const T=new P(this.document.version);return n(T),D._applyEdit(T.finalize())},get kernel(){return D._kernel},setDecorations(n,T){return D.setDecorations(n,T)}}}return this._editor}_acceptKernel(D){this._kernel=D}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const n=[];let T=-1;for(let k=0;k<D.cellEdits.length;k++){if(T<0){n.push(D.cellEdits[k]),T++;continue}const m=n[T],a=D.cellEdits[k];if(m.editType===1&&a.editType===1&&m.index===a.index){m.cells.push(...D.cellEdits[k].cells),m.count+=D.cellEdits[k].count;continue}n.push(D.cellEdits[k]),T++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,D.documentVersionId,n)}setDecorations(D,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return n.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,R.NotebookCellRange.from(n),D.key)}}e.ExtHostNotebookEditor=C}),define(pe[216],ve([0,1,20,111,161,21,68]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class A{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,b,m){const a=this._handles++,{title:p,location:S,cancellable:v}=b,_={label:(0,R.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(a,{location:E.ProgressLocation.from(S),title:p,source:_,cancellable:v},k),this._withProgress(a,m,!!v)}_withProgress(k,b,m){let a;m&&(a=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,a));const p=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let S;try{S=b(new n(this._proxy,k),m&&a?a.token:P.CancellationToken.None)}catch(v){throw p(k),v}return S.then(v=>p(k),v=>p(k)),S}$acceptProgressCanceled(k){const b=this._mapHandleToCancellationSource.get(k);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=A;function D(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends y.Progress{constructor(k,b){super(m=>this.throttledReport(m));this._proxy=k,this._handle=b}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,C.throttle)(100,(T,k)=>D(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(pe[122],ve([0,1,52,16,70,20,7]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(b,m){const a=A._Keys.nextId();b.$registerTextEditorDecorationType(a,P.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){b.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=A,A._Keys=new R.IdGenerator("TextEditorDecorationType");class D{constructor(b,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,m){this._throwIfFinalized();let a=null;if(b instanceof C.Position)a=new C.Range(b,b);else if(b instanceof C.Range)a=b;else throw new Error("Unrecognized location");this._pushEdit(a,m,!1)}insert(b,m){this._throwIfFinalized(),this._pushEdit(new C.Range(b,b),m,!0)}delete(b){this._throwIfFinalized();let m=null;if(b instanceof C.Range)m=b;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(b,m,a){const p=this._document.validateRange(b);this._collectedEdits.push({range:p,text:m,forceMoveMarkers:a})}setEndOfLine(b){if(this._throwIfFinalized(),b!==C.EndOfLine.LF&&b!==C.EndOfLine.CRLF)throw(0,y.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=D;class n{constructor(b,m,a,p){this._proxy=b,this._id=m,this._accept(a),this._logService=p;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(v){S._setTabSize(v)},get insertSpaces(){return S._insertSpaces},set insertSpaces(v){S._setInsertSpaces(v)},get cursorStyle(){return S._cursorStyle},set cursorStyle(v){S._setCursorStyle(v)},get lineNumbers(){return S._lineNumbers},set lineNumbers(v){S._setLineNumbers(v)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const m=Math.floor(b);return m>0?m:null}if(typeof b=="string"){const m=parseInt(b,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(b){const m=this._validateTabSize(b);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const m=this._validateInsertSpaces(b);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(b)})))}assign(b){const m={};let a=!1;if(typeof b.tabSize!="undefined"){const p=this._validateTabSize(b.tabSize);p==="auto"?(a=!0,m.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,a=!0,m.tabSize=p)}if(typeof b.insertSpaces!="undefined"){const p=this._validateInsertSpaces(b.insertSpaces);p==="auto"?(a=!0,m.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,a=!0,m.insertSpaces=p)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,a=!0,m.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,a=!0,m.lineNumbers=P.TextEditorLineNumbersStyle.from(b.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(b){b.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=n;class T{constructor(b,m,a,p,S,v,_,c){this.id=b,this._proxy=m,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new n(this._proxy,this.id,v,a),this._visibleRanges=_,this._viewColumn=c;const u=this;this.value=Object.freeze({get document(){return p.getValue()},set document(s){throw(0,y.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(s){if(!(s instanceof C.Selection))throw(0,y.illegalArgument)("selection");u._selections=[s],u._trySetSelection()},get selections(){return u._selections},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof C.Selection)))throw(0,y.illegalArgument)("selections");u._selections=s,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(s){throw(0,y.readonly)("visibleRanges")},get options(){return u._options.value},set options(s){u._disposed||u._options.assign(s)},get viewColumn(){return u._viewColumn},set viewColumn(s){throw(0,y.readonly)("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new D(p.getValue(),t);return s(i),u._applyEdit(i)},insertSnippet(s,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(r=>P.Range.from(r));else if(t instanceof C.Position){const{lineNumber:r,column:l}=P.Position.from(t);o=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof C.Range)o=[P.Range.from(t)];else{o=[];for(const r of t)if(r instanceof C.Range)o.push(P.Range.from(r));else{const{lineNumber:l,column:h}=P.Position.from(r);o.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return m.$tryInsertSnippet(b,s.value,o,i)},setDecorations(s,t){const i=t.length===0;i&&!u._hasDecorationsForKey.has(s.key)||(i?u._hasDecorationsForKey.delete(s.key):u._hasDecorationsForKey.add(s.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return m.$trySetDecorations(b,s.key,P.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const h=t[r];o[4*r]=h.start.line+1,o[4*r+1]=h.start.character+1,o[4*r+2]=h.end.line+1,o[4*r+3]=h.end.character+1}return m.$trySetDecorationsFast(b,s.key,o)}}))},revealRange(s,t){u._runOnProxy(()=>m.$tryRevealRange(b,P.Range.from(s),t||C.TextEditorRevealType.Default))},show(s){m.$tryShowEditor(b,P.ViewColumn.from(s))},hide(){m.$tryHideEditor(b)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,E.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,E.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,E.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,E.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const m=b.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const a=m.edits.map(S=>S.range);a.sort((S,v)=>S.end.line===v.end.line?S.end.character===v.end.character?S.start.line===v.start.line?S.start.character-v.start.character:S.start.line-v.start.line:S.end.character-v.end.character:S.end.line-v.end.line);for(let S=0,v=a.length-1;S<v;S++){const _=a[S].end;if(a[S+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=m.edits.map(S=>({range:P.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,p,{setEndOfLine:typeof m.setEndOfLine=="number"?P.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=T}),define(pe[217],ve([0,1,164,24,2,3,6,17,7,15,14,20,21]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(S,v){if((0,n.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class a{constructor(v,_,c){this._proxy=v,this.commands=_,this.logService=c,this.treeViews=new Map;function u(s){return s&&s.$treeViewId&&s.$treeItemHandle}_.registerArgumentProcessor({processArgument:s=>u(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(t=>u(t)?this.convertArgument(t):t):s})}registerTreeDataProvider(v,_,c){const u=this.createTreeView(v,{treeDataProvider:_},c);return{dispose:()=>u.dispose()}}createTreeView(v,_,c){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),s=this.createExtHostTreeView(v,_,c);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(t){s.message=t},get title(){return s.title},set title(t){s.title=t},get description(){return s.description},set description(t){s.description=t},reveal:(t,i)=>s.reveal(t,i),dispose:async()=>{await u,this.treeViews.delete(v),s.dispose()}}}$getChildren(v,_){const c=this.treeViews.get(v);return c?c.getChildren(_):Promise.reject(new Error((0,E.localize)(0,null,v)))}async $hasResolve(v){const _=this.treeViews.get(v);if(!_)throw new Error((0,E.localize)(1,null,v));return _.hasResolve}$resolve(v,_,c){const u=this.treeViews.get(v);if(!u)throw new Error((0,E.localize)(2,null,v));return u.resolveTreeItem(_,c)}$setExpanded(v,_,c){const u=this.treeViews.get(v);if(!u)throw new Error((0,E.localize)(3,null,v));u.setExpanded(_,c)}$setSelection(v,_){const c=this.treeViews.get(v);if(!c)throw new Error((0,E.localize)(4,null,v));c.setSelection(_)}$setVisible(v,_){const c=this.treeViews.get(v);if(!c)throw new Error((0,E.localize)(5,null,v));c.setVisible(_)}createExtHostTreeView(v,_,c){const u=new p(v,_,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(v,u),u}convertArgument(v){const _=this.treeViews.get(v.$treeViewId);return _?_.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=a;class p extends C.Disposable{constructor(v,_,c,u,s,t){super();if(this.viewId=v,this.proxy=c,this.commands=u,this.logService=s,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===v&&(this._title=l.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,o;this._register(P.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(h=>o=h),this.refreshPromise=this.refreshPromise.then(()=>i)),r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=o;return i=null,this.refresh(l).then(()=>h())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,n.isUndefinedOrNull)(v))}getChildren(v){const _=v?this.getExtensionElement(v):void 0;if(v&&!_)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(v);return(c?Promise.resolve(c):this.fetchChildrenNodes(_)).then(u=>u.map(s=>s.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,_){_=_||{select:!0,focus:!1};const c=(0,n.isUndefinedOrNull)(_.select)?!0:_.select,u=(0,n.isUndefinedOrNull)(_.focus)?!1:_.focus,s=(0,n.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(o=>o.item)},{select:c,focus:u,expand:s})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:u,expand:s})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,_){const c=this.getExtensionElement(v);c&&(_?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(v){(0,T.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,_){var c;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(v);if(u){const s=this.nodes.get(u);if(s){const t=(c=await this.dataProvider.resolveTreeItem(s.extensionItem,u,_))!==null&&c!==void 0?c:s.extensionItem;return s.item.tooltip=this.getTooltip(t.tooltip),s.item.command=this.getCommand(s.disposableStore,t.command),s.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(_=>_?this.resolveUnknownParentChain(_).then(c=>this.resolveTreeNode(_,c[c.length-1]).then(u=>(c.push(u),c))):Promise.resolve([]))}resolveParent(v){const _=this.nodes.get(v);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,_){const c=this.nodes.get(v);return c?Promise.resolve(c):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(u=>this.createHandle(v,u,_,!0)).then(u=>this.getChildren(_?_.item.handle:void 0).then(()=>{const s=this.getExtensionElement(u);if(s){const t=this.nodes.get(s);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(v){if(v){let _;if(typeof v=="string"){const c=this.getExtensionElement(v);_=c?this.nodes.get(c):void 0}else _=v;return _&&_.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const _=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=v?this.nodes.get(v):void 0,u=await this.dataProvider.getChildren(v);if(_.token.isCancellationRequested)return[];const s=await Promise.all((0,T.coalesce)(u||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,c):null}));return _.token.isCancellationRequested?[]:(0,T.coalesce)(s)}finally{_.dispose()}}refresh(v){if(v.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(v);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const _=new Set;for(const u of v){const s=this.nodes.get(u);if(s&&!_.has(s.item.handle)){let t=s;for(;t&&t.parent&&!_.has(t.parent.item.handle);){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&_.add(s.item.handle)}}const c=[];return _.forEach(u=>{const s=this.elements.get(u);if(s){const t=this.nodes.get(s);t&&(!t.parent||!_.has(t.parent.item.handle))&&c.push(u)}}),c}refreshHandles(v){const _={};return Promise.all(v.map(c=>this.refreshNode(c).then(u=>{u&&(_[c]=u.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(v){const _=this.getExtensionElement(v);if(_){const c=this.nodes.get(_);if(c)return this.clearChildren(_),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(u=>{if(u){const s=this.createTreeNode(_,u,c.parent);return this.updateNodeCache(_,s,c,c.parent),c.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,_,c){const u=this.createTreeNode(v,_,c);if(_.id&&this.elements.has(u.item.handle))throw new Error((0,E.localize)(6,null,_.id));return this.addNodeToCache(v,u),this.addNodeToParentCache(u,c),u}getTooltip(v){return D.MarkdownString.isMarkdownString(v)?k.MarkdownString.from(v):v}getCommand(v,_){return _?this.commands.toInternal(_,v):void 0}createTreeNode(v,_,c){const u=new C.DisposableStore,s=this.createHandle(v,_,c),t=this.getLightIconPath(_);return{item:{handle:s,parentHandle:c?c.item.handle:void 0,label:m(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(u,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,n.isUndefinedOrNull)(_.collapsibleState)?D.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:c,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(v){return v.iconPath instanceof D.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:_,label:c,resourceUri:u},s,t){if(_)return`${p.ID_HANDLE_PREFIX}/${_}`;const i=m(c,this.extension),o=s?s.item.handle:p.LABEL_HANDLE_PREFIX;let r=i?i.label:u?(0,y.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,h=this.getChildrenNodes(s)||[];let g,w=0;do{if(g=`${o}/${w}:${r}`,t||!this.elements.has(g)||l===g)break;w++}while(w<=h.length);return g}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon))return typeof v.iconPath=="string"||R.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return R.URI.isUri(v)?v:R.URI.file(v)}addNodeToCache(v,_){this.elements.set(_.item.handle,v),this.nodes.set(v,_)}updateNodeCache(v,_,c,u){this.elements.delete(_.item.handle),this.nodes.delete(v),_.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(v,_);const s=this.getChildrenNodes(u)||[],t=s.filter(i=>i.item.handle===c.item.handle)[0];t&&s.splice(s.indexOf(t),1,_)}addNodeToParentCache(v,_){_?(_.children||(_.children=[]),_.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const _=this.nodes.get(v);if(_){if(_.children)for(const c of _.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}_.children=void 0}}else this.clearAll()}clear(v){const _=this.nodes.get(v);if(_){if(_.children)for(const c of _.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}this.nodes.delete(v),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(pe[218],ve([0,1,14,17,21,20,7,121]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class D{constructor(){this.testIdsToInternal=new Map}getTestById(a,p){if(p!==void 0){const S=this.testIdsToInternal.get(p),v=S==null?void 0:S.get(a);if(v)return[S,v]}return(0,E.mapFind)(this.testIdsToInternal.values(),S=>{const v=S.get(a);return v&&[S,v]})}createForHierarchy(a=()=>{}){return new b(this.createIdMap(T++),a)}createIdMap(a){const p=new k(a);return this.testIdsToInternal.set(p.id,p),{object:p,dispose:()=>this.testIdsToInternal.delete(p.id)}}}e.OwnedTestCollection=D;var n;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let T=0;class k{constructor(a){this.id=a,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(a){if(this.map.has(a.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${a.item.extId}`);this.map.set(a.item.extId,a),a.parent||this._roots.add(a)}has(a){return this.map.has(a)}delete(a){const p=this.map.get(a);return p?(this.map.delete(a),this._roots.delete(p),!0):!1}get(a){return this.map.get(a)}comparePositions(a,p){const S=typeof a=="string"?this.map.get(a):a,v=typeof p=="string"?this.map.get(p):p;if(!S||!v)return 0;if(S===v)return 3;for(let _=this.map.get(v.parent);_;_=this.map.get(_.parent))if(_===S)return 1;for(let _=this.map.get(S.parent);_;_=this.map.get(_.parent))if(_===v)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=k;class b{constructor(a,p){this.testIdToInternal=a,this.publishDiff=p,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new y.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(a,p){this.addItem(a,p,null)}getTestByReference(a){return this.testItemToInternal.get(a)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const p=this.diff[this.diff.length-1];if(p&&a[0]===1){if(p[0]===1&&p[1].extId===a[1].extId){(0,A.applyTestItemUpdate)(p[1],a[1]);return}if(p[0]===0&&p[1].item.extId===a[1].extId){(0,A.applyTestItemUpdate)(p[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,p){var S;const v=this.testIdToInternal.object.get(a);if(!!v){if((v.expandLevels===void 0||p>v.expandLevels)&&(v.expandLevels=p),v.expand===1){const _=this.refreshChildren(v);return _.isSettled?this.expandChildren(v,p-1):_.p.then(()=>this.expandChildren(v,p-1))}else if(v.expand===3)return((S=v.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?v.initialExpand.p.then(()=>this.expandChildren(v,p-1)):this.expandChildren(v,p-1)}}dispose(){var a;for(const p of this.testItemToInternal.values())(a=p.discoverCts)===null||a===void 0||a.dispose(!0),p.actual[C.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(a,p,S){if(!(a instanceof C.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);if(this.testItemToInternal.has(a))throw new Error(`Attempted to add a single TestItem ${a.id} multiple times to the tree`);if(this.testIdToInternal.object.has(a.id))throw new Error(`Attempted to insert a duplicate test item ID ${a.id}`);const v=S?S.item.extId:null,_=a.expandable?1:0,c=S==null?void 0:S.expandLevels,u={provider:p,tree:this.testIdToInternal.object.id},s={actual:a,parent:v,item:P.TestItem.from(a),expandLevels:c&&_===1?c-1:void 0,expand:_,src:u};this.testIdToInternal.object.add(s),this.testItemToInternal.set(a,s),this.pushDiff([0,{parent:v,src:u,expand:_,item:s.item}]),a[C.TestItemHookProperty]={created:t=>this.addItem(t,p,s),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:a.id,item:{[t]:i}}])};for(const t of a.children)this.addItem(t,p,s)}expandChildren(a,p){if(!(p<0)){const S=[...a.actual.children].map(v=>this.expand(v.id,p-1)).filter(y.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(a){a.discoverCts&&a.discoverCts.dispose(!0),a.expand=2,a.discoverCts=new R.CancellationTokenSource,this.pushExpandStateUpdate(a);const p=new y.DeferredPromise;return a.initialExpand=p,a.actual.discoverChildren({report:S=>{S.busy?(a.expand=2,this.pushExpandStateUpdate(a)):(a.expand=3,p.isSettled||p.complete(),this.pushExpandStateUpdate(a))}},a.discoverCts.token),p}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.actual.id,expand:a.expand}])}removeItembyId(a){var p;this.pushDiff([2,a]);const S=[this.testIdToInternal.object.get(a)];for(;S.length;){const v=S.pop();if(!!v){(p=v.discoverCts)===null||p===void 0||p.dispose(!0),this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const _ of v.actual.children)S.push(this.testIdToInternal.object.get(_.id))}}}flushDiff(){const a=this.collectDiff();a.length&&this.publishDiff(a)}}e.SingleUseTestCollection=b}),define(pe[219],ve([0,1,29,3,8]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=P;class C{constructor(T){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${E.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(b=>k.add(E.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>k.has(E.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const b=C._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(b.map(m=>m.identifier)),k.length>0){const m=new Set;k.forEach(a=>m.add(E.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!m.has(E.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(b)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,v){this.addNode(S),this.addNode(v),this._arcs.has(S)?this._arcs.get(S).push(v):this._arcs.set(S,[v])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,v){const _=k.getArcs(S);for(let c=0;c<_.length;c++)if(!v.has(_[c]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let S of T){const v=E.ExtensionIdentifier.toKey(S.identifier);if(b.set(v,S),S.extensionDependencies)for(let _ of S.extensionDependencies){const c=E.ExtensionIdentifier.toKey(_);k.addArc(v,c)}}let m=new Set;k.getNodes().filter(S=>k.getArcs(S).length===0).forEach(S=>m.add(S));let a=k.getNodes().filter(S=>!m.has(S)),p;do{p=!1;for(let S=0;S<a.length;S++){const v=a[S];k.hasOnlyGoodArcs(v,m)&&(a.splice(S,1),S--,m.add(v),p=!0)}}while(p);return a.map(S=>b.get(S))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(E.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=C;var A;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(A||(A={}));function D(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,b=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==b)return k-b;const m=R.posix.basename(n.extensionLocation.path),a=R.posix.basename(T.extensionLocation.path);return m<a?-1:m>a?1:0}}),define(pe[220],ve([0,1,25]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var y;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function P(A){const D=E.VSBuffer.alloc(1);switch(A){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=P;function C(A,D){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=C}),define(pe[41],ve([0,1,3,2,4,29,181]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class A{constructor(u){this.dependency=u}}e.MissingDependencyError=A;var D;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(u,s,t,i){this.codeLoadingTime=u,this.activateCallTime=s,this.activateResolvedTime=t,this.activationReason=i}}e.ActivationTimes=n;class T{constructor(u,s){this.description=u,this.value=s}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function b(c){c.enableProposedApi||m(c)}e.checkProposedApiEnabled=b;function m(c){throw new Error(`[${c.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.throwProposedApiError=m;function a(c){var u;((u=c.workspaceTrust)===null||u===void 0?void 0:u.required)||p(c)}e.checkRequiresWorkspaceTrust=a;function p(c){throw new Error(`[${c.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=p;function S(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=S;function v(c){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(c.identifier.id),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!1,extensionLocation:c.location},c.manifest),{uuid:c.identifier.uuid})}e.toExtensionDescription=v;class _{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,s){}_activateById(u,s){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,s,t,i,o){}_onExtensionRuntimeError(u,s){}_onExtensionHostExit(u){}}e.NullExtensionService=_}),define(pe[221],ve([0,1,159,29,41,12]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class A{constructor(p,S,v,_){this.startup=p,this.codeLoadingTime=S,this.activateCallTime=v,this.activateResolvedTime=_}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class D{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,S){return p===-1||S===-1?-1:S-p}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class n{constructor(p,S,v,_,c,u){this.activationFailed=p,this.activationFailedError=S,this.activationTimes=v,this.module=_,this.exports=c,this.subscriptions=u}}e.ActivatedExtension=n;class T extends n{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class b extends n{constructor(p){super(!0,p,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let m=class{constructor(p,S,v,_,c){this._logService=c,this._registry=p,this._resolvedExtensionsSet=new Set,S.forEach(u=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,v.forEach(u=>this._hostExtensionsMap.set(y.ExtensionIdentifier.toKey(u),u)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(p){const S=y.ExtensionIdentifier.toKey(p);return this._activatedExtensions.has(S)}getActivatedExtension(p){const S=y.ExtensionIdentifier.toKey(p),v=this._activatedExtensions.get(S);if(!v)throw new Error("Extension `"+p.value+"` is not known or not activated");return v}activateByEvent(p,S){if(this._alreadyActivatedEvents[p])return C;const v=this._registry.getExtensionDescriptionsForActivationEvent(p);return this._activateExtensions(v.map(_=>({id:_.identifier,reason:{startup:S,extensionId:_.identifier,activationEvent:p}}))).then(()=>{this._alreadyActivatedEvents[p]=!0})}activateById(p,S){const v=this._registry.getExtensionDescription(p);if(!v)throw new Error("Extension `"+p+"` is not known");return this._activateExtensions([{id:v.identifier,reason:S}])}_handleActivateRequest(p,S,v){if(this._hostExtensionsMap.has(y.ExtensionIdentifier.toKey(p.id))){S[y.ExtensionIdentifier.toKey(p.id)]=p;return}const _=this._registry.getExtensionDescription(p.id);if(!_){this._host.onExtensionActivationError(p.id,new R.MissingDependencyError(p.id.value));const s=new Error(`Unknown dependency '${p.id.value}'`);this._activatedExtensions.set(y.ExtensionIdentifier.toKey(p.id),new b(s));return}const c=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let u=!0;for(let s=0,t=c.length;s<t;s++){const i=c[s];if(!this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(i))){const o=this._activatedExtensions.get(y.ExtensionIdentifier.toKey(i));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(_.identifier,E.localize(0,null,_.displayName||_.identifier.value,i));const h=new Error(`Dependency ${i} failed to activate`);h.detail=o.activationFailedError,this._activatedExtensions.set(y.ExtensionIdentifier.toKey(_.identifier),new b(h));return}if(this._hostExtensionsMap.has(y.ExtensionIdentifier.toKey(i))){u=!1,S[y.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(y.ExtensionIdentifier.toKey(i)),reason:p.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){u=!1,S[y.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:p.reason};continue}this._host.onExtensionActivationError(_.identifier,new R.MissingDependencyError(i));const l=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(y.ExtensionIdentifier.toKey(_.identifier),new b(l));return}}}u?S[y.ExtensionIdentifier.toKey(_.identifier)]=p:v.push(p)}_activateExtensions(p){if(p.length===0||(p=p.filter(c=>!this._activatedExtensions.has(y.ExtensionIdentifier.toKey(c.id))),p.length===0))return Promise.resolve(void 0);const S=Object.create(null),v=[];for(let c=0,u=p.length;c<u;c++)this._handleActivateRequest(p[c],S,v);for(let c=0,u=v.length;c<u;c++){const s=y.ExtensionIdentifier.toKey(v[c].id);S[s]&&delete S[s]}const _=Object.keys(S).map(c=>S[c]);return v.length===0?Promise.all(_.map(c=>this._activateExtension(c.id,c.reason))).then(c=>{}):this._activateExtensions(_).then(c=>this._activateExtensions(v))}_activateExtension(p,S){const v=y.ExtensionIdentifier.toKey(p);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const _=this._activatingExtensions.get(v);if(_)return _;const c=this._host.actualActivateExtension(p,S).then(void 0,u=>(this._host.onExtensionActivationError(p,E.localize(1,null,p.value,u.message)),this._logService.error(`Activating extension ${p.value} failed due to an error:`),this._logService.error(u),new b(u))).then(u=>{this._activatedExtensions.set(v,u),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,c),c}};m=je([Ue(4,P.ILogService)],m),e.ExtensionsActivator=m}),define(pe[222],ve([0,1,12,41,27,11,109]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends E.LogService{constructor(n){if(n.logFile.scheme!==P.Schemas.file)throw new Error("Only file-logging supported");super(new C.SpdLogLogger(y.ExtensionHostLogFileName,n.logFile.fsPath,!0,n.logLevel))}$setLevel(n){this.setLevel(n)}};A=je([Ue(0,R.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(pe[223],ve([0,1,16]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,C)=>{this._actualOk=P,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,E.onUnexpectedError)(P))}then(P,C){return this._ensureActual().then(P,C)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=y}),define(pe[123],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(D,n){this.isMain=D,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const y=[];function R(A){const D=new E(!0,A);return y[D.nid]=D,D}e.createMainContextProxyIdentifier=R;function P(A){const D=new E(!1,A);return y[D.nid]=D,D}e.createExtHostContextProxyIdentifier=P;function C(A){return y[A].sid}e.getStringIdentifierForProxy=C}),define(pe[5],ve([0,1,2,123,57]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(D=e.CellKind||(e.CellKind={}));var n;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var b;(function(c){c.name="$ident";function u(t,i){return Object.defineProperty(t,c.name,{value:i,enumerable:!0}),t}c.mixin=u;function s(t){return t[c.name]}c.of=s})(b=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(u){return u._id=m._n++,u}}e.IdObject=m,m._n=0;var a;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(c){if(c&&c.edits)for(const u of c.edits)typeof u.resource=="object"?u.resource=E.URI.revive(u.resource):(u.newUri=E.URI.revive(u.newUri),u.oldUri=E.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,R.revive)(u.metadata));return c}e.reviveWorkspaceEditDto=v;var _;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,y.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(pe[86],ve([0,1,5,3,4]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(A){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,D){return this._proxy.$getPassword(A,D)}store(A,D,n){return this._proxy.$setPassword(A,D,n)}delete(A,D){return this._proxy.$deletePassword(A,D)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,R.createDecorator)("IExtHostSecretState")}),define(pe[62],ve([0,1,4,12,5,13]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(D,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(R.MainContext.MainThreadTelemetry)}report(D,n,T){const k=this.getUsageKey(D,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:D}))}getUsageKey(D,n){return`${D}-${n.identifier.value}`}};C=je([Ue(0,P.IExtHostRpcService),Ue(1,y.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(A,D,n){}})}),define(pe[224],ve([0,1,3,5,7,29]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,n,T,k={}){const b=P.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(b)||[],a=T.sort().join(" ");let p=m.find(S=>S.scopes===a);if(p)return p.result;{const S=this._getSession(D,b,n,T,k);p={scopes:a,result:S},m.push(p),this._inFlightRequests.set(b,m);try{await S}finally{const v=m.findIndex(_=>_.scopes===a);v>-1&&(m.splice(v),this._inFlightRequests.set(b,m))}return S}}async _getSession(D,n,T,k,b={}){await this._proxy.$ensureProvider(T);const m=D.displayName||D.name;return this._proxy.$getSession(T,k,n,m,b)}async removeSession(D,n){const T=this._authenticationProviders.get(D);return T?T.provider.removeSession(n):this._proxy.$removeSession(D,n)}registerAuthenticationProvider(D,n,T,k){var b;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:n});const m=T.onDidChangeSessions(a=>{var p,S,v;this._proxy.$sendDidChangeSessions(D,{added:(p=a.added)!==null&&p!==void 0?p:[],changed:(S=a.changed)!==null&&S!==void 0?S:[],removed:(v=a.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(D,n,(b=k==null?void 0:k.supportsMultipleAccounts)!==null&&b!==void 0?b:!1),new R.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(p=>p.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,n){const T=this._authenticationProviders.get(D);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,n){const T=this._authenticationProviders.get(D);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,n){const T=this._authenticationProviders.get(D);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,n){return this._onDidChangeSessions.fire({provider:{id:D,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,n){return D.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(b=>b.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(pe[225],ve([0,1,5,13,20]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(A,D){this._extHostDocumentsAndEditors=D,this._proxy=A.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const D=R.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};P=je([Ue(0,y.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(pe[226],ve([0,1,5]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(P){const C=P.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(A){return C.$writeText(A)}})}}e.ExtHostClipboard=y}),define(pe[51],ve([0,1,15,7,20,22,5,14,12,57,43,49,2,6,4,13]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=i,this.converter=new v(this,o=>{const r=this._apiCommands.get(o);return(r==null?void 0:r.result)===c.Void?r:void 0},i),this._argumentProcessors=[{processArgument(o){return(0,n.revive)(o)}},{processArgument(o){return(0,P.cloneAndChange)(o,function(r){if(T.Range.isIRange(r))return R.Range.to(r);if(k.Position.isIPosition(r))return R.Position.to(r);if(T.Range.isIRange(r.range)&&b.URI.isUri(r.uri))return R.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...o)=>{const r=t.args.map((h,g)=>{if(!h.validate(o[g]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[g]}`);return h.convert(o[g])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new y.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,o,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:o,thisArg:r,description:l}),t&&this._proxy.$registerCommand(i),new y.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,o){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=(0,P.cloneAndChange)(i,function(l){if(l instanceof y.Position)return R.Position.from(l);if(l instanceof y.Range)return R.Range.from(l);if(l instanceof y.Location)return R.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,o);return(0,n.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:r,thisArg:l,description:h}=o;if(h)for(let g=0;g<h.args.length;g++)try{(0,E.validateConstraint)(i[g],h.args[g].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[g].name}' - ${h.args[g].description}`)}try{return await r.apply(l,i)}catch(g){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...i);w&&(t=w.command)}throw this._logService.error(g,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(o=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),o)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(o=>o[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,o]of this._commands){let{description:r}=o;r&&(t[i]=r)}return Promise.resolve(t)}};S=je([Ue(0,p.IExtHostRpcService),Ue(1,D.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class v{constructor(t,i,o){this._commands=t,this._lookupApiCommand=i,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const r=this._lookupApiCommand(t.command);if(r)o.id=r.internalId,o.arguments=r.args.map((l,h)=>l.convert(t.arguments&&t.arguments[h]));else if((0,A.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add((0,m.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),o.$ident=l,o.id=this.delegatingCommandId,o.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return o}}fromInternal(t){const i=C.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class _{constructor(t,i,o,r){this.name=t,this.description=i,this.validate=o,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new _(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",s=>b.URI.isUri(s),s=>s),_.Position=new _("position","A position in a text document",s=>y.Position.isPosition(s),R.Position.from),_.Range=new _("range","A range in a text document",s=>y.Range.isRange(s),R.Range.from),_.Selection=new _("selection","A selection in a text document",s=>y.Selection.isSelection(s),R.Selection.from),_.Number=new _("number","",s=>typeof s=="number",s=>s),_.String=new _("string","",s=>typeof s=="string",s=>s),_.CallHierarchyItem=new _("item","A call hierarchy item",s=>s instanceof y.CallHierarchyItem,R.CallHierarchyItem.to);class c{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=c,c.Void=new c("no result",s=>s);class u{constructor(t,i,o,r,l){this.id=t,this.internalId=i,this.description=o,this.args=r,this.result=l}}e.ApiCommand=u}),define(pe[227],ve([0,1,6,20,7,79,51,199,14,106]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",b(y.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(a,p)=>{if(!(0,D.isFalsyOrEmpty)(a)){class S extends R.SymbolInformation{static to(_){const c=new S(_.name,y.SymbolKind.to(_.kind),_.containerName||"",new R.Location(p[0],y.Range.to(_.range)));return c.detail=_.detail,c.range=c.location.range,c.selectionRange=y.Range.to(_.selectionRange),c.children=_.children?_.children.map(S.to):[],c}}return a.map(S.to)}})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(y.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(y.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(y.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(p=>R.Position.isPosition(p)),a=>a.map(y.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(p=>{let S;for(const v of p.reverse())S=new R.SelectionRange(y.Range.to(v),S);return S}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const p=[];if(Array.isArray(a))for(let S of a)p.push(...S[1].map(y.WorkspaceSymbol.to));return p})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return y.WorkspaceEdit.to(a)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(y.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new R.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const p=(0,n.decodeSemanticTokensDto)(a);if(p.type==="full")return new R.SemanticTokens(p.data,void 0)}})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new R.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const p=(0,n.decodeSemanticTokensDto)(a);if(p.type==="full")return new R.SemanticTokens(p.data,void 0)}})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,p,S)=>{if(!a)return new R.CompletionList([]);const v=a.suggestions.map(_=>y.CompletionItem.to(_,S));return new R.CompletionList(v,a.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return y.SignatureHelp.to(a)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,p,S)=>b(v=>new R.CodeLens(y.Range.to(v.range),v.command&&S.fromInternal(v.command)))(a))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>R.Range.isRange(a),a=>R.Selection.isSelection(a)?y.Selection.from(a):y.Range.from(a)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,p,S)=>b(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(v.command)}else{const _=new R.CodeAction(v.title,v.kind?new R.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=y.WorkspaceEdit.to(v.edit)),v.command&&(_.command=S.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(a))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(p=>new R.ColorInformation(y.Range.to(p.range),y.Color.to(p.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",a=>a instanceof R.Color,y.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:y.Range.from(a.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(y.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(y.InlineHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientMetadata:a.options.transientMetadata},filenamePattern:a.filenamePattern.map(p=>y.NotebookExclusiveDocumentPattern.to(p))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(y.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)]).optional()],C.ApiCommandResult.Void)];class k{constructor(p){this._disposables=new E.DisposableStore,this._commands=p}static register(p){return T.forEach(p.registerApiCommand,p),new k(p).registerCommands()}registerCommands(){const p=S=>(...v)=>S(this._commands,...v);this._register(A.RemoveFromRecentlyOpenedAPICommand.ID,p(A.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(A.OpenIssueReporter.ID,p(A.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(p,S,v){const _=this._commands.registerCommand(!1,p,S,this,v);this._disposables.add(_)}}e.ExtHostApiCommands=k;function b(a){return p=>{if(Array.isArray(p))return p.map(a)}}function m(a){if(!!Array.isArray(a)){const p=[];for(const S of a)P.isLocationLink(S)?p.push(y.DefinitionLink.to(S)):p.push(y.location.to(S));return p}}}),define(pe[228],ve([0,1,17,68,3,6,2,79,29,20,7,5]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class b{constructor(u,s,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(k.MainContext.MainThreadComments),s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const o=this._commentControllers.get(i.handle);return o||i}else if(i&&i.$mid===7){const o=this._commentControllers.get(i.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.commentUniqueId,h=r.getCommentByUniqueId(l);return h||i}else if(i&&i.$mid===10){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const r=o.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.text,h=i.commentUniqueId,g=r.getCommentByUniqueId(h);return g?(g.body=l,g):i}return i}})}createCommentController(u,s,t){const i=b.handlePool++,o=new a(u,i,this._proxy,s,t);this._commentControllers.set(o.handle,o);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(o),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(u.identifier),r),o}$createCommentThreadTemplate(u,s,t){const i=this._commentControllers.get(u);!i||i.$createCommentThreadTemplate(s,t)}async $updateCommentThreadTemplate(u,s,t){const i=this._commentControllers.get(u);!i||i.$updateCommentThreadTemplate(s,t)}$deleteCommentThread(u,s){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(s)}$provideCommentingRanges(u,s,t){const i=this._commentControllers.get(u);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(C.URI.revive(s));return(0,E.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(o,t)).then(r=>r?r.map(l=>n.Range.from(l)):void 0)}$toggleReaction(u,s,t,i,o){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const l=r.getCommentThread(s);if(l){const h=l.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&h&&r.reactionHandler)return r.reactionHandler(h,v(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=b,b.handlePool=0;class m{constructor(u,s,t,i,o,r,l){this._proxy=u,this._commentController=s,this._id=t,this._uri=i,this._range=o,this._comments=r,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${s.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),s={};u("range")&&(s.range=n.Range.from(this._range)),u("label")&&(s.label=this.label),u("contextValue")&&(s.contextValue=this.contextValue),u("comments")&&(s.comments=this._comments.map(t=>p(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(s.collapseState=_(this._collapseState)),u("canReply")&&(s.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,s)}}getCommentByUniqueId(u){for(let s of this._commentsMap){let t=s[0],i=s[1];if(u===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,y.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class a{constructor(u,s,t,i,o){this._extension=u,this._handle=s,this._proxy=t,this._id=i,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,s,t,i){if(typeof u=="string"){const o=new m(this._proxy,this,u,s,t,i,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new m(this._proxy,this,void 0,u,s,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,s){const t=new m(this._proxy,this,void 0,C.URI.revive(u),n.Range.to(s),[],this._extension.identifier);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,s){let t=this._threads.get(u);t&&(t.range=n.Range.to(s))}$deleteCommentThread(u){let s=this._threads.get(u);s&&s.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function p(c,u,s,t){let i=t.get(s);i||(i=++c.commentHandle,t.set(s,i));const o=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(s.body),userName:s.author.name,userIconPath:o,label:s.label,commentReactions:s.reactions?s.reactions.map(r=>S(r)):void 0}}function S(c){return{label:c.label,iconPath:c.iconPath?n.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function v(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function _(c){if(c!==void 0)switch(c){case T.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}}),define(pe[124],ve([0,1,2,5,7,4,13,12,14,10,8]),function(Z,e,E,y,R,P,C,A,D,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class mn{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const p=mn._handlePool++;this._provider.set(p,{provider:m,extensionId:a}),this._proxy.$registerDecorationProvider(p,a.value);const S=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(p,null);return}let _=(0,D.asArray)(v);if(_.length<=mn._maxEventSize){this._proxy.$onDidChange(p,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,_.length);const c=_.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),u=(0,D.groupBy)(c,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let s=[];e:for(let t of u){let i;for(let o of t){let r=(0,T.dirname)(o.uri.path);if(i!==r&&(i=r,s.push(o.uri)>=mn._maxEventSize))break e}}this._proxy.$onDidChange(p,s)});return new R.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(m,a,p){if(!this._provider.has(m))return Object.create(null);const S=Object.create(null),{provider:v,extensionId:_}=this._provider.get(m);return await Promise.all(a.map(async c=>{try{const{uri:u,id:s}=c,t=await Promise.resolve(v.provideFileDecoration(E.URI.revive(u),p));if(!t)return;try{R.FileDecoration.validate(t),S[s]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${_.value}': ${i}`)}}catch(u){this._logService.error(u)}})),S}};k._handlePool=0,k._maxEventSize=250,k=je([Ue(0,C.IExtHostRpcService),Ue(1,A.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(pe[229],ve([0,1,158,110,2,5,7,20,3,12,23]),function(Z,e,E,y,R,P,C,A,D,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(a,p,S,v,_){this._name=a,this._owner=p,this._maxDiagnosticsPerFile=S,this._proxy=v,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,p){if(!a){this.clear();return}this._checkDisposed();let S=[];if(R.URI.isUri(a)){if(!p){this.delete(a);return}this._data.set(a,p.slice()),S=[a]}else if(Array.isArray(a)){S=[];let _;a=[...a].sort(k._compareIndexedTuplesByUri);for(const c of a){const[u,s]=c;if((!_||u.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=u,S.push(u),this._data.set(u,[])),s){const t=this._data.get(u);t&&t.push(...s)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const v=[];for(let _ of S){let c=[];const u=this._data.get(_);if(u)if(u.length>this._maxDiagnosticsPerFile){c=[];const s=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of u)if(i.severity===s[t]&&c.push(A.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;c.push({severity:y.MarkerSeverity.Info,message:(0,E.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=u.map(s=>A.Diagnostic.from(s));v.push([_,c])}this._proxy.$changeMany(this._owner,v)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,p){this._checkDisposed();for(let S of this._data.keys())a.apply(p,[S,this.get(S),this])}get(a){this._checkDisposed();const p=this._data.get(a);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,p){return a[0].toString()<p[0].toString()?-1:a[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=k;let b=class Vt{constructor(a,p){this._logService=p,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=a.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(a,p){return a?a.concat(p):p}static _mapper(a){const p=[],S=new Set;for(const v of a)typeof v=="string"?S.has(v)||(S.add(v),p.push(R.URI.parse(v))):S.has(v.toString())||(S.add(v.toString()),p.push(v));return Object.freeze(p),{uris:p}}createDiagnosticCollection(a,p){const{_collections:S,_proxy:v,_onDidChangeDiagnostics:_,_logService:c}=this,u=new class{$changeMany(i,o){v.$changeMany(i,o),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,i,o.length===0?"CLEARING":o)}$clear(i){v.$clear(i),c.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,i)}dispose(){v.dispose()}};let s;if(!p)p="_generated_diagnostic_collection_name_#"+Vt._idPool++,s=p;else if(!S.has(p))s=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do s=p+Vt._idPool++;while(S.has(s))}return new class extends k{constructor(){super(p,s,Vt._maxDiagnosticsPerFile,u,_);S.set(s,this)}dispose(){super.dispose(),S.delete(s)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const p=new Map,S=[];for(const v of this._collections.values())v.forEach((_,c)=>{let u=p.get(_.toString());typeof u=="undefined"&&(u=S.length,p.set(_.toString(),u),S.push([_,[]])),S[u][1]=S[u][1].concat(...c)});return S}}_getDiagnostics(a){let p=[];for(let S of this._collections.values())S.has(a)&&(p=p.concat(S.get(a)));return p}$acceptMarkersChange(a){if(!this._mirrorCollection){const p="_generated_mirror",S=new k(p,p,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(p,S),this._mirrorCollection=S}for(const[p,S]of a)this._mirrorCollection.set(R.URI.revive(p),S.map(A.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([Ue(1,n.ILogService)],b),e.ExtHostDiagnostics=b}),define(pe[230],ve([0,1,2,5]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(C){this._proxy=C.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(A=>A?A.map(D=>E.URI.revive(D)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(A=>A?E.URI.revive(A):void 0)}}e.ExtHostDialogs=R}),define(pe[231],ve([0,1,16,2,7,5,11,21,10]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,b,m){this._documentsAndEditors=b,this._logService=m,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,b){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const m=n._handlePool++;this._documentContentProviders.set(m,b),this._proxy.$registerTextContentProvider(m,k);let a;return typeof b.onDidChange=="function"&&(a=b.onDidChange(p=>{if(p.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(m,p).then(S=>{if(!(!S&&typeof S!="string")){const v=this._documentsAndEditors.getDocument(p);if(!!v){const _=(0,D.splitLines)(S);if(!v.equalLines(_))return this._proxy.$onVirtualDocumentChange(p,S)}}},E.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(k,b){const m=this._documentContentProviders.get(k);return m?Promise.resolve(m.provideTextDocumentContent(y.URI.revive(b),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(pe[232],ve([0,1,3,6,2,5,118,20,15,22]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(b,m){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const p of a)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const p of a)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!!b){const m=this._documentsAndEditors.getDocument(b);if(m)return m}}getDocument(b){const m=this.getDocumentData(b);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this._documentsAndEditors.getDocument(b);if(m)return Promise.resolve(m);let a=this._documentLoader.get(b.toString());return a||(a=this._proxy.$tryOpenDocument(b).then(p=>{this._documentLoader.delete(b.toString());const S=R.URI.revive(p);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(S))},p=>(this._documentLoader.delete(b.toString()),Promise.reject(p))),this._documentLoader.set(b.toString(),a)),a}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(m=>R.URI.revive(m))}$acceptModelModeChanged(b,m){const a=R.URI.revive(b),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(m),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(b){const m=R.URI.revive(b),a=this._documentsAndEditors.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(b,m){const a=R.URI.revive(b),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");p._acceptIsDirty(m),this._onDidChangeDocument.fire({document:p.document,contentChanges:[]})}$acceptModelChanged(b,m,a){const p=R.URI.revive(b),S=this._documentsAndEditors.getDocument(p);if(!S)throw new Error("unknown document");S._acceptIsDirty(a),S.onEvents(m),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:S.document,contentChanges:m.changes.map(v=>({range:A.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(b,m){(0,C.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=T}),define(pe[39],ve([0,1,52,3,6,2,4,5,118,13,122,20,12,23,11,71,133]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(u,s){this._extHostRpc=u,this._logService=s,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const s=[],t=[],i=[];if(u.removedDocuments)for(const o of u.removedDocuments){const r=P.URI.revive(o),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),s.push(l.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const r=P.URI.revive(o.uri);let l=this._documents.get(r);if(l&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new v(new D.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(u.removedEditors)for(const o of u.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&i.push(r)}if(u.addedEditors)for(const o of u.addedEditors){const r=P.URI.revive(o.documentUri);E.ok(this._documents.has(r),`document '${r}' does not exist`),E.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const l=this._documents.get(r).value,h=new T.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>l.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(g=>k.Range.to(g)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}u.newActiveEditor!==void 0&&(E.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,R.dispose)(s),(0,R.dispose)(i),u.removedDocuments&&this._onDidRemoveDocuments.fire(s),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var s;return(s=this._documents.get(u))===null||s===void 0?void 0:s.value}allDocuments(){return p.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const s=this._editors.get(this._activeEditorId);return u?s:s==null?void 0:s.value}}allEditors(){return[...this._editors.values()]}};_=je([Ue(0,n.IExtHostRpcService),Ue(1,b.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[233],ve([0,1,2,5,6,7,20,141,10,25]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const a=this._schemes.indexOf(m);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),a=[];let p,S,v=14,_=14;for(const c of m){let u=p?(0,D.commonPrefixLength)(p,c):0;for(u===0?S=1:S=_;u<c.length;u++)u+1===c.length?(v=_,_=9):_+=1,a.push([S,c.toUpperCase().charCodeAt(u),_]),a.push([S,c.toLowerCase().charCodeAt(u),_]),S=_;p=c,_=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new A.StateMachine(a)}}provideDocumentLinks(m){this._initStateMachine();const a=[],p=A.LinkComputer.computeLinks({getLineContent(S){return m.lineAt(S-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const S of p){const v=C.DocumentLink.to(S);v.target&&a.push(v)}return a}}class k{constructor(m,a){this._extHostLanguageFeatures=a,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,a,p,S={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,p);let _=2;S.isCaseSensitive&&(_+=1024),S.isReadonly&&(_+=2048),typeof p.copy=="function"&&(_+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(v,a,_).catch(u=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${a}`),console.error(u)});const c=p.onDidChangeFile(u=>{const s=[];for(const t of u){let{uri:i,type:o}=t;if(i.scheme===a){let r;switch(o){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:i,type:r})}}this._proxy.$onFileSystemChange(v,s)});return(0,R.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(m){const{type:a,ctime:p,mtime:S,size:v}=m;return{type:a,ctime:p,mtime:S,size:v}}$stat(m,a){return Promise.resolve(this._getFsProvider(m).stat(E.URI.revive(a))).then(k._asIStat)}$readdir(m,a){return Promise.resolve(this._getFsProvider(m).readDirectory(E.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this._getFsProvider(m).readFile(E.URI.revive(a))).then(p=>n.VSBuffer.wrap(p))}$writeFile(m,a,p,S){return Promise.resolve(this._getFsProvider(m).writeFile(E.URI.revive(a),p.buffer,S))}$delete(m,a,p){return Promise.resolve(this._getFsProvider(m).delete(E.URI.revive(a),p))}$rename(m,a,p,S){return Promise.resolve(this._getFsProvider(m).rename(E.URI.revive(a),E.URI.revive(p),S))}$copy(m,a,p,S){const v=this._getFsProvider(m);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(E.URI.revive(a),E.URI.revive(p),S))}$mkdir(m,a){return Promise.resolve(this._getFsProvider(m).createDirectory(E.URI.revive(a)))}$watch(m,a,p,S){const v=this._getFsProvider(m).watch(E.URI.revive(p),S);this._watches.set(a,v)}$unwatch(m,a){const p=this._watches.get(a);p&&(p.dispose(),this._watches.delete(a))}$open(m,a,p){const S=this._getFsProvider(m);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(E.URI.revive(a),p))}$close(m,a){const p=this._getFsProvider(m);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(a))}$read(m,a,p,S){const v=this._getFsProvider(m);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const _=n.VSBuffer.alloc(S);return Promise.resolve(v.read(a,p,_.buffer,0,S)).then(c=>_.slice(0,c))}$write(m,a,p,S){const v=this._getFsProvider(m);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,p,S.buffer,0,S.byteLength))}_getFsProvider(m){const a=this._fsProvider.get(m);if(!a){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return a}}e.ExtHostFileSystem=k}),define(pe[87],ve([0,1,5,44,7,25,4,13,60]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Lt{constructor(k,b){const m=k.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return m.$stat(a).catch(Lt._handleError)},readDirectory(a){return m.$readdir(a).catch(Lt._handleError)},createDirectory(a){return m.$mkdir(a).catch(Lt._handleError)},async readFile(a){return m.$readFile(a).then(p=>p.buffer).catch(Lt._handleError)},writeFile(a,p){return m.$writeFile(a,P.VSBuffer.wrap(p)).catch(Lt._handleError)},delete(a,p){return m.$delete(a,Object.assign({recursive:!1,useTrash:!1},p)).catch(Lt._handleError)},rename(a,p,S){return m.$rename(a,p,Object.assign({overwrite:!1},S)).catch(Lt._handleError)},copy(a,p,S){return m.$copy(a,p,Object.assign({overwrite:!1},S)).catch(Lt._handleError)},isWritableFileSystem(a){const p=b.getCapabilities(a);if(typeof p=="number")return!(p&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new R.FileSystemError(String(k));if(k.name==="ENOPRO")throw R.FileSystemError.Unavailable(k.message);switch(k.name){case y.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(k.message);case y.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(k.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(k.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(k.message);case y.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(k.message);case y.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(k.message);default:throw new R.FileSystemError(k.message,k.name)}}};n=je([Ue(0,A.IExtHostRpcService),Ue(1,D.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[234],ve([0,1,6,5]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(C){this._handlePool=0,this._proxy=C.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,C),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=R}),define(pe[235],ve([0,1,2,22,20,7,17,5,10,43,14,15,138,6,106,70,116,46,16]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(z,J){this._documents=z,this._provider=J}provideDocumentSymbols(z,J){const te=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentSymbols(te,J)).then(ae=>{if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(R.DocumentSymbol.from):c._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(z){var J;z=z.slice(0).sort((fe,De)=>{let Oe=fe.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(fe.location.range.end)),Oe});const te=[],ae=[];for(const fe of z){const De={name:fe.name||"!!MISSING: name!!",kind:R.SymbolKind.from(fe.kind),tags:((J=fe.tags)===null||J===void 0?void 0:J.map(R.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:R.Range.from(fe.location.range),selectionRange:R.Range.from(fe.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),te.push(De);break}const Oe=ae[ae.length-1];if(n.Range.containsRange(Oe.range,De.range)&&!n.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),ae.push(De);break}ae.pop()}}return te}}class u{constructor(z,J,te){this._documents=z,this._commands=J,this._provider=te,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,J){const te=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(te,J);if(!(!ae||J.isCancellationRequested)){const fe=this._cache.add(ae),De=new m.DisposableStore;this._disposables.set(fe,De);const Oe={cacheId:fe,lenses:[]};for(let _e=0;_e<ae.length;_e++)Oe.lenses.push({cacheId:[fe,_e],range:R.Range.from(ae[_e].range),command:this._commands.toInternal(ae[_e].command,De)});return Oe}}async resolveCodeLens(z,J){var te;const ae=z.cacheId&&this._cache.get(...z.cacheId);if(!!ae){let fe;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?fe=ae:fe=await this._provider.resolveCodeLens(ae,J),fe||(fe=ae),!J.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((te=fe.command)!==null&&te!==void 0?te:u._badCmd,De),z}}}releaseCodeLenses(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(Me){return Array.isArray(Me)?Me.map(R.DefinitionLink.from):Me?[R.DefinitionLink.from(Me)]:[]}class t{constructor(z,J){this._documents=z,this._provider=J}provideDefinition(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideDefinition(ae,fe,te)).then(s)}}class i{constructor(z,J){this._documents=z,this._provider=J}provideDeclaration(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideDeclaration(ae,fe,te)).then(s)}}class o{constructor(z,J){this._documents=z,this._provider=J}provideImplementation(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideImplementation(ae,fe,te)).then(s)}}class r{constructor(z,J){this._documents=z,this._provider=J}provideTypeDefinition(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideTypeDefinition(ae,fe,te)).then(s)}}class l{constructor(z,J){this._documents=z,this._provider=J}provideHover(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideHover(ae,fe,te)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(fe)),De.range||(De.range=new P.Range(fe,fe)),R.Hover.from(De)})}}class h{constructor(z,J){this._documents=z,this._provider=J}provideEvaluatableExpression(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,fe,te)).then(De=>{if(De)return R.EvaluatableExpression.from(De)})}}class g{constructor(z,J){this._documents=z,this._provider=J}provideInlineValues(z,J,te,ae){const fe=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideInlineValues(fe,R.Range.to(J),R.InlineValueContext.to(te),ae)).then(De=>{if(Array.isArray(De))return De.map(Oe=>R.InlineValue.from(Oe))})}}class w{constructor(z,J){this._documents=z,this._provider=J}provideDocumentHighlights(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideDocumentHighlights(ae,fe,te)).then(De=>{if(Array.isArray(De))return De.map(R.DocumentHighlight.from)})}}class d{constructor(z,J){this._documents=z,this._provider=J}provideLinkedEditingRanges(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,fe,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(R.Range.from)),wordPattern:De.wordPattern}})}}class f{constructor(z,J){this._documents=z,this._provider=J}provideReferences(z,J,te,ae){const fe=this._documents.getDocument(z),De=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideReferences(fe,De,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(R.location.from)})}}class I{constructor(z,J,te,ae,fe,De,Oe){this._documents=z,this._commands=J,this._diagnostics=te,this._provider=ae,this._logService=fe,this._extension=De,this._apiDeprecation=Oe,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,J,te,ae){const fe=this._documents.getDocument(z),De=b.Selection.isISelection(J)?R.Selection.to(J):R.Range.to(J),Oe=[];for(const ke of this._diagnostics.getDiagnostics(z))if(De.intersection(ke.range)&&Oe.push(ke)>I._maxCodeActionsPerFile)break;const _e={diagnostics:Oe,only:te.only?new P.CodeActionKind(te.only):void 0,triggerKind:R.CodeActionTriggerKind.to(te.trigger)};return(0,C.asPromise)(()=>this._provider.provideCodeActions(fe,De,_e,ae)).then(ke=>{var Te;if(!(!(0,T.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const xe=this._cache.add(ke),Se=new m.DisposableStore;this._disposables.set(xe,Se);const Ke=[];for(let G=0;G<ke.length;G++){const ie=ke[G];!ie||(I._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(_e.only&&(ie.kind?_e.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${_e.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${_e.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[xe,G],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(R.Diagnostic.from),edit:ie.edit&&R.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Te=ie.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:xe,actions:Ke}}})}async resolveCodeAction(z,J){var te;const[ae,fe]=z,De=this._cache.get(ae,fe);if(!(!De||I._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(te=await this._provider.resolveCodeAction(De,J))!==null&&te!==void 0?te:De;return(Oe==null?void 0:Oe.edit)?R.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}I._maxCodeActionsPerFile=1e3;class L{constructor(z,J){this._documents=z,this._provider=J}provideDocumentFormattingEdits(z,J,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,J,te)).then(fe=>{if(Array.isArray(fe))return fe.map(R.TextEdit.from)})}}class B{constructor(z,J){this._documents=z,this._provider=J}provideDocumentRangeFormattingEdits(z,J,te,ae){const fe=this._documents.getDocument(z),De=R.Range.to(J);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,De,te,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(R.TextEdit.from)})}}class ee{constructor(z,J){this._documents=z,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,J,te,ae,fe){const De=this._documents.getDocument(z),Oe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,te,ae,fe)).then(_e=>{if(Array.isArray(_e))return _e.map(R.TextEdit.from)})}}class H{constructor(z,J){this._provider=z,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,J){const te=A.IdObject.mixin({symbols:[]});return(0,C.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,J)).then(ae=>{if((0,T.isNonEmptyArray)(ae)){for(const fe of ae)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const De=A.IdObject.mixin(R.WorkspaceSymbol.from(fe));this._symbolCache.set(De._id,fe),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(z,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const te=this._symbolCache.get(z._id);if(te){const ae=await(0,C.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,J));return ae&&(0,y.mixin)(z,R.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const J=this._resultCache.get(z);if(J){for(let[te,ae]=J;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(z)}}}class x{constructor(z,J,te){this._documents=z,this._provider=J,this._logService=te}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,J,te,ae){const fe=this._documents.getDocument(z),De=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.provideRenameEdits(fe,De,te,ae)).then(Oe=>{if(!!Oe)return R.WorkspaceEdit.from(Oe)},Oe=>{const _e=x._asMessage(Oe);return _e?{rejectReason:_e,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(z,J,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),fe=R.Position.to(J);return(0,C.asPromise)(()=>this._provider.prepareRename(ae,fe,te)).then(De=>{let Oe,_e;if(P.Range.isRange(De)?(Oe=De,_e=ae.getText(De)):(0,k.isObject)(De)&&(Oe=De.range,_e=De.placeholder),!!Oe){if(Oe.start.line>fe.line||Oe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(Oe),text:_e}}},De=>{const Oe=x._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,J){this.resultId=z,this.tokens=J}}class F{constructor(z,J){this._documents=z,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,J,te){const ae=this._documents.getDocument(z),fe=J!==0?this._previousResults.get(J):null;return(0,C.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,fe.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(De=>(fe&&this._previousResults.delete(J),De?(De=F._fixProvidedSemanticTokens(De),this._send(F._convertToEdits(fe,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return F._isSemanticTokens(z)?F._isCorrectSemanticTokens(z)?z:new P.SemanticTokens(new Uint32Array(z.data),z.resultId):F._isSemanticTokensEdits(z)?F._isCorrectSemanticTokensEdits(z)?z:new P.SemanticTokensEdits(z.edits.map(J=>new P.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const J of z.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,J){if(!F._isSemanticTokens(J)||!z||!z.tokens)return J;const te=z.tokens,ae=te.length,fe=J.data,De=fe.length;let Oe=0;const _e=Math.min(ae,De);for(;Oe<_e&&te[Oe]===fe[Oe];)Oe++;if(Oe===ae&&Oe===De)return new P.SemanticTokensEdits([],J.resultId);let ke=0;const Te=_e-Oe;for(;ke<Te&&te[ae-ke-1]===fe[De-ke-1];)ke++;return new P.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-ke,data:fe.subarray(Oe,De-ke)}],J.resultId)}_send(z,J){if(F._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new $(z.resultId,z.data)),(0,a.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(F._isSemanticTokensEdits(z)){const te=this._nextResultId++;return F._isSemanticTokens(J)?this._previousResults.set(te,new $(J.resultId,J.data)):this._previousResults.set(te,new $(z.resultId)),(0,a.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class U{constructor(z,J){this._documents=z,this._provider=J}provideDocumentRangeSemanticTokens(z,J,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,R.Range.to(J),te)).then(fe=>fe?this._send(fe):null)}_send(z){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(z,J,te,ae,fe){this._documents=z,this._commands=J,this._provider=te,this._apiDeprecation=ae,this._extension=fe,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,J,te,ae){const fe=this._documents.getDocument(z),De=R.Position.to(J),Oe=fe.getWordRangeAtPosition(De)||new P.Range(De,De),_e=Oe.with({end:De}),ke=new v.StopWatch(!0),Te=await(0,C.asPromise)(()=>this._provider.provideCompletionItems(fe,De,ae,R.CompletionContext.to(te)));if(!!Te&&!ae.isCancellationRequested){const xe=Array.isArray(Te)?new P.CompletionList(Te):Te,Se=M.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(Se,Ke);const G=[],ie={x:Se,b:G,a:{replace:R.Range.from(Oe),insert:R.Range.from(_e)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let Ee=0;Ee<xe.items.length;Ee++){const Ne=xe.items[Ee],ze=this._convertCompletionItem(Ne,[Se,Ee],_e,Oe);G.push(ze)}return ie}}async resolveCompletionItem(z,J){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...z);if(!!te){const ae=await(0,C.asPromise)(()=>this._provider.resolveCompletionItem(te,J));if(!!ae)return this._convertCompletionItem(ae,z)}}}releaseCompletionItems(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,J,te,ae){var fe;const De=this._disposables.get(J[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:J,a:(fe=z.label)!==null&&fe!==void 0?fe:"",o:z.label2,b:z.kind!==void 0?R.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(R.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof P.SnippetString&&(Oe.h=z.insertText.value,Oe.i|=4);let _e;return z.textEdit?_e=z.textEdit.range:z.range&&(_e=z.range),P.Range.isRange(_e)?Oe.j=R.Range.from(_e):_e&&(!(te==null?void 0:te.isEqual(_e.inserting))||!(ae==null?void 0:ae.isEqual(_e.replacing)))&&(Oe.j={insert:R.Range.from(_e.inserting),replace:R.Range.from(_e.replacing)}),Oe}}class N{constructor(z,J){this._documents=z,this._provider=J,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(z,J,te,ae){const fe=this._documents.getDocument(z),De=R.Position.to(J),Oe=this.reviveContext(te);return(0,C.asPromise)(()=>this._provider.provideSignatureHelp(fe,De,ae,Oe)).then(_e=>{if(_e){const ke=this._cache.add([_e]);return Object.assign(Object.assign({},R.SignatureHelp.from(_e)),{id:ke})}})}reviveContext(z){let J;if(z.activeSignatureHelp){const te=R.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=te.activeSignature,J.activeParameter=te.activeParameter):J=te}return Object.assign(Object.assign({},z),{activeSignatureHelp:J})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,J){this._documents=z,this._provider=J}provideInlineHints(z,J,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideInlineHints(ae,R.Range.to(J),te)).then(fe=>fe?{hints:fe.map(R.InlineHint.from)}:void 0)}}class V{constructor(z,J){this._documents=z,this._provider=J,this._cache=new S.Cache("DocumentLink")}provideLinks(z,J){const te=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentLinks(te,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(R.DocumentLink.from)};{const fe=this._cache.add(ae),De={links:[],id:fe};for(let Oe=0;Oe<ae.length;Oe++){const _e=R.DocumentLink.from(ae[Oe]);_e.cacheId=[fe,Oe],De.links.push(_e)}return De}}})}resolveLink(z,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...z);return te?(0,C.asPromise)(()=>this._provider.resolveDocumentLink(te,J)).then(ae=>ae&&R.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,J){this._documents=z,this._provider=J}provideColors(z,J){const te=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideDocumentColors(te,J)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:R.Color.from(De.color),range:R.Range.from(De.range)})):[])}provideColorPresentations(z,J,te){const ae=this._documents.getDocument(z),fe=R.Range.to(J.range),De=R.Color.to(J.color);return(0,C.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:fe},te)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(R.ColorPresentation.from)})}}class Q{constructor(z,J){this._documents=z,this._provider=J}provideFoldingRanges(z,J,te){const ae=this._documents.getDocument(z);return(0,C.asPromise)(()=>this._provider.provideFoldingRanges(ae,J,te)).then(fe=>{if(!!Array.isArray(fe))return fe.map(R.FoldingRange.from)})}}class me{constructor(z,J,te){this._documents=z,this._provider=J,this._logService=te}provideSelectionRanges(z,J,te){const ae=this._documents.getDocument(z),fe=J.map(R.Position.to);return(0,C.asPromise)(()=>this._provider.provideSelectionRanges(ae,fe,te)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let _e=0;_e<fe.length;_e++){const ke=[];Oe.push(ke);let Te=fe[_e],xe=De[_e];for(;;){if(!xe.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(R.SelectionRange.from(xe)),!xe.parent)break;Te=xe.range,xe=xe.parent}}return Oe})}}class we{constructor(z,J){this._documents=z,this._provider=J,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(z,J,te){const ae=this._documents.getDocument(z),fe=R.Position.to(J),De=await this._provider.prepareCallHierarchy(ae,fe,te);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(_e=>this._cacheAndConvertItem(Oe,_e)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(z,J,te){const ae=this._itemFromCache(z,J);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!fe)return fe.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Oe=>R.Range.from(Oe))}))}async provideCallsFrom(z,J,te){const ae=this._itemFromCache(z,J);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!fe)return fe.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Oe=>R.Range.from(Oe))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,J){var te;const ae=this._cache.get(z),fe={_sessionId:z,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:R.SymbolKind.from(J.kind),uri:J.uri,range:R.Range.from(J.range),selectionRange:R.Range.from(J.selectionRange),tags:(te=J.tags)===null||te===void 0?void 0:te.map(R.SymbolTag.from)};return ae.set(fe._itemId,J),fe}_itemFromCache(z,J){const te=this._cache.get(z);return te==null?void 0:te.get(J)}}class Ae{constructor(z,J){this.adapter=z,this.extension=J}}class Ie{constructor(z,J,te,ae,fe,De,Oe){this._adapter=new Map,this._uriTransformer=J,this._proxy=z.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=fe,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(z){return(0,T.coalesce)((0,T.asArray)(z).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:R.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new P.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ie._handlePool++}_withAdapter(z,J,te,ae,fe=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(ae);if(De.adapter instanceof J){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${J.name}'`));const _e=te(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(_e).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Te=>{fe&&Te instanceof _.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Te))}),_e}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,J){const te=this._nextHandle();return this._adapter.set(te,new Ae(z,J)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,J,te,ae){const fe=this._addNewAdapter(new c(this._documents,te),z),De=ae&&ae.label||Ie._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(J),De),this._createDisposable(fe)}$provideDocumentSymbols(z,J,te){return this._withAdapter(z,c,ae=>ae.provideDocumentSymbols(E.URI.revive(J),te),void 0)}registerCodeLensProvider(z,J,te){const ae=this._nextHandle(),fe=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new u(this._documents,this._commands.converter,te),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Oe=te.onDidChangeCodeLenses(_e=>this._proxy.$emitCodeLensEvent(fe));De=P.Disposable.from(De,Oe)}return De}$provideCodeLenses(z,J,te){return this._withAdapter(z,u,ae=>ae.provideCodeLenses(E.URI.revive(J),te),void 0)}$resolveCodeLens(z,J,te){return this._withAdapter(z,u,ae=>ae.resolveCodeLens(J,te),void 0)}$releaseCodeLenses(z,J){this._withAdapter(z,u,te=>Promise.resolve(te.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(z,J,te){const ae=this._addNewAdapter(new t(this._documents,te),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(z,J,te,ae){return this._withAdapter(z,t,fe=>fe.provideDefinition(E.URI.revive(J),te,ae),[])}registerDeclarationProvider(z,J,te){const ae=this._addNewAdapter(new i(this._documents,te),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(z,J,te,ae){return this._withAdapter(z,i,fe=>fe.provideDeclaration(E.URI.revive(J),te,ae),[])}registerImplementationProvider(z,J,te){const ae=this._addNewAdapter(new o(this._documents,te),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(z,J,te,ae){return this._withAdapter(z,o,fe=>fe.provideImplementation(E.URI.revive(J),te,ae),[])}registerTypeDefinitionProvider(z,J,te){const ae=this._addNewAdapter(new r(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(z,J,te,ae){return this._withAdapter(z,r,fe=>fe.provideTypeDefinition(E.URI.revive(J),te,ae),[])}registerHoverProvider(z,J,te,ae){const fe=this._addNewAdapter(new l(this._documents,te),z);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(J)),this._createDisposable(fe)}$provideHover(z,J,te,ae){return this._withAdapter(z,l,fe=>fe.provideHover(E.URI.revive(J),te,ae),void 0)}registerEvaluatableExpressionProvider(z,J,te,ae){const fe=this._addNewAdapter(new h(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(J)),this._createDisposable(fe)}$provideEvaluatableExpression(z,J,te,ae){return this._withAdapter(z,h,fe=>fe.provideEvaluatableExpression(E.URI.revive(J),te,ae),void 0)}registerInlineValuesProvider(z,J,te,ae){const fe=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new g(this._documents,te),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(J),fe);let Oe=this._createDisposable(De);if(fe!==void 0){const _e=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(fe));Oe=P.Disposable.from(Oe,_e)}return Oe}$provideInlineValues(z,J,te,ae,fe){return this._withAdapter(z,g,De=>De.provideInlineValues(E.URI.revive(J),te,ae,fe),void 0)}registerDocumentHighlightProvider(z,J,te){const ae=this._addNewAdapter(new w(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(z,J,te,ae){return this._withAdapter(z,w,fe=>fe.provideDocumentHighlights(E.URI.revive(J),te,ae),void 0)}registerLinkedEditingRangeProvider(z,J,te){const ae=this._addNewAdapter(new d(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,J,te,ae){return this._withAdapter(z,d,async fe=>{const De=await fe.provideLinkedEditingRanges(E.URI.revive(J),te,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ie._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,J,te){const ae=this._addNewAdapter(new f(this._documents,te),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(z,J,te,ae,fe){return this._withAdapter(z,f,De=>De.provideReferences(E.URI.revive(J),te,ae,fe),void 0)}registerCodeActionProvider(z,J,te,ae){var fe,De;const Oe=new m.DisposableStore,_e=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(_e,this._transformDocumentSelector(J),{providedKinds:(fe=ae==null?void 0:ae.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Oe)}))},Ie._extLabel(z),Boolean(te.resolveCodeAction)),Oe.add(this._createDisposable(_e)),Oe}$provideCodeActions(z,J,te,ae,fe){return this._withAdapter(z,I,De=>De.provideCodeActions(E.URI.revive(J),te,ae,fe),void 0)}$resolveCodeAction(z,J,te){return this._withAdapter(z,I,ae=>ae.resolveCodeAction(J,te),void 0)}$releaseCodeActions(z,J){this._withAdapter(z,I,te=>Promise.resolve(te.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(z,J,te){const ae=this._addNewAdapter(new L(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,J,te,ae){return this._withAdapter(z,L,fe=>fe.provideDocumentFormattingEdits(E.URI.revive(J),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,J,te){const ae=this._addNewAdapter(new B(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,J,te,ae,fe){return this._withAdapter(z,B,De=>De.provideDocumentRangeFormattingEdits(E.URI.revive(J),te,ae,fe),void 0)}registerOnTypeFormattingEditProvider(z,J,te,ae){const fe=this._addNewAdapter(new ee(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(J),ae,z.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(z,J,te,ae,fe,De){return this._withAdapter(z,ee,Oe=>Oe.provideOnTypeFormattingEdits(E.URI.revive(J),te,ae,fe,De),void 0)}registerWorkspaceSymbolProvider(z,J){const te=this._addNewAdapter(new H(J,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(z,J,te){return this._withAdapter(z,H,ae=>ae.provideWorkspaceSymbols(J,te),{symbols:[]})}$resolveWorkspaceSymbol(z,J,te){return this._withAdapter(z,H,ae=>ae.resolveWorkspaceSymbol(J,te),void 0)}$releaseWorkspaceSymbols(z,J){this._withAdapter(z,H,te=>te.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(z,J,te){const ae=this._addNewAdapter(new x(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),x.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(z,J,te,ae,fe){return this._withAdapter(z,x,De=>De.provideRenameEdits(E.URI.revive(J),te,ae,fe),void 0)}$resolveRenameLocation(z,J,te,ae){return this._withAdapter(z,x,fe=>fe.resolveRenameLocation(E.URI.revive(J),te,ae),void 0)}registerDocumentSemanticTokensProvider(z,J,te,ae){const fe=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Ae(new F(this._documents,te),z)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(J),ae,De);let Oe=this._createDisposable(fe);if(De){const _e=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=P.Disposable.from(Oe,_e)}return Oe}$provideDocumentSemanticTokens(z,J,te,ae){return this._withAdapter(z,F,fe=>fe.provideDocumentSemanticTokens(E.URI.revive(J),te,ae),null,!0)}$releaseDocumentSemanticTokens(z,J){this._withAdapter(z,F,te=>te.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(z,J,te,ae){const fe=this._addNewAdapter(new U(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(J),ae),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(z,J,te,ae){return this._withAdapter(z,U,fe=>fe.provideDocumentRangeSemanticTokens(E.URI.revive(J),te,ae),null,!0)}registerCompletionItemProvider(z,J,te,ae){const fe=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(J),ae,M.supportsResolving(te),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(fe)}$provideCompletionItems(z,J,te,ae,fe){return this._withAdapter(z,M,De=>De.provideCompletionItems(E.URI.revive(J),te,ae,fe),void 0)}$resolveCompletionItem(z,J,te){return this._withAdapter(z,M,ae=>ae.resolveCompletionItem(J,te),void 0)}$releaseCompletionItems(z,J){this._withAdapter(z,M,te=>te.releaseCompletionItems(J),void 0)}registerSignatureHelpProvider(z,J,te,ae){const fe=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(J),fe),this._createDisposable(De)}$provideSignatureHelp(z,J,te,ae,fe){return this._withAdapter(z,N,De=>De.provideSignatureHelp(E.URI.revive(J),te,ae,fe),void 0)}$releaseSignatureHelp(z,J){this._withAdapter(z,N,te=>te.releaseSignatureHelp(J),void 0)}registerInlineHintsProvider(z,J,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new O(this._documents,te),z);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(J),ae);let De=this._createDisposable(fe);if(ae!==void 0){const Oe=te.onDidChangeInlineHints(_e=>this._proxy.$emitInlineHintsEvent(ae));De=P.Disposable.from(De,Oe)}return De}$provideInlineHints(z,J,te,ae){return this._withAdapter(z,O,fe=>fe.provideInlineHints(E.URI.revive(J),te,ae),void 0)}registerDocumentLinkProvider(z,J,te){const ae=this._addNewAdapter(new V(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,J,te){return this._withAdapter(z,V,ae=>ae.provideLinks(E.URI.revive(J),te),void 0)}$resolveDocumentLink(z,J,te){return this._withAdapter(z,V,ae=>ae.resolveLink(J,te),void 0)}$releaseDocumentLinks(z,J){this._withAdapter(z,V,te=>te.releaseLinks(J),void 0)}registerColorProvider(z,J,te){const ae=this._addNewAdapter(new q(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(z,J,te){return this._withAdapter(z,q,ae=>ae.provideColors(E.URI.revive(J),te),[])}$provideColorPresentations(z,J,te,ae){return this._withAdapter(z,q,fe=>fe.provideColorPresentations(E.URI.revive(J),te,ae),void 0)}registerFoldingRangeProvider(z,J,te){const ae=this._nextHandle(),fe=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new Q(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Oe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));De=P.Disposable.from(De,Oe)}return De}$provideFoldingRanges(z,J,te,ae){return this._withAdapter(z,Q,fe=>fe.provideFoldingRanges(E.URI.revive(J),te,ae),void 0)}registerSelectionRangeProvider(z,J,te){const ae=this._addNewAdapter(new me(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(z,J,te,ae){return this._withAdapter(z,me,fe=>fe.provideSelectionRanges(E.URI.revive(J),te,ae),[])}registerCallHierarchyProvider(z,J,te){const ae=this._addNewAdapter(new we(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(z,J,te,ae){return this._withAdapter(z,we,fe=>Promise.resolve(fe.prepareSession(E.URI.revive(J),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,J,te,ae){return this._withAdapter(z,we,fe=>fe.provideCallsTo(J,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,J,te,ae){return this._withAdapter(z,we,fe=>fe.provideCallsFrom(J,te,ae),void 0)}$releaseCallHierarchy(z,J){this._withAdapter(z,we,te=>Promise.resolve(te.releaseSession(J)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ie._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ie._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ie._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ie._serializeRegExp(z.beforeText),afterText:z.afterText?Ie._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ie._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(z,J,te){let{wordPattern:ae}=te;if(ae&&(0,D.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const fe=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ie._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ie._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ie._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,J,De),this._createDisposable(fe)}$setWordDefinitions(z){for(const J of z)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(pe[236],ve([0,1,5,20,7]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(A,D){this._proxy=A.getProxy(E.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,D){await this._proxy.$changeLanguage(A,D);const n=this._documents.getDocumentData(A);if(!n)throw new Error(`document '${A.toString}' NOT found`);return n.document}async tokenAtPosition(A,D){var n;const T=A.version,k=y.Position.from(D),b=await this._proxy.$tokensAtPosition(A.uri,k),m={type:R.StandardTokenType.Other,range:(n=A.getWordRangeAtPosition(D))!==null&&n!==void 0?n:new R.Range(D.line,D.character,D.line,D.character)};if(!b)return m;const a={range:y.Range.to(b.range),type:y.TokenType.to(b.type)};return!a.range.contains(D)||T!==A.version?m:a}}e.ExtHostLanguages=P}),define(pe[237],ve([0,1,5,12,41]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(A){return A&&A.title}let C=class{constructor(D,n){this._logService=n,this._proxy=D.getProxy(E.MainContext.MainThreadMessageService)}showMessage(D,n,T,k,b){const m={extension:D};let a;typeof k=="string"||P(k)?a=[k,...b]:(m.modal=k&&k.modal,m.useCustom=k&&k.useCustom,a=b),m.useCustom&&(0,R.checkProposedApiEnabled)(D);const p=[];for(let S=0;S<a.length;S++){const v=a[S];if(typeof v=="string")p.push({title:v,handle:S,isCloseAffordance:!1});else if(typeof v=="object"){let{title:_,isCloseAffordance:c}=v;p.push({title:_,isCloseAffordance:!!c,handle:S})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(n,T,m,p).then(S=>{if(typeof S=="number")return a[S]})}};C=je([Ue(1,y.ILogService)],C),e.ExtHostMessageService=C}),define(pe[238],ve([0,1,21,3,6,2,28,5,20,7,84,85,23,214,215,70,15,25,73]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends R.Disposable{constructor(g,w,d,f,I){super();this._editorId=g,this.uri=w,this._proxy=d,this._webviewInitData=f,this.document=I,this._onDidReceiveDocumentMessage=new y.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:L=>this._proxy.$postMessage(this._editorId,void 0,L),asWebviewUri:L=>this._asWebviewUri(L)}}onDidReceiveMessage(g,w){var d;this._onDidReceiveDocumentMessage.fire(w),g!==void 0&&((d=this._rendererIdToEmitters.get(g))===null||d===void 0||d.fire(w))}getRendererComm(g){const w=new y.Emitter;return this._rendererIdToEmitters.set(g,w),{editorId:this._editorId,onDidReceiveMessage:w.event,postMessage:d=>this._proxy.$postMessage(this._editorId,g,d),asWebviewUri:d=>this._asWebviewUri(d)}}_asWebviewUri(g){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,g)}}class u extends R.Disposable{constructor(g,w,d,f){super();this._proxy=g,this._handle=w,this._extension=d,this._provider=f,this._kernelToFriendlyId=new b.ResourceMap,this._friendlyIdToKernel=new b.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(I=>{const L=I==null?void 0:I.uri;this._proxy.$onNotebookKernelChange(this._handle,L)}))}async provideKernels(g,w){const d=await this._provider.provideKernels(g.notebookDocument,w)||[],f=new Map;let I=0;const L=new Set,B=this._kernelToFriendlyId.get(g.uri),ee=d.map(x=>{let $=B==null?void 0:B.get(x);return $===void 0&&(x.id&&L.has(x.id)?$=`${this._extension.identifier.value}_${x.id}_${I++}`:$=`${this._extension.identifier.value}_${x.id||C.generateUuid()}`),f.set(x,$),{id:x.id,friendlyId:$,label:x.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:x.description,detail:x.detail,isPreferred:x.isPreferred,preloads:x.preloads,supportedLanguages:x.supportedLanguages,implementsInterrupt:!!x.interrupt}});this._kernelToFriendlyId.set(g.uri,f);const H=new Map;return f.forEach((x,$)=>{H.set(x,$)}),this._friendlyIdToKernel.set(g.uri,H),ee}getKernelByFriendlyId(g,w){var d;return(d=this._friendlyIdToKernel.get(g))===null||d===void 0?void 0:d.get(w)}async resolveNotebook(g,w,d,f){var I;const L=(I=this._friendlyIdToKernel.get(w.uri))===null||I===void 0?void 0:I.get(g);if(L&&this._provider.resolveKernel)return this._provider.resolveKernel(L,w.notebookDocument,d,f)}async executeNotebook(g,w,d){var f;const I=(f=this._friendlyIdToKernel.get(w.uri))===null||f===void 0?void 0:f.get(g);if(!!I){const L=d.map(B=>D.NotebookCellRange.to(B));return I.executeCellsRequest(w.notebookDocument,L)}}async interruptNotebookExecution(g,w){var d;const f=(d=this._friendlyIdToKernel.get(w.uri))===null||d===void 0?void 0:d.get(g);if(!(!f||!f.interrupt))return f.interrupt(w.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=u;class s{constructor(g,w){const d=s._Keys.nextId();g.$registerNotebookEditorDecorationType(d,D.NotebookDecorationRenderOptions.from(w)),this.value={key:d,dispose(){g.$removeNotebookEditorDecorationType(d)}}}}e.NotebookEditorDecorationType=s,s._Keys=new p.IdGenerator("NotebookEditorDecorationType");class t{constructor(g,w,d,f,I,L,B){this._textDocumentsAndEditors=d,this._textDocuments=f,this._webviewInitData=I,this.logService=L,this._extensionStoragePaths=B,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new b.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new y.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new y.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new y.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new y.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new y.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new y.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new y.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new y.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new y.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new b.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._proxy=g.getProxy(A.MainContext.MainThreadNotebook),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:ee=>{var H;if(ee&&ee.$mid===12){const x=(H=ee.notebookEditor)===null||H===void 0?void 0:H.notebookUri,$=ee.cell.handle,F=this._documents.get(x),U=F==null?void 0:F.getCell($);if(U)return U.cell}return ee}})}get activeNotebookEditor(){var g;return(g=this._activeNotebookEditor)===null||g===void 0?void 0:g.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(g=>g.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(g){return this._documents.get(g)}_getNotebookDocument(g){const w=this._documents.get(g);if(!w)throw new Error(`NO notebook document for '${g}'`);return w}_getProviderData(g){const w=this._notebookContentProviders.get(g);if(!w)throw new Error(`NO provider for '${g}'`);return w}registerNotebookContentProvider(g,w,d,f){var I,L,B;if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:g,provider:d});let ee;d.onDidChangeNotebookContentOptions&&(ee=d.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(w,d.options)}));const H=(I=f==null?void 0:f.viewOptions)===null||I===void 0?void 0:I.filenamePattern.map(x=>D.NotebookExclusiveDocumentPattern.from(x)).filter(x=>x!==void 0);return((L=f==null?void 0:f.viewOptions)===null||L===void 0?void 0:L.filenamePattern)&&!H&&console.warn(`Notebook content provider view options file name pattern is invalid ${(B=f==null?void 0:f.viewOptions)===null||B===void 0?void 0:B.filenamePattern}`),this._proxy.$registerNotebookProvider({id:g.identifier,location:g.extensionLocation,description:g.description},w,{transientOutputs:(f==null?void 0:f.transientOutputs)||!1,transientMetadata:(f==null?void 0:f.transientMetadata)||{},viewOptions:(f==null?void 0:f.viewOptions)&&H?{displayName:f.viewOptions.displayName,filenamePattern:H,exclusive:f.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{ee==null||ee.dispose(),this._notebookContentProviders.delete(w),this._proxy.$unregisterNotebookProvider(w)})}registerNotebookKernelProvider(g,w,d){const f=t._notebookKernelProviderHandlePool++,I=new u(this._proxy,f,g,d);return this._notebookKernelProviders.set(f,I),this._proxy.$registerNotebookKernelProvider({id:g.identifier,location:g.extensionLocation,description:g.description},f,{viewType:w.viewType,filenamePattern:w.filenamePattern?D.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0}),new n.Disposable(()=>{I.dispose(),this._notebookKernelProviders.delete(f),this._proxy.$unregisterNotebookKernelProvider(f)})}createNotebookEditorDecorationType(g){return new s(this._proxy,g).value}async openNotebookDocument(g){const w=this._documents.get(g);if(w)return w.notebookDocument;const d=await this._proxy.$tryOpenDocument(g),f=this._documents.get(P.URI.revive(d));return(0,S.assertIsDefined)(f==null?void 0:f.notebookDocument)}_withAdapter(g,w,d){const f=this._documents.get(P.URI.revive(w));if(!f)return[];const I=this._notebookKernelProviders.get(g);return I?d(I,f):[]}async showNotebookDocument(g,w){var d;P.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let f;typeof w=="object"?f={position:D.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:w.selection&&D.NotebookCellRange.from(w.selection),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:f={preserveFocus:!1};const I=await this._proxy.$tryShowNotebookDocument(g.uri,g.viewType,f),L=I&&((d=this._editors.get(I))===null||d===void 0?void 0:d.editor);if(L)return L.editor;throw I?new Error(`Could NOT open editor for "${g.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.toString()}".`)}async $provideNotebookKernels(g,w,d){return this._withAdapter(g,w,(f,I)=>f.provideKernels(I,d))}async $resolveNotebookKernel(g,w,d,f,I){await this._withAdapter(g,d,async(L,B)=>{const ee=this._webviewComm.get(w);ee&&await L.resolveNotebook(f,B,ee.contentProviderComm,I)})}async $resolveNotebookEditor(g,w,d){const f=this._notebookContentProviders.get(g),I=P.URI.revive(w),L=this._documents.get(I);if(!(!L||!f)){let B=this._webviewComm.get(d);B||(B=new c(d,I,this._proxy,this._webviewInitData,L),this._webviewComm.set(d,B)),!!f.provider.resolveNotebook&&await f.provider.resolveNotebook(L.notebookDocument,B.contentProviderComm)}}async $executeNotebookKernelFromProvider(g,w,d,f){await this._withAdapter(g,w,async(I,L)=>I.executeNotebook(d,L,f))}registerNotebookSerializer(g,w,d,f){const I=this._handlePool++;return this._notebookSerializer.set(I,d),this._proxy.$registerNotebookSerializer(I,{id:g.identifier,location:g.extensionLocation,description:g.description},w,f!=null?f:{transientOutputs:!1,transientMetadata:{}}),(0,R.toDisposable)(()=>{this._proxy.$unregisterNotebookSerializer(I)})}async $dataToNotebook(g,w){const d=this._notebookSerializer.get(g);if(!d)throw new Error("NO serializer found");const f=await d.dataToNotebook(w.buffer);return{metadata:D.NotebookDocumentMetadata.from(f.metadata),cells:f.cells.map(D.NotebookCellData.from)}}async $notebookToData(g,w){const d=this._notebookSerializer.get(g);if(!d)throw new Error("NO serializer found");const f=await d.notebookToData({metadata:D.NotebookDocumentMetadata.to(w.metadata),cells:w.cells.map(D.NotebookCellData.to)});return v.VSBuffer.wrap(f)}async $cancelNotebookCellExecution(g,w,d,f){await this._withAdapter(g,w,async(L,B)=>L.interruptNotebookExecution(d,B));const I=this._documents.get(P.URI.revive(w));if(!!I)for(let L of f)for(let B=L.start;B<L.end;B++){const ee=I.getCellFromIndex(B);ee&&this.cancelOneNotebookCellExecution(ee)}}cancelOneNotebookCellExecution(g){const w=this._activeExecutions.get(g.uri);w==null||w.cancel()}async $openNotebook(g,w,d,f,I){const{provider:L}=this._getProviderData(g),B=await L.openNotebook(P.URI.revive(w),{backupId:d,untitledDocumentData:f==null?void 0:f.buffer},I);return{metadata:D.NotebookDocumentMetadata.from(B.metadata),cells:B.cells.map(D.NotebookCellData.from)}}async $saveNotebook(g,w,d){const f=this._getNotebookDocument(P.URI.revive(w)),{provider:I}=this._getProviderData(g);return await I.saveNotebook(f.notebookDocument,d),!0}async $saveNotebookAs(g,w,d,f){const I=this._getNotebookDocument(P.URI.revive(w)),{provider:L}=this._getProviderData(g);return await L.saveNotebookAs(P.URI.revive(d),I.notebookDocument,f),!0}async $backupNotebook(g,w,d){var f;const I=this._getNotebookDocument(P.URI.revive(w)),L=this._getProviderData(g),B=(f=this._extensionStoragePaths.workspaceValue(L.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(L.extension),ee=String((0,_.hash)([I.uri.toString(),this._backupIdPool++])),H=P.URI.joinPath(B,ee),x=await L.provider.backupNotebook(I.notebookDocument,{destination:H},d);return I.updateBackup(x),x.id}$acceptNotebookActiveKernelChange(g){g.providerHandle!==void 0&&this._withAdapter(g.providerHandle,g.uri,async(w,d)=>{const f=g.kernelFriendlyId?w.getKernelByFriendlyId(P.URI.revive(g.uri),g.kernelFriendlyId):void 0;this._editors.forEach(I=>{I.editor.notebookData===d&&I.editor._acceptKernel(f)}),this._onDidChangeActiveNotebookKernel.fire({document:d.notebookDocument,kernel:f})})}$onDidReceiveMessage(g,w,d){var f;(f=this._webviewComm.get(g))===null||f===void 0||f.onDidReceiveMessage(w,d)}$acceptModelChanged(g,w,d){this._getNotebookDocument(P.URI.revive(g)).acceptModelChanged(w,d)}$acceptDirtyStateChanged(g,w){const d=this._getNotebookDocument(P.URI.revive(g));d.acceptModelChanged({rawEvents:[],versionId:d.notebookDocument.version},w)}$acceptModelSaved(g){const w=this._getNotebookDocument(P.URI.revive(g));this._onDidSaveNotebookDocument.fire(w.notebookDocument)}$acceptEditorPropertiesChanged(g,w){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,w);const d=this._editors.get(g);if(!d)throw new Error(`unknown text editor: ${g}`);w.visibleRanges&&d.editor._acceptVisibleRanges(w.visibleRanges.ranges.map(D.NotebookCellRange.to)),w.selections&&d.editor._acceptSelections(w.selections.selections.map(D.NotebookCellRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.editor.editor,visibleRanges:d.editor.editor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.editor.editor,selections:d.editor.editor.selections}))}$acceptDocumentPropertiesChanged(g,w){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",g.path,w);const d=this._getNotebookDocument(P.URI.revive(g));d.acceptDocumentPropertiesChanged(w),w.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:d.notebookDocument})}_createExtHostEditor(g,w,d){var f;const I=g.uri;let L=this._webviewComm.get(w);L||(L=new c(w,I,this._proxy,this._webviewInitData,g),this._webviewComm.set(w,L));const B=new a.ExtHostNotebookEditor(w,g.notebookDocument.viewType,this._proxy,g,d.visibleRanges.map(D.NotebookCellRange.to),d.selections.map(D.NotebookCellRange.to),typeof d.viewColumn=="number"?D.ViewColumn.to(d.viewColumn):void 0);(f=this._editors.get(w))===null||f===void 0||f.editor.dispose(),this._editors.set(w,{editor:B})}$acceptDocumentAndEditorsDelta(g){var w,d,f,I;let L=!1;if(g.removedDocuments)for(const ee of g.removedDocuments){const H=P.URI.revive(ee),x=this._documents.get(H);x&&(x.dispose(),this._documents.delete(H),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.notebookDocument.cells.map($=>$.document.uri)}),this._onDidCloseNotebookDocument.fire(x.notebookDocument));for(const $ of this._editors.values())$.editor.notebookData.uri.toString()===H.toString()&&($.editor.dispose(),this._editors.delete($.editor.id),L=!0)}if(g.addedDocuments){const ee=[];for(const H of g.addedDocuments){const x=P.URI.revive(H.uri),$=H.viewType;if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x}`);const F=this,U=new m.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(M){F._onDidChangeNotebookCells.fire(M)},emitCellOutputsChange(M){F._onDidChangeCellOutputs.fire(M)},emitCellMetadataChange(M){F._onDidChangeCellMetadata.fire(M)},emitCellExecutionStateChange(M){F._onDidChangeCellExecutionState.fire(M)}},$,H.metadata?D.NotebookDocumentMetadata.to(H.metadata):new n.NotebookDocumentMetadata,x);U.acceptModelChanged({versionId:H.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,H.cells]]}]},!1),ee.push(...H.cells.map(M=>m.ExtHostCell.asModelAddData(U.notebookDocument,M))),(w=this._documents.get(x))===null||w===void 0||w.dispose(),this._documents.set(x,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:ee}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(g.addedEditors)for(const ee of g.addedEditors){if(this._editors.has(ee.id))return;const H=P.URI.revive(ee.documentUri),x=this._documents.get(H);x&&(this._createExtHostEditor(x,ee.id,ee),L=!0)}const B=[];if(g.removedEditors)for(const ee of g.removedEditors){const H=this._editors.get(ee);H&&(L=!0,this._editors.delete(ee),((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.id)===H.editor.id&&(this._activeNotebookEditor=void 0),B.push(H))}if(L&&B.forEach(ee=>{ee.editor.dispose()}),g.visibleEditors){this._visibleNotebookEditors=g.visibleEditors.map(H=>this._editors.get(H).editor).filter(H=>!!H);const ee=new Set;this._visibleNotebookEditors.forEach(H=>ee.add(H.id));for(const H of this._editors.values()){const x=ee.has(H.editor.id);H.editor._acceptVisibility(x)}this._visibleNotebookEditors=[...this._editors.values()].map(H=>H.editor).filter(H=>H.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}g.newActiveEditor===null?this._activeNotebookEditor=void 0:g.newActiveEditor&&(this._activeNotebookEditor=(f=this._editors.get(g.newActiveEditor))===null||f===void 0?void 0:f.editor),g.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((I=this._activeNotebookEditor)===null||I===void 0?void 0:I.editor)}createNotebookCellStatusBarItemInternal(g,w,d){const f=new i(this._proxy,this._commandsConverter,g,w,d),I=k.CellUri.parse(g.document.uri);if(I){const L=this._documents.get(I.notebook);if(L){const B=L.getCell(I.handle);B&&y.Event.once(B.onDidDispose)(()=>f.dispose())}}return f}createNotebookCellExecution(g,w,d){const f=this.lookupNotebookDocument(g);if(!f)throw new Error(`Invalid cell uri/index: ${g}, ${w}`);const I=f.getCellFromIndex(w);if(!I)throw new Error(`Invalid cell uri/index: ${g}, ${w}`);if(!this._activeExecutions.has(I.uri)){const L=new l(g,f,I,this._proxy);this._activeExecutions.set(I.uri,L);const B=L.onDidChangeState(()=>{L.state===r.Resolved&&(L.dispose(),B.dispose(),this._activeExecutions.delete(I.uri))});return L.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends R.Disposable{constructor(g,w,d,f,I){super();this._proxy=g,this._commands=w,this._cell=d,this._priority=I,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=f!=null?f:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(g){this._alignment=g,this.update()}get priority(){return this._priority}set priority(g){this._priority=g,this.update()}get text(){return this._text}set text(g){this._text=g,this.update()}get tooltip(){return this._tooltip}set tooltip(g){this._tooltip=g,this.update()}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}set command(g){var w;((w=this._command)===null||w===void 0?void 0:w.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:this._commands.toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:this._commands.toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var g;if(!this._isDisposed){const w={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(g=this._command)===null||g===void 0?void 0:g.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,w)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function o(h){return Object.freeze({cell:h.cell,get alignment(){return h.alignment},set alignment(g){h.alignment=g},get priority(){return h.priority},set priority(g){h.priority=g},get text(){return h.text},set text(g){h.text=g},get tooltip(){return h.tooltip},set tooltip(g){h.tooltip=g},get command(){return h.command},set command(g){h.command=g},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(g){h.accessibilityInformation=g},show(){h.show()},hide(){h.hide()},dispose(){h.dispose()}})}var r;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(r||(r={}));class l extends R.Disposable{constructor(g,w,d,f){super();this._uri=g,this._document=w,this._cell=d,this._proxy=f,this._onDidChangeState=new y.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=d.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(g){return this._proxy.$applyEdits(this._uri,g,!1)}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(g){const w=[{editType:11,handle:this._cell.handle,metadata:g}];this.applyEdits(w)}cellIndexToHandle(g){const w=typeof g=="number"?this._document.getCellFromIndex(g):this._cell;if(!!w)return w.handle}asApiObject(){const g=this;return Object.freeze({get document(){return g._document.notebookDocument},get cell(){return g._cell.cell},get executionOrder(){return g._executionOrder},set executionOrder(w){g._executionOrder=w,g.mixinMetadata({executionOrder:w})},start(w){if(g._state===r.Resolved||g._state===r.Started)throw new Error("Cannot call start again");g._state=r.Started,g._onDidChangeState.fire(),g.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:w==null?void 0:w.startTime})},end(w){var d,f;if(g._state===r.Resolved)throw new Error("Cannot call resolve twice");g._state=r.Resolved,g._onDidChangeState.fire(),g.mixinMetadata({runState:k.NotebookCellExecutionState.Idle,lastRunSuccess:(d=w==null?void 0:w.success)!==null&&d!==void 0?d:null,lastRunDuration:(f=w==null?void 0:w.duration)!==null&&f!==void 0?f:null})},clearOutput(w){return g.verifyStateForOutput(),this.replaceOutput([],w)},async appendOutput(w,d){g.verifyStateForOutput();const f=g.cellIndexToHandle(d);if(typeof f=="number")return g.applyEdits([{editType:2,handle:f,append:!0,outputs:w.map(D.NotebookCellOutput.from)}])},async replaceOutput(w,d){g.verifyStateForOutput();const f=g.cellIndexToHandle(d);if(typeof f=="number")return g.applyEdits([{editType:2,handle:f,outputs:w.map(D.NotebookCellOutput.from)}])},async appendOutputItems(w,d){return g.verifyStateForOutput(),g.applyEdits([{editType:10,append:!0,items:w.map(D.NotebookCellOutputItem.from),outputId:d}])},async replaceOutputItems(w,d){return g.verifyStateForOutput(),g.applyEdits([{editType:10,items:w.map(D.NotebookCellOutputItem.from),outputId:d}])},token:g._tokenSource.token})}}}),define(pe[63],ve([0,1,5,3,6,25,4,13]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends R.Disposable{constructor(a,p,S,v){super();this._onDidAppend=this._register(new y.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=v,this._id=v.$register(this.name,p,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?P.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(p=>this._proxy.$clear(p,a))}show(a,p){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof a=="boolean"?a:p)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class n extends D{constructor(a,p){super(a,!1,void 0,p)}append(a){super.append(a),this._id.then(p=>this._proxy.$append(p,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends D{constructor(a,p,S){super(a,!0,p,S)}append(a){throw new Error("Not supported")}}class k{constructor(a,p){this.name=a,this._channel=p}append(a){this._channel.then(p=>p.append(a))}appendLine(a){this._channel.then(p=>p.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,p){this._channel.then(S=>S.show(a,p))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=k;let b=class{constructor(a){this._proxy=a.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new n(a,this._proxy)}createOutputChannelFromLogFile(a,p){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!p)throw new Error("illegal argument `file`. must not be falsy");return new T(a,p,this._proxy)}};b=je([Ue(0,A.IExtHostRpcService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(pe[239],ve([0,1,17,21,3,6,5,2,7,16,14,56]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(m,a,p){const S=m.getProxy(C.MainContext.MainThreadQuickOpen);class v{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,h,g=y.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(r),d=++this._instances,f=S.$show(d,{title:h==null?void 0:h.title,placeHolder:h==null?void 0:h.placeHolder,matchOnDescription:h==null?void 0:h.matchOnDescription,matchOnDetail:h==null?void 0:h.matchOnDetail,ignoreFocusLost:h==null?void 0:h.ignoreFocusOut,canPickMany:h==null?void 0:h.canPickMany},g),I={},L=f.then(()=>I);return Promise.race([L,w]).then(B=>{if(B!==I)return w.then(ee=>{const H=[];for(let x=0;x<ee.length;x++){const $=ee[x];let F,U,M,N,O;typeof $=="string"?F=$:(F=$.label,U=$.description,M=$.detail,N=$.picked,O=$.alwaysShow),H.push({label:F,description:U,handle:x,detail:M,picked:N,alwaysShow:O})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{h.onDidSelectItem(ee[x])}),S.$setItems(d,H),f.then(x=>{if(typeof x=="number")return ee[x];if(Array.isArray(x))return x.map($=>ee[$])})})}).then(void 0,B=>{if(!(0,n.isPromiseCanceledError)(B))return S.$setError(d,B),Promise.reject(B)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=y.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",l).then(void 0,h=>{if(!(0,n.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(r){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=y.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!h){const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(w=>w.uri.toString()===h.uri.toString())}}createQuickPick(r,l){const h=new t(r,l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(r){const l=new i(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const h=this._sessions.get(r);h&&h._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const h=this._sessions.get(r);h&&h._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class _{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,h)=>{const g=l===D.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(g,l)}),this.update({buttons:r.map((l,h)=>({iconPath:c(l.iconPath),tooltip:l.tooltip,handle:l===D.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const h=r[l];this._pendingUpdate[l]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function c(o){if(o instanceof D.ThemeIcon)return{id:o.id};const r=s(o),l=u(o);return{dark:typeof r=="string"?A.URI.file(r):r,light:typeof l=="string"?A.URI.file(l):l}}function u(o){return typeof o=="object"&&"light"in o?o.light:o}function s(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends _{constructor(r,l,h){super(r,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,h)=>{this._handlesToItems.set(h,l),this._itemsToHandles.set(l,h)}),this.update({items:r.map((l,h)=>({label:l.label,description:l.description,handle:h,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=(0,T.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=(0,T.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends _{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?k.default.Error:k.default.Ignore})}}return new v(a,p)}e.createExtHostQuickOpen=b}),define(pe[240],ve([0,1,2,3,68,6,17,5,14,95,12,29,41]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(r){if(r)return typeof r.iconPath=="string"?E.URI.file(r.iconPath):r.iconPath}function a(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const h=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,g=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,n.comparePaths)(h,g)}function p(r,l){let h=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(h=a(r,l),h!==0)return h;if(r.light&&l.light)h=a(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(h!==0)return h;if(r.dark&&l.dark)h=a(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return h}function S(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let h=0;h<r.arguments.length;h++){const g=r.arguments[h],w=l.arguments[h];if(g!==w)return g<w?-1:1}return 0}function v(r,l){let h=(0,n.comparePaths)(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(h!==0)return h;if(r.command&&l.command)h=S(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(h!==0)return h;if(r.decorations&&l.decorations)h=p(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return h}function _(r,l){for(let h=0;h<r.length;h++)if(r[h]!==l[h])return!1;return!0}function c(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?_(r.arguments,l.arguments):r.arguments===l.arguments)}function u(r,l){return(0,D.equals)(r,l,c)}class s{constructor(l,h,g){this._extension=l,this._proxy=h,this._sourceControlHandle=g,this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,b.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=s;class t{constructor(l,h,g,w,d){this._proxy=l,this._commands=h,this._sourceControlHandle=g,this._id=w,this._label=d,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,h){const g=this._resourceStatesCommandsMap.get(l);return g?(0,C.asPromise)(()=>this._commands.executeCommand(g.command,...g.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const h=[...this._resourceStates].sort(v),w=(0,D.sortedDiff)(this._resourceSnapshot,h,v).map(I=>{const L=I.toInsert.map(B=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,B);const H=B.resourceUri,x=m(B.decorations),$=B.decorations&&m(B.decorations.light)||x,F=B.decorations&&m(B.decorations.dark)||x,U=[];let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const me=new P.DisposableStore;M=this._commands.converter.toInternal(B.command,me),this._resourceStatesDisposablesMap.set(ee,me)}else this._resourceStatesCommandsMap.set(ee,B.command);$&&U.push($),F&&F.toString()!==($==null?void 0:$.toString())&&U.push(F);const N=B.decorations&&B.decorations.tooltip||"",O=B.decorations&&!!B.decorations.strikeThrough,V=B.decorations&&!!B.decorations.faded,q=B.contextValue||"";return{rawResource:[ee,H,U,N,O,V,q,M],handle:ee}});return{start:I.start,deleteCount:I.deleteCount,toInsert:L}}),d=w.map(({start:I,deleteCount:L,toInsert:B})=>[I,L,B.map(ee=>ee.rawResource)]),f=w.reverse();for(const{start:I,deleteCount:L,toInsert:B}of f){const ee=B.map(x=>x.handle),H=this._handlesSnapshot.splice(I,L,...ee);for(const x of H)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(l=this._resourceStatesDisposablesMap.get(x))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=h,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,h,g,w,d,f){this._proxy=h,this._commands=g,this._id=w,this._label=d,this._rootUri=f,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,w,d,f)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=l;const h=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&u(this._statusBarCommands,l))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=l;const h=(l||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(l,h){const g=new t(this._proxy,this._commands,this.handle,l,h),w=y.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,w),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const l=[],h=[];for(const[g,w]of this.createdResourceGroups){w.dispose();const d=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});y.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),d.dispose(),this._groups.delete(g.handle),this._proxy.$unregisterGroup(this.handle,g.handle)}),l.push([g.handle,g.id,g.label,g.features]);const f=g._takeResourceStateSnapshot();f.length>0&&h.push([g.handle,f]),this._groups.set(g.handle,g)}this._proxy.$registerGroups(this.handle,l,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(h=>{const g=h._takeResourceStateSnapshot();g.length!==0&&l.push([h.handle,g])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,R.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,R.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Fn{constructor(l,h,g){this._commands=h,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=l.getProxy(A.MainContext.MainThreadSCM),this._telemetry=l.getProxy(A.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===3){const d=this._sourceControls.get(w.sourceControlHandle);if(!d)return w;const f=d.getResourceGroup(w.groupHandle);return f?f.getResourceState(w.handle):w}else if(w&&w.$mid===4){const d=this._sourceControls.get(w.sourceControlHandle);return d?d.getResourceGroup(w.groupHandle):w}else if(w&&w.$mid===5){const d=this._sourceControls.get(w.handle);return d||w}return w}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,h,g,w){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,h,g,w),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const d=Fn._handlePool++,f=new i(l,this._proxy,this._commands,h,g,w);this._sourceControls.set(d,f);const I=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier))||[];return I.push(f),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(l.identifier),I),f}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const h=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier)),g=h&&h[h.length-1];return g&&g.inputBox}$provideOriginalResource(l,h,g){const w=E.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,w.toString());const d=this._sourceControls.get(l);return!d||!d.quickDiffProvider||!d.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>d.quickDiffProvider.provideOriginalResource(w,g)).then(f=>f||null)}$onInputBoxValueChange(l,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const g=this._sourceControls.get(l);return g&&g.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(l,h,g,w){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,h,g);const d=this._sourceControls.get(l);if(!d)return Promise.resolve(void 0);const f=d.getResourceGroup(h);return f?f.$executeResourceCommand(g,w):Promise.resolve(void 0)}$validateInput(l,h,g){this.logService.trace("ExtHostSCM#$validateInput",l);const w=this._sourceControls.get(l);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>w.inputBox.validateInput(h,g)).then(d=>d?Promise.resolve([d.message,d.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var h,g;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((h=this._sourceControls.get(l))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((g=this._sourceControls.get(this._selectedSourceControlHandle))===null||g===void 0||g.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};o._handlePool=0,o=je([Ue(2,T.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[241],ve([0,1,7,5,162,6]),function(Z,e,E,y,R,P){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(b,m,a,p,S=E.StatusBarAlignment.Left,v,_){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,C,b),tt(this,A,m),this._id=D.ID_GEN++,this._statusId=a,this._statusName=p,this._alignment=S,this._priority=v,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!D.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:Be(this,A).toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:Be(this,A).toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,C).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var b;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,C).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(b=this._command)===null||b===void 0?void 0:b.internal,m,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,C=new WeakMap,A=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(b){this._messages=[],this._item=b.createStatusBarEntry("status.extensionMessage",(0,R.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const m={message:b};return this._messages.unshift(m),this._update(),new E.Disposable(()=>{const a=this._messages.indexOf(m);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(b,m){this._proxy=b.getProxy(y.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new n(this)}createStatusBarEntry(b,m,a,p,S){return new D(this._proxy,this._commands,b,m,a,p,S)}setStatusBarMessage(b,m){const a=this._statusMessage.setMessage(b);let p;return typeof m=="number"?p=setTimeout(()=>a.dispose(),m):typeof m!="undefined"&&m.then(()=>a.dispose(),()=>a.dispose()),new E.Disposable(()=>{a.dispose(),clearTimeout(p)})}}e.ExtHostStatusBar=T}),define(pe[88],ve([0,1,5,3,4]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(A){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,D){this._proxy.$registerExtensionStorageKeysToSync(A,D)}getValue(A,D,n){return this._proxy.$getValue(A,D).then(T=>T||n)}setValue(A,D,n){return this._proxy.$setValue(A,D,n)}$acceptValue(A,D,n){this._onDidChangeStorage.fire({shared:A,key:D,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,R.createDecorator)("IExtHostStorage")}),define(pe[89],ve([0,1,4,27,12,87,2]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let A=class{constructor(n,T,k){var b;this._logService=T,this._extHostFileSystem=k,this._workspace=(b=n.workspace)!==null&&b!==void 0?b:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=C.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(b){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=C.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(n){if(this._value)return C.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return C.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};A=je([Ue(0,y.IExtHostInitDataService),Ue(1,R.ILogService),Ue(2,P.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(pe[35],ve([0,1,3,5,4,2,13,6,7,163,16,206,21,28,187]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,R.createDecorator)("IExtHostTerminalService");class p{constructor(t,i,o,r){this._proxy=t,this._id=i,this._creationOptions=o,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(h,g=!0){l._checkDisposed(),l._proxy.$sendText(l._id,h,g)},show(h){l._checkDisposed(),l._proxy.$show(l._id,h)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,i,o,r,l,h,g,w,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:o,env:r,waitOnExit:l,strictEnv:h,hideFromUser:g,isFeatureTerminal:w,isExtensionOwnedTerminal:d})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=p;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let v=1,_=class extends A.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=i.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new p(this._proxy,(0,m.generateUuid)(),t,t.name),o=new S(t.pty);return i.createExtensionTerminal().then(r=>{const l=this._setupExtHostProcessListeners(r,o);this._terminalProcessDisposables[r]=l}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(i),l=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:i})}async $acceptTerminalDimensions(t,i,o){const r=this._getTerminalById(t);r&&r.setDimensions(i,o)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,o){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,o)}async $acceptTerminalTitleChange(t,i){const o=this._getTerminalById(t);o&&(o.name=i)}async $acceptTerminalClosed(t,i){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const r=this._terminals.splice(o,1)[0];r.setExitCode(i),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,i,o,r){if(i){const g=this._getTerminalObjectIndexById(this._terminals,i);if(g!==null){this._terminals[g]._id=t,this._onDidOpenTerminal.fire(this.terminals[g]),this._terminals[g].isOpen=!0;return}}const l={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:P.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},h=new p(this._proxy,t,l,o);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,i){const o=this._getTerminalById(t);o&&o._setProcessId(i)}async $startExtensionTerminal(t,i){const o=this._getTerminalById(t);if(!o)return{message:(0,n.localize)(0,null,t)};o.isOpen||await new Promise(l=>{const h=this.onDidOpenTerminal(async g=>{g===o.value&&(h.dispose(),l())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const o=new A.DisposableStore;o.add(i.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),o.add(i.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,i.onProcessData),o.add(i.onProcessExit(l=>this._onProcessExit(t,l))),i.onProcessOverrideDimensions&&o.add(i.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,i);const r=this._extensionTerminalAwaitingStart[t];return r&&i instanceof S&&(i.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(i)}$acceptProcessResize(t,i,o){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,o)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const l=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const h=[],g={terminal:o.value,line:i},w=[];for(const I of this._linkProviders)w.push(new Promise(async L=>{l.token.onCancellationRequested(()=>L({provider:I,links:[]}));const B=await I.provideTerminalLinks(g,l.token)||[];l.token.isCancellationRequested||L({provider:I,links:B})}));const d=await Promise.all(w);if(l.token.isCancellationRequested)return[];const f=new Map;for(const I of d)I&&I.links.length>0&&h.push(...I.links.map(L=>{const B={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return f.set(B.id,{provider:I.provider,link:L}),B}));return this._terminalLinkCache.set(t,f),h}$activateLink(t,i){var o;const r=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(i);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const o=this._getTerminalObjectIndexById(t,i);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,i){let o=null;return t.some((r,l)=>r._id===i?(o=l,!0):!1),o}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new c,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const o=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const o=i[0],r=new c(i[1]);this._setEnvironmentVariableCollection(o,r)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};_=je([Ue(1,C.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class c{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:D.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const o=this.map.get(t);(!o||o.value!==i.value||o.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((o,r)=>t.call(i,r,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let u=class extends _{constructor(t){super(!1,t)}createTerminal(t,i,o){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){return""}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=je([Ue(0,C.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(pe[242],ve([0,1,3,14,5,122,20,7]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(b=>b.value)}async showTextDocument(T,k,b){let m;typeof k=="number"?m={position:C.ViewColumn.from(k),preserveFocus:b}:typeof k=="object"?m={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:m={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(T.uri,m),p=a&&this._extHostDocumentsAndEditors.getEditor(a);if(p)return p.value;throw a?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new P.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const b=this._extHostDocumentsAndEditors.getEditor(T);if(!b)throw new Error("unknown text editor");if(k.options&&b._acceptOptions(k.options),k.selections){const m=k.selections.selections.map(C.Selection.to);b._acceptSelections(m)}if(k.visibleRanges){const m=y.coalesce(k.visibleRanges.map(C.Range.to));b._acceptVisibleRanges(m)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const m=A.TextEditorSelectionChangeKind.fromValue(k.selections.source),a=k.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:a,kind:m})}if(k.visibleRanges){const m=y.coalesce(k.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:m})}}$acceptEditorPositionData(T){for(const k in T){const b=this._extHostDocumentsAndEditors.getEditor(k);if(!b)throw new Error("Unknown text editor");const m=C.ViewColumn.to(T[k]);b.value.viewColumn!==m&&(b._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:m}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=D});var gn=this&&this.__rest||function(Z,e){var E={};for(var y in Z)Object.prototype.hasOwnProperty.call(Z,y)&&e.indexOf(y)<0&&(E[y]=Z[y]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,y=Object.getOwnPropertySymbols(Z);R<y.length;R++)e.indexOf(y[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,y[R])&&(E[y[R]]=Z[y[R]]);return E};define(pe[243],ve([0,1,2,4,5,6,7]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,y.createDecorator)("IExtHostTimeline");class A{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:b=>{var m,a;if(b&&b.$mid===11){const p=b.uri===void 0?void 0:E.URI.revive(b.uri);return(a=(m=this._itemsBySourceAndUriMap.get(b.source))===null||m===void 0?void 0:m.get(D(p)))===null||a===void 0?void 0:a.get(b.handle)}return b}})}async $getTimeline(T,k,b,m,a){const p=this._providers.get(T);return p==null?void 0:p.provideTimeline(E.URI.revive(k),b,m,a)}registerTimelineProvider(T,k,b,m){const a=new P.DisposableStore,p=this.convertTimelineItem(k.id,m,a).bind(this);let S;k.onDidChange&&(S=k.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:k.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(_,c,u,s){var t;(s==null?void 0:s.resetCache)&&(a.clear(),(t=v.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(_,c,u);if(i!=null){const o=p(_,s);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(o)})}},dispose(){var _;for(const c of v.values())(_=c.get(k.id))===null||_===void 0||_.clear();S==null||S.dispose(),a.dispose()}}))}convertTimelineItem(T,k,b){return(m,a)=>{let p;if(a==null?void 0:a.cacheResults){let S=this._itemsBySourceAndUriMap.get(T);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(T,S));const v=D(m);p=S.get(v),p===void 0&&(p=new Map,S.set(v,p))}return S=>{var v,_;const{iconPath:c}=S,u=gn(S,["iconPath"]),s=`${T}|${(v=S.id)!==null&&v!==void 0?v:S.timestamp}`;p==null||p.set(s,S);let t,i,o;return S.iconPath&&(c instanceof C.ThemeIcon?o={id:c.id}:E.URI.isUri(c)?(t=c,i=c):{light:t,dark:i}=c),Object.assign(Object.assign({},u),{id:(_=u.id)!==null&&_!==void 0?_:void 0,handle:s,source:T,command:S.command?k.toInternal(S.command,b):void 0,icon:t,iconDark:i,themeIcon:o,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,P.toDisposable)(()=>{var b;for(const m of this._itemsBySourceAndUriMap.values())(b=m.get(T.id))===null||b===void 0||b.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=A;function D(n){return n==null?void 0:n.toString()}}),define(pe[244],ve([0,1,6,11,2,5]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(D){this._openers=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const b=k.schemes.find(m=>!C.supportedSchemes.has(m));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,D,k.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(D,n,T){const k=this._openers.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const b=R.URI.revive(n);return k.canOpenExternalUri(b,T)}async $openUri(D,n,T){const k=this._openers.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(R.URI.revive(n.resolvedUri),{sourceUri:R.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(pe[245],ve([0,1,5,2,6,16,29]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(C.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=A.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,R.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(y.URI.revive(T))}catch(b){(0,P.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(n){return y.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=A,A.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[64],ve([0,1,3,2,84,5]),function(Z,e,E,y,R,P){"use strict";var C,A,D,n,T,k,b,m,a,p,S;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class v{constructor(o,r,l,h,g,w,d){C.set(this,void 0),A.set(this,void 0),D.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),b.set(this,""),m.set(this,void 0),a.set(this,!1),p.set(this,!1),this._onMessageEmitter=new E.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,S.set(this,new E.Emitter),this._onDidDispose=Be(this,S).event,tt(this,C,o),tt(this,A,r),tt(this,m,l),tt(this,n,h),tt(this,T,g),tt(this,k,w),tt(this,D,d)}dispose(){tt(this,a,!0),Be(this,S).fire(),Be(this,S).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return tt(this,p,!0),(0,R.asWebviewUri)(Be(this,n),Be(this,C),o)}get cspSource(){return Be(this,n).webviewCspSource.replace("{{uuid}}",Be(this,C))}get html(){return this.assertNotDisposed(),Be(this,b)}set html(o){this.assertNotDisposed(),Be(this,b)!==o&&(tt(this,b,o),!Be(this,p)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(tt(this,p,!0),Be(this,D).report("Webview vscode-resource: uris",Be(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,A).$setHtml(Be(this,C),o))}get options(){return this.assertNotDisposed(),Be(this,m)}set options(o){this.assertNotDisposed(),Be(this,A).$setOptions(Be(this,C),u(Be(this,k),Be(this,T),o)),tt(this,m,o)}async postMessage(o){return Be(this,a)?!1:Be(this,A).$postMessage(Be(this,C),o)}assertNotDisposed(){if(Be(this,a))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,C=new WeakMap,A=new WeakMap,D=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,p=new WeakMap,S=new WeakMap;class _{constructor(o,r,l,h,g){this.initData=r,this.workspace=l,this._logService=h,this._deprecationService=g,this._webviews=new Map,this._webviewProxy=o.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(o,r){const l=this.getWebview(o);l&&l._onMessageEmitter.fire(r)}$onMissingCsp(o,r){this._logService.warn(`${r} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,r,l){const h=new v(o,this._webviewProxy,s(r),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(o,h),h._onDidDispose(()=>{this._webviews.delete(o)}),h}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=_;function c(i){return{id:i.identifier,location:i.extensionLocation}}e.toExtensionData=c;function u(i,o,r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots||t(i,o)}}e.serializeWebviewOptions=u;function s(i){var o;return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,portMapping:i.portMapping,localResourceRoots:(o=i.localResourceRoots)===null||o===void 0?void 0:o.map(r=>y.URI.from(r))}}e.reviveOptions=s;function t(i,o){return[...((o==null?void 0:o.getWorkspaceFolders())||[]).map(r=>r.uri),i.extensionLocation]}}),define(pe[246],ve([0,1,21,73,6,11,24,2,20,64,116,5,7]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class a{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,o){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new m(i,o);return this._documents.set(r,l),l}delete(t,i){const o=this.key(t,i.uri);this._documents.delete(o)}key(t,i){return`${t}@@@${i}`}}var p;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(p||(p={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,o){return this.add(0,t,i,o)}addCustomProvider(t,i,o){return this.add(1,t,i,o)}get(t){return this._providers.get(t)}add(t,i,o,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:o,provider:r}),new b.Disposable(()=>this._providers.delete(i))}}class v{constructor(t,i,o,r,l){this._extHostDocuments=i,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new S,this._documents=new a,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,o,r){const l=new R.DisposableStore;return _(o)?(l.add(this._editorProviders.addTextProvider(i,t,o)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor})):(l.add(this._editorProviders.addCustomProvider(i,t,o)),this.supportEditing(o)&&l.add(o.onDidChangeCustomDocument(h=>{const g=this.getCustomDocumentEntry(i,h.document.uri);if(c(h)){const w=g.addEdit(h);this._proxy.$onDidEdit(h.document.uri,i,w,h.label)}else this._proxy.$onContentChange(h.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument)),b.Disposable.from(l,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,o,r,l){var h;const g=this._editorProviders.get(i);if(!g)throw new Error(`No provider found for '${i}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${i}'`);const w=A.URI.revive(t),d=await g.provider.openCustomDocument(w,{backupId:o,untitledDocumentData:r==null?void 0:r.buffer},l);let f;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(f=(h=this._extensionStoragePaths.workspaceValue(g.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(i,d,f),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=A.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,o,r,l,h){const g=this._editorProviders.get(o);if(!g)throw new Error(`No provider found for '${o}'`);const w=D.ViewColumn.to(l),d=this._extHostWebview.createNewWebview(i,r.webviewOptions,g.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(i,o,r.title,w,r.panelOptions,d),I=A.URI.revive(t);switch(g.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,I);return g.provider.resolveCustomEditor(L,f,h)}case 0:{const L=this._extHostDocuments.getDocument(I);return g.provider.resolveCustomTextEditor(L,f,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,o){this.getCustomDocumentEntry(i,t).disposeEdits(o)}async $onMoveCustomEditor(t,i,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const h=A.URI.revive(i),g=this._extHostDocuments.getDocument(h);await r.provider.moveCustomTextEditor(g,l,E.CancellationToken.None)}async $undo(t,i,o,r){return this.getCustomDocumentEntry(i,t).undo(o,r)}async $redo(t,i,o,r){return this.getCustomDocumentEntry(i,t).redo(o,r)}async $revert(t,i,o){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(t,i,o){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(t,i,o,r){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,A.URI.revive(o),r)}async $backup(t,i,o){const r=this.getCustomDocumentEntry(i,t),h=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(h),h.id}getCustomDocumentEntry(t,i){const o=this._documents.get(t,A.URI.revive(i));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const i=this._editorProviders.get(t),o=i==null?void 0:i.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function _(s){return typeof s.resolveCustomTextEditor=="function"}function c(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function u(s){const t=s.scheme===P.Schemas.file||s.scheme===P.Schemas.untitled?s.fsPath:s.toString();return(0,y.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[247],ve([0,1,3,6,2,28,20,64,5,7]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";var T,k,b,m,a,p,S,v,_,c,u,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends y.Disposable{constructor(h,g,w,d,f,I,L){super();T.set(this,void 0),k.set(this,void 0),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),p.set(this,void 0),S.set(this,void 0),v.set(this,void 0),_.set(this,!0),c.set(this,!0),u.set(this,!1),s.set(this,this._register(new E.Emitter)),this.onDidDispose=Be(this,s).event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=Be(this,t).event,tt(this,T,h),tt(this,k,g),tt(this,b,w),tt(this,a,I),tt(this,v,f),tt(this,p,d),tt(this,m,L)}dispose(){Be(this,u)||(tt(this,u,!0),Be(this,s).fire(),Be(this,k).$disposeWebview(Be(this,T)),Be(this,m).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,m)}get viewType(){return this.assertNotDisposed(),Be(this,b)}get title(){return this.assertNotDisposed(),Be(this,p)}set title(h){this.assertNotDisposed(),Be(this,p)!==h&&(tt(this,p,h),Be(this,k).$setTitle(Be(this,T),h))}get iconPath(){return this.assertNotDisposed(),Be(this,S)}set iconPath(h){this.assertNotDisposed(),Be(this,S)!==h&&(tt(this,S,h),Be(this,k).$setIconPath(Be(this,T),R.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Be(this,a)}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,v)=="number"&&Be(this,v)<0))return Be(this,v)}get active(){return this.assertNotDisposed(),Be(this,c)}get visible(){return this.assertNotDisposed(),Be(this,_)}_updateViewState(h){Be(this,u)||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,c,h.active),tt(this,_,h.visible),tt(this,v,h.viewColumn),Be(this,t).fire({webviewPanel:this}))}reveal(h,g){this.assertNotDisposed(),Be(this,k).$reveal(Be(this,T),{viewColumn:h?C.ViewColumn.from(h):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Be(this,u))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,p=new WeakMap,S=new WeakMap,v=new WeakMap,_=new WeakMap,c=new WeakMap,u=new WeakMap,s=new WeakMap,t=new WeakMap;class o{constructor(h,g,w){this.webviews=g,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(h,g,w,d,f={}){const I=typeof d=="object"?d.viewColumn:d,L={viewColumn:C.ViewColumn.from(I),preserveFocus:typeof d=="object"&&!!d.preserveFocus},B=o.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(h),B,g,{title:w,panelOptions:r(f),webviewOptions:(0,A.serializeWebviewOptions)(h,this.workspace,f)},L);const ee=this.webviews.createNewWebview(B,f,h);return this.createNewWebviewPanel(B,g,w,I,f,ee)}$onDidChangeWebviewPanelViewStates(h){const g=Object.keys(h);g.sort((w,d)=>{const f=h[w],I=h[d];return f.active?1:I.active?-1:+f.visible-+I.visible});for(const w of g){const d=this.getWebviewPanel(w);if(!!d){const f=h[w];d._updateViewState({active:f.active,visible:f.visible,viewColumn:C.ViewColumn.to(f.position)})}}}async $onDidDisposeWebviewPanel(h){const g=this.getWebviewPanel(h);g==null||g.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,g,w){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:w,extension:h}),this._proxy.$registerSerializer(g),new n.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(h,g,w,d){const f=this._serializers.get(g);if(!f)throw new Error(`No serializer found for '${g}'`);const{serializer:I,extension:L}=f,B=this.webviews.createNewWebview(h,w.webviewOptions,L),ee=this.createNewWebviewPanel(h,g,w.title,d,w.panelOptions,B);await I.deserializeWebviewPanel(ee,w.state)}createNewWebviewPanel(h,g,w,d,f,I){const L=new i(h,this._proxy,g,w,d,f,I);return this._webviewPanels.set(h,L),L}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[248],ve([0,1,3,6,64,5,7]),function(Z,e,E,y,R,P,C){"use strict";var A,D,n,T,k,b,m,a,p,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends y.Disposable{constructor(u,s,t,i,o,r){super();A.set(this,void 0),D.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),p.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=Be(this,p).event,S.set(this,this._register(new E.Emitter)),this.onDidDispose=Be(this,S).event,tt(this,n,t),tt(this,m,i),tt(this,A,u),tt(this,D,s),tt(this,T,o),tt(this,b,r)}dispose(){Be(this,k)||(tt(this,k,!0),Be(this,S).fire(),Be(this,T).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,m)}set title(u){this.assertNotDisposed(),Be(this,m)!==u&&(tt(this,m,u),Be(this,D).$setWebviewViewTitle(Be(this,A),u))}get description(){return this.assertNotDisposed(),Be(this,a)}set description(u){this.assertNotDisposed(),Be(this,a)!==u&&(tt(this,a,u),Be(this,D).$setWebviewViewDescription(Be(this,A),u))}get visible(){return Be(this,b)}get webview(){return Be(this,T)}get viewType(){return Be(this,n)}_setVisible(u){u===Be(this,b)||Be(this,k)||(tt(this,b,u),Be(this,p).fire())}show(u){this.assertNotDisposed(),Be(this,D).$show(Be(this,A),!!u)}assertNotDisposed(){if(Be(this,k))throw new Error("Webview is disposed")}}A=new WeakMap,D=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,p=new WeakMap,S=new WeakMap;class _{constructor(u,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,s,t,i){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,R.toExtensionData)(u),s,i),new C.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(u,s,t,i,o){const r=this._viewProviders.get(s);if(!r)throw new Error(`No view provider found for '${s}'`);const{provider:l,extension:h}=r,g=this._extHostWebview.createNewWebview(u,{},h),w=new v(u,this._proxy,s,t,g,!0);this._webviewViews.set(u,w),await l.resolveWebviewView(w,{state:i},o)}async $onDidChangeWebviewViewVisibility(u,s){this.getWebviewView(u)._setVisible(s)}async $disposeWebviewView(u){const s=this.getWebviewView(u);this._webviewViews.delete(u),s.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const s=this._webviewViews.get(u);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=_}),define(pe[125],ve([0,1,3,5,2,11,10,4,13]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Mn{constructor(k){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Mn.InitialState,this._proxy=k.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,b){let m;if(typeof k=="string"){m=k;try{k=R.URI.parse(k)}catch(a){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,m,b)}async asExternalUri(k,b){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const m=await this._proxy.$asExternalUri(k,b);return R.URI.from(m)}};n.InitialState={focused:!0},n=je([Ue(0,D.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(pe[249],ve([0,1,8,48,28,51,6,5,2,13]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends C.Disposable{constructor(b,m){super();const a=b.getProxy(A.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async p=>{const S=D.URI.file((0,E.join)((0,y.tmpdir)(),(0,R.generateUuid)()));return await a.$download(p,S),S})}};T=je([Ue(0,n.IExtHostRpcService),Ue(1,P.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(pe[250],ve([0,1,2,8,145,26,37,63,27,13,6,12,109,44]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(_,c){this.file=c,this.appender=(0,b.createRotatingLogger)(_,c,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class p extends A.AbstractExtHostOutputChannel{constructor(_,c,u){super(_,!1,E.URI.file(c.file),u);this._appender=c}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,c){this._appender.flush(),super.show(_,c)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=p;let S=class extends A.ExtHostOutputService{constructor(_,c,u){super(_);this.logService=c,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(_){if(_){const c=this._channels.get(_);c&&(this._visibleChannelDisposable.value=c.onDidAppend(()=>c.update()))}}createOutputChannel(_){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(_);return c.then(u=>u._id.then(s=>this._channels.set(s,u))),new A.LazyOutputChannel(_,c)}async _doCreateOutChannel(_){try{const c=(0,y.join)(this._logsLocation.fsPath,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await P.SymlinkSupport.existsDirectory(c)||await C.promises.mkdir(c,{recursive:!0});const s=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=E.URI.file((0,y.join)(c,`${s}.log`)),i=new a(s,t.fsPath);return new p(_,i,this._proxy)}catch(c){return this.logService.error(c),new A.ExtHostPushOutputChannel(_,this._proxy)}}};S=je([Ue(0,n.IExtHostRpcService),Ue(1,k.ILogService),Ue(2,D.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(pe[251],ve([0,1,5,13,6,27,2,38,24,37,26,7,9,50,3,72,12,14]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(w,d,f){this.remoteAddress=w,this.localAddress=d,this._dispose=f,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function c(g){const w=g.trim().split(`
`),d=[];return w.forEach(I=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(I);L&&L.length>=3&&d.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),d.reduce((I,L)=>(I[L.socket]=L,I),{})}e.getSockets=c;function u(...g){const w=[].concat(...g.map(t));return[...new Map(w.filter(d=>d.st==="0A").map(d=>{const f=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:s(f[0]),port:parseInt(f[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=u;function s(g){let w="";if(g.length===8)for(let d=g.length-2;d>=0;d-=2)w+=parseInt(g.substr(d,2),16),d!==0&&(w+=".");else for(let d=g.length-4;d>=0;d-=4)w+=parseInt(g.substr(d,4),16).toString(16),d!==0&&(w+=":");return w}e.parseIpAddress=s;function t(g){const w=g.trim().split(`
`),d=w.shift().trim().split(/\s+/).filter(I=>I!=="rx_queue"&&I!=="tm->when");return w.map(I=>I.trim().split(/\s+/).reduce((L,B,ee)=>(L[d[ee]||ee]=B,L),{}))}e.loadConnectionTable=t;function i(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/vs/server/main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function o(g){const w=g.trim().split(`
`),d=[];return w.forEach(f=>{const I=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);I&&I.length>=4&&d.push({pid:parseInt(I[1],10),ppid:parseInt(I[2]),cmd:I[3]})}),d}e.getRootProcesses=o;async function r(g,w,d){const f=d.reduce((L,B)=>(L[B.pid]=B,L),{}),I=[];return g.forEach(({socket:L,ip:B,port:ee})=>{var H;const x=w[L]?w[L].pid:void 0,$=x?(H=f[x])===null||H===void 0?void 0:H.cmd:void 0;x&&$&&!i($)&&I.push({host:B,port:ee,detail:$,pid:x})}),I}e.findPorts=r;function l(g,w,d){const f=new Map,I=o(w);for(const L of g){const B=d.get(L.port);if(B){f.set(L.port,B);continue}const ee=I.find(H=>H.cmd.includes(`${L.port}`));if(ee){let H=ee,x;do x=I.find($=>$.ppid===H.pid),x&&(H=x);while(x);f.set(L.port,{host:L.ip,port:L.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}}return f}e.tryFindRootPorts=l;let h=class extends R.Disposable{constructor(w,d,f){super();this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=w.getProxy(E.MainContext.MainThreadTunnelService),b.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(w,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${w.identifier} called openTunnel API for ${d.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(d,w.displayName);if(f){const I=new _(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(I),I}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(w){return Math.max(w*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(w,d){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:w,provider:d}),this._proxy.$registerPortsAttributesProvider(w,f),new k.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(w,d,f,I,L){const ee=(await Promise.all(w.map(H=>{const x=this._portAttributesProviders.get(H);return x?x.provider.providePortAttributes(d,f,I,L):[]}))).filter(H=>!!H&&H.length>0);return ee.length>0?(0,v.flatten)(ee).map(H=>({autoForwardAction:H.autoForwardAction,port:H.port})):[]}async $registerCandidateFinder(w){if(!(w&&this._candidateFindingEnabled)){this._candidateFindingEnabled=w;let d=new p.MovingAverage,f;for(;this._candidateFindingEnabled;){const I=new Date().getTime(),L=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(ee=>ee.port).join(", ")}`);const B=new Date().getTime()-I;d.update(B),(!f||JSON.stringify(f)!==JSON.stringify(L))&&(f=L,await this._proxy.$onFoundNewCandidates(f)),await new Promise(ee=>setTimeout(()=>ee(),this.calculateDelay(d.value)))}}}async setTunnelExtensionFunctions(w){var d;return w?(w.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(w.candidatePortSource),w.showCandidatePort&&(this._showCandidatePort=w.showCandidatePort,await this._proxy.$setCandidateFilter()),w.tunnelFactory&&(this._forwardPortProvider=w.tunnelFactory,await this._proxy.$setTunnelProvider((d=w.tunnelFeatures)!==null&&d!==void 0?d:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,R.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(w,d){if(this._extensionTunnels.has(w.host)){const f=this._extensionTunnels.get(w.host);f.has(w.port)&&(d&&f.get(w.port).disposeListener.dispose(),await f.get(w.port).tunnel.dispose(),f.delete(w.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(w,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(w,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const I=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(w.remoteAddress.host)||this._extensionTunnels.set(w.remoteAddress.host,new Map);const L=this._register(I.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(I.remoteAddress))));return this._extensionTunnels.get(w.remoteAddress.host).set(w.remoteAddress.port,{tunnel:I,disposeListener:L}),m.TunnelDto.fromApiTunnel(I)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(w){const d=await Promise.all(w.map(I=>this._showCandidatePort(I.host,I.port,I.detail))),f=w.filter((I,L)=>d[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${w.map(I=>I.port).join(", ")} to ${f.map(I=>I.port).join(", ")}`),f}async findCandidatePorts(){let w="",d="";try{w=await n.promises.readFile("/proc/net/tcp","utf8"),d=await n.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const f=u(w,d),I=await new Promise(U=>{(0,A.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,N,O)=>{U(N)})}),L=c(I),B=await T.readdir("/proc"),ee=[];for(let U of B)try{const M=Number(U),N=D.joinPath(C.URI.file("/proc"),U);if((await n.promises.stat(N.fsPath)).isDirectory()&&!isNaN(M)){const V=await n.promises.readlink(D.joinPath(N,"cwd").fsPath),q=await n.promises.readFile(D.joinPath(N,"cmdline").fsPath,"utf8");ee.push({pid:M,cwd:V,cmd:q})}}catch(M){}const H=[],x=f.filter(U=>{const M=L[U.socket];return M||H.push(U),M}),$=r(x,L,ee);let F;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const U=await new Promise(M=>{(0,A.exec)("ps -F -A -l | grep root",(N,O,V)=>{M(O)})});this._foundRootPorts=l(H,U,this._foundRootPorts),F=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${F.join(", ")}`)}return $.then(U=>F?U.concat(F):U)}};h=je([Ue(0,y.IExtHostRpcService),Ue(1,P.IExtHostInitDataService),Ue(2,S.ILogService)],h),e.ExtHostTunnelService=h}),define(pe[252],ve([0,1,17,21,16,3,6,97,223,123,25]),function(Z,e,E,y,R,P,C,A,D,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function b(r,l){try{return JSON.stringify(r,l)}catch(h){return"null"}}function m(r,l){return JSON.stringify(r,l)}function a(r){return r?(l,h)=>h&&h.$mid===1?r.transformOutgoing(h):h:null}var p;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},_=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends C.Disposable{constructor(l,h=null,g=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=h,this._uriTransformer=g,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,d=n.ProxyIdentifier.count;w<d;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,A.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:h,sid:g}=l;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,g)),this._proxies[h]}_createProxy(l,h){let g={get:(w,d)=>(typeof d=="string"&&!w[d]&&d.charCodeAt(0)===36&&(w[d]=(...f)=>this._remoteCall(l,d,f)),d===c?h:w[d])};return new Proxy(Object.create(null),g)}set(l,h){return this._locals[l.nid]=h,h}assertRegistered(l){for(let h=0,g=l.length;h<g;h++){const w=l[h];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const h=l.byteLength,g=s.read(l,0),w=g.readUInt8(),d=g.readUInt32();switch(w){case 1:case 2:{let{rpcId:f,method:I,args:L}=t.deserializeRequestJSONArgs(g);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,d,f,I,L,w===2);break}case 3:case 4:{let{rpcId:f,method:I,args:L}=t.deserializeRequestMixedArgs(g);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,d,f,I,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(h,d,0,"ack"),this._onDidReceiveAcknowledge(d);break}case 6:{this._receiveCancel(h,d);break}case 7:{this._receiveReply(h,d,void 0);break}case 9:{let f=t.deserializeReplyOKJSON(g);this._uriTransformer&&(f=(0,A.transformIncomingURIs)(f,this._uriTransformer)),this._receiveReply(h,d,f);break}case 8:{let f=t.deserializeReplyOKVSBuffer(g);this._receiveReply(h,d,f);break}case 10:{let f=t.deserializeReplyErrError(g);this._uriTransformer&&(f=(0,A.transformIncomingURIs)(f,this._uriTransformer)),this._receiveReplyErr(h,d,f);break}case 11:{this._receiveReplyErr(h,d,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,h,g,w,d,f){this._logger&&this._logger.logIncoming(l,h,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(g)}.${w}(`,d);const I=String(h);let L,B;if(f){const H=new y.CancellationTokenSource;d.push(H.token),L=this._invokeHandler(g,w,d),B=()=>H.cancel()}else L=this._invokeHandler(g,w,d),B=v;this._cancelInvokedHandlers[I]=B;const ee=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(ee.byteLength,h,1,"ack"),this._protocol.send(ee),L.then(H=>{delete this._cancelInvokedHandlers[I];const x=t.serializeReplyOK(h,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,h,1,"reply:",H),this._protocol.send(x)},H=>{delete this._cancelInvokedHandlers[I];const x=t.serializeReplyErr(h,H);this._logger&&this._logger.logOutgoing(x.byteLength,h,1,"replyErr:",H),this._protocol.send(x)})}_receiveCancel(l,h){this._logger&&this._logger.logIncoming(l,h,1,"receiveCancel");const g=String(h);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(l,h,g){this._logger&&this._logger.logIncoming(l,h,0,"receiveReply:",g);const w=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const d=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],d.resolveOk(g)}}_receiveReplyErr(l,h,g){this._logger&&this._logger.logIncoming(l,h,0,"receiveReplyErr:",g);const w=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const d=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let f;g&&(g.$isError?(f=new Error,f.name=g.name,f.message=g.message,f.stack=g.stack):f=g),d.resolveErr(f)}}_invokeHandler(l,h,g){try{return Promise.resolve(this._doInvokeHandler(l,h,g))}catch(w){return Promise.reject(w)}}_doInvokeHandler(l,h,g){const w=this._locals[l];if(!w)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(l));let d=w[h];if(typeof d!="function")throw new Error("Unknown method "+h+" on actor "+(0,n.getStringIdentifierForProxy)(l));return d.apply(w,g)}_remoteCall(l,h,g){if(this._isDisposed)return Promise.reject(R.canceled());let w=null;if(g.length>0&&y.CancellationToken.isCancellationToken(g[g.length-1])&&(w=g.pop()),w&&w.isCancellationRequested)return Promise.reject(R.canceled());const d=t.serializeRequestArguments(g,this._uriReplacer),f=++this._lastMessageId,I=String(f),L=new D.LazyPromise;w&&w.onCancellationRequested(()=>{const ee=t.serializeCancel(f);this._logger&&this._logger.logOutgoing(ee.byteLength,f,0,"cancel"),this._protocol.send(t.serializeCancel(f))}),this._pendingRPCReplies[I]=L,this._onWillSendRequest(f);const B=t.serializeRequest(f,l,h,d,!!w);return this._logger&&this._logger.logOutgoing(B.byteLength,f,0,`request: ${(0,n.getStringIdentifierForProxy)(l)}.${h}(`,g),this._protocol.send(B),L}}e.RPCProtocol=u,k=_,u.UNRESPONSIVE_TIME=3*1e3;class s{constructor(l,h){this._buff=l,this._offset=h}static alloc(l,h,g){let w=new s(T.VSBuffer.alloc(g+1+4),0);return w.writeUInt8(l),w.writeUInt32(h),w}static read(l,h){return new s(l,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,g}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,g}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,h}static sizeMixedArray(l,h){let g=0;g+=1;for(let w=0,d=l.length;w<d;w++){const f=l[w],I=h[w];switch(g+=1,I){case 1:g+=this.sizeLongString(f);break;case 2:g+=this.sizeVSBuffer(f);break;case 3:break}}return g}writeMixedArray(l,h){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let g=0,w=l.length;g<w;g++){const d=l[g];switch(h[g]){case 1:this.writeUInt8(1),this.writeLongString(d);break;case 2:this.writeUInt8(2),this.writeVSBuffer(d);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(l);for(let g=0;g<l;g++)switch(this.readUInt8()){case 1:h[g]=this.readLongString();break;case 2:h[g]=this.readVSBuffer();break;case 3:h[g]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(l){for(let h=0,g=l.length;h<g;h++)if(l[h]instanceof T.VSBuffer||typeof l[h]=="undefined")return!0;return!1}static serializeRequestArguments(l,h){if(this._arrayContainsBufferOrUndefined(l)){let g=[],w=[];for(let d=0,f=l.length;d<f;d++){const I=l[d];I instanceof T.VSBuffer?(g[d]=I,w[d]=2):typeof I=="undefined"?(g[d]=T.VSBuffer.alloc(0),w[d]=3):(g[d]=T.VSBuffer.fromString(m(I,h)),w[d]=1)}return{type:"mixed",args:g,argsType:w}}return{type:"simple",args:m(l,h)}}static serializeRequest(l,h,g,w,d){return w.type==="mixed"?this._requestMixedArgs(l,h,g,w.args,w.argsType,d):this._requestJSONArgs(l,h,g,w.args,d)}static _requestJSONArgs(l,h,g,w,d){const f=T.VSBuffer.fromString(g),I=T.VSBuffer.fromString(w);let L=0;L+=s.sizeUInt8(),L+=s.sizeShortString(f),L+=s.sizeLongString(I);let B=s.alloc(d?2:1,l,L);return B.writeUInt8(h),B.writeShortString(f),B.writeLongString(I),B.buffer}static deserializeRequestJSONArgs(l){const h=l.readUInt8(),g=l.readShortString(),w=l.readLongString();return{rpcId:h,method:g,args:JSON.parse(w)}}static _requestMixedArgs(l,h,g,w,d,f){const I=T.VSBuffer.fromString(g);let L=0;L+=s.sizeUInt8(),L+=s.sizeShortString(I),L+=s.sizeMixedArray(w,d);let B=s.alloc(f?4:3,l,L);return B.writeUInt8(h),B.writeShortString(I),B.writeMixedArray(w,d),B.buffer}static deserializeRequestMixedArgs(l){const h=l.readUInt8(),g=l.readShortString(),w=l.readMixedArray(),d=new Array(w.length);for(let f=0,I=w.length;f<I;f++){const L=w[f];typeof L=="string"?d[f]=JSON.parse(L):d[f]=L}return{rpcId:h,method:g,args:d}}static serializeAcknowledged(l){return s.alloc(5,l,0).buffer}static serializeCancel(l){return s.alloc(6,l,0).buffer}static serializeReplyOK(l,h,g){return typeof h=="undefined"?this._serializeReplyOKEmpty(l):h instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(l,h):this._serializeReplyOKJSON(l,b(h,g))}static _serializeReplyOKEmpty(l){return s.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,h){let g=0;g+=s.sizeVSBuffer(h);let w=s.alloc(8,l,g);return w.writeVSBuffer(h),w.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,h){const g=T.VSBuffer.fromString(h);let w=0;w+=s.sizeLongString(g);let d=s.alloc(9,l,w);return d.writeLongString(g),d.buffer}static deserializeReplyOKJSON(l){const h=l.readLongString();return JSON.parse(h)}static serializeReplyErr(l,h){return h?this._serializeReplyErrEror(l,h):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,h){const g=T.VSBuffer.fromString(b(R.transformErrorForSerialization(h),null));let w=0;w+=s.sizeLongString(g);let d=s.alloc(10,l,w);return d.writeLongString(g),d.buffer}static deserializeReplyErrError(l){const h=l.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(l){return s.alloc(11,l,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var o;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(o||(o={}))}),define(pe[253],ve([0,1,4]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(pe[254],ve([0,1,11,8,9,2,4,253]),function(Z,e,E,y,R,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let D=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||R.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?y.win32:y.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const m=T.indexOf("/",2);m===-1?(k=T.substring(2),T="/"):(k=T.substring(2,m),T=T.substring(m)||"/")}return P.URI.from({scheme:E.Schemas.file,authority:k,path:T,query:"",fragment:""})}};D=je([Ue(1,A.IRemoteAgentService)],D),e.AbstractPathService=D}),define(pe[32],ve([0,1,14,34,22,31,10,4,8,16]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",b=(T.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var m;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function p(F){return!!F.preview}e.resultIsMatch=p;function S(F){return!!F.resource}e.isFileMatch=S;function v(F){return!!F.message}e.isProgressMessage=v;var _;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=c;class u{constructor(U,M,N){this.ranges=M;const O=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&s(O)){U=(0,C.getNLines)(U,N.matchLines);let V="",q=0,Q=0;const me=Math.floor(N.charsPerLine/5),we=[];for(const Ae of O){const Ie=Math.max(Ae.startColumn-me,0),Me=Ae.startColumn+N.charsPerLine;if(Ie>Q+me+b){const z=T+(Ie-Q)+k;V+=z+U.slice(Ie,Me),q+=Ie-(Q+z.length)}else V+=U.slice(Q,Me);we.push(new i(0,Ae.startColumn-q,Ae.endColumn-q)),Q=Me}this.preview={text:V,matches:Array.isArray(this.ranges)?we:we[0]}}else{const V=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,E.mapArrayOrNot)(M,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=u;function s(F){const U=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class t{constructor(U,M,N,O){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class i extends t{constructor(U,M,N){super(U,M,U,N)}}e.OneLineRange=i;var o;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,U=!0){const M=F&&F.files&&F.files.exclude,N=U&&F&&F.search&&F.search.exclude;if(!(!M&&!N)){if(!M||!N)return M||N;let O=Object.create(null);return O=R.mixin(O,R.deepClone(M)),O=R.mixin(O,R.deepClone(N),!0),O}}e.getExcludes=r;function l(F,U){return F.excludePattern&&y.match(F.excludePattern,U)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&y.match(F.includePattern,U)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(P.isEqualOrParent(U,N)){const O=D.relative(N,U);return!M.includePattern||!!y.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var h;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=g;function w(F){const U=F.message;if((0,n.isPromiseCanceledError)(F))return new g(U,h.canceled);try{const M=JSON.parse(U);return new g(M.message,M.code)}catch(M){return new g(U,h.other)}}e.deserializeSearchError=w;function d(F){const U={message:F.message,code:F.code};return new Error(JSON.stringify(U))}e.serializeSearchError=d;function f(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=f;function I(F){return F.type==="success"}e.isSerializedSearchSuccess=I;function L(F){return!!F.path}e.isSerializedFileMatch=L;function B(F,U){const M=F.searchPath?F.searchPath:F.relativePath;return(0,C.fuzzyContains)(M,U)}e.isFilePatternMatch=B;class ee{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function H(F,U){const M=Object.assign(Object.assign({},F||{}),U||{});return Object.keys(M).filter(N=>{const O=M[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=H;class x{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=y.parse(this._excludeExpression);let N=U.includePattern;M.includePattern&&(N?N=Object.assign(Object.assign({},N),M.includePattern):N=M.includePattern),N&&(this._parsedIncludeExpression=y.parse(N))}includedInQuerySync(U,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,N))}includedInQuery(U,M,N){return Promise.resolve(this._parsedExcludeExpression(U,M,N)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,N)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=x;function $(F){for(const U in F)if(typeof F[U]!="boolean")return!0;return!1}}),define(pe[33],ve([0,1,14,17,21,3,23,11,72,24,10,15,2,165,4,12,183,59,60,27,13,7,32,5]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c,u,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(I,L,B){return new n.ExtUri(ee=>g(ee,B)).isEqual(I,L)}function r(I,L,B){return o(I.uri,L.uri,B)?0:(0,T.compare)(I.uri.toString(),L.uri.toString())}function l(I,L,B){return I.index!==L.index?I.index<L.index?-1:1:o(I.uri,L.uri,B)?(0,T.compare)(I.name,L.name):(0,T.compare)(I.uri.toString(),L.uri.toString())}function h(I,L,B,ee){const H=I.slice(0).sort(($,F)=>B($,F,ee)),x=L.slice(0).sort(($,F)=>B($,F,ee));return(0,E.delta)(H,x,($,F)=>B($,F,ee))}function g(I,L){const B=L.getCapabilities(I.scheme);return!(B&&B&1024)}class w extends v.Workspace{constructor(L,B,ee,H,x,$){super(L,ee.map(F=>new v.WorkspaceFolder(F)),H,$);this._name=B,this._isUntitled=x,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris($),ee.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,B,ee,H){if(!L)return{workspace:null,added:[],removed:[]};const{id:x,name:$,folders:F,configuration:U,isUntitled:M}=L,N=[],O=B;B?F.forEach((me,we)=>{const Ae=b.URI.revive(me.uri),Ie=w._findFolder(ee||B,Ae,H);Ie?(Ie.name=me.name,Ie.index=me.index,N.push(Ie)):N.push({uri:Ae,name:me.name,index:we})}):N.push(...F.map(({uri:me,name:we,index:Ae})=>({uri:b.URI.revive(me),name:we,index:Ae}))),N.sort((me,we)=>me.index<we.index?-1:1);const V=new w(x,$,N,U?b.URI.revive(U):null,!!M,me=>g(me,H)),{added:q,removed:Q}=h(O?O.workspaceFolders:[],V.workspaceFolders,r,H);return{workspace:V,added:q,removed:Q}}static _findFolder(L,B,ee){for(let H=0;H<L.folders.length;H++){const x=L.workspaceFolders[H];if(o(x.uri,B,ee))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let d=class{constructor(L,B,ee,H){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=s.WorkspaceTrustState.Unknown,this._logService=H,this._extHostFileSystemInfo=ee,this._requestIdProvider=new D.Counter,this._barrier=new y.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new w(x.id,x.name,[],x.configuration?b.URI.revive(x.configuration):null,!!x.isUntitled,$=>g($,ee)):void 0}$initializeWorkspace(L,B){this._workspaceTrustState=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:A.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,ee,...H){const x=[];if(Array.isArray(H)&&H.forEach(N=>{b.URI.isUri(N.uri)&&!x.some(O=>o(O.uri,N.uri,this._extHostFileSystemInfo))&&x.push({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[B,ee].some(N=>typeof N!="number"||N<0)||ee===0&&x.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+ee>$.length)return!1;const F=$.slice(0);F.splice(B,ee,...x.map(N=>({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<F.length;N++){const O=F[N];if(F.some((V,q)=>q!==N&&o(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}F.forEach((N,O)=>N.index=O);const{added:U,removed:M}=h($,F,l,this._extHostFileSystemInfo);if(U.length===0&&M.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,B,ee,x).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,m.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,B){let ee,H="";if(typeof L=="string"?(ee=b.URI.file(L),H=L):typeof L!="undefined"&&(ee=L,H=L.fsPath),!ee)return H;const x=this.getWorkspaceFolder(ee,!0);if(!x)return H;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let $=(0,n.relativePath)(x.uri,ee);return B&&x.name&&($=`${x.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:ee,removed:H}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:H}))}findFiles(L,B,ee,H,x=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let $;if(B===null?$=!1:B&&(typeof B=="string"?$=B:$=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:U}=f(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(F),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)($),(0,k.withUndefinedAsNull)(ee),x).then(M=>Array.isArray(M)?M.map(N=>b.URI.revive(N)):[])}async findTextInFiles(L,B,ee,H,x=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),F=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:U,folder:M}=f(B.include),N=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:F,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:U,excludePattern:N},V=!1;if(this._activeSearchCallbacks[$]=q=>{if(!V){const Q=b.URI.revive(q.resource);q.results.forEach(me=>{(0,t.resultIsMatch)(me)?ee({uri:Q,preview:{text:me.preview.text,matches:(0,E.mapArrayOrNot)(me.preview.matches,we=>new s.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,E.mapArrayOrNot)(me.ranges,we=>new s.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):ee({uri:Q,text:me.text,lineNumber:me.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(M),O,$,x);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(L){return this._proxy.$requireWorkspaceTrust(L)}$onDidChangeWorkspaceTrustState(L){this._workspaceTrustState=L.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(L))}};d=je([Ue(0,u.IExtHostRpcService),Ue(1,c.IExtHostInitDataService),Ue(2,_.IExtHostFileSystemInfo),Ue(3,p.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function f(I){let L,B;return I&&(typeof I=="string"?L=I:(L=I.pattern,B=I.baseFolder||b.URI.file(I.base))),{includePattern:L,folder:B}}}),define(pe[36],ve([0,1,22,3,33,5,7,185,82,15,17,4,13,12,2]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(i,o){if(o){const r=o.split(".");let l=i;for(let h=0;l&&h<r.length;h++)l=l[r[h]];return l}}function S(i){return i instanceof a.URI}function v(i){return i&&i.uri instanceof a.URI&&i.languageId&&typeof i.languageId=="string"}function _(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof a.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function u(i){if(S(i))return{resource:i};if(v(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(_(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let s=class{constructor(o,r,l){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(o,r))}};s=je([Ue(0,b.IExtHostRpcService),Ue(1,R.IExtHostWorkspace),Ue(2,m.ILogService)],s),e.ExtHostConfiguration=s;class t{constructor(o,r,l,h){this._onDidChangeConfiguration=new y.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=r,this._configuration=A.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(o,r,l){const h=u(r)||{},g=this._toReadonlyValue(o?p(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,l==null?void 0:l.identifier);function w(f){if(f==null)return null;if(typeof f=="boolean")return f?1:4;switch(f){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(f){return typeof p(g,f)!="undefined"},get:(f,I)=>{this._validateConfigurationAccess(o?`${o}.${f}`:f,h,l==null?void 0:l.identifier);let L=p(g,f);if(typeof L=="undefined")L=I;else{let B;const ee=(H,x)=>{let $;const F=()=>{B=B||(0,E.deepClone)(g),$=$||p(B,x)};return(0,n.isObject)(H)?new Proxy(H,{get:(U,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>$;if(B)return $=$||p(B,x),$[M];const N=U[M];return typeof M=="string"?ee(N,`${x}.${M}`):N},set:(U,M,N)=>(F(),$&&($[M]=N),!0),deleteProperty:(U,M)=>(F(),$&&delete $[M],!0),defineProperty:(U,M,N)=>(F(),$&&Object.defineProperty($,M,N),!0)}):H};L=ee(L,f)}return L},update:(f,I,L,B)=>{f=o?`${o}.${f}`:f;const ee=w(L);return I!==void 0?this._proxy.$updateConfigurationOption(ee,f,I,h,B):this._proxy.$removeConfigurationOption(ee,f,h,B)},inspect:f=>{var I,L,B,ee,H,x,$,F;f=o?`${o}.${f}`:f;const U=(0,E.deepClone)(this._configuration.inspect(f,h,this._extHostWorkspace.workspace));if(U)return{key:f,defaultValue:(I=U.default)===null||I===void 0?void 0:I.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:(B=U.workspace)===null||B===void 0?void 0:B.value,workspaceFolderValue:(ee=U.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(H=U.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(x=U.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:($=U.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(F=U.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:U.overrideIdentifiers}}};return typeof g=="object"&&(0,E.mixin)(d,g,!1),Object.freeze(d)}_toReadonlyValue(o){const r=l=>(0,n.isObject)(l)?new Proxy(l,{get:(h,g)=>r(h[g]),set:(h,g,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(o)}_validateConfigurationAccess(o,r,l){const h=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),g=l?`[${l.value}] `:"";if(h===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(r==null?void 0:r.resource)&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const l=new A.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,g)=>l.affectsConfiguration(h,u(g))})}_toMap(o){return o.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[65],ve([0,1,2,17,3,5,7,33,39,36,21,35,13,27,4,11,9,12,62,205,16]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c,u){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function x(F){if(F!=null)return F}H.from=x;function $(F){if(F!=null)return F}H.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(H){function x(F){if(F!=null)return F}H.from=x;function $(F){if(F!=null)return F}H.to=$})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(H){function x(F){if(F!=null)return F}H.from=x;function $(F){if(F!=null)return F}H.to=$})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(H){function x(U){if(U){const M=U;return M&&!!M.process}else return!1}H.is=x;function $(U){if(U!=null){const M={process:U.process,args:U.args};return U.options&&(M.options=o.from(U.options)),M}}H.from=$;function F(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}H.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(H){function x(F){if(F!=null)return F}H.from=x;function $(F){if(F!=null)return F}H.to=$})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(H){function x(U){if(U){const M=U;return M&&(!!M.commandLine||!!M.command)}else return!1}H.is=x;function $(U){if(U!=null){const M={};return U.commandLine!==void 0?M.commandLine=U.commandLine:(M.command=U.command,M.args=U.args),U.options&&(M.options=l.from(U.options)),M}}H.from=$;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=F})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(H){function x(U){if(U){let M=U;return M&&M.customExecution==="customExecution"}else return!1}H.is=x;function $(U){return{customExecution:"customExecution"}}H.from=$;function F(U,M){return M.get(U)}H.to=F})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(H){function x($,F){let U;return $.scope!==void 0&&typeof $.scope!="number"?U=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===C.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=c.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:U}}H.from=x})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(H){function x(U,M){if(U==null)return[];const N=[];for(let O of U){const V=$(O,M);V&&N.push(V)}return N}H.fromMany=x;function $(U,M){if(U!=null){let N;U.execution instanceof C.ProcessExecution?N=r.from(U.execution):U.execution instanceof C.ShellExecution?N=h.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(N=g.from(U.execution));const O=t.from(U.definition);let V;if(U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=C.TaskScope.Workspace,!(!O||!V)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:M.identifier.value,label:U.source,scope:V},execution:N,isBackground:U.isBackground,group:q,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}H.from=$;async function F(U,M,N){if(U!=null){let O;r.is(U.execution)?O=r.to(U.execution):h.is(U.execution)?O=h.to(U.execution):g.is(U.execution)&&(O=g.to(U._id,N));const V=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await M.resolveWorkspaceFolder(E.URI.revive(U.source.scope)):q=C.TaskScope.Workspace),!(!V||!q)){const Q=new C.Task(V,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=C.TaskGroup.from(U.group)),U.presentationOptions&&(Q.presentationOptions=i.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}}}H.to=F})(d=e.TaskDTO||(e.TaskDTO={}));var f;(function(H){function x(F){return F}H.from=x;function $(F){if(!!F)return Object.assign(Object.create(null),F)}H.to=$})(f=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(x,$,F){this._id=$,this._task=F,s.set(this,void 0),tt(this,s,x)}get task(){return this._task}terminate(){Be(this,s).terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}s=new WeakMap;var L;(function(H){function x($){return{id:$._id,task:void 0}}H.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(x,$,F,U,M,N,O,V){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=x.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=M,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,$,F){if(!F)return new C.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:$,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,$),new C.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,$){this._proxy.$registerTaskSystem(x,$)}fetchTasks(x){return this._proxy.$fetchTasks(f.from(x)).then(async $=>{const F=[];for(let U of $){const M=await d.to(U,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach($=>x.push($)),x}terminateTask(x){if(!(x instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,$,F){const U=this._providedCustomExecutions2.get(x.id);if(U){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal($,await U.callback(F))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const $=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:$,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:x.exitCode})}$provideTasks(x,$){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],M=(0,y.asPromise)(()=>F.provider.provideTasks(T.CancellationToken.None)).then(N=>this.provideTasksInternal($,U,F,N));return new Promise(N=>{M.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(x,$){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if($.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await d.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(U,T.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const N=d.from(M,F.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(N.execution)&&await this.addCustomExecution(N,M,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,$,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,$.execution)}async getTaskExecution(x,$){if(typeof x=="string"){const M=this._taskExecutionPromises.get(x);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise(async(M,N)=>{const O=$||await d.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new I(this,x.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,U),U.then(M=>(this._taskExecutions.set(x.id,M),M),M=>Promise.reject(M))}checkDeprecation(x,$){x._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let F=this._notProvidedCustomExecutions.values(),U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};B=je([Ue(0,b.IExtHostRpcService),Ue(1,m.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,D.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,_.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let ee=class extends B{constructor(x,$,F,U,M,N,O,V){super(x,$,F,U,M,N,O,V);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(x,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const F=d.from($,x);if(F===void 0)throw new Error("Task is not valid");if(g.is(F.execution))await this.addCustomExecution(F,$,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),$);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),U}provideTasksInternal(x,$,F,U){const M=[];if(U)for(let N of U){this.checkDeprecation(N,F),(!N.definition||!x[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=d.from(N,F.extension);O&&g.is(O.execution)?(M.push(O),$.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(x){if(g.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,$,F){}};ee=je([Ue(0,b.IExtHostRpcService),Ue(1,m.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,D.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,k.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,_.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var gn=this&&this.__rest||function(Z,e){var E={};for(var y in Z)Object.prototype.hasOwnProperty.call(Z,y)&&e.indexOf(y)<0&&(E[y]=Z[y]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,y=Object.getOwnPropertySymbols(Z);R<y.length;R++)e.indexOf(y[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,y[R])&&(E[y[R]]=Z[y[R]]);return E};define(pe[255],ve([0,1,14,17,21,3,69,6,22,15,2,28,5,39,13,20,7,33,218,121]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(w,d)=>`${w}:${d.toString()}`;let s=class{constructor(d,f,I){this.documents=f,this.workspace=I,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new _.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=d.getProxy(b.MainContext.MainThreadTesting),this.workspaceObservers=new h(this.proxy),this.textDocumentObservers=new g(this.proxy,f)}registerTestProvider(d){const f=(0,k.generateUuid)();this.providers.set(f,d),this.proxy.$registerTestProvider(f);const I=[...this.testSubscriptions.keys()];return setTimeout(()=>{var L;for(const B of I)(L=this.testSubscriptions.get(B))===null||L===void 0||L.subscribeFn(f,d)},0),new S.Disposable(()=>{this.providers.delete(f),this.proxy.$unregisterTestProvider(f)})}createTextDocumentTestObserver(d){return this.textDocumentObservers.checkout(d.uri)}createWorkspaceTestObserver(d){return this.workspaceObservers.checkout(d.uri)}async runTests(d,f=R.CancellationToken.None){const I=L=>L.map(this.getInternalTestForReference,this).filter(n.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:d.exclude?I(d.exclude).map(L=>L.testId):void 0,tests:I(d.tests),debug:d.debug},f)}publishExtensionProvidedResults(d,f){this.proxy.$publishExtensionProvidedResults(p.TestResults.from((0,k.generateUuid)(),d),f)}$publishTestResults(d){this.results=Object.freeze(d.map(f=>(0,D.deepFreeze)(p.TestResults.to(f))).concat(this.results).sort((f,I)=>I.completedAt-f.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(d,f){const I=T.URI.revive(f),L=u(d,I);if(!this.testSubscriptions.has(L)){const B=new R.CancellationTokenSource;let ee;if(d===1){let F=this.documents.getDocument(I);if(!F){const U=new A.DisposableStore;F=await new Promise(M=>{U.add((0,y.disposableTimeout)(()=>M(void 0),5e3)),U.add(this.documents.onDidAddDocuments(N=>{const O=N.find(V=>V.document.uri.toString()===I.toString());O&&M(O)}))}).finally(()=>U.dispose())}if(F){const U=await this.workspace.getWorkspaceFolder2(I,!1);ee=M=>M.provideDocumentTestRoot?M.provideDocumentTestRoot(F.document,B.token):(0,e.createDefaultDocumentTestRoot)(M,F.document,U,B.token)}}else{const F=await this.workspace.getWorkspaceFolder2(I,!1);F&&(ee=U=>U.provideWorkspaceTestRoot(F,B.token))}if(!!ee){const H=async(F,U)=>{try{const M=await ee(U);M&&$.addRoot(M,F)}catch(M){console.error(M)}},x=new A.DisposableStore,$=x.add(this.ownedTests.createForHierarchy(F=>this.proxy.$publishDiff(d,f,F)));x.add((0,A.toDisposable)(()=>B.dispose(!0)));for(const[F,U]of this.providers)H(F,U);$.pushDiff([3,-1]),this.testSubscriptions.set(L,{store:x,collection:$,subscribeFn:H})}}}async $expandTest(d,f){const I=(0,E.mapFind)(this.testSubscriptions.values(),L=>L.collection.treeId===d.src.tree?L:void 0);await(I==null?void 0:I.collection.expand(d.testId,f<0?Infinity:f)),this.flushCollectionDiffs()}$unsubscribeFromTests(d,f){var I;const L=T.URI.revive(f),B=u(d,L);(I=this.testSubscriptions.get(B))===null||I===void 0||I.store.dispose(),this.testSubscriptions.delete(B)}$acceptDiff(d,f,I){d===1?this.textDocumentObservers.acceptDiff(T.URI.revive(f),I):this.workspaceObservers.acceptDiff(T.URI.revive(f),I)}async $runTestsForProvider(d,f){const I=this.providers.get(d.tests[0].src.provider);if(!!I){const L=d.tests.map(({testId:ee,src:H})=>this.ownedTests.getTestById(ee,H.tree)).filter(n.isDefined).map(([ee,H])=>H),B=d.excludeExtIds.map(ee=>this.ownedTests.getTestById(ee)).filter(n.isDefined).filter(([ee,H])=>L.some(x=>ee.comparePositions(x,H)===1));if(!!L.length)try{await I.runTests({setState:(ee,H)=>{for(const[x,$]of B){const F=x.comparePositions($,ee.id);if(F===1||F===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(d.runId,ee.id,p.TestState.from(H))},tests:L.map(ee=>i.unwrap(ee.actual)),exclude:B.map(([,ee])=>i.unwrap(ee.actual)),debug:d.debug},f);for(const{collection:ee}of this.testSubscriptions.values())ee.flushDiff();return}catch(ee){throw console.error(ee),ee}}}$lookupTest(d){const f=this.ownedTests.getTestById(d.testId);if(!f)return Promise.resolve(void 0);const I=f[1],{actual:L,discoverCts:B,expandLevels:ee}=I,H=gn(I,["actual","discoverCts","expandLevels"]);return Promise.resolve(H)}flushCollectionDiffs(){for(const{collection:d}of this.testSubscriptions.values())d.flushDiff()}getInternalTestForReference(d){var f,I;return(I=(f=this.workspaceObservers.getMirroredTestDataByReference(d))!==null&&f!==void 0?f:(0,E.mapFind)(this.testSubscriptions.values(),L=>L.collection.getTestByReference(d)))!==null&&I!==void 0?I:this.textDocumentObservers.getMirroredTestDataByReference(d)}};s=je([Ue(0,a.IExtHostRpcService),Ue(1,m.IExtHostDocumentsAndEditors),Ue(2,v.IExtHostWorkspace)],s),e.ExtHostTesting=s;const t=async(w,d,f,I)=>{if(!!f){const L=await w.provideWorkspaceTestRoot(f,I);if(!!L)return I.onCancellationRequested(()=>{i.removeFilter(d)}),i.getWrapperForTestItem(L,d)}};e.createDefaultDocumentTestRoot=t;class i extends S.TestItem{constructor(d,f,I){super(d.id,d.label,d.expandable);if(this.actual=d,this.filterDocument=f,this.parent=I,!(d instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);d[S.TestItemHookProperty]={setProp:(L,B)=>{this[L]=B,L==="location"&&this.refreshMatch()},created:L=>i.getWrapperForTestItem(L,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:L=>this.children.delete(L)}}static removeFilter(d){this.wrapperMap.delete(d)}static getWrapperForTestItem(d,f,I){let L=this.wrapperMap.get(f);if(L==null?void 0:L.has(d))return L.get(d);L||(L=new WeakMap,this.wrapperMap.set(f,L));const B=new i(d,f,I);return L.set(d,B),B}static unwrap(d){return d instanceof i?d.actual:d}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var d,f;const I=this._cachedMatchesFilter;for(const B of this.actual.children){const ee=i.getWrapperForTestItem(B,this.filterDocument,this);ee.hasNodeMatchingFilter?this.children.add(ee):this.children.delete(ee)}const L=this.children.size>0||((d=this.actual.location)===null||d===void 0?void 0:d.uri.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=L,L!==I&&((f=this.parent)===null||f===void 0||f.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=i,i.wrapperMap=new WeakMap;class o extends c.IncrementalChangeCollector{constructor(d){super();this.emitter=d,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(d){this.added.add(d)}update(d){Object.assign(d.revived,p.TestItem.toPlain(d.item)),this.added.has(d)||this.updated.add(d)}remove(d){if(this.added.has(d)){this.added.delete(d);return}if(this.updated.delete(d),d.parent&&this.alreadyRemoved.has(d.parent)){this.alreadyRemoved.add(d.item.extId);return}this.removed.add(d)}getChangeEvent(){const{added:d,updated:f,removed:I}=this;return{get added(){return[...d].map(L=>L.revived)},get updated(){return[...f].map(L=>L.revived)},get removed(){return[...I].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class r extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(d){let f=[];for(const I of d){const L=this.items.get(I);L&&f.push(L.revived)}return f}getMirroredTestDataById(d){return this.items.get(d)}getMirroredTestDataByReference(d){return this.items.get(d.id)}createItem(d,f){return Object.assign(Object.assign({},d),{revived:p.TestItem.toPlain(d.item),depth:f?f.depth+1:0,children:new Set})}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=r;class l{constructor(){this.resources=new Map}checkout(d){var f,I;const L=d.toString(),B=(f=this.resources.get(L))!==null&&f!==void 0?f:this.createObserverData(d);return(I=B.pendingDeletion)===null||I===void 0||I.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,C.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(d))})}}getMirroredTestDataByReference(d){for(const{tests:f}of this.resources.values()){const I=f.getMirroredTestDataByReference(d);if(I)return I}}eventuallyDispose(d){return(0,y.disposableTimeout)(()=>this.unlisten(d),10*1e3)}createObserverData(d){const f=new r,I=this.listen(d,B=>f.apply(B)),L={observers:0,tests:f,listener:I};return this.resources.set(d.toString(),L),L}unlisten(d){var f;const I=d.toString(),L=this.resources.get(I);L&&(L.observers=-1,(f=L.pendingDeletion)===null||f===void 0||f.dispose(),L.listener.dispose(),this.resources.delete(I))}}class h extends l{constructor(d){super();this.proxy=d,this.diffListeners=new Map}acceptDiff(d,f){var I;(I=this.diffListeners.get(d.toString()))===null||I===void 0||I(f)}listen(d,f){this.proxy.$subscribeToDiffs(0,d);const I=d.toString();return this.diffListeners.set(I,f),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,d),this.diffListeners.delete(I)})}}class g extends l{constructor(d,f){super();this.proxy=d,this.documents=f,this.diffListeners=new Map}acceptDiff(d,f){var I;(I=this.diffListeners.get(d.toString()))===null||I===void 0||I(f)}listen(d,f){if(!this.documents.getDocument(d))return new S.Disposable(()=>{});const L=d.toString();return this.diffListeners.set(L,f),this.proxy.$subscribeToDiffs(1,d),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,d),this.diffListeners.delete(L)})}}}),define(pe[256],ve([0,1,14,53,34,75,23,11,8,24,10,15,2,139,171,83,59,210,254,32]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(w,d,f,I){this.configurationService=w,this.workspaceContextService=d,this.editorGroupsService=f,this.pathService=I}text(w,d,f={}){w=this.getContentPattern(w,f);const I=this.configurationService.getValue(),L=d&&d.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),B=this.commonQuery(d==null?void 0:d.map(S.toWorkspaceFolder),f);return Object.assign(Object.assign({},B),{type:2,contentPattern:w,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:I.search.usePCRE2||L||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles})}getContentPattern(w,d){const f=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const I=Object.assign(Object.assign({},w),{wordSeparators:f.editor.wordSeparators});return this.isCaseSensitive(w,d)&&(I.isCaseSensitive=!0),this.isMultiline(w)&&(I.isMultiline=!0),I}file(w,d={}){const f=this.commonQuery(w,d);return Object.assign(Object.assign({},f),{type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey})}handleIncludeExclude(w,d){return w?(w=Array.isArray(w)?w.map(r):r(w),d?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],d={}){const f=this.handleIncludeExclude(d.includePattern,d.expandPatterns),I=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),L=w.length>1,B=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,d,I)):w.map(x=>this.getFolderQueryForRoot(x,d,I,L))).filter(x=>!!x),ee={_reason:d._reason,folderQueries:B,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:I.pattern,includePattern:f.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const $=E.coalesce(E.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(M=>M.resource)))).filter(U=>(0,c.pathIncludedInQuery)(ee,U.fsPath)),F=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ee),F)}const H=d.extraFileResources&&d.extraFileResources.filter(x=>(0,c.pathIncludedInQuery)(ee,x.fsPath));return ee.extraFileResources=H&&H.length?H:void 0,ee}commonQueryFromFileList(w){const d=[],f=new C.ResourceMap,I={};let L=!1;return w.forEach(B=>{var ee,H;if(B.scheme!==A.Schemas.walkThrough)if((0,n.isAbsolutePath)(B)){const $=(H=(ee=this.workspaceContextService.getWorkspaceFolder(B))===null||ee===void 0?void 0:ee.uri)!==null&&H!==void 0?H:B.with({path:D.dirname(B.fsPath)});let F=f.get($);F||(L=!0,F={folder:$,includePattern:{}},d.push(F),f.set($,F));const U=D.relative($.fsPath,B.fsPath);(0,k.assertIsDefined)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else B.fsPath&&(L=!0,I[B.fsPath]=!0)}),{folderQueries:d,includePattern:I,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,d){if(d.isSmartCase){if(w.isRegExp){if(T.containsUppercaseCharacter(w.pattern,!0))return!0}else if(T.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const d=F=>D.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),I=(Array.isArray(w)?w:i(w)).map(F=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(F,U.scheme===A.Schemas.file?U.fsPath:U.path):F}),L=y.groupBy(I,F=>d(F)?"searchPaths":"exprSegments"),B=(L.exprSegments||[]).map(F=>T.rtrim(F,"/")).map(F=>T.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),o(F))),ee={},H=this.expandSearchPathPatterns(L.searchPaths||[]);H&&H.length&&(ee.searchPaths=H);const x=E.flatten(B),$=t(...x);return $&&(ee.pattern=$),ee}getExcludesForFolder(w,d){return d.disregardExcludeSettings?void 0:(0,c.getExcludes)(w,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const d=E.flatten(w.map(I=>{let{pathPortion:L,globPortion:B}=s(I);B&&(B=l(B));const ee=this.expandOneSearchPath(L);return E.flatten(ee.map(H=>this.resolveOneSearchPathPattern(H,B)))})),f=new Map;return d.forEach(I=>{const L=I.searchPath.toString(),B=f.get(L);B?I.pattern&&(B.pattern=B.pattern||{},B.pattern[I.pattern]=!0):f.set(L,{searchPath:I.searchPath,pattern:I.pattern?t(I.pattern):void 0})}),Array.from(f.values())}expandOneSearchPath(w){if(D.isAbsolute(w)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==A.Schemas.file?[{searchPath:d[0].uri.with({path:w})}]:[{searchPath:b.URI.file(D.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=r(w),w.startsWith("../")||w===".."){const I=D.posix.resolve(d.path,w);return[{searchPath:d.with({path:I})}]}const f=l(w);return[{searchPath:d,pattern:f}]}else{if(w==="./"||w===".\\")return[];{const d=w.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(d){const f=d[1],I=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===f);if(I.length)return I.map(L=>{const B=d[2];return{searchPath:L.uri,pattern:B&&l(B)}});{const L=a.localize(0,null,f);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(w,d){const f=w.pattern&&d?`${w.pattern}/${d}`:w.pattern||d,I=[{searchPath:w.searchPath,pattern:f}];return f&&!f.endsWith("**")&&I.push({searchPath:w.searchPath,pattern:f+"/**"}),I}getFolderQueryForSearchPath(w,d,f){const I=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(w.searchPath),d,f,!1);return I?Object.assign(Object.assign({},I),{includePattern:w.pattern}):null}getFolderQueryForRoot(w,d,f,I){let L;const B=b.URI.isUri(w)?w:w.uri;if(f.searchPaths){const F=f.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,B))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const ee=this.configurationService.getValue({resource:B}),H=this.getExcludesForFolder(ee,d),x=Object.assign(Object.assign({},H||{}),L||{}),$=b.URI.isUri(w)?(0,n.basename)(w):w.name;return{folder:B,folderName:I?$:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!ee.search.followSymlinks}}};u=je([Ue(0,p.IConfigurationService),Ue(1,S.IWorkspaceContextService),Ue(2,v.IEditorGroupsService),Ue(3,_.IPathService)],u),e.QueryBuilder=u;function s(g){const w=g.match(/[\*\{\}\(\)\[\]\?]/);if(w){const d=w.index,f=g.substr(0,d).match(/[/|\\][^/\\]*$/);if(f){let I=g.substr(0,f.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:g.substr((f.index||0)+1)}}}return{pathPortion:g}}function t(...g){return g.length?g.reduce((w,d)=>(w[d]=!0,w),Object.create(null)):void 0}function i(g){return R.splitGlobAware(g,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(g){return[`**/${g}/**`,`**/${g}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function r(g){return g.replace(/\\/g,"/")}function l(g){return r(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(g,w){g=E.distinct(g,I=>I.toString());const d=[],f=w.getWorkspace();return g&&g.forEach(I=>{let L;if(w.getWorkbenchState()===2)L=(0,n.relativePath)(f.folders[0].uri,I),L&&L!=="."&&(L="./"+L);else{const B=w.getWorkspaceFolder(I);if(B){const ee=B.name;if(f.folders.filter(x=>x.name===ee).length===1){const x=(0,n.relativePath)(B.uri,I);x===""?L=`./${B.name}`:L=`./${B.name}/${x}`}else L=I.fsPath}}L&&d.push(L)}),d}e.resolveResourcesForSearchIncludes=h}),define(pe[257],ve([0,1,24,2,21,16,4,256,32,59]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(p,S){const v=S.activationEvents;if(!v)return Promise.resolve(void 0);const _=[],c=[];for(const r of v)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||p.forceUsingSearch?c.push(l):_.push(l)}if(_.length===0&&c.length===0)return Promise.resolve(void 0);let u;const s=new Promise((r,l)=>{u=r}),t=r=>u({activationEvent:r}),i=Promise.all(_.map(r=>b(p,r,t))).then(()=>{}),o=m(p,S.identifier,c,t);return Promise.all([i,o]).then(()=>{u(void 0)}),s}e.checkActivateWorkspaceContainsExtension=k;async function b(p,S,v){for(const _ of p.folders)if(await p.exists(E.joinPath(y.URI.revive(_),S))){v(`workspaceContains:${S}`);return}}async function m(p,S,v,_){if(v.length===0)return Promise.resolve(void 0);const c=new R.CancellationTokenSource,u=p.checkExists(p.folders,v,c.token),s=setTimeout(async()=>{c.cancel(),_(`workspaceContainsTimeout:${v.join(",")}`)},T);let t=!1;try{t=await u}catch(i){P.isPromiseCanceledError(i)||P.onUnexpectedError(i)}c.dispose(),clearTimeout(s),t&&_(`workspaceContains:${v.join(",")}`)}function a(p,S,v,_){const c=p.get(C.IInstantiationService),u=p.get(D.ISearchService),t=c.createInstance(A.QueryBuilder).file(S.map(i=>(0,n.toWorkspaceFolder)(y.URI.revive(i))),{_reason:"checkExists",includePattern:v,exists:!0});return u.fileSearch(t,_).then(i=>!!i.limitHit,i=>P.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(Z,e,E){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,E),E},Be=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(pe[42],ve([0,1,160,8,66,24,17,6,23,2,12,5,36,221,88,33,41,219,16,29,11,25,193,7,113,4,27,89,13,81,50,35,3,257,86,194]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c,u,s,t,i,o,r,l,h,g,w,d,f,I,L,B,ee){"use strict";var H,x,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class On extends A.Disposable{constructor(O,V,q,Q,me,we,Ae,Ie,Me,z){super();this._onDidChangeRemoteConnectionData=this._register(new I.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Ae,this._extHostWorkspace=Q,this._extHostConfiguration=me,this._logService=we,this._extHostTunnelService=Me,this._extHostTerminalService=z,this._disposables=new A.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=O.createChild(new w.ServiceCollection([a.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const J=new Set;this._initData.hostExtensions.forEach(te=>J.add(c.ExtensionIdentifier.toKey(te))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(J.has(c.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new m.HostExtension;const fe=this._registry.getExtensionDescription(te);return this._activateExtension(fe,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){_.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(me=>me.identifier).filter(me=>this.isActivated(me)).map(me=>this._deactivate(me))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=D.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(Q=>O.set(n.URI.file(Q).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,Q=>Promise.resolve(void 0)))}catch(Q){}try{(0,A.dispose)(q.subscriptions)}catch(Q){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const Q=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",Q),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,Q){const me=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},me),Q||{}),{outcome:q}))}_doActivateExtension(O,V){const q=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const Q=this._getEntryPoint(O);if(!Q)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const me=new m.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,P.joinPath)(O.extensionLocation,Q),me),this._loadExtensionContext(O)]).then(we=>(R.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),On._callActivate(this._logService,O.identifier,we[0],we[1],me))).then(we=>(R.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),we))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),Q=new ee.ExtensionSecrets(O,this._secretState),me=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,we=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let Ie;return Object.freeze({globalState:V,workspaceState:q,secrets:Q,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Me){return y.join(O.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Ae._storagePath.workspaceValue(O))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(O).fsPath},get logPath(){return y.join(Ae._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(Ae._initData.logsLocation,O.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(O)},get globalStorageUri(){return Ae._storagePath.globalValue(O)},get extensionMode(){return me},get extension(){return Ie===void 0&&(Ie=new M(Ae,O.identifier,O,we)),Ie},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,Q,me){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,Q,me).then(we=>new m.ActivatedExtension(!1,null,me.build(),q,we,Q.subscriptions))}static _callActivateOptional(O,V,q,Q,me){if(typeof q.activate=="function")try{me.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const we=typeof global=="object"?global:self,Ae=q.activate.apply(we,[Q]);return me.activateCallStop(),me.activateResolveStart(),Promise.resolve(Ae).then(Ie=>(me.activateResolveStop(),Ie))}catch(we){return Promise.reject(we)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),Q=Promise.all([O,q]).then(()=>{});return Promise.race([Q,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={folders:O.map(we=>we.uri),forceUsingSearch:q,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Ae,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(we,Ae,Ie)},me=await(0,L.checkActivateWorkspaceContainsExtension)(Q,V);if(!!me)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:me.activationEvent}).then(void 0,we=>this._logService.error(we))}}async $extensionTestsExecute(){await this._readyToRunExtensions.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==u.Schemas.file)throw new Error(E.localize(0,null));const q=(0,P.originalFSPath)(V),Q=await this._loadCommonJSModule(null,V,new m.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(E.localize(1,null,q));return new Promise((me,we)=>{const Ae=(Me,z)=>{Me?we(Me):me(typeof z=="number"&&z>0?1:0)},Ie=Q.run(q,Ae);Ie&&Ie.then&&Ie.then(()=>{me(0)}).catch(Me=>{we(Me.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,A.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const Q=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1);const me=this._resolvers[Q];if(!me)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${Q}`);const we=await me.resolve(O,{resolveAttempt:V});R.mark(`code/extHost/didResolveAuthorityOK/${Q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(me));const Ae={authority:O,host:we.host,port:we.port,connectionToken:we.connectionToken},Ie={extensionHostEnv:we.extensionHostEnv};return{type:"ok",value:{authority:Ae,options:Ie,tunnelInformation:{environmentTunnels:we.environmentTunnels}}}}catch(we){if(R.mark(`code/extHost/didResolveAuthorityError/${Q}`),we instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(Q=>Q.extensionLocation=n.URI.revive(Q.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async Q=>{const me=this._registry.getExtensionDescription(Q);if(!!me){const we=await this._hostUtils.realpath(me.extensionLocation.fsPath);q.delete(n.URI.file(we).fsPath)}})),await Promise.all(O.map(async Q=>{const me=await this._hostUtils.realpath(Q.extensionLocation.fsPath);q.set(n.URI.file(me).fsPath,Q)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=s.VSBuffer.alloc(O),q=Math.random()%256;for(let Q=0;Q<O;Q++)V.writeUInt8(q,Q);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([Ue(0,r.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,g.IExtHostRpcService),Ue(3,p.IExtHostWorkspace),Ue(4,b.IExtHostConfiguration),Ue(5,T.ILogService),Ue(6,l.IExtHostInitDataService),Ue(7,h.IExtensionStoragePaths),Ue(8,d.IExtHostTunnelService),Ue(9,f.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,V,q,Q){H.set(this,void 0),x.set(this,void 0),$.set(this,void 0),tt(this,H,O),tt(this,x,V),tt(this,$,q.identifier),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=y.normalize((0,P.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=Q}get isActive(){return Be(this,H).isActivated(Be(this,$))}get exports(){if(this.packageJSON.api!=="none")return Be(this,H).getExtensionExports(Be(this,$))}activate(){return Be(this,H).activateByIdWithErrors(Be(this,$),{startup:!1,extensionId:Be(this,x),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,H=new WeakMap,x=new WeakMap,$=new WeakMap}),define(pe[45],ve([0,1,8,2,3,17,5,7,119,33,42,39,209,36,200,13,4,15,30]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let c=class{constructor(h,g,w,d,f){this._workspaceService=g,this._extensionService=w,this._editorsService=d,this._configurationService=f,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=h.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(I=>{I.onDidChange(L=>{this.registerAllDebugTypes(I)}),this.registerAllDebugTypes(I)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,g){const w=h;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let d=`debug:${encodeURIComponent(w.path||"")}`,f="?";return g&&(d+=`${f}session=${encodeURIComponent(g.id)}`,f="&"),d+=`${f}ref=${w.sourceReference}`,y.URI.parse(d)}else{if(w.path)return y.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const g=[];for(const w of h.getAllExtensionDescriptions())if(w.contributes){const d=w.contributes.debuggers;if(d&&d.length>0)for(const f of d)(0,a.isDebuggerMainContribution)(f)&&g.push(f.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(g=>h.push(g)),h}addBreakpoints(h){this.startBreakpoints();const g=h.filter(f=>{const I=f.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,f),!0)});this.fireBreakpointChanges(g,[],[]);const w=[],d=new Map;for(const f of g)if(f instanceof A.SourceBreakpoint){let I=d.get(f.location.uri.toString());I||(I={type:"sourceMulti",uri:f.location.uri,lines:[]},d.set(f.location.uri.toString(),I),w.push(I)),I.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.FunctionBreakpoint&&w.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this._debugServiceProxy.$registerBreakpoints(w)}removeBreakpoints(h){this.startBreakpoints();const g=h.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],g,[]);const w=g.filter(I=>I instanceof A.SourceBreakpoint).map(I=>I.id),d=g.filter(I=>I instanceof A.FunctionBreakpoint).map(I=>I.id),f=g.filter(I=>I instanceof A.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(w,d,f)}startDebugging(h,g,w){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,g,{parentSessionID:w.parentSession?w.parentSession.id:void 0,repl:w.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,g,w){if(!g)return new A.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:d,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,w,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,d),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(f=>f.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(h,g,w){if(!w)return new A.Disposable(()=>{});if(!this.definesDebugType(h,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:d,factory:w}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,d),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(f=>f.factory!==w),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(h,g){if(!g)return new A.Disposable(()=>{});const w=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:w,factory:g}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==g)})}async $runInTerminal(h,g){return Promise.resolve(void 0)}async $substituteVariables(h,g){if(!this._variableResolver){const[f,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(f||[],this._editorsService,I)}let w;const d=await this.getFolder(h);return d&&(w={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(w,g)}createDebugAdapter(h,g){if(h.type==="implementation")return new o(h.implementation)}createSignService(){}async $startDASession(h,g){const w=this,d=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const I=this.convertToDto(f),L=this.createDebugAdapter(I,d);if(!L)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const B=L;return this._debugAdapters.set(h,B),this.getDebugAdapterTrackers(d).then(ee=>(ee&&this._debugAdaptersTrackers.set(h,ee),B.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const x=H,$={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(x.arguments.value);$.body={signature:F},B.sendResponse($)}else throw new Error("no signer")}catch(F){$.success=!1,$.message=F.message,B.sendResponse($)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(H),H=(0,a.convertToVSCPaths)(H,!0),w._debugServiceProxy.$acceptDAMessage(h,H)}),B.onError(H=>{ee&&ee.onError&&ee.onError(H),this._debugServiceProxy.$acceptDAError(h,H.name,H.message,H.stack)}),B.onExit(H=>{ee&&ee.onExit&&ee.onExit((0,v.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,v.withNullAsUndefined)(H),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),B.startSession()))})}$sendDAMessage(h,g){g=(0,a.convertToDAPaths)(g,!1);const w=this._debugAdaptersTrackers.get(h);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(g);const d=this._debugAdapters.get(h);d&&d.sendMessage(g)}$stopDASession(h){const g=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),g&&g.onWillStopSession&&g.onWillStopSession();const w=this._debugAdapters.get(h);return this._debugAdapters.delete(h),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const g=[],w=[],d=[];if(h.added)for(const f of h.added){const I=f.id;if(I&&!this._breakpoints.has(I)){let L;if(f.type==="function")L=new A.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const B=y.URI.revive(f.uri);L=new A.SourceBreakpoint(new A.Location(B,new A.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}L._id=I,this._breakpoints.set(I,L),g.push(L)}}if(h.removed)for(const f of h.removed){const I=this._breakpoints.get(f);I&&(this._breakpoints.delete(f),w.push(I))}if(h.changed){for(const f of h.changed)if(f.id){const I=this._breakpoints.get(f.id);if(I){if(I instanceof A.FunctionBreakpoint&&f.type==="function"){const L=I;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(I instanceof A.SourceBreakpoint&&f.type==="source"){const L=I;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.Location(y.URI.revive(f.uri),new A.Position(f.line,f.character))}d.push(I)}}}this.fireBreakpointChanges(g,w,d)}$provideDebugConfigurations(h,g,w){return(0,P.asPromise)(async()=>{const d=this.getConfigProviderByHandle(h);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.getFolder(g);return d.provideDebugConfigurations(f,w)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(h,g,w,d){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(g);return f.resolveDebugConfiguration(I,w,d)})}$resolveDebugConfigurationWithSubstitutedVariables(h,g,w,d){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(g);return f.resolveDebugConfigurationWithSubstitutedVariables(I,w,d)})}async $provideDebugAdapter(h,g){const w=this.getAdapterDescriptorFactoryByHandle(h);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(g);return this.getAdapterDescriptor(w,d).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(f)})}async $acceptDebugSessionStarted(h){const g=await this.getSession(h);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(h){const g=await this.getSession(h);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,g){const w=await this.getSession(h);w&&w._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(h,g){const d={session:await this.getSession(h),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(h){if(h instanceof A.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof A.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const g=this._adapterFactories.filter(w=>w.type===h);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(h){const g=this._adapterFactories.filter(w=>w.handle===h);if(g.length>0)return g[0].factory}getConfigProviderByHandle(h){const g=this._configProviders.filter(w=>w.handle===h);if(g.length>0)return g[0].provider}definesDebugType(h,g){if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0){for(const d of w)if(d.label&&d.type&&d.type===g)return!0}}return!1}getDebugAdapterTrackers(h){const w=h.configuration.type,d=this._trackerFactories.filter(f=>f.type===w||f.type==="*").map(f=>(0,P.asPromise)(()=>f.factory.createDebugAdapterTracker(h)).then(I=>I,I=>null));return Promise.race([Promise.all(d).then(f=>{const I=f.filter(L=>!!L);if(I.length>0)return new i(I)}),new Promise((f,I)=>{const L=setTimeout(()=>{clearTimeout(L),I(new Error("timeout"))},1e3)})]).catch(f=>{})}async getAdapterDescriptor(h,g){const w=g.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new A.DebugAdapterServer(w));if(h){const f=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>h.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,f))).then(I=>{if(I)return I})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,d))}daExecutableFromPackage(h,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,g,w){(h.length>0||g.length>0||w.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:g,changed:w}))}async getSession(h){if(h)if(typeof h=="string"){const g=this._debugSessions.get(h);if(g)return g}else{let g=this._debugSessions.get(h.id);if(!g){const w=await this.getFolder(h.folderUri);g=new u(this._debugServiceProxy,h.id,h.type,h.name,w,h.configuration),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(h){if(h){const g=y.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};c=je([Ue(0,p.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,m.IExtHostConfiguration)],c),e.ExtHostDebugServiceBase=c;class u{constructor(h,g,w,d,f,I){this._debugServiceProxy=h,this._id=g,this._type=w,this._name=d,this._workspaceFolder=f,this._configuration=I}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,g)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=u;class s{constructor(h){this.value=Object.freeze({append(g){h.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=s;class t extends b.AbstractVariableResolverService{constructor(h,g,w,d){super({getFolderUri:f=>{const I=h.filter(L=>L.name===f);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(f,I)=>w.getConfiguration(void 0,f).get(I),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(g){const f=g.activeEditor();if(f)return E.normalize(f.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(g&&d){const f=g.activeEditor();if(f){const I=d.getWorkspaceFolder(f.document.uri);if(I)return E.normalize(I.uri.fsPath)}}},getSelectedText:()=>{if(g){const f=g.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(g){const f=g.activeEditor();if(f)return String(f.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=t;class i{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(g=>g.onError?g.onError(h):void 0)}onExit(h,g){this.trackers.forEach(w=>w.onExit?w.onExit(h,g):void 0)}}class o extends D.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(h,g,w,d,f){super(h,g,w,d,f)}createVariableResolver(h,g,w){return new t(h,g,w)}};r=je([Ue(0,p.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,T.IExtHostExtensionService),Ue(3,k.IExtHostDocumentsAndEditors),Ue(4,m.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(pe[258],ve([0,1,66,2,5,36,41,29,13,27,4,42,30,12]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(c,u,s,t,i,o,r){this._apiFactory=c,this._extensionRegistry=u,this._instaService=s,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=o,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,u,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,u,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let u of c.nodeModuleName)this._factories.set(u,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(u=>c.alternativeModuleName(u))}};a=je([Ue(2,T.IInstantiationService),Ue(3,P.IExtHostConfiguration),Ue(4,k.IExtHostExtensionService),Ue(5,n.IExtHostInitDataService),Ue(6,m.ILogService)],a),e.RequireInterceptor=a;class p{constructor(c,u,s,t,i){this._apiFactory=c,this._extensionPaths=u,this._extensionRegistry=s,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,u){const s=this._extensionPaths.findSubstr(u.fsPath);if(s){let t=this._extApiImpl.get(A.ExtensionIdentifier.toKey(s.identifier));return t||(t=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(s.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,o)=>t+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(c,u){this.nodeModuleName="keytar";const{environment:s}=u,t=c.getProxy(R.MainContext.MainThreadKeytar);if(s.appRoot){let i=s.appRoot.fsPath;b.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,o)=>t.$getPassword(i,o),setPassword:(i,o,r)=>t.$setPassword(i,o,r),deletePassword:(i,o)=>t.$deletePassword(i,o),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(c,u){return this._impl}alternativeModuleName(c){const u=c.length;if(!(u<=7||!this.alternativeNames)){const s=u-7;if((c.charAt(s)==="/"||c.charAt(s)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}}};S=je([Ue(0,D.IExtHostRpcService),Ue(1,n.IExtHostInitDataService)],S);let v=class{constructor(c,u,s){this._extensionPaths=c,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(R.MainContext.MainThreadTelemetry);const t=s.getProxy(R.MainContext.MainThreadWindow);this._impl=(i,o)=>{const r=y.URI.parse(i);return o?this.callOriginal(i,o):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,o)}}load(c,u,s){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=s(c),this._impl}callOriginal(c,u){return this.sendNoForwardTelemetry(),this._original(c,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Ue(2,D.IExtHostRpcService)],v)}),define(pe[259],ve([0,1,166,9,7,201,33,42,39,36,35,13,45,186,204,17]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends b.ExtHostDebugServiceBase{constructor(c,u,s,t,i,o){super(c,u,s,t,i);this._terminalService=o,this._integratedTerminalInstances=new v}createDebugAdapter(c,u){switch(c.type){case"server":return new P.SocketDebugAdapter(c);case"pipeServer":return new P.NamedPipeDebugAdapter(c);case"executable":return new P.ExecutableDebugAdapter(c,u.type)}return super.createDebugAdapter(c,u)}daExecutableFromPackage(c,u){const s=P.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),c.type);if(s)return new R.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new m.SignService}async $runInTerminal(c,u){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(f=>{this._integratedTerminalInstances.onTerminalClosed(f)}));const s=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,s),i=this._terminalService.getDefaultShellArgs(!0,s),o=JSON.stringify({shell:t,shellArgs:i});let r=await this._integratedTerminalInstances.checkout(o),l,h=!1;if(r)l=c.cwd;else{const f={shellPath:t,shellArgs:i,cwd:c.cwd,name:c.title||E.localize(0,null)};h=!0,r=this._terminalService.createTerminalFromOptions(f,!0),this._integratedTerminalInstances.insert(r,o)}r.show(!0);const g=await r.processId;h?await new Promise(f=>setTimeout(f,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):y.isWindows?r.sendText("cls"):r.sendText("clear"));const w=(0,a.prepareCommand)(t,c.args,l,c.env);r.sendText(w);const d=this.onDidTerminateDebugSession(f=>{f.id===u&&(this._integratedTerminalInstances.free(r),d.dispose())});return g}else if(c.kind==="external")return(0,a.runInExternalTerminal)(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,u)}createVariableResolver(c,u,s){return new b.ExtHostVariableResolverService(c,u,s,this._workspaceService)}};S=je([Ue(0,k.IExtHostRpcService),Ue(1,C.IExtHostWorkspace),Ue(2,A.IExtHostExtensionService),Ue(3,D.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,T.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class v{constructor(){this._terminalInstances=new Map}async checkout(c){const s=[...this._terminalInstances.entries()].map(([t,i])=>(0,p.createCancelablePromise)(async o=>{if(i.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const r=Date.now();return i.lastUsedAt+v.minUseDelay>r||o.isCancellationRequested||i.config!==c?null:(i.lastUsedAt=r,t)}));return await(0,p.firstParallel)(s,t=>!!t)}insert(c,u){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:u})}free(c){const u=this._terminalInstances.get(c);u&&(u.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}v.minUseDelay=1e3}),define(pe[260],ve([0,1,8,2,77,33,45,39,36,35,13,27,65,11,12,62]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends b.ExtHostTaskBase{constructor(_,c,u,s,t,i,o,r){super(_,c,u,s,t,i,o,r);this.workspaceService=u,c.remote.isRemote&&c.remote.authority&&this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,c){const u=c;if(!c.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=b.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(s);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(t,c);return this._proxy.$executeTask(s).catch(()=>{}),i}else{const s=b.TaskDTO.from(c,_);if(s===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,c,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),c);return this._proxy.$executeTask(s).catch(()=>{}),t}}provideTasksInternal(_,c,u,s){const t=[];if(s)for(let i of s){this.checkDeprecation(i,u),(!i.definition||!_[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const o=b.TaskDTO.from(i,u.extension);o&&(t.push(o),b.CustomExecutionDTO.is(o.execution)&&c.push(this.addCustomExecution(o,i,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(_){return _}async getVariableResolver(_){if(this._variableResolver===void 0){const c=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(_,this._editorService,c,this.workspaceService)}return this._variableResolver}async $resolveVariables(_,c){const u=y.URI.revive(_),s={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(i),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let l of c.variables)s.variables[l]=o.resolve(r,l);if(c.process!==void 0){let l;if(c.process.path!==void 0){l=c.process.path.split(E.delimiter);for(let h=0;h<l.length;h++)l[h]=o.resolve(r,l[h])}s.process=await R.win32.findExecutable(o.resolve(r,c.process.name),c.process.cwd!==void 0?o.resolve(r,c.process.cwd):void 0,l)}return s}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(_,c,u){return R.win32.findExecutable(_,c,u)}};S=je([Ue(0,T.IExtHostRpcService),Ue(1,k.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,A.IExtHostDocumentsAndEditors),Ue(4,D.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,a.ILogService),Ue(7,p.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(pe[261],ve([0,1,9,15,28,148,12,36,45,39,13,35,33,207,208]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let p=class extends k.BaseExtHostTerminalService{constructor(v,_,c,u,s){super(!0,v);this._extHostConfiguration=_,this._extHostWorkspace=c,this._extHostDocumentsAndEditors=u,this._logService=s,this._isWorkspaceShellAllowed=!1,(0,P.getSystemShell)(E.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._updateVariableResolver(),this._registerListeners()}createTerminal(v,_,c){const u=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:v,shellPath:_,shellArgs:c},v);return this._terminals.push(u),u.create(_,c),u.value}createTerminalFromOptions(v,_){const c=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),v,v.name);return this._terminals.push(c),c.create((0,y.withNullAsUndefined)(v.shellPath),(0,y.withNullAsUndefined)(v.shellArgs),(0,y.withNullAsUndefined)(v.cwd),(0,y.withNullAsUndefined)(v.env),void 0,(0,y.withNullAsUndefined)(v.strictEnv),(0,y.withNullAsUndefined)(v.hideFromUser),(0,y.withNullAsUndefined)(_),!0),c.value}getDefaultShell(v,_){var c;const u=s=>{const t=_.getConfiguration(s.substr(0,s.lastIndexOf("."))).inspect(s.substr(s.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return m.getDefaultShell(u,this._isWorkspaceShellAllowed,(c=this._defaultShell)!==null&&c!==void 0?c:(0,P.getSystemShellSync)(E.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,_){const c=u=>{const s=_.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(s)};return m.getDefaultShellArgs(c,this._isWorkspaceShellAllowed,v,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(v){return{userValue:v?v.globalValue:void 0,value:v?v.workspaceValue:void 0,defaultValue:v?v.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>this._updateVariableResolver())}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),_=await this._extHostWorkspace.getWorkspaceFolders2();this._variableResolver=new D.ExtHostVariableResolverService(_||[],this._extHostDocumentsAndEditors,v)}async $getAvailableProfiles(v){const _=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(v,this._logService,_,this._variableResolver,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const _=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,_),args:this.getDefaultShellArgs(v,_)}}$acceptWorkspacePermissionsChanged(v){this._isWorkspaceShellAllowed=v}};p=je([Ue(0,T.IExtHostRpcService),Ue(1,A.IExtHostConfiguration),Ue(2,b.IExtHostWorkspace),Ue(3,n.IExtHostDocumentsAndEditors),Ue(4,C.ILogService)],p),e.ExtHostTerminalService=p}),define(pe[262],ve([0,1,17,16,66,6,2,5,252,12,78,81,27,182,13,61,42,35]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(u,s,t,i){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new D.RPCProtocol(u,null,i);s=_._transform(s,o);const r=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());r.set(b.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},s)),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(o)),r.set(p.IURITransformerService,new p.URITransformerService(i)),r.set(S.IHostUtils,t);const l=new m.InstantiationService(r,!0),h=l.invokeFunction(f=>f.get(v.IExtHostTerminalService));this._disposables.add(h),this._logService=l.invokeFunction(f=>f.get(n.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",s),this._extensionService=l.invokeFunction(f=>f.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(I,L)=>{let B="",ee,H;for(const x of L)B+=`
	at ${x.toString()}`,H=x.getFileName(),!ee&&H&&(ee=f.findSubstr(H));return g.set(I,ee),`${I.name||"Error"}: ${I.message||""}${B}`}});const w=o.getProxy(A.MainContext.MainThreadExtensionService),d=o.getProxy(A.MainContext.MainThreadErrors);y.setUnexpectedErrorHandler(f=>{const I=y.transformErrorForSerialization(f),L=g.get(f);L?w.$onExtensionRuntimeError(L.identifier,I):d.$onUnexpectedError(I)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),y.setUnexpectedErrorHandler(t=>{});const s=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),s]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,s){u.extensions.forEach(i=>i.extensionLocation=C.URI.revive(s.transformIncomingURIs(i.extensionLocation))),u.environment.appRoot=C.URI.revive(s.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(i=>C.URI.revive(s.transformIncomingURIs(i)))),u.environment.extensionTestsLocationURI=C.URI.revive(s.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=C.URI.revive(s.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=C.URI.revive(s.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=C.URI.revive(s.transformIncomingURIs(u.logsLocation)),u.logFile=C.URI.revive(s.transformIncomingURIs(u.logFile)),u.workspace=s.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=_}),define(pe[263],ve([0,1,8,21,58,34,24,46,32,30]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(m,a,p){this.config=m,this.provider=a,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&P.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&P.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const a=this.config.folderQueries||[];return new Promise((p,S)=>{const v=_=>{this.resultCount++,m(_)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(_=>{const c=_.toString(),u=E.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,u)||this.matchFile(v,{base:_,basename:u})}),Promise.all(a.map(_=>this.searchInFolder(_,v))).then(_=>{p({limitHit:this.isLimitHit,stats:_[0]||void 0})},_=>{S(new Error((0,R.toErrorMessage)(_)))})})}searchInFolder(m,a){const p=new y.CancellationTokenSource;return new Promise((S,v)=>{const _=this.getSearchOptionsForFolder(m),c=this.initDirectoryTree(),u=new D.QueryGlobTester(this.config,m),s=!u.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(p),t=A.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},_,p.token))).then(i=>{const o=t.elapsed(),r=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(l=>{const h=E.posix.relative(m.folder.path,l.path);if(s){const g=E.basename(l.path);this.matchFile(a,{base:m.folder,relativePath:h,basename:g});return}this.addDirectoryEntries(c,m.folder,h,a)}),this.activeCancellationTokens.delete(p),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,u,a),{providerTime:o,postProcessTime:r.elapsed()})}).then(i=>{p.dispose(),S(i)},i=>{p.dispose(),v(i)})})}getSearchOptionsForFolder(m){const a=(0,D.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),p=(0,D.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:p,includes:a,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},a,p,S){if(p===this.filePattern){const _=E.basename(this.filePattern);this.matchFile(S,{base:a,relativePath:this.filePattern,basename:_})}function v(_){const c=E.basename(_),u=E.dirname(_);let s=m[u];s||(s=m[u]=[],v(u)),s.push({base:a,relativePath:_,basename:c})}v(p)}matchDirectoryTree({rootEntries:m,pathToEntries:a},p,S){const v=this,_=this.filePattern;function c(u){const s=P.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,i=u.length;t<i;t++){const o=u[t],{relativePath:r,basename:l}=o;if(!!p.includedInQuerySync(r,l,_!==l?s:void 0)){const h=a[r];if(h)c(h);else{if(r===_)continue;v.matchFile(S,o)}if(v.isLimitHit)break}}}c(m)}matchFile(m,a){(!this.includePattern||a.relativePath&&this.includePattern(a.relativePath,a.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(a))}}class k{constructor(){this.sessions=new Map}fileSearch(m,a,p,S){const v=this.getSessionTokenSource(m.cacheKey),_=new T(m,a,v&&v.token);let c=0;const u=s=>{c+=s.length,p(s.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(_,k.BATCH_SIZE,u,S).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:s.stats}}))}clearCache(m){const a=this.getSessionTokenSource(m);a&&a.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new y.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:C.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,a,p,S){S.onCancellationRequested(()=>{m.cancel()});const v=c=>{c&&(_.push(c),a>0&&_.length>=a&&(p(_),_=[]))};let _=[];return m.search(v).then(c=>(_.length&&p(_),c),c=>(_.length&&p(_),Promise.reject(c)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(pe[126],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class E{constructor(P,C){this.line=P,this.character=C}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,C){return new E(0,0)}with(P){return new E(0,0)}}e.Position=E;class y{constructor(P,C,A,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(P,C),this.end=new E(A,D)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new y(0,0,0,0)}with(P){return new y(0,0,0,0)}}e.Range=y}),define(pe[127],ve([0,1,8,14,21,58,24,34,2,32,30,11]),function(Z,e,E,y,R,P,C,A,D,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(c,u,s){this.query=c,this.provider=u,this.fileUtils=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,u){const s=this.query.folderQueries||[],t=new R.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((i,o)=>{this.collector=new a(c);let r=!1;const l=(h,g)=>{if(!r&&!this.isLimitHit){const w=this.resultSize(h);S(h)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const d=this.resultSize(h);this.resultCount+=d,(d>0||!S(h))&&this.collector.add(h,g)}};Promise.all(s.map((h,g)=>this.searchInFolder(h,w=>l(w,g),t.token))).then(h=>{t.dispose(),this.collector.flush();const g=h.some(w=>!!w&&!!w.limitHit);i({limitHit:this.isLimitHit||g,stats:{type:"textSearchProvider"}})},h=>{t.dispose();const g=(0,P.toErrorMessage)(h);o(new Error(g))})})}resultSize(c){return S(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,u){const s=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:s.slice(0,u),preview:{matches:t.slice(0,u),text:c.preview.text},uri:c.uri}}searchInFolder(c,u,s){const t=new n.QueryGlobTester(this.query,c),i=[],o={report:l=>{if(!!this.validateProviderResult(l)){const h=c.folder.scheme===k.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(l.uri))):void 0,g=C.relativePath(c.folder,l.uri);g&&i.push(t.includedInQuery(g,E.basename(g),h).then(w=>{w&&u(l)}))}}},r=this.getSearchOptionsForFolder(c);return new Promise(l=>(0,T.nextTick)(l)).then(()=>this.provider.provideTextSearchResults(m(this.query.contentPattern),r,o,s)).then(l=>Promise.all(i).then(()=>l))}validateProviderResult(c){if(S(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const u=(0,n.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),s=(0,n.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:D.URI.from(c.folder),excludes:s,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=b;function m(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class a{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,u=>this.sendItems(u))}add(c,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!C.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(p(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=a;function p(_){return S(_)?{preview:{matches:(0,y.mapArrayOrNot)(_.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:_.preview.text},ranges:(0,y.mapArrayOrNot)(_.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function S(_){return!!_.preview}e.extensionResultIsMatch=S;class v{constructor(c,u){this.maxBatchSize=c,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,u){!c||this.addItemToBatch(c,u)}addItems(c,u){!c||this.addItemsToBatch(c,u)}addItemToBatch(c,u){this.batch.push(c),this.batchSize+=u,this.onUpdate()}addItemsToBatch(c,u){this.batch=this.batch.concat(c),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(pe[67],ve([0,1,6,5,4,263,13,61,12,2,127]),function(Z,e,E,y,R,P,C,A,D,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,R.createDecorator)("IExtHostSearch");let k=class{constructor(p,S,v){this.extHostRpc=p,this._uriTransformer=S,this._logService=v,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,S){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const v=this._handlePool++;return this._textSearchProvider.set(v,S),this._proxy.$registerTextSearchProvider(v,this._transformScheme(p)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(p,S){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const v=this._handlePool++;return this._fileSearchProvider.set(v,S),this._proxy.$registerFileSearchProvider(v,this._transformScheme(p)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(p,S,v,_){const c=b(v),u=this._fileSearchProvider.get(p);if(u)return this._fileSearchManager.fileSearch(c,u,s=>{this._proxy.$handleFileMatch(p,S,s.map(t=>t.resource))},_);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,S,v,_){const c=this._textSearchProvider.get(p);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const u=b(v);return this.createTextSearchManager(u,c).search(t=>this._proxy.$handleTextMatch(p,S,t),_)}createTextSearchManager(p,S){return new T.TextSearchManager(p,S,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};k=je([Ue(0,C.IExtHostRpcService),Ue(1,A.IURITransformerService),Ue(2,D.ILogService)],k),e.ExtHostSearch=k;function b(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(m),extraFileResources:a.extraFileResources&&a.extraFileResources.map(p=>n.URI.revive(p))})}e.reviveQuery=b;function m(a){return Object.assign(Object.assign({},a),{folder:n.URI.revive(a.folder)})}}),define(pe[264],ve([0,1,157,21,16,3,56,2,150,104,140,76,44,5,227,226,51,228,36,229,230,231,212,232,39,42,233,213,235,236,237,63,216,239,240,241,88,35,242,217,20,7,245,64,125,33,41,53,197,234,114,124,65,45,67,12,61,13,27,238,196,50,62,224,243,195,89,87,248,246,247,225,60,255,244,86,192,117]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c,u,s,t,i,o,r,l,h,g,w,d,f,I,L,B,ee,H,x,$,F,U,M,N,O,V,q,Q,me,we,Ae,Ie,Me,z,J,te,ae,fe,De,Oe,_e,ke,Te,xe,Se,Ke,G,ie,Ee,Ne,ze,We,et,K,se,he,Y,ne,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ge(be){const He=be.get(Oe.IExtHostInitDataService),$e=be.get(K.IExtHostFileSystemInfo),qe=be.get(Ee.IExtHostConsumerFileSystem),Xe=be.get(r.IExtHostExtensionService),Ze=be.get(q.IExtHostWorkspace),ut=be.get(le.IExtHostTelemetry),ot=be.get(_.IExtHostConfiguration),nt=be.get(fe.IURITransformerService),ce=be.get(De.IExtHostRpcService),Ce=be.get(H.IExtHostStorage),ue=be.get(ie.IExtensionStoragePaths),X=be.get(ae.ILogService),Re=be.get(Te.IExtHostTunnelService),Le=be.get(xe.IExtHostApiDeprecationService),Ye=be.get(V.IExtHostWindow),Ge=be.get(Y.IExtHostSecretState);ce.set(m.ExtHostContext.ExtHostFileSystemInfo,$e),ce.set(m.ExtHostContext.ExtHostLogService,X),ce.set(m.ExtHostContext.ExtHostWorkspace,Ze),ce.set(m.ExtHostContext.ExtHostConfiguration,ot),ce.set(m.ExtHostContext.ExtHostExtensionService,Xe),ce.set(m.ExtHostContext.ExtHostStorage,Ce),ce.set(m.ExtHostContext.ExtHostTunnelService,Re),ce.set(m.ExtHostContext.ExtHostWindow,Ye),ce.set(m.ExtHostContext.ExtHostSecretState,Ge),ce.set(m.ExtHostContext.ExtHostTelemetry,ut);const rt=ce.set(m.ExtHostContext.ExtHostDecorations,be.get(Me.IExtHostDecorations)),at=ce.set(m.ExtHostContext.ExtHostDocumentsAndEditors,be.get(o.IExtHostDocumentsAndEditors)),Qe=ce.set(m.ExtHostContext.ExtHostCommands,be.get(S.IExtHostCommands)),ct=ce.set(m.ExtHostContext.ExtHostTerminalService,be.get(x.IExtHostTerminalService)),st=ce.set(m.ExtHostContext.ExtHostDebugService,be.get(J.IExtHostDebugService)),gt=ce.set(m.ExtHostContext.ExtHostSearch,be.get(te.IExtHostSearch)),Et=ce.set(m.ExtHostContext.ExtHostTask,be.get(z.IExtHostTask)),Ct=ce.set(m.ExtHostContext.ExtHostOutputService,be.get(f.IExtHostOutputService)),wt=ce.set(m.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),St=ce.set(m.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(ce)),pt=ce.set(m.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ce,at)),Ft=ce.set(m.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(ce,at,X)),Mt=ce.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(X,pt,ce.getProxy(m.MainContext.MainThreadBulkEdits))),ft=ce.set(m.ExtHostContext.ExtHostNotebook,new _e.ExtHostNotebookController(ce,Qe,at,pt,He.environment,X,ue)),yt=ce.set(m.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ce,at)),jt=ce.set(m.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(ce.getProxy(m.MainContext.MainThreadTreeViews),Qe,X)),Qt=ce.set(m.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(ce.getProxy(m.MainContext.MainThreadEditorInsets),yt,He.environment)),Ot=ce.set(m.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(ce,X)),ht=ce.set(m.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(ce,nt,pt,Qe,Ot,X,Le)),Xt=ce.set(m.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(ce,ht)),It=ce.set(m.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(ce,X,at)),Ut=ce.set(m.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ce,Ze,Qe)),qt=ce.set(m.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(ce,Qe,X)),Jt=ce.set(m.ExtHostContext.ExtHostComments,new v.ExtHostComments(ce,Qe,pt)),sn=ce.set(m.ExtHostContext.ExtHostProgress,new I.ExtHostProgress(ce.getProxy(m.MainContext.MainThreadProgress))),pn=ce.set(m.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(ce)),on=ce.set(m.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(ce)),Nt=ce.set(m.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(ce)),vn=ce.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ce,Qe)),xt=ce.set(m.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ce,He.environment,Ze,X,Le)),Wt=ce.set(m.ExtHostContext.ExtHostWebviewPanels,new We.ExtHostWebviewPanels(ce,xt,Ze)),wn=ce.set(m.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(ce,pt,ue,xt,Wt)),_n=ce.set(m.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ce,xt)),Tt=ce.set(m.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(ce,at,Ze)),bn=ce.set(m.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ce)),Kt=(0,me.values)(m.ExtHostContext);ce.assertRegistered(Kt);const En=new et.ExtHostBulkEdits(ce,at),Sn=new p.ExtHostClipboard(ce),$t=new d.ExtHostMessageService(ce,X),an=new u.ExtHostDialogs(ce),ln=new ee.ExtHostStatusBar(ce,Qe.converter),Bt=new w.ExtHostLanguages(ce,pt);return a.ExtHostApiCommands.register(Qe),function(Fe,Yt,Zt){const mt=function(){let re=!Fe.isUnderDevelopment;function de(Pe){re||(X.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Pe(lt){if(Array.isArray(lt))lt.forEach(Pe);else if(typeof lt=="string")de(lt);else{const _t=lt;typeof _t.scheme=="undefined"&&de(lt),!Fe.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Fe)}return lt}}(),yn={getSession(re,de,Pe){return Nt.getSession(Fe,re,de,Pe)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(re,de,Pe,lt){return Nt.registerAuthenticationProvider(re,de,Pe,lt)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Fe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Fe),Nt.providers},logout(re,de){return(0,Q.checkProposedApiEnabled)(Fe),Nt.removeSession(re,de)}},Dn={registerCommand(re,de,Pe){return Qe.registerCommand(!0,re,de,Pe)},registerTextEditorCommand(re,de,Pe){return Qe.registerCommand(!0,re,(...lt)=>{const _t=yt.getActiveTextEditor();if(!_t){X.warn("Cannot execute "+re+" because there is no active text editor.");return}return _t.edit(Dt=>{de.apply(Pe,[_t,Dt,...lt])}).then(Dt=>{Dt||X.warn("Edits from command "+re+" were not applied.")},Dt=>{X.warn("An error occurred while running command "+re,Dt)})})},registerDiffInformationCommand:(re,de,Pe)=>((0,Q.checkProposedApiEnabled)(Fe),Qe.registerCommand(!0,re,async(...lt)=>{const _t=at.activeEditor(!0);if(!_t){X.warn("Cannot execute "+re+" because there is no active text editor.");return}const Dt=await yt.getDiffInformation(_t.id);de.apply(Pe,[Dt,...lt])})),executeCommand(re,...de){return Qe.executeCommand(re,...de)},getCommands(re=!1){return Qe.getCommands(re)}},cn={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var re,de;return(de=(re=He.environment.appRoot)===null||re===void 0?void 0:re.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return ct.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return ut.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ut.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,de){return Ye.openUri(re,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(re){return re.scheme===He.environment.appUriScheme?St.createAppUri(re):Ye.asExternalUri(re,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,Ie.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(cn);const un=He.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Cn={registerTestProvider(re){return(0,Q.checkProposedApiEnabled)(Fe),Tt.registerTestProvider(re)},createDocumentTestObserver(re){return(0,Q.checkProposedApiEnabled)(Fe),Tt.createTextDocumentTestObserver(re)},createWorkspaceTestObserver(re){return(0,Q.checkProposedApiEnabled)(Fe),Tt.createWorkspaceTestObserver(re)},runTests(re){return(0,Q.checkProposedApiEnabled)(Fe),Tt.runTests(re)},publishTestResult(re,de=!0){return(0,Q.checkProposedApiEnabled)(Fe),Tt.publishExtensionProvidedResults(re,de)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Fe),Tt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Fe),Tt.results}},en={getExtension(re){const de=Yt.getExtensionDescription(re);if(de)return new r.Extension(Xe,Fe.identifier,de,un)},get all(){return Yt.getAllExtensionDescriptions().map(re=>new r.Extension(Xe,Fe.identifier,re,un))},get onDidChange(){return Yt.onDidChange}},kn={createDiagnosticCollection(re){return Ot.createDiagnosticCollection(Fe.identifier,re)},get onDidChangeDiagnostics(){return Ot.onDidChangeDiagnostics},getDiagnostics:re=>Ot.getDiagnostics(re),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(re,de){return Bt.changeLanguage(re.uri,de)},match(re,de){return(0,k.score)(U.LanguageSelector.from(re),de.uri,de.languageId,!0)},registerCodeActionsProvider(re,de,Pe){return ht.registerCodeActionProvider(Fe,mt(re),de,Pe)},registerCodeLensProvider(re,de){return ht.registerCodeLensProvider(Fe,mt(re),de)},registerDefinitionProvider(re,de){return ht.registerDefinitionProvider(Fe,mt(re),de)},registerDeclarationProvider(re,de){return ht.registerDeclarationProvider(Fe,mt(re),de)},registerImplementationProvider(re,de){return ht.registerImplementationProvider(Fe,mt(re),de)},registerTypeDefinitionProvider(re,de){return ht.registerTypeDefinitionProvider(Fe,mt(re),de)},registerHoverProvider(re,de){return ht.registerHoverProvider(Fe,mt(re),de,Fe.identifier)},registerEvaluatableExpressionProvider(re,de){return ht.registerEvaluatableExpressionProvider(Fe,mt(re),de,Fe.identifier)},registerInlineValuesProvider(re,de){return ht.registerInlineValuesProvider(Fe,mt(re),de,Fe.identifier)},registerDocumentHighlightProvider(re,de){return ht.registerDocumentHighlightProvider(Fe,mt(re),de)},registerLinkedEditingRangeProvider(re,de){return ht.registerLinkedEditingRangeProvider(Fe,mt(re),de)},registerReferenceProvider(re,de){return ht.registerReferenceProvider(Fe,mt(re),de)},registerRenameProvider(re,de){return ht.registerRenameProvider(Fe,mt(re),de)},registerDocumentSymbolProvider(re,de,Pe){return ht.registerDocumentSymbolProvider(Fe,mt(re),de,Pe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(Fe,re)},registerDocumentFormattingEditProvider(re,de){return ht.registerDocumentFormattingEditProvider(Fe,mt(re),de)},registerDocumentRangeFormattingEditProvider(re,de){return ht.registerDocumentRangeFormattingEditProvider(Fe,mt(re),de)},registerOnTypeFormattingEditProvider(re,de,Pe,...lt){return ht.registerOnTypeFormattingEditProvider(Fe,mt(re),de,[Pe].concat(lt))},registerDocumentSemanticTokensProvider(re,de,Pe){return ht.registerDocumentSemanticTokensProvider(Fe,mt(re),de,Pe)},registerDocumentRangeSemanticTokensProvider(re,de,Pe){return ht.registerDocumentRangeSemanticTokensProvider(Fe,mt(re),de,Pe)},registerSignatureHelpProvider(re,de,Pe,...lt){return typeof Pe=="object"?ht.registerSignatureHelpProvider(Fe,mt(re),de,Pe):ht.registerSignatureHelpProvider(Fe,mt(re),de,typeof Pe=="undefined"?[]:[Pe,...lt])},registerCompletionItemProvider(re,de,...Pe){return ht.registerCompletionItemProvider(Fe,mt(re),de,Pe)},registerDocumentLinkProvider(re,de){return ht.registerDocumentLinkProvider(Fe,mt(re),de)},registerColorProvider(re,de){return ht.registerColorProvider(Fe,mt(re),de)},registerFoldingRangeProvider(re,de){return ht.registerFoldingRangeProvider(Fe,mt(re),de)},registerSelectionRangeProvider(re,de){return ht.registerSelectionRangeProvider(Fe,re,de)},registerCallHierarchyProvider(re,de){return ht.registerCallHierarchyProvider(Fe,re,de)},setLanguageConfiguration:(re,de)=>ht.setLanguageConfiguration(Fe,re,de),getTokenInformationAtPosition(re,de){return(0,Q.checkProposedApiEnabled)(Fe),Bt.tokenAtPosition(re,de)},registerInlineHintsProvider(re,de){return(0,Q.checkProposedApiEnabled)(Fe),ht.registerInlineHintsProvider(Fe,re,de)}},In={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(re,de,Pe){const lt=await(A.URI.isUri(re)?Promise.resolve(dn.openTextDocument(re)):Promise.resolve(re));return yt.showTextDocument(lt,de,Pe)},createTextEditorDecorationType(re){return yt.createTextEditorDecorationType(re)},onDidChangeActiveTextEditor(re,de,Pe){return yt.onDidChangeActiveTextEditor(re,de,Pe)},onDidChangeVisibleTextEditors(re,de,Pe){return yt.onDidChangeVisibleTextEditors(re,de,Pe)},onDidChangeTextEditorSelection(re,de,Pe){return yt.onDidChangeTextEditorSelection(re,de,Pe)},onDidChangeTextEditorOptions(re,de,Pe){return yt.onDidChangeTextEditorOptions(re,de,Pe)},onDidChangeTextEditorVisibleRanges(re,de,Pe){return yt.onDidChangeTextEditorVisibleRanges(re,de,Pe)},onDidChangeTextEditorViewColumn(re,de,Pe){return yt.onDidChangeTextEditorViewColumn(re,de,Pe)},onDidCloseTerminal(re,de,Pe){return ct.onDidCloseTerminal(re,de,Pe)},onDidOpenTerminal(re,de,Pe){return ct.onDidOpenTerminal(re,de,Pe)},onDidChangeActiveTerminal(re,de,Pe){return ct.onDidChangeActiveTerminal(re,de,Pe)},onDidChangeTerminalDimensions(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalDimensions(re,de,Pe)},onDidWriteTerminalData(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ct.onDidWriteTerminalData(re,de,Pe)},get state(){return Ye.state},onDidChangeWindowState(re,de,Pe){return Ye.onDidChangeWindowState(re,de,Pe)},showInformationMessage(re,...de){return $t.showMessage(Fe,C.default.Info,re,de[0],de.slice(1))},showWarningMessage(re,...de){return $t.showMessage(Fe,C.default.Warning,re,de[0],de.slice(1))},showErrorMessage(re,...de){return $t.showMessage(Fe,C.default.Error,re,de[0],de.slice(1))},showQuickPick(re,de,Pe){return Ut.showQuickPick(re,!!Fe.enableProposedApi,de,Pe)},showWorkspaceFolderPick(re){return Ut.showWorkspaceFolderPick(re)},showInputBox(re,de){return Ut.showInput(re,de)},showOpenDialog(re){return an.showOpenDialog(re)},showSaveDialog(re){return an.showSaveDialog(re)},createStatusBarItem(re,de){let Pe,lt,_t,Dt;return re&&typeof re!="number"?(Pe=re.id,lt=re.name,_t=re.alignment,de=re.priority,Dt=re.accessibilityInformation):(Pe=Fe.identifier.value,lt=E.localize(0,null,Fe.displayName||Fe.name),_t=re),ln.createStatusBarEntry(Pe,lt,_t,de,Dt)},setStatusBarMessage(re,de){return ln.setStatusBarMessage(re,de)},withScmProgress(re){return Le.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),sn.withProgress(Fe,{location:M.ProgressLocation.SourceControl},(de,Pe)=>re({report(lt){}}))},withProgress(re,de){return sn.withProgress(Fe,re,de)},createOutputChannel(re){return Ct.createOutputChannel(re)},createWebviewPanel(re,de,Pe,lt){return Wt.createWebviewPanel(Fe,re,de,Pe,lt)},createWebviewTextEditorInset(re,de,Pe,lt){return(0,Q.checkProposedApiEnabled)(Fe),Qt.createWebviewEditorInset(re,de,Pe,lt,Fe)},createTerminal(re,de,Pe){return typeof re=="object"?"pty"in re?ct.createExtensionTerminal(re):ct.createTerminalFromOptions(re):ct.createTerminal(re,de,Pe)},registerTerminalLinkProvider(re){return ct.registerLinkProvider(re)},registerTreeDataProvider(re,de){return jt.registerTreeDataProvider(re,de,Fe)},createTreeView(re,de){return jt.createTreeView(re,de,Fe)},registerWebviewPanelSerializer:(re,de)=>Wt.registerWebviewPanelSerializer(Fe,re,de),registerCustomEditorProvider:(re,de,Pe={})=>wn.registerCustomEditorProvider(Fe,re,de,Pe),registerFileDecorationProvider(re){return rt.registerFileDecorationProvider(re,Fe.identifier)},registerUriHandler(re){return St.registerUriHandler(Fe.identifier,re)},createQuickPick(){return Ut.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Ut.createInputBox(Fe.identifier)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(re,de,Pe){return on.onDidChangeActiveColorTheme(re,de,Pe)},registerWebviewViewProvider(re,de,Pe){return _n.registerWebviewViewProvider(Fe,re,de,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookEditor(re,de,Pe)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorSelection(re,de,Pe)},onDidChangeNotebookEditorVisibleRanges(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorVisibleRanges(re,de,Pe)},showNotebookDocument(re,de){return(0,Q.checkProposedApiEnabled)(Fe),ft.showNotebookDocument(re,de)},registerExternalUriOpener(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),bn.registerExternalUriOpener(Fe.identifier,re,de,Pe)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Fe),wt.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Fe),wt.onDidChangeTabs}},dn={get rootPath(){return Le.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(re){throw R.readonly()},getWorkspaceFolder(re){return Ze.getWorkspaceFolder(re)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(re){throw R.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(re){throw R.readonly()},updateWorkspaceFolders:(re,de,...Pe)=>Ze.updateWorkspaceFolders(Fe,re,de||0,...Pe),onDidChangeWorkspaceFolders:function(re,de,Pe){return Ze.onDidChangeWorkspace(re,de,Pe)},asRelativePath:(re,de)=>Ze.getRelativePath(re,de),findFiles:(re,de,Pe,lt)=>Ze.findFiles(U.GlobPattern.from(re),U.GlobPattern.from(de),Pe,Fe.identifier,lt),findTextInFiles:(re,de,Pe,lt)=>{let _t,Dt;return typeof de=="object"?(_t=de,Dt=Pe):(_t={},Dt=de,lt=Pe),Ze.findTextInFiles(re,_t||{},Dt,Fe.identifier,lt)},saveAll:re=>Ze.saveAll(re),applyEdit(re){return En.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,de,Pe,lt)=>It.createFileSystemWatcher(U.GlobPattern.from(re),de,Pe,lt),get textDocuments(){return pt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw R.readonly()},openTextDocument(re){let de;const Pe=re;if(typeof re=="string")de=Promise.resolve(A.URI.file(re));else if(A.URI.isUri(re))de=Promise.resolve(re);else if(!Pe||typeof Pe=="object")de=pt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(lt=>pt.ensureDocumentData(lt).then(_t=>_t.document))},onDidOpenTextDocument:(re,de,Pe)=>pt.onDidAddDocument(re,de,Pe),onDidCloseTextDocument:(re,de,Pe)=>pt.onDidRemoveDocument(re,de,Pe),onDidChangeTextDocument:(re,de,Pe)=>pt.onDidChangeDocument(re,de,Pe),onDidSaveTextDocument:(re,de,Pe)=>pt.onDidSaveDocument(re,de,Pe),onWillSaveTextDocument:(re,de,Pe)=>Mt.getOnWillSaveTextDocumentEvent(Fe)(re,de,Pe),onDidChangeConfiguration:(re,de,Pe)=>Zt.onDidChangeConfiguration(re,de,Pe),getConfiguration(re,de){return de=arguments.length===1?void 0:de,Zt.getConfiguration(re,de,Fe)},registerTextDocumentContentProvider(re,de){return Ft.registerTextDocumentContentProvider(re,de)},registerTaskProvider:(re,de)=>(Le.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Fe,re,de)),registerFileSystemProvider(re,de,Pe){return Xt.registerFileSystemProvider(Fe.identifier,re,de,Pe)},get fs(){return qe.value},registerFileSearchProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Fe),gt.registerFileSearchProvider(re,de)),registerTextSearchProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Fe),gt.registerTextSearchProvider(re,de)),registerRemoteAuthorityResolver:(re,de)=>((0,Q.checkProposedApiEnabled)(Fe),Xe.registerRemoteAuthorityResolver(re,de)),registerResourceLabelFormatter:re=>((0,Q.checkProposedApiEnabled)(Fe),pn.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,de,Pe)=>It.onDidCreateFile(re,de,Pe),onDidDeleteFiles:(re,de,Pe)=>It.onDidDeleteFile(re,de,Pe),onDidRenameFiles:(re,de,Pe)=>It.onDidRenameFile(re,de,Pe),onWillCreateFiles:(re,de,Pe)=>It.getOnWillCreateFileEvent(Fe)(re,de,Pe),onWillDeleteFiles:(re,de,Pe)=>It.getOnWillDeleteFileEvent(Fe)(re,de,Pe),onWillRenameFiles:(re,de,Pe)=>It.getOnWillRenameFileEvent(Fe)(re,de,Pe),openTunnel:re=>((0,Q.checkProposedApiEnabled)(Fe),Re.openTunnel(Fe,re).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Fe),Re.getTunnels()},onDidChangeTunnels:(re,de,Pe)=>((0,Q.checkProposedApiEnabled)(Fe),Re.onDidChangeTunnels(re,de,Pe)),registerPortAttributesProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Fe),Re.registerPortsAttributesProvider(re,de)),registerTimelineProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Fe),vn.registerTimelineProvider(re,de,Fe.identifier,Qe.converter)),get trustState(){return(0,Q.checkProposedApiEnabled)(Fe),(0,Q.checkRequiresWorkspaceTrust)(Fe),Ze.trustState},requireWorkspaceTrust:re=>((0,Q.checkProposedApiEnabled)(Fe),(0,Q.checkRequiresWorkspaceTrust)(Fe),Ze.requireWorkspaceTrust(re)),onDidChangeWorkspaceTrustState:(re,de,Pe)=>Ze.onDidChangeWorkspaceTrustState(re,de,Pe)},Pn={get inputBox(){return Le.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Fe)},createSourceControl(re,de,Pe){return qt.createSourceControl(Fe,re,de,Pe)}},An={createCommentController(re,de){return Jt.createCommentController(Fe,re,de)}},hn={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(re,de,Pe){return st.onDidStartDebugSession(re,de,Pe)},onDidTerminateDebugSession(re,de,Pe){return st.onDidTerminateDebugSession(re,de,Pe)},onDidChangeActiveDebugSession(re,de,Pe){return st.onDidChangeActiveDebugSession(re,de,Pe)},onDidReceiveDebugSessionCustomEvent(re,de,Pe){return st.onDidReceiveDebugSessionCustomEvent(re,de,Pe)},onDidChangeBreakpoints(re,de,Pe){return st.onDidChangeBreakpoints(re,de,Pe)},registerDebugConfigurationProvider(re,de,Pe){return st.registerDebugConfigurationProvider(re,de,Pe||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,de){return st.registerDebugAdapterDescriptorFactory(Fe,re,de)},registerDebugAdapterTrackerFactory(re,de){return st.registerDebugAdapterTrackerFactory(re,de)},startDebugging(re,de,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?st.startDebugging(re,de,{parentSession:Pe}):st.startDebugging(re,de,Pe||{})},stopDebugging(re){return st.stopDebugging(re)},addBreakpoints(re){return st.addBreakpoints(re)},removeBreakpoints(re){return st.removeBreakpoints(re)},asDebugSourceUri(re,de){return st.asDebugSourceUri(re,de)}},Gt={registerTaskProvider:(re,de)=>Et.registerTaskProvider(Fe,re,de),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(Fe,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,de,Pe)=>Et.onDidStartTask(re,de,Pe),onDidEndTask:(re,de,Pe)=>Et.onDidEndTask(re,de,Pe),onDidStartTaskProcess:(re,de,Pe)=>Et.onDidStartTaskProcess(re,de,Pe),onDidEndTaskProcess:(re,de,Pe)=>Et.onDidEndTaskProcess(re,de,Pe)},fn={openNotebookDocument:re=>((0,Q.checkProposedApiEnabled)(Fe),ft.openNotebookDocument(re)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Fe),ft.notebookDocuments.map(re=>re.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookSerializer(Fe,re,de,Pe)},registerNotebookContentProvider:(re,de,Pe)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookContentProvider(Fe,re,de,Pe)),registerNotebookKernelProvider:(re,de)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookKernelProvider(Fe,re,de)),createNotebookEditorDecorationType(re){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookEditorDecorationType(re)},onDidChangeNotebookDocumentMetadata(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookDocumentMetadata(re,de,Pe)},onDidChangeNotebookCells(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCells(re,de,Pe)},onDidChangeCellExecutionState(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCellExecutionState(re,de,Pe)},onDidChangeCellOutputs(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeCellOutputs(re,de,Pe)},onDidChangeCellMetadata(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeCellMetadata(re,de,Pe)},createConcatTextDocument(re,de){return(0,Q.checkProposedApiEnabled)(Fe),new G.ExtHostNotebookConcatDocument(ft,pt,re,de)},createCellStatusBarItem(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookCellStatusBarItemInternal(re,de,Pe)},createNotebookCellExecutionTask(re,de,Pe){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookCellExecution(re,de,Pe)}};return{version:He.version,authentication:yn,commands:Dn,comments:An,debug:hn,env:cn,extensions:en,languages:kn,notebook:fn,scm:Pn,tasks:Gt,test:Cn,window:In,workspace:dn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:y.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:b.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:T.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:A.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookCellRange:M.NotebookCellRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestState:M.TestState,TestResult:M.TestResult,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=ge}),define(pe[265],ve([0,1,78,63,33,124,36,51,39,35,65,45,67,89,88,50,62,125,87,60,86,117]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_,c,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,E.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,E.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,E.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,E.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,E.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,E.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,E.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),(0,E.registerSingleton)(y.IExtHostOutputService,y.ExtHostOutputService),(0,E.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,E.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,E.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,E.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,E.registerSingleton)(R.IExtHostWorkspace,R.ExtHostWorkspace),(0,E.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,E.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry)}),define(pe[90],ve([0,1,14,12,32,126]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function A(k,b,m,a){const p=(0,E.mapArrayOrNot)(m,D),S=new R.TextSearchMatch(b,p,a),v=S.preview.matches;return{ranges:(0,E.mapArrayOrNot)(p,n),uri:k,preview:{text:S.preview.text,matches:(0,E.mapArrayOrNot)(v,n)}}}e.createTextSearchResult=A;function D(k){return new R.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function n(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(b,m){this.prefix=b,this.logService=m}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};T=je([Ue(1,y.ILogService)],T),e.OutputChannel=T}),define(pe[266],ve([0,1,91,25]),function(Z,e,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,C=512,A=512*8,D=512*128;class n{constructor(i){this.iconvLiteDecoder=i}static async create(i){let o;if(i!==e.UTF8)o=(await new Promise((l,h)=>{Z(["iconv-lite-umd"],l,h)})).getDecoder(m(i));else{const r=new TextDecoder;o={write(l){return r.decode(l,{stream:!0})},end(){return r.decode()}}}return new n(o)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function T(t,i){var o;const r=((o=i.minBytesRequiredForDetection)!==null&&o!==void 0?o:i.guessEncoding)?A:C;return new Promise((l,h)=>{const g=(0,E.newWriteableStream)(L=>L.join("")),w=[];let d=0,f;const I=async()=>{try{const L=await s({buffer:y.VSBuffer.concat(w),bytesRead:d},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),f=await n.create(L.encoding);const B=f.write(y.VSBuffer.concat(w).buffer);g.write(B),w.length=0,d=0,l({stream:g,detected:L})}catch(L){h(L)}};(0,E.listenStream)(t,{onData:async L=>{f?g.write(f.write(L.buffer)):(w.push(L),d+=L.byteLength,d>=r&&(t.pause(),await I(),setTimeout(()=>t.resume())))},onError:L=>g.error(L),onEnd:async()=>{f||await I(),g.end(f==null?void 0:f.end())}})})}e.toDecodeStream=T;async function k(t,i,o){const l=(await new Promise((w,d)=>{Z(["iconv-lite-umd"],w,d)})).getEncoder(m(i),o);let h=!1,g=!1;return{read(){if(g)return null;const w=t.read();if(typeof w!="string"){if(g=!0,!h&&(o==null?void 0:o.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return y.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return y.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return y.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const d=l.end();return d&&d.length>0?(h=!0,y.VSBuffer.wrap(d)):null}return h=!0,y.VSBuffer.wrap(l.write(w))}}}e.toEncodeReadable=k;async function b(t){return(await new Promise((o,r)=>{Z(["iconv-lite-umd"],o,r)})).encodingExists(m(t))}e.encodingExists=b;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function a(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),r=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return o===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const p=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((g,w)=>{Z(["jschardet"],g,w)}),o=t.slice(0,D),r=c(o.buffer),l=i.detect(r);if(!l||!l.encoding)return null;const h=l.encoding.toLowerCase();return 0<=p.indexOf(h)?null:_(l.encoding)}const v={ibm866:"cp866",big5:"cp950"};function _(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[i]||i}function c(t){let i="";for(let o=0;o<t.length;o++)i+=String.fromCharCode(t[o]);return i}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=u;function s({buffer:t,bytesRead:i},o){let r=a(t,i),l=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let h=!0,g=!0,w=!1;for(let d=0;d<i&&d<P;d++){const f=d%2==1,I=t.readUInt8(d)===0;if(I&&(w=!0),h&&(f&&!I||!f&&I)&&(h=!1),g&&(f&&I||!f&&!I)&&(g=!1),I&&!h&&!g)break}w&&(h?r=e.UTF16le:g?r=e.UTF16be:l=!0)}return o&&!l&&!r&&t?S(t.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:l,encoding:r}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[128],ve([0,1,266,26,127]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends R.TextSearchManager{constructor(A,D,n=y){super(A,D,{readdir:T=>n.readdir(T.fsPath),toCanonicalName:T=>(0,E.toCanonicalName)(T)})}}e.NativeTextSearchManager=P}),define(pe[267],ve([0,1,268,282,283,2,284]),function(Z,e,E,y,R,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(k,b,m,a,p,S){const v=S.environment.useHostProxy,_=typeof v=="boolean"?v:!S.remote.isRemote,c=(0,C.createProxyResolver)({resolveProxy:s=>k.resolveProxy(s),getHttpProxySetting:()=>b.getConfiguration("http").get("proxy"),log:(s,t,...i)=>{switch(s){case C.LogLevel.Trace:a.trace(t,...i);break;case C.LogLevel.Debug:a.debug(t,...i);break;case C.LogLevel.Info:a.info(t,...i);break;case C.LogLevel.Warning:a.warn(t,...i);break;case C.LogLevel.Error:a.error(t,...i);break;case C.LogLevel.Critical:a.critical(t,...i);break;case C.LogLevel.Off:break;default:o(s,t,i);break}function o(r,l,...h){a.error("Unknown log level",r),a.error(l,...h)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:s=>{p.$publicLog2("resolveProxy",s)},useHostProxy:_,env:process.env}),u=D(b,c);return T(m,u)}e.connectProxyResolver=A;function D(k,b){const m={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(p=>{m.config=k.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(p=>{a.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},E,(0,C.createHttpPatch)(E,b,{config:"off"},a,!0)),on:Object.assign({},E,(0,C.createHttpPatch)(E,b,{config:"on"},a,!0)),override:Object.assign({},E,(0,C.createHttpPatch)(E,b,{config:"override"},a,!0)),onRequest:Object.assign({},E,(0,C.createHttpPatch)(E,b,m,a,!0)),default:Object.assign(E,(0,C.createHttpPatch)(E,b,m,a,!1))},https:{off:Object.assign({},y,(0,C.createHttpPatch)(y,b,{config:"off"},a,!0)),on:Object.assign({},y,(0,C.createHttpPatch)(y,b,{config:"on"},a,!0)),override:Object.assign({},y,(0,C.createHttpPatch)(y,b,{config:"override"},a,!0)),onRequest:Object.assign({},y,(0,C.createHttpPatch)(y,b,m,a,!0)),default:Object.assign(y,(0,C.createHttpPatch)(y,b,m,a,!1))},tls:Object.assign(R,(0,C.createTlsPatch)(R))}}const n=new Map;function T(k,b){return k.getExtensionPathIndex().then(m=>{const a=Z.__$__nodeRequire("module"),p=a._load;a._load=function(v,_,c){if(v==="tls")return b.tls;if(v!=="http"&&v!=="https")return p.apply(this,arguments);const u=b[v],s=m.findSubstr(P.URI.file(_.filename).fsPath);let t=n.get(s);if(t||n.set(s,t={}),!t[v]){let i=u.default;s&&s.enableProposedApi&&(i=u[s.proxySupport]||u.onRequest),t[v]=Object.assign({},i)}return t[v]}})}}),define(pe[269],ve([0,1,38,8,74,31,9,10,90,270]),function(Z,e,E,y,R,P,C,A,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(c,u,s,t){const i=b(c,u,s,t),o=u.folder.fsPath;return{cmd:E.spawn(T,i.args,{cwd:o}),rgDiskPath:T,siblingClauses:i.siblingClauses,rgArgs:i,cwd:o}}e.spawnRipgrepCmd=k;function b(c,u,s,t){const i=["--files","--hidden","--case-sensitive"];a([u],s,!1).forEach(r=>{const l=(0,D.anchorGlob)(r);if(i.push("-g",l),C.isMacintosh){const h=(0,R.normalizeNFD)(l);h!==l&&i.push("-g",h)}});const o=m([u],t,void 0,!1);return o.globArgs.forEach(r=>{const l=`!${(0,D.anchorGlob)(r)}`;if(i.push("-g",l),C.isMacintosh){const h=(0,R.normalizeNFD)(l);h!==l&&i.push("-g",h)}}),u.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),u.ignoreSymlinks||i.push("--follow"),c.exists&&i.push("--quiet"),i.push("--no-config"),u.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:o.siblingClauses}}function m(c,u,s,t=!0){const i=[];let o={};return c.forEach(r=>{const l=Object.assign({},r.excludePattern||{},u||{}),h=p(l,t?r.folder.fsPath:void 0,s);i.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:i,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function a(c,u,s=!0){const t=[];return c.forEach(i=>{const o=Object.assign({},u||{},i.includePattern||{}),r=p(o,s?i.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function p(c,u,s){const t=[],i={};return Object.keys(c).forEach(o=>{if(!(s&&s.has(o))&&!!o){const r=c[o];o=v(u?S(u,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),t.push(_(o))):r&&r.when&&(i[o]=r)}}),{globArgs:t,siblingClauses:i}}function S(c,u){return y.isAbsolute(u)?u:y.join(c,u)}e.getAbsoluteGlob=S;function v(c){return c=A.rtrim(c,"\\"),A.rtrim(c,"/")}function _(c){return P.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=_}),define(pe[271],ve([0,1,38,37,8,98,14,58,34,74,31,9,46,10,15,26,32,269,96]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(o=>o())});class u{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),g=l.folder.fsPath;r.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==g).forEach(w=>{(0,T.isEqualOrParent)(w,g)&&(h[R.relative(g,w)]=!0)}),this.folderExcludePatterns.set(g,new t(h,g))})}cancel(){this.isCanceled=!0}walk(r,l,h,g,w){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);l.forEach(d=>{const f=R.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,f)||this.matchFile(h,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(r,(d,f)=>{this.call(this.cmdTraversal,this,d,h,g,I=>{if(I){const L=(0,A.toErrorMessage)(I);console.error(L),this.errors.push(L),f(I,void 0)}else f(null,void 0)})},(d,f)=>{this.fileWalkSW.stop();const I=d?C.coalesce(d)[0]:null;w(I,this.isLimitHit)})}parallel(r,l,h){const g=new Array(r.length),w=new Array(r.length);let d=!1,f=0;if(r.length===0)return h(null,[]);r.forEach((I,L)=>{l(I,(B,ee)=>{if(B?(d=!0,g[L]=null,w[L]=B):(g[L]=ee,w[L]=null),++f===r.length)return h(d?w:null,g)})})}call(r,l,...h){try{r.apply(l,h)}catch(g){h[h.length-1](g)}}cmdTraversal(r,l,h,g){const w=r.folder.fsPath,d=k.isMacintosh;let f;const I=()=>f&&f.kill();c.add(I);let L=U=>{c.delete(I),L=()=>{},g(U)},B="";const ee=this.initDirectoryTree();let H;const x=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);f=x.cmd,H=!Object.keys(x.siblingClauses).length;const $=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${x.rgDiskPath} ${$}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),h({message:F}),this.cmdResultCount=0,this.collectStdout(f,"utf8",h,(U,M,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const V=(B+(d?n.normalizeNFC(M||""):M)).split(`
`);if(N){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else B=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,H){for(const q of V)if(this.matchFile(l,{base:w,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){I();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,ee,w,V,l),N&&(this.matchDirectoryTree(ee,w,l),L())})}spawnFindCmd(r){const l=this.folderExcludePatterns.get(r.folder.fsPath),h=l.getBasenameTerms(),g=l.getPathTerms(),w=["-L","."];if(h.length||g.length){w.push("-not","(","(");for(const d of h)w.push("-name",d),w.push("-o");for(const d of g)w.push("-path",d),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),E.spawn("find",w,{cwd:r.folder.fsPath})}readStdout(r,l,h){let g="";this.collectStdout(r,l,()=>{},(w,d,f)=>{if(w){h(w);return}g+=d,f&&h(null,g)})}collectStdout(r,l,h,g){let w=(I,L,B)=>{(I||B)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),g(I,L,B)},d=!1;r.stdout?(this.forwardData(r.stdout,l,w),r.stdout.once("data",()=>d=!0)):h({message:"stdout is null"});let f;r.stderr?f=this.collectData(r.stderr):h({message:"stderr is null"}),r.on("error",I=>{w(I)}),r.on("close",I=>{let L;!d&&(L=this.decodeData(f,l))&&i(L)?w(new Error(`command failed with error code ${I}: ${this.decodeData(f,l)}`)):(this.exists&&I===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(r,l,h){const g=new P.StringDecoder(l);return r.on("data",w=>{h(null,g.write(w))}),g}collectData(r){const l=[];return r.on("data",h=>{l.push(h)}),l}decodeData(r,l){const h=new P.StringDecoder(l);return r.map(g=>h.write(g)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:l},h,g,w){g.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const d=f=>{const I=R.basename(f),L=R.dirname(f);let B=l[L];B||(B=l[L]=[],d(L)),B.push({base:h,relativePath:f,basename:I,searchPath:this.getSearchPath(r,f)})};g.forEach(d)}matchDirectoryTree({rootEntries:r,pathToEntries:l},h,g){const w=this,d=this.folderExcludePatterns.get(h),f=this.filePattern;function I(L){w.directoriesWalked++;const B=D.hasSiblingFn(()=>L.map(ee=>ee.basename));for(let ee=0,H=L.length;ee<H;ee++){const x=L[ee],{relativePath:$,basename:F}=x;if(!d.test($,F,f!==F?B:void 0)){const U=l[$];if(U)I(U);else{if(w.filesWalked++,$===f)continue;w.matchFile(g,x)}if(w.isLimitHit)break}}}I(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,l,h,g,w){const d=r.folder,f=D.hasSiblingFn(()=>h);this.parallel(h,(I,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const B=l?[l,I].join(R.sep):I;if(this.folderExcludePatterns.get(r.folder.fsPath).test(B,I,this.config.filePattern!==I?f:void 0))return L(null);const ee=[d.fsPath,B].join(R.sep);y.lstat(ee,(H,x)=>{if(H||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ee,x,($,F)=>$||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,x,(U,M)=>U||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,p.readdir)(ee).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,B,N,g,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&a.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(g,{base:d.fsPath,relativePath:B,searchPath:this.getSearchPath(r,B)}),L(null,void 0)))})},I=>{const L=I&&C.coalesce(I);return w(L&&L.length>0?L[0]:void 0)})}matchFile(r,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,R.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(l))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,l,h){return l.isSymbolicLink()?y.stat(r,h):h(null,l)}realPathIfNeeded(r,l,h){return l.isSymbolicLink()?y.realpath(r,(g,w)=>g?h(g):h(null,w)):h(null,r)}getSearchPath(r,l){return r.folderName?R.join(r.folderName,l):l}}e.FileWalker=u;class s{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new u(r)}search(r,l,h){this.walker.walk(this.folderQueries,this.extraFiles,r,l,(g,w)=>{h(g,{limitHit:w,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=s;class t{constructor(r,l){this.expression=r,this.root=l,this.init(r)}init(r){let l,h;Object.keys(r).filter(g=>r[g]).forEach(g=>{R.isAbsolute(g)?(l=l||D.getEmptyExpression(),l[g]=r[g]):(h=h||D.getEmptyExpression(),h[g]=r[g])}),this.absoluteParsedExpr=l&&D.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=h&&D.parse(h,{trimForExclusions:!0})}test(r,l,h){return this.relativeParsedExpr&&this.relativeParsedExpr(r,l,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(R.join(this.root,r),l,h)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function i(o){const r=o.trim().split(`
`),l=r[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return m.uppercaseFirstLetter(r[r.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=i}),define(pe[129],ve([0,1,38,285,98,14,53,34,8,10,2,32,126,286,270,90]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(d){this.outputChannel=d}provideTextSearchResults(d,f,I,L){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify(Object.assign(Object.assign({},f),{folder:f.folder.toString()}))}`),new Promise((B,ee)=>{L.onCancellationRequested(()=>O());const H=i(d,f),x=f.folder.fsPath,$=H.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${S} ${$}
 - cwd: ${x}`);let F=E.spawn(S,H,{cwd:x});F.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),ee((0,k.serializeSearchError)(new k.SearchError(we&&we.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const M=new u(f.maxResults,x,f.previewOptions);M.on("result",we=>{U=!0,q="",I.report(we)});let N=!1;const O=()=>{N=!0,F&&F.kill(),M&&M.cancel()};let V=!1;M.on("hitLimit",()=>{V=!0,O()});let q="";F.stdout.on("data",we=>{M.handleData(we),U||(q+=we)});let Q=!1;F.stdout.once("data",()=>Q=!0);let me="";F.stderr.on("data",we=>{const Ae=we.toString();this.outputChannel.appendLine(Ae),me+=Ae}),F.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)B({limitHit:V});else{M.flush(),F=null;let we;me&&!Q&&(we=_(me))?ee((0,k.serializeSearchError)(new k.SearchError(we.message,we.code))):B({limitHit:V})}})})}}e.RipgrepTextSearchEngine=v;function _(w){const d=w.split(`
`),f=d[0].trim();if(d.some(L=>L.startsWith("regex parse error")))return new k.SearchError(c(d),k.SearchErrorCode.regexParseError);const I=f.match(/grep config error: unknown encoding: (.*)/);if(I)return new k.SearchError(`Unknown encoding: ${I[1]}`,k.SearchErrorCode.unknownEncoding);if(f.startsWith("error parsing glob"))return new k.SearchError(f.charAt(0).toUpperCase()+f.substr(1),k.SearchErrorCode.globParseError);if(f.startsWith("the literal"))return new k.SearchError(f.charAt(0).toUpperCase()+f.substr(1),k.SearchErrorCode.invalidLiteral);if(f.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(f,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function c(w){const d=["Regex parse error"],f=w.filter(I=>I.startsWith("PCRE2:"));if(f.length>=1){const I=f[0].replace("PCRE2:","");if(I.indexOf(":")!==-1&&I.split(":").length>=2){const L=I.split(":")[1];d.push(":"+L)}}return d.join("")}e.buildRegexParseError=c;class u extends y.EventEmitter{constructor(d,f,I){super();this.maxResults=d,this.rootFolder=f,this.previewOptions=I,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new R.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,f){return super.on(d,f),this}handleData(d){if(!this.isDone){const f=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(f)}}handleDecodedData(d){let f=d.indexOf(`
`);const I=this.remainder+d;if(f>=0)f+=this.remainder.length;else{this.remainder=I;return}let L=0;for(;f>=0;)this.handleLine(I.substring(L,f).trim()),L=f+1,f=I.indexOf(`
`,L);this.remainder=I.substring(L)}handleLine(d){if(!(this.isDone||!d)){let f;try{f=JSON.parse(d)}catch(I){throw new Error(`malformed line from rg: ${d}`)}if(f.type==="match"){const I=s(f.data.path),L=T.URI.file(D.join(this.rootFolder,I)),B=this.createTextSearchMatch(f.data,L);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(f.type==="context"){const I=s(f.data.path),L=T.URI.file(D.join(this.rootFolder,I));this.createTextSearchContext(f.data,L).forEach(ee=>this.onResult(ee))}}}createTextSearchMatch(d,f){const I=d.line_number-1;let L=!1,B=s(d.lines);I===0&&(0,n.startsWithUTF8BOM)(B)&&(L=!0,B=(0,n.stripUTF8BOM)(B));const ee=Buffer.from(B);let H=0,x=0,$=I;d.submatches.length===0&&d.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(d.submatches.map((U,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=s(U.match);I===0&&M===0&&L&&(N=(0,n.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=ee.slice(H,U.start).toString().length,V=x+O,q=t(N),Q=$,me=q.numLines+Q,we=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return H=U.end,x=we,$=me,new b.Range(Q,V,me,we)}));return(0,p.createTextSearchResult)(f,B,F,this.previewOptions)}createTextSearchContext(d,f){const I=s(d.lines),L=d.line_number;return I.replace(/\r?\n$/,"").split(`
`).map((B,ee)=>({text:B,uri:f,lineNumber:L+ee}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=u;function s(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const d=/\n/g;let f=0,I=-1,L;for(;L=d.exec(w);)f++,I=L.index;const B=I>=0?w.length-I-1:w.length;return{numLines:f,lastLineLength:B}}function i(w,d){const f=["--hidden"];f.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:I,otherIncludes:L}=(0,C.groupBy)(d.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ee=new Set;L.forEach(H=>{ee.add(H)}),f.push("-g","!*"),ee.forEach(H=>{o(H).map(p.anchorGlob).forEach(x=>{f.push("-g",x)})})}I&&I.length&&I.forEach(ee=>{f.push("-g",ee)}),d.excludes.map(p.anchorGlob).forEach(ee=>f.push("-g",`!${ee}`)),d.maxFileSize&&f.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?f.push("--no-ignore-parent"):f.push("--no-ignore"),d.followSymlinks&&f.push("--follow"),d.encoding&&d.encoding!=="utf8"&&f.push("--encoding",d.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,n.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),d.usePCRE2&&f.push("--pcre2"),f.push("--crlf"),w.isRegExp&&(w.pattern=r(w.pattern),f.push("--auto-hybrid-regex"));let B;if(w.isWordMatch){const H=(0,n.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");f.push("--regexp",H)}else if(w.isRegExp){let ee=h(w.pattern);ee=g(ee),f.push("--regexp",ee)}else B=w.pattern,f.push("--fixed-strings");return f.push("--no-config"),d.useGlobalIgnoreFiles||f.push("--no-ignore-global"),f.push("--json"),w.isMultiline&&f.push("--multiline"),d.beforeContext&&f.push("--before-context",d.beforeContext+""),d.afterContext&&f.push("--after-context",d.afterContext+""),f.push("--"),B&&f.push(B),f.push("."),f}function o(w){const d=(0,A.splitGlobAware)(w,"/");return d.map((f,I)=>d.slice(0,I+1).join("/"))}e.spreadGlobComponents=o;function r(w){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(d);)w=w.replace(d,"$1\\x{$2}");const f=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(f);)w=w.replace(f,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=r;const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function h(w){let d;try{d=new m.RegExpParser().parsePattern(w)}catch(H){return w}let f="",I=0;const L=(H,x,$)=>{f+=w.slice(I,H)+$,I=x},B=[];return new m.RegExpVisitor({onCharacterEnter(H){if(H.raw==="\\n"){const x=B[0];if(!x)L(H.start,H.end,"\\r?\\n");else if(!B.some(l))if(x.type==="CharacterClass"){const $=w.slice(x.start+1,H.start)+w.slice(H.end,x.end-1);L(x.start,x.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else x.type==="Quantifier"&&L(H.start,H.end,"(?:\\r?\\n)")}},onQuantifierEnter(H){B.unshift(H)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(H){B.unshift(H)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(H){B.unshift(H)},onCharacterClassLeave(){B.shift()},onAssertionEnter(H){l(H)&&B.push(H)},onAssertionLeave(H){B[0]===H&&B.shift()}}).visit(d),f+=w.slice(I),f}e.fixRegexNewline=h;function g(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=g}),define(pe[272],ve([0,1,21,129,111,11]),function(Z,e,E,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(n){this.outputChannel=n,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(n,T,k,b){const m=new y.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===P.Schemas.userData){const a=Object.assign(Object.assign({},T),{folder:T.folder.with({scheme:P.Schemas.file})}),p=new R.Progress(S=>k.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:T.folder.scheme})})));return this.withToken(b,S=>m.provideTextSearchResults(n,a,p,S))}else return this.withToken(b,a=>m.provideTextSearchResults(n,T,k,a))}async withToken(n,T){const k=A(n);this.inProgress.add(k);const b=await T(k.token);return this.inProgress.delete(k),b}dispose(){this.inProgress.forEach(n=>n.cancel())}}e.RipgrepSearchProvider=C;function A(D){const n=new E.CancellationTokenSource;return D.onCancellationRequested(()=>n.cancel()),n}}),define(pe[273],ve([0,1,26,129,128]),function(Z,e,E,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(D){this.query=D}search(D,n,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(m){T({message:m})}},b=new R.NativeTextSearchManager(this.query,new y.RipgrepTextSearchEngine(k),E);return new Promise((m,a)=>b.search(p=>{n(p.map(C))},D).then(p=>m({limitHit:p.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=P;function C(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((D,n)=>{if(n.ranges){const T=n;return D+(Array.isArray(T.ranges)?T.ranges.length:1)}else return D+1},0)}}}),define(pe[274],ve([0,1,37,287,14,17,16,3,96,8,46,2,44,32,271,273]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,y.gracefulify(E);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const o=c(t),r=new A.Emitter({onFirstListenerDidAdd:()=>{i=(0,P.createCancelablePromise)(l=>this.doFileSearchWithEngine(a.Engine,o,h=>r.fire(h),l)),i.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}textSearch(t){let i;const o=c(t),r=new A.Emitter({onFirstListenerDidAdd:()=>{i=(0,P.createCancelablePromise)(l=>this.ripgrepTextSearch(o,h=>r.fire(h),l)),i.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}ripgrepTextSearch(t,i,o){return t.maxFileSize=(0,b.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(t).search(o,i,i)}doFileSearch(t,i,o){return this.doFileSearchWithEngine(a.Engine,t,i,o)}doFileSearchWithEngine(t,i,o,r,l=S.BATCH_SIZE){let h=0;const g=d=>{Array.isArray(d)?(h+=d.length,o(d.map(f=>this.rawMatchToSearchItem(f)))):d.relativePath?(h++,o(this.rawMatchToSearchItem(d))):o(d)};if(i.sortByScore){let d=this.trySortedSearchFromCache(i,g,r);if(!d){const f=i.maxResults?Object.assign({},i,{maxResults:null}):i,I=new t(f);d=this.doSortedSearch(I,i,o,g,r)}return new Promise((f,I)=>{d.then(([L,B])=>{const ee=B.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(ee,o,l),f(L)},I)})}const w=new t(i);return this.doSearch(w,g,l,r).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,n.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,o,r,l){const h=new A.Emitter;let g=(0,P.createCancelablePromise)(d=>{let f=[];const I=L=>{Array.isArray(L)?f=L:(r(L),h.fire(L))};return this.doSearch(t,I,-1,d).then(L=>[L,f])}),w;if(i.cacheKey){w=this.getOrCreateCache(i.cacheKey);const d={promise:g,event:h.event,resolved:!1};w.resultsToSearchCache[i.filePattern||""]=d,g.then(()=>{d.resolved=!0},f=>{delete w.resultsToSearchCache[i.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([d,f])=>{const I=w?w.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&T.StopWatch.create(!1);return this.sortResults(i,f,I,l).then(B=>{const ee=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:B.length},limitHit:d.limitHit||typeof i.maxResults=="number"&&f.length>i.maxResults},B]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new v)}trySortedSearchFromCache(t,i,o){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const l=this.getResultsFromCache(r,t.filePattern||"",i,o);if(l)return l.then(([h,g,w])=>{const d=T.StopWatch.create(!1);return this.sortResults(t,g,r.scorerCache,o).then(f=>{const I=d.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:g.length,sortingTime:I};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&g.length>t.maxResults,stats:L},f]})})}}sortResults(t,i,o,r){const l=(0,D.prepareQuery)(t.filePattern||""),h=(w,d)=>(0,D.compareItemsByFuzzyScore)(w,d,l,!0,_,o),g=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return R.topAsync(i,h,g,1e4,r)}sendProgress(t,i,o){if(o&&o>0)for(let r=0;r<t.length;r+=o)i(t.slice(r,r+o));else i(t)}getResultsFromCache(t,i,o,r){const l=T.StopWatch.create(!1),h=i.indexOf(n.sep)>=0;let g;for(const I in t.resultsToSearchCache)if(i.startsWith(I)){if(h&&I.indexOf(n.sep)<0&&I!=="")continue;const L=t.resultsToSearchCache[I];g={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!g)return null;const w=l.elapsed(),d=T.StopWatch.create(!1),f=g.event(o);return r&&r.onCancellationRequested(()=>{f.dispose()}),g.promise.then(([I,L])=>{if(r&&r.isCancellationRequested)throw(0,C.canceled)();const B=[],ee=(0,D.prepareQuery)(i).normalizedLowercase;for(const H of L)!(0,m.isFilePatternMatch)(H,ee)||B.push(H);return[I,B,{cacheWasResolved:g.resolved,cacheLookupTime:w,cacheFilterTime:d.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,o,r){return new Promise((l,h)=>{let g=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(g.push(w),o>0&&g.length>=o&&(i(g),g=[])):i(w))},w=>{i(w)},(w,d)=>{g.length&&i(g),w?h(w):l(d)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,o){return t.then(i,o)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(s){return(0,n.basename)(s.relativePath)}getItemDescription(s){return(0,n.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function c(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(u),extraFileResources:s.extraFileResources&&s.extraFileResources.map(t=>k.URI.revive(t))})}function u(s){return Object.assign(Object.assign({},s),{folder:k.URI.revive(s.folder)})}}),define(pe[275],ve([0,1,6,2,26,12,32,274,272,90,13,61,27,67,11,128]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends m.ExtHostSearch{constructor(_,c,u,s){super(_,u,s);this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new n.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new n.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(a.Schemas.file,new A.SearchService)}registerInternalFileSearchProvider(_,c){const u=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(_)),(0,E.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(_,c,u,s){const t=(0,m.reviveQuery)(u);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,c,t,s):super.$provideFileSearchResults(_,c,u,s)}doInternalFileSearch(_,c,u,s){const t=i=>{if((0,C.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(_,c,i.map(o=>y.URI.file(o.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,s)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,c){return new p.NativeTextSearchManager(_,c)}};S=je([Ue(0,T.IExtHostRpcService),Ue(1,b.IExtHostInitDataService),Ue(2,k.IURITransformerService),Ue(3,P.ILogService)],S),e.NativeExtHostSearch=S}),define(pe[130],ve([0,1,288,120,289,3,101,8,48,28,6,25,102,16,9]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(g){this.socket=g}dispose(){this.socket.destroy()}onData(g){const w=d=>g(k.VSBuffer.wrap(d));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(g){return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((g,w)=>{if(this.socket.bufferSize===0){g();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),g()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=p;var S;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(v||(v={}));class _ extends T.Disposable{constructor(g,w,d,f){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=f,w?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",I=>{console.error(I),(0,m.onUnexpectedError)(I),this._onClose.fire()}),this._zlibInflate.on("data",I=>{this._pendingInflateData.push(I)}),d&&(this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",I=>{console.error(I),(0,m.onUnexpectedError)(I),this._onClose.fire()}),this._zlibDeflate.on("data",I=>{this._pendingDeflateData.push(I)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(I=>this._acceptChunk(I))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(k.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,w){let d=2;g.byteLength<126?d+=0:g.byteLength<2**16?d+=2:d+=8;const f=k.VSBuffer.alloc(d);if(w?f.writeUInt8(194,0):f.writeUInt8(130,0),g.byteLength<126)f.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){f.writeUInt8(126,1);let I=1;f.writeUInt8(g.byteLength>>>8&255,++I),f.writeUInt8(g.byteLength>>>0&255,++I)}else{f.writeUInt8(127,1);let I=1;f.writeUInt8(0,++I),f.writeUInt8(0,++I),f.writeUInt8(0,++I),f.writeUInt8(0,++I),f.writeUInt8(g.byteLength>>>24&255,++I),f.writeUInt8(g.byteLength>>>16&255,++I),f.writeUInt8(g.byteLength>>>8&255,++I),f.writeUInt8(g.byteLength>>>0&255,++I)}this._totalOutgoingWireBytes+=f.byteLength+g.byteLength,this.socket.write(k.VSBuffer.concat([f,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),f=(w.readUInt8(0)&128)>>>7,I=w.readUInt8(1),L=(I&128)>>>7,B=I&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=f,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),d=w.readUInt8(1),f=(d&128)>>>7;let I=d&127,L=1;I===126?I=w.readUInt8(++L)*2**8+w.readUInt8(++L):I===127&&(I=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let B=0;f&&(B=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=I,this._state.mask=B}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);c(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const d=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=d.length,this._onData.fire(k.VSBuffer.wrap(d))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function c(h,g){if(g!==0){let w=h.byteLength>>>2;for(let ee=0;ee<w;ee++){const H=h.readUInt32BE(ee*4);h.writeUInt32BE(H^g,ee*4)}let d=w*4,f=h.byteLength-d;const I=g>>>24&255,L=g>>>16&255,B=g>>>8&255;f>=1&&h.writeUInt8(h.readUInt8(d)^I,d),f>=2&&h.writeUInt8(h.readUInt8(d+1)^L,d+1),f>=3&&h.writeUInt8(h.readUInt8(d+2)^B,d+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const h=(0,n.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):g=(0,A.join)((0,D.tmpdir)(),`vscode-ipc-${h}.sock`),i(g),g}e.createRandomIPCHandle=s;function t(h,g,w){const d=(0,E.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${w}-${g}-sock`;let f;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?f=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${w}-${g}.sock`):f=(0,A.join)(h,`${w}-${g}.sock`),i(f),f}e.createStaticIPCHandle=t;function i(h){const g=u[a.platform];typeof g=="number"&&h.length>=g&&console.warn(`WARNING: IPC handle "${h}" is longer than ${g} chars, try a shorter --user-data-dir`)}class o extends C.IPCServer{constructor(g){super(o.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const w=P.Event.fromNodeEventEmitter(g,"connection");return P.Event.map(w,d=>({protocol:new b.Protocol(new p(d)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(h){return new Promise((g,w)=>{const d=(0,y.createServer)();d.on("error",w),d.listen(h,()=>{d.removeListener("error",w),g(new o(d))})})}e.serve=r;function l(h,g){return new Promise((w,d)=>{const f=(0,y.createConnection)(h,()=>{f.removeListener("error",d),w(b.Client.fromSocket(new p(f),g))});f.once("error",d)})}e.connect=l}),define(pe[276],ve([0,1,130,268,37,51,2,115,12]),function(Z,e,E,y,R,P,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(b,m,a){this._commands=b,this.logService=m,this._ipcHandlePath=a,this._server=y.createServer((p,S)=>this.onRequest(p,S)),this.setup().catch(p=>(m.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch(b){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,m){const a=[];b.setEncoding("utf8"),b.on("data",p=>a.push(p)),b.on("end",()=>{const p=JSON.parse(a.join(""));switch(p.type){case"open":this.open(p,m);break;case"openExternal":this.openExternal(p,m);break;case"status":this.getStatus(p,m);break;case"command":this.runCommand(p,m).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(p,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${p.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(b,m){let{fileURIs:a,folderURIs:p,forceNewWindow:S,diffMode:v,addMode:_,forceReuseWindow:c,gotoLineMode:u,waitMarkerFilePath:s}=b;const t=[];if(Array.isArray(p))for(const i of p)try{t.push({folderUri:C.URI.parse(i)})}catch(o){}if(Array.isArray(a))for(const i of a)try{(0,A.hasWorkspaceFileExtension)(i)?t.push({workspaceUri:C.URI.parse(i)}):t.push({fileUri:C.URI.parse(i)})}catch(o){}if(t.length){const i=s?C.URI.file(s):void 0,r={forceNewWindow:S,diffMode:v,addMode:_,gotoLineMode:u,forceReuseWindow:c,preferNewWindow:!c&&!i&&!_,waitMarkerFileURI:i};this._commands.executeCommand("_files.windowOpen",t,r)}m.writeHead(200),m.end()}async openExternal(b,m){for(const a of b.uris){const p=C.URI.parse(a),S=p.scheme==="file"?p:a;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(b,m){console.log("server: manageExtensions");try{const a=v=>v==null?void 0:v.map(_=>/\.vsix$/i.test(_)?C.URI.parse(_):_),p={list:b.list,install:a(b.install),uninstall:a(b.uninstall),force:b.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",p,{allowTunneling:!0});m.writeHead(200),m.write(S)}catch(a){m.writeHead(500),m.write(String(a))}m.end()}async getStatus(b,m){try{const a=await this._commands.executeCommand("_issues.getSystemStatus");m.writeHead(200),m.write(a),m.end()}catch(a){m.writeHead(500),m.write(String(a),p=>{p&&this.logService.error(p)}),m.end()}}async runCommand(b,m){try{const{command:a,args:p}=b,S=await this._commands.executeCommand(a,...p);m.writeHead(200),m.write(JSON.stringify(S),v=>{v&&this.logService.error(v)}),m.end()}catch(a){m.writeHead(500),m.write(String(a),p=>{p&&this.logService.error(p)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&R.existsSync(this._ipcHandlePath)&&R.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let T=class extends n{constructor(b,m){super(b,m,(0,E.createRandomIPCHandle)())}};T=je([Ue(0,P.IExtHostCommands),Ue(1,D.ILogService)],T),e.CLIServer=T}),define(pe[277],ve([0,1,66,264,258,5,267,42,249,2,11,7,276,99]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends R.RequireInterceptor{_installInterceptor(){const v=this,_=Z.__$__nodeRequire("module"),c=_._load;_._load=function(s,t,i){for(let o of v._alternatives){let r=o(s);if(r){s=r;break}}return v._factories.has(s)?v._factories.get(s).load(s,n.URI.file((0,m.realpathSync)(t.filename)),o=>c.apply(this,[o,t,i])):c.apply(this,arguments)}}}class p extends A.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(y.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(b.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,v,this._registry).install(),E.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),E.mark("code/extHost/didInitProxyResolver");const u=process.send,s=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(s.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,_,c){if(_.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let u=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{v&&E.mark(`code/extHost/willLoadExtensionCode/${v.value}`),u=Z.__$__nodeRequire(_.fsPath)}catch(s){return Promise.reject(s)}finally{v&&E.mark(`code/extHost/didLoadExtensionCode/${v.value}`),c.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const _ in v){const c=v[_];c===null?delete process.env[_]:process.env[_]=c}}}e.ExtHostExtensionService=p}),define(pe[278],ve([0,1,78,250,261,260,259,275,277,222,251,45,42,63,67,65,35,50,12]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p,S,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(b.IExtHostExtensionService,D.ExtHostExtensionService),(0,E.registerSingleton)(_.ILogService,n.ExtHostLogService),(0,E.registerSingleton)(k.IExtHostDebugService,C.ExtHostDebugService),(0,E.registerSingleton)(m.IExtHostOutputService,y.ExtHostOutputService2),(0,E.registerSingleton)(a.IExtHostSearch,A.NativeExtHostSearch),(0,E.registerSingleton)(p.IExtHostTask,P.ExtHostTask),(0,E.registerSingleton)(S.IExtHostTerminalService,R.ExtHostTerminalService),(0,E.registerSingleton)(v.IExtHostTunnelService,T.ExtHostTunnelService)}),define(pe[279],ve([0,1,120,290,66,16,102,130,184,220,262,25,97,26,99,17,265,278]),function(Z,e,E,y,R,P,C,A,D,n,T,k,b,m,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=y(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=Z.__$__nodeRequire("module"),r=o._load;o._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function _(o){process.exit=function(r){if(o)v(r);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let c=function(o){v()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,r)=>{let l=null,h=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const g=108e5,w=3e5,d=new p.RunOnceScheduler(()=>c("renderer disconnected for too long (1)"),g),f=new p.RunOnceScheduler(()=>c("renderer disconnected for too long (2)"),w);process.on("message",(L,B)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=k.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let H;if(L.skipWebSocketFrames)H=new A.NodeSocket(B);else{const x=k.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));H=new A.WebSocketNodeSocket(new A.NodeSocket(B),L.permessageDeflate,x,!1)}l?(d.cancel(),f.cancel(),l.beginAcceptReconnection(H,ee),l.endAcceptReconnection()):(clearTimeout(h),l=new C.PersistentProtocol(H,ee),l.onDidDispose(()=>c("renderer disconnected")),o(l),l.onSocketClose(()=>{d.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(f.isScheduled())return;d.isScheduled()&&f.schedule()}});const I={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(I)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,l)=>{const h=E.createConnection(o,()=>{h.removeListener("error",l),r(new C.PersistentProtocol(new A.NodeSocket(h)))});h.once("error",l)})}}async function s(){const o=await u();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(r=>{(0,n.isMessageOfType)(r,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||o.send(r)}drain(){return o.drain()}}}function t(o){return new Promise(r=>{const l=o.onMessage(h=>{l.dispose();const g=JSON.parse(h.toString()),w=g.commit,d=D.default.commit;w&&d&&w!==d&&v(55);const f=[];process.on("unhandledRejection",(B,ee)=>{f.push(ee),setTimeout(()=>{const H=f.indexOf(ee);H>=0&&ee.catch(x=>{f.splice(H,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,P.onUnexpectedError)(B)})},1e3)}),process.on("rejectionHandled",B=>{const ee=f.indexOf(B);ee>=0&&f.splice(ee,1)}),process.on("uncaughtException",function(B){(0,P.onUnexpectedError)(B)});let I=0;setInterval(function(){try{process.kill(g.parentPid,0),I=0}catch(B){B&&B.code==="EPERM"?(I++,I>=3&&c(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):c(`parent process ${g.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let L;try{L=Z.__$__nodeRequire("native-watchdog"),L.start(g.parentPid)}catch(B){(0,P.onUnexpectedError)(B)}o.send((0,n.createMessageOfType)(0)),r({protocol:o,initData:g})});o.send((0,n.createMessageOfType)(1))})}async function i(){R.mark("code/extHost/willConnectToRenderer");const o=await s();R.mark("code/extHost/didConnectToRenderer");const r=await t(o);R.mark("code/extHost/didWaitForInitData");const{initData:l}=r;_(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const h=new class{exit(f){v(f)}exists(f){return(0,m.exists)(f)}realpath(f){return(0,a.realpath)(f)}};let g=null;if(l.remote.authority&&S.uriTransformerPath)try{const f=Z.__$__nodeRequire(S.uriTransformerPath)(l.remote.authority);g=new b.URITransformer(f)}catch(d){console.error(d)}const w=new T.ExtensionHostMain(r.protocol,l,h,g);c=d=>w.terminate(d)}e.startExtensionHostProcess=i}),define(pe[291],ve([0,1,279]),function(Z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.startExtensionHostProcess)().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2b66dfe0218cc18333ba92429218b33802b186bc/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
